package edu.wpi.cs.dsrg.demo;
import java.io.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class DeepCopyMaker {

     private DeepCopyMaker()
    {
          //I made constructor private so that DeepCopyMaker could not be creat$
    }


    static public Object makeDeepCopy(Object obj2DeepCopy) throws Exception
    {
      //obj2DeepCopy must be serializable
      ObjectOutputStream outStream = null;
      ObjectInputStream inStream = null;

      try
      {
          ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
          outStream = new ObjectOutputStream(byteOut);
          // serialize and write obj2DeepCopy to byteOut
          outStream.writeObject(obj2DeepCopy);
          //always flush your stream
          outStream.flush();

          ByteArrayInputStream byteIn = new ByteArrayInputStream(byteOut.toByteArray());
          inStream = new ObjectInputStream(byteIn);
         // read the serialized, and deep copied, object and return it
         return inStream.readObject();
      }
      catch(Exception e)
      {
          //handle the exception
          //it is not a bad idea to throw the exception, so that the caller of $
          //method knows something went wrong
          throw(e);
          }
     finally
     {
        //always close your streams in finally clauses
        if(outStream != null)
          outStream.close();
        if(inStream != null)
          inStream.close();
    }
  }    
}