package edu.wpi.cs.dsrg.demo;
import java.io.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import javax.swing.text.StyleConstants.*;
import javax.swing.text.StyleContext;
import javax.swing.text.Style;
import javax.swing.text.Document;
import javax.swing.text.BadLocationException;
/**
 * Insert the type's description here.
 * Creation date: (5/8/2002 3:18:45 PM)
 * @author: Brian Murphy
 */
public abstract class HighLitePane extends javax.swing.JTextPane {

	/** Data value that stores data information */
    public String dataInfo;
    
    /** Data values that store color information */
    String keyWordColor = new String("blue");
	String symbolColor = new String("red");
	String plainColor = new String("black");
 
    /**
     * HighLitePane constructor comment.
     */
    public HighLitePane(){
	setEditable (false);
	setBackground(Color.white);
	setInitStyle();
    }

    /**
     * HighLitePane constructor comment.
     * @param doc javax.swing.text.StyledDocument
     */
    public HighLitePane(javax.swing.text.StyledDocument doc) {
	super(doc);
	setEditable (false);
	setBackground(Color.white);
	setInitStyle();
    }

    public void doHighLite(){}

    public String getDataInfo(){
	    return dataInfo;
    }

    public String getKeyWordColor(){
	    return keyWordColor;
    }

    public String getPlainColor(){
	    return plainColor;
    }

    public String getSymbolColor(){
	    return symbolColor;
    }

    /** Open a file, store the contents as a String */
    public void readFile(String fileName){
	StringBuffer fileString = new StringBuffer();
        String tmpString = new String();
        try {
            BufferedReader in = new BufferedReader( new FileReader(fileName));
            while ((tmpString = in.readLine())!=null) {
                fileString.append(tmpString + "\n");
            }
            in.close();
        } catch (IOException e){
            e.printStackTrace();
        }
	dataInfo = fileString.toString();
    }

    /** Take a string value, store it locally */
    public void readString(String dataString){
	dataInfo = dataString;
    }

    protected void setInitStyle () {
        //Set the color constants
        Style def = StyleContext.getDefaultStyleContext().getStyle(
				        StyleContext.DEFAULT_STYLE);
        Style blue = addStyle("blue", def);
        ColorConstants.setForeground( blue, Color.blue);
        Style red = addStyle("red", def);
        ColorConstants.setForeground( red, Color.red);
        Style black = addStyle("black", def);
        ColorConstants.setForeground( black, Color.black);
    }
}