package edu.wpi.cs.dsrg.demo;

import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import javax.swing.text.StyleConstants.*;
import javax.swing.text.StyleContext;
import javax.swing.text.Style;
import javax.swing.text.Document;
import javax.swing.text.BadLocationException;
/**
 * Insert the type's description here.
 * Creation date: (5/8/2002 3:18:45 PM)
 * @author: Brian Murphy
 */
public class SQLHighLitePane extends HighLitePane {
    /**
     * SQLHighLitePane constructor comment.
     */
    public SQLHighLitePane(){
	super();
    }
    /**
     * SQLHighLitePane constructor comment.
     * @param doc javax.swing.text.StyledDocument
     */
    public SQLHighLitePane(javax.swing.text.StyledDocument doc) {
	super(doc);
    }
public void doHighLite(){
	String kwColor = new String(this.getKeyWordColor());
	String sColor = new String(this.getSymbolColor());
	String pColor = new String(this.getPlainColor());
	Document doc = this.getDocument();
	
	//In case a document is loaded, remove it
	// and re high lite it.
	try{
            doc.remove(0,doc.getLength());
        }
        catch (BadLocationException e){
	    System.out.println(e);
	}

    Hashtable sqlResWords = new Hashtable();
	sqlResWords.put("select", kwColor);
	sqlResWords.put("from", kwColor);
	sqlResWords.put("where", kwColor);
	sqlResWords.put("having", kwColor);
    sqlResWords.put("group", kwColor);
	sqlResWords.put("order", kwColor);
	sqlResWords.put("by", kwColor);
	sqlResWords.put("on", kwColor);
	sqlResWords.put("delete", kwColor);
	sqlResWords.put("insert", kwColor);
	sqlResWords.put("update", kwColor);
	sqlResWords.put("as", kwColor);
	sqlResWords.put("min", kwColor);
	sqlResWords.put("max", kwColor);
	sqlResWords.put("avg", kwColor);
	sqlResWords.put("stddev", kwColor);
	sqlResWords.put("count", kwColor);
	sqlResWords.put("sum", kwColor);
	sqlResWords.put("variance", kwColor);
	sqlResWords.put("replace", kwColor);
	sqlResWords.put("distinct", kwColor);

	sqlResWords.put(",", sColor);
	sqlResWords.put(".", sColor);
	sqlResWords.put(">", sColor);	
	sqlResWords.put("<", sColor);
	sqlResWords.put("=", sColor);
	sqlResWords.put("/", sColor);
	sqlResWords.put("\"", sColor);	
	sqlResWords.put("(", sColor);
	sqlResWords.put(")", sColor);
	sqlResWords.put("[", sColor);
	sqlResWords.put("]", sColor);	
	sqlResWords.put(";", sColor);
	sqlResWords.put(":", sColor);
	sqlResWords.put("$", sColor);
	sqlResWords.put("*", sColor);
	sqlResWords.put("@", sColor);
	sqlResWords.put("+", sColor);
	sqlResWords.put("-", sColor);
	sqlResWords.put("!", sColor);
	sqlResWords.put("@", sColor);
	sqlResWords.put("%", sColor);
	
	String sqlString = this.getDataInfo();
	StringTokenizer st = new StringTokenizer(sqlString, " \n");
	while (st.hasMoreTokens()) {
		String color = new String();
	    String nowToken = st.nextToken();
	    String lowNowToken = nowToken.toLowerCase();
	    // add delimiter back in
	    nowToken += " ";

	  	//Used to match strings properly
		if(lowNowToken.charAt(0) == '\n'){
			lowNowToken = lowNowToken.substring(1,lowNowToken.length());
		}
		
	    // if the keyword is found, make it blue
	    if((color = (String)sqlResWords.get(lowNowToken))!=null){
				try{
					doc.insertString(doc.getLength(), nowToken, 
					 this.getStyle(color));
				}catch (BadLocationException bpe){
					System.out.println(bpe);
				}
	    }else{
			//Else make it black
		    try{
				doc.insertString(doc.getLength(), nowToken, 
				 	 this.getStyle(pColor));
			}catch (BadLocationException bpe){
				System.out.println(bpe);
			}
	    }
	}
	
	//All words are now either blue or black
	// Now the symbols must be turned red
	for (int i=0; i<sqlString.length(); i++){
	    //If a symbol is encountered, insert it's red version
	    // then delete the black/blue version
	    String color = new String();
	    String sChar = new String(sqlString.charAt(i) + "");
	   	if((color = (String)sqlResWords.get(sChar))!=null) {
			try{
				doc.insertString(i, sChar, this.getStyle(color));
			}catch (BadLocationException bpe){
				System.out.println(bpe);
			}
			// After inserting red symbol, remove black/blue symbol
			try{
				doc.remove(i+1, 1);
			}catch (BadLocationException bpe){
				System.out.println(bpe);
			}
		}
	  
	}
	int j =0, k=0;
	while(k<sqlString.length()){
		int loc = sqlString.indexOf("\n",k+1);
		System.out.println("k:" + k + " loc:" + loc);
		if(loc<0){ 
			break;
		}else{
			j++; k=loc;
			try{
				doc.insertString(loc+j, "\n", this.getStyle(pColor));
			}catch (BadLocationException bpe){
		 		System.out.println(bpe);
			}
		}
	}
	
	revalidate();

	
    }
}
