/*
 * Created on 2004-8-8
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.demo.raindropdemo;

/**
 * @author minglee
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import java.io.IOException;


import att.grappa.GrappaAdapter;
import java.io.StringReader;
import java.io.PrintWriter;
import java.net.URLConnection;
import java.net.URL;
import java.awt.Rectangle;

import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraph;

public class GraphGenSG {
	protected boolean debug = false;
	//protected NodeContainer nodes = null;
	protected Graph graph = null;
	protected Rectangle bbox = null;
	protected GrappaPanel grappapanel = null;
	//protected NodeListener listener = null;

	/**
	 * Creates a default grappa panel, can be only called by its subclass.
	 */
	protected GraphGenSG() {
		init("", true);
	}
	/**
	 * Creates a new GrappaPanel from an XATTree object.
	 */
	public GraphGenSG(SchemaGraph xda, QueryGraph qgs ,boolean debug_in) {
		debug = debug_in;

		// convert the XAT into DOT format
		SGParser xp = new SGParser(xda, qgs);
		
		//if (debug) {
		//	xp.printDOT();
		//}

		// extract the node container
		//nodes = xp.getNodes();

		init(xp.getDOT(), debug_in);
        
	}
	/**
	 * Creates a new GrappaPanel from a DOT string.
	 */
	public GraphGenSG(String dot, boolean debug_in) {
		init(dot, debug_in);
	}
	/**
	 * Returns the GrappaPanel that this object creates.
	 */
	public GrappaPanel getGrappaPanel() {
		return grappapanel;
	}
	/**
	 * Returns the height of the GrappaPanel that this object creates.
	 */
	public int getHeight() {
		return bbox.height;
	}
	/**
	 * Returns the NodeContainer that this object creates.
	 */
	//public NodeContainer getNodeContainer() {
	//	return nodes;
	//}
	/**
	 * Returns the NodeListener that this object creates.
	 */
	//public NodeListener getNodeListener() {
	//	return listener;
	//}
	/**
	 * Returns the width of the GrappaPanel that this object creates.
	 */
	public int getWidth() {
		return bbox.width;
	}
/**
 * Init a grappa panel.
 * Creation date: (4/6/2003 8:01:22 PM)
 * @param dot java.lang.String
 * @param debug boolean
 */
protected void init(String dot, boolean debug_in) {
		debug = debug_in;

		// perform tree layout
		StringReader sr = new StringReader(dot);
		this.performLayout(sr);

		// get the size of the graph
		Rectangle bbox = (graph.getBoundingBox()).getBounds();

		// create and return a new GrappaPanel for this graph
		grappapanel = new GrappaPanel(graph);
		grappapanel.addGrappaListener(new GrappaAdapter());
		// listen to the click to show the tables.
		//grappapanel.addGrappaListener(new NodeListener(nodes));
		grappapanel.setScaleToFit(false);
	
}
/**
 * Performs tree layout.
 */
public void performLayout(StringReader sr) {
	Parser program = new Parser(sr);
	try {
		program.parse();
	} catch (Exception ex) {
		System.err.println("Exception: " + ex.getMessage());
		ex.printStackTrace(System.err);
		return;
	}

	graph = program.getGraph();

	if (debug) {
		System.out.println(
			"The graph contains "
				+ graph.countOfElements(Grappa.NODE | Grappa.EDGE | Grappa.SUBGRAPH)
				+ " elements.");
	}

	graph.setEditable(true);
	//graph.setMenuable(true);
	graph.setErrorWriter(new PrintWriter(System.err, true));
	//graph.printGraph(new PrintWriter(System.out));

	if (debug) {
		System.out.println("bbox=" + graph.getBoundingBox().getBounds().toString());
	}

	Object connector = null;

	// try the local dot file, which full path specified by System Property
	// DOT_PATH.
	// try to locate if the Runtime specify where is the dot.exe.
	String dot_path = System.getProperty("DOT_PATH");
	String bin_path = "\"bin/dot.exe\"";
    //Try bin_path first
    try {
        connector = Runtime.getRuntime().exec(bin_path);
    } catch (IOException e) {
        System.err.println(
            "Exception while setting up Process: "
                + e.getMessage()
                + "\nLayout not performed.");
        connector = null;
    }
    if(connector != null){
    	//meaningless if
    }else
	if (dot_path != null) {
		if (connector == null) {
			try {
				if (dot_path == null) {
					// if there is no such property
					// give it a default path and try.
					dot_path =
						"\"../project_resources/Visual Exploration of XQuery Processing/ATT/Graphviz/bin/dot.exe\"";
					System.out.println(
						"DOT_PATH system property is not set. Cannot locate dot.exe (by AT&T Grappa). Try default location at:"
							+ dot_path);

				}
				connector = Runtime.getRuntime().exec(dot_path);
			} catch (IOException e) {
				System.err.println(
					"Exception while setting up Process: "
						+ e.getMessage()
						+ "\nLayout not performed.");
				connector = null;
			}
		}
	} else {
		// try the internet connection.
		if (connector == null) {
			try {
				connector =
					(new URL("http://www.research.att.com/~john/cgi-bin/format-graph"))
						.openConnection();
				URLConnection urlConn = (URLConnection) connector;
				urlConn.setDoInput(true);
				urlConn.setDoOutput(true);
				urlConn.setUseCaches(false);
				urlConn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
			} catch (Exception ex) {
				System.err.println(
					"Exception while setting up URLConnection: " + ex.getMessage());
				connector = null;
			}
		}
	}

	// If still cannot make the connection,  then failed.
	if (connector != null) {
		if (!GrappaSupport.filterGraph(graph, connector)) {
			System.err.println("ERROR: somewhere in filterGraph");
		}
		if (connector instanceof Process) {
			try {
				int code = ((Process) connector).waitFor();
				if (code != 0) {
					System.err.println("WARNING: proc exit code is: " + code);
				}
			} catch (InterruptedException ex) {
				System.err.println("Exception while closing down proc: " + ex.getMessage());
				ex.printStackTrace(System.err);
			}
		}
		connector = null;
	}
}
}
