package edu.wpi.cs.dsrg.demo.raindropdemo;


/**
 * XAT to DOT parser.
 * Creation date:  2004 by Underdog
 */

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByCollectionStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByCollectionStreamImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByCollectionStreamImp2;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByUnnestStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStreamImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavCollectionStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavUnnestStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.TaggerStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.XMLScanStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator.*;



import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.updateoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.NodeContainer;

import java.lang.reflect.Array;
import java.util.Hashtable;

public class XATParser extends InheritableVisitor {

    protected XATTree tree = null;
    protected String dottree = null;
    protected NodeContainer nodes = null;
	protected Hashtable visitedNodes = new Hashtable();

    protected int numnode;
    public XATParser(XATTree xattree) {
        // copy in the XAT tree for our methods to access
        tree = xattree;

        // set up the first part of the DOT tree
        dottree = "digraph XAT {\n\tgraph [ratio = \"compress\", size = \"8, 8\", ranksep = \"0.5\"];\n\tnode [shape = \"record\", fontsize = \"12\"];\n\tedge [dir = \"back\", style = \"bold\"];\n";

		// initialize the node container
		nodes = new NodeContainer();

        // initialize the number of each type of node
        numnode = 0;
    }
    /**
     * Converts characters that DOT considers reserved into harmless ones
     */
    protected String deReserve(String dotString) {
	    int i;

		String finalString = new String("");

		if(dotString == null)
	    	return finalString;
	    
		for(i=0; i<dotString.length();i++){
			char dts = dotString.charAt(i);
			switch (dts){
				case '<': finalString += "\\<";   break;
				case '>': finalString += "\\>";   break;
				case '"': finalString += "\\\"";  break;
				case '\n': finalString += "\\n";  break; // new line.
				default : finalString += dts;    break;
			} 
		}
		return finalString;
    }
    public Object dispatch() {
        // System.out.println(indent() + "NULL");
        return null;
    }
    public Object dispatch(Object obj) {
        System.out.println("Dispatch!! " + obj.getClass().toString());
        return null;
    }
    /**
     * Get the DOT tree
     */
    public String getDOT() {
        return dottree;
    }
/**
 * Return a unique ID for Grappa node.
 * Creation date: (6/1/2003 11:06:44 PM)
 * @return java.lang.String
 */
protected String getNextID(Object obj) {
	numnode ++;
	return "node" + numnode;
}
    /**
     * Get the nodes
     */
    public NodeContainer getNodes() {
        return nodes;
    }
    /**
     * Get the XML algebra tree
     */
    public XATTree getTree() {
        return tree;
    }
    /**
     * Converts the XAT into DOT format and prints it out onto the screen
     */
    public void printDOT() {
        printNode(tree.getRoot(), null);
        System.out.println("\n");
         
        // finish off the DOT format
        dottree += "}\n";

        // print out the XAT tree in DOT format
        System.out.println(dottree);
    }
    
    
    /*
    
    //New part of NodePrinting from the DagNode class(subclass merged)
    
	protected void printNode(XATNode node, String parent) {
		if(node == null){
			// do nothing.
			return;
		}
		if (!visitedNodes.containsKey(node)){
			XATNode[] children = node.getChildren();
			String child = (String)visit(node.getOperator());
			
			
			System.out.println("the operator is: "+child+" "+ node.getOperator());
			
			
			visitedNodes.put(node,child);
			
			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + ";\n";
			}
			for(int i = 0; i < Array.getLength(children); i++) {
				if(node.getOperator() instanceof LeftOuterJoin && i == 0){
					printNode(children[i], child, " [label=\"Left\"] ");
				}else
					printNode(children[i], child);
			}
		} else {
			String child = (String)visitedNodes.get(node);
			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + ";\n";
			}
		}
	}



	protected void printNode(XATNode node, String parent, String style) {
		if(node == null){
			// do nothing.
			return;
		}
		if (!visitedNodes.containsKey(node)){
			XATNode[] children = node.getChildren();
			String child = (String)visit(node.getOperator());

			visitedNodes.put(node,child);

			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + style + ";\n";
			}
			for(int i = 0; i < Array.getLength(children); i++) {
				printNode(children[i], child);
			}
		}else{
			String child = (String)visitedNodes.get(node);
			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + style + ";\n";
			}
		}
	}
    
    */
    
    
    
    
    ///*
    
    //Old part of NodePrinting and getting the linking graph...
    //
    // Prints a node in the XAT
    // If printNode is sent the root node of an XAT as input,
    // the whole tree is printed out.
    //
    protected void printNode(XATNode node, String parent) {
	    if(node == null){
		    // do nothing.
		    return;
	    }
        XATNode[] children = node.getChildren();
        String child = (String)visit(node.getOperator());
        if(parent == null) {
	        parent = child;
        }
        else if(child != null) {
			dottree += "\t" + parent + " -> " + child + ";\n";
        }
        for(int i = 0; i < Array.getLength(children); i++) {
	        if(node.getOperator() instanceof LeftOuterJoin && i == 0){
		        printNode(children[i], child, " [label=\"Left\"] ");
	        }else
	            printNode(children[i], child);
        }
    }
    //
    // Prints a node in the XAT with different style.
    // If printNode is sent the root node of an XAT as input,
    // the whole tree is printed out.
    //
    protected void printNode(XATNode node, String parent, String style) {
	    if(node == null){
		    // do nothing.
		    return;
	    }
        XATNode[] children = node.getChildren();
        String child = (String)visit(node.getOperator());
        if(parent == null) {
	        parent = child;
        }
        else if(child != null) {
			dottree += "\t" + parent + " -> " + child + style + ";\n";
        }
        for(int i = 0; i < Array.getLength(children); i++) {
            printNode(children[i], child);
        }
    }
    
    //*/
    
    
    
    
    
    
    /**
     * Set the XML algebra tree
     */
    public void setTree(XATTree xattree) {
        tree = xattree;
    }
    /**
     * Output of the select node in an XAT
     */
    public Object visit(Expose expVisit) {
	    String childID = getNextID(expVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(expVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Expose"+"|"
            + "{expose column|" + expVisit.getColumnName() + "}"
            + "}\"];\n";

        return child;
    }
    /**
     * Output of the for node in an XAT
     */
    public Object visit(FOR forVisit) {
	    String childID = getNextID(forVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(forVisit, childID);

        String[] binding = forVisit.getColumnNames();
        
        dottree += "\t" + child
            + " [label = \"{For"+"|"
            + "{output column|" + deReserve(forVisit.getOutputColumnName()) + "}|"
            + "{binding|" + deReserve(binding[0]) + "}"
            + "}\",style=filled,color=pink];\n";

	    printNode(forVisit.getXtreFunctions().getRoot(), child, " [style=\"dashed\" , arrowhead=\"odot\", label=\"Inner\\nTree\"] ");

        return child;
    }
    /**
     * Output of the function node in an XAT
     */
    public Object visit(Function funVisit) {
	    String childID = getNextID(funVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(funVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Function"+"|"
            + "{output column|" + deReserve(funVisit.getOutputColumnName()) + "}|"
            + "{name|" + deReserve(funVisit.getName()) + "}|";

        
	    Object[] params = funVisit.getParams();

		String navigation = new String("");
	    for(int i = 0; i < params.length; i++) {
			if(params[i] instanceof NavigationStepImp) {
				NavigationStep navStep = (NavigationStep)params[i];
			    navigation += navStep.getStepValue() + "/";
		    }
		    else {
				navigation += params[i].toString() + "/";
	        }
    	}

	    if(navigation != ""){
		    if(navigation.endsWith("/")){navigation = navigation.substring(0,navigation.length()-1);}
		    dottree += "{navigation|" + deReserve(navigation) + "}"
	    		+ "}\"];\n";
		}else{
			dottree += "];\n";
		}

	    return child;
    }
    /**
     * Output of the join node in an XAT
     */
    public Object visit(IfExpr ifVisit) {
	    String childID = getNextID(ifVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(ifVisit, childID);

        dottree += "\t" + child
            + " [label = \"{If"+"|"
            + "{output column|" + ifVisit.getOutputColumnName() + "}|"
            + "{condition|" + deReserve(ifVisit.getIfExpr().toString()) + "}"
            + "}\"];\n";

	    printNode(ifVisit.getThenXAT().getRoot(), child, " [style=dashed , arrowhead=odot, label=\"Then\\nTree\"] ");
	    printNode(ifVisit.getElseXAT().getRoot(), child, " [style=dashed , arrowhead=odot, label=\"Else\\nTree\"] ");
            
        return child;
    }
	/**
     * Output of the intersect node in an XAT
     */
    public Object visit(Merge mergeVisit) {
	    String childID = getNextID(mergeVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(mergeVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Merge"+"|"
            + "}\"];\n";

        return child;
    }
/**
 * Output of the column name node in an XAT
 */
public Object visit(NameColumn colVisit) {
    String childID = getNextID(colVisit);
    String child = "\"" + childID + "\"";
    nodes.addNode(colVisit, childID);

    StringBuffer sb = new StringBuffer();

    if (colVisit.getBlockDesc() != null) {
        // then it's a block identifer.
        dottree += "\t"
            + child
            + " [label = \"{Block"
            //+ colVisit.getNode().hashCode()
            + "|"
            + "{column name|"
            + colVisit.getOriginalColumnName()
            + "}|"
            + "{desc |"
            + colVisit.getBlockDesc()
            + "}"
            + "}\",style=filled,color=orange];\n";
    } else {

        dottree += "\t"
            + child
            + " [label = \"{Name Column"
            //+ colVisit.getNode().hashCode()
            + "|"
            + "{original name|"
            + colVisit.getOriginalColumnName()
            + "}|"
            + "{new name|"
            + colVisit.getNewColumnName()
            + "}"
            + "}\",style=filled,color=grey];\n";
    }

    return child;
}
    /**
         * Output of the select node in an XAT
         */
    public Object visit(Or orVisit) {
	    String childID = getNextID(orVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(orVisit, childID);

        dottree += "\t" + child + " [label = \"OR"+"\", color=purple, style=filled];\n";

        return child;
    }
    /**
     * Output of the source node in an XAT
     */
    public Object visit(Source souVisit) {
	    String childID = getNextID(souVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(souVisit, childID);


		if(souVisit.getNode().getParent().getOperator()instanceof StreamNavigate)
		{
        dottree += "\t" + child
            + " [label = \"{StreamSource"
			//+ "|" + "{output column|" + souVisit.getOutputColumnName() + "}|"
            //+ "{data|" + souVisit.getName() + "}"
            + "}\",style=filled,color=springgreen];\n";
		}
		else
		
		{
			dottree += "\t" + child
				+ " [label = \"{Source"+"|"
				+ "{output column|" + souVisit.getOutputColumnName() + "}|"
				+ "{data|" + souVisit.getName() + "}"
				+ "}\",style=filled,color=gold];\n";
			
		}

        return child;
    }
    /**
     * Output of the SQL node in an XAT
     */
    public Object visit(SQLStmt sqlVisit) {
	    String childID = getNextID(sqlVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(sqlVisit, childID);

        dottree += "\t" + child
            + " [label = \"{SQL"+"|"
            + "{SQL statement|" + deReserve(sqlVisit.getStmt()) + "}"
            + "}\"];\n";

        return child;
    }
    /**
     * Output of the XQuery node in an XAT
     */
    public Object visit(XQueryStmt xquVisit) {
	    String childID = getNextID(xquVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(xquVisit, childID);

        dottree += "\t" + child
            + " [label = \"{XQuery Statement"+"|"
            + deReserve(xquVisit.getStmt())
            + "}\"];\n";

        return child;
    }
    /**
     * Output of the cartesian product node in an XAT
     */
    public Object visit(CartesianProduct carVisit) {
	    String childID = getNextID(carVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(carVisit, childID);

        dottree += "\t" + child
            + " [label = \"Cartesian Product"+"\"];\n";

        return child;
    }
    /**
     * Output of the distinct node in an XAT
     */
    public Object visit(Distinct disVisit) {
	    String childID = getNextID(disVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(disVisit, childID);

        dottree += "\t" + child
            + " [label = \"Distinct"+"\"];\n";

        return child;
    }
/**
 * Output of the group by node in an XAT
 */
public Object visit(GroupBy groVisit) {

    String childID = getNextID(groVisit);
    String child = "\"" + childID + "\"";
    nodes.addNode(groVisit, childID);

    String[] cols = groVisit.getColumnNames();

    dottree += "\t"
        + child
        + " [label = \"{Group By"
        //+ groVisit.getNode().hashCode()
        + "|"
        + "{output column|"
        + deReserve(groVisit.getOutputColumnName())
        + "}|";

    dottree += "{grouping column(s)|";
    for (int i = 0; i < +cols.length; i++)
        dottree += (cols[i] + " ");

    dottree += "}}\",style=filled,color=yellow]\n";

    try {
        printNode(
            groVisit.getXATTree().getRoot(),
            child,
            " [style=\"dashed\" , arrowhead=\"odot\", label=\"Inner\\nTree\"] ");
    } catch (Exception e) {
    }

    return child;
}
	/**
     * Output of the intersect node in an XAT
     */
    public Object visit(Intersection intVisit) {
	    String childID = getNextID(intVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(intVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Intersect"+"|"
            + "{output column|" + deReserve(intVisit.getOutputColumnName()) + "}"
            + "}\"];\n";

        return child;
    }
    /**
     * Output of the join node in an XAT
     */
    public Object visit(Join joiVisit) {
	    String childID = getNextID(joiVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(joiVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Join"+"|"
            + "{output column|" + joiVisit.getOutputColumnName() + "}|"
            + "{condition|" + deReserve((joiVisit.getExpression()).toString()) + "}"
            + "}\"];\n";

        return child;
    }
	/**
	 * Output of the join node in an XAT
	 */
	public Object visit(LeftOuterJoin joiVisit) {
		String childID = getNextID(joiVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(joiVisit, childID);

		dottree += "\t" + child
			+ " [label = \"{Left Outer Join"+"|"
			+ "{output column|" + joiVisit.getOutputColumnName() + "}|"
			//+ "{condition|" + deReserve((joiVisit.getExpression()).toString()) + "}"
			+ "}\",style=filled,color=red];\n";

		return child;
	}
	/**
	 * Output of the join node in an XAT
	 */
	public Object visit(NatureJoin joiVisit) {
		String childID = getNextID(joiVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(joiVisit, childID);

		dottree += "\t" + child
			+ " [label = \"{Natural Join"
			//+"|" + "{output column|" + joiVisit.getOutputColumnName() + "}"
			//+ "{condition|" + deReserve((joiVisit.getExpression()).toString()) + "}"
			+ "}\",style=filled,color=yellow];\n";

		return child;
	}
    /**
     * Output of the order node in an XAT
     */
    public Object visit(OrderBy ordVisit) {
	    String childID = getNextID(ordVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(ordVisit, childID);

        String[] cols = ordVisit.getColumnNames();

        dottree += "\t" + child
            + " [label = \"{Order"+"|"
            + "{output column|" + deReserve(ordVisit.getOutputColumnName()) + "}|"
            + "{column names|";

        int length = cols.length - 1;
	    for(int i = 0; i < length; i++) {
	      dottree += deReserve(cols[i]) + ", ";
	    }
        dottree += deReserve(cols[length]) + "}|";
	     

        dottree += "}\"];\n";

        return child;
    }
    /**
     * Output of the select node in an XAT
     */
    public Object visit(Project projVisit) {
	    String childID = getNextID(projVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(projVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Project"+"|"
            + "{column names|" ;
            
        String [] list = projVisit.getColumnNames();
		for(int i=0;i<list.length; i++)
			dottree += list[i] + " ";
        
        dottree += "}" + "}\"];\n";

        return child;
    }
    /**
     * Output of the select node in an XAT
     */
    public Object visit(Select selVisit) {
	    String childID = getNextID(selVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(selVisit, childID);

        if(selVisit.getNode().getParent().getOperator()instanceof StructuralJoinImp || selVisit.getNode().getParent().getOperator() instanceof StructuralJoinUnnestImp || selVisit.getNode().getParent().getOperator() instanceof StructuralJoinUnnest)
        {
        dottree += "\t" + child
            + " [label = \"{Select"+"|"
           // + "{output column|" + selVisit.getOutputColumnName() + "}|"
            + "{expression|" + deReserve((selVisit.getExpression()).toString()) + "}"
            + "}\",style=filled,color=springgreen];\n";
        }
        
        else
        {
        	//System.out.println("\nWhy!!!!!!!!!!!?????????\n"+selVisit.getNode().getParent().getOperator());
     	
			dottree += "\t" + child
				+ " [label = \"{Select"+"|"
				//+ "{output column|" + selVisit.getOutputColumnName() + "}|"
				+ "{expression|" + deReserve((selVisit.getExpression()).toString()) + "}"
				+ "}\"];\n";
        }
        

        return child;
    }
    /**
     * Output of the union node in an XAT
     */
    public Object visit(Union uniVisit) {
	    String childID = getNextID(uniVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(uniVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Union"+"|"
            + "{output column|" + deReserve(uniVisit.getOutputColumnName()) + "}"
            + "}\"];\n";

        return child;
    }
    /**
     * Output of the delete node in an XAT
     */
    public Object visit(Delete delVisit) {
	    String childID = getNextID(delVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(delVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Delete"+"|"
            + "{context|" + deReserve(delVisit.getContext()) + "}|"
            + "{variable|" + deReserve(delVisit.getVariable()) + "}"
            + "}\"];\n";
        
        return child;
    }
    /**
     * Output of the insert node in an XAT
     */
    public Object visit(Insert insVisit) {
	    String childID = getNextID(insVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(insVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Insert"+"|"
            + "{context|" + deReserve(insVisit.getContext()) + "}";
        
		// if there is a variable in the insert node	
	    if(insVisit.getVariable() != null) {
		  dottree += "|{variable|" + deReserve(insVisit.getVariable()) + "}";
	    }

	    // if there appears an update function in the insert node     
		if(insVisit.getUpdateFunction() != 2) {
		  dottree += "|{update function|";
		
		  String[] params = insVisit.getFuncArgs();
		   
		  if(insVisit.getUpdateFunction() == 0) {
			dottree += "new_attribute(" + deReserve(params[0]) + "," + deReserve(params[1]) + ")}";
		  }
		  else {
			dottree += "new_ref(" + deReserve(params[0]) + "," + deReserve(params[1]) + ")}";		 
		  }
		}
		 
		// if there is a relative variable in the insert node
		if(insVisit.getRelativeVariable() != null) {
		  dottree += "|{";
		  if(insVisit.getOrderPredicate() == 0) {
		    dottree += "before ";
		  }
		  else if(insVisit.getOrderPredicate() == 1) {
		 	dottree += "after ";
		  }
		  dottree += "relative variable|" + deReserve(insVisit.getRelativeVariable()) + "}";
		}

		dottree += "}\"];\n";

        return child;
    }
    /**
     * Output of the rename node in an XAT
     */
    public Object visit(Rename renVisit) {
	    String childID = getNextID(renVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(renVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Rename"+"|"
            + "{context|" + deReserve(renVisit.getContext()) + "}|"
            + "{variable|" + deReserve(renVisit.getName()) + "}|"
            + "{content|" + deReserve(renVisit.getVariable()) + "}"
            + "}\"];\n";

        return child;
    }
    /**
     * Output of the replace node in an XAT
     */
    public Object visit(Replace repVisit) {
	    String childID = getNextID(repVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(repVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Replace"+"|"
            + "{context|" + deReserve(repVisit.getContext()) + "}|"
            + "{variable|" + deReserve(repVisit.getVariable()) + "}|"
            + "{replacing var.|" + deReserve(repVisit.getReplacingVariable()) + "}";

        // if there appears an update function in the insert node     
		if(repVisit.getUpdateFunction() != 2) {
		  dottree += "|{update function|";
		
		  String[] params = repVisit.getFuncArgs();
		   
		  if(repVisit.getUpdateFunction() == 0) {
			dottree += "new_attribute(" + deReserve(params[0]) + "," + deReserve(params[1]) + ")}";
		  }
		  else {
			dottree += "new_ref(" + deReserve(params[0]) + "," + deReserve(params[1]) + ")}";		 
		  }
		}
		
		// if there is content in the replace node
	    if(repVisit.getPCDATAContent() != null) {
		  dottree += "|{content|" + deReserve(repVisit.getPCDATAContent()) + "}";
	    }

	    dottree += "}\"];\n";
		     
        return child;
    }
	/**
     * Output of the aggregate node in an XAT
     */
    public Object visit(Combine aggVisit) {
	    String childID = getNextID(aggVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(aggVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Combine"+"|"
            + "{focus column|" + aggVisit.getOutputColumnName() + "}"
            + "}\"];\n";

        return child;
    }
/**
 * Output of the navigate node in an XAT
 */


public Object visit(Navigate navVisit) {
    String childID = getNextID(navVisit);
    String child = "\"" + childID + "\"";
    nodes.addNode(navVisit, childID);

    int eLength = 0, dLength = 0;


            
    if (navVisit instanceof NavCollectionImp)
		dottree += "\t"
			+ child
			+ " [label = \"{NavCollection"
			//+ navVisit.getNode().hashCode()
			+ "";
			
	else if (navVisit instanceof NavUnnestImp)
		dottree += "\t"
			+ child
			+ " [label = \"{NavUnnest"
			//+ navVisit.getNode().hashCode()
			+ "";	
			
	else if (navVisit instanceof OuterNavCollectionImp)
			dottree += "\t"
				+ child
				+ " [label = \"{OuterNavCollection"
				//+ navVisit.getNode().hashCode()
				+ "";
	else if (navVisit instanceof OuterNavUnnestImp)
			dottree += "\t"
				+ child
				+ " [label = \"{OuterNavUnnest"
				//+ navVisit.getNode().hashCode()
				+ "";
                   
    else
        dottree += "\t"
            + child
            + " [label = \"{NavUnnest"
            //+ navVisit.getNode().hashCode()
            + "";

    StringBuffer sb = new StringBuffer();

    try {
        NavigationStep[] entry = navVisit.getEntryPoint();
        eLength = entry.length - 1;
        if (eLength > -1) {
            sb.append("|{entry|");
            for (int i = 0; i < eLength; i++) {
                sb.append(deReserve(entry[i].getStepValue()) + ", ");
            }
            sb.append(deReserve(entry[eLength].getStepValue()) + "}");
        }

    } catch (NullPointerException e) {
        sb.append("|{entry|");
        sb.append("null}");
    }

    NavigationStep[] destination = navVisit.getDestination();
    if (destination != null) {
        dLength = destination.length - 1;
        if (dLength > -1) {
            sb.append("|{path|/");
            for (int i = 0; i < dLength; i++) {
                sb.append(deReserve(destination[i].getStepValue()) + "/");
            }
            sb.append(deReserve(destination[dLength].getStepValue()) + "}");
        }

    } else {
        sb.append("|{path|");
        sb.append("null}");
    }

    dottree += sb.toString();

    dottree += "|{destination|"
        + deReserve(navVisit.getOutputColumnName())
        + "}}\",style=filled,color=pink];\n";

    return child;
}

    /**
     * Output of the tagger node in an XAT
     */
    public Object visit(Tagger tagVisit) {
	    String childID = getNextID(tagVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(tagVisit, childID);

        dottree += "\t" + child
            + " [label = \"{Tagger"+"|"
            + "{output column|" + deReserve(tagVisit.getOutputColumnName()) + "}|";
        
      	DOMPattern tagTree = (DOMPattern)tagVisit.getPattern();
      	dottree += "{tagger tree |" + deReserve(tagTree.toIndentString()) + "}}\",style=filled,color=gold];\n";
    
        return child;
    }
    /**
     * Output of the xml union node in an XAT
     */
    public Object visit(XMLUnion uniVisit) {
	    String childID = getNextID(uniVisit);
        String child = "\"" + childID + "\"";
        nodes.addNode(uniVisit, childID);

        dottree += "\t" + child
            + " [label = \"{XMLUnion"+"|"
            + "{output column|" + deReserve(uniVisit.getOutputColumnName()) + "}"
            + "}\"];\n";

        return child;
    }
    
	public Object visit(InTimeSJStreamImp itsJ) {
		String childID = getNextID(itsJ);
		String child = "\"" + childID + "\"";
		nodes.addNode(itsJ, childID);

		dottree += "\t" + child
			+ " [label = \"{InTimeStructualJoin"+"|"
			+ "{Join On|" + deReserve(itsJ.getBranchNavOp().getOutputColumnName()) + "}"
			+ "}\",style=filled,color=springgreen];\n";
			
			
	    //System.out.println("\nYes, we get one InTimeStructureJoin here!\n");

		return child;
	}   
	
	
	public Object visit(NaturalJoinStream joiVisit) {
		String childID = getNextID(joiVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(joiVisit, childID);

		dottree += "\t" + child
			+ " [label = \"{NatureJoinStream"
			//+"|" + "{output column|" + joiVisit.getOutputColumnName() + "}"
			//+ "{condition|" + deReserve((joiVisit.getExpression()).toString()) + "}"
			+ "}\",style=filled,color=blue];\n";

		return child;
	} 
	
    
	public Object visit(AutoMegaImp atM) {
		String childID = getNextID(atM);
		String child = "\"" + childID + "\"";
		nodes.addNode(atM, childID);

		dottree += "\t" + child
			+ " [label = \"{AutoMega"+"|"
			+ "{output column|"  + deReserve(atM.getOutputColumnName())+ "}"
			+ "}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	public Object visit(XMLScanStream atM) {
		String childID = getNextID(atM);
		String child = "\"" + childID + "\"";
		nodes.addNode(atM, childID);

		dottree += "\t" + child
			+ " [label = \"{XMLScanStream"
			//+ "|" + "{output column|"  + deReserve(atM.getOutputColumnName())+ "}"
			+ "}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	
    
    
	public Object visit(StructuralJoinImp sjImp) {
		String childID = getNextID(sjImp);
		String child = "\"" + childID + "\"";
		nodes.addNode(sjImp, childID);

		dottree += "\t" + child
			+ " [label = \"{StructuralJoin"+"|"
			+ "{Join On|"  + deReserve(sjImp.getShadowNode().getOperator().getOutputColumnName()) + "}"
			+ "}\",style=filled,color=springgreen];\n";
			
	    //System.out.println("\nYes here is one StructureJoin!\n");

		return child;
	}
	
	
	public Object visit(AutoMegaOperator atM) {
		String childID = getNextID(atM);
		String child = "\"" + childID + "\"";
		nodes.addNode(atM, childID);

		dottree += "\t" + child
			+ " [label = \"{AutoMegaOperator"+"|"
			+ "{output column|"  + deReserve(atM.getOutputColumnName()) + "}"
			+ "}\"];\n";
			
		System.out.println("yes it is");

		return child;
	}
	
	
	public Object visit(ExtractCollImp navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;

		if (navVisit instanceof ExtractCollImp)
			dottree += "\t"
				+ child
				+ " [label = \"{ExtractColl"
				//+ navVisit.getNode().hashCode()
				+ "";
		else
			dottree += "\t"
				+ child
				+ " [label = \"{ExtractColl2"
				//+ navVisit.getNode().hashCode()
				+ "";

		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	
	public Object visit(NavCollectionStream navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;


			dottree += "\t"
				+ child
				+ " [label = \"{NavCollectionStream"
				//+ navVisit.getNode().hashCode()
				+ "";

		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=pink];\n";

		return child;
	}
	
	
	
	
	
	public Object visit(PureNavigateAutoStream navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;


			dottree += "\t"
				+ child
				+ " [label = \"{PureNavigateAutoStream"
				//+ navVisit.getNode().hashCode()
				+ "";


		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	
	public Object visit(NavUnnestStream navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;


			dottree += "\t"
				+ child
				+ " [label = \"{NavUnnestStream"
				//+ navVisit.getNode().hashCode()
				+ "";


		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=pink];\n";

		return child;
	}
	
	
	
	
	public Object visit(StreamNavigateImp navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;

		if (navVisit instanceof StreamNavigateImp)
			dottree += "\t"
				+ child
				+ " [label = \"{StreamNavigate"
				//+ navVisit.getNode().hashCode()
				+ "";
		else
			dottree += "\t"
				+ child
				+ " [label = \"{StreamNavigate2"
				//+ navVisit.getNode().hashCode()
				+ "";

		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	
	
	public Object visit(ExtractByUnnestStream navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;


			dottree += "\t"
				+ child
				+ " [label = \"{ExtractCollection"
				//+ navVisit.getNode().hashCode()
				+ "";


		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	
	
	
	
	public Object visit(ExtractByCollectionStreamImp navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;

		if (navVisit instanceof ExtractByCollectionStreamImp)
			dottree += "\t"
				+ child
				+ " [label = \"{ExtractCollection"
				//+ navVisit.getNode().hashCode()
				+ "";
		else
			dottree += "\t"
				+ child
				+ " [label = \"{ExtractCollection2"
				//+ navVisit.getNode().hashCode()
				+ "";

		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=springgreen];\n";

		return child;
	}
	
	
	
	public Object visit(CollSimpleSelStream selVisit) {
		String childID = getNextID(selVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(selVisit, childID);


		
			//System.out.println("\nWhy!!!!!!!!!!!?????????\n"+selVisit.getNode().getParent().getOperator());
     	
			dottree += "\t" + child
				+ " [label = \"{CollSimpleSelStream"+"|"
				//+ "{output column|" + selVisit.getOutputColumnName() + "}|"
				+ "{expression|" + deReserve((selVisit.getExpression()).toString()) + "}"
				+ "}\"style=filled,color=springgreen];\n";  
		
          

		return child;  
	}
	
	//Not very sure for this one's color
	public Object visit(SelectStreamImp selVisit) {
		String childID = getNextID(selVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(selVisit, childID);


		dottree += "\t" + child
			+ " [label = \"{SelectStreamImp"+"|"
			//+ "{output column|" + selVisit.getOutputColumnName() + "}|"
			+ "{expression|" + deReserve((selVisit.getExpression()).toString()) + "}"
			+ "}\",style=filled,color=pink];\n";

        

		return child;
	}
	
	
	public Object visit(TaggerStream tagVisit) {
		String childID = getNextID(tagVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(tagVisit, childID);

		dottree += "\t" + child
			+ " [label = \"{TaggerStream"+"|"
			+ "{output column|" + deReserve(tagVisit.getOutputColumnName()) + "}|";
        
		DOMPattern tagTree = (DOMPattern)tagVisit.getPattern();
		dottree += "{tagger tree |" + deReserve(tagTree.toIndentString()) + "}}\",style=filled,color=gold];\n";
    
		return child;
	}
	

    /*
	public Object visit(StreamNavigate atM) {
		String childID = getNextID(atM);
		String child = "\"" + childID + "\"";
		nodes.addNode(atM, childID);

		dottree += "\t" + child
			+ " [label = \"{StreamNavigate"
			//+ "|" + "{output column|"  + deReserve(atM.getOutputColumnName())+ "}"
			+ "}\",style=filled,color=springgreen];\n";

		return child;
	}
	*/
	

	
	
	public Object visit(ExtractUnnestImp navVisit) {
		String childID = getNextID(navVisit);
		String child = "\"" + childID + "\"";
		nodes.addNode(navVisit, childID);

		int eLength = 0, dLength = 0;

		if (navVisit instanceof ExtractUnnestImp)
			dottree += "\t"
				+ child
				+ " [label = \"{ExtractUnnest"
				//+ navVisit.getNode().hashCode()
				+ "";
		else
			dottree += "\t"
				+ child
				+ " [label = \"{ExtractUnnest2"
				//+ navVisit.getNode().hashCode()
				+ "";

		StringBuffer sb = new StringBuffer();

		try {
			NavigationStep[] entry = navVisit.getEntryPoint();
			eLength = entry.length - 1;
			if (eLength > -1) {
				sb.append("|{entry|");
				for (int i = 0; i < eLength; i++) {
					sb.append(deReserve(entry[i].getStepValue()) + ", ");
				}
				sb.append(deReserve(entry[eLength].getStepValue()) + "}");
			}

		} catch (NullPointerException e) {
			sb.append("|{entry|");
			sb.append("null}");
		}

		NavigationStep[] destination = navVisit.getDestination();
		if (destination != null) {
			dLength = destination.length - 1;
			if (dLength > -1) {
				sb.append("|{path|/");
				for (int i = 0; i < dLength; i++) {
					sb.append(deReserve(destination[i].getStepValue()) + "/");
				}
				sb.append(deReserve(destination[dLength].getStepValue()) + "}");
			}

		} else {
			sb.append("|{path|");
			sb.append("null}");
		}

		dottree += sb.toString();

		dottree += "|{destination|"
			+ deReserve(navVisit.getOutputColumnName())
			+ "}}\",style=filled,color=springgreen];\n";

		return child;
	}
    
}
