package edu.wpi.cs.dsrg.demo.raindropdemo;
import java.awt.print.*;
/**
 * XAT drawing demonstration.
 * Creation date: 2004 by Underdog
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;

//import sun.reflect.Label;
import att.grappa.*;

import xacute.quilt.*;
import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;

//import edu.wpi.cs.dsrg.xmldb.xat.component.gui.DocViewStep;
//import edu.wpi.cs.dsrg.xmldb.xat.component.gui.ExecutionStep;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.KweeltFilter;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.OracleConnectionException;
//import edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep;
//import edu.wpi.cs.dsrg.xmldb.xat.component.gui.TreeGenerationStep;
import edu.wpi.cs.dsrg.xmldb.xat.component.sqlgeneration.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.*;
import edu.wpi.cs.dsrg.demo.ReWriteGUI;

public class XQueryGUI
    extends JFrame
    implements ActionListener, GrappaConstants {

    protected static XQueryGUI gui = null;
    protected Graph graph = null;

    // the current status of the XQueryGUI, for single query or double queries.
    protected boolean single;

    // information stored 
    protected XATTree uxat;
    protected XATTree vxat;
    protected static String dot = null;

    // information passed in through the constructor
    protected String userQuery;
    protected String viewQuery;
    protected String username;
    protected String password;
    protected String URI;
    
    protected int mappingSet;
    protected int paraSet;
    protected int paraSet2;
    
    protected String xsdPath;
    protected String inputPath;
    protected String outputPath;
    
    protected boolean rule1;
    protected boolean rule2;
    protected boolean rule3;
    protected boolean rule4;
     

    protected JTabbedPane tabbedpane = null;
    // create a file chooser
    protected JFileChooser fc = new JFileChooser();

    // define what to do when someone clicks a tab
    public class TabListener implements ChangeListener {
        public void stateChanged(ChangeEvent ce) {
            SingleSelectionModel model = (SingleSelectionModel) ce.getSource();
            int tabDex = model.getSelectedIndex();
            
            
            System.out.println("\n********************************************************************\nTab Capturing! Here gets the Tab " + tabDex+".\n");            
            ProcessRDStep ps = (ProcessRDStep) getStepVector().elementAt(tabDex);    
            //ps.executeUser();

         	//DocViewStep dvs = new DocViewStep(getUxat(), userQuery_in);            
            
            
            if (!single) {
            	
				System.out.println("Getting Two");
                ps.updateContentPane(ps.executeUser(), ps.executeView());
                setUxat(ps.getUserTree());
                setVxat(ps.getViewTree());
                setStepBindingTable(ps.getUserBindingTable(), ps.getViewBindingTable());
				//DrawOriginalPanel(userQuery, username, password, URI);

            } else {
            	
				//ps.executeUser().repaint();
                ps.updateContentPane(ps.executeUser(),mappingSet,tabDex,userQuery,paraSet, paraSet2, rule1, rule2, rule3, rule4);
                setUxat(ps.getUserTree());
                setStepBindingTable(ps.getUserBindingTable());
				//DrawOriginalPanel(userQuery, username, password, URI);
                
            }
            
            
            /* 
            * pretty ineffcient, sets the bindingtable of each step every time this event is fired
            * a better solution would involve a hack to make sure it runs only once.  
            */
            
            setStepBindingTable(ps.getUserBindingTable(), ps.getViewBindingTable());
            System.out.println("\nTab " + tabDex + "  Generation Done!\n" + "********************************************************************"+"\n\n");
            grappapanel1 = ps.getUserGrappaPanel();
            updateTrees();
            
            //grappapanel1.repaint();
        }
    }

    // define the item types
    protected final int ITEM_PLAIN = 0;
    protected final int ITEM_CHECK = 1;
    protected final int ITEM_RADIO = 2;
    
	//public JFrame faa = null;

    protected JMenuBar menuBar;
    protected JMenu menuFile;
    protected JMenu menuEdit;
    protected JMenu menuGraph;
    protected JMenu menuProperty;
    protected JMenu menuScale;
    protected JMenu menuCopyright;
    protected JMenu menuSqo;
    protected JMenu menuCom;
    
    
    protected JMenu menuPlot;
    protected JMenu menuLogic;
    protected JMenu menuPhy;
    
    
	protected JMenuItem menuXAT;
    protected JMenuItem menuMax;
	protected JMenuItem menuABind;
	protected JMenuItem menuNaS;
	protected JMenuItem menuNa;
	protected JMenuItem menuSPar;
	protected JMenuItem menuPhysical;
	
	protected JMenuItem menuSG;
	protected JMenuItem menuQG;
    protected JMenuItem menuComSqo;
    protected JMenuItem menuComExe;
    protected JMenuItem menuCopyr;
    protected JMenuItem menuMaxPush;
    protected JMenuItem menuAllBinding;
    protected JMenuItem menuMainBindling;
	protected JMenuItem menuSource;
	protected JMenuItem menuNavSel;
	protected JMenuItem menuNavUnnestSel;
	protected JMenuItem menuNav;
	protected JMenuItem menuSelPar;
	protected JMenuItem menuSqoRule;
	protected JMenuItem menuSqoFlag;
	
	
    protected JMenuItem menuScaleSet;
    protected JMenuItem menuScale1;
    protected JMenuItem menuScale2;
    protected JMenuItem menuScale3;
    protected JMenuItem menuScale4;
    protected JMenuItem menuFileNew;
    protected JMenuItem menuFileOpen;
    protected JMenuItem menuFileOpenII;
    protected JMenuItem menuFileOpenIII;
    protected JMenuItem menuFileOutFile;
    protected JMenuItem menuFileSave;
    protected JMenuItem menuFileSaveAs;
    protected JMenuItem menuFileExit;
    protected JMenuItem menuEditCopy;
    protected JMenuItem menuEditCut;
    protected JMenuItem menuEditPaste;
    protected JMenuItem menuGraphRepaint;
    protected JMenuItem menuGraphPrint;
    protected JMenuItem menuGraphReset;
    protected JMenuItem menuGraphResync;

    protected Vector stepVector;
    protected att.grappa.GrappaPanel grappapanel1;
    /**
    * XQuery GUI constructor.
    *
    * @param userQuery_in the user query
    * @param username_in the username of an account on the Oracle server
    * @param password_in the password of the account on the Oracle server
    * @param URI_in the Universal Resource Indicator of the Oracle server
    * @param type the type of the GUI. XQueryGUI.QUERY works on queries. XQueryGUI.UPDATE works on updates.
    */
    public XQueryGUI(
        String userQuery_in,
        String username_in,
        String password_in,
        String URI_in,
        int mappingWay,
        int paraNum,
        int paraNum2,
        String xsdSet,
        String inputSet,
        String outputSet,
        boolean rule1Set,
        boolean rule2Set,
        boolean rule3Set,
        boolean rule4Set
        )
        {
        userQuery = userQuery_in;
        if (username_in == null | password_in == null | URI_in == null) {
            
        }
        username = username_in;
        password = password_in;
        URI = URI_in;
        stepVector = new Vector();
        uxat = new XATTreeImp();
        single = true;
        mappingSet = mappingWay; 
        paraSet = paraNum;
        paraSet2 = paraNum2;
        
		xsdPath = xsdSet;
		inputPath = inputSet;
	    outputPath = outputSet;
	    
		rule1 = rule1Set;
		rule2 = rule2Set;
		rule3 = rule3Set;
		rule4 = rule4Set;
        
        //drawing the original tag panels in the backside      
		DrawOriginalPanel(userQuery, username, password, URI);     
        
    }
    /**
    * XQuery GUI constructor.
    *
    * @param userQuery_in the user query
    * @param viewQuery_in the view query
    * @param username_in the username of an account on the Oracle server
    * @param password_in the password of the account on the Oracle server
    * @param URI_in the Universal Resource Indicator of the Oracle server
    * @param type the type of the GUI. XQueryGUI.QUERY works on queries. XQueryGUI.UPDATE works on updates.
    */
    public XQueryGUI(
        String userQuery_in,
        String viewQuery_in,
        String username_in,
        String password_in,
        String URI_in,
        int mappingWay,
        int paraNum,
        int paraNum2,
        String xsdSet,
        String inputSet,
        String outputSet,
		boolean rule1Set,
		boolean rule2Set,
		boolean rule3Set,
		boolean rule4Set
        )
        {
        userQuery = userQuery_in;
        viewQuery = viewQuery_in;
        if (username_in == null | password_in == null | URI_in == null) {
           
        }
        username = username_in;
        password = password_in;
        URI = URI_in;
        stepVector = new Vector();
        uxat = new XATTreeImp();
        vxat = new XATTreeImp();
        single = false;
        mappingSet = mappingWay;
        paraSet = paraNum;
		paraSet2 = paraNum2;
		xsdPath = xsdSet;
		inputPath = inputSet;
		outputPath = outputSet;
		rule1 = rule1Set;
		rule2 = rule2Set;
		rule3 = rule3Set;
		rule4 = rule4Set;
    }
    
    
    
    
    // define what to do when someone selects a menu item
    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource() instanceof JMenuItem) {
            JMenuItem menu = (JMenuItem) evt.getSource();
            
            
            if (menu == menuMaxPush)
            {
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(2);
				
				this.dispose();
				
            }
            else if (menu == menuAllBinding)
            {
            	
				stepVector.removeAllElements();
				XQueryGUI gui;
				//faa.dispose();
				gui = new XQueryGUI(userQuery, username, password, URI, 1, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(2);
				
				this.dispose();
            	
            }
            /*
            else if(menu == menuMainBindling)
            {
				stepVector.removeAllElements();
				XQueryGUI gui;
				gui = new XQueryGUI(userQuery, username, password, URI, 2, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(2);
				
				this.dispose();
            }
            else if(menu == menuSource)
            {
				stepVector.removeAllElements();
				XQueryGUI gui;
				gui = new XQueryGUI(userQuery, username, password, URI, 3, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(2);
				
				this.dispose();
            }
            */
            else if(menu == menuNavSel)
            {
				
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                                                                                                 ");
				JLabel jLbe2 = new JLabel("                                                                                                                                 ");
				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLbe2);

				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jLbe);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,185);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, 4, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(2);
				
						dispose();
						
						
					}
					
					
				});  
				
				 
				   
				
				/*
				stepVector.removeAllElements();
				XQueryGUI gui;
				try {
					gui = new XQueryGUI(userQuery, username, password, URI, 4, paraSet);
					gui.displayGraph(2);
				} catch (OracleConnectionException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				this.dispose();
				*/
            }
            
            /*
            else if(menu == menuNavUnnestSel)
            {
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                        ");

				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
			    cont.add(jLbe);
				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,165);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						gui = new XQueryGUI(userQuery, username, password, URI, 5, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(2);
				
						dispose();
						
						
						
					}
					
					
				});
            }
            */
            
            else if(menu == menuNav)
            {
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                                                                                                  ");
				JLabel jLbe2 = new JLabel("                                                                                                                                  ");

				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				//JLabel jLb2 = new JLabel("SelPushdown: ");
				//final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLbe2);
				cont.add(jLb);
				cont.add(jTf);
				//cont.add(jLb2);
				//cont.add(jTf2);
				cont.add(jLbe);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,185);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						//String tempString2 = jTf2.getText();
						//paraSet2 = Integer.parseInt(tempString2);
						paraSet2 = 0;
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, 6, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(2);
				
						dispose();
						
						
						
					}
					
					
				});
            }
            
            else if(menu == menuSelPar)
            {
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                                                                                                        ");
				JLabel jLbe2 = new JLabel("                                                                                                                                        ");
				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLbe2);
				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jLbe);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,185);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, 7, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(2);
				
						dispose();
						
						
					}
					
					
				});
            }
            
            else // Physical part... almost the same as the logical part, just some tab invoking changes
            
            
			if (menu == menuMax)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(3);
				
				this.dispose();
				
			}
			else if (menu == menuABind)
			{
            	
				stepVector.removeAllElements();
				XQueryGUI gui;
				//faa.dispose();
				gui = new XQueryGUI(userQuery, username, password, URI, 1, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(3);
				
				this.dispose();
            	
			}
			/*
			else if(menu == menuMainBindling)
			{
				stepVector.removeAllElements();
				XQueryGUI gui;
				gui = new XQueryGUI(userQuery, username, password, URI, 2, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(3);
				
				this.dispose();
			}
			else if(menu == menuSource)
			{
				stepVector.removeAllElements();
				XQueryGUI gui;
				gui = new XQueryGUI(userQuery, username, password, URI, 3, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(3);
				
				this.dispose();
			}
			*/
			else if(menu == menuNaS)
			{
				
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                                                                                                 ");
				JLabel jLbe2 = new JLabel("                                                                                                                                 ");
				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLbe2);

				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jLbe);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,185);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, 4, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(3);
				
						dispose();
						
						
					}
					
					
				});  
				
				 
				   
				
				/*
				stepVector.removeAllElements();
				XQueryGUI gui;
				try {
					gui = new XQueryGUI(userQuery, username, password, URI, 4, paraSet);
					gui.displayGraph(2);
				} catch (OracleConnectionException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				this.dispose();
				*/
			}
            
			/*
			else if(menu == menuNavUnnestSel)
			{
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                        ");

				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,165);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						gui = new XQueryGUI(userQuery, username, password, URI, 5, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(3);
				
						dispose();
						
						
						
					}
					
					
				});
			}
			*/
            
			else if(menu == menuNa)
			{
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                                                                                                  ");
				JLabel jLbe2 = new JLabel("                                                                                                                                  ");

				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLbe2);
				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jLbe);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,185);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, 6, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(3);
				
						dispose();
						
						
						
					}
					
					
				});
			}
            
			else if(menu == menuSPar)
			{
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Parameter Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());
				
				JLabel jLbe = new JLabel("                                                                                                                                        ");
				JLabel jLbe2 = new JLabel("                                                                                                                                        ");
				JLabel jLb = new JLabel("NavPushdown: ");
				final JTextField jTf = new JTextField("Number of Nav to Pushdown");	
				
				JLabel jLb2 = new JLabel("SelPushdown: ");
				final JTextField jTf2 = new JTextField("Number of Sel to Pushdown");			
					    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
			    
				cont.add(jLbe);
				cont.add(jLbe2);
				cont.add(jLb);
				cont.add(jTf);
				cont.add(jLb2);
				cont.add(jTf2);
				cont.add(jLbe);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,300,185);
	 
				fa.show(true);
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						
						String tempString2 = jTf2.getText();
						paraSet2 = Integer.parseInt(tempString2);
						
						
						fa.dispose();
						
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, 7, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(3);
				
						dispose();
						
						
					}
					
					
				});
			}
            
            //other additional switch adding....
			else if (menu == menuXAT)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(1);
				
				this.dispose();
				
			}
			
			else if (menu == menuPhysical)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(3);
				
				this.dispose();
				
			}
            
            
			else if (menu == menuSG)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
				gui.displayGraph(6);
				
				this.dispose();
				
			}
			
			else if (menu == menuQG)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, "comparison.txt", rule1, rule2, rule3, rule4);
				gui.displayGraph(5);
				
				this.dispose();
				
			}
			
			else if (menu == menuComExe)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, "comparison.txt", rule1, rule2, rule3, rule4);
				gui.displayGraph(8);
				
				this.dispose();
				
			}
			
			else if (menu == menuComSqo)
			{
				
				//faa.dispose();
				stepVector.removeAllElements();
				XQueryGUI gui;
				
				gui = new XQueryGUI(userQuery, username, password, URI, 0, 0, 0, xsdPath, inputPath, "comparison2.txt", rule1, rule2, rule3, rule4);
				gui.displayGraph(8);
				
				this.dispose();
				
			}
			
			
            
            
            
            
            
            
            
            ////////////////////////////////////
            
            
            /*
			else if(menu == menuScaleSet)
			{

				final JFrame fa = new JFrame("Pushdown Parameter");
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());

				JLabel jLb = new JLabel("Parameter");
			    final JTextField jTf = new JTextField("Number of Nav to Pushdown");		    
			    JButton jBu = new JButton("OK");
			    jBu.setBackground(SystemColor.control);
			    
                cont.add(jLb);
				cont.add(jTf);
				cont.add(jBu);	 					 
				fa.setBounds(300,200,250,115);;
	 
				fa.show();
				
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						// TODO Auto-generated method stub
						//System.out.println("OK done");
						String tempString = jTf.getText();
						//System.out.println(tempString);
						paraSet = Integer.parseInt(tempString);
						//System.out.println(paraSet);
						fa.dispose();
					}
					
					
				});
							

			}
			
			else if(menu == menuScale1)
			{
                 paraSet = 1;
			}
			
			else if(menu == menuScale2)
			{
                 paraSet = 2;
			}
			
			else if(menu == menuScale3)
			{
				paraSet = 3;
			}
			
			else if(menu == menuScale4)
			{
				paraSet = 4;
			}
			*/
			else if(menu == menuSqoRule)
			{
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Applying Rules");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());

				JLabel jLb1 = new JLabel("                                                                                                                            ");
				JLabel jLb2 = new JLabel("                                                                                                                        ");
				JLabel jLb3 = new JLabel("SQO Rules Setting");
				JLabel jLb4 = new JLabel("                                                                                                                                ");
				//final JTextField jTf = new JTextField("Number of Nav to Pushdown");
				
							
				final JCheckBox jCb1 =new JCheckBox("Apply SQO's Occurrence Rule",true);	
				if(rule1 == false) 
				 jCb1.setSelected(false);
				else
				{
				}
				
				final JCheckBox jCb2 =new JCheckBox("Apply SQO's Exclusive Rule   ",true);
				if(rule2 == false) 
				 jCb2.setSelected(false);
				else
				{
				}
				
				final JCheckBox jCb3 =new JCheckBox("Apply SQO's Order Rule        ",true);
				if(rule3 == false) 
				 jCb3.setSelected(false);
				else
				{
				}
				
				JLabel jLb5 = new JLabel("                                                                                                                           ");
				JLabel jLb6 = new JLabel("                                                                                                        ");
				JLabel jLb7 = new JLabel("Inter SQO Rule Relation Setting");
				JLabel jLb8 = new JLabel("                                                                                                        ");
				JLabel jLb9 = new JLabel("                                                                                                        ");
				//final JTextField jTf = new JTextField("Number of Nav to Pushdown");
				
				
				final JCheckBox jCb4 =new JCheckBox("Disallow Potentially Redundant Rules",true);
				if(rule4 == false) 
				 jCb4.setSelected(false);
				else
				{
				}
				
						    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
				
			    
				cont.add(jLb1);
				//cont.add(jTf);
				cont.add(jLb3);
				//cont.add(jLb4);
				cont.add(jCb1);
				cont.add(jCb2);
				cont.add(jCb3);
				//cont.add(jLb2);
				cont.add(jLb5);
				cont.add(jLb6);
				cont.add(jLb7);
				//cont.add(jLb9);
				cont.add(jCb4);
				cont.add(jLb8);
				cont.add(jBu);	 
				
									 
				fa.setBounds(300,100,270,354);
	 			fa.show(true);
	 			
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) 
					{				
						// TODO Auto-generated method stub
						
						boolean bSelRule1 = jCb1.isSelected();
						boolean bSelRule2 = jCb2.isSelected();
						boolean bSelRule3 = jCb3.isSelected();
						boolean bSelRule4 = jCb4.isSelected();
						
						rule1 = bSelRule1;
						rule2 = bSelRule2;
						rule3 = bSelRule3;
						rule4 = bSelRule4;
						
						//testing event invoking
						//System.out.println("+++++++++++"+bSelRule1+bSelRule2+bSelRule3+bSelRule4+"+++++++++++");
						
						stepVector.removeAllElements();
						XQueryGUI gui;
						//faa.dispose();
						gui = new XQueryGUI(userQuery, username, password, URI, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
						gui.displayGraph(4);
						
						fa.dispose();
						dispose();
					}	
				});
			}
			/*
			else if(menu == menuSqoFlag)
			{
				final JDialog fa = new javax.swing.JDialog();
				fa.setTitle("Redundant Rule Setting");
				
				
	
				Container cont = fa.getContentPane();
				cont.setLayout (new FlowLayout());

				JLabel jLb1 = new JLabel("                                                          ");
				JLabel jLb2 = new JLabel("                                                          ");
				JLabel jLb3 = new JLabel("Please Set the SQO Redundant Rule");
				JLabel jLb4 = new JLabel("                                                          ");
				//final JTextField jTf = new JTextField("Number of Nav to Pushdown");
				final JCheckBox jCb1 =new JCheckBox("Applying SQO's Unredundant Rule",true);
				//final JCheckBox jCb2 =new JCheckBox("Schema-based Query Optimization Rule2",true);
				//final JCheckBox jCb3 =new JCheckBox("Schema-based Query Optimization Rule3",true);
						    
				JButton jBu = new JButton("OK");
				jBu.setBackground(SystemColor.control);
				
			    
				cont.add(jLb1);
				//cont.add(jTf);
				cont.add(jLb3);
				//cont.add(jLb4);
				cont.add(jCb1);
				//cont.add(jCb2);
				//cont.add(jCb3);
				cont.add(jLb2);
				cont.add(jBu);	 
				
									 
				fa.setBounds(300,200,300,205);
				fa.show(true);
	 			
				jBu.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) 
					{				
						// TODO Auto-generated method stub
						fa.dispose();
						stepVector.removeAllElements();
						XQueryGUI gui;
						try {
							gui = new XQueryGUI(userQuery, username, password, URI, mappingSet, paraSet);
							gui.displayGraph(4);
						} catch (OracleConnectionException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
				
						dispose();
					}	
				});
			}
			*/
			
			
			else
			if (menu == menuCopyr) {
            	
				//Graphics g;
				
			   final JFrame jF = new JFrame("Copyright");
			   /*
			   {
				public void paint(Graphics g)
				{		
						//
				}  	
			   };
			   */

            		
                
				Container cont = jF.getContentPane();
				cont.setLayout (new FlowLayout());

			   JLabel jLb = new JLabel("Raindrop Version 1.0.1");
               
			   Font fo = new Font("Serif",Font.PLAIN,34);
			   Font foo = new Font("Serif", Font.PLAIN, 24);
			   jLb.setFont(fo);
               
               
			   JLabel jLbsite = new JLabel("http://davis.wpi.edu/dsrg/raindrop/index.html\n");
			   
			   JLabel jLbemail = new JLabel("Copyright:  DSRG @ WPI 2004");
			   //jLbemail.setFont(foo);
			   
			   JLabel jLbempt = new JLabel("                                                                               ");
              		    
               	    
			   JButton jBu = new JButton("Thank You for Using");
			   jBu.setBackground(SystemColor.control);
			    
			   cont.add(jLb);
			   cont.add(jLbsite);
			   cont.add(jLbemail); 
			   cont.add(jLbempt);
			   cont.add(jBu);	 					 
			   jF.setBounds(300,200,350,211);
	 
			   jF.show(true);
				
			   jBu.addActionListener(new ActionListener()
			   {
			   public void actionPerformed(ActionEvent arg0) 
			   {
						
			   jF.dispose();									
						
			   }				
			   });

            	
				//System.exit(0);
			} 			
			
			
			
			
      
            else
            if (menu == menuFileExit) {
            	
				//Graphics g;
				
               JFrame jF = new JFrame("Copyright");
               /*
               {
				public void paint(Graphics g)
				{		
            			//
				}  	
               };
               */

            		
                
				Container cont = jF.getContentPane();
                cont.setLayout (new FlowLayout());

               JLabel jLb = new JLabel("Raindrop Version 1.0.1");
               
               Font fo = new Font("Serif",Font.PLAIN,34);
               jLb.setFont(fo);
               
               
			   JLabel jLbsite = new JLabel("http://davis.wpi.edu/dsrg/raindrop/index.html");
			   JLabel jLbemail = new JLabel("Copyright:  DSRG @ WPI 2004");
			   JLabel jLbempt = new JLabel("                                                                              ");
              		    
               	    
               JButton jBu = new JButton("Thank You for Using");
               jBu.setBackground(SystemColor.control);
			    
               cont.add(jLb);
               cont.add(jLbsite);
               cont.add(jLbemail); 
               cont.add(jLbempt);
               cont.add(jBu);	 					 
               jF.setBounds(300,200,350,211);
	 
               jF.show(true);
				
               jBu.addActionListener(new ActionListener()
               {
	           public void actionPerformed(ActionEvent arg0) 
	           {
						
		       System.exit(0);									
						
	           }				
               });

            	
                //System.exit(0);
            } 
            else
                if (menu == menuFileOpen) {
                	//protected JFileChooser fc = new JFileChooser();
                    int returnVal = fc.showOpenDialog(menu);

                    if (returnVal == JFileChooser.APPROVE_OPTION) {
                        File file = fc.getSelectedFile();
                        System.out.println("Opening: \"" + file.getPath()+ "\".");

                        try {
                        	
                        	//This userQuery would be reset here!
                            userQuery = readFile(file.getPath());
                                                   
                            //tabbedpane.setSelectedIndex(0);
					
							stepVector.removeAllElements();	
							//faa.dispose();
							XQueryGUI gui = new XQueryGUI(userQuery,username, password, URI, 0, 0, 0, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
							gui.displayGraph(0);
							
							this.dispose();
                                                        
                        } catch (Exception e) {
                            e.printStackTrace(System.out);
                            System.exit(-1);
                        }
                    } else {
                        System.out.println("Open command cancelled by user.");
                    }
                } 
                
                
			else //this one will invoking the execution on-the-fly....
			     //A execution step adding............................
						   if (menu == menuFileOpenII) {
							   int returnVal = fc.showOpenDialog(menu);

							   if (returnVal == JFileChooser.APPROVE_OPTION) {
								   File file = fc.getSelectedFile();
								   System.out.println("Opening: \"" + file.getPath()+ "\".");

								   try {
                        	
									   //This userQuery would be reset here!
									   //userQuery = readFile(file.getPath());
                                                   
									   //tabbedpane.setSelectedIndex(0);
					
									   stepVector.removeAllElements();	
									   //faa.dispose();
									   XQueryGUI gui = new XQueryGUI(userQuery,username, password, URI, 0, 0, 0, xsdPath, file.getPath(), outputPath, rule1, rule2, rule3, rule4);
									   gui.displayGraph(7);//This gonna to be taken care of....
							
									   this.dispose();
                                                        
								   } catch (Exception e) {
									   e.printStackTrace(System.out);
									   System.exit(-1);
								   }
							   } else {
								   System.out.println("Open command cancelled by user.");
							   }
						   } 
						   
			else
						   if (menu == menuFileOpenIII) {
							   int returnVal = fc.showOpenDialog(menu);

							   if (returnVal == JFileChooser.APPROVE_OPTION) {
								   File file = fc.getSelectedFile();
								   System.out.println("Opening: \"" + file.getPath()+ "\".");
								   
								   String pathString = new String(file.getPath());
								   
								   String tempStr = new String(pathString.substring(3, pathString.length()));
								   System.out.println("Getting substring: " + tempStr);

								   try {
                        	
									   //This userQuery would be reset here!
									   //userQuery = readFile(file.getPath());
                                                   
									   //tabbedpane.setSelectedIndex(0);
					
									   stepVector.removeAllElements();	
									   //faa.dispose();
									   XQueryGUI gui = new XQueryGUI(userQuery,username, password, URI, 0, 0, 0, "File:///"+tempStr, inputPath, outputPath, rule1, rule2, rule3, rule4);
									   gui.displayGraph(4);
							
									   this.dispose();
                                                        
								   } catch (Exception e) {
									   e.printStackTrace(System.out);
									   System.exit(-1);
								   }
							   } else {
								   System.out.println("Open command cancelled by user.");
							   }
						   } 
						   
			else
						   if (menu == menuFileOutFile) {
							   int returnVal = fc.showOpenDialog(menu);

							   if (returnVal == JFileChooser.APPROVE_OPTION) {
								   File file = fc.getSelectedFile();
								   System.out.println("Opening: \"" + file.getPath()+ "\".");

								   try {
                        	
									   //This userQuery would be reset here!
									   //userQuery = readFile(file.getPath());
                                                   
									   //tabbedpane.setSelectedIndex(0);
					
									   stepVector.removeAllElements();	
									   //faa.dispose();
									   XQueryGUI gui = new XQueryGUI(userQuery,username, password, URI, 0, 0, 0, xsdPath, inputPath, file.getPath(), rule1, rule2, rule3, rule4);
									   gui.displayGraph(0);
							
									   this.dispose();
                                                        
								   } catch (Exception e) {
									   e.printStackTrace(System.out);
									   System.exit(-1);
								   }
							   } else {
								   System.out.println("Open command cancelled by user.");
							   }
						   } 
                
                
                
                
                else
                /*
                    if (menu == menuFileSave) {
                        int returnVal = fc.showSaveDialog(menu);

                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                            File file = fc.getSelectedFile();
                            // this is where a real application would save the file.
                            System.out.println("Saving: \"" + file.getName() + "\".");
                        } else {
                            System.out.println("Save command cancelled by user.");
                        }
                    } else
                    */   //The following two operations don't work, for some reason......
                    
                        if (menu == menuGraphRepaint) {
                            grappapanel1.repaint();
                        } else
                            if (menu == menuGraphPrint) {
                                // Get a PrinterJob     
                                PrinterJob job = PrinterJob.getPrinterJob();
                                // Specify the Printable is an instance of SimplePrint
                                job.setPrintable(grappapanel1);
                                // Put up the dialog box     
                                if (job.printDialog()) {
                                    // Print the job if the user didn't cancel printing 
                                    try {
                                        job.print();
                                    } catch (Exception e) { /* handle exception */
                                        System.out.println("Print Error: " + e.getMessage());
                                    }
                                }
                            } 
        }
        

			
       
        
        
    }
    protected void createMenu() {
        // Create the menu bar
        menuBar = new JMenuBar();

        // Set this instance as the application's menu bar
        setJMenuBar(menuBar);

        // Build the property sub-menu
        menuProperty = new JMenu("Plan_Generation");
        menuProperty.setMnemonic('P');
        
        menuXAT =  CreateMenuItem(menuProperty, ITEM_PLAIN, "Semantics-focused Plan", null, 'S', null);
        menuLogic = new JMenu("Raindrop Logical Plan");
        menuPhy =new JMenu("Raindrop Physical Plan");
		
        
        menuProperty.add(menuLogic);
        //menuProperty.add(menuPhy);
		menuPhysical =  CreateMenuItem(menuProperty, ITEM_PLAIN, "Raindrop Physical Plan", null, 'R', null);

        // Create property items
        menuMaxPush =
            CreateMenuItem(menuLogic, ITEM_PLAIN, "Maximal Pushdown", null, 'M', null);
        menuAllBinding =
            CreateMenuItem(menuLogic, ITEM_PLAIN, "All Nav Pushdown", null, 'A', null);
        //menuMainBindling =
        //    CreateMenuItem(menuLogic, ITEM_PLAIN, "MAIN BINDING", null, 'i', null);
		//menuSource =
		//	CreateMenuItem(menuLogic, ITEM_PLAIN, "SOURCE", null, 's', null);
		////menuNavSel =
		////	CreateMenuItem(menuLogic, ITEM_PLAIN, "NAV with SELECTION", null, 'n', null);
		//menuNavUnnestSel =
		//	CreateMenuItem(menuLogic, ITEM_PLAIN, "NAVUNNEST with SELECTION ", null, 'u', null);
		menuNav =
			CreateMenuItem(menuLogic, ITEM_PLAIN, "Nav Only Pushdown...", null, 'N', null);
		menuSelPar =
			CreateMenuItem(menuLogic, ITEM_PLAIN, "Nav & Sel Pushdown...", null, 'S', null);
			
		// Create property items for the physical set...
		menuMax =
			CreateMenuItem(menuPhy, ITEM_PLAIN, "MAXIMAL", null, 'a', null);
		menuABind =
			CreateMenuItem(menuPhy, ITEM_PLAIN, "ALL BINDING", null, 'b', null);
		//menuMainBindling =
		//    CreateMenuItem(menuPhy, ITEM_PLAIN, "MAIN BINDING", null, 'i', null);
		//menuSource =
		//	CreateMenuItem(menuPhy, ITEM_PLAIN, "SOURCE", null, 's', null);
		menuNaS =
			CreateMenuItem(menuPhy, ITEM_PLAIN, "NAV with SELECTION", null, 'n', null);
		//menuNavUnnestSel =
		//	CreateMenuItem(menuPhy, ITEM_PLAIN, "NAVUNNEST with SELECTION ", null, 'u', null);
		menuNa =
			CreateMenuItem(menuPhy, ITEM_PLAIN, "NAV ONLY", null, 'o', null);
		menuSPar =
			CreateMenuItem(menuPhy, ITEM_PLAIN, "SELECTION PARTIAL IN", null, 'p', null);
			

			
		// Create the graph menu
		menuGraph = new JMenu("File");
		menuGraph.setMnemonic('F');
		menuBar.add(menuGraph);

		// Create graph menu options
		/*
		menuGraphRepaint =
			CreateMenuItem(
				menuGraph,
				ITEM_PLAIN,
				"Repaint",
				null,
				'p',
				"Repaint the graph");
		*/
		
		menuFileOpen =
			CreateMenuItem(
		        menuGraph,
				ITEM_PLAIN,
				"Set XQuery File",
				new ImageIcon("open.gif"),
				'S',
				"Open a New XQuery File");
				
		menuGraphPrint =
			CreateMenuItem(menuGraph, ITEM_PLAIN, "Print...", null, 'P', "Print the Screen Information");
			
		menuGraph.addSeparator();
		 //menuFile.add(menuProperty);
		 //menuFile.addSeparator();
		 menuFileExit =
			 CreateMenuItem(menuGraph, ITEM_PLAIN, "Exit", null, 'E', "Exit the Program");
			 
			 

        // Create the file menu
        menuFile = new JMenu("Settings");
        menuFile.setMnemonic('e');
        //menuBar.add(menuFile);
		menuBar.add(menuProperty);
			
		
		
		
		//copyright menu part
		menuCopyright = new JMenu("Copyright");
		menuCopyright.setMnemonic('C');
		menuCopyr = CreateMenuItem(menuCopyright,ITEM_PLAIN,"Raindrop 1.0.1",null,'R',null);
		
		//SQO menupart
		menuSqo = new JMenu("Schema-based_Optimization");
		menuSqo.setMnemonic('S');
		
		//menuTry = new JMenu("Showing the Automaton");
		
		menuQG = CreateMenuItem(menuSqo,ITEM_PLAIN,"Query Graph",null,'q',null);
		menuFileOpenIII =
			CreateMenuItem(
				menuSqo,
				ITEM_PLAIN,
				"Set Schema File",
				new ImageIcon("open.gif"),
				'S',
				"Set a New Schema File");  
		menuSqoRule = CreateMenuItem(menuSqo,ITEM_PLAIN,"Apply SQO Rules...",null,'r',null);
		//menuSG = CreateMenuItem(menuSqo,ITEM_PLAIN,"Showing Schema Graph",null,'s',null);

		
		//menuSqoFlag = CreateMenuItem(menuSqo,ITEM_PLAIN,"Flag Setting",null,'r',null);
		
		
		menuBar.add(menuSqo);
		
		
		// Build the scale sub-menu
		menuScale = new JMenu("Set Parametes");
		menuScale.setMnemonic('S');

        // Create the file menu
        // Build a file menu items
        //menuFileNew = CreateMenuItem(menuFile, ITEM_PLAIN, "New", null, 'N', null);
                    
        
                
		menuFileOpenII =
			CreateMenuItem(
				menuFile,
				ITEM_PLAIN,
				"Set Token Source",
				new ImageIcon("open.gif"),
				'C',
				"Connect to a New Token File");
				

				
		/*
		menuFileOutFile =
			CreateMenuItem(
				menuFile,
				ITEM_PLAIN,
				"Set a New Plotting File",
				new ImageIcon("open.gif"),
				'S',
				"Set a New Plotting File");
		*/		
                
		/*       
        menuFileSave =
            CreateMenuItem(
                menuFile,
                ITEM_PLAIN,
                "Save",
                new ImageIcon("save.gif"),
                'S',
                "Save this file");
        
        menuFileSaveAs =
            CreateMenuItem(
                menuFile,
                ITEM_PLAIN,
                "Save As...",
                null,
                'A',
                "Save this data to a new file");
        */
        // Add the property menu to the file menu


        // Create the edit menu
        menuEdit = new JMenu("Edit");
        menuEdit.setMnemonic('E');
        
        //Take the edit out from the menu for raindrop GUI
        //menuBar.add(menuEdit);

        // Create edit menu options
        menuEditCut =
            CreateMenuItem(
                menuEdit,
                ITEM_PLAIN,
                "Cut",
                new ImageIcon("cut.gif"),
                't',
                "Cut data to the clipboard");
        menuEditCopy =
            CreateMenuItem(
                menuEdit,
                ITEM_PLAIN,
                "Copy",
                new ImageIcon("copy.gif"),
                'C',
                "Copy data to the clipboard");
        menuEditPaste =
            CreateMenuItem(
                menuEdit,
                ITEM_PLAIN,
                "Paste",
                new ImageIcon("paste.gif"),
                'P',
                "Paste data from the clipboard");



        // Create scale items
        menuScaleSet =
            CreateMenuItem(
                menuScale,
                ITEM_PLAIN,
                "Set Here",
                null,
                'S',
                null);
                
		menuScale.addSeparator();
		
        menuScale1 =
            CreateMenuItem(
                menuScale,
                ITEM_PLAIN,
                "Set As 1",
                null,
                '1',
                null);
        menuScale2 =
            CreateMenuItem(
                menuScale,
                ITEM_PLAIN,
                "Set As 2",
                null,
                '2',
                null);
        menuScale3 =
            CreateMenuItem(
                menuScale,
                ITEM_PLAIN,
                "Set As 3",
                null,
                '3',
                null);
        menuScale4 =
            CreateMenuItem(
                menuScale,
                ITEM_PLAIN,
                "Set As 4",
                null,
                '4',
                null);




        //menuGraphReset =
        //    CreateMenuItem(menuGraph, ITEM_PLAIN, "Reset", null, 's', "Reset the graph");
        //menuGraphResync =
        //    CreateMenuItem(menuGraph, ITEM_PLAIN, "Resync", null, 'y', "Resync the graph");
        // Add the scale menu to the graph menu
        //menuGraph.addSeparator();
        
        //Learning example of double level of pop-up menu here....
        //menuGraph.add(menuScale);
        
		//menuProperty.addSeparator();
		//menuProperty.add(menuScale);
		
		
		//setting plotting file
		//under the requirement, only two types are permitted...
		menuCom = new JMenu("Query_Execution");
		menuCom.setMnemonic('Q');
		menuBar.add(menuCom);
		menuPlot = new JMenu("Performance Comparison");
		
		menuFileOpenII =
			CreateMenuItem(
		        menuCom,
				ITEM_PLAIN,
				"Set Stream Source",
				new ImageIcon("open.gif"),
				'S',
				"Connect to Stream Source and Begin Execution"); 
		
		menuCom.add(menuPlot);
		
		menuComExe =
			CreateMenuItem(
				menuPlot,
				ITEM_PLAIN,
				"Plot Alternative Automata Pushdown Strategies",
				new ImageIcon("open.gif"),
				'S',
				"Plot Alternative Automata Pushdown Strategies");
                
		menuComSqo =
			CreateMenuItem(
				menuPlot,
				ITEM_PLAIN,
				"Plot Alternative SQO Plans",
				new ImageIcon("open.gif"),
				'Q',
				"Plot Alternative SQO Plans");
		
		menuBar.add(menuCopyright);
        
    }
    protected JMenuItem CreateMenuItem(
        JMenu menu,
        int iType,
        String sText,
        ImageIcon image,
        int acceleratorKey,
        String sToolTip) {
        // Create the item
        JMenuItem menuItem;

        switch (iType) {
            case ITEM_RADIO :
                menuItem = new JRadioButtonMenuItem();
                break;

            case ITEM_CHECK :
                menuItem = new JCheckBoxMenuItem();
                break;

            default :
                menuItem = new JMenuItem();
                break;
        }

        // Add the item test
        menuItem.setText(sText);

        // Add the optional icon
        if (image != null) {
            menuItem.setIcon(image);
        }

        // Add the accelerator key
        if (acceleratorKey > 0) {
            menuItem.setMnemonic(acceleratorKey);
        }

        // Add the optional tool tip text
        if (sToolTip != null) {
            menuItem.setToolTipText(sToolTip);
        }

        // Add an action handler to this menu item
        menuItem.addActionListener(this);

        menu.add(menuItem);

        return menuItem;
    }
    public void displayGraph(int indexSet) {
        this.setTitle("Raindrop - XQuery Evaluation over Streaming XML");
        this.setLocation(0, 0);

        // set the file filter for the file chooser
        KweeltFilter kf = new KweeltFilter();
        fc.setFileFilter(kf);

        // create the tabs
        tabbedpane = new JTabbedPane();
        Vector steps = getStepVector();
        //iterate through the steps in the vector and add them to the tabbedPane
        for (int i = 0; i < steps.size(); i++) {
            ProcessRDStep ps = (ProcessRDStep) steps.elementAt(i);
            tabbedpane.addTab(
                ps.getTabName(),
                new ImageIcon("images/icon.gif"),
                ps.getContentPane(),
                ps.getTabTip());
            System.out.println(ps.toString());
        }

        // well, select it the second panel.In order to trigger the Listener
        if(indexSet != 1)
         tabbedpane.setSelectedIndex(1);
        else
		tabbedpane.setSelectedIndex(0);

        tabbedpane.getModel().addChangeListener(new TabListener());
        // select the first tab, so we can have the first tab pane executed.
        tabbedpane.setSelectedIndex(indexSet);

        JPanel tabPanel = new JPanel();
        tabPanel.setLayout(new BorderLayout());
        tabPanel.add(tabbedpane, BorderLayout.CENTER);

        getContentPane().add("Center", tabPanel);


        // create menu.
        this.createMenu();
        this.setSize(1024, 710);

        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                //System.exit(0);
                 ((JFrame) e.getSource()).setVisible(false);
            }
        });

        this.setVisible(true);
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.lang.String
     */
    protected java.lang.String getPassword() {
        return password;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.util.Vector
     */
    public java.util.Vector getStepVector() {
        return stepVector;
    }
    /**
     * Insert the method's description here.
     * 
     * @return javax.swing.JTabbedPane
     */
    public javax.swing.JTabbedPane getTabbedpane() {
        return tabbedpane;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.lang.String
     */
    protected java.lang.String getURI() {
        return URI;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.lang.String
     */
    protected java.lang.String getUsername() {
        return username;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.lang.String
     */
    protected java.lang.String getUserQuery() {
        return userQuery;
    }
    /**
     * Insert the method's description here.
     * 
     * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    public edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree getUxat() {
        return uxat;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.lang.String
     */
    protected java.lang.String getViewQuery() {
        return viewQuery;
    }
    /**
     * Insert the method's description here.
     * 
     * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    public edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree getVxat() {
        return vxat;
    }
    /**
    * Reads in the contents of a file and converts it to a string object
    */
    protected static String readFile(String file) throws Exception {
        BufferedReader in =
            new BufferedReader(new InputStreamReader(new FileInputStream(file)));
        StringBuffer buf = new StringBuffer();
        String s;
        while ((s = in.readLine()) != null) {
            buf.append(s + "\n");
        }
        in.close();
        return buf.toString();
    }
    /**
     * Insert the method's description here.
     * Creation date: (5/21/2002 1:19:05 PM)
     */
    public void setParameters(
        String uname,
        String upasswd,
        String uURI,
        String uQuery,
        String vQuery) {
        username = uname;
        password = upasswd;
        URI = uURI;
        userQuery = uQuery;
        viewQuery = vQuery;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newPassword java.lang.String
     */
    protected void setPassword(java.lang.String newPassword) {
        password = newPassword;
    }
    /**
     * sets the binding hashtable for each step
     * 
     */
    public void setStepBindingTable(BindingTable userBindingTable) {
        for (int i = 0; i < stepVector.size(); i++) {
            ((ProcessRDStep) stepVector.elementAt(i)).setUserBindingTable(userBindingTable);
        }
    }
    /**
     * sets the binding hashtable for each step
     * 
     */
    public void setStepBindingTable(
        BindingTable userBindingTable,
        BindingTable viewBindingTable) {
        for (int i = 0; i < stepVector.size(); i++) {
            ((ProcessRDStep) stepVector.elementAt(i)).setUserBindingTable(userBindingTable);
            ((ProcessRDStep) stepVector.elementAt(i)).setViewBindingTable(viewBindingTable);
        }
    }
    /**
     * Insert the method's description here.
     * 
     * @param newStepVector java.util.Vector
     */
   public void setStepVector(java.util.Vector newStepVector) {
        stepVector = newStepVector;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newURI java.lang.String
     */
    protected void setURI(java.lang.String newURI) {
        URI = newURI;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newUsername java.lang.String
     */
    protected void setUsername(java.lang.String newUsername) {
        username = newUsername;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newUserQuery java.lang.String
     */
    protected void setUserQuery(java.lang.String newUserQuery) {
        userQuery = newUserQuery;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newUxat edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    public void setUxat(
        edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree newUxat) {
        uxat = newUxat;
        
        ///////////
        //System.out.println("PRINTING the tree"+uxat+"\n");
        //System.out.println("END of printing" + "\n");
        
        
        
    }
    /**
     * Insert the method's description here.
     * 
     * @param newViewQuery java.lang.String
     */
    public void setViewQuery(java.lang.String newViewQuery) {
        viewQuery = newViewQuery;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newVxat edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    public void setVxat(
        edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree newVxat) {
        vxat = newVxat;
    }
    /**
     * Updates the user and view trees of each step
     * 
     */
    
    public void DrawOriginalPanel(
	String userQuery_in,
	String username_in,
	String password_in,
	String URI_in) 
    {
    	 
		this.repaint(0);
    	
		//System.out.println("1 "+userQuery_in+" 1");
		//System.out.println("2 "+username_in+" 2");
		//System.out.println("3 "+password_in+" 3");
		//System.out.println("4 "+URI_in+" 4");
		//System.out.println("xxx"+getUserQuery());
			
		DocViewRDStep dvs = new DocViewRDStep(getUxat(), userQuery_in);
		TreeGenerationRDStep tgs = new TreeGenerationRDStep(getUxat(), getUserQuery());
		RDPlanGenerationStep rdp = new RDPlanGenerationStep(getUxat(), getUserQuery(), mappingSet, paraSet, paraSet2);
		RDPhyPlanGenStep rdpp = new RDPhyPlanGenStep(getUxat(), getUserQuery(),mappingSet, paraSet, paraSet2);
		SqoViewStep svs = new SqoViewStep(getUxat(), userQuery_in, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
		ExecutionRDStep qes = new ExecutionRDStep(getUxat(),getUsername(), getPassword(), getURI());
		AutoDrawStep ads = new AutoDrawStep(getUxat(), userQuery_in, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
		SGDrawStep sds = new SGDrawStep(getUxat(), userQuery_in, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
		QGDrawStep qds = new QGDrawStep(getUxat(), userQuery_in, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
		ExeStep es = new ExeStep(getUxat(), userQuery_in, mappingSet, paraSet, paraSet2, xsdPath, inputPath, outputPath, rule1, rule2, rule3, rule4);
		
		stepVector.addElement(dvs);
		stepVector.addElement(tgs);
		stepVector.addElement(rdp);
		stepVector.addElement(rdpp);
		stepVector.addElement(ads);
		stepVector.addElement(qds);
		stepVector.addElement(sds);
				
		//stepVector.addElement(qds);
		//stepVector.addElement(sds);
		//stepVector.addElement(qes);
		
		stepVector.addElement(es);
		stepVector.addElement(svs);
		//displayGraph();
		
		/*
		if(true)
		 //if(this instanceof TreeGenerationStep)
		 {
		 if(faa!=null) faa.dispose();
		 faa = new JFrame("XQuery");
		 Container cont = faa.getContentPane();
		 cont.setLayout (new FlowLayout());
			  cont.add(new JTextArea(userQuery));
		 faa.setSize(800,200);
	 
		 faa.show();
	 

		 }
		 */
		
		
    	
    }
    
    
    
    public void updateTrees() {

        for (int i = 0; i < stepVector.size(); i++) {
            ProcessRDStep ps1 = (ProcessRDStep) stepVector.elementAt(i);
            ps1.setUserTree(this.getUxat());
            ps1.setViewTree(this.getVxat());
        }

    }
}
