package edu.wpi.cs.dsrg.xmldb.xat.automata.utils;

/**
 * A set does not ensure the order of its components when converted to a list
 * this utility makes sure a list derived from the set has a fixed order, i.e., the lexicographical order of the string
 * Creation date: (5/14/2003 4:00:29 PM)
 * @author: Hong Su
 */
import java.util.*;
 
public class SetConverter {
/**
 * SetToFixOrderedList constructor comment.
 */
public SetConverter() {
	super();
}
/**
 * convert the given set always to a list in a fixed order
 * Creation date: (5/14/2003 4:01:53 PM)
 * @return java.lang.String[]
 * @param set java.util.Set
 */
static public List convertToOrderList(Set set) {
    String[] stringSet = (String[])set.toArray(new String[0]);

    for (int i = 0; i < stringSet.length - 1; i++) {
        int minPos = i;
        String minString = stringSet[i];
	    
        for (int j = i + 1; j < stringSet.length; j++) {
            if (stringSet[j].compareTo(minString) < 0){
	            //stringSet[j] < minString
              minString = stringSet[j];
              minPos = j;               
            }
        }

        //swap the position of the minimal string with the guard (i.e., stringSet[i])
        String temp = stringSet[i];
        stringSet[i] = minString;
        stringSet[minPos] = temp;
    }

    ArrayList list = new ArrayList();

    for (int i= 0; i<stringSet.length; i++)
      list.add(stringSet[i]);
      
    return list;
}
}
