package edu.wpi.cs.dsrg.xmldb.xat.automata.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollection;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnest;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Navigate;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.schemacleanup.SchemaCleanupVisitor;


/**
 * Insert the type's description here.
 * Creation date: (5/11/2003 10:00:02 PM)
 * @author: Hong Su
 */
 
public class TreeTraversal {
/**
 * SemanticsPlanVisitor constructor comment.
 */
public TreeTraversal() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 5:40:21 PM)
 */
static public Set getNavReliedBySels(XATTree tree) {
    
        //not set up yet
        Set result = new HashSet();

        Vector nodes = treeTopDownTraverse(tree);

        for (Iterator i = nodes.iterator(); i.hasNext();) {
            XATNode node = (XATNode) i.next();
            if (node.getOperator() instanceof Navigate && selOpsReliedOn(node))
                //a navigate node that has select
                result.add(node);

        }

        return result;
    }
/**
 * find in the tree underneath node (the node itself exclude),
 * how many navs are with sels defined on the column the nav generates
 * Creation date: (5/13/2003 5:40:21 PM)
 */
static public Set getNavReliedBySels(XATNode node) {

    //not set up yet
    Set result = new HashSet();

    if (node.getOperator() instanceof Source)
        return result;

    Vector nodes = treeTopDownTraverse(node.getChild(0));

    for (Iterator i = nodes.iterator(); i.hasNext();) {
        XATNode searchNode = (XATNode) i.next();
        if (searchNode.getOperator() instanceof Navigate && selOpsReliedOn(searchNode))
            //a navigate node that has select
            result.add(searchNode);

    }

    return result;
}
/**
 * Insert the method's description here.
 * Creation date: (5/15/2003 5:36:32 PM)
 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Navigate
 */
public static Set getNavReliedBySelsButNotReliedBy(Navigate op) {
	Set navsWithSels = getNavReliedBySels(op.getNode());
	List navsReliedBy = getNavsReliedBy(op);

	Set results = new HashSet();
	
	for (Iterator i = navsWithSels.iterator(); i.hasNext();){
		XATNode node = (XATNode)i.next();
		if (!(navsReliedBy.contains(node)))
			results.add(node);
	}

	return results;
	}
/**
 * find all the navs in the tree
 * Creation date: (5/13/2003 5:40:21 PM)
 */
static public Set getNavs(XATTree tree) {
    
        //not set up yet
        Set result = new HashSet();

        Vector nodes = treeTopDownTraverse(tree);

        for (Iterator i = nodes.iterator(); i.hasNext();) {
            XATNode node = (XATNode) i.next();
            if (node.getOperator() instanceof Navigate)
                //a navigate node that has select
                result.add(node);

        }

        return result;
    }
/**
 * find in the tree underneath node (the node itself exclude),
 * how many navs are defined on the column the nav generates
 * Creation date: (5/13/2003 5:40:21 PM)
 */
static public Set getNavs(XATNode node) {

    //not set up yet
    Set result = new HashSet();

    if (node.getOperator() instanceof Source)
        return result;

    Vector nodes = treeTopDownTraverse(node.getChild(0));

    for (Iterator i = nodes.iterator(); i.hasNext();) {
        XATNode searchNode = (XATNode) i.next();
        if (searchNode.getOperator() instanceof Navigate)
            //a navigate node that has select
            result.add(searchNode);

    }

    return result;
}
/**
 * given a navigate node, find how many navs underneath it
 * Creation date: (5/13/2003 10:46:14 PM)
 * @return java.util.ArrayList
 * @param selNode edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public static List getNavsReliedBy(Navigate navOp) {
    ArrayList results = new ArrayList();

    XATNode searchNode = navOp.getNode().getChild(0);
    XATOperator searchOp = searchNode.getOperator();

    Navigate generatingNavOp = null;

    while (!(searchOp instanceof Source)) {
        //find the generating nav for this node
        while (!(searchOp instanceof Source)) {
           if (searchOp instanceof Navigate) {
                Navigate foundNavOp = (Navigate) searchOp;
                if (foundNavOp
                    .getOutputColumnName()
                    .equals(navOp.getEntryPoint()[0].getStepValue())) {
                    generatingNavOp = foundNavOp;
                    break;
                }
            }
            searchNode = searchNode.getChild(0);
            searchOp = searchNode.getOperator();
        }

        if (searchOp instanceof Source)
         break;

        results.add(generatingNavOp.getNode());

        searchNode = searchNode.getChild(0);

        searchOp = searchNode.getOperator();

    }

   /* if (searchOp instanceof Navigate) {
        //searchOp is the nearest navigate descendant
        results.add(searchNode);
        String entryColName = ((Navigate) searchOp).getEntryPoint()[0].getStepValue();
        //find the navigate operator, continue to find its generating navigate operator
        searchNode = searchNode.getChild(0);
        searchOp = searchNode.getOperator();
        while (!(searchOp instanceof Source)) {
            if (searchOp instanceof Navigate) {
                String destinationColName = ((Navigate) searchOp).getOutputColumnName();
                if (destinationColName.equals(entryColName)) {
                    results.add(searchNode);
                    entryColName = ((Navigate) searchOp).getEntryPoint()[0].getStepValue();
                }
            }
            searchNode = searchNode.getChild(0);
            searchOp = searchNode.getOperator();
        }
    }*/

    return results;
}
/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 4:41:41 PM)
 * @return int
 */
static public int getNumOfNavReliedBySels(XATTree tree) {

    Set navWithSels = getNavReliedBySels(tree);

    return navWithSels.size();
}
/**
 * find all the navs in the tree
 * Creation date: (5/13/2003 5:40:21 PM)
 */
static public List getSels(XATTree tree) {
    
        //not set up yet
        List result = new ArrayList();

        Vector nodes = treeTopDownTraverse(tree);

        for (Iterator i = nodes.iterator(); i.hasNext();) {
            XATNode node = (XATNode) i.next();
            if (node.getOperator() instanceof Select)
                //a navigate node that has select
                result.add(node);

        }

        return result;
    }
/**
 * find in the tree underneath node (the node itself exclude),
 * how many sels are defined on the column the nav generates
 * Creation date: (5/13/2003 5:40:21 PM)
 */
static public Set getSels(XATNode node) {

    //not set up yet
    Set result = new HashSet();

    if (node.getOperator() instanceof Source)
        return result;

    Vector nodes = treeTopDownTraverse(node.getChild(0));

    for (Iterator i = nodes.iterator(); i.hasNext();) {
        XATNode searchNode = (XATNode) i.next();
        if (searchNode.getOperator() instanceof Select)
            //a navigate node that has select
            result.add(searchNode);

    }

    return result;
}
/**
 * get the navigate node which generates the column that the selNode consumes
 * Creation date: (5/13/2003 9:09:06 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 * @param selNode edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public static XATNode getSrcNode(XATNode selNode) {
	XATNode searchNode = selNode.getChild(0);

	while (!(searchNode.getOperator() instanceof Navigate)){
		searchNode = searchNode.getChild(0);
	}
	
	return searchNode;
}

/**
 * pull up a navigate with no selection above any selections
 * Creation date: (5/16/2003 12:47:33 PM)
 * @param navOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Navigate
 */
public static void navWithoutSelPulledUp(XATTree xattree) {

    Vector nodes = treeTopDownTraverse(xattree);

    int size = nodes.size();

    Set navNodesWithSels = getNavReliedBySels(xattree);

    HashMap highestPosForNodes = new HashMap();

    for (int i = 0; i < size; i++) {
        XATNode node = (XATNode) nodes.get(i);
        XATOperator op = node.getOperator();

        if (op instanceof Navigate && !navNodesWithSels.contains(node)) {
            //this op is a navigate without sels, should be pulled as high as possible
            //find the highest position it could be pulled up to
            XATNode searchNode = node.getParent();
            XATOperator searchOp = searchNode.getOperator();
            while (!(searchOp instanceof Tagger)) {
                if (!(searchOp instanceof Navigate) || searchOp instanceof Select) {
                    searchNode = searchNode.getParent();
                    searchOp = searchNode.getOperator();
                } else {
                    if (searchOp instanceof Navigate) {
                        if (!getNavsReliedBy((Navigate) searchOp).contains(node))
                            //searchOp is dependent from op 
                            if (navNodesWithSels.contains(searchNode)) {
                                //and searchOp has a sel on it
                                //so searchOp must be under op
                                searchNode = searchNode.getParent();
                                searchOp = searchNode.getOperator();
                            } else
                                //searchOp has no sel on it, so searchOp could maintain the same position
                                break;
                        else
                            //searchOp is dependt on op
                            break;
                    } else
                        if (searchOp instanceof Select) {
                            searchNode = searchNode.getParent();
                            searchOp = searchNode.getOperator();
                        }

                } //end of else

            } //end of while

            //fix the position of the op
            //it should be inserted under searchNode
            if (node.getParent() != searchNode){
	            //it needs change
	            XATNode currentParent = node.getParent();
	            XATNode currentChild = node.getChild(0);
	            currentParent.setChild(0, currentChild);
	            currentChild.setParent(currentParent);

	            XATNode toBeParent = searchNode;
	            XATNode toBeChild = searchNode.getChild(0);
	            toBeParent.setChild(0, node);
	            node.setParent(toBeParent);
	            toBeChild.setParent(node);
	            node.setChild(0, toBeChild);
	            
            }

        } //end of if
    }//end of for
}
/**
 * whether navNode has a selection defined on
 * Creation date: (5/11/2003 10:04:57 PM)
 * @return java.util.ArrayList
 * @param navNode edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
static public boolean selOpsDefinedOn(XATNode navNode) {
    XATOperator navOp = navNode.getOperator();
    if (!(navOp instanceof NavCollection) && !(navOp instanceof NavUnnest)) {
        System.out.println("exception: must be a navCollection or NavUnnest operator");
        System.exit(-1);
    }

    if (navNode.getParent() instanceof Select)
        return true;
    else
        return false;

}
/**
 * whether there is a select dependent on it
 * Creation date: (5/11/2003 10:04:57 PM)
 * @return java.util.ArrayList
 * @param navNode edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
static public boolean selOpsReliedOn(XATNode navNode) {
    XATOperator navOp = navNode.getOperator();
    String outputColName = navOp.getOutputColumnName();

    if (!(navOp instanceof NavCollection) && !(navOp instanceof NavUnnest)) {
        System.out.println("exception: must be a navCollection or NavUnnest operator");
        System.exit(-1);
    }

    XATNode searchNode = navNode.getParent();
    ArrayList result = new ArrayList();

    while (searchNode != null) {

        XATOperator searchOp = (XATOperator) searchNode.getOperator();

        if (searchOp instanceof Navigate && ((Navigate)searchOp).getEntryPoint()[0].toString().equals(navOp.getOutputColumnName())) {
	        //find the navigate originates from it
            if (selOpsReliedOn(searchNode))
                return true;
        }

        if (searchOp instanceof Select) {
            Select selectOp = (Select) searchOp;
            ColumnName[] relatedCols = selectOp.getExpression().getRelatedColumnNames();
            for (int i = 0; i < relatedCols.length; i++)
                if (relatedCols[i].toString().equals(outputColName))
                    return true;
        }

        searchNode = searchNode.getParent();

    }

    return false;
}

/**
 * only leave num sels closet to their navs, all the others under tagger
 * Creation date: (5/16/2003 12:47:33 PM)
 * @param navOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Navigate
 */
public static void selPulledUp(int num, XATTree xattree) {

    Vector nodes = treeTopDownTraverse(xattree);

    XATNode taggerNode = null;

    for (int i = 0; i < nodes.size(); i++)
        if (((XATNode) nodes.get(i)).getOperator() instanceof Tagger)
            taggerNode = (XATNode) nodes.get(i);

    List sels = getSels(xattree);

    int pullUpNum = sels.size() - num;

    for (int i = 0; i < pullUpNum; i++) {
        XATNode selNode = (XATNode) sels.get(i);

        XATNode currentParent = selNode.getParent();
        XATNode currentChild = selNode.getChild(0);
        currentParent.setChild(0, currentChild);
        currentChild.setParent(currentParent);

        XATNode toBeParent = taggerNode;
        XATNode toBeChild = taggerNode.getChild(0);
        toBeParent.setChild(0, selNode);
        selNode.setParent(toBeParent);
        toBeChild.setParent(selNode);
        selNode.setChild(0, toBeChild);

    }

     SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
        sc.visit(xattree);
}
/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 5:25:40 PM)
 * @return java.util.Vector
 * @param xattree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public static Vector treeBottomUpTraverse(XATTree xattree) {
		Vector resultSet = new Vector();

  try {

	  XATNode root = (XATNode)xattree.getRoot();
		XATNode leaf = root;
		while(leaf.getChildrenSize() > 0)
			leaf = (XATNode)leaf.getChild(0);

    //Do breath first traverse
    Set curSet = new HashSet();//contains nodes on current visiting level
    Set nextSet = new HashSet();//contains nodes on next visiting level

		//traversal begins from the leaf
    curSet.add(leaf);
    do {
			//for each node in current level
	    for (Iterator it = curSet.iterator(); it.hasNext();) {
        XATNode curNode = (XATNode) it.next();

        //visit this node
        resultSet.add(curNode);

        if (curNode != root) {
          //XATNode[] parents = curNode.getParents();

          //push each parent in next level
          //for (int i = 0; i < parents.length; i++) {
					for(Iterator parentIt = curNode.getParents(); parentIt.hasNext();){
						//flag == true means all parents are visited
						XATNode curParent = (XATNode)parentIt.next();
            boolean flag = true;
            XATNode[] prevLevel = curParent.getChildren();
            for (int j = 0; j < prevLevel.length; j++) {
              if (!resultSet.contains(prevLevel[j])) {
                flag = false;
                break;
              }
            }

            if (flag) 
            	nextSet.add(curParent);
          }//push each parent
        } //push next level

      } //for

      curSet = nextSet;
      nextSet = new HashSet();
    } while (!curSet.isEmpty());

  } catch (Exception e) {
    e.printStackTrace();
  }

  return resultSet;
}
/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 5:26:51 PM)
 * @return java.util.Vector
 * @param xattree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public static Vector treeTopDownTraverse(XATTree xattree) {
	 Vector resultSet = new Vector();

  try {

    //Do breath first traverse
    Set curSet = new HashSet();//contains nodes on current visiting level
    Set nextSet = new HashSet();//contains nodes on next visiting level

		//traversal begins from root
    curSet.add(xattree.getRoot());
    do {
			//for each node in current level
	    for (Iterator it = curSet.iterator(); it.hasNext();) {
        XATNode curNode = (XATNode) it.next();

        //visit this node
        resultSet.add(curNode);

        if (curNode.getChildrenSize() > 0) {
          XATNode[] children = curNode.getChildren();

          //push each child in next level
          for (int i = 0; i < children.length; i++) {
            XATNode curChild = (XATNode) children[i];

						//flag == true means all parents are visited
            boolean flag = true;
            //XATNode[] prevLevel = curChild.getParents();
            //for (int j = 0; j < prevLevel.length; j++) {
            for(Iterator prevIt = curChild.getParents(); prevIt.hasNext();){
	            XATNode curPrev = (XATNode)prevIt.next();
	            if (!resultSet.contains(curPrev)) {
                flag = false;
                break;
              }
            }

            if (flag)
              nextSet.add(curChild);
          }//push each child
        } //push next level

      } //for

      curSet = nextSet;
      nextSet = new HashSet();
    } while (!curSet.isEmpty());

  } catch (Exception e) {
    e.printStackTrace();
  }

  return resultSet;
}
/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 5:27:47 PM)
 * @return java.util.Vector
 * @param root edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public static Vector treeTopDownTraverse(XATNode root) {
	Vector resultSet = new Vector();

  try {

    //Do breath first traverse
    Set curSet = new HashSet();//contains nodes on current visiting level
    Set nextSet = new HashSet();//contains nodes on next visiting level

		//traversal begins from root
    curSet.add(root);
    do {
			//for each node in current level
	    for (Iterator it = curSet.iterator(); it.hasNext();) {
        XATNode curNode = (XATNode) it.next();

        //visit this node
        resultSet.add(curNode);

        if (curNode.getChildrenSize() > 0) {
          XATNode[] children = curNode.getChildren();

          //push each child in next level
          for (int i = 0; i < children.length; i++) {
            XATNode curChild = (XATNode) children[i];

						//flag == true means all parents are visited
            boolean flag = true;
            //XATNode[] prevLevel = curChild.getParents();
            //for (int j = 0; j < prevLevel.length; j++) {
            for(Iterator prevIt = curChild.getParents(); prevIt.hasNext();){
	            XATNode curPrev = (XATNode)prevIt.next();
	            if (!resultSet.contains(curPrev)) {
                flag = false;
                break;
              }
            }

            if (flag)
              nextSet.add(curChild);
          }//push each child
        } //push next level

      } //for

      curSet = nextSet;
      nextSet = new HashSet();
    } while (!curSet.isEmpty());

  } catch (Exception e) {
    e.printStackTrace();
  }

  return resultSet;
}
}

