package edu.wpi.cs.dsrg.xmldb.xat.common.calculators;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.AggregateStatisticsObject;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsGatherer;
/**
 * Calculates the average time that it takes tuples to move through the system. This is 
 * calculated by asking the XATStreamApplication to look at the tuples
 * in the roots' queues and averaging the delay.  The XSA returns a standard mean and this
 * value will be (weighed) averaged with the other values.  There is a small caveat here
 * related to the XSA.  Because the XSA will remove the tuples from the queues,
 * the OVERALL category cannot be updated correctly.  Therefore, the XSA will
 * only remove the tuples if the category is OVERALL.  This is a small hack...
 * @author: Brad Pielech
 */
public class AverageTupleDelay extends AggregateStatisticsObject {
/**
 * AverageTupleDelay constructor comment.
 */
public AverageTupleDelay() {
	super();
}
/**
 * AverageTupleDelay constructor comment.
 * @param name java.lang.String
 * @param queryObject edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject
 */
public AverageTupleDelay(String name, XATQueryObject queryObject) {
	super(name, queryObject);
}
/**
 * This is semantically the same as <tt>calculateNewValue()</tt>, but this
 * provides a parameter which assists in the calculation.
 * Calculates the new Value of the given property of this operator.  This
 * should be overwritten by subclasses who can tailor this method to calculating 1
 * specific property. <p>
 * This method should update at least the local propertyValue and possibly the
 * value with the operator The entire StatisticsGatherer is available for assistance.   <p>
 *
 * The procedure for calculating new values should be as follows:
 *
 * <ol>
 * <li> Consult the statsTable for any propertyValues that are needed.
 * <li> Perform the required calculations using the propertyValues from step 1
 * <li> Update the local propertyValue.
 * <li> Update the lastTimeUpdated value by using <tt>lastTimeUpdated = System.currentTimeMillis();</tt>
 * </ol> 
 */
public void calculateNewValue() {
	//remove if this is for the overall category
	boolean remove = (getCategory() == StatisticsGatherer.OVERALL) ? true:false;
	//this.setPropertyValue("" + XATStreamApplication.getXATStreamApplication().calculateAverageTupleAge(remove));	
	//@TODO fix this somehow without application? not sure about this.
	this.setPropertyValue("" + 0 );	
}
/**
 * This is semantically the same as <tt>calculateNewValue()</tt>, but this
 * provides a parameter which assists in the calculation.
 * Calculates the new Value of the given property of this operator.  This
 * should be overwritten by subclasses who can tailor this method to calculating 1
 * specific property. <p>
 * This method should update at least the local propertyValue and possibly the
 * value with the operator The entire StatisticsGatherer is available for assistance.   <p>
 *
 * The procedure for calculating new values should be as follows:
 *
 * <ol>
 * <li> Consult the statsTable for any propertyValues that are needed.
 * <li> Perform the required calculations using the propertyValues from step 1
 * <li> Update the local propertyValue.
 * <li> Update the lastTimeUpdated value by using <tt>lastTimeUpdated = System.currentTimeMillis();</tt>
 * </ol> 
 */
public void calculateNewValue(String newValue) {
	//remove if this is for the overall category
	boolean remove = (getCategory() == StatisticsGatherer.OVERALL) ? true:false;
	//this.setPropertyValue("" + XATStreamApplication.getXATStreamApplication().calculateAverageTupleAge(remove));	
	//@TODO fix this somehow without application? not sure about this.
	this.setPropertyValue("" + 0 );	
}
}
