package edu.wpi.cs.dsrg.xmldb.xat.common.calculators;

import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsObject;
/**
 * Calculates the number of tuples this operator has dequeued total.  This
 * is conceptually equivalent to how much work the operator has done
 * @author: Brad Pielech
 */
public class NumberOfTuplesToDequeue extends StatisticsObject {
/**
 * NumberOfTuplesToDequeue constructor comment.
 */
public NumberOfTuplesToDequeue() {
	super();

}
/**
 * NumberOfTuplesToDequeue constructor comment.
 * @param name java.lang.String
 * @param operator edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator
 */
public NumberOfTuplesToDequeue(String name, edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator operator) {
	super(name, operator);
}
/**
 * Calculates the new Value of the given property of this operator.  This
 * should be overwritten by subclasses who can tailor this method to calculating 1
 * specific property. <p>
 * This method should update at least the local propertyValue and possibly the
 * value with the operator The entire StatisticsGatherer is available for assistance.   <p>
 *
 * The procedure for calculating new values should be as follows:
 *
 * <ol>
 * <li> Consult the statsTable for any propertyValues that are needed.
 * <li> Perform the required calculations using the propertyValues from step 1
 * <li> Update the local propertyValue.
 * 
 * <li> Update the lastTimeUpdated value by using <tt>lastTimeUpdated = System.currentTimeMillis();</tt>
 * </ol> 
 */
public void calculateNewValue() {
	
	this.setPropertyValue(getAssociatedQueryObject().getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
}
}
