package edu.wpi.cs.dsrg.xmldb.xat.common.calculators;

import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsObject;
/**
 * This provides a convience method for summing the number of tuples in
 * output queues. It relies on the corresponding TUPLE_COUNT values that
 * are stored within the StatisticsGatherer
 */
public abstract class TuplesInQueueCalculator extends StatisticsObject {
/**
 * TuplesInQueueCalculator constructor comment.
 */
public TuplesInQueueCalculator() {
	super();
}
/**
 * TuplesInQueueCalculator constructor comment.
 * @param name java.lang.String
 * @param queryObject edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject
 */
public TuplesInQueueCalculator(String name, edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject queryObject) {
	super(name, queryObject);
}
/**
 * This is a convience method for the NumberOfTuplesInOutput and Input Queues
 * Statistics Objects.  Rather than have both classes calculate the tuple count the same way,
 * this method allows for the sharing of code.
 * @param queues an Iteration of XATQueues
 */
public String calculateTupleCount(Iterator queues) {
	
	int count = 0;
	/** iterate through queues */
	for (;queues.hasNext();) {
		XATQueue queue = (XATQueue)queues.next();
		count = count + queue.getQueueSize();		
	}	
	return "" + count;			
}
}
