package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

/**
 * This class represents a Node in a DAG.
 * It need to extend from XATNode because
 * XATOperator only knows XATNode.
 * 
 * Creation date: (2003-1-9 22:03:39)
 * @author: JinHui Jian
 */
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;

public interface DagNode extends XATNode{
/**
 * adds a new parent.  The parent is added to the right of the previous parents
 * @param parent edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.DagNode
 */
void addParent(XATNode parent);


/**
 * Removes the specified parent
 * @param parent edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.DagNode
 */
void deleteParent(XATNode parent);
void deleteAllParents();

/**
 * Returns the parent at the specified index
 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.DagNode
 * @param id int
 */
DagNode getParent(int id);

/**
 * Returns how many parents this DagNode has
 * @return int
 */
int getParentsSize();

int getIndexOfParent(DagNode dn);
int getIndexOfChild(DagNode dn);

/**
 * Set the specified parent 
 * @param id int
 * @param newParent the new XATNode
 */
public void setParent(int id, XATNode newParent);

}
