package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

/**
 * Insert the type's description here.
 * Creation date: (2002-12-22 15:59:48)
 * @author: sk
 */
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.Vector;
import java.io.Serializable;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp;

public class XATQueueSchema implements Serializable{
    private Vector colNames = null;
    //a vector of column names, these column stores whether some data exists or not rather than the actual value
    //suited for a[b], only care whether there exists b rather than b's value	
    private Vector existentialColNames = null;
    //alias of the input
    private java.lang.String name;
    private java.util.Vector unsatisfiedExistentialColNames = null;
/**
 * QueueMetadata constructor comment.
 */

public XATQueueSchema() {
	super();
	colNames = new Vector();
}
/**
 * QueueMetadata constructor comment.
 */

public XATQueueSchema(Vector names) {
	super();
	colNames = names;
}
/**
 * Insert the method's description here.
 * Creation date: (2002-12-24 14:08:13)
 * @param name java.lang.String
 */
public void addColumn(String name) {
	colNames.add(name);	
}
/**
 * Insert the method's description here.
 * Creation date: (2/19/2003 9:59:01 PM)
 * @return java.util.Vector
 */
public java.util.Vector getExistentialColNames() {
	return existentialColNames;
}
/**
 * Insert the method's description here.
 * Creation date: (1/23/2003 10:15:01 PM)
 * @return int
 */
public int getLength() {
	return colNames.size();
}
/**
 * Insert the method's description here.
 * Creation date: (1/23/2003 5:44:25 PM)
 * @return java.lang.String
 */
public String getName() {
	return name;
}

public void setName(String name){
	this.name = name;
}
/**
 * Insert the method's description here.
 * Creation date: (2002-12-24 13:32:14)
 * @deprecated use getColNames()
 * @return java.util.Vector
 */
public Vector getNames() {
	return colNames;
}
/**
 * Insert the method's description here.
 * Creation date: (2002-12-22 16:01:12)
 * @return int
 * @param colName java.lang.String
 */
public int getPos(String colName)throws NoSuchElementException {
  int index = colNames.indexOf(colName);
  if(index < 0)
  	throw new NoSuchElementException();
  return index;
}
/**
 * Insert the method's description here.
 * Creation date: (2/19/2003 9:03:28 PM)
 * @return java.util.Vector
 */
public java.util.Vector getUnsatisfiedExistentialColNames() {
	if (unsatisfiedExistentialColNames == null){
		unsatisfiedExistentialColNames = existentialColNames;
	}
	 
	return unsatisfiedExistentialColNames;
}
/**
 * whether colName is a existential column
 * Creation date: (2/19/2003 4:08:56 PM)
 * @return boolean
 * @param colName java.lang.String
 */
public boolean isExistentialCol(String colName) {
	if (!(existentialColNames==null)){
		return existentialColNames.contains(colName);
	}
	else return false;
}
/**
 * remove the column from unsatisfiedexistentialcolnames
 * Creation date: (2/19/2003 9:05:51 PM)
 * @param colName java.lang.String
 */
public void removeFrUnsatisfied(String colName) {

	

/*    for (int i = 0; i < unsatisfiedExistentialColNames.size(); i++) {
        if (unsatisfiedExistentialColNames.get(i).equals(colName)) {
            unsatisfiedExistentialColNames.remove(i);
            break;
        }

    }*/

    unsatisfiedExistentialColNames.remove(colName);

}
/**
 * Insert the method's description here.
 * Creation date: (2/19/2003 9:59:01 PM)
 * @param newExistentialColNames java.util.Vector
 */
public void setExistentialColNames(java.util.Vector newExistentialColNames) {
	existentialColNames = newExistentialColNames;
}
/**
 * Insert the method's description here.
 * Creation date: (2002-12-25 14:53:14)
 * @return java.lang.String
 */
public String toString() {
	StringBuffer sb = new StringBuffer();
	sb.append("{");
	for(Iterator it = colNames.iterator(); it.hasNext();){
		String name = (String)it.next();
		sb.append(this.getName());
		sb.append(".");
		sb.append(name);
		sb.append(", ");
	}
	sb.append("}");
	return sb.toString();
}
	/**
	 * @return
	 */
	public Vector getColNames() {
		return colNames;
	}

	/**
	 * @param vector
	 */
	public void setColNames(Vector vector) {
		colNames = vector;
	}

}
