/*
 * Created on Jun 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.operatortester;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PWSingleEquiJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunction;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamFunctionCount;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.basics.StatGather;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.state.*;
import java.util.Vector;
import java.lang.reflect.Constructor;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ExperimentLauncher {	
	public static void main(String[] args) {
		testPWJoinOperator(args[0]);
		//testStreamGroupbyOperator();
	}

	private static void testStreamGroupbyOperator() { 
		StreamGroupbyOperator groupby = new StreamGroupbyOperatorImp(new XATNodeImp());
		groupby.setGroupAttrPosArray(new int[] {0});
		StreamFunction countFunc = new StreamFunctionCount();
		countFunc.setAttrPos(0);
		groupby.setAggFunctions(new StreamFunction[] {countFunc});
		
		int[] inputDataType = new int[] {TupleReaderImp.Integer};
		Vector inputDTypes = new Vector();
		inputDTypes.add(inputDataType);
		
		XATQueueSchema inSchema = new XATQueueSchema();
		inSchema.addColumn("itemID");
		
		XATQueueSchema[] inSchemas = new XATQueueSchema[] {inSchema};
		
		int[] maxNumTuples = new int[] {200};
		
		String[] sDataFiles = new String[] {"resources/PWJoin/data/Bid.txt"};
		
		OperatorTester opTest = new OperatorTester(groupby, new long[] {1000});
		opTest.initialize(inputDTypes, inSchemas, inSchema, maxNumTuples, sDataFiles);
		opTest.run();
	}
		
	private static void testPWJoinOperator(String configFileName) {
		ConfigFileParser cfp = null;
		try { 
			cfp = new ConfigFileParser(configFileName);
		} catch(Exception e) {
			e.printStackTrace();
		}
		int num_input = cfp.getNumInput();
		PWSingleEquiJoinOperator pwjoin = null;
		try {
			Constructor[] construct = Class.forName(cfp.getOperatorClass()).getConstructors();
			pwjoin = (PWSingleEquiJoinOperator)construct[0].newInstance(new Object[] {new XATNodeImp()});
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		pwjoin.setJoinAttrPos(cfp.getJoinPos());
		pwjoin.setWindowSize(cfp.getWindowSize());
		
		PWJoinState state = null;
		try {
			Constructor[] construct = Class.forName(cfp.getJoinStateClass()).getConstructors();
			state = (PWJoinState)construct[0].newInstance(new Object[] {new Integer(num_input)});
		} catch(Exception e) {
			e.printStackTrace();
		}

		//PWJoinState state = new PWJoinStateSelectiveMaterialImp(num_input);
		state.setJoinAttrPos(cfp.getJoinPos());
		state.setWindowSize(cfp.getWindowSize());
		state.setStreamSelectivity(cfp.getStreamSelectivity());
		state.setStreamRate(cfp.getStreamRate());
		state.setMaterialThreshold(cfp.getMaterialThreshold());
		
		Index index = new HashIndexImp(num_input);
		state.setIndex(index);
		pwjoin.setJoinState(state);
		
		int[] inputDataType = new int[] {TupleReaderImp.Integer};
		Vector inputDTypes = new Vector();
		for (int i=0; i<num_input; i++) {
			inputDTypes.add(inputDataType);
		}
		
		XATQueueSchema inSchema = new XATQueueSchema();
		inSchema.addColumn("itemID");
		XATQueueSchema[] inSchemas = new XATQueueSchema[num_input];
		for (int i=0; i<num_input; i++) {
			inSchemas[i] = inSchema;
		}
		
		XATQueueSchema outSchema = new XATQueueSchema();
		for (int i=0; i<num_input; i++) {
			outSchema.addColumn("itemID");
		}
		
		int[] maxNumTuples = new int[num_input];
		for (int i=0; i<num_input; i++) {
			maxNumTuples[i] = cfp.getMaxNumTupleRead();
		}
		
		String[] sDataFiles = cfp.getInputDataFile();
		
		long[] timeInterval = cfp.getTimeInterval();
		OperatorTester opTest = new OperatorTester(pwjoin, timeInterval);
		opTest.initialize(inputDTypes, inSchemas, outSchema, maxNumTuples, sDataFiles);
		opTest.start();
		
		StatGather stat = new StatGather(30000, 500);
		stat.start();
		
		try {
			opTest.join();
			//stat.join();
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		stat.stopRecording();
	}

	private static void testDistinctOperator(String configFileName) {
		ConfigFileParser cfp = null;
		try { 
			cfp = new ConfigFileParser(configFileName);
		} catch(Exception e) {
			e.printStackTrace();
		}
		int num_input = cfp.getNumInput();
		PWSingleEquiJoinOperator pwjoin = null;
		try {
			Constructor[] construct = Class.forName(cfp.getOperatorClass()).getConstructors();
			pwjoin = (PWSingleEquiJoinOperator)construct[0].newInstance(new Object[] {new XATNodeImp()});
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		pwjoin.setJoinAttrPos(cfp.getJoinPos());
		pwjoin.setWindowSize(cfp.getWindowSize());
		
		PWJoinState state = null;
		try {
			Constructor[] construct = Class.forName(cfp.getJoinStateClass()).getConstructors();
			state = (PWJoinState)construct[0].newInstance(new Object[] {new Integer(num_input)});
		} catch(Exception e) {
			e.printStackTrace();
		}

		//PWJoinState state = new PWJoinStateSelectiveMaterialImp(num_input);
		state.setJoinAttrPos(cfp.getJoinPos());
		state.setWindowSize(cfp.getWindowSize());
		state.setStreamSelectivity(cfp.getStreamSelectivity());
		state.setStreamRate(cfp.getStreamRate());
		state.setMaterialThreshold(cfp.getMaterialThreshold());
		
		Index index = new HashIndexImp(num_input);
		state.setIndex(index);
		pwjoin.setJoinState(state);
		
		int[] inputDataType = new int[] {TupleReaderImp.Integer};
		Vector inputDTypes = new Vector();
		for (int i=0; i<num_input; i++) {
			inputDTypes.add(inputDataType);
		}
		
		XATQueueSchema inSchema = new XATQueueSchema();
		inSchema.addColumn("itemID");
		XATQueueSchema[] inSchemas = new XATQueueSchema[num_input];
		for (int i=0; i<num_input; i++) {
			inSchemas[i] = inSchema;
		}
		
		XATQueueSchema outSchema = new XATQueueSchema();
		for (int i=0; i<num_input; i++) {
			outSchema.addColumn("itemID");
		}
		
		int[] maxNumTuples = new int[num_input];
		for (int i=0; i<num_input; i++) {
			maxNumTuples[i] = cfp.getMaxNumTupleRead();
		}
		
		String[] sDataFiles = cfp.getInputDataFile();
		
		long[] timeInterval = cfp.getTimeInterval();
		OperatorTester opTest = new OperatorTester(pwjoin, timeInterval);
		opTest.initialize(inputDTypes, inSchemas, outSchema, maxNumTuples, sDataFiles);
		opTest.start();
		
		StatGather stat = new StatGather(30000, 500);
		stat.start();
		
		try {
			opTest.join();
			//stat.join();
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		stat.stopRecording();
	}
}
