/*
 * Created on May 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.operatortester;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATMemoryQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.PWSingleEquiJoinOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import java.util.Vector;
import java.io.BufferedWriter;
import java.io.FileWriter;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OperatorTester extends Thread {

	XATStreamOperator operator;

	int numInputQueues;
	TupleReader[] tupleReaders;
	long[] timeInterval;
	
	//BufferedWriter out;
	
	/**
	 * constructor
	 */
	public OperatorTester() {
	}
	
	public OperatorTester(XATStreamOperator op, long[] timeInterval) {
		operator = op;
		this.timeInterval = timeInterval;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.OperatorTester#getOperator()
	 */
	public XATStreamOperator getOperator() {
		return operator;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.OperatorTester#setOperator(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public void setOperator(XATStreamOperator op) {
		operator = op;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.OperatorTester#initialize(java.util.Vector, int[], edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema[], edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema, int[], java.lang.String[])
	 */
	public void initialize(Vector inputDataTypes,
	                       XATQueueSchema[] inputSchema,
	                       XATQueueSchema outputSchema,
	                       int[] maxNumTuplesReadArray,
	                       String[] streamDataFiles) {
	                       	
		numInputQueues = maxNumTuplesReadArray.length;
		XATQueue outQueue = new XATMemoryQueueImp(operator);
		outQueue.setSchema(outputSchema);
		operator.setOutputQueue(outQueue);
		tupleReaders = new TupleReader[numInputQueues];
		for (int i=0; i<numInputQueues; i++) {
			XATQueue queue = new XATMemoryQueueImp();
			queue.setSchema(inputSchema[i]);
			operator.addInputQueue(queue);
			TupleReader tReader = new TupleReaderImp(timeInterval[i]);
			tReader.setQueue(queue);
			tReader.setDataTypes((int[]) inputDataTypes.get(i));
			tReader.setMaxNumTuplesRead(maxNumTuplesReadArray[i]);
			tReader.setStreamDataFile(streamDataFiles[i]);
			tupleReaders[i] = tReader;
		}
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.OperatorTester#run()
	 */
	public void run() {
		while(true) {
			int stopCondition = 0;
			for (int i=0; i<numInputQueues; i++) {
				if (tupleReaders[i].read()) {
					stopCondition ++;
				}
			}
			try {
				operator.run();
				BufferedWriter writer = new BufferedWriter(new FileWriter("result_generation_time.txt", true));
				Vector timeVector = ((PWSingleEquiJoinOperator)operator).getTimeVector();
				if (timeVector.size()>0) {
					for (int i=0; i<timeVector.size(); i++) {
						writer.write(timeVector.get(i).toString()+"\n");
					}
					timeVector.removeAllElements();
				}
				writer.flush();
				writer.close();

			} catch(Exception e) {
				e.printStackTrace(System.out);
			}
			//clear output queue
			//XATQueue outputQueue = this.operator.getOutputQueue();
			//outputQueue.dequeue(outputQueue.getQueueSize(), this);
			
			if (stopCondition == numInputQueues) { //drain all streams
				try {
					/*
					BufferedWriter writer = new BufferedWriter(new FileWriter("result_generation_time.txt"));
					Vector timeVector = ((PWJoinOperator)operator).getTimeVector();
					for (int i=0; i<timeVector.size(); i++) {
						writer.write(timeVector.get(i).toString()+"\n");
					}
					writer.flush();
					writer.close(); */
					System.out.println(((PWSingleEquiJoinOperator)operator).getTotalNumResultTuples()+" tuples have been output.");
				} catch(Exception e) {
					e.printStackTrace();
				}
				return;
			}
			/*//write the result tuples in the output queue to a file
			if (stopCondition == numInputQueues) {
				XATQueue outputQueue = this.operator.getOutputQueue();
				try {
					out = new BufferedWriter(new FileWriter("resources/PWJoin/result.txt"));
				} catch (Exception e) {
					e.printStackTrace();
				}
				while (true) {
					try {
						XATTuple t = outputQueue.dequeue(this);
						if (t.isPunctuation()) {
							out.write("Punctuation \n");
							out.flush();
						} else {
							out.write((t.toString()+"\n"));
							out.flush();
						}
					} catch (Exception e) {
						break;
					}
				}
				try {
					out.close();
				} catch(Exception e) {
					e.printStackTrace();
				}
				return;
			}*/
		}
	}
	
}
