/*
 * Created on May 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.operatortester;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TupleReaderImp implements TupleReader {
	public static final char RecordDelimeter1 = '\n';
	public static final char RecordDelimeter2 = '\r';
	public static final String FieldDelimeter = " ";
	public static final int Integer = 1;
	public static final int Long = 2;
	public static final int Float = 3;
	public static final int Double = 4;
	public static final int String = 5;
	
	//time interval between 2 consecutive tuples
	//static final long TIME_INTERVAL = 100;
	
	long timeInterval;
	int maxNumTuplesRead;
	XATQueue queue;
	String streamDataFile;
	int[] dataTypes;
	
	BufferedInputStream in;
	boolean fileEnd = false;
	long currentTimeStamp = 0;
	
	public TupleReaderImp(long timeInterval) {
		this.timeInterval = timeInterval;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#getMaxNumTuplesRead()
	 */
	public int getMaxNumTuplesRead() {
		return maxNumTuplesRead;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#setMaxNumTuplesRead(int)
	 */
	public void setMaxNumTuplesRead(int maxNumTuples) {
		maxNumTuplesRead = maxNumTuples;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#getQueue()
	 */
	public XATQueue getQueue() {
		return queue;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#setQueue(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue)
	 */
	public void setQueue(XATQueue q) {
		queue = q;
		queue.addNewOwner(this);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#getStreamDataFile()
	 */
	public String getStreamDataFile() {
		return streamDataFile;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#setStreamDataFile(java.lang.String)
	 */
	public void setStreamDataFile(String sDataFile) {
		streamDataFile = sDataFile;
		try {
			in = new BufferedInputStream(new FileInputStream(streamDataFile));
		} catch(Exception e) {
			e.printStackTrace(System.out);
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#getDataTypes()
	 */
	public int[] getDataTypes() {
		return dataTypes;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#setDataTypes(java.lang.String[])
	 */
	public void setDataTypes(int[] dTypes) {
		dataTypes = dTypes;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#read()
	 */
	public boolean read() {
		if (fileEnd) {
			return true;
		}
		
		char ch;
		
		int cursor = 0;
		while (cursor < maxNumTuplesRead) {
			String strRecord = "";
			try {
				ch = (char) in.read();
				while(ch != RecordDelimeter1 && ch != RecordDelimeter2) {
					if((int)ch == 65535){
						//The file is ended
						System.out.println("The file " + streamDataFile + " has no more entries. Will start from beginning.");
						in.close();
						//for now repeat the file
						//in = new BufferedInputStream(new FileInputStream(inputFiles[0]));
						//strRecord="";
						fileEnd = true;
						break;
					} else{	
						strRecord = strRecord + ch;
						ch = (char) in.read();
					}
				}
				
				if (strRecord.length() == 0) {
					continue;
				}
				Vector vDataValue = new Vector();
				int index = 0;
				if (strRecord.startsWith("##")) {
					StringTokenizer st = new StringTokenizer(strRecord.substring(2, strRecord.length()), FieldDelimeter);
					Vector vPunctType = new Vector();
					while (st.hasMoreTokens()) {
						String nextToken = st.nextToken();
						if (nextToken.equals("*")) {
							vPunctType.add(new Integer(XATTupleImp.ALL_VALUE));
							vDataValue.add(null);
						} else {
							vPunctType.add(new Integer(XATTupleImp.SINGLE_VALUE));
							vDataValue.add(new XATDataValueImp(new Integer(nextToken)));
						} 
						index ++;
					} 
					int size = vPunctType.size();
					int[] punctTypeArray = new int[size];
					for (int k=0; k<size; k++) {
						punctTypeArray[k] = ((Integer) vPunctType.get(k)).intValue();
					}
					XATDataValue[] dataValueArray = (XATDataValue[]) vDataValue.toArray(new XATDataValueImp[] {});
					XATTuple tuple = new XATTupleImp(dataValueArray);
					tuple.setPunctTypeArray(punctTypeArray);
					tuple.setAsPunctuation(true);
					long[] newtime = new long[1];
					newtime[0] = currentTimeStamp - timeInterval;
					tuple.setTimeStamp(newtime);
//					XATTimeStamp timestamp = new XATTimeStampImp();
//					timestamp.setTimeStamp(currentTimeStamp-timeInterval, 0, 0);
//					//currentTimeStamp += 1000;
//					tuple.setTimeStamp(timestamp);
					queue.enqueue(tuple, this);
				} else {
					StringTokenizer st = new StringTokenizer(strRecord, FieldDelimeter);
					XATDataValue xatValue = null;
					while (st.hasMoreTokens()) {
						if (dataTypes[index] == Integer) {
							xatValue = new XATDataValueImp(new Integer(st.nextToken()));
						} else if (dataTypes[index] == Long) {
							xatValue = new XATDataValueImp(new Long(st.nextToken()));
						} else if (dataTypes[index] == Float) {
							xatValue = new XATDataValueImp(new Float(st.nextToken()));
						} else if (dataTypes[index] == Double) {
							xatValue = new XATDataValueImp(new Double(st.nextToken()));
						} else if (dataTypes[index] == String) {
							xatValue = new XATDataValueImp(st.nextToken());
						} 
						vDataValue.add(xatValue);
						index ++;
					} 
				
					XATDataValue[] dataValueArray = (XATDataValue[]) vDataValue.toArray(new XATDataValueImp[] {});
					XATTuple tuple = new XATTupleImp(dataValueArray);
					long[] newtime = new long[1];
					newtime[0] = currentTimeStamp;
					tuple.setTimeStamp(newtime);
//					XATTimeStamp timestamp = new XATTimeStampImp();
//					timestamp.setTimeStamp(currentTimeStamp, 0, 0);
//					currentTimeStamp += timeInterval;
//					tuple.setTimeStamp(timestamp);
					queue.enqueue(tuple, this);
				}
				cursor ++;
			} catch(Exception e) {
				e.printStackTrace(System.out);
			}
			if (fileEnd) {
				return true;
			}
		}
		return false;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.TupleReader#close()
	 */
	public void close() {
		try {
			in.close();
		} catch(Exception e) {
			e.printStackTrace(System.out);
		}
	}
}
