package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;

/**
 * The FunTOKEN class.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public class FunTOKEN extends FunctionImp {

    /**
    * Execution method.
    * @param deRefParamV are the parameters    
    * @since   1.0      
    */
    public void execute() {
        try {
            XATTable xatOutput =
                (XATTable) this.getPrimaryDataSource().deepCloneDataSource();
            String colName = this.getOutputColumnName();
            Object[] paramV = this.getParams();
            Vector tokV = new Vector();

            Vector colDom =
                xatOutput.getColumn(
                    xatOutput.getColumnPosition(((ColumnName) paramV[0]).getColumnName()));
            Vector col = new Vector();
            //now convert each element to string
            for (int j = 0; j < colDom.size(); j++) {
                // THIS NEEDS FIXING.  XATVAULE WHERE ARE YOU?
                col.add(((XATDataValue) (colDom.elementAt(j))).convertToString());
            }

            String tok = (String) paramV[1];
            int counter = Integer.parseInt(((String) paramV[2]).trim());

            String r1 = null;
            for (int i = 0; i < col.size(); i++) {
                int fcou = counter;
                Object cellItem = col.elementAt(i);
                if (cellItem instanceof Collection) {
                    Vector vCell = (Vector) cellItem;
                    Vector newR = new Vector();
                    for (int j = 0; j < vCell.size(); j++) {
                        StringTokenizer tokenizer =
                            new StringTokenizer((String) vCell.elementAt(j), tok);

                        while (fcou > 0) {
                            if (tokenizer.hasMoreTokens()) {
                                r1 = tokenizer.nextToken();
                            } else {
                                r1 = "";
                            }
                            fcou--;
                        }
                        newR.add(new XATDataValueImp(r1));
                    }
                    tokV.add(newR);
                } else {
                    StringTokenizer tokenizer = new StringTokenizer((String) cellItem, tok);

                    while (fcou > 0) {
                        if (tokenizer.hasMoreTokens()) {
                            r1 = tokenizer.nextToken();
                        } else {
                            r1 = "";
                        }
                        fcou--;
                    }
                    tokV.add(new XATDataValueImp(r1));
                }
            }
            xatOutput.appendColumn(colName, tokV);
            this.setOutput((XATDataSource) xatOutput);
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}