package edu.wpi.cs.dsrg.xmldb.xat.common.operator.state;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;

//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp;

//import streamgenerator.*;
/**
 * Insert the type's description here.
 * Creation date: (2/17/2003 4:38:29 PM)
 * @author: Yali Zhu
 */
public abstract class WOperatorState extends OperatorStateImp {
	//protected boolean isMatched = false; //used by moving-state-migration strategy
	
	protected long timeWindow;
	protected XATQueueSchema stateSchema;
	//protected XATStreamOperator operator;
	protected boolean allOldPurged = false;
	
	public WOperatorState() {
		super();
	}
	
	public WOperatorState(WOperatorState oldstate, XATStreamOperator newop) {
		super(oldstate, newop);
		this.debugFlag = oldstate.debugFlag;
		this.isMatched = false;
		this.stateSchema = oldstate.stateSchema;
		this.timeWindow = oldstate.timeWindow;
	}
/**
 * Insert the method's description here.
 * Creation date: (4/10/2003 9:19:49 AM)
 * @return boolean
 */
public abstract boolean checkAllOldTuplePurged();
/**
 * Insert the method's description here.
 * Creation date: (6/3/2003 2:07:16 AM)
 * @return boolean
 */
public synchronized boolean getAllOldPurgedFlag() {
	return allOldPurged;
}

public abstract XATTuple[] getAllStateTuples();

/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 7:36:13 AM)
 * @return long
 */
public abstract long[] getEarlistTimeStamp();
/**
 * Insert the method's description here.
 *
 * Get tuple with earliest timestamp
 *
 * Creation date: (6/1/2003 7:36:13 AM)
 * @return long
 */
public abstract XATTuple getEarlistTuple();
/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 7:36:35 AM)
 * @return long
 */
public abstract long[] getLatestTimeStamp();
/**
 * Insert the method's description here.
 *
 * Get tuple with latest timestamp
 *
 * Creation date: (6/1/2003 7:36:35 AM)
 * @return long
 */
public abstract XATTuple getLatestTuple();

/**
 * Insert the method's description here.
 * Creation date: (5/28/2003 6:07:56 AM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
 */
public XATStreamOperator getOperator() {
	return operator;
}
/**
 * Insert the method's description here.
 * Creation date: (4/10/2003 9:00:32 AM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema
 */
public XATQueueSchema getSchema() {
	return stateSchema;
}

/**
 * Insert the method's description here.
 * Creation date: (6/23/2003 5:38:12 AM)
 * @return int
 */
//public abstract int getStateTupleCounts();
/**
 * Insert the method's description here.
 * Creation date: (3/15/2003 10:23:33 PM)
 * @return int
 */
public long getTimeWindow() {
	return timeWindow;
}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:22:36 AM)
 */
public abstract void insertTuple(XATTuple newTuple);
public abstract void insertTuple(XATTuple[] newTuple);
/**
 * Insert the method's description here.
 * Creation date: (5/28/2003 6:10:14 AM)
 * @param operator edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
 */
public void setOperator(XATStreamOperator owner) {
    operator = owner;
}
/**
 * Insert the method's description here.
 * Creation date: (4/10/2003 9:00:53 AM)
 * @param schema edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema
 */
public void setSchema(XATQueueSchema schema) {
    //stateQ.setSchema(schema);
    stateSchema = schema;
}
/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 2:54:45 AM)
 * @param newWindow long
 */
public void setTimeWindow(long newWindow) {
    timeWindow = newWindow;
}
/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 2:06:45 AM)
 * @return boolean
 * @param t1 streamgenerator.XATStreamTuple
 * @param t2 streamgenerator.XATStreamTuple
 */
public boolean timeStampExpired(XATTuple newtuple, XATTuple statetuple) {
	/** if tuple1 and tuple2 is out of window size from each other, return false */
	try {
		if (newtuple.getTimeStamp() == null
			|| statetuple.getTimeStamp() == null)
			return true;

		if (newtuple.getMinTimeStamp()
			- statetuple.getMaxTimeStamp()
			> timeWindow)
			return true;
		//if (tuple2.getMaxTS() - tuple1.getMinTS() > timeWindow)
		//    return true;

	} catch (Exception e) {
		e.printStackTrace();
		return false;
	}
	return false;
}

/**
 * Insert the method's description here.
 * Creation date: (6/27/2003 12:37:29 PM)
 * @return java.lang.String
 */
public String toString() {
	return ("State " + stateSchema);
}

public abstract void purgeByTuple(XATTuple newTuple);


//public abstract void probe(XATTuple tuple);
//public abstract void probe(XATTuple tuple, ExpressionStr expression, int statepos);
//public abstract void probe(XATTuple[] tuples);
public abstract XATTuple[] probe(XATTuple[] tuples, ExpressionStr expression, int statepos);
	
}
