/*
 * Created on May 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class StreamGroupbyOperatorImp
	extends StreamAggregateOperatorImp
	implements StreamGroupbyOperator {

	int[] groupAttrPosArray;
	StreamFunction[] aggFunctions;
	
	Hashtable hashtable;
	int hashsize = 20;

	/**
	 * constructor
	 * @param init
	 */
	public StreamGroupbyOperatorImp(XATNode init) {
		super(init);
		hashtable = new Hashtable(hashsize);
	}
	/**
	 * @param value
	 * @return
	 */
	private Object hash(Object value) {
		//right now we assume all attribute values are numeric
		//and groupAttrPosArray only contains one element
		try {

			if (value instanceof Integer) {
				return new Integer(((Integer) value).intValue()%hashsize);
			} else if (value instanceof Long) {
				return new Integer(((Long) value).intValue()%hashsize);
			} else if (value instanceof Double) {
				return new Integer(((Double) value).intValue()%hashsize);
			} else if (value instanceof Float) {
				return new Integer(((Float) value).intValue()%hashsize);
			}
			return null;
		} catch(Exception e) {
			return null;
		}
	}
	
	/**
	 * @param punct
	 */
	private void generateResult(XATTuple punct) {
		int type = punct.getPunctType(groupAttrPosArray[0]);
		if (type == XATTupleImp.SINGLE_VALUE) {
			Object punctValue = punct.getCell(groupAttrPosArray[0]).getValue();
			generateSingleGroup(punctValue);
		} else if (type == XATTupleImp.SET_VALUE) {
			ArrayList punctList = (ArrayList) punct.getCell(groupAttrPosArray[0]);
			for (int i=0; i<punctList.size(); i++) {
				generateSingleGroup(punctList.get(i));
			}
		} else if (type == XATTupleImp.RANGE_VALUE) {
				//to be finished
		} else if (type == XATTupleImp.ALL_VALUE || type == XATTupleImp.NULL_VALUE) {
		}
	}
	
	/**
	 * @param groupVal
	 */
	private void generateSingleGroup(Object groupVal) {
		System.out.println("Generate Single Group!");
		Object key = hash(groupVal);
		Object bucket = hashtable.get(key);
		if (bucket == null) {
			return;
		}
		ArrayList bucketList = (ArrayList) bucket;
		ArrayList currentGroup = new ArrayList();
		int cursor = 0;
		while(cursor < bucketList.size()) {
			XATTuple tuple = (XATTuple)bucketList.get(cursor);
			if (tuple.getCell(groupAttrPosArray[0]).getValue().equals(groupVal)) {
				currentGroup.add(tuple);
				bucketList.remove(cursor);
			} else {
				cursor ++;
			}
		}
		
		XATTuple[] tupleArray = (XATTuple[]) currentGroup.toArray(new XATTuple[] {});
		int length = aggFunctions.length;
		XATDataValue[] resultValue = new XATDataValue[length];
		for (int i=0; i<length; i++) {
			if (i == groupAttrPosArray[0]) {
				if (aggFunctions[i] == null) {
					resultValue[i] = new XATDataValueImp(groupVal);
				} else {
					resultValue[i] = aggFunctions[i].evaluate(tupleArray);
				}
			} else {
				resultValue[i] = aggFunctions[i].evaluate(tupleArray);
			}
		}
		System.out.println("Enqueuing result tuple...");
		this.getOutputQueue().enqueue(new XATTupleImp(resultValue), this);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		XATQueue inputQueue = this.getInputQueue();
		
		if (inputQueue.getSchema() == null) {
			return false;
		}
		
		if (this.getOutputQueue().getSchema() == null) {
			init();
		}

		while (true) {
			try {
				XATTuple tuple = inputQueue.dequeue(this);
				if (tuple.isPunctuation()) {
					generateResult(tuple);
				} else {
					Object groupValue = tuple.getCell(groupAttrPosArray[0]).getValue();
					Object key = hash(groupValue);
					Object bucket = hashtable.get(key);
					if (bucket == null) {
						ArrayList bucketList = new ArrayList();
						bucketList.add(tuple);
						hashtable.put(key, bucketList);
					} else {
						((ArrayList) bucket).add(tuple);
					}
				}
			} catch(Exception e) {
				break;
			}
		}
		return true;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperator#getGroupAttrPos(int)
	 */
	public int getGroupAttrPos(int pos) {
		return this.groupAttrPosArray[pos];
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperator#getGroupAttrPosArray()
	 */
	public int[] getGroupAttrPosArray() {
		return this.groupAttrPosArray;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperator#setGroupAttrPos(int, int)
	 */
	public void setGroupAttrPos(int pos, int gAttrPos) {
		this.groupAttrPosArray[pos] = gAttrPos;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamGroupbyOperator#setGroupAttrPosArray(int[])
	 */
	public void setGroupAttrPosArray(int[] gAttrPosArray) {
		this.groupAttrPosArray = gAttrPosArray;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		return "Groupby";
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#init()
	 */
	public void init() {
		XATQueueSchema outSchema = new XATQueueSchema();
		XATQueueSchema s = this.getInputQueue().getSchema();
		String schemaName = s.getName();
		
		Iterator iter = s.getColNames().iterator();
		while(iter.hasNext()){
			outSchema.addColumn((String) iter.next());
		}
		
		for (int i=0; i<aggFunctions.length; i++) {
			outSchema.addColumn(aggFunctions[i].getOutputAttrName());
		}

		outSchema.setName(schemaName);
		this.getOutputQueue().setSchema(outSchema);
	}
}
