/*
 * Created on 2004-3-25
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import java.util.Vector;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class StreamProjectOperatorImp
	extends XATSingleQueueStreamOperatorImp
	implements StreamProjectOperator {

	String[] retainAttrNames; //assumes no name conflict
	//	retainAttrPos[0] is the index of the input queue schema that matches the first column of the output queue schema. 
	//  int[] retainAttrPos;  

	/**
	 * constructor
	 * @param init
	 */
	public StreamProjectOperatorImp(XATNode init) {
		super(init);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamProjectOperator#getAttrNames()
	 */
	public String[] getRetainAttrNames() {
		return retainAttrNames;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamProjectOperator#setAttrName(int, java.lang.String)
	 */
	public void setRetainAttrName(int pos, String newName) {
		retainAttrNames[pos] = newName;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.StreamProjectOperator#setAttrNames(java.lang.String[])
	 */
	public void setRetainAttrNames(String[] attrs) {
		retainAttrNames = attrs;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		/**
		 * first figure out how many tuples to dequeue, the selectivity, and 
		 * result delay  
		 */
		if (this.getInputQueue().getSchema() == null){
				return false;
		}
		
		if(this.getOutputQueue().getSchema() == null){
			init();
		}
		
		//int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		int howMany = 100;

		/** get the tuples */

		XATTuple[] tuples = this.getInputQueue().dequeue(howMany, this);
		/** figure out how many tuples to keep*/

		for (int i=0; i<tuples.length; i++) {
			XATTuple tuple = tuples[i];
			XATTuple newTuple = new XATTupleImp(retainAttrNames.length);
			for (int j=0; j<retainAttrNames.length; j++) {
//				newTuple.setCell(j, tuple.getCell(attrNames[j]));
//				newTuple.setCell(j, tuple.getCell(retainAttrPos[j]));
				newTuple.setCell(j, tuple.getCell(outputPositions[0][j]));
			}
			newTuple.setTimeStamp(tuple.getTimeStamp());
			newTuple.setMinTimeStamp(tuple.getMinTimeStamp());
			newTuple.setMaxTimeStamp(tuple.getMaxTimeStamp());
			newTuple.setAsPunctuation(tuple.isPunctuation());
			
			this.getOutputQueue().enqueue(newTuple, this);
		}

		return true;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#init()
	 */
	public void init() {
		
		XATQueueSchema s;
		XATQueueSchema outSchema = new XATQueueSchema();

		s = this.getInputQueue().getSchema();
		Vector inColName = s.getColNames();
//		for (int i=0; i<projAttrPos.length; i++) {
//			outSchema.addColumn((String) inColName.get(projAttrPos[i]));
//		}

		int[] retainAttrPos = new int[retainAttrNames.length];
		for (int i=0; i<retainAttrNames.length; i++) {
			outSchema.addColumn(retainAttrNames[i]);
			retainAttrPos[i] = inColName.indexOf(retainAttrNames[i]);
		}

		outSchema.setName(s.getName());
		this.getOutputQueue().setSchema(outSchema);
		outputPositions = new int[1][];
		outputPositions[0] = retainAttrPos;
		
		//this.getOutputQueue().setSchema(this.getInputQueue().getSchema());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return "Project";
	}
	
	/**
	 * The method cleanAccumulatedTuples() is similar to the method run(),
	 * except the way of figuring out how many tuples to dequeue from input queues.
	 * Inside method run() the numbers are computed based on the property
	 * "NUMBER_OF_TUPLES_TO_DEQUEUE" set by the system scheduler,
	 * while in cleanAccumulatedTuples, all tuples in input queues that have their max timesamp
	 * smaller than the given maxtimestamp should be dequened.
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		return true;
	}

	/*
	 * process all accumulated tuples in this operators' input queues.
	 */
	public boolean cleanAllAccumulatedTuples() {
		return true;
	}
	
	/*
	 * check if this operator has any unmatched states.
	 * return: TRUE if this operator has unmatched states, FALSE otherwise.
	 */
	public boolean hasUnmatchedState() {
		return false;
	}

	public boolean matchStates(XATStreamOperator op) {
		return false;
	}
	
	public boolean recomputeUnmatchedState() {
		return true;
	}
	
	public int setStateID(int nextid) {
		return nextid;
	}


}
