package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
/**
 * Insert the type's description here.
 * Creation date: (1/6/2003 3:07:43 PM)
 * @author: Brad Pielech
 */
public abstract class XATSingleQueueStreamOperatorImp extends XATStreamOperatorImp implements XATSingleQueueStreamOperator {
/**
 * The input queue of an operator is a pointer to the output queue
 * of the <emph>left</emph> child.  When an operator only has 1 child, this
 * points to the queue of its only child, but it is important to note this has the
 * implied semantic that it points to the left one.
 * @return XATQueue the queue that serves as input to this operator
 */

public XATSingleQueueStreamOperatorImp(XATNode init) {
	super(init);
}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 1:52:30 PM)
 * @return int[]
 */
public XATTuple projectToDesiredOutput(XATTuple input) {
	
    int[] colPos = getOutputPositions(0);

    XATDataValue[] resultData = new XATDataValue[colPos.length];

    ((XATTupleImp)input).fillDataInListTo(resultData, colPos, 0);

    XATTuple newTuple = new XATTupleImp(resultData);

    return newTuple;
}
/**
 * Runs the actual operator.
 *
 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
 * because the StreamOperators represent physical operators instead of Logic.
 * Creation date: (1/22/03 4:18:24 PM)
 */
abstract public boolean run() throws java.lang.Exception;
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getStateSize()
	 */
	public int getStateSize() {
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#init()
	 */
	public void init() {
		this.getOutputQueue().setSchema(this.getInputQueue().getSchema());
		computeOutputPositions();
	}
	
	public void cleanTemp(){
		getOutputQueue().removeAllTuples();
	}

}
