package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode;

/**for automata inside operators
 * Creation date: (1/15/2003 7:24:03 PM)
 * @author: Hong Su
 */

import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;

public interface AutomataEnabled {
	//if there is only one output queue, its key in the hashtable is -1	
	int UNIQUE_OUTPUT_QUEUE = -1;

	/**
	 * since the operator relies on information associated with ertain state(s) in automata
	 * associate the operator with these states
	 * E.g., a extractNest relies on two states: one for the target (to wrap the subtuple), one for source (to group the subtuples and wrap them to a tuple)
	 * @param auto edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.ExtendedAutomata
	 */
	void associateWithAuto(ExtendedAutomata auto);

	/**
	 * whether the operator can be triggered by a partition-end event
	 * @return boolean
	 */
	boolean isPartitionInvoked();
	
	List runGroupBy();

	void runPushStack(int tokenId, int startTokenId);

	void runPopStack(int tokenId, int startTokenId);
}
