package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode;

import java.util.List;

/*
 * Mode means how invocation of this operator may invoke other operators, i.e., from the run method
 * of this operator, run methods of what other operators are called
 
 * DemandDrivenMode: if an operator implements this interface, when it runs, its child operator(s) is(are)
 * invoked to generates some outputs for it to consume,
 * i.e., the control flow is from parent operator to child operator 
 * refer to the classical "iterator model"
 *
 */
public interface DemandDrivenInvoking {
	/**
	 * operator implementing this interface needs to call its child operator(s) in order to generate any outputs
	  
	 * Creation date: (4/1/2003 9:44:02 PM)
	 */
	List[] demandDrivenInvokingRun();
	
	//in what order the children of this operator should be evaluated
	List getBranchEvalOrder();
	
	void setBranchEvalOrder(List branchEvalOrder);
	
	//the children are evaluated in the specified order
	List[] demandDrivenInvokingRunWithOrder();
}
