/*
 * Created on 2005-7-14
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;

import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.XATKeyDataValueForRecursion;

/**
 * @author Mingzhu Wei
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CartesianStreamForRecursion extends CartesianStream {

	/**
	 * @param node
	 */
	public CartesianStreamForRecursion(DagNode node) {
		super(node);
		// TODO Auto-generated constructor stub
	}
	/**
	 * join the tuples
	 * @param tuples List[] inputs
	 * @param List outputs
	 */
	public List join(List[] tuples) {

		int[][] temp = getOutputPositions();
		List outputTuples = new ArrayList();

		int srcNum = tuples.length;

		
		
		int tupleLength = getTupleLength();

		int[] cursors = new int[srcNum];

		int[] inputsInResults = getUsefulInputSrc();
		int inputsInResultsLength = inputsInResults.length;
		
		int joinOnCol = locateJoinOn();

		while (true) {

			XATDataValue[] newData = new XATDataValue[tupleLength];
			int startPos = 0;

			for (int j = 0; j < inputsInResultsLength; j++) {
				int inputSrc = inputsInResults[j];
				//there is something in source j that needs to be filled
				/*
				( (XATTupleImp) tuples[inputSrc].get(
						cursors[inputSrc]) ).fillDataInListTo(
					newData,
					temp[inputSrc],
					startPos);*/
				// the cursor point to the elemnt in the current input 
				int curCursor = cursors[inputSrc];
				List curList = tuples[inputSrc];
				// get the current tuple in the input queue(curList)
				XATTupleImp curTuple = (XATTupleImp)curList.get(curCursor); 
				curTuple.fillDataInListTo(
						newData,
						temp[inputSrc],
						startPos);

				startPos = startPos + temp[inputSrc].length;
			}
			
//			for (int j = 0; j < inputsInResultsLength; j++){
//				int inputSrc = inputsInResults[j];
//				
//			}
			
			if ( isIdValid(newData, locateJoinOn() ) )
				outputTuples.add(new XATTupleImp(newData));

			//adjust the cursor 
			for (int k = srcNum - 1; k >= 0; k--) {
				cursors[k]++;
				if (cursors[k] == tuples[k].size()) {
					if (k == 0)
						//all inputs has been consumed
						return outputTuples;
					else
						cursors[k] = 0;
				} else
					//cursor has been set up correctly at this point
					break;

			}

		} //end of while true

		
	}
	
	/*
	 * 
	 * @author Mingzhu Wei
	 *
	 * return the column No in newData where the join operation is on
	 */
	int locateJoinOn()
	{
		return 0;
	}
	
	boolean isIdValid(XATDataValue[] newData, int joinOnCol)
	{
		boolean valid = true;
		int joinOnColStartTokenId = 
			((XATKeyDataValueForRecursion)newData[joinOnCol]).getStartTokenId();
		int joinOnColEndTokenId =
			((XATKeyDataValueForRecursion)newData[joinOnCol]).getEndTokenId();
		
		for (int i=0; i<newData.length; i++)
		{
			if ( i != joinOnCol)
			{
				int curColStartId =
					((XATKeyDataValueForRecursion)newData[i]).getStartTokenId();
				int curColEndId =
					((XATKeyDataValueForRecursion)newData[i]).getEndTokenId();
				if ( (curColStartId<joinOnColStartTokenId)
					|| (curColEndId>joinOnColEndTokenId) )
				{
					valid = false;
					break;
				}
			}
		}
		
		return valid;
	}
	
	/**
	 * given a holder, fill it from position begin 
	 * the filling content is part of the "data field" specified by list
	 * Creation date: (2/9/2003 11:47:11 AM)
	 * @param list java.util.Vector
	 */
	/*
	public void fillDataInListTo(
		XATDataValue[] holder,
		int[] list,
		int begin) {

		int length = list.length;
		for (int i = 0; i < length; i++) {
			holder[begin + i] = getCell(list[i]);
		}

	}
	*/
}
