package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSubTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSubTupleQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.*;

import java.util.*;

/**
 * Insert the type's description here.
 * Creation date: (1/13/2003 4:57:52 PM)
 * @author: Hong Su
 */
abstract public class CollSelectStreamImp
	extends SelectStreamImp
	implements CollSelectStream {
	protected boolean holderIncludesBegin = true;
	protected boolean holderPassed = false;
	protected XATSubTuple subTupleHolder;
	protected boolean shortCircuit;
	//key is the column 
	//object is the source that generates the column, must be an extract	
	protected java.util.Hashtable shortCircuitMgr;
	protected java.util.ArrayList shortCircuitedOps = new ArrayList();
	protected AutomataEnabledImp automataCommon;

	protected int quickRes = -1;
	protected ExtendedState opState;
	/**
	 * CollectionSelectImp constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public CollSelectStreamImp(
		edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode node,
		ExpressionStr expression) {
		super(node, expression);
		//subTupleExpression = (ExpressionStr)expression.clone();
		holderIncludesBegin = true;
		//subTupleHolder = new XATTupleImp();
		shortCircuit = false;
		automataCommon = new AutomataEnabledImp(this);
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 1:53:42 PM)
	 * @param auto edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.ExtendedAutomata
	 */
	public void associateWithAuto(ExtendedAutomata auto) {

		/*if (isPartitionInvoked() && getProperty("DATA_DRIVEN_INVOKING")
		.equals("0")) {
			//only when group by information is needed

			String colName =
				(String) getExpression().getTerminalColumnNames().get(0);

			DagNode extractNode =
				FindOpVisitor.findColGeneratingSource(this, colName);

			try {
				PureNavigateAutoStream navOp =
					((ExtractByCollectionStream) extractNode.getOperator())
						.getCollectionByNavOp();

				List states = auto.getFrStateHash(navOp);

				for (Iterator it = states.iterator(); it.hasNext();) {
					ExtendedState state = (ExtendedState) it.next();
					state.addGroupbyOp(this);
					opState = state;
				}
			} catch (Exception e) {
				e.printStackTrace();
				System.exit(-1);
			}

		}*/

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/30/2003 1:31:35 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState
	 */
	public edu
		.wpi
		.cs
		.dsrg
		.xmldb
		.xat
		.component
		.automata
		.automata
		.ExtendedState getOpState() {
		return opState;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/24/2003 11:34:15 AM)
	 * @return int
	 */
	public int getQuickRes() {
		if (quickRes == -1)
			//not set yet
			if (getProperty("QUICK_RESPONSE").equals("0"))
				quickRes = 0;
			else
				quickRes = 1;

		return quickRes;
	}
	/**
	 * given the column name, find related ops that can be shortcircuited
	 * colName must be one in an existential format 
	 * Creation date: (2/20/2003 6:58:03 PM)
	 * @return java.util.List
	 */
	public List getShortCircuitedOps(String colName) {

		List ops = (List) shortCircuitMgr.get(colName);

		if (ops == null) {
			ArrayList shortcircuitedOps = new ArrayList();

			//FindOpVisitor visitor = new FindOpVisitor();
			XATStreamOperator foundOp =
				(XATStreamOperator) FindOpVisitor
					.findColGeneratingSource(this, colName)
					.getOperator();
			shortcircuitedOps.add(foundOp);

			//find whether the navigate is shortcircuitable or not
			//if it has no other parent rather than the shortcircuitable extract
			DagNode navNode = null;
			try {
				navNode = (DagNode) foundOp.getNode().getChild(0);
			} catch (Exception e) {
				e.printStackTrace();
			}

			if (navNode.getParentsSize() == 1)
				shortcircuitedOps.add(navNode.getOperator());

			shortCircuitMgr.put(colName, shortcircuitedOps);
			return shortcircuitedOps;
		} else
			return ops;
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 9:49:18 PM)
	 * @return java.util.List
	 */
	public java.util.List getTuplesToApplyPredicate() {

		XATQueue inQueue = getInputQueue();

		List targetTups = new LinkedList();

		int howMany =
			Integer.parseInt(getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));

		if (!(inQueue instanceof XATSubTupleQueue))
			targetTups = inQueue.dequeueN(howMany, this);
		else
			targetTups = ((XATSubTupleQueue) inQueue).dequeueN(howMany, this);

		return targetTups;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 9:49:18 PM)
	 * @return java.util.List
	 */
	public java.util.List getTuplesToApplyPredicateBak() {
		XATQueue inQueue = getInputQueue();

		List targetTups = new LinkedList();

		//dequeue input queue to get target tuples to apply selction predicates on
		if (dequeueStrategy == DEQUEUE_ONE) {
			//dequeu one tuple at a time
			if (!(inQueue instanceof XATSubTupleQueue)) {
				//the input queue does not support subtuple
				targetTups.add(inQueue.dequeue(this));
			} else {
				//the queue support subtuple
				targetTups.add(((XATSubTupleQueue) inQueue).dequeue(this));
			}
		} else if (dequeueStrategy == DEQUEUE_AVAILABLE) {
			if (!(inQueue instanceof XATSubTupleQueue)) {
				//the input queue does not support subtuple
				targetTups = inQueue.dequeueN(inQueue.getQueueSize(this), this);
			} else {
				//the queue support subtuple
				targetTups.addAll(
					inQueue.dequeueN(inQueue.getQueueSize(this), this));
			}
		}

		return targetTups;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/26/2003 7:54:48 PM)
	 * @return boolean
	 */
	public boolean isHolderPassed() {
		return holderPassed;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/11/2003 2:43:31 PM)
	 * @return boolean
	 */
	public boolean isPartitionInvoked() {
		return automataCommon.isPartitionInvoked();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/20/2003 10:06:57 PM)
	 */
	public void resumeRegularComp() {

		//if (!(shortCircuitedOps == null)){

		if (!(shortCircuitedOps.size() == 0)) {
			//there are ops short circuited
			for (int i = 0; i < shortCircuitedOps.size(); i++) {

				ExtractStream extractOp =
					(ExtractStream) shortCircuitedOps.get(i);

				//ExtendedAutomata auto = extractOp.getAutomata();

				//ExtendedState state = auto.getFrStateHash((XATStreamOperator)extractOp);
				ExtendedState state = extractOp.getOpState();

				state.resumeExtractOp();

			}

			shortCircuitedOps.clear();
		}
		//	}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (2/19/2003 10:12:36 PM)
	 * @param newShortCircuit boolean
	 */
	public void setShortCircuit(boolean newShortCircuit) {
		shortCircuit = newShortCircuit;
		//initialize the shortCicruite manager as well
		shortCircuitMgr = new Hashtable();
	}

	
	/**
	 * Insert the method's description here.
	 * Creation date: (2/20/2003 7:34:03 PM)
	 * @param relatedOps java.util.ArrayList
	 */
	public void shortCircuitOp(XATStreamOperator op) {

		//	if (!(op instanceof ExtractStream)){
		//		System.out.println("Impossible: an short circuit source operator is not an extract operator");		
		//	}
		//	else{

		if (op instanceof ExtractStream) {
			ExtractStream extractOp = (ExtractStream) op;

			//ExtendedAutomata auto = extractOp.getAutomata();

			//ExtendedState state = auto.getFrStateHash(op);
			ExtendedState state = extractOp.getOpState();

			state.suspendExtractOp();

			/*if (shortCircuitedOps == null){
				shortCircuitedOps = new ArrayList();
				shortCircuitedOps.add(op);
			}
			else{
				shortCircuitedOps.add(op);
			}*/
		} else if (op instanceof PureNavigateAutoStream) {
			PureNavigateAutoStream navOp = (PureNavigateAutoStream) op;
			ExtendedState state = navOp.getOpState();
			state.suspendNavOp(navOp);
		}

		shortCircuitedOps.add(op);

		//	}

	}
}
