package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import java.util.List;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSubTuple;
/**
 * Insert the type's description here.
 * Creation date: (1/13/2003 4:59:28 PM)
 * @author: Hong Su
 */
public class CollSimpleSelStream extends CollSelectStreamImp {
	/**
	 * CollectionSimpleSelImp constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public CollSimpleSelStream(XATNode node, ExpressionStr expression) {
		super(node, expression);
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/11/2003 2:43:16 PM)
	 * @return boolean
	 */
	public boolean isPartitionInvoking() {
		return false;
	}
	/*
	 * a naive approach (1) no existential format (2) no short-circuit computing based on subtuple evaluation results so far
	 * Creation date: (2/19/2003 5:06:12 PM)
	 */
	public List nonShortCircuitComp() {
		List result = new LinkedList();

		XATQueue outQueue = getOutputQueue();

		List targetTups = getTuplesToApplyPredicate();

		//apply selection predicates on target tuples    
		for (int i = 0; i < targetTups.size(); i++) {

			//List toCompareTuples = new LinkedList();
			XATTuple currentTup = (XATTuple) (targetTups.get(i));
			//toCompareTuples.add(currentTup);

			if (!(holderPassed)) {
				//only check when past subtuples do not qualify

				//toCompreTuples is just for matching the signature of the expression, there can only one tuple in it
				List toCompareTuples = new LinkedList();
				toCompareTuples.add(currentTup);

				//apply expressions that have not satisfied by previous subtuples

				Object subEvalResults =
					expression.getUntrueExpression().eval(
						toCompareTuples,
						this);

				if (!(expression.getUntrueExpression() == null)) {
					//expression is not completely satisfied
					expression.setUntrueExpression(
						expression.getUntrueExpression().getUntrueExpression());
				}

				if ((subEvalResults != null)
					&& (subEvalResults instanceof Boolean)) {
					holderPassed = ((Boolean) subEvalResults).booleanValue();
				}
			}

			//put the current tuple to the subtuple workspace
			subTupleHolder.union(
				new XATSubTuple(projectToDesiredOutput(currentTup)));

			if (holderPassed) {

				if (getProperty("OUTPUT_TUPLE_GRANULARITY")
					.equals(SUB_TUPLE)) {
					if (holderIncludesBegin) {
						//the holder itself holds the beginning of the tuple
						//enqueue it like a regular tuple
						//getOutputQueue().enqueue(subTupleHolder, this);
						result.add(subTupleHolder);
						//dataDrivenChainRun();
						holderIncludesBegin = false;
					} else {
						//need to enqueue it using special method 
						//((XATSubTupleQueue) getOutputQueue()).enqueueSubTuple(subTupleHolder, this);
						result.add(subTupleHolder);
						//dataDrivenChainRun();
					}

					//subtuples have been output, clear the holder
					subTupleHolder = new XATSubTuple();
				}
			}
		}

		return result;
	}
	/*
	 * a naive approach (1) no existential format (2) no short-circuit computing based on subtuple evaluation results so far
	 * Creation date: (2/19/2003 5:06:12 PM)
	 */
	public List nonShortCircuitComp(List inputTuples) {

		List result = new LinkedList();

		if (inputTuples == null) {
			int howMany =
				Integer.parseInt(
					this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
			inputTuples = getInputQueue().dequeueN(howMany, this);
		}

		// XATQueue outQueue = getOutputQueue();

		// List targetTups = getTuplesToApplyPredicate();

		if (!holderPassed || getQuickRes() == 1) {

			//apply selection predicates on target tuples
			int inputSize = inputTuples.size();
			for (int i = 0; i < inputSize; i++) {
				//toCompreTuples is just for matching the signature of the expression, there can only one tuple in it

				XATTuple currentTup = (XATTuple) (inputTuples.get(i));

				//Vector unsatisfiedColsBefore = expression.getUntrueTerminalColumnNames();

				//Vector newlySatisfiedCols = new Vector();

				if (!(holderPassed)) {
					//only check when past subtuples do not qualify

					List toCompareTuples = new LinkedList();
					toCompareTuples.add(currentTup);

					Object subEvalResults =
						expression.eval(toCompareTuples, this);

					if ((subEvalResults != null)
						&& (subEvalResults instanceof Boolean)) {
						holderPassed =
							((Boolean) subEvalResults).booleanValue();

						if (holderPassed) {
							//this new tuple satisfies
							//revisit here,
							/* Vector existentialCols = getExpression().getTerminalColumnNames();
							 //all the operators propagating the existential format columns can be shortcircuited
							 for (int j = 0; j < existentialCols.size(); j++) {
							     String colName = (String) existentialCols.get(j);
							
							     //XATStreamOperator shortCircuitSourceOp = getShortCircuitedOp(colName);
							     List shortcircuitableOps = getShortCircuitedOps(colName);
							
							     for (Iterator k = shortcircuitableOps.iterator(); k.hasNext(); )
							        shortCircuitOp((XATStreamOperator)k.next());
							
							 }*/

							if (getQuickRes() == 0) {
								result.add(currentTup);
								return result;
							}
						}
					}
				} //end of if (!(holderPassed))

				//put the current tuple to the subtuple workspace
				//subTupleHolder.union(projectToDesiredOutput(currentTup, unsatisfiedColsBefore));
				if (getQuickRes() == 1) {
					//only if the quick reponse feature turned on then the subtuple holder is needed
					//otherwise the shortcircuit only cares about whether the large tuple makes the predicates
					//rather than its content
					//subTupleHolder.union(projectToDesiredOutput(currentTup, newlySatisfiedCols));
					subTupleHolder.union(
						new XATSubTuple(projectToDesiredOutput(currentTup)));

					if (holderPassed) {

						if (getProperty("OUTPUT_TUPLE_GRANULARITY")
							.equals(SUB_TUPLE)) {
							if (holderIncludesBegin) {
								//the holder itself holds the beginning of the tuple
								//enqueue it like a regular tuple
								//outQueue.enqueue(subTupleHolder, this);
								result.add(subTupleHolder);
								holderIncludesBegin = false;
								// dataDrivenChainRun();
							} else {
								//need to enqueue it using special method 
								//((XATSubTupleQueue) outQueue).enqueueSubTuple(subTupleHolder, this);
								result.add(subTupleHolder);
								// dataDrivenChainRun();
							}

							//subtuples have been output, clear the holder
							subTupleHolder = new XATSubTuple();
						}
					}
				} //end of if (getProperty("QUICK_RESPONSE").equals("1"))

			}
		}
		return result;
	}
	/*
	 * a naive approach (1) no existential format (2) no short-circuit computing based on subtuple evaluation results so far
	 * Creation date: (2/19/2003 5:06:12 PM)
	 */
	public List nonShortCircuitCompbak(List inputTuples) {
		List result = new LinkedList();

		if (inputTuples == null) {
			int howMany =
				Integer.parseInt(
					this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
			inputTuples = getInputQueue().dequeueN(howMany, this);
		}

		XATQueue outQueue = getOutputQueue();

		List targetTups = getTuplesToApplyPredicate();

		//apply selection predicates on target tuples    
		for (int i = 0; i < targetTups.size(); i++) {

			//List toCompareTuples = new LinkedList();
			XATTuple currentTup = (XATTuple) (targetTups.get(i));
			//toCompareTuples.add(currentTup);

			if (!(holderPassed)) {
				//only check when past subtuples do not qualify

				//toCompreTuples is just for matching the signature of the expression, there can only one tuple in it
				List toCompareTuples = new LinkedList();
				toCompareTuples.add(currentTup);

				//apply expressions that have not satisfied by previous subtuples

				Object subEvalResults =
					expression.getUntrueExpression().eval(
						toCompareTuples,
						this);

				if (!(expression.getUntrueExpression() == null)) {
					//expression is not completely satisfied
					expression.setUntrueExpression(
						expression.getUntrueExpression().getUntrueExpression());
				}

				if ((subEvalResults != null)
					&& (subEvalResults instanceof Boolean)) {
					holderPassed = ((Boolean) subEvalResults).booleanValue();
				}
			}

			//put the current tuple to the subtuple workspace
			subTupleHolder.union(
				new XATSubTuple(projectToDesiredOutput(currentTup)));

			if (holderPassed) {

				if (getProperty("OUTPUT_TUPLE_GRANULARITY")
					.equals(SUB_TUPLE)) {
					if (holderIncludesBegin) {
						//the holder itself holds the beginning of the tuple
						//enqueue it like a regular tuple
						//getOutputQueue().enqueue(subTupleHolder, this);
						result.add(subTupleHolder);
						//dataDrivenChainRun();
						holderIncludesBegin = false;
					} else {
						//need to enqueue it using special method 
						//((XATSubTupleQueue) getOutputQueue()).enqueueSubTuple(subTupleHolder, this);
						result.add(subTupleHolder);
						//dataDrivenChainRun();
					}

					//subtuples have been output, clear the holder
					subTupleHolder = new XATSubTuple();
				}
			}
		}

		return result;
	}
	/**
	 * always dequeue one tuple (a tuple or subtuples in a tuple)
	 * no control of how many subtuples to dequeue from a tuple
	 * revisit later: allow dequeuing specified n tuples
	 */
	public List run(List inputTuples, int inputPos) {

		//timeKeeper.start();

		List result = new ArrayList();
		
		//apply selection predicates on target tuples     
		for (int i = 0; i < inputTuples.size(); i++) {
			//toCompreTuples is just for matching the signature of the expression, there can only one tuple in it
			List toCompareTuples = new ArrayList();
			XATTuple currentTup =
				(XATTuple) (inputTuples.get(i));
			toCompareTuples.add(currentTup);
			Object evalResults =
				getExpression().eval(toCompareTuples, this);

			boolean passed =
					((Boolean) evalResults).booleanValue();

				if (passed)
					result.add(currentTup);
				else{
					int j=0;
				}
				

				//there is no subtuple holder to be cleared

			}
		

	/*	switch (getTriggeringEvent().getStackAction()) {
			case TriggeringEvent.GROUPBY_END :
				{
					//the expression is untrue again
					// getExpression().setUntrueExpression(getExpression());

					DagNode childNode = null;

					try {
						childNode = (DagNode) getNode().getChild(0);
					} catch (Exception e) {
						e.printStackTrace();
					}

					//if (inQueue instanceof XATSubTupleQueue) {
					if (childNode
						.getOperator()
						.getProperty("OUTPUT_TUPLE_GRANULARITY")
						.equals(SUB_TUPLE)) {
						//input is all subtuple, must be
						// if (getProperty("QUICK_RESPONSE").equals("1")) 
						if (getQuickRes() == 1) {
							//subTupleHolder only makes sense for quick response which cares for intact values
							if ((!(getProperty("OUTPUT_TUPLE_GRANULARITY")
								.equals(SUB_TUPLE)))
								&& (holderPassed))

								//output the tuple in the subtupleholder workspace
								//must be subtuples waiting to be output in tuple granularity
								result.add(subTupleHolder);

							holderPassed = false;
							holderIncludesBegin = true;
							subTupleHolder = new XATSubTuple();
						} else //quick_response is turned off
							holderPassed = false;

					} else {
						//input is tuple, only sent when groupby_end is triggered
						//when the current tuple is a tuple
						if (inputTuples == null)
							//need to fetch from the input queue
							inputTuples = getTuplesToApplyPredicate();

						//apply selection predicates on target tuples    
						for (int i = 0; i < inputTuples.size(); i++) {
							//toCompreTuples is just for matching the signature of the expression, there can only one tuple in it
							List toCompareTuples = new LinkedList();
							XATTuple currentTup =
								(XATTuple) (inputTuples.get(i));
							toCompareTuples.add(currentTup);
							// Object evalResults =
							//   ((ExpressionStr) getExpression().getUntrueExpression()).eval(
							//       toCompareTuples,
							//       this);
							Object evalResults =
								getExpression().eval(toCompareTuples, this);

							if ((evalResults != null)
								&& (evalResults instanceof Boolean)) {
								boolean passed =
									((Boolean) evalResults).booleanValue();

								if (passed)
									result.add(currentTup);

								//there is no subtuple holder to be cleared

							}
						}

						// System.out.println("impossible: group-by event sent to collectionsimplesel with an input queue of full tuple");
					}

					if (shortCircuit)
						resumeRegularComp();

					break;
				}

			case TriggeringEvent.NO_THING :
				{ //only possible when subtuples are sent to be processed
					if (shortCircuit)
						result = shortCircuitComp(inputTuples);
					else
						result = nonShortCircuitComp(inputTuples);

				}
		}*/

		//timeKeeper.pause();
		return result;

	}
	
	/**
	 * revisit: existentialCols can shrink 
	 * Creation date: (2/19/2003 5:06:12 PM)
	 */
	public List shortCircuitComp(List inputTuples) {

		List result = new LinkedList();

		if (inputTuples == null) {
			int howMany =
				Integer.parseInt(
					this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
			inputTuples = getInputQueue().dequeueN(howMany, this);
		}

		// XATQueue outQueue = getOutputQueue();

		// List targetTups = getTuplesToApplyPredicate();

		if (!holderPassed || getQuickRes() == 1) {

			//apply selection predicates on target tuples
			int inputSize = inputTuples.size();
			for (int i = 0; i < inputSize; i++) {
				//toCompreTuples is just for matching the signature of the expression, there can only one tuple in it

				XATTuple currentTup = (XATTuple) (inputTuples.get(i));

				//Vector unsatisfiedColsBefore = expression.getUntrueTerminalColumnNames();

				//Vector newlySatisfiedCols = new Vector();

				if (!(holderPassed)) {
					//only check when past subtuples do not qualify

					List toCompareTuples = new LinkedList();
					toCompareTuples.add(currentTup);

					Object subEvalResults =
						expression.eval(toCompareTuples, this);

					if ((subEvalResults != null)
						&& (subEvalResults instanceof Boolean)) {
						holderPassed =
							((Boolean) subEvalResults).booleanValue();

						if (holderPassed) {
							//this new tuple satisfies
							//revisit here,
							Vector existentialCols =
								getExpression().getTerminalColumnNames();
							//all the operators propagating the existential format columns can be shortcircuited
							for (int j = 0; j < existentialCols.size(); j++) {
								String colName =
									(String) existentialCols.get(j);

								//XATStreamOperator shortCircuitSourceOp = getShortCircuitedOp(colName);
								List shortcircuitableOps =
									getShortCircuitedOps(colName);

								for (Iterator k =
									shortcircuitableOps.iterator();
									k.hasNext();
									)
									shortCircuitOp(
										(XATStreamOperator) k.next());

							}

							if (getQuickRes() == 0) {
								result.add(currentTup);
								return result;
							}
						}
					}
				} //end of if (!(holderPassed))

				//put the current tuple to the subtuple workspace
				//subTupleHolder.union(projectToDesiredOutput(currentTup, unsatisfiedColsBefore));
				if (getQuickRes() == 1) {
					//only if the quick reponse feature turned on then the subtuple holder is needed
					//otherwise the shortcircuit only cares about whether the large tuple makes the predicates
					//rather than its content
					//subTupleHolder.union(projectToDesiredOutput(currentTup, newlySatisfiedCols));
					subTupleHolder.union(
						new XATSubTuple(projectToDesiredOutput(currentTup)));

					if (holderPassed) {

						if (getProperty("OUTPUT_TUPLE_GRANULARITY")
							.equals(SUB_TUPLE)) {
							if (holderIncludesBegin) {
								//the holder itself holds the beginning of the tuple
								//enqueue it like a regular tuple
								//outQueue.enqueue(subTupleHolder, this);
								result.add(subTupleHolder);
								holderIncludesBegin = false;
								// dataDrivenChainRun();
							} else {
								//need to enqueue it using special method 
								//((XATSubTupleQueue) outQueue).enqueueSubTuple(subTupleHolder, this);
								result.add(subTupleHolder);
								// dataDrivenChainRun();
							}

							//subtuples have been output, clear the holder
							subTupleHolder = new XATSubTuple();
						}
					}
				} //end of if (getProperty("QUICK_RESPONSE").equals("1"))

			}
		}
		return result;
	}

	public void cleanTemp() {
		//clean those intermeditate results that haven't sent to outputqueue yet
		((XATQueueImp)outputQueue.get(0)).dequeueAll();

	}
}
