package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;

import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSubTupleQueue;
/**
 * Insert the type's description here.
 * Creation date: (1/13/2003 4:57:23 PM)
 * @author: Hong Su
 */
public class FlatSelectStreamImp extends SelectStreamImp implements FlatSelectStream {
/**
 * Insert the method's description here.
 * Creation date: (2/1/2003 9:02:15 PM)
 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 * @param expressin edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
public FlatSelectStreamImp(XATNode node, ExpressionStr expression) {
	super(node, expression);
	
	}
/**
 * Insert the method's description here.
 * Creation date: (2/2/2003 5:36:28 PM)
 */
public void dataDrivenChainRun() {
	for (Iterator i = ((DagNode)getNode()).getParents(); i.hasNext();){
   
        try {
            XATStreamOperator op = (XATStreamOperator) ((DagNode)i.next()).getOperator();

            if (!(op instanceof XATMultiQueueStreamOperator)) {
                //a unary operator, revisit for Tagger
              /*  if (op instanceof AutomataEnabled)
				{
					TriggeringEvent event = new TriggeringEvent(0, TriggeringEvent.NO_THING, null, null);
					((AutomataEnabled)op).setTriggeringEvent(event);					
				}*/
                op.run();
            }

        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}
/**
 * Insert the method's description here.
 * Creation date: (1/13/2003 6:01:59 PM)
 */
public boolean run() {

    //for holding all tuples involving in the select predicate,
    //actually there can be one here since select is a unary operator
    List tuples = new LinkedList();

    List dequeuedTuples = new LinkedList();

    XATQueue queue = getInputQueue();

    if (dequeueStrategy == DEQUEUE_ONE) {
        //dequeue one tuple at a time
        if (!(queue instanceof XATSubTupleQueue)) {
            //the input queue does not support subtuple, there is only one tuple in the dequeueTuples
            dequeuedTuples.add(queue.dequeue(this));
        } else {
            //the queue support subtuple, revisit
        }
    } else
        if (dequeueStrategy == DEQUEUE_AVAILABLE) {
            if (!(queue instanceof XATSubTupleQueue)) {
                //the input queue does not support subtuple
                dequeuedTuples = queue.dequeueN(queue.getQueueSize(this), this);
            } else {
                //the queue support subtuple
                //tuples.add(getInputQueue().dequeue(this));
            }
        }

    ExpressionStr expression = (ExpressionStr) getExpression();

    if (dequeueStrategy == DEQUEUE_ONE) {
        tuples.add(dequeuedTuples.get(0));

        Object evalResults = expression.eval(tuples, this);

        if ((evalResults != null) && (evalResults instanceof Boolean)) {
            if (((Boolean) evalResults).booleanValue()) {
	            //always enque the first in tuples since there is always on one in tuples
                getOutputQueue().enqueue((XATTuple)tuples.get(0), this);               
            }
        }

    } else { //dequeustagety == dequeue_available
        for (int i = 0; i < dequeuedTuples.size(); i++) {
            tuples.clear();

            tuples.add(dequeuedTuples.get(i));

            Object evalResults = expression.eval(tuples, this);

            if ((evalResults != null) && (evalResults instanceof Boolean)) {

                if (((Boolean) evalResults).booleanValue()) {
                    getOutputQueue().enqueue(projectToDesiredOutput((XATTuple)tuples.get(0)), this);
                    dataDrivenChainRun();
                }
             
                
            }
        }
    }
return true;
    

}
}
