package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;


import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.AllInvokingModeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

import java.util.*;
/**
 * Insert the type's description here.
 * Creation date: (1/23/2003 4:50:11 PM)
 * @author: Luping Ding
 */
public class HashEquiJoinStream extends JoinStreamImp {
	List colNames;
	protected Hashtable[] synopsis = new Hashtable[2];
	public AllInvokingModeImp allInvokingModes;
	
public HashEquiJoinStream(DagNode node, List colNames) {
	super(node, null);
	this.colNames = colNames;
	synopsis[0] = new Hashtable();
	synopsis[1] = new Hashtable();
	allInvokingModes = new AllInvokingModeImp(this);
}


public boolean dataDrivenInvokingRun(java.util.List inputTuples, int inputPos) {
	return allInvokingModes.dataDrivenInvokingRun(inputTuples, inputPos);
	}

/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 1:49:38 PM)
 */
public List getColNames() {
    return colNames;
}
/**
 * Insert the method's description here.
 * Creation date: (1/21/2003 10:57:01 AM)
 * @param cols positions of the join columns of rTuple
 */
public XATTuple join(XATTuple lTuple, XATTuple rTuple, List cols) {

	//Vector lv = new Vector(lTuple.getValues());
	//Vector rv = rTuple.getValues();
	
	XATDataValue[] ldata = lTuple.getArrayData();
	XATDataValue[] rdata = rTuple.getArrayData();
	
	XATDataValue[] newData = new XATDataValue[ldata.length+rdata.length];
	//copy ldata into newdata
	for (int i =0; i<ldata.length;i++)
	 newData[i] = ldata[i];
	
	for (int i=0; i<rdata.length; i++) {
		boolean joined = false;
		Iterator it = cols.iterator();
		while (it.hasNext()) {
			int pos = ((Integer)it.next()).intValue();
			if (pos == i) {
				joined = true;
				break;
			}
		}
		if (!joined) {
			//lv.add(rv.elementAt(i));
			for (int j=0; j<rdata.length; j++)
			  newData[j+ldata.length] = rdata[j];
		}
	}
	//return new XATTupleImp(lv);
	return new XATTupleImp(newData);
}
/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 1:49:38 PM)
 */
/*public boolean run() {
    XATQueue lQueue = this.getLeftInputQueue();
    XATQueue rQueue = this.getRightInputQueue();

    /*
    ConsumedVisitor cv = new ConsumedVisitor();
    Set cols = (Set) cv.visit(this);
    Iterator it = cols.iterator();
    int leftCol = lQueue.getSchema().getPos((String) it.next());
    int rightCol = rQueue.getSchema().getPos((String) it.next());
    Vector joinCols = new Vector();
    joinCols.add(new Integer(rightCol));
    */
    
   /* int leftCol = lQueue.getSchema().getPos((String) getColNames().get(0));
    int rightCol = rQueue.getSchema().getPos((String) getColNames().get(1));

    Vector joinCols = new Vector();
    joinCols.add(new Integer(rightCol));

    int flag = 2;
    while (true) {
        try {
            XATTuple tl = lQueue.dequeue(this);
            Object lKey = tl.getCell(leftCol).toString();
            Object lVal = synopsis[0].get(lKey);
            if (lVal == null) {
                Vector lv = new Vector();
                lv.add(tl);
                synopsis[0].put(lKey, lv);
            } else {
                ((Vector) lVal).add(tl);
                synopsis[0].put(lKey, lVal);
            }

            Object rVal = synopsis[1].get(lKey);
            if (rVal != null) {
                Vector rv = (Vector) rVal;
                for (int i = 0; i < rv.size(); i++) {
                    XATTuple tr = (XATTuple) rv.elementAt(i);
                    this.getOutputQueue().enqueue(join(tl, tr, joinCols), this);
                }
            }
        } catch (XATQueueException e) {
            flag--;
            if (flag == 0) {
                return true;
            }
        }

        try {
            XATTuple tr = rQueue.dequeue(this);
            Object rKey = tr.getCell(rightCol).toString();
            Object rVal = synopsis[1].get(rKey);
            if (rVal == null) {
                Vector rv = new Vector();
                rv.add(tr);
                synopsis[1].put(rKey, rv);
            } else {
                ((Vector) rVal).add(tr);
                synopsis[1].put(rKey, rVal);
            }

            Object lVal = synopsis[0].get(rKey);
            if (lVal != null) {
                Vector lv = (Vector) lVal;
                for (int i = 0; i < lv.size(); i++) {
                    XATTuple tl = (XATTuple) lv.elementAt(i);
                    this.getOutputQueue().enqueue(join(tl, tr, joinCols), this);
                }
            }
        } catch (XATQueueException e) {
            flag--;
            if (flag == 0) {
                return true;
            }
        }
    }

}*/
public boolean run() {
	allInvokingModes.run();
	return true;

}
/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 1:49:38 PM)
 */
public void setColNames(List colNames) {
    this.colNames = colNames;
}

/**
 * Pipelining version
 * Creation date: (4/7/2003 10:52:51 PM)
 * new inputs from src "inputPos" would 
 * (1) be joined with the states at the other side
 * (2) be put into the states of its own side for possible later join
 
 * @return java.util.List joined results
 * @param inputTuples java.util.List new input tuples from an input source
 * @param inputPos which input source, if 0, left input source, otherwise 1, right input source) 
 */
 
public java.util.List run(java.util.List inputTuples, int inputPos){
	List result = new ArrayList();

	XATQueue lQueue = getLeftInputQueue();
	XATQueue rQueue = getRightInputQueue();

	//which columns in each joining party would appear in the joined result (versus those columns that are projected out)
   
	int[][] outputPos = getOutputPositions();

	//get the position of the column in the left side. the joining predicate is defined on this column
	int leftCol = getJoinColPos()[0];

	//and the joining predicate is defined on this column, i.e., joining predicate requires value of leftCol = value of rightCol
	int rightCol = getJoinColPos()[1];

	int otherPartyPos;

	if (inputPos == 0)
		otherPartyPos = 1;
	else
		otherPartyPos = 0;

	for (int i = 0; i < inputTuples.size(); i++) {

      
		XATTuple tIncoming = (XATTuple) inputTuples.get(i);

		//find the value of leftCol in this incoming tuple
		Object incomingKey = tIncoming.getCell(leftCol).toString();
		//find the partition in the hashtable for the value
		Object incomingVal = synopsis[inputPos].get(incomingKey);

		//put this tuple into the corresponding partition in the hashtable
		if (incomingVal == null) {
			Vector incomingV = new Vector();
			incomingV.add(tIncoming);
			synopsis[inputPos].put(incomingKey, incomingV);
		} else {
			((Vector) incomingVal).add(tIncoming);
			synopsis[inputPos].put(incomingKey, incomingVal);
		}

		//find whether there is a corresponding partition in the other side, 
		Object existVal = synopsis[otherPartyPos].get(incomingKey);
		if (existVal != null) {
			//all tuples in the partition
			Vector existV = (Vector) existVal;
			for (int j = 0; j < existV.size(); j++) {
				XATTuple tExist = (XATTuple) existV.elementAt(j);
				//this.getOutputQueue().enqueue(join(tl, tr, joinCols), this);
				if (inputPos < otherPartyPos)
					result.add(join(tIncoming, tExist));
				else
					result.add(join(tExist, tIncoming));
			}
		}
	}

	return result;
}
}
