/*
 * Created on Aug 3, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.schedulemode
	.DataDrivenInvoking;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;

/**
 * @author suhong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class NaturalJoinStream
	extends CartesianStream
	implements XATStreamOpRunCore, DataDrivenInvoking {
	//private List leftBuffer = new ArrayList();
	//private List rightBuffer = new ArrayList();

	List curLeftPartition = new ArrayList();
	//the id in the left partition
	int leftPartitionId = -1;

	List curRightPartition = new ArrayList();
	//the id in the right partition
	int rightPartitionId = -1;

	int leftCursor = 0;
	int rightCursor = 0;

	//the position of the attribute joined on
	private int leftTargetPos;
	private int rightTargetPos;

	/**
	 * @param node
	 */
	public NaturalJoinStream(DagNode node) {
		super(node);
	}

	public void setLeftTargetPos(int leftTargetPos) {
		this.leftTargetPos = leftTargetPos;
	}

	public void setRightTargetPos(int rightTargetPos) {
		this.rightTargetPos = rightTargetPos;
	}

	public List run(List inputTuples, int inputPos) {

		int size = inputTuples.size();

		List result = new ArrayList();

		//init
		//if (leftBuffer.isEmpty() || rightBuffer.isEmpty())
		//	return result;

		int curLeftId = -1;
		int curRightId = -1;

		XATTuple curLeftTuple = null;

		XATTuple curRightTuple = null;

		//clean buffer until at least one buffer is empty
		boolean runLeft = true;

		for (int i = 0; i < inputTuples.size(); i++) {
			XATTuple tuple = (XATTuple) inputTuples.get(i);
			if (inputPos == 0) {
				//left
				curLeftId =
					tuple.getCell(leftTargetPos).convertToDouble().intValue();
				if (curLeftId == leftPartitionId)
					curLeftPartition.add(tuple);
				else if (curLeftId > leftPartitionId) {
					curLeftPartition.clear();
					curLeftPartition.add(tuple);
					leftPartitionId = curLeftId;
					leftCursor = 0;
				}
			} else if (inputPos == 1) {
				curRightId =
					tuple.getCell(rightTargetPos).convertToDouble().intValue();
				if (curRightId == rightPartitionId)
					curRightPartition.add(tuple);
				else if (curRightId > rightPartitionId) {
					curRightPartition.clear();
					curRightPartition.add(tuple);
					rightPartitionId = curRightId;
					rightCursor = 0;
				}
			}
		} //end of for

		if (inputPos == 0) {
			if (curRightPartition.size() == 0)
				return result;

			for (int i = leftCursor; i < curLeftPartition.size(); i++) {
				curLeftTuple = (XATTuple) curLeftPartition.get(leftCursor);
				leftCursor++;
				curLeftId =
					curLeftTuple
						.getCell(this.leftTargetPos)
						.convertToDouble()
						.intValue();

				if (curLeftId == rightPartitionId) {
					//join this tuple with every thing in the right partition
					for (int j = 0; j < curRightPartition.size(); j++) {

						XATDataValue[] resultData =
							new XATDataValue[getOutputQueue()
								.getSchema()
								.getLength()];

						int[][] temp = getOutputPositions();

						((XATTupleImp) curLeftTuple).fillDataInListTo(
							resultData,
							temp[0],
							0);

						(
							(XATTupleImp) curRightPartition.get(
								j)).fillDataInListTo(
							resultData,
							temp[1],
							temp[0].length);

						result.add(new XATTupleImp(resultData));
					} //end for j
				} else if (curLeftId > rightPartitionId) {
					//purge the other side
					curRightPartition.clear();
					rightCursor = 0;
				} //it is impossible that curLeftId < rightPartitionId						
			}
		} else {
			//inputPos = 1
			if (curLeftPartition.size() == 0)
				//no content in left
				return result;

			for (int i = rightCursor; i < curRightPartition.size(); i++) {
				//new input
				curRightTuple = (XATTuple) curRightPartition.get(rightCursor);
				rightCursor++;
				curRightId =
					curRightTuple
						.getCell(this.rightTargetPos)
						.convertToDouble()
						.intValue();

				if (curRightId == leftPartitionId) {
					//join this tuple with every thing in the right partition
					for (int j = 0; j < curLeftPartition.size(); j++) {

						XATDataValue[] resultData =
							new XATDataValue[getOutputQueue()
								.getSchema()
								.getLength()];

						int[][] temp = getOutputPositions();

						((XATTupleImp) curRightTuple).fillDataInListTo(
							resultData,
							temp[1],
							temp[0].length);

						(
							(XATTupleImp) curLeftPartition.get(
								j)).fillDataInListTo(
							resultData,
							temp[0],
							0);

						result.add(new XATTupleImp(resultData));
					} //end for j
				} else if (curRightId > leftPartitionId) {
					//purge the other side
					curLeftPartition.clear();
					leftCursor = 0;
				} //it is impossible that curLeftId < rightPartitionId		
			}
		}

		timeKeeper.increOutputCount(result.size());

		return result;

		/*for (int num = 0; num < size; num++) {
		
			//tuple from left
			if (inputPos == 0) {
				leftBuffer.add(inputTuples.get(num));
			}
			//tuple from right
			else {
				rightBuffer.add(inputTuples.get(num));
			}
		}*/

		//return generateTuples();

	}

	public List runbak(List inputTuples, int inputPos) {

		int size = inputTuples.size();

		List result = new ArrayList();

		XATTuple curLeftTuple;

		XATDataValue[] resultData =
			new XATDataValue[getOutputQueue().getSchema().getLength()];

		int[][] temp = getOutputPositions();

		//init
		//if (leftBuffer.isEmpty() || rightBuffer.isEmpty())
		//	return result;
		if (inputPos == 0) {

			curLeftPartition = inputTuples;
		} else {

			for (int j = 0; j < inputTuples.size(); j++) {
				XATTupleImp tuple = (XATTupleImp) inputTuples.get(j);

				for (int i = 0; i < curLeftPartition.size(); i++) {
					curLeftTuple = (XATTuple) curLeftPartition.get(i);

					((XATTupleImp) curLeftTuple).fillDataInListTo(
						resultData,
						temp[0],
						0);

					tuple.fillDataInListTo(resultData, temp[1], temp[0].length);

					result.add(new XATTupleImp(resultData));
				}

			}

			curLeftPartition.clear();
		}

		

		return result;

		/*for (int num = 0; num < size; num++) {
		
			//tuple from left
			if (inputPos == 0) {
				leftBuffer.add(inputTuples.get(num));
			}
			//tuple from right
			else {
				rightBuffer.add(inputTuples.get(num));
			}
		}*/

		//return generateTuples();

	}

	/*public List generateTuples() {
	
		List result = new ArrayList();
	
		//init
		if (leftBuffer.isEmpty() || rightBuffer.isEmpty())
			return result;
	
		int curLeftId = -1;
		int curRightId = -1;
	
		XATTuple curLeftTuple = null;
	
		XATTuple curRightTuple = null;
	
		//clean buffer until at least one buffer is empty
		boolean runLeft = true;
	
		while (!leftBuffer.isEmpty() && !rightBuffer.isEmpty()) {
	
			if (runLeft) {
				//init right hand side
				if (curRightId == -1) {
					//curRightTuple = (XATTuple) rightBuffer.get(0);
					//this.rightBuffer.remove(0);
					curRightTuple = (XATTuple) rightBuffer.remove(0);
					curRightId =
						curRightTuple
							.getCell(rightTargetPos)
							.convertToDouble()
							.intValue();
	
					//add into partition
					curRightPartition.add(curRightTuple);
					rightPartitionId = curRightId;
	
				} else { //curRightId!=-1
					if (curRightId == rightPartitionId)
						curRightPartition.add(curRightTuple);
					else if (curRightId > rightPartitionId) {
						//purge itself
						curRightPartition.clear();
						curRightPartition.add(curRightTuple);
						rightPartitionId = curRightId;
					}
	
				}
	
				//curLeftTuple = (XATTuple) this.leftBuffer.get(0);
				//this.leftBuffer.remove(0);
				curLeftTuple = (XATTuple) leftBuffer.remove(0);
	
				curLeftId =
					curLeftTuple
						.getCell(leftTargetPos)
						.convertToDouble()
						.intValue();
	
				if (curLeftId < curRightId) {
					continue;
				}
				if (curLeftId == curRightId) {
					//generate new tuple from leftTuple and rightTuple
					XATDataValue[] resultData =
						new XATDataValue[getOutputQueue()
							.getSchema()
							.getLength()];
	
					int[][] temp = getOutputPositions();
	
					((XATTupleImp) curLeftTuple).fillDataInListTo(
						resultData,
						temp[0],
						0);
	
					((XATTupleImp) curRightTuple).fillDataInListTo(
						resultData,
						temp[1],
						temp[0].length);
	
					result.add(new XATTupleImp(resultData));
				} else { //curLeftId>curRightId
					runLeft = false;
					//purge the other side
					curRightPartition.clear();
				}
			}
			//run right hand side
			else {
				//init right hand side
				if (curLeftId == -1) {
					//curLeftTuple = (XATTuple) this.leftBuffer.get(0);
					//this.leftBuffer.remove(0);
					curLeftTuple = (XATTuple) leftBuffer.remove(0);
					curLeftId =
						curLeftTuple
							.getCell(this.leftTargetPos)
							.convertToDouble()
							.intValue();
				} else {
					if (curLeftId == leftPartitionId)
						curLeftPartition.add(curLeftTuple);
					else if (curLeftId > leftPartitionId) {
						//purge itself
						curLeftPartition.clear();
						curLeftPartition.add(curLeftTuple);
						leftPartitionId = curLeftId;
					}
				}
	
				// curRightTuple = (XATTuple) this.rightBuffer.get(0);
				//	this.rightBuffer.remove(0);
				curRightTuple = (XATTuple) rightBuffer.remove(0);
				curRightId =
					curRightTuple
						.getCell(this.rightTargetPos)
						.convertToDouble()
						.intValue();
	
				if (curRightId < curLeftId) {
					continue;
				}
				if (curRightId == curLeftId) {
					//generate new tuple from rightTuple and leftTuple
					XATDataValue[] resultData =
						new XATDataValue[getOutputQueue()
							.getSchema()
							.getLength()];
	
					int[][] temp = getOutputPositions();
	
					((XATTupleImp) curLeftTuple).fillDataInListTo(
						resultData,
						temp[0],
						0);
	
					((XATTupleImp) curRightTuple).fillDataInListTo(
						resultData,
						temp[1],
						temp[0].length);
	
					result.add(new XATTupleImp(resultData));
				} else {
					runLeft = true;
					//purge the other side
					curLeftPartition.clear();
				}
			} //end of else runLeft = false;
		} //end of while
	
		return result;
	}*/

	public String toString() {
		String rs = new String();

		rs = "NaturalJoinStream";

		rs = rs + " with schema: ";

		for (int i = 0; i < outputQueue.size(); i++) {
			XATQueue queue = (XATQueue) outputQueue.get(i);

			XATQueueSchema schema = queue.getSchema();

			if (schema != null) {
				Vector v = schema.getColNames();

				for (int j = 0; j < v.size(); j++) {
					rs = rs + (String) v.get(j);
				}
			}
		}

		return rs;

	}

}
