package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import java.util.*;

public class ThetaJoinStream extends JoinStreamImp {
	protected XATSynopsisQueueImp[] synopsis = new XATSynopsisQueueImp[2];

	protected ClassExecTimeKeeper timeKeeper;

	public ThetaJoinStream(DagNode node, ExpressionStr exp) {
		super(node, exp);
		timeKeeper = new ClassExecTimeKeeper(this);
	}

	public boolean dataDrivenInvokingRun(java.util.List inputTuples,
			int inputPos) {
		return allInvokingModes.dataDrivenInvokingRun(inputTuples, inputPos);
	}

	/**
	 * Pipelining version Creation date: (4/8/2003 11:38:17 AM)
	 * 
	 * @return java.util.List
	 * @param multiSrcInputTuples
	 *            java.util.List[] each List in the array is input tuples from a
	 *            source
	 * @exception java.lang.Exception
	 *                The exception description.
	 */
	public List run(List inputTuples, int inputPos) {

		timeKeeper.start();

		List result = new ArrayList();

		Vector tList = new Vector();

		int otherPartyPos;

		if (inputPos == 0)
			otherPartyPos = 1;
		else
			otherPartyPos = 0;

		//while (true) {
		for (int i = 0; i < inputTuples.size(); i++) {

			tList.removeAllElements();
			//XATTuple tl = lQueue.dequeue(this);
			XATTuple tIncoming = (XATTuple) inputTuples.get(i);

			synopsis[inputPos].enqueue(tIncoming, this);
			synopsis[otherPartyPos].resetCursor(this);

			for (int j = 0; j < synopsis[otherPartyPos].getQueueSize(); j++) {

				XATTuple tExist = (XATTuple) synopsis[otherPartyPos]
						.dequeue(this);

				tList.removeAllElements();
				tList.add(tIncoming);
				tList.add(tExist);

				Object evalResult = this.getExpression().eval(tList, this);
				if (evalResult instanceof Boolean) {
					// create joined tuple
					if (((Boolean) evalResult).booleanValue()) {

						if (inputPos < otherPartyPos)
							result.add(join(tIncoming, tExist));
						else
							result.add(join(tExist, tIncoming));

						//oQueue.enqueue(newTuple, this);

					}
				}
			}
		}

		timeKeeper.pause();
		return result;
	}
}