package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

/**
 * Insert the type's description here. Creation date: (1/13/2003 4:52:46 PM)
 * 
 * @author: Hong Su
 */
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.FindOpVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.InTimeSJStream;

import org.w3c.dom.Element;
//import org.xml.sax.*;

import java.util.*;

public class ExtractByCollectionStreamImp extends NavigateStreamImp implements
		ExtractByCollectionStream {
	protected int[] storingMethods = { 0, 0, 0, 0, 0 };

	protected ExtendedAutomata automata;

	protected ExtractStreamImp extractCommon;

	protected Finer_StreamStoreMgr storeMgr;

	//the newestly generated subtuple
	protected XATDataValue[] subTupleContentHolder;
	protected Finer_StreamStoreMgrKey typedSubTupleKey;

	protected PureNavigateAutoStream collectionByNavOp;

	protected ClassExecTimeKeeper timeKeeper;

	protected ExtendedState opState;

	//protected int numberOfTuplesToEnqueue = 1;

	//	protected List tempResult;
	//protected boolean clearTempResult = false;

	//hardcode
	protected List[] accummulateSubTuples;

	public AllInvokingModeImp allInvokingModes = new AllInvokingModeImp(this);

	//count of bindings of the destination node with the entry
	protected int itemCountWithinEntry = 0;

	//whether it has been checked on this partition
	boolean partitionChecked = false;

	protected int outputCount;

	protected int posType;

	protected int posDom;

	protected int posAttr;

	protected int posNodeId;

	boolean needSetPartitionCheck = false;

	/**
	 * NavRegCollectionImp constructor comment.
	 * 
	 * @param node
	 *            edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public ExtractByCollectionStreamImp(XATNode node, NavigationStep[] ep,
			NavigationStep[] dest) {
		super(node, ep, dest);

		extractCommon = new ExtractStreamImp(this);

		timeKeeper = new ClassExecTimeKeeper(this);

	}

	//according to how many representations the extract has
	public void setUpCellNum() {
		int cellNum = getTupleColNum();

		accummulateSubTuples = new ArrayList[cellNum];

		for (int i = 0; i < cellNum; i++)
			accummulateSubTuples[i] = new ArrayList();
		
		subTupleContentHolder = new XATDataValue[cellNum];

	}

	public int getItemCountWithinEntry() {
		return itemCountWithinEntry;
	}

	/**
	 * Insert the method's description here. Creation date: (1/29/2003 5:50:04
	 * PM)
	 * 
	 * @param auto
	 *            edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.ExtendedAutomata
	 */
	public void associateWithAuto(ExtendedAutomata auto) {
		this.automata = auto;
		extractCommon.associateWithAuto(auto);

		//set up typePos and domPos

		for (int i = 0; i < ExtractStream.TYPED_VALUE; i++) {
			if (storingMethods[i] == 1)
				posType++;
		}

		for (int i = 0; i < ExtractStream.DOM; i++) {
			if (storingMethods[i] == 1)
				posDom++;
		}

		for (int i = 0; i < ExtractStream.ATTRS; i++) {
			if (storingMethods[i] == 1)
				posAttr++;
		}

		for (int i = 0; i < ExtractStream.NODE_ID; i++) {
			if (storingMethods[i] == 1)
				posNodeId++;
		}

		//use demandriven from sj
		//add operator into state's groupbyops
		//		commented out for using demandriven from sj
		List ances = FindOpVisitor.findAncestorOps((DagNode) getNode());
		boolean hasSJAnces = false;
		for (Iterator it = ances.iterator(); it.hasNext();) {
			XATOperator anceOp = (XATOperator) it.next();
			if (anceOp instanceof InTimeSJStream) {
				hasSJAnces = true;
				break;
			}

		}

		if (!hasSJAnces) {

			PureNavigateAutoStream navOp = getCollectionByNavOp();
			;

			List states = auto.getFrStateHash(navOp);

			for (Iterator it = states.iterator(); it.hasNext();) {
				ExtendedState state = (ExtendedState) it.next();

				state.addGroupbyOp(this);
			}
		}

	}

	/**
	 * output tuples of an operator A implementing this interface are passed as
	 * parameters to the parent operator B, therefore B does not need to fetch
	 * from the queue this is a pipeling manner in the sense that all
	 * intermediate data is directly passed to be consumed rather than stored
	 * (neither in second storage nor memory)
	 * 
	 * Creation date: (4/8/2003 1:24:40 PM)
	 */
	public boolean dataDrivenInvokingRun(List inputTuples, int inputPos) {
		return allInvokingModes.dataDrivenInvokingRun(inputTuples, inputPos);
	}

	public boolean lightweightDataDrivenInvokingRun(List inputTuples,
			int inputPos) {
		return allInvokingModes.lightweightDataDrivenInvokingRun(inputTuples,
				inputPos);

	}

	/**
	 * Insert the method's description here. Creation date: (1/29/2003 1:26:37
	 * PM)
	 * 
	 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata
	 */
	public ExtendedAutomata getAutomata() {
		return automata;
	}

	public PureNavigateAutoStream getCollectionByNavOp() {
		return collectionByNavOp;
	}

	public ExtendedState getOpState() {
		return opState;
	}

	public Finer_StreamStoreMgr getStoreMgr() {
		return storeMgr;
	}

	public int[] getStoringMethods() {
		return storingMethods;
	}

	public ClassExecTimeKeeper getTimeKeeper() {
		return timeKeeper;
	}

	public int getTupleColNum() {
		return extractCommon.getTupleColNum();
	}

	public boolean isAttrs() {
		//return extractCommon.isAttrs();
		if (storingMethods[ExtractStream.ATTRS] == 1)
			return true;
		else
			return false;
	}

	public boolean isCompleteTree() {
		return extractCommon.isCompleteTree();
	}

	public boolean isDom() {
		//return extractCommon.isDom();
		if (storingMethods[ExtractStream.DOM] == 1)
			return true;
		else
			return false;
	}

	public boolean isNodeId() {
		if (storingMethods[ExtractStream.NODE_ID] == 1)
			return true;
		else
			return false;
		//return extractCommon.isNodeId();
	}

	public boolean isPartitionInvoked() {
		return extractCommon.isPartitionInvoked();
	}

	public boolean isTypedValue() {
		//return extractCommon.isTypedValue();
		if (storingMethods[ExtractStream.TYPED_VALUE] == 1)
			return true;
		else
			return false;
	}

	/**
	 * Insert the method's description here. Creation date: (1/18/2003 4:49:54
	 * PM)
	 */
	public boolean run() {
       
		allInvokingModes.run();
		return true;
	}

	/**
	 * Insert the method's description here. Creation date: (2/3/2003 5:33:21
	 * PM)
	 * 
	 * @param newCollectionByNavOp
	 *            edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAuto
	 */
	public void setCollectionByNavOp(PureNavigateAutoStream newCollectionByNavOp) {
		collectionByNavOp = newCollectionByNavOp;
	}

	/**
	 * Insert the method's description here. Creation date: (4/30/2003 1:28:30
	 * PM)
	 * 
	 * @param newOpState
	 *            edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState
	 */
	public void setOpState(ExtendedState newOpState) {
		opState = newOpState;
	}

	/**
	 * Insert the method's description here. Creation date: (1/30/2003 10:37:13
	 * AM)
	 * 
	 * @param newStoreMgr
	 *            edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.StreamStoreMgr
	 */
	public void setStoreMgr(Finer_StreamStoreMgr newStoreMgr) {
		storeMgr = newStoreMgr;
	}

	/**
	 * Insert the method's description here. Creation date: (1/31/2003 11:47:59
	 * AM)
	 * 
	 * @param storingMethod
	 *            int
	 */
	public void setStoringMethod(int storingMethod) {
		extractCommon.setStoringMethod(storingMethod);
	}

	/**
	 * Insert the method's description here. Creation date: (1/20/2003 9:38:14
	 * PM)
	 * 
	 * @param newStoringMethods
	 *            java.util.Vector
	 */
	public void setStoringMethods(int[] newStoringMethods) {
		storingMethods = newStoringMethods;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSingleQStreamOpRunCore#runWithBlockingInputs(java.util.List)
	 */
	public List runWithBlockingInputs(List[] inputTuples, int inputPos) {
		// TODO Auto-generated method stub
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#selfPartitionDelimiInvokingRun(edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState)
	 */
	public boolean selfPartitionDelimiInvokingRun(List partitionStates,
			SuspensionEdge suspendComp) {
		/*
		 * boolean result = allInvokingModes.selfPartitionDelimiInvokingRun(
		 * partitionStates, suspendComp);
		 */

		if (!partitionChecked) {

			partitionChecked = true;
			int partitionStateNum = partitionStates.size();
			//no matter whether the state is suspended or not,
			//the paritionchecked flag should reset for the operator

			//	((ExtendedState) partitionStates.get(partitionStateNum - 1))

			//curOp is extractbycoolection
			if (lightweightDataDrivenInvokingRun(null, 0)) {
				//extractbycollection yields sth

				return true;
			}

			//this pattern fails
			//suspend the navOp which provides the bindings to the variable
			// that is partitioned on
			//suspend all the navs from this partition

			for (int i = 0; i < partitionStateNum - 1; i++)
				((ExtendedState) partitionStates.get(i)).suspendAllTransits(
						suspendComp, false);
			//clean temp for the last one
			//it covers all the temps for the previous ones
			//boolean indicates clean temporary results
			((ExtendedState) partitionStates.get(partitionStateNum - 1))
					.suspendAllTransits(suspendComp, true);

			return false;

		}

		return true;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByCollectionStream#cleanTemp()
	 */
	public void cleanTemp() {
		timeKeeper.increItemCountWithinEntrySum(itemCountWithinEntry);
		itemCountWithinEntry = 0;

		for (int i = 0; i < accummulateSubTuples.length; i++)
			accummulateSubTuples[i].clear();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#getPartitionChecked()
	 */
	public boolean getPartitionChecked() {
		return partitionChecked;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#setPartitionChecked(boolean)
	 */
	public void setPartitionChecked(boolean partitionChecked) {
		this.partitionChecked = partitionChecked;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
	 */
	public boolean cleanAllAccumulatedTuples() {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public boolean matchStates(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
	 */
	public boolean hasUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
	 */
	public boolean recomputeUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
	 */
	public int setStateID(int startID) {
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#getOutputCount()
	 */
	public int getOutputCount() {
		return outputCount;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#resetOutputCount()
	 */
	public void resetOutputCount() {
		outputCount = 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream#runGroupBy()
	 */
	public List runGroupBy() {
		List tempResult = new ArrayList();
		timeKeeper.increItemCountWithinEntrySum(itemCountWithinEntry);
		itemCountWithinEntry = 0;

		if (accummulateSubTuples[0].size() > 0) {
			//get sth that can be output
			//XATKeyDataValue[] subTupleContentHolder = new XATKeyDataValue[accummulateSubTuples.length];

			for (int i = 0; i < accummulateSubTuples.length; i++) {

				subTupleContentHolder[i] = new XATKeyDataValue(
						((ArrayList) accummulateSubTuples[i]).clone());
				accummulateSubTuples[i].clear();
			}

			tempResult.add(new XATTupleImp(subTupleContentHolder));

		}

		//tempResult.addAll(((XATQueueImp)getOutputQueue()).dequeueAll());

		return tempResult;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream#runPushStack()
	 */
	public void runPushStack(int tokenId, int startTokenId) {
			
		timeKeeper.startTokenCount(tokenId);
		timeKeeper.start();
		
		itemCountWithinEntry++;

		if (isTypedValue()) {
			//next text descendant encountered would be the first text
			// descendant of the subtuple element
			typedSubTupleKey = new Finer_StreamStoreMgrKey(storeMgr
					.getCurrentUnitToPutTypedVal(), storeMgr.getTypedValBegin());

			accummulateSubTuples[posType].add(typedSubTupleKey);

		} else if (isDom()) {
			//add in the dom object handle
			Element currentNode = storeMgr.getCurrentUnitToPutDom();
			accummulateSubTuples[posDom].add(currentNode);

		} //end of if dom

		if (isNodeId()) {
			//create the node id (synthetic, not intrinsic in data), which is
			// equivalent to run time state id

			accummulateSubTuples[posNodeId].add(new Integer(tokenId));

		}
		
		timeKeeper.pause();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream#runPopStack()
	 */
	public void runPopStack(int tokenId, int startTokenId) {
		timeKeeper.pauseTokenCount(tokenId);
		
		typedSubTupleKey.setEnd(storeMgr.getTypedValEnd());

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#run(java.util.List,
	 *      int)
	 */
	public List run(List inputTuples, int inputPos) {
		return runGroupBy();
	}

	public boolean needSetPartitionCheck() {
		// TODO Auto-generated method stub
		return needSetPartitionCheck;
	}

	public void setNeedSetPartitionCheck() {
		needSetPartitionCheck = true;
	}

	public List[] demandDrivenInvokingRunWithOrder() {
		return null;
	}
	public void runPushStackWithRecur(int tokenId, int startTokenId){}
	public void runPopStackWithRecur(int tokenId, int startTokenId){}
	
	


}