package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

import java.io.Serializable;
import java.util.*;

//import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATMemoryQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATNodeDoesNotExistException;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.*;
/**
 * Creation date: (1/18/2003 4:07:01 PM)
 * @author: Hong Su
 */
public class ExtractStreamImp  
	extends AutomataEnabledImp
	implements ExtractStream, Serializable {

	protected Finer_StreamStoreMgr storeMgr;
	protected ExtendedAutomata automata;
	protected boolean partitionChecked = false;

	/**
	 * ExtractionAutoImp constructor comment.
	 * @param automata edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata
	 * @param physicalOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
	 */
	public ExtractStreamImp(XATStreamOpRunCore physicalOp) {

		super(physicalOp);

		//autoOutputQueues = new Hashtable();

		//XATQueue uniqueOutQueue = null;

		/*if (physicalOp
			.getProperty("OUTPUT_TUPLE_GRANULARITY")
			.equals(XATStreamOperator.FULL_TUPLE)) {
			uniqueOutQueue = new XATQueueImp(physicalOp);
		}*/
		//else 
		//  if (physicalOp.getProperty("OUTPUT_TUPLE_GRANULARITY").equals(XATStreamOperator.SUB_TUPLE)){
		//	uniqueOutQueue = new XATSubTupleQueue(physicalOp);		
		//}

		//autoOutputQueues.put(new Integer(UNIQUE_OUTPUT_QUEUE), uniqueOutQueue);

		//allInvokingModes = new AllInvokingModeImp(physicalOp);

	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:16:15 PM)
	 * @param auto edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.ExtendedAutomata
	 */
	public void associateWithAuto(ExtendedAutomata auto) {

		((ExtractStream) physicalOp).setStoreMgr(auto.getStoreMgr());

		XATNode node = physicalOp.getNode();

		//get parent info: the state associated with the child operator
		//child operator must be a pureNavigateAuto as well
		XATStreamOperator childOp =
			(XATStreamOperator) node.getChild(0).getOperator();

		List childOpStas = auto.getFrStateHash(childOp);

		for (Iterator it = childOpStas.iterator(); it.hasNext();) {
			ExtendedState childOpSta = (ExtendedState) it.next();
			//relate operator and state bi-directionally
			//the extract shares the same state as the pureNavigateAuto
								
			childOpSta.addExtractOp((ExtractStream) physicalOp);
			
			//add appropraite extractop to the popExtractOp
			if (((ExtractStream)physicalOp).isCompleteTree() ||
			    ((ExtractStream)physicalOp).isTypedValue())
			    childOpSta.addPopExtractOp((ExtractStream)physicalOp);
			
			
			auto.addIntoStateHash(physicalOp, childOpSta);

			((ExtractStream) physicalOp).setOpState(childOpSta);
		}

	

	}
	

	
	/**
	 * output tuples of an operator A implementing this interface are passed as parameters  
	 * to the parent operator B, therefore B does not need to fetch from the queue
	 * this is a pipeling manner in the sense that all intermediate data is directly passed
	 * to be consumed rather than stored (neither in second storage nor memory)
	  
	 * Creation date: (5/26/2003 3:29:31 PM)
	 */
	public boolean dataDrivenInvokingRun(
		java.util.List inputTuples,
		int inputPos) {
		return false;
	}

	
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 12:20:22 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata
	 */
	public ExtendedAutomata getAutomata() {
		return null;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 12:20:22 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
	 */
	public edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue getAutoOutputQueue() {
		return null;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 1:05:44 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
	 * @param staId int
	 */
	public edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue getAutoOutputQueue(
		int groupbyRunTimeStaId) {
		return null;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/19/2003 10:57:35 PM)
	 */
	public ExtendedState getOpState() {
		return null;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/22/2003 10:59:17 AM)
	 * @return int
	 * @param storingMethod int
	 */
	/*public int getPosInTupleForStoringMethod(int storingMethod) {
		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		int pos = -1;
		for (int i = 0; i <= storingMethod; i++) {
			if (storingMethods[i] == 1)
				pos++;
		}

		return pos;

	}*/
	
	
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 1:08:45 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.StreamStoreMgr
	 */
	public Finer_StreamStoreMgr getStoreMgr() {
		return storeMgr;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/30/2003 10:10:57 AM)
	 * @return int
	 */
	public int[] getStoringMethods() {
		return null;
	}
	

	/**
	 * Insert the method's description here.
	 * Creation date: (2/19/2003 10:07:48 AM)
	 * @return int
	 */
	public int getTupleColNum() {
		int count = 0;

		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		for (int i = 0; i < storingMethods.length; i++) {
			if (storingMethods[i] == 1) {
				count++;
			}
		}
		return count;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (3/19/2003 6:17:33 PM)
	 * @return boolean
	 */
	public boolean isAttrs() {
		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		if (storingMethods[ExtractStream.ATTRS] == 1)
			return true;
		else
			return false;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:09:05 PM)
	 * @return boolean
	 */
	public boolean isCompleteTree() {

		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		if (storingMethods[ExtractStream.COMPLETE_TREE] == 1)
			return true;
		else
			return false;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/15/2003 9:18:10 PM)
	 * @return boolean
	 */
	public boolean isDom() {
		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		if (storingMethods[ExtractStream.DOM] == 1)
			return true;
		else
			return false;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:10:47 PM)
	 * @return boolean
	 */
	public boolean isNodeId() {

		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		if (storingMethods[ExtractStream.NODE_ID] == 1)
			return true;
		else
			return false;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:11:24 PM)
	 * @return boolean
	 */
	public boolean isTypedValue() {
		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		if (storingMethods[ExtractStream.TYPED_VALUE] == 1)
			return true;
		else
			return false;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (4/19/2003 11:07:10 PM)
	 */
	public void setExtractOpState(
		edu
			.wpi
			.cs
			.dsrg
			.xmldb
			.xat
			.component
			.automata
			.automata
			.ExtendedState extractOpState) {
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (4/19/2003 11:07:10 PM)
	 */
	public void setOpState(ExtendedState newOpState) {

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 1:08:45 PM)
	 * @param newStoreMgr edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.StreamStoreMgr
	 */
	public void setStoreMgr(Finer_StreamStoreMgr newStoreMgr) {
		storeMgr = newStoreMgr;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/31/2003 11:41:09 AM)
	 * @param storingMethod int
	 */
	public void setStoringMethod(int storingMethod) {
		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		storingMethods[storingMethod] = 1;

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/19/2003 10:07:48 AM)
	 * @return int
	 */
	public int tupleColNum() {
		int count = 0;

		int[] storingMethods = ((ExtractStream) physicalOp).getStoringMethods();

		for (int i = 0; i < storingMethods.length; i++) {
			if (storingMethods[i] == 1) {
				count++;
			}
		}
		return count;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#selfPartitionDelimiInvokingRun(edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState)
	 */
	public boolean selfPartitionDelimiInvokingRun(
		List partitionStates,
		SuspensionEdge suspendComp) {
		System.out.println(
			"Warning: should not reach here!selfpartitionDelimiInvokingRun in extractstreamimp");
		return false;

	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream#clearTemp()
	 */
	public void cleanTemp() {
		System.out.println("should not reach here");

	}
	/*will never be refered, just for implementing the interface
	 */
	public int getItemCountWithinEntry() {
		return 0;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#selfPartitionDelimiInvokingRun(java.util.List, edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.SuspensionEdge, boolean)
	 */
	public boolean selfPartitionDelimiInvokingRun(
		List partitionStates,
		SuspensionEdge edge,
		boolean partitionChecked) {
		// TODO Auto-generated method stub
		return false;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#getPartitionChecked()
	 */
	public boolean getPartitionChecked() {
		return partitionChecked;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#setPartitionChecked(boolean)
	 */
	public void setPartitionChecked(boolean partitionChecked) {
		this.partitionChecked = partitionChecked;

	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.DataDrivenInvoking#lightweightDataDrivenInvokingRun(java.util.List, int)
	 */
	public boolean lightweightDataDrivenInvokingRun(List inputTuples, int inputPos) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#needSetPartitionCheck()
	 */
	public boolean needSetPartitionCheck() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.SelfPartitionDelimiInvoking#setNeedSetPartitionCheck()
	 */
	public void setNeedSetPartitionCheck() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#run(java.util.List, int)
	 */
	public List run(List inputTuples, int inputPos) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getOutputPositions()
	 */
	public int[][] getOutputPositions() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getOutputPositions(int)
	 */
	public int[] getOutputPositions(int i) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#addInputQueue(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue)
	 */
	public void addInputQueue(XATQueue newInputQueue) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#clearAllTuples()
	 */
	public void clearAllTuples() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
	 */
	public boolean cleanAllAccumulatedTuples() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public boolean matchStates(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
	 */
	public boolean hasUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
	 */
	public boolean recomputeUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
	 */
	public int setStateID(int startID) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#equals(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public boolean equals(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getInputQueue()
	 */
	public XATQueue getInputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getInputQueue(int)
	 */
	public XATQueue getInputQueue(int queueNum) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getInputQueue(java.lang.String)
	 */
	public XATQueue getInputQueue(String queueName) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getInputQueueCount()
	 */
	public int getInputQueueCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getInputQueues()
	 */
	public Iterator getInputQueues() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getNthState(int)
	 */
	public OperatorState getNthState(int n) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getObjectID()
	 */
	public int getObjectID() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getOperatorID()
	 */
	public int getOperatorID() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getOutputQueue()
	 */
	public XATQueue getOutputQueue() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getOutputQueueCount()
	 */
	public int getOutputQueueCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getOutputQueues()
	 */
	public Iterator getOutputQueues() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getState()
	 */
	public OperatorState[] getState() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getStateSize()
	 */
	public int getStateSize() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasState()
	 */
	public boolean hasState() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#init()
	 */
	public void init() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#isActive()
	 */
	public boolean isActive() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#isBoxOperator()
	 */
	public boolean isBoxOperator() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#isOldBoxLeaf()
	 */
	public boolean isOldBoxLeaf() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#isRunning()
	 */
	public boolean isRunning() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#replaceInputQueue(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue)
	 */
	public void replaceInputQueue(XATQueue existingQueue, XATQueue newQueue) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#run()
	 */
	public boolean run() throws Exception {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setActive(boolean)
	 */
	public void setActive(boolean active) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setAsNewBoxRoot()
	 */
	public void setAsNewBoxRoot() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setAsOldBoxLeaf()
	 */
	public void setAsOldBoxLeaf() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setAsOldBoxRoot()
	 */
	public void setAsOldBoxRoot() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setAsOldOperator()
	 */
	public void setAsOldOperator() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setBoxOperator(boolean)
	 */
	public void setBoxOperator(boolean isboxop) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setDebug(boolean)
	 */
	public void setDebug(boolean debug) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setInputQueue(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue)
	 */
	public void setInputQueue(XATQueue newInputQueue) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setNthState(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState, int)
	 */
	public void setNthState(OperatorState state, int n) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setNumberOfPossibleOutputs()
	 */
	public void setNumberOfPossibleOutputs() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setOperatorID(int)
	 */
	public void setOperatorID(int id) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setOutputQueue(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue)
	 */
	public void setOutputQueue(XATQueue newOutputQueue) throws XATQueueException {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setRunning(boolean)
	 */
	public void setRunning(boolean running) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setState(edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState[])
	 */
	public void setState(OperatorState[] state) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toShortString()
	 */
	public String toShortString() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setOutputPositions(int, int[])
	 */
	public void setOutputPositions(int i, int[] ithOutputPositions) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setOutputPositions(int[][])
	 */
	public void setOutputPositions(int[][] newOutputPositions) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#clone()
	 */
	public Object clone() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getNode()
	 */
	public XATNode getNode() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getOutput()
	 */
	public XATTable getOutput() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getOutputColumnName()
	 */
	public String getOutputColumnName() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getOutputDataSource()
	 */
	public XATDataSource getOutputDataSource() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getOutputDataSources()
	 */
	public Iterator getOutputDataSources() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getPrimaryDataSource()
	 */
	public XATDataSource getPrimaryDataSource() throws XATNodeDoesNotExistException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#getPrimarySource()
	 */
	public XATTable getPrimarySource() throws XATNodeDoesNotExistException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#setNode(edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode)
	 */
	public void setNode(XATNode newNode) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#setOutput(edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataSource)
	 */
	public void setOutput(XATDataSource newoutput) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator#setOutputColumnName(java.lang.String)
	 */
	public void setOutputColumnName(String OutputColumnName) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject#getStatistics()
	 */
	public Enumeration getStatistics() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject#isValidStatistic(java.lang.String)
	 */
	public boolean isValidStatistic(String nameToCheck) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATProperties#getProperties()
	 */
	public Enumeration getProperties() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATProperties#getProperty(java.lang.String)
	 */
	public String getProperty(String name) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATProperties#isValidPropertyName(java.lang.String)
	 */
	public boolean isValidPropertyName(String nameToCheck) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATProperties#setProperty(java.lang.String, java.lang.String)
	 */
	public void setProperty(String name, String value) throws Exception {
		// TODO Auto-generated method stub
		
	}
	

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#getTimeKeeper()
	 */
	public ClassExecTimeKeeper getTimeKeeper() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream#setUpCellNum()
	 */
	public void setUpCellNum() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#getAllInvokingModes()
	 */
	public AllInvokingModeImp getAllInvokingModes() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#resetOutputPositions()
	 */
	public void resetOutputPositions() {
		// TODO Auto-generated method stub
		
	}
	public void runPushStackWithRecur(int tokenId, int startTokenId)
	{
		
	}
	public void runPopStackWithRecur(int tokenId, int startTokenId){
	
	}

	
}
