package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.AllInvokingModeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.LightElement;

import org.w3c.dom.*;
import java.util.*;

/**
 * Creation date: (1/13/2003 3:32:51 PM)
 * @author: Hong Su
 */
abstract public class NavigateStreamImp  
	extends XATSingleQueueStreamOperatorImp
	implements NavigateStream {      

	protected AllInvokingModeImp allInvokingModes;
	protected NavigationStep[] dest;
	protected NavigationStep[] entry;
	
	protected boolean partitionChecked = false;
	boolean needSetPartitionCheck = false;

	//the entry point column's postition
	protected int entryColPos = -1;
		
	protected List branchEvalOrder;
	
	int outputCount =0;	

	//if the destination does not appear in the outputschema, we do not have to
	// create new tuple
	private int createNewTuple = -1;	

	protected ClassExecTimeKeeper timeKeeper;
	
	
	

	/**
	 * NavigateStreamImp constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public NavigateStreamImp(XATNode node) {
		super(node);
		allInvokingModes = new AllInvokingModeImp(this);
	}

	/**
	 * Creation date: (1/15/2003 10:46:27 PM)
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 * @param ep edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigationStep[]
	 * @param d edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigationStep[]
	 */
	public NavigateStreamImp(
		XATNode node,
		NavigationStep[] ep,
		NavigationStep[] d) {
		super(node);
		entry = ep;
		dest = d;
		allInvokingModes = new AllInvokingModeImp(this);
	}
		
	public AllInvokingModeImp getAllInvokingModes(){
		return allInvokingModes;
		
	}
	
	public boolean getPartitionChecked(){
		return partitionChecked;
	}
	
	public void setPartitionChecked(boolean partitionChecked){
		this.partitionChecked = partitionChecked;
	}
	
	public boolean selfPartitionDelimiInvokingRun(List partitionStates,
			SuspensionEdge suspendComp){
		return 
		allInvokingModes.selfPartitionDelimiInvokingRunForExtract(
			partitionStates,
			suspendComp);
	}
	
    public boolean needSetPartitionCheck(){
    	return needSetPartitionCheck;
    }
    public void setNeedSetPartitionCheck(){
    	needSetPartitionCheck = true;
    }

	protected List follow(Node source, NavigationStep[] destination) {
		
		List result = new ArrayList();
		result.add(source);
		
		int length = destination.length;

		// Let's iterate through the destination path.
//		 Let's iterate through the destination path.
		for (int i = 0; i < destination.length; i++) {
			NavigationStep curStep = destination[i];
			result = followStep(result, destination[i], destination, i);
			if (curStep instanceof DescendantStep)
				//because it has already been handled by followStep
				break;
		}
						
		return result;
	}

	/**
	* Navigate from either a node or a collection, and return a Vector.
	* So far, we cannot handle the case of descendant.
	*/
	protected List followOne(Node node, NavigationStep step) {
		List result = new ArrayList();

		if (node instanceof Text) { // it's a text node.
			if (step instanceof TextStep) // it's a text step.
				result.add(node.getNodeValue());
		} else if (node instanceof Element) {
			if (step instanceof NodeStep) { // it's a node.
				String sStepValue = step.getStepValue();
			
				List nlList = ((LightElement) node).getChildList();
				int childLength = nlList.size();
				
				timeKeeper.increDeltaStartTokenCount(childLength);

				for (int j = 0; j < childLength; j++) {
					Node curNode = (Node)nlList.get(j);
					String sNodeName = curNode.getNodeName();
					if (sStepValue.equals(sNodeName))
						result.add(curNode);
					else if (sStepValue.equals("*")) // if that's the any match.
						result.add(curNode);
				}
			} /*else if (step instanceof AttStep) { // it's an attribute.
				String sStepValue = step.getStepValue();
				String sAttTest = sStepValue; //.substring(1);
				NamedNodeMap nmList = ((Element) node).getAttributes();
				int nmListLength = nmList.getLength();
				
				for (int j = 0; j < nmListLength; j++) {
					Node curNode = nmList.item(j);
					String sAttName = curNode.getNodeName();
					if (sAttTest.equals("*")) // if that's any node.
						result.add(curNode.getNodeValue());
					else if (sAttTest.equals(sAttName))
						result.add(curNode.getNodeValue());
				}
			}*/ else if (step instanceof TextStep) { // it's a text step.

				String resultString = "";
				List nlList = ((LightElement) node).getChildList();
				int size = nlList.size();
				for (int j = 0; j < size; j++) {
					Node curNode = (Node)nlList.get(j);
					String sNodeName = curNode.getNodeName();
					if (sNodeName.equals("#text"))
						resultString += curNode.getNodeValue();
					else {
						//sNodeName is an intermediate tag, not text data yet
						//recursively apply finding text descendants
						//the vector can only contain one item since all descendants are coalesced to one
						resultString
							+= (String) followOne(curNode, step).get(0);
					}
				}
				// get its texted typed child.
				result.add(resultString);
			} /*else if (
			//cannot be descSte[
				step instanceof DescendantStep) { // it's a descendant step.
				// get all the elements include itself.

				result.addAll(getAllDescNodes((Element)node));
				
				
			}*/ else {
				System.err.println(
					"followOne:Sorry, this type ("
						+ step.getClass().getName()
						+ ") of NavigationStep is not handled.");
			}
		} /*else if (node instanceof Attr) {
			if (step instanceof TextStep) // it's a text step.
				result.add(((Attr) node).getValue());
		} else if (node instanceof Node) { // Node of text or other stuff.

			if (step instanceof TextStep) // it's a text step.
				result.add(((Text) node).getData());
		} else if (node instanceof List) { // if that's a collection

			List collection = (List) node;
			for (int j = 0; j < collection.size(); j++) {
				// make it a datavalue.
				XATKeyDataValue data = new XATKeyDataValue(collection.get(j));
				// follow it again.
				result.addAll(followOne(data.convertToDOM(), step));
			}
		} */else {
			System.err.println(
				"followOne:Sorry, this type ("
					+ node.getClass().getName()
					+ ") of value ("
					+ node.toString()
					+ ") is not handled.");
		}

		return result;
	}
	
	/*
	 * @param node
	 * @param NavigationStep[] steps
	 * @param int start the pos of the first step after the desc step
	 * 
	 */
	private List followDescStep(Node node, NavigationStep[] steps, int start){
		List result = new ArrayList();
		
		NavigationStep[] newSteps = new NavigationStep[steps.length-start];
		int j=0;
		for (int i=start; i<steps.length; i++){
			newSteps[i] = steps[i];
		}
			
     	List childList = ((LightElement) node).getChildList();
		int childListLength =childList.size();
		timeKeeper.increDeltaStartTokenCount(childListLength);
		for (int k = 0; k < childListLength; k++) {
			Node  curNode = (Node)childList.get(k);
			if (curNode instanceof Element){
			 result.addAll(follow(curNode, newSteps));
			 result.addAll(followDescStep(curNode, steps, start));
			}
		}
		
		return result;
	}

	/**
	 * Follow one step.
	 * @param source The vector contains the nodes to be navigated from.
	 * @param step The navigation step. Justin only implements the NavigationStepImp
	 * @return a vector of destination nodes of type Node.
	 */
	private List followStep(List source, NavigationStep step, NavigationStep[] steps, int start) {
		List output = new ArrayList();
		
		int size = source.size();
		
		if (step instanceof DescendantStep)
			for (int i=0; i<size; i++) {
				Node node = (Node)source.get(i);
				
				output.addAll(followDescStep(node, steps, start+1));
			}
		else
		//iterate through the source.
		for (int i=0; i<size; i++) {
			Node node = (Node)source.get(i);
			
			output.addAll(followOne(node, step));
		}
		return output;
	}
	
	private List getAllDescNodes(Element elm){
		List result = new ArrayList();
		result.add(elm);
		List nlList = ((LightElement) elm).getChildList();
		int nlListLength = nlList.size();
		for (int j = 0; j < nlListLength; j++) {
			Node  child = (Node)nlList.get(j);
			if (child instanceof Element)
			result.addAll(getAllDescNodes((Element)child));
		}
		
		return result;
		
	}

	/**
	 * getBinding method comment.
	 */
	public String getBinding() {
		return getOutputColumnName();
	}

	/**
		 * setBinding method comment.
		 */
	public void setBinding(String bind) {
		setOutputColumnName(bind);
	}

	/**
	 * getDestination method comment.
	 */
	public NavigationStep[] getDestination() {
		return dest;
	}

	/** @return NavigationStep entry point*/
	public NavigationStep[] getEntryPoint() {
		return entry;
	}

	/**
	 * printNode method comment.
	 */
	public String printNode() {
		StringBuffer sb = new StringBuffer();
		sb.append("Navigate Node: \n  entry: ");
		for (int i = 0; i < entry.length; i++)
			sb.append(entry[i].getStepValue() + " ");
		sb.append("\n destination: ");
		for (int j = 0; j < dest.length; j++)
			sb.append(dest[j].getStepValue() + " ");
		sb.append("\n binding: " + getOutputColumnName());
		return sb.toString();
	}

	/**
	 * setDestination method comment.
	 */
	public void setDestination(NavigationStep[] destination) {
		dest = destination;
	}

	/**
	    * Set Entry Point. It will traverse the DOM tree to evaluate the XPath.
	    * @param ept New entry point for this navigation operator.
	    */
	public void setEntryPoint(NavigationStep[] ept) {
		entry = ept;
	}

	/**
	 * get the position of the entry point in the tuple
	 * so that we can navigate into it
	 * @return int
	 */
	protected int getEntryColPos() {
		if (entryColPos == -1) {
			//not set yet
			String colName = getEntryPoint()[0].getStepValue();
			entryColPos = getInputQueue().getSchema().getPos(colName);
		}

		return entryColPos;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		return null;
	}

	/**
	 * Creation date: (2/12/2003 4:55:40 PM)
	 * @return java.lang.String
	 */
	public String toString() {
		String rs = new String();

		if (this instanceof ExtractByCollectionStream) {
			rs = rs + "ExtractByCollection:";
			if (((ExtractStream) this).isCompleteTree())
				rs = rs + "C";
			if (((ExtractStream) this).isTypedValue())
				rs = rs + "T";
			if (((ExtractStream) this).isNodeId())
				rs = rs + "N";
			if (((ExtractStream) this).isDom())
				rs = rs + "D";
			if (((ExtractStream) this).isAttrs())
				rs = rs + "A";
		} else {
			if (this instanceof ExtractByUnnestStream) {
				rs = rs + "ExtractByUnnest:";
				if (((ExtractStream) this).isCompleteTree())
					rs = rs + "C";
				if (((ExtractStream) this).isTypedValue())
					rs = rs + "T";
				if (((ExtractStream) this).isNodeId())
					rs = rs + "N";
				if (((ExtractStream) this).isDom())
					rs = rs + "D";
				if (((ExtractStream) this).isAttrs())
					rs = rs + "A";
			} else {
				if (this instanceof PureNavigateAutoStream) {
					rs = rs + "PureNavigateAuto:";

				} else {
					if (this instanceof OuterExtractByCollectionStream) {
						rs = rs + "OuterExtractByCollectionStream:";
						if (((ExtractStream) this).isCompleteTree())
							rs = rs + "C";
						if (((ExtractStream) this).isTypedValue())
							rs = rs + "T";
						if (((ExtractStream) this).isNodeId())
							rs = rs + "N";
						if (((ExtractStream) this).isDom())
							rs = rs + "D";
						if (((ExtractStream) this).isAttrs())
							rs = rs + "A";
					} else {

						if (this instanceof NavCollectionStream) {
							rs = rs + "NavCollectionStream:";
						} else {
							if (this instanceof NavUnnestStream) {
								rs = rs + "NavUnnestStream:";
							}
						}
					}
				}
			}
		}

		if (!(getEntryPoint() == null)) {

			//	rs = rs + " entry: ";
			for (int i = 0; i < getEntryPoint().length; i++) {
				rs = rs + getEntryPoint()[i];
			}
			rs = rs + "/";
		}

		if (!(getDestination() == null)) {
			//	rs = rs + " dest: ";
			for (int i = 0; i < getDestination().length; i++) {
				if (i > 0
					&& getDestination()[i] instanceof NodeStep
					&& !(getDestination()[i - 1] instanceof DescendantStep))
					rs = rs + "/" + getDestination()[i];
				else
					rs = rs + getDestination()[i];
			}
		}

		if (!(this instanceof PureNavigateAutoStream)) {
			//PureNavigateAutoStream operator does not have any physical queues or schema associated with it
			rs = rs + " with schema: ";

			if (!(outputQueue == null)) {

				for (int i = 0; i < outputQueue.size(); i++) {
					XATQueue queue = (XATQueue) outputQueue.get(i);

					if (queue != null) {

						XATQueueSchema schema = queue.getSchema();
						if (schema != null) {
							Vector v = schema.getColNames();

							for (int j = 0; j < v.size(); j++) {
								rs = rs + (String) v.get(j);
							}
						}
					}
				}
			}

			rs = rs + "->" + getOutputColumnName();

			//if (getProperty("OUTPUT_TUPLE_GRANULARITY").equals(SUB_TUPLE))
			//	rs = rs + " *subtuple output queue";
		}

		return rs;
	}
	
	/**
	 * output tuples of an operator A implementing this interface are passed as parameters  
	 * to the parent operator B, therefore B does not need to fetch from the queue
	 * this is a pipeling manner in the sense that all intermediate data is directly passed
	 * to be consumed rather than stored (neither in second storage nor memory)
	  
	 * Creation date: (5/8/2003 5:09:38 PM)
	 */
	public boolean dataDrivenInvokingRun(
		List inputTuples,
		int inputPos) {
		return allInvokingModes.dataDrivenInvokingRun(inputTuples, inputPos);
	}
	
	public boolean lightweightDataDrivenInvokingRun(
			List inputTuples,
			int inputPos) {
			return allInvokingModes.lightweightDataDrivenInvokingRun(inputTuples, inputPos);
		}

	public List[] demandDrivenInvokingRun(){
		return allInvokingModes.demandDrivenInvokingRun();
	}
	
	public List getBranchEvalOrder(){
		return branchEvalOrder;
	}
	
	public void setBranchEvalOrder(List branchEvalOrder){
		this.branchEvalOrder = branchEvalOrder;
	}
	
	protected int getCreateNewTuple() {
		if (createNewTuple == -1) {
			XATQueueSchema schema = getOutputQueue().getSchema();
			if (schema.getColNames().contains(
					getOutputColumnName()) && schema.getLength()==getInputQueue().getSchema().getLength()) {
				createNewTuple = 1;
			} else
				createNewTuple = 0;
		}

		return createNewTuple;
	}
	
	// changes to Hong's code on /8/18/05 by Mingzhu
	public NavigationStep[] getDest()
	{
		return dest;
	
	}
}
