package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.AllInvokingModeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.DataDrivenInvoking;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.DemandDrivenInvoking;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.Finer_StreamStoreMgr;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.LightElement;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.XATKeyDataValue;

import java.util.*;

/**
 * Creation date: (2/1/2003 10:10:43 AM)
 * 
 * @author: Luping Ding
 */
public class TaggerStream extends XATSingleQueueStreamOperatorImp implements
		Tagger, DataDrivenInvoking, DemandDrivenInvoking, XATStreamOpRunCore {

	protected Pattern pTgPattern;

	protected AllInvokingModeImp allInvokingModes;

	protected ClassExecTimeKeeper timeKeeper;

	protected int nonEmptyCount = 0;

	protected long overallTime = 0;

	private Finer_StreamStoreMgr storeMgr;

	private List result = new ArrayList();

	List branchEvalOrder = new ArrayList();

	public TaggerStream(DagNode node) {
		super(node);
		allInvokingModes = new AllInvokingModeImp(this);
		timeKeeper = new ClassExecTimeKeeper(this);
	}

	public TaggerStream(DagNode parent, Pattern pnodInit) {
		super(parent);
		pTgPattern = pnodInit;
		allInvokingModes = new AllInvokingModeImp(this);
		timeKeeper = new ClassExecTimeKeeper(this);
	}

	public AllInvokingModeImp getAllInvokingModes() {
		return allInvokingModes;
	}

	public ClassExecTimeKeeper getTimeKeeper() {
		return timeKeeper;
	}

	public Pattern getPattern() {
		return pTgPattern;
	}

	/**
	 * Runs the actual operator.
	 * 
	 * Unlike in Rainbow, the Stream operators have the implementation tied to
	 * the operator because the StreamOperators represent physical operators
	 * instead of Logic. Creation date: (2/1/2003 10:10:43 AM)
	 */
	public boolean run() throws Exception {
		allInvokingModes.run();

		return true;
	}

	public void setPattern(Pattern new_pattern) {
		pTgPattern = new_pattern;
	}

	public String toString() {

		String returnString = null;

		returnString = "TaggerStream";
		// DOMPattern tagTree = (DOMPattern) this.getPattern();
		// sreturnString = returnString + getPattern().toString();
		returnString = returnString + "output col: "
				+ this.getOutputColumnName();

		return returnString;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperatorImp#init()
	 */
	public void init() {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.DataDrivenInvoking#dataDrivenInvokingRun(java.util.List,
	 *      int)
	 */
	public boolean dataDrivenInvokingRun(List inputTuples, int inputPos) {
		return allInvokingModes.dataDrivenInvokingRun(inputTuples, inputPos);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSingleQStreamOpRunCore#run(java.util.List)
	 */
	public List run(List inputTuples, int inputPos) {
		// timeKeeper.start();
		// result.clear();
		// pTgPattern.

		// System.out.println(inputTuples.size());

		if (inputTuples == null) {
			// This would be the case if current
			// operation wasn't pipelining the operators.
			int howMany = Integer.parseInt(this
					.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
			inputTuples = getInputQueue().dequeueN(howMany, this);
		}

		Vector origTmpl = new Vector();
		/*
		 * // When does this scenario occur? if (getPattern() instanceof
		 * ListPattern) { origTmpl = ((ListPattern) getPattern()).getList(); } //
		 */
		// Grab the output pattern of the tuples
		if (getPattern() instanceof DOMPattern) {
			ListPattern lp = ((DOMPattern) getPattern())
					.toListPattern(((DOMPattern) getPattern()).getRoot());
			origTmpl = lp.getList();
		}

		// Vector template = new Vector(origTmpl.size());
		// colLoc will need to become a list later to support multiple colums in
		// a result
//		int colLoc = 0;
		List colLoc = new ArrayList();
		for (int i = 0; i < origTmpl.size(); i++) {
			Object el = origTmpl.elementAt(i);
			if (el instanceof String) {
				// template.add(el);
				continue;
			} else if (el instanceof ColumnName) {
				String name = ((ColumnName) el).getColumnName();
				int pos = -1;
				try{
					pos = getInputQueue().getSchema().getPos(name);
				}catch (Exception e){
					continue;
				}
				// template.add(new Integer(pos));
				origTmpl.setElementAt(new Integer(pos), i);
				colLoc.add(new Integer(i));
			} else
				throw new RuntimeException("invalid list element "
						+ el.toString());
		}

		/*
		 * A very basic collection method, I just store the XATDataValues result
		 * to keep efficiency up. XATDataValue.toString involves a decent amount
		 * of String manipulation, which could slow the tagger if results aren't
		 * going to be printed.
		 */
		for (int j = 0; j < inputTuples.size(); j++) {
			// int[] outputPos = getOutputPositions()[0];
			XATDataValue[] cells = ((XATTupleImp) inputTuples.get(j))
					.getArrayData();
			Vector res = new Vector(origTmpl);
			for(int k = 0; k < colLoc.size(); k++){
				Integer itemp = (Integer)colLoc.get(k);
				int colTemp = itemp.intValue();
				int temp = ((Integer) res.get(colTemp)).intValue();
				res.set(colTemp, cells[temp]);				
			}
			result.add(res);
		}

		/*
		 * for (int j = 0; j < inputTuples.size(); j++) {
		 * 
		 * int[] outputPos = getOutputPositions()[0];
		 * 
		 * //1 is for the newly generated taggered data XATDataValue[] newData =
		 * new XATDataValue[outputPos.length + 1];
		 * 
		 * XATTuple t = (XATTuple) inputTuples.get(j);
		 * 
		 * StringBuffer value = new StringBuffer();
		 * 
		 * for (Enumeration e = template.elements(); e.hasMoreElements();) {
		 * Object o = e.nextElement(); if (o instanceof String)
		 * value.append((String) o); else value.append( t.getCell(((Integer)
		 * o).intValue()).convertToString());
		 *  }
		 * 
		 * ((XATTupleImp) t).fillDataInListTo(newData, outputPos, 0);
		 * 
		 * newData[outputPos.length] = new XATDataValueImp(value.toString());
		 * 
		 * result.add(new XATTupleImp(newData));
		 * 
		 * System.out.println(new XATTupleImp(newData));
		 *  } //
		 */

		// timeKeeper.pause();
		timeKeeper.increOutputCount(inputTuples.size());

		return result;
	}

	/*
	 * tagger is not stateful
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATSingleQStreamOpRunCore#runWithBlockingInputs(java.util.List)
	 */
	public List runWithBlockingInputs(List[] inputTuples, int inputPos) {
		// TODO Auto-generated method stub
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.AutomataEnabled#cleanTemp()
	 */
	public void cleanTemp() {
		getOutputQueue().removeAllTuples();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
	 */
	public boolean cleanAllAccumulatedTuples() {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public boolean matchStates(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
	 */
	public boolean hasUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
	 */
	public boolean recomputeUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
	 */
	public int setStateID(int startID) {
		// TODO Auto-generated method stub
		return 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.DataDrivenInvoking#lightweightDataDrivenInvokingRun(java.util.List,
	 *      int)
	 */
	public boolean lightweightDataDrivenInvokingRun(List inputTuples,
			int inputPos) {

		return allInvokingModes.lightweightDataDrivenInvokingRun(inputTuples,
				inputPos);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#getOverallTime()
	 */
	public long getOverallTime() {
		return overallTime;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore#increOverallTime(long)
	 */
	public void increOverallTime(long newTime) {
		overallTime = overallTime + newTime;

	}

	public int getNonEmptyCount() {
		return nonEmptyCount;
	}

	public List[] demandDrivenInvokingRun() {
		return allInvokingModes.demandDrivenInvokingRun();
	}

	public List getBranchEvalOrder() {
		return branchEvalOrder;
	}

	public void setBranchEvalOrder(List branchEvalOrder) {
		this.branchEvalOrder = branchEvalOrder;

	}

	public List[] demandDrivenInvokingRunWithOrder() {
		return allInvokingModes.demandDrivenInvokingRunWithOrder();
	}

	public int getNumOfResults() {
		return result.size();
	}
	
	/**
	 * Return all of the tuples returned from the query.
	 * 
	 * @return String array of all xml tuples in the result
	 * @throws Exception
	 * @author Drew Ditto
	 */
	public String[] getResults() throws Exception{
		if(result.size() > 1)
			return getResults(0, result.size() - 1);
		else
//			return new String[0];
			return getFirstResult();
	}

	/**
	 * Return requested range of tuples from result.
	 * 
	 * @param start
	 * @param end
	 * @return String array of all xml tuples in the result
	 * @throws Exception
	 * @author Drew Ditto 
	 */
	public String[] getResults(int start, int end) throws Exception{
		if(start >= 0 && end < result.size() && start < end){
			String[] res = new String[(end - start) + 1];
			for(int i = start; i <= end ; i++){
				Vector t = (Vector)result.get(i);				
				res[i - start] = t.toString();
			}		
			return res;
		}else
			throw new Exception("Improper result request range!");
	}
	
	public String[] getFirstResult(){
		String[] res = new String[1];
		if(result.size() > 0){
			Vector t = (Vector)result.get(0); 		
			res[0] = t.toString();
			return res;
		}			
		else
			return new String[0];		
	}
}
