package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

/**
 * Source Operator
 * Creation date: (1/29/2003 11:52:06 AM)
 * @author: Hong Su
 */

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.xml.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.statistics.StatisticsCollector;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.TextFileReader;

import java.io.*;
import java.lang.*;

public class XMLScanStream
	extends XATSingleQueueStreamOperatorImp
	implements XATSingleQueueStreamOperator, Serializable {
	private TokenHandler tokenHandler;
	private boolean srcFinished = false;
	private TokenBuffer tokenBuffer;
	private ClassExecTimeKeeper timeKeeper;
	private ObjectInputStream p;
	private BufferedInputStream b;
	private String sourceName;
	public static int curLevel =0;

	/**
	 * XMLScan constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public XMLScanStream(XATNode node) {
		super(node);
		timeKeeper = new ClassExecTimeKeeper(this);
	}

	public void setSourceName(String sourceName) {
		this.sourceName = sourceName;
	}

	public String getSourceName() {
		return sourceName;
	}

	public TokenHandler getTokenHandler() {
		return tokenHandler;
	}

	/**
	 * associate it with the initial state in the automata
	 * @param auto edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.ExtendedAutomata
	 */
	public void associateWithAuto(ExtendedAutomata auto) {

		ExtendedState s0 = new ExtendedState(auto);
		auto.addIntoStates(s0);
		auto.setRootState(s0);

		auto.addIntoStateHash(this, s0);
	}

	/**
	 * Creation date: (4/16/2003 11:41:26 AM)
	 * @return boolean
	 */
	public boolean isFinished() {
		return srcFinished;
	}

	/**
	 * load p into the buffer with capacity
	 * Creation date: (5/29/2003 1:20:56 PM)
	 * @param p java.io.ObjectInputStream
	 * @param capacity int
	 * @param tokenQueue edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.XATTokenQueue
	 */
	public void loadFrFileToBuffer(ObjectInputStream p, int capacity) {

		try {
			XMLToken token = null;

			for (int i = 0; i < capacity; i++) {
				try {
					token = (XMLToken) p.readObject();
				} catch (EOFException e) {
					//there is no more content,
					break;
				}

				tokenBuffer.addIntoBuffer(token);

			}

			tokenBuffer.setGetPos(0);

			//indicate successfully filling the token queue

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);

		}
	}

	/**
	 * scan over the token sequence in its input queue, if encountering EOF token, set finished flag to be true
	 */
	public boolean run() throws Exception {

		// int howMany = Integer.parseInt(this.getProperty("NUMBER_OF_TUPLES_TO_DEQUEUE"));
		int tagCount = 0;
		
		p = new ObjectInputStream(b);

		XMLToken token = new XMLToken();
		
		boolean firstToken = true;

		while (true) {

			// XMLToken token = new XMLToken();

			//p = new ObjectInputStream(b);	
			//p = new BufferedInputStream(socket.getInputStream());
			//p = new ObjectInputStream(new BufferedInputStream(is));
			try {
				//token = (XMLToken) p.readObject();
				token.readExternal(p);
			} catch (EOFException e) {
				//there is no more content, should not be here anyway, break when EOF is seen
				System.out.println("finished");
				break;
			}

			
			//strLine = new String("Start\n");
			/*String a ="bb";
			String strLine2 = new String(a);
			int i = 0;
			strLine = String.valueOf(i);
			fw.write(strLine2);
			fw.close();*/

			tagCount++;

			/* if (tagCount % 100000 == 0) {
			     System.out.println("processing " + tagCount);
			     if (tagCount % 3000000 == 0) {
			
			         //  if (tagCount % 100000 == 0)
			
			         p = new ObjectInputStream(b);
			     }
			 }*/

	/*		if (tagCount % 1000000 == 0) {

				//  if (tagCount % 100000 == 0)

				System.out.println("processing " + tagCount);
				
				//revisit: comment out for reading from local file instead of sockets
				p = new ObjectInputStream(b);
			}*/
			//	System.out.println("processing " + tagCount);
			
			
			
			/*if (firstToken) {
					//the beginning of the document
					firstToken = false;
					tokenHandler.automata.reset();
					tokenHandler.storeMgr.createDocument("temp");
				}*/
			timeKeeper.start();
			switch (token.getType()) {
				
				case XMLToken.OPEN :
					//timeKeeper.start();
					curLevel ++;
					tokenHandler.startElement(  
						token.getVal(), tagCount);
					//timeKeeper.pause();
					break;
				case XMLToken.CLOSE :
					//timeKeeper.start();
											
					tokenHandler.endElement(tagCount, 0);
				
					curLevel--;
					//timeKeeper.pause();
					break;

				case XMLToken.PCDATA :
					//timeKeeper.start();
					tokenHandler.characters(token.getVal());
					//timeKeeper.pause();
					break;
				case XMLToken.EOF :
				  //  timeKeeper.pause();
					FileWriter fw;
					try {
						fw = new FileWriter("1.txt", true);
						fw.write("joinT:");
						fw.write(String.valueOf(tokenHandler.automata.timeSum));
						fw.write("\n");
						fw.close();
					} catch (Exception e) {
						e.printStackTrace() ;
					}
					
					tokenHandler.reset();
					setFinished(true);
					System.out.println("eof");
					timeKeeper.pause();
					return true;
			}
			timeKeeper.pause();
			
			

		} //end of while
		
		

		return true;

	}
	
	/**
	 * scan over the token sequence in its input queue, if encountering EOF token, set finished flag to be true
	 * @int bottommostDestCount the count of the destination element of the bottommost tokenNav
	 * this run is invoked when run-time statistics are needed to be gathered
	 */
	public boolean run(int desiredBottomDestCount) throws Exception {

		int tagCount = 0;

		p = new ObjectInputStream(b);

		XMLToken token = new XMLToken();
		
		boolean firstToken = true;

		while (true) {

			// XMLToken token = new XMLToken();

			//p = new ObjectInputStream(b);	
			//p = new BufferedInputStream(socket.getInputStream());
			//p = new ObjectInputStream(new BufferedInputStream(is));
			try {
				//token = (XMLToken) p.readObject();
				token.readExternal(p);
			} catch (EOFException e) {
				//there is no more content, should not be here anyway, break when EOF is seen
				System.out.println("finished");
				break;
			}

			tagCount++;

			if (tagCount % 1000000 == 0) {

				System.out.println("processing " + tagCount);

				//revisit: comment out for reading from local file instead of sockets
				p = new ObjectInputStream(b);
			}
			
			timeKeeper.start();
			switch (token.getType()) {
				
				case XMLToken.OPEN :
					//timeKeeper.start();
					tokenHandler.startElement(  
						token.getVal(), tagCount);
					//timeKeeper.pause();
					break;
				case XMLToken.CLOSE :
					//timeKeeper.start();
											
					tokenHandler.endElement(tagCount, desiredBottomDestCount);
					//timeKeeper.pause();
					break;

				case XMLToken.PCDATA :
					//timeKeeper.start();
					tokenHandler.characters(token.getVal());
					//timeKeeper.pause();
					break;
				case XMLToken.EOF :
				  //  timeKeeper.pause();
					StatisticsCollector.getBottomTokenNavTokenNum(tokenHandler.automata);
					tokenHandler.reset();
					setFinished(true);
					FileWriter fw;
					try {
						fw = new FileWriter("1.txt", true);
						fw.write("eTime:");
						fw.write(String.valueOf(System.currentTimeMillis()));
						fw.write("\n");
						fw.close();
					} catch (Exception e) {
						e.printStackTrace() ;
					}
					System.out.println("eof");
					System.out.println(tagCount + " tokens\n");
					timeKeeper.pause();
					return true;
			}
			timeKeeper.pause();		

		} //end of while
		
		
		return true;

	}

	/**
	 * Creation date: (5/29/2003 4:09:32 PM)
	 * @param newP java.io.ObjectInputStream
	 */
	public void setB(BufferedInputStream newB) {
		b = newB;
	}

	/**
	 * Creation date: (4/16/2003 11:41:26 AM)
	 * @param newFinished boolean
	 */
	public void setFinished(boolean newFinished) {
		srcFinished = newFinished;
	}

	/**
	 * Creation date: (4/23/2003 5:20:26 PM)
	 * @param newTokenHandler edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.TokenHandler
	 */
	public void setTokenHandler(TokenHandler newTokenHandler) {
		tokenHandler = newTokenHandler;
	}

	/**
	 * Creation date: (4/23/2003 5:24:07 PM)
	 */

	public String toString() {
		return "XMLScanStream";
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperatorImp#init()
	 */
	public void init() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
	 */
	public boolean cleanAccumulatedTuples(long maxtimestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
	 */
	public boolean cleanAllAccumulatedTuples() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
	 */
	public boolean matchStates(XATStreamOperator op) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
	 */
	public boolean hasUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
	 */
	public boolean recomputeUnmatchedState() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
	 */
	public int setStateID(int startID) {
		// TODO Auto-generated method stub
		return 0;
	}

	public ClassExecTimeKeeper getTimeKeeper() {
		return timeKeeper;
	}
}
