/*
 * Created on Jun 20, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.punctuationstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import java.util.Vector;
import java.io.BufferedWriter;
import java.io.FileWriter;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WSingleEquiJoinOperatorImp extends PWSingleEquiJoinOperatorImp {

	public WSingleEquiJoinOperatorImp(XATNode init) {
		super(init);
	}

	public boolean run() throws Exception {
		
		int numQueues = this.getInputQueueCount();
		//check the schema of the input queues
		for (int i=0; i<numQueues; i++) {
			if (this.getNthInputQueue(0).getSchema() == null) {
				return false;
			}
		}
		//initialize schema of the output queue 
		if (this.getOutputQueue().getSchema() == null) {
			init();
		}

		//keep track of operator starting time
		long currentTime = System.currentTimeMillis();
		try {
			bufferWriter = new BufferedWriter(new FileWriter("execution_time_track.txt", true));
			bufferWriter.write("\n"+currentTime+" ");
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		//initialize nextTupleTimeArray and streamIndexArray
		nextTupleTimeArray = new Vector();
		streamIndexArray = new Vector();
		
		for (int i=0; i<numQueues; i++) {
			XATQueue queue = this.getNthInputQueue(i);
			
			// initialize nextTupleTimeArray and streamIndexArray
			long nextTupleTime = 0;
			try {
				nextTupleTime = queue.peek(this).getMinTimeStamp();
			} catch(Exception e) {
				nextTupleTimeArray.add(new Long(Long.MAX_VALUE));
				streamIndexArray.add(new Integer(i));
				continue;
			}
			int vLength = nextTupleTimeArray.size();
			boolean inserted = false;
			for (int j=0; j<vLength; j++) {
				if (nextTupleTime < ((Long)nextTupleTimeArray.get(j)).longValue()) {
					nextTupleTimeArray.insertElementAt(new Long(nextTupleTime), j);
					streamIndexArray.insertElementAt(new Integer(i), j);
					inserted = true;
					break;
				}
			}
			if (!inserted) {
				nextTupleTimeArray.add(new Long(nextTupleTime));
				streamIndexArray.add(new Integer(i));
			}
		}

		while (true) {
			//check whether all input queues are empty
			if (((Long) nextTupleTimeArray.get(0)).longValue() == Long.MAX_VALUE) {
				bufferWriter.write(System.currentTimeMillis()+"");
				bufferWriter.flush();
				bufferWriter.close();
				return true;
			}
			
			int queueIndex = ((Integer)streamIndexArray.get(0)).intValue();
			
			try {
				XATTuple tuple = this.getNthInputQueue(queueIndex).dequeue(this);
				if (tuple.isPunctuation()) { //a punctuation is received
					//this.joinState.processPunct(tuple, queueIndex);				
				} else { //a tuple is received
					//invalidation
					joinState.purgeByWindow(((Long) nextTupleTimeArray.get(0)).longValue());
					//probe
					XATTuple[] matchTuples = this.joinState.probe(tuple, queueIndex);
					//there are at least 1 result tuple
					if (matchTuples != null) {
						//this.getOutputQueue().enqueue(matchTuples, this);
						
						// for recording experiment data
						totalNumResultTuples += matchTuples.length;
						if (totalNumResultTuples >= resultTupleIncrementCount * resultTupleIncrement) {
							timeVector.add(new Long(System.currentTimeMillis()));
							resultTupleIncrementCount ++;
						}
						
						matchTuples = null;
					}
				}
			} catch(XATQueueException e) {
				bufferWriter.write(System.currentTimeMillis()+" ");
				bufferWriter.flush();
				bufferWriter.close();
				return true;
			}
			
			
			nextTupleTimeArray.remove(0);
			streamIndexArray.remove(0);
			
			long nextTupleTime = 0;
			try {
				nextTupleTime = this.getNthInputQueue(queueIndex).peek(this).getMinTimeStamp();
				int vLength = nextTupleTimeArray.size();
				boolean inserted = false;
				for (int i=0; i<vLength; i++) {
					long timestamp = ((Long) nextTupleTimeArray.get(i)).longValue();
					if (nextTupleTime < timestamp) {
						nextTupleTimeArray.insertElementAt(new Long(nextTupleTime), i);
						streamIndexArray.insertElementAt(new Integer(queueIndex), i);
						inserted = true;
						break;
					} 
				}
				if (!inserted) {
					nextTupleTimeArray.add(new Long(nextTupleTime));
					streamIndexArray.add(new Integer(queueIndex));
				}
			} catch(Exception e) {
				nextTupleTimeArray.add(new Long(Long.MAX_VALUE));
				streamIndexArray.add(new Integer(queueIndex));
			}
		}
	}
}
