package edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression;

import java.util.List;
//import java.util.Vector;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinArithExpression;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinArithExpressionImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class BinArithExpressionStrImp extends ExpressionStrImp implements BinArithExpressionStr {

	ExpressionStr eLeft, eRight;
	int iType;

/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 6:18:20 PM)
 * @param str edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
public BinArithExpressionStrImp() {
	super();
}

public BinArithExpressionStrImp(ExpressionStr left, ExpressionStr right, int type) {
	super();
	eLeft = left;
	eRight = right;
	iType = type;
}

//public BinArithExpressionStrImp(Expression expr) {
//	ExpressionStrImp expressionStrImp = new ExpressionStrImp();
//	
//	eLeft = expressionStrImp.createExpressionStr(((BinArithExpression)expr).getLeft());
//
//	eRight = expressionStrImp.createExpressionStr(((BinArithExpression)expr).getRight());
//
//	iType = ((BinArithExpressionImp)expr).getType();
//
//	 //untrueExpression = (BinArithExpressionStrImp)this.clone();
//	}
//	public BinArithExpressionStrImp(ExpressionStr left, ExpressionStr right) {
//		eLeft = left;
//		eRight = right;
//		//untrueExpression = (BinArithExpressionStrImp)this.clone();
//	}
 /**
	* It will evaluate itself and return the value as an object.
	* Remember, it could be like: Integer, Float, Double, String, Boolean.
	*/
//public java.lang.Object eval(edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper, int[] iPositions) {
//	return null;
//}
	public Object eval(List tuples, XATStreamOperator op) {
		try {
			long lLeft = ((Long) eLeft.eval(tuples, op)).longValue();
			long lRight = ((Long) eRight.eval(tuples, op)).longValue();
			Object oReturn;
			switch (iType) {
				case PLUS :
					oReturn = new Long(lLeft + lRight);
					break;
				case MINUS :
					oReturn = new Long(lLeft - lRight);
					break;
				case MULTIPLE :
					oReturn = new Long(lLeft * lRight);
					break;
				case DIVIDE :
					oReturn = new Double(lLeft / lRight);
					break;
				case MOD :
					oReturn = new Long(lLeft % lRight);
					break;
				default :
					/* fail */
					return null;
			}
			return oReturn;
		} catch (ClassCastException e) {
			try {
				double dLeft = ((Number) eLeft.eval(tuples,op)).doubleValue();
				double dRight = ((Number) eRight.eval(tuples, op)).doubleValue();
				double dReturn;
				switch (iType) {
					case PLUS :
						dReturn = dLeft + dRight;
						break;
					case MINUS :
						dReturn = dLeft - dRight;
						break;
					case MULTIPLE :
						dReturn = dLeft * dRight;
						break;
					case DIVIDE :
						dReturn = dLeft / dRight;
						break;
					case MOD :
						dReturn = dLeft % dRight;
						break;
					default :
						/* fail */
						return null;
				}
				return new Double(dReturn);
			} catch (ClassCastException e2) {
				/* um, fail?  */
				return null;
			}
		}
	}
	public ExpressionStr getLeft() {
		return eLeft;
	}
	public ExpressionStr getRight() {
		return eRight;
	}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:25:52 PM)
 * @return java.util.Vector
 */
//public java.util.Vector getTerminalColumnExprs() {
//	Vector results = new Vector();
//
//	results.addAll(eLeft.getTerminalColumnExprs());
//	results.addAll(eRight.getTerminalColumnExprs());
//	
//	return results;
//}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:25:52 PM)
 * @return java.util.Vector
 */
//public java.util.Vector getTerminalColumnNames() {
//	if (terminalColumnNames == null) {
//		terminalColumnNames = new Vector();
//
//		terminalColumnNames.addAll(eLeft.getTerminalColumnNames());
//		terminalColumnNames.addAll(eRight.getTerminalColumnNames());
//	}
//
//	return terminalColumnNames;
//}
	public int getType() {
		return iType;
	}
	public void setLeft(ExpressionStr left) {
		eLeft = left;
	}
	public void setRight(ExpressionStr right) {
		eRight = right;
	}
	public void setType(int type) {
		iType = type;
	}
/**
 * Insert the method's description here.
 * Creation date: (1/26/2003 8:52:18 PM)
 * @param newUntrueExpression edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
//public void setUntrueExpression(ExpressionStr newUntrueExpression) {
//	untrueExpression = newUntrueExpression;
//}

	public String toString() {
		switch (iType) {
			case PLUS :
				return "(" + eLeft.toString() + " + " + eRight.toString() + ")";
			case MINUS :
				return "(" + eLeft.toString() + " - " + eRight.toString() + ")";
			case MULTIPLE :
				return "(" + eLeft.toString() + " * " + eRight.toString() + ")";
			case DIVIDE :
				return "(" + eLeft.toString() + " / " + eRight.toString() + ")";
			case MOD :
				return "(" + eLeft.toString() + " % " + eRight.toString() + ")";
			default :
				return "("
					+ eLeft.toString()
					+ " Arith("
					+ Integer.toString(iType)
					+ ") "
					+ eRight.toString()
					+ ")";
		}
	}
	
	/**
	 * reset column positions in expression according to the given position mapping.
	 * this method is usually called by optimizer when switching two operators and as a result we
	 * have to reset the column IDs of involving operators' expressions.
	 * 
	 * This method is usually called right before the method "getRelatedSubExpression" in this class.
	 * @param pos
	 * @return
	 */
	public boolean resetColumnPosition(int[][] positionmap) {
  		return false;
	}
    
	/**
	* get the sub-expressions that contains ONLY the given
	* queue position and column positions.
	* the returned expression could be as large as this expression itself, or as small as null.
	* 
	* This method is usually called by the optimizer right after the method "resetColumnPosition" in this class.
	*/
	public ExpressionStr getRelatedSubExpression(int queuepos, int[] columnpos) {
  		return null;
	}
	
	public boolean containColumnPositions(int queuePos, int[] columnPos) {
	  return (eLeft.containColumnPositions(queuePos, columnPos) || eRight.containColumnPositions(queuePos, columnPos));
	 }
}
