package edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression;

/**
* @author Xin Zhang
*/
public interface BinExpressionStr extends ExpressionStr
{
    ExpressionStr getLeft();
    ExpressionStr getRight();
    void setLeft(ExpressionStr left);
    void setRight(ExpressionStr right);
    
    
    /**
     * reset column positions in expression according to the given position mapping.
     * this method is usually called by optimizer when switching two operators and as a result we
     * have to reset the column IDs of involving operators' expressions.
     * 
     * This method is usually called right before the method "getRelatedSubExpression" in this class.
     * @param pos
     * @return
     */
    boolean resetColumnPosition(int[][] positionmap);
    
	/**
	* get the sub-expressions that contains ONLY the given
	* queue position and column positions.
	* the returned expression could be as large as this expression itself, or as small as null.
	* 
	* This method is usually called by the optimizer right after the method "resetColumnPosition" in this class.
	*/
	ExpressionStr getRelatedSubExpression(int queuepos, int[] columnpos);
}
