package edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression;


import java.util.List;
import java.util.Vector;

import org.w3c.dom.Node;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.XMLNodeManipulator;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;


/**
 * Title: Description: Copyright: Copyright (c) 2001 Company:
 * 
 * @author
 * @version 1.0.0.0
 */

public class BinCOMPExpressionStrImp extends ExpressionStrImp implements
		BinCOMPExpressionStr {
	ExpressionStr eLeft, eRight;

	int iType;

	/**
	 * Insert the method's description here. Creation date: (2/4/2003 12:56:05
	 * PM)
	 * 
	 * @param expression
	 *            edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression
	 */
	public BinCOMPExpressionStrImp(Expression expr) {

		ExpressionStrImp expressionStrImp = new ExpressionStrImp();

		eLeft = expressionStrImp.createExpressionStr(((BinCOMPExpression) expr)
				.getLeft());

		eRight = expressionStrImp
				.createExpressionStr(((BinCOMPExpression) expr).getRight());

		iType = ((BinCOMPExpressionImp) expr).getType();

		untrueExpression = (BinCOMPExpressionStrImp) this.clone();

	}

	public BinCOMPExpressionStrImp(ExpressionStr left, ExpressionStr right,
			int type) {
		eLeft = left;
		eRight = right;
		iType = type;
		untrueExpression = (BinCOMPExpressionStrImp) this.clone();

	}

	/**
	 * Insert the method's description here. Creation date: (1/23/2003 10:08:21
	 * PM)
	 * 
	 * @return java.lang.Boolean
	 * @param left
	 *            java.lang.Object
	 * @param right
	 *            java.lang.Object
	 */
	public Boolean compAtomic(Object left, Object right) {
		try {
			String sLeft = null;
			String sRight = null;

			if (right instanceof String) {
				//if (left instanceof XATDataValue){
				if (left instanceof Node) {
					sLeft = XMLNodeManipulator.getStringValue((Node)left);
				} else //if (left instanceof Finer_StreamStoreMgrKey){
					sLeft = left.toString();
				}
				
				if (iType == EQ) {
					return new Boolean(sLeft.equals(right));
				} else if (iType == NEQ)
					return new Boolean(!sLeft.equals(right));
			

			long lLeft = ((Long) left).longValue();
			long lRight = ((Long) right).longValue();
			boolean bReturn;
			switch (iType) {
			case LT:
				bReturn = (lLeft < lRight);
				break;
			case GT:
				bReturn = (lLeft > lRight);
				break;
			case LEQ:
				bReturn = (lLeft <= lRight);
				break;
			case GEQ:
				bReturn = (lLeft >= lRight);
				break;
			case EQ:
				bReturn = (lLeft == lRight);
				break;
			case NEQ:
				bReturn = (lLeft != lRight);
				break;
			default:
				/* fail */
				return Boolean.FALSE;
			}
			return new Boolean(bReturn);
		} catch (ClassCastException e) {
			try {
				double dLeft = ((Number) left).doubleValue();
				double dRight = ((Number) right).doubleValue();
				boolean bReturn;
				switch (iType) {
				case LT:
					bReturn = (dLeft < dRight);
					break;
				case GT:
					bReturn = (dLeft > dRight);
					break;
				case LEQ:
					bReturn = (dLeft <= dRight);
					break;
				case GEQ:
					bReturn = (dLeft >= dRight);
					break;
				case EQ:
					bReturn = (dLeft == dRight);
					break;
				case NEQ:
					bReturn = (dLeft != dRight);
					break;
				default:
					/* fail */
					return Boolean.FALSE;
				}
				return new Boolean(bReturn);
			} catch (ClassCastException e2) {
				String sLeft = left.toString();
				String sRight = right.toString();
				boolean bReturn;
				switch (iType) {
				case LT:
					bReturn = (sLeft.compareTo(sRight) < 0);
					break;
				case GT:
					bReturn = (sLeft.compareTo(sRight) > 0);
					break;
				case LEQ:
					bReturn = (sLeft.compareTo(sRight) <= 0);
					break;
				case GEQ:
					bReturn = (sLeft.compareTo(sRight) >= 0);
					break;
				case EQ:
					bReturn = (sLeft.equals(sRight));
					break;
				case NEQ:
					bReturn = (!sLeft.equals(sRight));
					break;
				default:
					/* fail */
					return Boolean.FALSE;
				}

				return new Boolean(bReturn);
			}
		} catch (NullPointerException e) {
			return Boolean.FALSE;
		}
	}

	/**
	 * It will evaluate itself and return the value as an object. Remember, it
	 * could be like: Integer, Float, Double, String, Boolean.
	 */
	public java.lang.Object eval(
			edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper,
			int[] iPositions) {
		return null;
	}

	// this code is written incorrectly... this need to check for column names
	// and such
	public Object eval(List tuples, XATStreamOperator op) {
		Object lValue = eLeft.eval(tuples, op);
		Object rValue = eRight.eval(tuples, op);
		
		boolean left = false;

		if (!(lValue instanceof List)) {
			return compAtomic(lValue, rValue);
		} else  {
            for (int i=0; i<((List)lValue).size(); i++){
              Boolean comp = compAtomic(((List)lValue).get(i), rValue);
              return comp;
			}
            
		} 
		return Boolean.FALSE;
	}

	public ExpressionStr getLeft() {
		return eLeft;
	}

	public ExpressionStr getRight() {
		return eRight;
	}

	/**
	 * Insert the method's description here. Creation date: (2/17/2003 4:25:52
	 * PM)
	 * 
	 * @return java.util.Vector
	 */
	public java.util.Vector getTerminalColumnExprs() {
		Vector results = new Vector();

		results.addAll(eLeft.getTerminalColumnExprs());
		results.addAll(eRight.getTerminalColumnExprs());

		return results;
	}

	/**
	 * Insert the method's description here. Creation date: (2/17/2003 4:25:52
	 * PM)
	 * 
	 * @return java.util.Vector
	 */
	public java.util.Vector getTerminalColumnNames() {
		if (terminalColumnNames == null) {
			terminalColumnNames = new Vector();

			terminalColumnNames.addAll(eLeft.getTerminalColumnNames());
			terminalColumnNames.addAll(eRight.getTerminalColumnNames());
		}

		return terminalColumnNames;

	}

	public int getType() {
		return iType;
	}

	public void setLeft(ExpressionStr left) {
		eLeft = left;
	}

	public void setRight(ExpressionStr right) {
		eRight = right;
	}

	public void setType(int type) {
		iType = type;
	}

	/**
	 * Insert the method's description here. Creation date: (1/26/2003 8:51:26
	 * PM)
	 * 
	 * @param newUntrueExpression
	 *            edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
	 */
	public void setUntrueExpression(ExpressionStr newUntrueExpression) {
		untrueExpression = newUntrueExpression;
	}

	public String toString() {
		switch (iType) {
		case LT:
			return "(" + eLeft.toString() + " < " + eRight.toString() + ")";
		case GT:
			return "(" + eLeft.toString() + " > " + eRight.toString() + ")";
		case LEQ:
			return "(" + eLeft.toString() + " <= " + eRight.toString() + ")";
		case GEQ:
			return "(" + eLeft.toString() + " >= " + eRight.toString() + ")";
		case EQ:
			return "(" + eLeft.toString() + " == " + eRight.toString() + ")";
		case NEQ:
			return "(" + eLeft.toString() + " != " + eRight.toString() + ")";
		default:
			return "(" + eLeft.toString() + " COMP(" + Integer.toString(iType)
					+ ") " + eRight.toString() + ")";
		}
	}

}