package edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression;

import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinANDExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinArithExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinORExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.TerminalExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.UniMinusExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.UniNotExpression;
import edu.wpi.cs.dsrg.xmldb.xat.component.sqlgeneration.OperatorEvaluator;

public class ExpressionStrImp  implements ExpressionStr {
	protected ExpressionStr untrueExpression;
	protected Vector terminalColumnNames = null;
/**
 * ExpressionStrImp constructor comment.
 */
public ExpressionStrImp() {
	super();
	untrueExpression = null;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:21:08 AM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
public Object clone() {
	Object o = null;

	try{
		o= super.clone();
	}catch (CloneNotSupportedException e){
		System.out.println("this object cann't clone");
	}
	return o;
}
/**
 * used for the factory method
 * Creation date: (2/12/2003 6:28:52 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 * @param str edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression
 */
public ExpressionStr createExpressionStr(Expression expr) {
	if (expr instanceof BinANDExpression){
		return new BinANDExpressionStrImp(expr);
	}

	if (expr instanceof BinArithExpression){
		return new BinArithExpressionStrImp(expr);
	}

	if (expr instanceof BinCOMPExpression){
		return new BinCOMPExpressionStrImp(expr);
	}

	if (expr instanceof BinORExpression){
		return new BinORExpressionStrImp(expr);
	}

	if (expr instanceof TerminalExpression){
		return new TerminalExpressionStrImp(expr);
	}

	if (expr instanceof UniMinusExpression){
		return new UniMinusExpressionStrImp(expr);
	}

	if (expr instanceof UniNotExpression){
		return new UniNotExpressionStrImp(expr);
	}

	
	return null;
}
 /**
	* It will evaluate itself and return the value as an object.
	* Remember, it could be like: Integer, Float, Double, String, Boolean.
	*/
public Object eval(edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper, int[] iPositions) {
	return null;
}
 /**
	* It will evaluate itself and return the value as an object.
	* Remember, it could be like: Integer, Float, Double, String, Boolean.
	*/
public Object eval(java.util.List tuples, edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator op) {
	return null;
}
/**
 * getRelatedColumnNames method comment.
 */
public edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName[] getRelatedColumnNames() {
	return null;
}
/**
 * find the terminal columns' names, a vector of strings
 * Creation date: (2/17/2003 4:38:04 PM)  
 * @return java.util.Vector
 */
public java.util.Vector getTerminalColumnExprs() {  
	return null;
}
/**
 * find the terminal columns' names, a vector of strings
 * Creation date: (2/17/2003 4:38:04 PM)  
 * @return java.util.Vector
 */
public java.util.Vector getTerminalColumnNames() {  
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:27:07 AM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
public ExpressionStr getUntrueExpression() {
	return untrueExpression;
}
/**
 * Insert the method's description here.
 * Creation date: (2/19/2003 5:57:59 PM)
 * @return java.util.Vector
 */
public java.util.Vector getUntrueTerminalColumnNames() {
	if (untrueExpression == null)
		return null;
	else
		return untrueExpression.getTerminalColumnNames();

}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:27:07 AM)
 * @param newUntrueExpression edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
public void setUntrueExpression(ExpressionStr newUntrueExpression) {
	untrueExpression = newUntrueExpression;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression#toSQL(edu.wpi.cs.dsrg.xmldb.xat.component.sqlgeneration.OperatorEvaluator)
 */
public String toSQL(OperatorEvaluator soe) {
	// TODO Auto-generated method stub
	return null;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.ExpressionStr#evalBool(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
 */
public boolean evalBool(XATTuple inputTuple) {
	// TODO Auto-generated method stub
	return false;
}

}
