package edu.wpi.cs.dsrg.xmldb.xat.component.NEXMarkdatagenerator;

/*  
   NEXMark Generator -- Niagara Extension to XMark Data Generator

   Acknowledgements:
   The NEXMark Generator was developed using the xmlgen generator 
   from the XMark Benchmark project as a basis. The NEXMark
   generator generates streams of auction elements (bids, items
   for auctions, persons) as opposed to the auction files
   generated by xmlgen.  xmlgen was developed by Florian Waas.
   See http://www.xml-benchmark.org for information.

   Copyright (c) Dept. of  Computer Science & Engineering,
   OGI School of Science & Engineering, OHSU. All Rights Reserved.

   Permission to use, copy, modify, and distribute this software and
   its documentation is hereby granted, provided that both the
   copyright notice and this permission notice appear in all copies
   of the software, derivative works or modified versions, and any
   portions thereof, and that both notices appear in supporting
   documentation.

   THE AUTHORS AND THE DEPT. OF COMPUTER SCIENCE & ENGINEERING 
   AT OHSU ALLOW USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION, 
   AND THEY DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY DAMAGES 
   WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.

   This software was developed with support from NSF ITR award
   IIS0086002 and from DARPA through NAVY/SPAWAR 
   Contract No. N66001-99-1-8098.

*/

import java.util.*;

class Persons {

    public static int PERSON_DISTR_SIZE = 100;

    // persons dont go away so lowChunk is always 0
    private int highChunk = 1;
    private int currId = 0;
    private Random rnd =  new Random(283494);

    public Persons() {
    }

    // creates the open auction instance as well as returning the new id
    public int getNewId() {
        int newId = currId;
        currId++;
        if(newId == highChunk*PERSON_DISTR_SIZE) {
            highChunk++;
        }
        return newId;
    }

    public int getExistingId() {  // used by generateBid 
        int id = rnd.nextInt(PERSON_DISTR_SIZE);
        id += getRandomChunkOffset();
        return id%currId;
    }

    private int getRandomChunkOffset() {
        int chunkId = rnd.nextInt(highChunk);
        return chunkId*PERSON_DISTR_SIZE;
    }

}

