package edu.wpi.cs.dsrg.xmldb.xat.component.automata.common;

/**
 * The added run(List) only describes what output is generated when given the input List
 * it does not concern about how the input is fetched, whether dequeuing from its input queue
 * or being passed directly from its child operator
 * neither does it concern about how the output is put, whether enqueuing into its ouptut queue
 * or being passed directly to its child operator
 * all these are decided by the its child's invocation mode or its own invocation mode
 * 
 * these operator provides two kinds of info
 * 1) output cardinality
 * 2) unit processing time
 * Creation date: (4/2/2003 10:27:00 AM)
 * @author: Hong Su
 */
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.AllInvokingModeImp;

public interface XATStreamOpRunCore
	extends XATStreamOperator {
	/**
		 * Pipelining version
		 * Creation date: (4/3/2003 10:24:22 PM)
		 * @return List outputs
		 * @param List inputTuples from positionPos, not blocking
		 * @exception java.lang.Exception The exception description.
		 */
	List run(List inputTuples, int inputPos);

	ClassExecTimeKeeper getTimeKeeper();	
	
	
	/* clean its output that hasn't been consumed yet
	 *   
	 */
	void cleanTemp();
	
	
	AllInvokingModeImp getAllInvokingModes();  
	  

	
	
}
