/*
 * Created on Mar 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.common;

import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * @author suhong
 *
 * subtuples are aggregated into a complete tuple
 * in XATTuple, a cell can be a collection, and a subtuple can be an item in such a collection
 * or a subcollection of this collection
 */
public class XATSubTuple extends XATTupleImp implements XATTuple {
	public XATSubTuple() {
		super();
	}

	public XATSubTuple(XATDataValue[] data) {
		super(data);
	}

	public XATSubTuple(int capacity) {
		super(capacity);
	}

	public XATSubTuple(List list) {
		super(list);
	}

	public XATSubTuple(XATTuple tuple) {
		super(tuple.getArrayData());
	}
	
	/**
	 * union a subtuple with another subtuple
	 * Creation date: (1/19/2003 5:03:34 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 * @param tuple edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 */
	public XATTuple union(XATSubTuple subTuple) {
		if (subTuple == null) {
			return this;
		}

		XATDataValue[] tupleContent = subTuple.arrayCell;

		int length = tupleContent.length;

		for (int i = 0; i < length; i++) {
			if (getLength() > 0) {
				//if this tuple is an initialized one 
				XATDataValue cell = getCell(i);
				List oldCellV = new Vector();

				if (cell != null) {
					oldCellV = getCell(i).convertToCollection();
				}

				if (tupleContent[i] == null) {
					//for cell in existential format, it can be null when its past subtuple has indicated the existence
					setCell(i, new XATDataValueImp(oldCellV));

				} else {

					// Vector toBeAddedCellV = tuple.getCell(i).convertToCollection();
					XATDataValue tupleCell = tupleContent[i];

					if (tupleCell instanceof Vector)
						oldCellV.addAll((Vector) tupleContent[i]);
					else
						oldCellV.add(tupleContent[i]);

					setCell(i, new XATDataValueImp(oldCellV));
				}
			} else {
				//no capacity yet
				this.arrayCell = tupleContent;
			}
		}

		return this;
	}

}
