/*
 * Created on Feb 25, 2004
 *
 * a subtuple queue allows a subtuple to be enqueued
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.common;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * @author suhong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class XATSubTupleQueue extends XATQueueImp implements XATQueue {

	//	  key is the customer, return an int[n]
	//	  int[0] is a flag information, indicating the first tuple is a completely processed tuple or a partially processed one
	//	  int[1], ...int[i], ...int[n] indicates the cursor position within the (i-1)th column in the first tuple
	//	  note int[i] can be XATSubTupleQueueCursor.NONE, there are below possibilities:
	//	   (1)the corresponding column is not a collection type and thus does not have a subcell to grab, moreover, this cell cannot be grabbed as whole either since it is not complete yet
	//	   (2) the corresponding cell has been output before, no need to output again
	//	   (3) the corresponding cell may be a collection and not output yet, but does not want to be output yet, is it possible?

	public java.util.Hashtable microCustomerList;
	//hashed on cursor index, giving back correponding column position
	public java.util.Hashtable cursorPosMgr;
	//indicating this cursor does not point a meaningful value	
	final static int NONE = -1;
	//		public final static int HEAD = 0;
	//		public final static int TAIL = 1;
	public int FULL_TUPLE = -1;
	public int SUB_TUPLE = -2;
	/**
	 * Insert the method's description here.
	 * Creation date: (2/12/2003 2:38:55 PM)
	 */
	public XATSubTupleQueue() {
		super();
		cursorPosMgr = new Hashtable();
		microCustomerList = new Hashtable();

	}
	
	/**
	 * XATSubTupleQueueImp constructor comment.
	 * @param newQueueOwner java.lang.Object
	 */
	public XATSubTupleQueue(Object newQueueOwner) {
		super(newQueueOwner);
		//cursorPosMgr = new Hashtable();
		microCustomerList = new Hashtable();
		//add this owner into customerlist, but no meaningful microcursor yet
		//microCustomerList.put(newQueueOwner, new Integer(NONE));

	}
	
	/**
	 * 
	 * dequeue one tuple (always at the head of the queue, relative to this caller)
	 * maybe a complete tuple, maybe a partial tuple 
	 * Creation date: (1/23/2003 10:50:28 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 * @param caller java.lang.Object
	 * @param microCursors int[]
	 */
	public XATTuple dequeue(java.lang.Object caller) {
		//peek the first object in the queue
		XATTuple result = new XATTupleImp();
		XATTuple targetTuple = new XATTupleImp();

		//get the first tuple in the queue
		targetTuple = peek(caller);

		int[] microCursors = getMicroCursors(caller);

		//int[0] is a flag indicating whether this tuple is a completely unprocessed one or a partially unprocessed one
		if (microCursors[0] != NONE) {
			//the first tuple is a partialy processed and partialy unprocessed tuple
			//we only grab the unprocessed part

			for (int i = 1; i < microCursors.length; i++) {
				int celCursor = microCursors[i];

				Vector partialCell = new Vector();

				if (celCursor != FULL_TUPLE) {
					//this cell does have a subcell to put into the subtuple
					//find the corresponding cell in the fisrt tuple
					List cell =
						targetTuple.getCell(i - 1).convertToCollection();

					//add in all the subcells in cell from the cursor to the end of the cell to the partialCell

					for (int j = celCursor; j <= cell.size(); j++) {
						partialCell.add(cell.get(j));

					}

					//move the cursor to the cell
					incrementMicroCursor(
						cell.size() - celCursor,
						i - 1,
						caller);
				} else {
					//this cell does not have a subcell to put into the subtuple
					partialCell.add(null);
				}
				//update the current micro cursor to the end of cell

				result.setCell(i - 1, new XATDataValueImp(partialCell));
			}

			//manage the microcusors,
			if (getQueueSize(caller) > 1) {
				//there is more than one tuple, therefore this first tuple has been completely processed
				//increment the macro cursor 
				//incrementCursor(1, caller);
				dequeueN(1, caller);
				//reset the micro cursor
				if (getQueueSize(caller) > 1) {
					//the current first tuple (after incrementing the macro cursor) must be a tuple
					resetMicroCursor(caller, XATStreamOperator.FULL_TUPLE);
				} else {
					//the current first tuple can be a subtuple
					resetMicroCursor(caller, XATStreamOperator.SUB_TUPLE);
				}
			} else { //this is the only tuple, set its mode to subtuple now
				switchMicroCursor(caller, SUB_TUPLE);
			}

		} else { //must be SUB_TUPLE
			//the first tuple is a completely unprocessed tuple

			result = super.dequeue(caller);
		}

		return result;
	}
	
	/**
	 * a subtuple can only exist either at the head or tail of a queue
	 * Creation date: (1/23/2003 10:50:28 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 * @param caller java.lang.Object
	 * @param microCursors int[]
	 */
	public XATTuple dequeuebak(int headOrTail, java.lang.Object caller) {
		//peek the first object in the queue
		/*  XATTuple result = new XATTupleImp();
			XATTuple targetTuple = new XATTupleImp();
		
			if (headOrTail == HEAD) {
				//get first tuple
				targetTuple = peek(caller);
			} else { //tail
				//get the last tuple
				targetTuple = peek(caller, getQueueSize(caller));
			}
		
			int[][] microCursors = getMicroCursors(caller);
		
			try {
				if (headOrTail == HEAD) {
					if (microCursors[0][0] != -1) {
						//unprocessed partial tuple appears in the first object, 
						for (int i = 0; i < microCursors.length; i++) {
							//int colPos = getCurPosToColPos(microCursors[0][i]);
							//each i corresponds to a column position, not all column can have subcell
							// only column that can have collection type would have subcell
							int colPos = getCurPosToColPos(i);
							Vector cell = targetTuple.getCell(colPos).convertToCollection();
		
							//add in all the subcells in cell from the cursor to the end of the cell to the partialCell
							Vector partialCell = new Vector();
							for (int j = microCursors[0][i]; j <= cell.size(); j++) {
								partialCell.add(cell.get(j));
							}
		
							//update the current micro cursor to the end of cell
							incrementMicroCursor(cell.size() - microCursors[0][i], HEAD, i, caller);
		
							result.setCell(colPos, new XATDataValueImp(partialCell));
						}
					} else { //microCursors[0][0] can be either 0 or -1, while -1, indicates the first object is a tuple
						//return the first object which is actually not subtuples
						result = super.dequeue(caller);
					}
				} else //tail
					{
					if (microCursors[1][0] != -1) {
						//the subtuples appears in the last object, 
						for (int i = 0; i < microCursors.length; i++) {
							int colPos = getCurPosToColPos(microCursors[1][i]);
							Vector cell = targetTuple.getCell(colPos).convertToCollection();
		
							//add in all the subcells in cell from the cursor to the end of the cell to the partialCell
							Vector partialCell = new Vector();
							for (int j = microCursors[1][i]; j <= cell.size(); j++) {
								partialCell.add(cell.get(j));
							}
		
							//update the current micro cursor to the end of cell
							incrementMicroCursor(cell.size() - microCursors[0][i], TAIL, i, caller);
		
							result.setCell(colPos, new XATDataValueImp(partialCell));
						}
					} else { //microCursors[0][0] can be either 0 or -1, while -1, indicates the first object is a tuple
						//return the first object which is actually not subtuples
						result = super.dequeue(caller);
					}
				}
			} catch (XATQueueException e) {
				throw e;
			} catch (IndexOutOfBoundsException e1) {
				//hmm, the cursor became corrupted somehow
				throw new XATQueueException("The caller tried to dequeue something off the queue that doesnt exist");
			} catch (Exception e2) {
				//from deep copy maker
				throw new XATQueueException(e2.getMessage());
			}
		
			return result;*/
		return null;
	}
	
	/**
	 * makes only sense
	 * Creation date: (1/25/2003 11:01:53 PM)
	 * @return java.util.List
	 * @param howMany int
	 * @param caller java.lang.Object
	 * revisit: for exception
	 */
	public List dequeueN(int howMany, Object caller) {
		List results = new LinkedList();
		// XATTuple lastTuple = peek(caller, getQueueSize(caller));

		int[] microCursors = getMicroCursors(caller);

		try {
			if (howMany < getQueueSize(caller)) {
				//not dequeue to the end which is possibly subtuples
				if (microCursors[0] == FULL_TUPLE) {
					//first object is a tuple
					results = super.dequeueN(howMany, caller);
				} else { //first object is subtuples
					results.add(dequeue(caller));
					results.addAll(super.dequeueN(howMany - 1, caller));
				}
			} else {
				if (howMany > 0) {
					if (howMany == getQueueSize(caller)) {
						//dequeue all in the queue, dequeue the last tuple as it is a subtuple
						if (microCursors[0] == FULL_TUPLE) {
							//fist object is a tuple
							results = super.dequeueN(howMany - 1, caller);
							results.add(dequeue(caller));
						} else { //fist object is also a subtuple
							results.add(dequeue(caller));
							results.addAll(super.dequeueN(howMany - 2, caller));
							results.add(dequeue(caller));
						}
					}
				}
			}
		} catch (XATQueueException e) {
			throw e;
		} catch (IndexOutOfBoundsException e1) {
			//hmm, the cursor became corrupted somehow
			throw new XATQueueException("The caller tried to dequeue something off the queue that doesnt exist");
		} catch (Exception e2) {
			//from deep copy maker
			throw new XATQueueException(e2.getMessage());
		}

		return results;
	}
	
	/**
	 * makes only sense
	 * Creation date: (1/25/2003 11:01:53 PM)
	 * @return java.util.List
	 * @param howMany int
	 * @param caller java.lang.Object
	 * revisit: for exception
	 */
	public List dequeueNbak(int howMany, Object caller) {
		/*  List results = new LinkedList();
			XATTuple lastTuple = peek(caller, getQueueSize(caller));
		
			int[][] microCursors = getMicroCursors(caller);
		
			try {
				if (howMany < getQueueSize(caller)) {
					//not dequeue to the end which is possibly subtuples
					if (microCursors[0][0] == -1){
						//first object is a tuple
						results = super.dequeueN(howMany, caller);
					}
					else{//first object is subtuples
						results.add(dequeue(HEAD, caller));
						results.addAll(super.dequeueN(howMany -1, caller));
					}
				} else {
					if (howMany == getQueueSize(caller)) {
						//dequeue all in the queue, the last object can be subtuples
						if (microCursors[1][0] == -1){
							//last object is a tuple
							results = super.dequeueN(howMany, caller);
						}
						else{//last object is subtuples
							if (microCursors[0][0] == -1){
								//fist object is a tuple
								results = super.dequeueN(howMany -1, caller);
								results.add(dequeue(TAIL, caller));			                
							}
							else{//fist object is also subtuples
								results.add(dequeue(HEAD, caller));
								results.addAll(super.dequeueN(howMany -2, caller));
								results.add(dequeue(TAIL, caller));		                
							}
						}
					}
				}
			}catch (XATQueueException e) {
				throw e;
			} catch (IndexOutOfBoundsException e1) {
				//hmm, the cursor became corrupted somehow
				throw new XATQueueException("The caller tried to dequeue something off the queue that doesnt exist");
			} catch (Exception e2) {
				//from deep copy maker
				throw new XATQueueException(e2.getMessage());
			}
		
			return results;*/

		return null;
	}
	
	/**
	 * There is only one position for the subTuple to be merged at, i.e., the last tuple in the queue
	 * Creation date: (1/19/2003 3:17:18 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 * @param subTuple edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 */
	public XATTuple enqueueSubTuple(XATSubTuple subTuple, Object caller) {
		if (getQueueSize() > 0) {
			XATSubTuple accommodatingTuple = (XATSubTuple) (peekLast());
			return accommodatingTuple.union(subTuple);
		} else {
			enqueue(subTuple, caller);
			return subTuple;
		}
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (1/23/2003 10:40:01 PM)
	 * @return int
	 * @param column java.lang.String
	 */
	public int getCurPosToColPos(int cursorPos) {
		return ((Integer) cursorPosMgr.get(new Integer(cursorPos))).intValue();
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (1/23/2003 10:34:58 PM)
	 * @return int
	 * @param column java.lang.String
	 */
	public int getMicroCursorPos(String column) {
		return 0;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/23/2003 9:47:51 PM)
	 * @return int[]
	 * @param caller java.lang.Object
	 */
	protected int[] getMicroCursors(Object caller) {

		Object o = microCustomerList.get(caller);

		return (int[]) (o);

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/23/2003 9:47:51 PM)
	 * @return int[]
	 * @param caller java.lang.Object
	 */
	protected int[][] getMicroCursorsbak(Object caller) {
		//int[][] result = new int[2][getSchema().getLength()];

		return (int[][]) (microCustomerList.get(caller));

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/24/2003 4:13:52 PM)
	 * @param step int
	 * @param colPos int
	 * @param caller java.lang.Object
	 */
	public void incrementMicroCursor(int step, int colPos, Object caller) {
		int[] microCursors = getMicroCursors(caller);

		microCursors[colPos] = microCursors[colPos] + step;

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/24/2003 4:13:52 PM)
	 * @param step int
	 * @param colPos int
	 * @param caller java.lang.Object
	 */
	public void incrementMicroCursorbak(
		int step,
		int headOrTail,
		int curPos,
		Object caller) {
		/*int[][] microCursors = getMicroCursors(caller);
		
		microCursors[headOrTail][curPos] = microCursors[headOrTail][curPos]+step;*/

	}
	/**
	 * peek the queue, get the first tuple, but not dequeue it (no increment of the cursor)
	 * Creation date: (1/23/2003 8:52:38 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 * @param caller java.lang.Object
	 */
	/*public XATTuple peek(java.lang.Object caller) {
		try {
			int cursor = getCursor(caller);
			/** have to make a copy of the tuple to return 
			XATTuple toReturn = (XATTuple)DeepCopyMaker.makeDeepCopy(queue.get(cursor));
			
			return toReturn;		
		
		} catch (XATQueueException e) {
			throw e;
		} catch (IndexOutOfBoundsException e1){
			//hmm, the cursor became corrupted somehow
			throw new XATQueueException("The caller tried to dequeue something off the queue that doesnt exist");
		} catch (Exception e2){
			//from deep copy maker
			throw new XATQueueException(e2.getMessage());
		}
	}*/
	/**
	 * get the nth object in the queue for the caller
	 * Creation date: (1/25/2003 11:20:42 PM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple
	 * @param caller java.lang.Object
	 * @param pos int
	 */
	/*public XATTuple peek(Object caller, int n) {
		try {
			int cursor = getCursor(caller);
			/** have to make a copy of the tuple to return 
			XATTuple toCopy = (XATTuple)queue.get(cursor+n);
			XATTuple toReturn = (XATTuple)DeepCopyMaker.makeDeepCopy(toCopy);
			
			return toReturn;		
		
		} catch (XATQueueException e) {
			throw e;
		} catch (IndexOutOfBoundsException e1){
			//hmm, the cursor became corrupted somehow
			throw new XATQueueException("The caller tried to dequeue something off the queue that doesnt exist");
		} catch (Exception e2){
			//from deep copy maker
			throw new XATQueueException(e2.getMessage());
		}
	}*/
	/**
	 * Insert the method's description here.
	 * Creation date: (2/13/2003 11:54:32 AM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
	 * @param caller java.lang.Object
	 * @exception edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueException The exception description.
	 */
	public XATQueue registerMicro(Object caller) throws XATQueueException {
		super.register(caller);
		//add the consumer of the queue to the microCustomerList, no meaningful microCursors yet
		int[] hole = { NONE };
		microCustomerList.put(caller, hole);
		return null;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/13/2003 10:30:44 AM)
	 * @param caller java.lang.Object
	 * @param resetMode int
	 */
	public void resetMicroCursor(Object caller, String resetMode) {
		int[] microCursors = getMicroCursors(caller);

		if (resetMode == XATStreamOperator.FULL_TUPLE) {

			microCursors[0] = FULL_TUPLE;
			for (int i = 1; i < microCursors.length; i++) {
				microCursors[i] = NONE;
			}
		} else if (resetMode == XATStreamOperator.SUB_TUPLE) {

			microCursors[0] = SUB_TUPLE;
			for (int i = 1; i < microCursors.length; i++) {
				microCursors[i] = 0;
			}

		}

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/23/2003 10:37:07 PM)
	 */
	public void setCurPosToColPos(int cursorPos, int columnPos) {
		cursorPosMgr.put(new Integer(cursorPos), new Integer(columnPos));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/13/2003 11:12:17 AM)
	 * @param schema edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema
	 */
	public synchronized void setSchema(XATQueueSchema schema) {
		super.setSchema(schema);

		//initialize all the microCursors for each customer
		for (Enumeration e = microCustomerList.keys(); e.hasMoreElements();) {

			int[] microCursors = new int[schema.getLength() + 1];
			microCursors[0] = FULL_TUPLE;
			for (int j = 1; j < schema.getLength(); j++) {
				microCursors[j] = 0;
			}

			microCustomerList.put(e.nextElement(), microCursors);
		}

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/13/2003 11:44:19 AM)
	 * @param caller java.lang.Object
	 * @param modeSwitchTo int
	 */
	public void switchMicroCursor(Object caller, int modeSwitchTo) {
		int[] microCursors = getMicroCursors(caller);

		if (microCursors[0] == modeSwitchTo) {
			System.out.println("switch to a same mode: impossible");
		} else {
			microCursors[0] = modeSwitchTo;
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/13/2003 2:20:13 PM)
	 * @return java.lang.String
	 */
	/*public String toString() {
		String rs = "XATSubTupleQueue: " + this.hashCode() + "Owners: ";
		for (int i = 0; i < queueOwner.size(); i++){
			rs = rs + queueOwner.toString() + " ";
		}
	
		return rs;
	}*/
	
	/**
	 * updates the tupleCount parameter for the given datasource.
	 * TUPLE_COUNT is used in enough places so it makes sense to make this method 
	 * @param howMany int
	 */
	protected void updateTupleCount(int howMany) {

		//stats.updateValue("TUPLE_COUNT", this, edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.StringMaker.makeString(howMany));

	}
}
