/*
 * Created on Mar 23, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;

/**
 * when moving in/out an operator, the information about the changed parts
 * for estimating the cost change
 */
public class AffectedPart {
	
	//when a tokennav is removed, its dest sj is removed too
	List removedSjs;
	List addedSjs;
	
	//these sj nodes appear in both plans before and after
	List affectedSjs;
	
	List removedTokenNavs;
	List addedTokenNavs;	
	
	List descendantTokenNavs = new ArrayList();
	List ancestorNodeNavs = new ArrayList();
	
	//if new extract is added, this records the mapping
	Map newTokenNavToExtract;
	Map newSjToBranchStatistics;
	Map newEntryOpToInputSj;
	Map newBranchToStatistics;
		
	
	public AffectedPart(){
		removedSjs = new ArrayList();
		addedSjs = new ArrayList();
		affectedSjs = new ArrayList();
		removedTokenNavs = new ArrayList();
		addedTokenNavs = new ArrayList();
		newTokenNavToExtract = new HashMap();
		newSjToBranchStatistics = new HashMap();
		newEntryOpToInputSj = new HashMap();
		newBranchToStatistics = new HashMap();
		
	}
	
	public AffectedPart(List removedSjs, List addedSjs, List removedTokenNavs, List addedTokenNavs, List affectedSjs, Map newTokenNavToExtract, Map newSjToBranchStatistics, Map newEntryOpToInputSj, Map newBranchToStatistics){
		this.removedSjs = removedSjs;
		this.addedSjs = addedSjs;
		this.affectedSjs = affectedSjs;
		this.removedTokenNavs = removedTokenNavs;
		this.addedTokenNavs = addedTokenNavs;
		this.newTokenNavToExtract= newTokenNavToExtract;
		this.newSjToBranchStatistics = newSjToBranchStatistics;
		this.newEntryOpToInputSj = newEntryOpToInputSj;
		this.newBranchToStatistics = newBranchToStatistics;
	}
	

	
	public Map getNewTokenNavToExtract(){
		return newTokenNavToExtract;
	}
	
	public void setNewTokenNavToExtract(Map newTokenNavToNewExtract){
		this.newTokenNavToExtract = newTokenNavToNewExtract;
	}
	
	public Map getNewSjToBranchStatistics(){
		return newSjToBranchStatistics;
	}
	
	public void setNewSjToBranchStatistics(Map newSjToBranchStatistics){
		this.newSjToBranchStatistics = newSjToBranchStatistics;
	}
	
	public Map getNewEntryOpToInputSj(){
		return newEntryOpToInputSj;
	}
	
	public void setNewEntryOpToInputSj(Map newEntryOpToInputSj){
		this.newEntryOpToInputSj = newEntryOpToInputSj;
	}
	
	public Map getNewBranchToStatistics(){
		return newBranchToStatistics;
	}
	
	public List getRemovedSjs(){
		return removedSjs;
	}
	
	public List getAddedSjs(){
		return addedSjs;
	}
	
	public List getAffectedSjs(){
		return affectedSjs;
	}
	
	public List getRemovedTokenNavs(){
		return removedTokenNavs;
	}
	
	public List getAddedTokenNavs(){
		return addedTokenNavs;
	}
	
	/*
	 * when a nodeNav is moved in, find the token nav is derived 
	 */
	public PureNavigateAutoStream getDerviedTokenNav(){
		return (PureNavigateAutoStream)addedTokenNavs.get(addedTokenNavs.size()-1);
	}
	
	/*
	 * the sj in which the pulled out tokenNav was previous in
	 */
	public AffectedSj getPullOutAffectedSj(){
		return (AffectedSj)affectedSjs.get(0);
	}
	
	/*public List getAncestorNodeNavs(){
		return ancestorNodeNavs;
	}
	
	public List getDescendantTokenNavs(){
		return descendantTokenNavs;
	}*/

	public void incorporateAffectedPart(AffectedPart newAffectedPart){
			
		removedSjs.addAll(newAffectedPart.getRemovedSjs());
		removedTokenNavs.addAll(newAffectedPart.getRemovedTokenNavs());
		addedSjs.addAll(newAffectedPart.getAddedSjs());
		addedTokenNavs.addAll(newAffectedPart.getAddedTokenNavs());
		
		List newAffectedSjs = newAffectedPart.getAffectedSjs();
		int newSize = newAffectedSjs.size();
		int size = affectedSjs.size();
		for (int i=0; i<newSize; i++){
			AffectedSj newAffectedSj = (AffectedSj)newAffectedSjs.get(i);
			XATStreamOperator newEntry = newAffectedSj.getEntryOp();
			StructuralJoinStream newSj = newAffectedSj.getSj();
			boolean overlap = false;
			for (int j=0; j<size; j++){
				AffectedSj affectedSj = (AffectedSj)affectedSjs.get(j);
				XATStreamOperator entry = affectedSj.getEntryOp();
				if (newEntry== entry){
					//overlap
					//replace the old one with the new one
				    affectedSjs.set(j, newAffectedSj);
				    overlap = true;
				    break;
				}				
			}
			
			if (!overlap)
				affectedSjs.add(newAffectedSj);
			
		}
		//saffectedSjs.addAll(newAffectedPart.getAffectedSjs());
		//ancestorNodeNavs.addAll(newAffectedPart.getAncestorNodeNavs());
		//descendantTokenNavs.addAll(newAffectedPart.getDescendantTokenNavs());
		
		newTokenNavToExtract.putAll(newAffectedPart.getNewTokenNavToExtract());
		newSjToBranchStatistics.putAll(newAffectedPart.getNewSjToBranchStatistics());
		newEntryOpToInputSj.putAll(newAffectedPart.getNewEntryOpToInputSj());
		newBranchToStatistics.putAll(newAffectedPart.getNewBranchToStatistics());
		
		newAffectedPart.removedSjs.clear();
		newAffectedPart.removedTokenNavs.clear();
		newAffectedPart.addedSjs.clear();
		newAffectedPart.addedTokenNavs.clear();
		newAffectedPart.affectedSjs.clear();
		
		newAffectedPart.newTokenNavToExtract.clear();
		newAffectedPart.newSjToBranchStatistics.clear();
		newAffectedPart.newEntryOpToInputSj.clear();
		newAffectedPart.newBranchToStatistics.clear();
	}
	
	
	 

}
