/*
 * Created on Mar 23, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor;

import java.util.Map;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;

/**
 * the structural join whose contents are changed
 */
public class AffectedSj {

	StructuralJoinStream sj;

	//the entry op that identifies an input subplan whose contents are changed
	XATStreamOperator entryOp;

	//especially for the entry operator which is extract newly added when
	// pulling a tokenNav out
	boolean entryOpAdded = false;

	//especially for the entry operator which is extract removed when pushing a
	// nodeNav in
	boolean entryOpRemoved = false;
	
	//the sj is affected because its child sj is removed due to there is only
	//one child of this child sj
	boolean sjRemoved = false;

	//the evaluation order of the input subplans to the structural join
	int[] newSubplanEvalOrder;
	
	Map newSjToBranchStatistics;

	public AffectedSj(StructuralJoinStream sj, XATStreamOperator entryOp,
			boolean entryOpAdded, boolean entryOpRemoved, boolean sjRemoved) {
		this.sj = sj;
		this.entryOp = entryOp;
		this.entryOpAdded = entryOpAdded;
		this.entryOpRemoved = entryOpRemoved;
		this.sjRemoved = sjRemoved;
	}
	
	public void setNewSubplanEvalOrder(int[] newSubplanEvalOrder){
		this.newSubplanEvalOrder = newSubplanEvalOrder;
	}
	
	public int[] getNewSubplanEvalOrder(){
		return newSubplanEvalOrder;
	}
	
	public void setNewSjToBranchStatistics(Map newSjToBranchStatistics){
		this.newSjToBranchStatistics = newSjToBranchStatistics;
	}
	
	public Map getNewSjToBranchStatistics(){
		return newSjToBranchStatistics; 
	}	

	public StructuralJoinStream getSj() {
		return sj;
	}
	
	public void setSj(StructuralJoinStream sj){
		this.sj = sj;
	}

	public XATStreamOperator getEntryOp() {
		return entryOp;
	}

	public boolean isEntryOpAdded() {
		return entryOpAdded;
	}

	public boolean isEntryOpRemoved() {
		return entryOpRemoved;
	}
	
	public boolean isSjRemoved(){
		return sjRemoved;
	}
	
	public void setSjRemoved(boolean sjRemoved){
		this.sjRemoved = sjRemoved;
	}

	public String toString() {
		String str = "";
		str = str + sj;
		if (entryOpAdded)
			str = str + " entryOpAdded ";
		else if (entryOpRemoved)
			str = str + " entryOpRemoved";

		return str;
	}

}