package edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor;

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.*;

import java.util.*;
/**
 * construct the automata from the physical plan
 * Creation date: (1/29/2003 9:40:37 AM)
 * @author: Hong Su
 */

public class AutoCreaterFrPlan {
	
	private ExtendedAutomata auto;
	
	List nodesVisited = new ArrayList();
	/**
	 * generate automata from the physical plan
	 * @return ExtendedAutomata
	 * @param rootnode XATNode the rootnode of the physical plan
	 * @param storeMgr the storage manager where the automata put extracted data into
	 */
	public ExtendedAutomata generateAuto(
		DagNode rootNode,
		Finer_StreamStoreMgr storeMgr) {
		auto = new ExtendedAutomata(storeMgr);

		visitNode(rootNode);

		return auto;
	}
	
	/**
	 * get the resultant automata 
	 * @return ExtendedAutomata
	 */
	public ExtendedAutomata getAuto() {
		return auto;
	}
	
	/**
	 * traverse the plan and associate each operator with the states in automata
	 * @param node XATNode node visited
	 */
	public void visitNode(DagNode node) {
		if (nodesVisited.contains(node))
		return;
		
		nodesVisited.add(node);
		
		XATStreamOperator op = (XATStreamOperator) node.getOperator();

		if (op instanceof XMLScanStream)
			 ((XMLScanStream) op).associateWithAuto(auto);

		if (op instanceof AutomataEnabled)
			 ((AutomataEnabled) op).associateWithAuto(auto);

		for (Iterator i = node.getParents(); i.hasNext();) {
			visitNode((DagNode) (i.next()));
		}

	}
}
