/*
 * Created on Aug 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.FindOpVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.NatureJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.SelectStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnest;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Navigate;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NavigationStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator.Extract;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.ExtractCollImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.ExtractUnnestImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StreamNavigate;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StreamNavigateImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StreamSelect;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StreamSelectImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StructuralJoin;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StructuralJoinImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.xatrewrite
	.common
	.dag
	.RewriteUtilities;
/**
 * @author suhong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GeneralRaindropRewriteRules extends NavSourceRewriteRule {
	
	static boolean navOnly = false;
	
	/**
	 * Rules for pushing a Navigate operator through a structural join operator
	 * and split to corresponding 
	 * @return ReWriteResult. The swap flag in ReWriteResult false.
	 * @param parent parent XAT operator (Navigate).
	 * @param child child XAT Operator (Select).
	 * @since 1.0   
	 * @see Navigate
	 * @see Select  
	 * @see ReWriteResult
	 */
	public Object visit(Navigate parent, StructuralJoin child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		NavigationStep[] entries = parent.getEntryPoint();
		DagNode navNode = (DagNode) parent.getNode();

		//find which branch of child the sourceNavNode lies on
		DagNode sjNode = (DagNode) child.getNode();

		int i = findPushPos(parent, child);

		if (i == -1) {
			p1.setFinalPosition(false);
			p1.setSwapped(false);
			return p1;
		}

		//put navNode above the i th child of sjNode
		sjNode.getChild(i).setParent(navNode);
		navNode.deleteChild(sjNode);
		navNode.addChild(sjNode.getChild(i));
		sjNode.deleteParent(navNode);
		for (Iterator it = navNode.getParents(); it.hasNext();) {
			DagNode navNodeParent = (DagNode) it.next();
			sjNode.addParent(navNodeParent);
			navNodeParent.deleteChild(navNode);
			navNodeParent.addChild(sjNode);
		}
		navNode.deleteAllParents();
		navNode.addParent(sjNode);
		sjNode.addChild(navNode);
		sjNode.deleteChild(sjNode.getChild(i));

		return visit(parent, parent.getNode().getChild(0).getOperator());

	}

	/*
	 * find whether the intermedite part between a structuraljoin and a natural join can be linearized
	 */
	public Object visit(StructuralJoin parent, XATOperator child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		DagNode sjNode = (DagNode) parent.getNode();
		DagNode njNode = sjNode;

		while (njNode != null
			&& !(njNode.getOperator() instanceof NatureJoin)) {
			//hardcode, check
			int i = njNode.getParentsSize();
			njNode = njNode.getParent(i-1);
		}

		if (njNode == null) {
			p1.setFinalPosition(false);
			p1.setSwapped(false);
			return p1;
		}

		//curnode is a natural join
		List inters = FindOpVisitor.findAllInterOps(sjNode, njNode);
		//if no inter operator is nav, then mergable

		int navUnnestCount = 0;
		for (Iterator it = inters.iterator(); it.hasNext();) {
			XATOperator inter = (XATOperator) it.next();
			if (inter instanceof NavUnnest)
				navUnnestCount++;

		}

		if (navUnnestCount > 1) {
			//two navunnest can not be linearized
			p1.setFinalPosition(false);
			p1.setSwapped(false);
			return p1;
		}

		//none is nav, mergable
		linearize((NatureJoin) njNode.getOperator());

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	public Object visit(Navigate parent, Extract child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		//split parent to a pure nav + extract + structuraljoin (if there is none)
		NavigationStep[] entries = parent.getEntryPoint();

		if (entries[0].getStepValue().equals(child.getOutputColumnName())) {
			//add a new nav
			DagNode extractNode = (DagNode) child.getNode();
			DagNode extractChild = (DagNode) child.getNode().getChild(0);
			DagNode newNavNode = new DagNodeImp();
			StreamNavigate navForParent =
				new StreamNavigateImp(newNavNode, parent);
			extractChild.addParent(newNavNode);
			newNavNode.addChild(extractChild);

			//add a new extract  
			DagNode newExtractNode = new DagNodeImp();
			Extract extractForParent = null;
			if (parent instanceof NavUnnest)
				extractForParent = new ExtractUnnestImp(newExtractNode, parent);
			else
				extractForParent = new ExtractCollImp(newExtractNode, parent);
			newNavNode.addParent(newExtractNode);
			newExtractNode.addChild(newNavNode);

			boolean createNewSj = true;
			XATOperator parentParent =
				parent.getNode().getParent().getOperator();
			//find whether there exit a sj on child already
			if ((parentParent instanceof StructuralJoin)) {
				StructuralJoin sj = (StructuralJoin) parentParent;
				if (((Navigate) (sj.getShadowNode().getOperator()))
					.getOutputColumnName()
					.equals(parent.getEntryPoint()[0].getStepValue())) {
					createNewSj = false;

					//concatenate the new extract node with the structuraljoin
					DagNode sjNode = (DagNode) parent.getNode().getParent();
					sjNode.addChild(newExtractNode);
					newExtractNode.addParent(sjNode);
					//remove parent from sj
					sjNode.deleteChild(parent.getNode());
					//concatneate child with sj
					sjNode.addChild(child.getNode());
					child.getNode().setParent(sjNode);

				}
			}

			if (createNewSj) {

				DagNode newSjNode = new DagNodeImp();
				StructuralJoin sj =
					new StructuralJoinImp(newSjNode, extractChild);

				//put extract's original parents all above sjNode
				for (Iterator it = extractNode.getParents(); it.hasNext();) {
					DagNode extractNodeParent = (DagNode) it.next();
					if (extractNodeParent != parent.getNode()) {
						newSjNode.addParent(extractNodeParent);
						extractNodeParent.deleteChild(extractNode);
						extractNodeParent.addChild(newSjNode);
					} else {
						//put nav's parent under sjNode
						for (Iterator it2 = parent.getNode().getParents();
							it2.hasNext();
							) {
							DagNode navParent = (DagNode) it2.next();
							newSjNode.addParent(navParent);
							navParent.deleteChild(parent.getNode());
							navParent.addChild(newSjNode);
						}
					}
				}

				extractNode.deleteAllParents();

				newSjNode.addChild(newExtractNode);
				newSjNode.addChild(extractNode);
				extractNode.addParent(newSjNode);
				newExtractNode.setParent(newSjNode);
				child.getNode().setParent(newSjNode);
			}

			//set up extract schema
			Set extractSchema = new HashSet();
			extractSchema.add(parent.getOutputColumnName());
			newExtractNode.setSchema(extractSchema);

			p1.setFinalPosition(true);
			p1.setSwapped(true);
			return p1;

		}

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	public Object visit(Navigate parent, Select child) {

		//ReWriteResult p1 = new ReWriteResult();

		//		push to be underneath select since it will be down to a sj anyway
		RewriteUtilities.swap(parent, child);
		//p1.setFinalPosition(false);
		//p1.setSwapped(true);
		return visit(parent, parent.getNode().getChild(0).getOperator());

	}

	public Object visit(Navigate parent, NatureJoin nj) {

		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		//push to an abitray one since it will be down to a sj anyway
//		hardcode, structuraljoin ranks higher than natural join
		XATNode childNode = nj.getNode().getChild(0);
		boolean sjFound = false;
		XATNode[] children = nj.getNode().getChildren();
		for (int i=0; i<children.length;i++){
			XATNode child = children[i];
			if (child.getOperator() instanceof StructuralJoin) {
				childNode = child;
				sjFound = true;
			}
		}
		
		if (!sjFound){
			for (int i=0; i<children.length;i++){
				XATNode child = children[i];
				if (child.getOperator() instanceof NatureJoin) {
					childNode = child;
				}
			}
			
		}
		
		XATOperator childOp = childNode.getOperator();

		DagNode navNode = (DagNode) parent.getNode();
		DagNode njNode = (DagNode) nj.getNode();

		for (Iterator it = navNode.getParents(); it.hasNext();) {
			DagNode navParent = (DagNode) it.next();
			njNode.addParent(navParent);
			navParent.deleteChild(navNode);
			navParent.addChild(njNode);
		}		
		
		njNode.deleteParent(navNode);

		navNode.deleteAllParents();
		navNode.addParent(njNode);
		navNode.deleteChild(njNode);
		
		/*navNode.addChild(njNode.getChild(0));
		njNode.getChild(0).setParent(navNode);
		njNode.deleteChild(njNode.getChild(0));
		njNode.addChild(navNode);*/
		
		navNode.addChild(childNode);
		childNode.setParent(navNode);
		njNode.deleteChild(childNode);
		njNode.addChild(navNode);
	
		
		//return visit(parent, parent.getNode().getChild(0).getOperator());
		return visit(parent, childNode.getOperator());

	}

	private void linearize(NatureJoin op) {

		DagNode node = (DagNode) op.getNode();

		if (node.getChildrenSize() == 1) {
			//this node can be directly removed
			boolean hasParentAlready = false;
			for (Iterator it = node.getChild(0).getParents();it.hasNext();)
			{
			    DagNode parent = (DagNode)it.next();
			    if (parent ==node.getParent(0)){
			    	hasParentAlready = true;
			    	break;
			    }
			    	
			}
			
			if (!hasParentAlready){
			node.getChild(0).setParent(node.getParent(0));
			node.getParent(0).addChild(node.getChild(0));
			}
			
			node.getParent(0).deleteChild(node);
			((DagNode)node.getChild(0)).deleteParent(node);
			
			
			return;
		}
		
		

		//node is now the natural join
		List desc = FindOpVisitor.getDescNodes(node);
		for (Iterator it2 = desc.iterator(); it2.hasNext();) {
			DagNode descNode = (DagNode) it2.next();
			if (descNode.getParentsSize() > 1) {
				//a desc node has multiple parent
				//must be a common ancestor
				/*	DagNode firstParent = (DagNode) descNode.getParent(0);
					//intermediate does not include firstparent, so we include firstParent 
					List intermediate =
						FindOpVisitor.findAllInterOps(firstParent, node);
					intermediate.add(0, firstParent.getOperator());
				
					DagNode currentNjChild =
						(DagNode) ((XATOperator) intermediate
							.get(intermediate.size() - 1))
							.getNode();*/

                /** hardcode***/
                List interOps = FindOpVisitor.findAllInterOps(descNode, node);
                boolean allSjs = true;
                for (Iterator it = interOps.iterator(); it.hasNext();){
                	if (!(it.next() instanceof NatureJoin))
                	allSjs = false;
                	
                }
                if (allSjs){
                	//delete all the sjs
                	descNode.deleteAllParents();
                	descNode.addParent(node.getParent());
                	node.getParent().addChild(descNode);
                	node.getParent().deleteChild(node);
                	return;
                	
                }
                /**end of hardcode***/

				DagNode currentNjChild = null;

				//record which parent of descNode is its immediate parent later on
				int firstBranch = 0;
				boolean first = true;

				for (int i = 0; i < descNode.getParentsSize(); i++) {
					//put all nodes on the first branch   
					DagNode ithParent = (DagNode) descNode.getParent(i);

					if (currentNjChild != null && ithParent != op.getNode() ) {
						//it is possible the njchild itself is the ancestor of ithparent
						//    nj
						//    /\
						//   nj \
						//   |  /
						//    sj
						ithParent.addChild(currentNjChild);
						currentNjChild.deleteParent(node);
						currentNjChild.addParent(ithParent);
						ithParent.deleteChild(descNode);

						node.deleteChild(currentNjChild);
					}

					if (ithParent != op.getNode()) {
						//the highest intermediate node between nj node to descNode
						//need to be inserted above by another later node
						List intermediate =
							FindOpVisitor.findAllInterOps(ithParent, node);
						intermediate.add(0, ithParent.getOperator());
						currentNjChild =
							(DagNode) ((XATOperator) intermediate
								.get(intermediate.size() - 1))
								.getNode();

						if (first) {
							first = false;
							firstBranch = i;
						}

					}

				} //end of for
				//remove naturejoin and add in multiNavUnnest
				currentNjChild.addParent(node.getParent());
				currentNjChild.deleteParent(node);
				node.getParent().addChild(currentNjChild);
				node.getParent().deleteChild(node);

				DagNode firstBranchParent = descNode.getParent(firstBranch);

				for (Iterator it = descNode.getParents(); it.hasNext();) {
					DagNode parent = (DagNode) it.next();
					if (parent != firstBranchParent)
						descNode.deleteParent(parent);
				}

				//for (int i= 0; i<node.getChildrenSize(); i++)
				//	((DagNode)node.getChild(i)).deleteParent(node);

				break;
			} //end of if (descNode.getParentsSize()>1)

		} //end of for (iterator it2)

	}

	public Object visit(Select parent, XATOperator child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		int i = findPushPos(parent, child);
		if (i == -1) {
			p1.setFinalPosition(true);
			p1.setSwapped(false);
			return p1;
		}

		DagNode childNode = (DagNode) child.getNode();
		DagNode selNode = (DagNode) parent.getNode();

		//	put navNode above the i th child of sjNode
		childNode.getChild(i).setParent(selNode);
		selNode.deleteChild(childNode);
		selNode.addChild(childNode.getChild(i));
		childNode.deleteParent(selNode);
		for (Iterator it = selNode.getParents(); it.hasNext();) {
			DagNode navNodeParent = (DagNode) it.next();
			childNode.addParent(navNodeParent);
			navNodeParent.deleteChild(selNode);
			navNodeParent.addChild(childNode);
		}
		selNode.deleteAllParents();
		selNode.addParent(childNode);
		childNode.addChild(selNode);
		childNode.deleteChild(childNode.getChild(i));

		if (childNode.getChild(i).getOperator() instanceof Extract) {
			//set up schema
			Set selSchema = new HashSet();
			selSchema.add(
				((Extract) (childNode.getChild(i).getOperator()))
					.getOutputColumnName());
			selNode.setSchema(selSchema);
			StreamSelect selOp = new StreamSelectImp(selNode, parent);
			p1.setFinalPosition(true);
			p1.setInAuto(true);
		} else
			p1.setFinalPosition(false);

		if (selNode.getChild(0).getOperator() instanceof StructuralJoin
			|| selNode.getChild(0).getOperator() instanceof Extract)
			p1.setOnBoundary(true);

		p1.setSwapped(true);
		
		
		//return p1;
		if (!p1.isFinalPosition())
		return visit(parent, parent.getNode().getChild(0).getOperator());
		else return p1;

	}

	public Object visit(StreamSelect parent, XATOperator child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		int i = findPushPos(parent, child);
		if (i == -1) {
			p1.setFinalPosition(true);
			p1.setSwapped(false);
			return p1;
		}

		DagNode sjNode = (DagNode) child.getNode();
		DagNode selNode = (DagNode) parent.getNode();

		//	put navNode above the i th child of sjNode
		sjNode.getChild(i).setParent(selNode);
		selNode.deleteChild(sjNode);
		selNode.addChild(sjNode.getChild(i));
		sjNode.deleteParent(selNode);
		for (Iterator it = selNode.getParents(); it.hasNext();) {
			DagNode navNodeParent = (DagNode) it.next();
			sjNode.addParent(navNodeParent);
			navNodeParent.deleteChild(selNode);
			navNodeParent.addChild(sjNode);
		}
		selNode.deleteAllParents();
		selNode.addParent(sjNode);
		sjNode.addChild(selNode);
		sjNode.deleteChild(sjNode.getChild(i));

		if (sjNode.getChild(i).getOperator() instanceof Extract) {
			//set up schema
			Set selSchema = new HashSet();
			selSchema.add(
				((Extract) (sjNode.getChild(i).getOperator()))
					.getOutputColumnName());
			selNode.setSchema(selSchema);
			p1.setFinalPosition(true);
			p1.setInAuto(true);
		} else
			p1.setFinalPosition(false);

		p1.setSwapped(true);
		return p1;

	}

	/*public Object visit(Select parent, NatureJoin nj) {
	
		ReWriteResult p1 = new ReWriteResult();
	
		//push to an abitray one since it will be down to a sj anyway
		//XATOperator child = nj.getNode().getChild(0).getOperator();
		int i = findPushPos(parent, nj);
	
		DagNode selNode = (DagNode) parent.getNode();
		DagNode njNode = (DagNode) nj.getNode();
	
		for (Iterator it = selNode.getParents(); it.hasNext();) {
			DagNode navParent = (DagNode) it.next();
			njNode.addParent(navParent);
			navParent.deleteChild(selNode);
			navParent.addChild(njNode);
		}
	
		njNode.deleteParent(selNode);
	
		selNode.deleteAllParents();
		selNode.addParent(njNode);
		selNode.deleteChild(njNode);
		selNode.addChild(njNode.getChild(0));
		njNode.getChild(i).setParent(selNode);
		njNode.deleteChild(njNode.getChild(0));
		njNode.addChild(selNode);
	
		StreamSelect selOp = new StreamSelectImp(selNode, parent);
		
		String entry =
					((Select) parent)
						.getExpression()
						.getRelatedColumnNames()[0]
						.getColumnName();
	
		if (selNode.getChild(0).getOperator() instanceof ExtractStream
			|| (selNode.getChild(0).getOperator() instanceof Navigate
				&& ((Navigate) selNode.getChild(0).getOperator())
					.getOutputColumnName()
					.equals(
					entry))) {
			p1.setFinalPosition(true);
			p1.setSwapped(true);
			return p1;
		}
	
		p1.setFinalPosition(false);
		p1.setSwapped(true);
		return p1;
	
	}
	
	public Object visit(StreamSelect parent, NatureJoin nj) {
	
		ReWriteResult p1 = new ReWriteResult();
	
		//push to an abitray one since it will be down to a sj anyway
		//XATOperator child = nj.getNode().getChild(0).getOperator();
		int i = findPushPos(parent, nj);
	
		DagNode selNode = (DagNode) parent.getNode();
		DagNode njNode = (DagNode) nj.getNode();
	
		for (Iterator it = selNode.getParents(); it.hasNext();) {
			DagNode navParent = (DagNode) it.next();
			njNode.addParent(navParent);
			navParent.deleteChild(selNode);
			navParent.addChild(njNode);
		}
	
		njNode.deleteParent(selNode);
	
		selNode.deleteAllParents();
		selNode.addParent(njNode);
		selNode.deleteChild(njNode);
		selNode.addChild(njNode.getChild(0));
		njNode.getChild(i).setParent(selNode);
		njNode.deleteChild(njNode.getChild(0));
		njNode.addChild(selNode);
	
		String entry =
			((Select) parent)
				.getExpression()
				.getRelatedColumnNames()[0]
				.getColumnName();
	
		if (selNode.getChild(0).getOperator() instanceof ExtractStream
			|| (selNode.getChild(0).getOperator() instanceof Navigate
				&& ((Navigate) selNode.getChild(0).getOperator())
					.getOutputColumnName()
					.equals(
					entry))) {
			p1.setFinalPosition(true);
			p1.setSwapped(true);
			return p1;
		}
	
		p1.setFinalPosition(false);
		p1.setSwapped(true);
		return p1;
	
	}*/

	/*protected int findPushPos(XATOperator parent, StructuralJoin child) {
	
		String entry = "";
	
		if (parent instanceof Navigate)
			entry = ((Navigate) parent).getEntryPoint()[0].getStepValue();
		else if (parent instanceof Select)
			entry =
				((Select) parent)
					.getExpression()
					.getRelatedColumnNames()[0]
					.getColumnName();
	
		DagNode sjNode = (DagNode) child.getNode();
	
		for (int i = 0; i < sjNode.getChildrenSize(); i++) {
			DagNode sjNodeChild = (DagNode) sjNode.getChild(i);
	
			while (!(sjNodeChild.getOperator() instanceof Extract)
				&& !(sjNodeChild.getOperator() instanceof StructuralJoin)) {
				sjNodeChild = (DagNode) sjNodeChild.getChild(0);
			}
	
			if (sjNodeChild.getOperator() instanceof Extract) {
				if (((Extract) (sjNodeChild.getOperator()))
					.getOutputColumnName()
					.equals(entry))
					return i;
			} else { //must be a structuraljoin
				if (findPushPos(parent,
					(StructuralJoin) sjNodeChild.getOperator())
					!= -1)
					return i;
			}
	
		}
	
		return -1;
	
	}*/

	/*
	 * parent must be navigate or select
	 */

	protected int findPushPos(XATOperator parent, XATOperator child) {
		
		//no operator can be pushed down to extract
		if (child instanceof Extract || child instanceof ExtractStream)
		 if (parent.getNode()==child.getNode().getParent())
		return -1;

		String entry = "";

		if (parent instanceof Navigate)
			entry = ((Navigate) parent).getEntryPoint()[0].getStepValue();
		else if (parent instanceof NavigateStream)
			entry = ((NavigateStream)parent).getEntryPoint()[0].getStepValue();
		else if (parent instanceof Select)
			entry =
				((Select) parent)
					.getExpression()
					.getRelatedColumnNames()[0]
					.getColumnName();
		else if (parent instanceof SelectStream)
			entry = ((SelectStream)parent).getExpression().getRelatedColumnNames()[0].getColumnName();
		

        DagNode parentNode = (DagNode)parent.getNode();
		DagNode childNode = (DagNode) child.getNode();

		XATOperator grandChildOp = childNode.getChild(0).getOperator();
		if ((child instanceof Select || child instanceof SelectStream)
			&& ((grandChildOp instanceof Extract 
					|| grandChildOp instanceof ExtractStream)
				|| (grandChildOp
					instanceof StructuralJoin)) || grandChildOp instanceof StructuralJoinStream) {
			//to avoid loop by switching two selects
			//continue;
			boolean hasInterNav = false;
			List interOps = FindOpVisitor.findAllInterOps(childNode, parentNode);
			for (Iterator it = interOps.iterator(); it.hasNext();){
				XATOperator interOp = (XATOperator)it.next();
				if (interOp instanceof Navigate || interOp instanceof NavigateStream){
					hasInterNav = true;
					break;
				}
			}
			
			if (!hasInterNav){
			//there is no intermediate navigate
			//find whether its navigate is in automata
			DagNode node = FindOpVisitor.findColGeneratingSource(parent, ((Select)parent).getExpression().getRelatedColumnNames()[0].getColumnName());
			if (!(node.getOperator() instanceof Extract || node.getOperator() instanceof ExtractStream) || navOnly)
			//sel's source is not in automata or not allow to push selection down
			return -1;
			}
			
			
		}
		
		if (child instanceof Navigate){
			if (((Navigate)child).getOutputColumnName().equals(entry) && childNode.getParent()!=parentNode)
			//push a selection to its the navigate which generates the entry
			//0 does not represent any thing			
			return -1;
			
		}else if (child instanceof NavigateStream){
			if (((NavigateStream)child).getOutputColumnName().equals(entry) && childNode.getParent()!=parentNode)
				//push a selection to its the navigate which generates the entry
				//0 does not represent any thing			
				return -1;
		}

		for (int i = 0; i < childNode.getChildrenSize(); i++) {
			DagNode childNodeChild = (DagNode) childNode.getChild(i);
			XATOperator njChildOp = childNodeChild.getOperator();

			if (njChildOp instanceof Extract) {
				if (((Extract) (childNodeChild.getOperator()))
					.getOutputColumnName()
					.equals(entry))
					return i;
			}else if (njChildOp instanceof ExtractStream) {
				if (((ExtractStream) (childNodeChild.getOperator()))
						.getOutputColumnName()
						.equals(entry))
						return i;
				}
			else {
				if (njChildOp instanceof Select
					|| njChildOp instanceof StreamSelect) {
					//if the parent and child are both select defined on the outputs of the same extract
					//no need to push in
					String childEntry =
						((Select) njChildOp)
							.getExpression()
							.getRelatedColumnNames()[0]
							.getColumnName();
					if (parent instanceof Select && entry == childEntry)
						continue;

				}else if (njChildOp instanceof SelectStream){
					String childEntry =
						((SelectStream) njChildOp)
							.getExpression()
							.getRelatedColumnNames()[0]
							.getColumnName();
					if (parent instanceof SelectStream && entry == childEntry)
						continue;
					
				}

				if (findPushPos(parent, childNodeChild.getOperator()) != -1)
					return i;
			}

		}

		return -1;

	}
	
	/*
	 * @param sjNode
	 * @param childNode
	 * move childNode above sjNode
	 */
	void swap(DagNode sjNode, DagNode childNode){
		//childNode must either be a navigate or select
		//has only one grandchild
	    DagNode grandChildNode = (DagNode)childNode.getChild(0);
	    grandChildNode.deleteParent(childNode);
	    grandChildNode.addParent(sjNode);
	    sjNode.addChild(grandChildNode);
	    sjNode.deleteChild(childNode);
	    childNode.deleteChild(grandChildNode);
	    childNode.deleteParent(sjNode);
	    childNode.addChild(sjNode);
	    DagNode grandParentNode = (DagNode)sjNode.getParent(0);
	    sjNode.deleteParent(grandParentNode);
	    sjNode.addParent(childNode);
	    childNode.addParent(grandParentNode);
	    grandParentNode.deleteChild(sjNode);
	    grandParentNode.addChild(childNode);  
		
		
	}
}
