/*
 * Created on Aug 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor;

import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.NatureJoin;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Navigate;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator.Extract;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.logicaloperator
	.StructuralJoin;

/**
 * @author suhong
 *
 * for push in only part of the nav operator
 * whether sel is pushed in depends on whether selection operator is added into the order vector
 */
public class NavPartialInRewriteRule extends GeneralRaindropRewriteRules {
	static int inAutoNavNum;
	static int inAutoSelNum;

	static int alreadyInAutoNavNum = 1;
	static int alreadyInAutoSelNum = 0;
	//a nav operator might be pushed multiple times, count it only as one nav pushed down
	List navChecked = new ArrayList();
	List selChecked = new ArrayList();

	public static void resetAlreadyInAutoNavNum() {
		alreadyInAutoNavNum = 1;
	}

	public static void resetAlreadyInAutoSelNum() {
		alreadyInAutoSelNum = 0;
	}

	public Object visit(Navigate parent, Extract child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		if (navChecked.contains(parent) || applyOnNav(parent)) {
			p1 = (ToAutomataRewriteResult) super.visit(parent, child);
			if (p1.isSwapped()){			
				//this navigate has been pushed down
				alreadyInAutoNavNum++;
				//navChecked.remove(parent);
			}

			return p1;
		}

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	public Object visit(Navigate parent, NatureJoin child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		if (navChecked.contains(parent) || applyOnNav(parent)) {
			p1 = (ToAutomataRewriteResult) super.visit(parent, child);
			return p1;
		}

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	public Object visit(Navigate parent, Select child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		if (navChecked.contains(parent) || applyOnNav(parent)) {
			p1 = (ToAutomataRewriteResult) super.visit(parent, child);
			return p1;
		}

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	public Object visit(Navigate parent, StructuralJoin child) {
		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		if (navChecked.contains(parent) || applyOnNav(parent)) {
			p1 = (ToAutomataRewriteResult) super.visit(parent, child);
			return p1;
		}

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	public Object visit(Select parent, XATOperator child) {

		ToAutomataRewriteResult p1 = new ToAutomataRewriteResult();

		//select should be pushed down as further as possible if outside automata
		if (inAutoSelNum == 0) {
			if (!(child instanceof StructuralJoin)
				&& !(child instanceof Extract))
				p1 = (ToAutomataRewriteResult) super.visit(parent, child);
			if (p1.getOnBoundary())
				p1.setFinalPosition(true);
			return p1;
		}

		if (selChecked.contains(parent) || applyOnSel(parent)) {
			p1 = (ToAutomataRewriteResult) super.visit(parent, child);
			if (p1.getInAuto())
				alreadyInAutoSelNum++;
			return p1;
		}

		p1.setSwapped(false);
		p1.setFinalPosition(true);
		return p1;

	}

	private boolean applyOnNav(Navigate parent) {
		DagNode node = (DagNode) parent.getNode();

		if (alreadyInAutoNavNum + 1 <= inAutoNavNum) {
			//there is selection defined on
			//alreadyInAutoNavNum++;
			navChecked.add(parent);
			return true;
		}

		return false;
	}

	private boolean applyOnSel(Select parent) {
		DagNode node = (DagNode) parent.getNode();

		if (alreadyInAutoSelNum + 1 <= inAutoSelNum) {
			//alreadyInAutoSelNum++;
			selChecked.add(parent);
			return true;
		}

		return false;

	}

}
