/*
 * move the specified tokenNav out, including the tokenNavs that are dependending on it
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.SelectStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByUnnestStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavCollectionStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavUnnestStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.TaggerStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.ExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.BranchStatistics;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.CopiedDag;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.CostComp;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.PlanManipulator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.RuntimeOptUtil;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.SimulateMoveResult;
import edu.wpi.cs.dsrg.xmldb.xat.component.statistics.StatisticsCollector;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SpecifiedNavPulloutRewriteRule extends GeneralRaindropRewriteRules {

	public SimulateMoveResult result;

	List removedSjs = new ArrayList();

	//these sj nodes appear in both plans before and after
	List affectedSjs = new ArrayList();

	List removedTokenNavs = new ArrayList();

	//the node nav derived from the pull out tokenNav
	List addedNodeNavs = new ArrayList();

	PureNavigateAutoStream targetTokenNav;

	//the nodenav derived from the tokenNav
	NavigateStream derivedNodeNav;

	CopiedDag tempPlan;

	Map newTokenNavToExtract = new HashMap();

	Map newSjToBranchStatistics = new HashMap();

	Map newEntryOpToInputSj = new HashMap();
	
	Map newBranchToStatistics = new HashMap();

	boolean extractAdded = false;

	public SpecifiedNavPulloutRewriteRule(SimulateMoveResult result,
			PureNavigateAutoStream targetTokenNav) {
		this.result = result;
		this.tempPlan = result.getTempPlan();
		this.targetTokenNav = targetTokenNav;
	}

	public Map getNewTokenNavToExtract() {
		return newTokenNavToExtract;
	}

	public Object visit(PureNavigateAutoStream parent,
			PureNavigateAutoStream child) {
		//parent is depending on child
		//pull parent first

		DagNode parentNode = tempPlan.getNewNodeFromOldNode((DagNode) parent
				.getNode());
		DagNode childNode = tempPlan.getNewNodeFromOldNode((DagNode) child
				.getNode());

		//mark the changed parts
		removedTokenNavs.add(parent);

		StructuralJoinStream destSj = (StructuralJoinStream) RuntimeOptUtil.getTokenNavToFanInSj()
				.get(parent);
		if (destSj != null)
			//not all tokennav has a destsj
			removedSjs.add(destSj);

		//whether the tokenNav is pulled beyond the input sj it was previous in
		Boolean movedBeyond = null;

		int parentSize = parentNode.getParentsSize();
		if (parentSize == 1) {
			DagNode grandParentNode = (DagNode) parentNode.getParent(0);
			//grandParentOp must be extract
			ExtractStream extractOp = (ExtractStream) grandParentNode
					.getOperator();

			movedBeyond = (Boolean) visit(extractOp, parent);
			if (parent == targetTokenNav)
				childNode.deleteParent(parentNode);
		} else {
			ExtractStream extractOp = null;
			for (Iterator it = parentNode.getParents(); it.hasNext();) {
				DagNode grandParent = (DagNode) it.next();
				XATStreamOperator grandParentOp = (XATStreamOperator) grandParent
						.getOperator();
				if (grandParentOp instanceof ExtractStream)
					extractOp = (ExtractStream) grandParentOp;
				else {
					if (grandParentOp instanceof PureNavigateAutoStream)
						visit(grandParentOp, parent);
					else
						visit(grandParentOp, parent);
				}

				if (grandParent.getOperator() != grandParentOp)
					//a tokenNav must have been converted into nodeNav
					//this new nodenav is no long the parent of the tokenNav
					it.remove();

			}

			movedBeyond = (Boolean) visit(extractOp, parent);
			childNode.deleteParent(parentNode);
		}

		return new AffectedPart(removedSjs, new ArrayList(), removedTokenNavs,
				new ArrayList(), affectedSjs, newTokenNavToExtract,
				newSjToBranchStatistics, newEntryOpToInputSj, newBranchToStatistics);
	}

	/*
	 * find the extract needed for pull out a tokenNav
	 */
	public ExtractStream findExtract(DagNode parentNodeNavNode,
			DagNode childTokenNavNode) {
		//try pull up the parentNodeNavNode first

		PureNavigateAutoStream childTokenNav = (PureNavigateAutoStream) childTokenNavNode
				.getOperator();
		ExtractStream tokenNavSiblingExtract = (ExtractStream) newTokenNavToExtract
				.get(childTokenNav);

		if (tokenNavSiblingExtract == null) {
			//there is no extract in the delta change
			//we want to see whether in the previous delta plan before, there
			// is already an extract
			XATStreamOperator fanInSj = (XATStreamOperator) RuntimeOptUtil.getTokenNavToFanInSj()
					.get(childTokenNav);
			tokenNavSiblingExtract = (ExtractStream) RuntimeOptUtil.tokenNavToExtract
					.get(childTokenNav);
			DagNode tokenNavSiblingExtractNode = tempPlan
					.getNode(tokenNavSiblingExtract);

			if (tokenNavSiblingExtractNode == null) {
				//					there is no such node in the original plan
				tokenNavSiblingExtractNode = new DagNodeImp();
				extractAdded = true;

				//this extract has never appeared in other plans
				if (tokenNavSiblingExtract == null){
					tokenNavSiblingExtract = new ExtractByUnnestStream(
							tokenNavSiblingExtractNode, childTokenNav
									.getEntryPoint(), childTokenNav
									.getDestination());
					tokenNavSiblingExtract.setOutputColumnName(childTokenNav
						.getOutputColumnName());
					tokenNavSiblingExtract.setStoringMethod(ExtractStream.DOM);
				}

				tokenNavSiblingExtractNode.setOperator(tokenNavSiblingExtract);
				//				  associate this node with its parent and child
				tokenNavSiblingExtractNode.addChild(childTokenNavNode);
				childTokenNavNode.addParent(tokenNavSiblingExtractNode);
				DagNode fanInSjNodeInTemp = tempPlan.getNode(fanInSj);
				fanInSjNodeInTemp.addChild(tokenNavSiblingExtractNode);
				tokenNavSiblingExtractNode.addParent(fanInSjNodeInTemp);

				newTokenNavToExtract.put(childTokenNav, tokenNavSiblingExtract);
				newEntryOpToInputSj.put(tokenNavSiblingExtract, fanInSj);
				tempPlan.registerOpToNode(tokenNavSiblingExtract,
						tokenNavSiblingExtractNode);

				//register this new operator, this snippet cannot be moved
				// before adding
				//children nodes to tokenNavSiblingExtract
				//because setupextractsta relies on the child info of the
				// tokenNavSiblingExtract
				RuntimeOptUtil.tokenNavToExtract.put(childTokenNav,
						tokenNavSiblingExtract);
				StatisticsCollector.setUpExtractSta(tokenNavSiblingExtract);
			}

		}

		return tokenNavSiblingExtract;
		//this new operator should be directly inserted between the
		// childTokenNavNode and the parentNodeNavNode
		/*
		 * tokenNavSiblingExtractNode.addChild(childTokenNavNode);
		 * childTokenNavNode.deleteParent(parentNodeNavNode);
		 * childTokenNavNode.addParent(tokenNavSiblingExtractNode);
		 * tokenNavSiblingExtractNode.addParent(childTokenNavNode);
		 * parentNodeNavNode.deleteChild(childTokenNavNode);
		 * parentNodeNavNode.addChild(tokenNavSiblingExtractNode);
		 */

		/*
		 * } else { //existing an extract before
		 * 
		 * //merge two branches
		 * 
		 * tokenNavSiblingExtractNode = tempPlan
		 * .getNewNodeFromOriginalOldNode((DagNode) tokenNavSiblingExtract
		 * .getNode()); RuntimeOptUtil.mergeTwoBranches(parentNodeNavNode,
		 * tokenNavSiblingExtractNode, tempPlan, false); }
		 * 
		 * return newExtract;
		 */
	}

	//return the strucutral join node that tokenNav's entry operators lies on
	public Object visit(StructuralJoinStream parent, NavigateStream child) {

		//if structural join has no navunnest or extractunnest
		//then child can be moved beyond parent
		DagNode parentNode = tempPlan.getNewNodeFromOldNode((DagNode) parent
				.getNode());
		//child is newly created, so its node is in temp plan rather in
		// original plan
		DagNode childNode = (DagNode) child.getNode();

		int childSize = parentNode.getChildrenSize();
		for (int i = 0; i < childSize; i++) {
			DagNode parentDescNode = (DagNode) parentNode.getChild(i);
			XATStreamOperator descOp = (XATStreamOperator) parentDescNode
					.getOperator();
			while (!(descOp instanceof ExtractStream)
					&& !(descOp instanceof StructuralJoinStream)) {
				if (descOp instanceof NavUnnestStream)
					//child cannot moved beyond parent
					return new Boolean(false);
				parentDescNode = (DagNode) parentDescNode.getChild(0);
				descOp = (XATStreamOperator) parentDescNode.getOperator();

			}
			//descOp is either extractstream or structuraljoinstream
			if (descOp instanceof ExtractByUnnestStream)
				return new Boolean(false);
		}

		//if parent has further structuraljoin
		DagNode ancesNode = (DagNode) parentNode.getParent(0);
		XATStreamOperator ancesOp = (XATStreamOperator) ancesNode.getOperator();
		while (!(ancesOp instanceof TaggerStream)) {
			if (ancesOp instanceof StructuralJoinStream) {
				//continue to swap

				swap(parentNode, childNode);
				Boolean movedBeyond = (Boolean) visit(childNode.getParent(0)
						.getOperator(), child);
				if (child.getOutputColumnName().equals(
						targetTokenNav.getOutputColumnName())
						&& !movedBeyond.booleanValue()) {
					//only if the nodeNav is derived from the target tokenNav
					AffectedSj moreAffectedSj = new AffectedSj(
							(StructuralJoinStream) ancesOp, parent,
							extractAdded, false, false);
					affectedSjs.add(moreAffectedSj);
				}
				//moved beyond the structural join
				return new Boolean(true);
			}
			ancesNode = (DagNode) ancesNode.getParent(0);
			ancesOp = (XATStreamOperator) ancesNode.getOperator();
		}

		return new Boolean(false);

	}

	/*
	 * merge parent + child -> nodeNav node @param Object a boolean indicate
	 * whether the nodeNav stays in the same input sj as before
	 */
	public Object visit(ExtractStream parent, PureNavigateAutoStream child) {
		//whether this converted nodeNav can be moved beyond
		boolean moveBeyond = false;

		DagNode childNode = tempPlan.getNewNodeFromOldNode((DagNode) child
				.getNode());
		DagNode parentNode = tempPlan.getNewNodeFromOldNode((DagNode) parent
				.getNode());

		NavigateStream newOp = (NavigateStream) RuntimeOptUtil.nodeNavToTokenNav
				.get(child);
		if (newOp == null) {
			//there is never such an operator before
			if (parent instanceof ExtractByUnnestStream)
				newOp = new NavUnnestStream(childNode, child.getEntryPoint(),
						child.getDestination());
			else
				newOp = new NavCollectionStream(childNode, child
						.getEntryPoint(), child.getDestination());

			newOp.setOutputColumnName(child.getOutputColumnName());
		} else
			childNode.setOperator(newOp);

		List newEvalOrder = new ArrayList();
		newEvalOrder.add(newOp.getNode().getChild(0).getOperator());
		newOp.setBranchEvalOrder(newEvalOrder);

		if (child == targetTokenNav)
			derivedNodeNav = newOp;

		addedNodeNavs.add(newOp);

		//register newOp
		RuntimeOptUtil.nodeNavToTokenNav.put(newOp, child);
		tempPlan.registerOpToNode(newOp, childNode);

		//remove the extract operator
		childNode.deleteParent(parentNode);
		int grandParentSize = parentNode.getParentsSize();
		for (int k = 0; k < grandParentSize; k++) {
			DagNode grandParentNode = (DagNode) parentNode.getParent(k);
			childNode.addParent(grandParentNode);
			grandParentNode.addChild(childNode);
			grandParentNode.deleteChild(parentNode);
		}

		//move this nodeNav as high as possible
		//the nodenav cannot be moved beyond any parent navigates
		//nodenav can be only moved beyond select/structural join
		DagNode curParentNode = (DagNode) childNode.getParent(0);
		XATStreamOperator curParentOp = (XATStreamOperator) curParentNode
				.getOperator();

		StructuralJoinStream inputSj = PlanManipulator.findInputSj(child);

		XATStreamOperator extract = findExtract(childNode, (DagNode) childNode
				.getChild(0));
		DagNode extractNode = tempPlan.getNode(extract);

		if (!(curParentOp instanceof NavigateStream))
			moveBeyond = ((Boolean) visit(curParentOp, newOp)).booleanValue();

		//create extract or associate extract with appropriate subplan
		if (child.getOutputColumnName().equals(
				targetTokenNav.getOutputColumnName())) {
			if (moveBeyond) {
				//newOp has found a postition
				AffectedSj affectedSj = new AffectedSj(inputSj, extract,
						extractAdded, false, false);
				affectedSjs.add(affectedSj);
			} else {
				AffectedSj affectedSj = new AffectedSj(inputSj, extract,
						extractAdded, false, false);
				affectedSjs.add(affectedSj);
			}
		}

		//newOp must be inserted above extract
     
		if (isMergable(childNode, extractNode)){
			BranchStatistics newBranchSta = CostComp.mergeTwoBranches(childNode, extractNode, tempPlan, removedSjs, affectedSjs, newEntryOpToInputSj);
			newBranchToStatistics.put(extract, newBranchSta);
		}else{  
			//nomergable
			DagNode grandChildNode = (DagNode)childNode.getChild(0);
			childNode.deleteChild(grandChildNode);
			grandChildNode.deleteParent(childNode);
			childNode.addChild(extractNode);
			extractNode.addParent(childNode);
			BranchStatistics newBranchSta = CostComp.computeBranchStatistics(extractNode);
			newBranchToStatistics.put(extract, newBranchSta);			
		}
		//reset extratAdded
		extractAdded = false;

		return null;

	}

	public Object visit(SelectStream parent, NavigateStream child) {
		String outputCol = child.getOutputColumnName();

		//check whether the condition needs child
		ExpressionStr expression = parent.getExpression();
		ColumnName[] columns = expression.getRelatedColumnNames();
		int columnNum = columns.length;

		for (int i = 0; i < columnNum; i++) {
			ColumnName columnName = columns[i];
			if (columnName.getColumnName().equals(outputCol))
				//cannot move beyond
				return new Boolean(false);
		}

		//can move beyond

		//		push to be underneath select since it will be down to a sj anyway
		XATNode parentNode = tempPlan.getNewNodeFromOldNode((DagNode) parent
				.getNode());
		XATNode childNode = tempPlan.getNewNodeFromOldNode((DagNode) child
				.getNode());

		parentNode.setOperator(child);
		childNode.setOperator(parent);

		return visit(parent, parentNode.getChild(0).getOperator());

	}
	
	/*
	 * @param activeSourceNode DagNode
	 * @param passiveSourceNode DagNode
	 * @return boolean whether activeSourceNode can be merged onto passiveSourceNode
	 */
	private boolean isMergable(DagNode activeSourceNode,
			DagNode passiveSourceNode){
		//if any of its descendant is a navunnest, unmergable
		DagNode passiveNode = (DagNode)passiveSourceNode.getParent();
		XATStreamOperator passiveOp = (XATStreamOperator)passiveNode.getOperator();
		String unnestEntry = "";
		
		while (!(passiveOp instanceof StructuralJoinStream)){
			if (passiveOp instanceof NavUnnestStream){
				unnestEntry = ((NavUnnestStream)passiveOp).getEntryPoint()[0].getStepValue();
				break;
			}
			passiveNode = (DagNode)passiveNode.getParent();
			passiveOp = (XATStreamOperator)passiveNode.getOperator();
		}
		
		if (!unnestEntry.equals("")){
			//exist an unnest
			DagNode activeNode = activeSourceNode;
			XATStreamOperator activeOp = (XATStreamOperator)activeNode.getOperator();
			while (!(activeOp instanceof StructuralJoinStream)){
				if (activeOp instanceof NavigateStream){
					if (((NavigateStream)activeOp).getEntryPoint()[0].getStepValue().equals(unnestEntry))
						return false;
				}
				activeNode = (DagNode)activeNode.getParent();
				activeOp = (XATStreamOperator)activeNode.getOperator();
			}
		}
		return true;
	}
	
	
	
	

}