package edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator;

/**
 * Insert the type's description here.
 * Creation date: (2003-1-12 19:30:16)
 * @author: JinHui Jian
 */

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;

public class StreamNavigateImp extends XATStreamOperatorImp implements StreamNavigate {
	//entry point of the navigate node
	protected NavigationStep[] entry;

	//destination of the navigate node
	protected NavigationStep[] dest;
/**
 * StreamNavigateImp constructor comment.
 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public StreamNavigateImp(XATNode node) {
	super(node);
}
/**
 * StreamNavigateImp constructor comment.
 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public StreamNavigateImp(XATNode node,Navigate nav) {
	super(node);
	this.entry = nav.getEntryPoint();
	this.dest = nav.getDestination();
	this.setOutputColumnName(nav.getOutputColumnName());
	
}
/**
 * getBinding method comment.
 */
public String getBinding() {
	return getOutputColumnName();
}
/**
 * getDestination method comment.
 */
public NavigationStep[] getDestination() {
	return dest;
}
 /** @return NavigationStep entry point*/
public NavigationStep[] getEntryPoint() {
	return entry;
}
/**
 * printNode method comment.
 */
public String printNode() {
	return null;
}
/**
 * Runs the actual operator.
 *
 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
 * because the StreamOperators represent physical operators instead of Logic.
 * Creation date: (2003-1-12 19:30:16)
 */
public boolean run() {
return true;
}
/**
 * setBinding method comment.
 */
public void setBinding(String bind) {
  setOutputColumnName(bind);
}
/**
 * setDestination method comment.
 */
public void setDestination(NavigationStep[] destination) {
	this.dest = destination;
}
 /**
     * Set Entry Point. It will traverse the DOM tree to evaluate the XPath.
     * @param ept New entry point for this navigation operator.
     */
public void setEntryPoint(NavigationStep[] ept) {
	this.entry = ept;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-1-12 22:00:03)
 * @return java.lang.String
 */
public String toString() {
	StringBuffer sb = new StringBuffer();
	sb.append("StreamNavigate (");
	sb.append(getBinding());
	sb.append(" ");
	for (int i=0; i< entry.length; i++)
		  sb.append(entry[i]+"/");
	  
		for (int i=0; i< dest.length; i++)
		  sb.append(dest[i]+"/");
	sb.append(")");
	return sb.toString();

}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperatorImp#init()
 */
public void init() {
	// TODO Auto-generated method stub
	
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
 */
public String toToolTipString() {
	// TODO Auto-generated method stub
	return null;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getStateSize()
 */
public int getStateSize() {
	// TODO Auto-generated method stub
	return 0;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
 */
public boolean cleanAccumulatedTuples(long maxtimestamp) {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
 */
public boolean cleanAllAccumulatedTuples() {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
 */
public boolean matchStates(XATStreamOperator op) {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
 */
public boolean hasUnmatchedState() {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
 */
public boolean recomputeUnmatchedState() {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
 */
public int setStateID(int startID) {
	// TODO Auto-generated method stub
	return 0;
}
}
