package edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator;

/**
 * Insert the type's description here.
 * Creation date: (2003-1-12 19:49:16)
 * @author: JinHui Jian
 */
import java.util.*;
 
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;

public class StreamSelectImp extends XATStreamOperatorImp implements StreamSelect {
	protected Expression expression;
/**
 * StreamSelectImp constructor comment.
 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public StreamSelectImp(XATNode node) {
	super(node);
}
/**
 * StreamSelectImp constructor comment.
 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public StreamSelectImp(XATNode node, Select sel) {
	super(node);
	this.expression = sel.getExpression();
}
 /** Get select expression. */
public Expression getExpression() {
	return expression;
}
/**
 * Runs the actual operator.
 *
 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
 * because the StreamOperators represent physical operators instead of Logic.
 * Creation date: (2003-1-12 19:49:16)
 */
public boolean run() {return true;}
 /**
     * Set select expression.
     * @return original expression.
     * @param new_expression New Select expression.
     */
public void setExpression(Expression new_expression) {
	expression = new_expression;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-1-12 22:00:29)
 * @return java.lang.String
 */
public String toString() {
	StringBuffer sb = new StringBuffer();
	sb.append("StreamSelect (");
	sb.append(getExpression());
	sb.append(")");
	sb.append("<");
	Set schema = this.getNode().getSchema();
	for(Iterator it = schema.iterator();it.hasNext();){
		String s = (String)it.next();
		sb.append(s + ", ");
	}
	sb.append(">");
	return sb.toString();

}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperatorImp#init()
 */
public void init() {
	// TODO Auto-generated method stub
	
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
 */
public String toToolTipString() {
	// TODO Auto-generated method stub
	return null;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getStateSize()
 */
public int getStateSize() {
	// TODO Auto-generated method stub
	return 0;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAccumulatedTuples(long)
 */
public boolean cleanAccumulatedTuples(long maxtimestamp) {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#cleanAllAccumulatedTuples()
 */
public boolean cleanAllAccumulatedTuples() {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#matchStates(edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator)
 */
public boolean matchStates(XATStreamOperator op) {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#hasUnmatchedState()
 */
public boolean hasUnmatchedState() {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#recomputeUnmatchedState()
 */
public boolean recomputeUnmatchedState() {
	// TODO Auto-generated method stub
	return false;
}
/* (non-Javadoc)
 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#setStateID(int)
 */
public int setStateID(int startID) {
	// TODO Auto-generated method stub
	return 0;
}
}
