/*
 * Created on Jan 28, 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author hong su
 *
 *  common data structures for graphs
 */
public class GraphImp implements Graph {
	//assume there would be no more than 10  outputs
	private Vector topEntries = new Vector();
	private Vector bottomEntries = new Vector();
	
	

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.Graph#getBottomEntries()
	 */

	public GraphImp() {
		super();
	}
	
    
	public GraphImp(GraphNode topEntry) {
		this.topEntries.add(topEntry);
	}

	public Vector getBottomEntries() {
		return bottomEntries;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.Graph#getTopEntries()
	 */
	public Vector getTopEntries() {
		return topEntries;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.Graph#setBottomEntries(edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode[])
	 */
	public void addTopEntry(GraphNode topEntry) {
		topEntries.add(topEntry);
	}
	
	public void deleteTopEntry(GraphNode topEntry){
		topEntries.remove(topEntry);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.Graph#setTopEntries(edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode[])
	 */
	public void setBottomEntries(Vector bottomEntries) {
		this.bottomEntries = bottomEntries;

	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.Graph#addTopEntry(edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode)
	 */
	public void addBottomEntry(GraphNode bottomEntry) {
		bottomEntries.add(bottomEntry);

	}

	protected String childrenString(GraphNode node, String indent) {
		if (node == null)
			return indent + "\n";
		String sOutput = indent + node.toString() + "\n";
		String newIndent = indent + "  ";
		GraphNode[] children = node.getChildren();
		for (int i = 0; i < children.length; i++) {
			sOutput = sOutput + childrenString(children[i], newIndent);
		}
		return sOutput;
	}

	public String toString() {
		String out = new String("");
		for (Iterator it = getTopEntries().iterator(); it.hasNext();){
			out = out + childrenString((GraphNode)it.next(), "");
		}
		return out;

	}

	/* 
	 * set the bottom entries of the graph by traversing it
	 */
	public void setBottomEntries() {
		Vector leaves = new Vector();
	   for (Iterator it = topEntries.iterator(); it.hasNext();){
	   	  GraphNode topEntry = (GraphNode)it.next();
	   	  leaves.addAll(leavesOf(topEntry));
	   }
      
       bottomEntries = leaves;
	}

	/* (non-Javadoc)
		 * @return Vector the leaves of the tree rooted at qn
		 */
	private Vector leavesOf(GraphNode qn) {
		Vector leaves = new Vector();
		GraphNode[] children = qn.getChildren();
		int childrenSize = children.length;
		for (int i = 0; i < childrenSize; i++)
			if (children[i].getChildrenSize() == 0)
				//a leave
				leaves.add(children[i]);
			else
				//not a leave
				leaves.addAll(leavesOf(children[i]));

		return leaves;
	}	

}
