/*
 * Created on Jan 28, 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo;

import java.util.*;

/**
 * @author hong su
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public interface GraphNode extends Cloneable {
	
int addChild(GraphNode new_child);
/**
 * Add one child to this node. 
 * @return Number of children.
 * @param new_child New child node.
 * @position the position of this node.
 */
int addChild(GraphNode new_child, int position);

/**
 * Delete a child from this node.
 * @return number of children.
 * @param child the to-be-deleted child.
 */
int deleteChild(GraphNode child);
/**
 * Get a specific child node of this node by their position.
 * @param position The position of the child node.
 */

GraphNode getChild(int position);
/** Get all the children nodes of this node. */
GraphNode[] getChildren();
boolean containChildWithName(String childName);
/**
 * Returns how many children this node has
 * @return int
 */
int getChildrenSize();

/** Get the parent node of this node. If the caller has multiple parent nodes, return the first one*/
GraphNode getParent();
/*
 * Returns an Iterator of all of the parents.  
 */
Iterator getParents();
/**
 * Get a position for a specific child node.
 * If not found, return -1.
 * @param child node's reference.
 * @return Position of this child.
 */
int locateChild(GraphNode child);
/**
 * Set a specific child to be a new child node.
 * @return original child node.
 * @param position The position of the child node.
 * @param new_child The new child node.
 */
GraphNode setChild(int position, GraphNode new_child);
/**
 * Set all the children nodes of this node.
 * @return original children.
 * @param new_children new children nodes.
 */
GraphNode[] setChildren(GraphNode[] new_children);

GraphNode setParent(GraphNode new_parent);
void  addParent(GraphNode new_parent);
void removeParent(GraphNode parent);
void removeAllChildren();
ArrayList traversal();
String getTagName();
void setTagName(String tagName);
List getParentList();


}


