/*
 * Created on Jan 28, 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 * @author hong su
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class GraphNodeImp implements GraphNode {

	protected List parents = new ArrayList();

	protected Vector children = new Vector();

	protected String tagName;
	
	
	
	
	public GraphNodeImp(){
	   super();	
	}
	
	public GraphNodeImp(String tagName){
		this.tagName = tagName;
	}

	public String getTagName() {
		return tagName;
	}

	public void setTagName(String tagName) {
		this.tagName = tagName;
	}

	/**
		* Add one child to this node. This should be called only by the XATTree.addNode().
		* Remember the children are order unsensitive.
		* @return Number of children.
		* @param new_child New child node.
		*/
	public int addChild(GraphNode new_child) {
		if ((new_child != null) && !children.contains(new_child))
			children.addElement(new_child);
		return children.size();
	}
	
	
	
	/**
		* Add one child to this node. This should be called only by the XATTree.addNode().
		* Remember the children are order unsensitive.
		* @return Number of children.
		* @param new_child New child node.
		* @position the position of this node.
		*/
	public int addChild(GraphNode new_child, int position) {
		children.insertElementAt(new_child, position);
		return children.size();
	}

	/**
		* Delete a child from this node.
		* @return number of children.
		* @param child the to-be-deleted child.
		*/
	public int deleteChild(GraphNode child) {
		children.removeElement(child);
		return children.size();
	}
	/**
		* Get a specific child node of this node by their position.
		* @param position The position of the child node.
		*/
	public GraphNode getChild(int position) {
		try {
			return (GraphNode) children.elementAt(position);
		} catch (ArrayIndexOutOfBoundsException e) {
			throw new RuntimeException();
		}
	}
	/** Get all the children nodes of this node. */
	public GraphNode[] getChildren() {
		/* hideous, hideous kludge... java is too pedantic */
		return (GraphNode[]) children.toArray(new GraphNode[] {
		});
	}

	/** Get the parent node of this node. */
	public GraphNode getParent() {
		return (parents.size() > 0) ? (GraphNode) parents.get(0) : null;
	}

	/**
		* Set a specific child to be a new child node.
		* @return original child node.
		* @param position The position of the child node.
		* @param new_child The new child node.
		*/
	public GraphNode setChild(int position, GraphNode new_child) {
		try {
			GraphNode tmp = null;
			if (children.size() > position) {
				tmp = (GraphNode) children.elementAt(position);
				children.setElementAt(new_child, position);
			} else {
				children.addElement(new_child);
			}
			return tmp;
		} catch (NullPointerException e) {
			throw new RuntimeException();
		}
	}
	/**
		* Set all the children nodes of this node.
		* @return original children.
		* @param new_children new children nodes.
		*/
	public GraphNode[] setChildren(GraphNode[] new_children) {
		Vector tmp = children;
		int i;
		int length = Array.getLength(new_children);
		children = new Vector(length);
		for (i = 0; i < length; i++) {
			children.addElement(new_children[i]);
		}
		return (GraphNode[]) children.toArray(new GraphNode[] {
		});
	}

	/**
		* Set the parent node of this node.
		* @return original parent of this node.
		* @param new_parent new parent of this node.
		*/
	public GraphNode setParent(GraphNode new_parent) {

		GraphNode tmp = getParent();
		if (parents.size() > 0) {
			parents.set(0, new_parent);
		} else {
			parents.add(new_parent);
		}
		return tmp;

	}

	/**
		* Returns how many children this node has
		* @return int
		*/
	public int getChildrenSize() {
		return children.size();
	}

	/**
		* Returns an Iterator of all of the parents.  The XATNode only
		* has one parent, thus this iterator will only contain
		* one element.  However, subclasses may have multiple parents, thus
		* nothing is lost by placing this method here
		* @return Iterator of parents
		*/
	public java.util.Iterator getParents() {
		return parents.iterator();
	}

	/**
		* Get a position for a specific child node.
		* If not found, return -1.
		* @param child node's reference.
		* @return Position of this child.
		*/
	public int locateChild(GraphNode child) {
		return children.indexOf(child);
	}

	public Object clone() {
		Object o = null;
		try {
			o = super.clone();
		} catch (CloneNotSupportedException e) {
		}

		return o;
		//return super.clone();
		/*	   Object newNode = new GraphNodeImp();
			   
			   int parentNum = parent.size();  	   
			   
			   for (int i=0; i<parentNum; i++)
			   	parent.add(((GraphNode)parent.get(i)).clone());   	   	
			      	   
			   int childrenNum = children.size();
			   
			   for (int i=0; i<childrenNum; i++)
			    children.add(((GraphNode)children.get(i)).clone());
			   
			   return newNode;*/
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode#removeAllChildren()
	 */
	public void removeAllChildren() {

		children.clear();
	}

	public ArrayList traversal() {
		ArrayList results = new ArrayList();
		results.add(this);

		if (children != null) {
			for (Iterator it = children.iterator(); it.hasNext();) {
				results.addAll(((GraphNode) it.next()).traversal());
			}
		}

		return results;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode#containChild(edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode)
	 */
	public boolean containChildWithName(String childName) {
		for (Iterator it = children.iterator(); it.hasNext();) {
			GraphNode child = (GraphNode) it.next();
			if (child.getTagName().equals(childName))
				return true;

		}

		return false;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode#addParent(edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode)
	 */
	public void addParent(GraphNode new_parent) {
		parents.add(new_parent);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode#removeParent(edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode)
	 */
	public void removeParent(GraphNode parent) {
		parents.remove(parent);
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode#getParentList()
	 */
	public List getParentList() {
		return parents;
	}
	
	
}
