/*
 * Created on Jan 29, 2004
 *
 * graph constructing out of the plan, describing the structural pattern
 * targetted in the automata
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.utils.DagTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.FindOpVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.PureNavigateAutoStream;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.SuspensionEdge;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.XMLScanStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;

/**
 * @author hong su
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class QueryGraph extends GraphImp implements Graph {
	String sourceName = null;
	//from an auto state to a qgn
	HashMap autoStateToTraceStates = new HashMap();
	public static int POP = 0;
	public static int PUSH = 1;

	/**
	 * @param bottomEntry
	 */
	public QueryGraph(QueryGraphNode qgn) {
		super(qgn);
	}

	public String getSourceName() {
		return sourceName;
	}

	public void setSourceName(String sourceName) {
		this.sourceName = sourceName;
	}

	public HashMap getAutoStateToTraceStates() {
		return autoStateToTraceStates;
	}

	public QueryGraphNode getQgn(XATStreamOperator extract) {
		Vector curNodes = new Vector();
		curNodes.addAll(getTopEntries());

		XATOperator nav = extract.getNode().getChild(0).getOperator();

		while (curNodes.size() > 0) {
			Vector newCurNodes = new Vector();
			for (Iterator it = curNodes.iterator(); it.hasNext();) {
				QueryGraphNode curNode = (QueryGraphNode) it.next();
				if (curNode.getOpsOnDest().contains(nav))
					return curNode;
				newCurNodes.addAll(curNode.children);
			}

			curNodes = newCurNodes;
		}

		return null;
	}
	
	/*
	 * when a compuation is suspended, intermediate results must be cleaned in order not to be output later
	 */

	public void setupGroupbyOpsNeededClean(ExtendedState state) {

		List edges = new ArrayList();
		edges.addAll(state.getSuspensionEdgesAtPop());
		int numOfPop = edges.size();
		edges.addAll(state.getSuspensionEdgesAtPush());

		for (int i = 0; i < edges.size(); i++) {
			SuspensionEdge edge = (SuspensionEdge) edges.get(i);

			XATStreamOperator checkedOp =
				(XATStreamOperator) edge.getCheckedOp();

			List checkedOpDesc = new ArrayList();
			List checkedOpBetween = new ArrayList();

			//the furtherest ancestor entry 
			ExtendedState partitionState =
				(ExtendedState) edge.getPartitionStates().get(
					edge.getPartitionStates().size() - 1);

			if (checkedOp != null) {
				checkedOpDesc =
					FindOpVisitor.getDescNodes((DagNode) checkedOp.getNode());
				XATStreamOperator checkedOpSJ =
					(XATStreamOperator) FindOpVisitor.findNearestAncestorSJ(
						(DagNode) checkedOp.getNode());
				checkedOpBetween =
					FindOpVisitor.findInterOps(
						(DagNode) checkedOp.getNode(),
						(DagNode) checkedOpSJ.getNode());
			} else {
				//ExtendedState entryState = state.getEntryState();
				List navs = state.getEntryNavOps();
				for (Iterator it2 = navs.iterator(); it2.hasNext();) {
					//e.g., extract(,/sameAddr)
					ExtractStream extract =
						FindOpVisitor.findAssociatedExtract(
							(DagNode) ((XATStreamOperator) it2.next())
								.getNode());
					//e.g, select(sameAddr!="")
					List groupbyOps = partitionState.getGroupbyOps();
					DagNode partitionOpNode =
						(DagNode) ((XATStreamOperator) groupbyOps
							.get(groupbyOps.size() - 1))
							.getNode();
					List extractAnces =
						FindOpVisitor.findInterOps(
							(DagNode) ((XATStreamOperator) extract).getNode(),
							partitionOpNode);
					checkedOpBetween.add(extract);
					checkedOpBetween.addAll(extractAnces);
					//checkedOpBetween.add(partitionOpNode.getOperator());
				}

			}

			List cleanOps = new ArrayList();
			XATStreamOperator highestGroupby =
				(XATStreamOperator) partitionState.getGroupbyOps().get(
					partitionState.getGroupbyOps().size() - 1);
			//operators between checkop and highestGroupby 
			List descNodes =
				DagTraversal.dagTopDownTraverse(
					(DagNode) highestGroupby.getNode());
			//do not include the highest group by itself
			descNodes.remove(highestGroupby.getNode());

			for (Iterator it2 = descNodes.iterator(); it2.hasNext();) {
				DagNode descNode = (DagNode) it2.next();
				XATStreamOperator descOp =
					(XATStreamOperator) descNode.getOperator();
				if (!checkedOpDesc.contains(descNode)
					&& !checkedOpBetween.contains(descOp)
					&& //no duplicates
				/*!partitionState
					.groupbyOpsNeededClean
					.contains(
						descNode.getOperator())
					&&*/
					!(descOp instanceof PureNavigateAutoStream)
						&& !(descOp instanceof XMLScanStream)
					//&& descNode.getOperator() instanceof ExtractStream
						&& descOp != checkedOp)
				//	if ((i < numOfPop && needCleanUp(state, descOp, POP))
				//		|| (i >= numOfPop && needCleanUp(state, descOp, PUSH)))
						cleanOps.add(descNode.getOperator());
			}

			//partitionState.getGroupbyOpsNeededClean().put(edge, cleanOps);
			partitionState.getGroupbyOpsNeededClean().put(edge, cleanOps);
		}

	}

	/*
	 * find whether testOp needs to be cleaned up when checkedOp is checked by suspension edge and fails
	 * @param testOp XATStreamOperator the operator that needs to be decided whether clean up is needed
	 * @param checkedOp XATStreamOperator
	 */
	boolean needCleanUp(
		ExtendedState initiatingState,
		XATStreamOperator testOp,
		int suspensionMethod) {

		List initiatingTraceStates =
			(List) autoStateToTraceStates.get(initiatingState);

		//find the tracestate of the testop
		XATStreamOperator extractDescForTest =
			FindOpVisitor.findExtractDesc((DagNode) testOp.getNode());

		QueryGraphNode testedQgn = getQgn(extractDescForTest);
		List testedStates = testedQgn.getTraceStates();

		for (Iterator it = testedStates.iterator(); it.hasNext();) {
			TraceState testedState = (TraceState) it.next();
			for (Iterator it2 = initiatingTraceStates.iterator();
				it2.hasNext();
				) {
				TraceState initiatingTraceState = (TraceState) it2.next();
				if (!initiatingTraceState
					.before(testedState, suspensionMethod)){
					//since not necessary the tested state occur after initiatingstate
					//it needs clean up
					if (initiatingTraceState==testedState)
					{
						//two states are the same
						//if the method is push, then there cannot be outputs yet
						if (suspensionMethod == QueryGraph.PUSH)
						return false;
					}
				return true;
				}
			}
		}

		return false;
	}

	/*
		 * 
		 */
	public void setUpCleanOps(ExtendedAutomata[] autos) {
		for (int i = 0; i < autos.length; i++) {
			ExtendedAutomata auto = autos[i];
			for (Iterator it = auto.getStates().iterator(); it.hasNext();) {
				ExtendedState state = (ExtendedState) it.next();
				setupGroupbyOpsNeededClean(state);

			}

		}
	}

}
