/*
 * Created on Jan 29, 2004
 *
 * graph for the schema
 * each node can have multiple children or multiple parents
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo;

import java.util.Collection;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

/**
 * @author hong su
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class SchemaGraph extends GraphImp implements Graph {

	/**
	 * @param bottomEntry
	 */

	//	given a doc element type, find its according schema graph nodes (can be more than one)
	//e.g., USAddress->shipTo, billTo
	private Hashtable typeToNodesMapper = new Hashtable();
	//give a element name, find its corresponding schema graph nodes (can be only one)
	private Hashtable nameToNodeMapper = new Hashtable();

	//given a sgn, find sorted type underneath it
	private HashMap sgnToSortedTypes = new HashMap();

	public void addNodesForType(SchemaGraphNode sgn, String type) {
		Vector sgnsOfSameTypes = (Vector) typeToNodesMapper.get(type);
		if (sgnsOfSameTypes == null)
			sgnsOfSameTypes = new Vector();
		else
			sgnsOfSameTypes = (Vector) typeToNodesMapper.get(type);

		sgnsOfSameTypes.add(sgn);
		typeToNodesMapper.put(type, sgnsOfSameTypes);
	}

	public void setNodeForName(SchemaGraphNode sgn, String name) {
		nameToNodeMapper.put(name, sgn);
	}

	public Vector getNodesForType(String name) {
		return (Vector) typeToNodesMapper.get(name);
	}

	public SchemaGraphNode getNodeForName(String name) {
		return (SchemaGraphNode) nameToNodeMapper.get(name);
	}

	protected SchemaGraphNode findRoot() {

		Collection c = nameToNodeMapper.values();

		for (Iterator it = c.iterator(); it.hasNext();) {
			SchemaGraphNode sgn = (SchemaGraphNode) it.next();
			if (sgn.getParent() == null) {
				//has no parent, it must then be the root
				//there is only root, i.e., the type of the root element of the XML document conforming to this schema
				addTopEntry(sgn);
				return sgn;
			}
		}

		return null;

	}

	protected String childrenString(
		SchemaGraphNode node,
		String indent,
		SchemaGraphNode parent) {
		if (node == null)
			return indent + "\n";
		String sOutput = indent + node.toString(parent) + "\n";
		String newIndent = indent + "  ";
		GraphNode[] children = node.getChildren();
		for (int i = 0; i < children.length; i++) {
			sOutput =
				sOutput
					+ childrenString(
						(SchemaGraphNode) children[i],
						newIndent,
						node);
		}
		return sOutput;
	}

	

	public String toString() {
		String out = new String("");
		for (Iterator it = getTopEntries().iterator(); it.hasNext();) {
			out = out + childrenString((SchemaGraphNode) it.next(), "", null);
		}
		return out;

	}

}
