/*
 * Created on Mar 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.XATStreamOperator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;

/**
 * @author suhong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TraceState implements Cloneable {

	//	trace node is used as the state in the production automata

	private SchemaGraphNode sgn;
	private TraceState parentTraceState;
	private QueryGraphNode qgn;

	//private TraceState nextSiblingTraceState;
	private List childrenTraceStates = new ArrayList();

	//a tracestate might be a general state representing a union of concrete trace states
	private boolean unionTraceState = false;
	private List unionTraceStates = new ArrayList();

	//e.g., <!element a (b|(c, d)|(e, f))>
	//if a an entry, then b's exclusive types are{c, d, e, f}
	//we do not distinguish that (c,d) are together and (e,f) are together
	//however we must distinguish which start state the exclusive states are defined in relative to
	private Map exclusiveSgns = new HashMap();

	private Map sureExclusiveSgns = new HashMap();

	static int globalId = 0;
	private Integer stateId;

	//hsahed on a query tree node, whether it has been taken care by occurrence rule
	//e.g.,   a                a
	//        |             /    \   
	//        b          choice   d
	//                    /  \ 
	//                   b    c
	//even though b is not guaranteed to appear within a, we can use c as the ending marks
	//instead of using d 
	private List takenCareByOccur = new ArrayList();

	public TraceState(SchemaGraphNode sgn, TraceState parentTraceState) {
		this.sgn = sgn;
		this.parentTraceState = parentTraceState;
		if (parentTraceState != null)
			parentTraceState.childrenTraceStates.add(this);
		globalId++;
		stateId = new Integer(globalId);
	}

	public void setQueryGraphNode(QueryGraphNode qgn) {
		this.qgn = qgn;
	}

	public TraceState(
		SchemaGraphNode sgn,
		QueryGraphNode qgn,
		TraceState parentTraceState) {
		this.sgn = sgn;
		this.qgn = qgn;
		this.parentTraceState = parentTraceState;
		if (parentTraceState != null)
			parentTraceState.childrenTraceStates.add(this);
		globalId++;
		stateId = new Integer(globalId);
	}

	public QueryGraphNode getQgn() {
		return qgn;
	}

	public void addUnionTraceState(TraceState unionTraceState) {
		unionTraceStates.add(unionTraceState);
	}

	public Iterator getUnionTraceState() {
		return unionTraceStates.iterator();
	}

	public boolean isUnionTraceState() {
		return unionTraceState;
	}

	public void setUnionTraceState(boolean unionTraceState) {
		this.unionTraceState = unionTraceState;
	}

	/*
	 * put a set of exclusive states derived from a starting state into exclusive hashmap
	 */
	public void setExclusiveSgns(
		List exclusiveForState,
		TraceState startingState) {
		exclusiveSgns.put(startingState, exclusiveForState);
	}

	/*
		 * put a set of exclusive states derived from a starting state into exclusive hashmap
		 */
	public void setSureExclusiveSgns(
		List exclusiveForState,
		TraceState startingState) {
		sureExclusiveSgns.put(startingState, exclusiveForState);
	}

	/*
	 * get a set of exclusive states derived from a starting state
	 */
	public List getExclusiveSgns(TraceState startingState) {
		return (List) (exclusiveSgns.get(startingState));
	}

	public int getExclusiveSgnNum() {
		return exclusiveSgns.size();
	}

	/*
		 * get a set of exclusive states derived from a starting state
		 */
	public List getSureExclusiveSgns(TraceState startingState) {
		List temp = (List) sureExclusiveSgns.get(startingState);
		return temp;
	}

	public Integer getStateId() {
		return stateId;
	}

	public SchemaGraphNode getSgn() {
		return sgn;
	}

	public TraceState getParentTraceState() {
		return parentTraceState;
	}

	public List getChildrenTraceStates() {
		return childrenTraceStates;
	}

	public void removeChildTraceState(TraceState childTraceState) {
		childrenTraceStates.remove(childTraceState);
	}

	/*
	 * a list of sgns that lead to this state
	 */
	public List sgnsOnTrace() {
		List result = new LinkedList();

		TraceState curState = this;

		while (curState != null) {
			//insert at the head
			result.add(0, curState.sgn);
			curState = curState.parentTraceState;
		}
		return result;
	}

	/*
	 * finds states on its sgnsOnTrace which is a choice
	 */
	public List thruChoiceStates() {
		List results = new ArrayList();

		TraceState curState = this;

		while (curState != null) {
			if (curState.sgn.getTagName().equals(SchemaGraphNode.CHOICE))
				results.add(curState);

			curState = curState.parentTraceState;

		}
		return results;
	}

	/*
	 * finds a furthest state on its sgnsOnTrace whose descendant states won't conflict with each
	 * i.e., there exists no intermediate choice node between the general state and THIS 
	 */
	public TraceState getGeneralState() {
		TraceState curState = this;
		TraceState parentState = curState.parentTraceState;

		while (parentState != null) {
			if (parentState.sgn.getTagName().equals(SchemaGraphNode.CHOICE))
				return curState;
			curState = parentState;
			parentState = curState.parentTraceState;

		}

		//in the extreme case, the root of the schema graph
		return curState;
	}
	/**
	 * @return TraceState a tracestatet that is the ancestor of THIS State
	 * and it is the nearest concrete one rather than choice or sequence 
	 */
	public TraceState getConcreteParentState() {
		TraceState parState = parentTraceState;
		String parTag = parState.sgn.getTagName();
		while (parTag.equals(SchemaGraphNode.CHOICE)
			|| parTag.equals(SchemaGraphNode.SEQUENCE)) {
			parState = parState.parentTraceState;
			parTag = parState.sgn.getTagName();
		}

		return parState;

	}

	public Object clone() {
		Object newTraceState = null;
		;
		try {
			newTraceState = super.clone();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return newTraceState;
	}

	/*
	 * find descendant states derive from this state
	 * and the descendant states are states of qgn
	 */
	public List getDescStates(QueryGraphNode qgn) {
		List newDescStates = new ArrayList();

		if (this.getQgn() == qgn) {
			newDescStates.add(this);
			return newDescStates;
		}

		List descStates = this.childrenTraceStates;
		if (childrenTraceStates.size() == 0)
			//if this node is an EMPTY node, it does not have children trace states
			return new ArrayList();

		for (Iterator it = childrenTraceStates.iterator(); it.hasNext();) {
			TraceState childState = (TraceState) it.next();
			if (childState.qgn == qgn)
				newDescStates.add(childState);
		}

		if (newDescStates.size() > 0)
			return newDescStates;

		for (Iterator it = descStates.iterator(); it.hasNext();) {
			TraceState descState = (TraceState) it.next();
			newDescStates.addAll(descState.getDescStates(qgn));
		}

		return newDescStates;
	}

	/**
	 * @return TraceState a trace state that is the ancestor of THIS
	 * and the trace state is associated with a qgn which is the nearest entry node
	 * of the query tree node THIS state is associated with
	 * 
	 */
	public TraceState getEntryState(QueryGraphNode entryQgn) {
		TraceState curState = this;
		while (true) {
			QueryGraphNode qgn = curState.qgn;
			if (qgn != null && qgn == entryQgn)
				break;
			curState = curState.parentTraceState;
		}

		return curState;
	}

	/**
	 * @param QueryGraphNode qgn 
	 * @return boolean whether the occurrence of bindings to qgn must occur non-zero time within THIS state
	 * 
	 */
	public boolean minOccurPositive(QueryGraphNode qgn) {
		List descStates = getDescStates(qgn);
		for (Iterator it = descStates.iterator(); it.hasNext();) {
			TraceState descState = (TraceState) it.next();
			if (minOccurPositive(descState))
				return true;
		}
		return false;
	}

	/**
	 * 
	 * THIS must be a entry state
	 * @param qgn a descendant node of the query tree node THIS state is assocaited with
	 * @return boolean whether the qgn has been taken care of by occurrence rule
	 * so that even if qgn's occurrence is not greater than zero, it has been shortcutted by exclusive elements
	 */
	public boolean isTakenCareByOccur(QueryGraphNode descQgn) {
		if (takenCareByOccur.contains(descQgn))
			return true;
		else
			return false;
	}

	/**
	 * the qgn has been taken care of within THIS starting state
	 * @param qgn
	 */
	public void registerTakenCareByOccur(QueryGraphNode descQgn) {
		takenCareByOccur.add(descQgn);
	}

	/**
	 * get occurrence of descState in this
	 * @param childQgn
	 * @return
	 */
	public Occurrence getOccur(TraceState descState) {
		if (this == descState)
			//for termination of recursive calling
			return new Occurrence(1, 1);

		Vector path = pathDownToDesc(descState);
		TraceState childStateToDescState = (TraceState) path.get(0);
		SchemaGraphNode childSgn = childStateToDescState.sgn;
		Occurrence occur = null;
		int minOccur = 0;
		int maxOccur = 0;

		if (childSgn.getTagName() != SchemaGraphNode.CHOICE)
			minOccur =
				childSgn.getOccurWithParent(sgn).getMinOccurs()
					* childStateToDescState.getOccur(descState).getMinOccurs();
		else //e.g., a
			//      |
			//    choice
			//      |
			//      b
			//even though choice occurs with a (1,1) and b occurs within choice (1,1)
			//b occurs within a can be 0
			minOccur = 0;

		maxOccur =
			childSgn.getOccurWithParent(sgn).getMaxOccurs()
				* childStateToDescState.getOccur(descState).getMaxOccurs();
		return new Occurrence(minOccur, maxOccur);

	}

	/*
		 * find the last type, if any, among this type's child states assicated with qgn
		 */
	public TraceState findLastState(QueryGraphNode childQgn) {
		List statesWithChildQgn = getDescStates(childQgn);

		for (Iterator it = statesWithChildQgn.iterator(); it.hasNext();) {
			TraceState childState = (TraceState) it.next();
			SchemaGraphNode curChildSgn = childState.getSgn();
			//see whehter this is last one
			boolean last = true;
			for (Iterator it2 = statesWithChildQgn.iterator();
				it2.hasNext();
				) {
				TraceState siblingState = (TraceState) it2.next();
				SchemaGraphNode curSiblingSgn = siblingState.getSgn();
				if (curSiblingSgn != curChildSgn
					&& !(sgn
						.nodeTypesMustAfter(curSiblingSgn.getTagName())
						.contains(curChildSgn.getTagName()))) {
					//curChildSgn is not after curSiblingSgn
					last = false;
					break;
				}
			} //end of inner for
			if (last)
				return childState;

		}

		return null;

	}

	/**
	 * @return boolean whether descState's minimal occurrence within this state is >0
	 * @param descState TraceState
	 * 
	 */
	public boolean minOccurPositive(TraceState descState) {
		TraceState parentState = descState.parentTraceState;
		TraceState childState = descState;
		/*do {
			SchemaGraphNode parentSgn = parentState.sgn;
			SchemaGraphNode childSgn = childState.sgn;
			if (parentSgn.getMinOccurrence(childSgn.tagName) == 0)
				return false;
			
			childState = parentState;
			parentState = parentState.parentTraceState;
		
		} while (childState != this && childState != null);*/

		Occurrence occur = getOccur(descState);

		/*	if (childState == this)
				return true;
			else //childstate = null
				//there is no such descState of this state
				return false;*/

		if (occur != null && occur.getMinOccurs() > 0)
			return true;
		else
			return false;

	}

	/**
		 * @return boolean if true, there is no single occurrence whose min = 0
		 * @param descState TraceState
		 * e.g., a 
		 *       |
		 *      choice
		 *      / \
		 *     b   c
		 * even though b does not necessarily occur within a
		 * a.anoOptionalOccurInBetween(b) = true
		 * because choice occurs within a (1,1), b occurs within choice (1,1)
		 * 
		 */
	public boolean noOptionalOccurInBetween(TraceState descState) {
		TraceState parentState = descState.parentTraceState;
		TraceState childState = descState;
		do {
			SchemaGraphNode parentSgn = parentState.sgn;
			SchemaGraphNode childSgn = childState.sgn;
			if (childSgn.getOccurWithParent(parentSgn).getMinOccurs() == 0)
				return false;

			childState = parentState;
			parentState = parentState.parentTraceState;

		} while (childState != this && childState != null);

		if (childState == this)
			return true;
		else //childstate = null
			//there is no such descState of this state
			return false;

	}

	/**
		 * @return boolean whether this state's minimal occurrence within the root state is >0
		 * @param descState TraceState
		 * 
		 */
	public boolean minOccurPositiveToRoot() {
		TraceState parentState = parentTraceState;
		if (parentState == null)
			//this state must be associated with the root
			return true;

		TraceState childState = this;
		/*	do {
				SchemaGraphNode parentSgn = parentState.sgn;
		
				SchemaGraphNode childSgn = childState.sgn;
				if (parentSgn.getMinOccurrence(childSgn.tagName) == 0)
					return false;
				childState = parentState;
				parentState = parentState.parentTraceState;
		
			} while (parentState != null);
		
			//only reach here when (parentState == null)
			return true;*/
		//find the root
		while (parentState.parentTraceState != null) {
			parentState = parentState.parentTraceState;
		}

		//now parent state is the root state
		Occurrence occur = parentState.getOccur(this);
		if (occur != null && occur.getMinOccurs() > 0)
			return true;
		else
			return false;

	}

	public String toString() {
		String output = null;
		if (parentTraceState != null)
			output =
				sgn.getTagName()
					+ ","
					+ stateId
					+ " from "
					+ parentTraceState.sgn.tagName;
		else
			output = sgn.getTagName() + "," + stateId;

		if (exclusiveSgns.keySet().size() > 0) {
			output = output + " exclusive of:";
			for (Iterator it = exclusiveSgns.keySet().iterator();
				it.hasNext();
				) {
				TraceState startingState = (TraceState) it.next();
				//it is exclusive of other sgns
				output = output + exclusiveSgns.get(startingState);
				output = output + " in " + startingState + ";";
			}
		}

		return output;
	}

	/**from this state to its descendant state
	 * @param descState
	 * @return
	 */
	public Vector pathDownToDesc(TraceState descState) {
		Vector path = new Vector();

		if (childrenTraceStates.contains(descState)) {
			path.add(descState);
		} else {
			for (Iterator it = childrenTraceStates.iterator(); it.hasNext();) {
				TraceState childState = (TraceState) it.next();
				Vector subPath = childState.pathDownToDesc(descState);
				if (subPath.size() > 0) {
					path.add(childState);
					path.addAll(subPath);
				}
			}
		}

		return path;

	}

	/**
		 * find the furthest ancestor entry state of THIS
		 * there must all be (1,1) occurrence between any neighbouring nodes between
		 * this ancestor entry state and the starting state
		 * @param startingState
		 * @return TraceState
		 */
	/*public TraceState furtherestStartingState() {
		TraceState curState = this;
		TraceState parentState = curState.getParentTraceState();
		TraceState lastParentState = curState;
	
		while (parentState != null) {
	
			SchemaGraphNode curStateSgn = curState.getSgn();
			SchemaGraphNode parentStateSgn = parentState.getSgn();
			if (parentStateSgn.getMaxOccurrence(curStateSgn.getTagName()) > 1)
				//multiple occrurrece, cannot be propagated further more
				return lastParentState;
	
			QueryGraphNode parentQgn = parentState.getQgn();
			if (parentQgn != null && parentQgn.isNonSelDest())
				lastParentState = parentState;
	
			//lastParentState = curState;
			curState = parentState;
			parentState = parentState.getParentTraceState();
	
		}
	
		//if reach here, parentstate is null, i.e., curState is the root
		return curState;
	}*/

	//all the states from THIS state on the path to the furthest starting state (including the furthest starting state) 
	public List propagatableStartingStates() {
		List states = new ArrayList();

		TraceState curState = this;

		if (curState.getQgn().isNonSelDest())
			states.add(curState);

		TraceState parentState = curState.getParentTraceState();
		TraceState lastParentState = curState;

		while (parentState != null) {

			SchemaGraphNode curStateSgn = curState.getSgn();
			SchemaGraphNode parentStateSgn = parentState.getSgn();

			if (parentStateSgn.getMaxOccurrence(curStateSgn.getTagName()) > 1)
				//multiple occrurrece, cannot be propagated further more
				return states;

			QueryGraphNode parentQgn = parentState.getQgn();
			if (parentQgn != null //&& parentQgn.isNonSelDest()
					//revisit: all the states, not limited to entry states are added
					) {
				lastParentState = parentState;
				states.add(lastParentState);
			}

			//lastParentState = curState;
			curState = parentState;
			parentState = parentState.getParentTraceState();

		}

		//if reach here, parentstate is null, i.e., curState is the root
		return states;
	}

	/**
	 * @return boolean whether the trace state has any descendant states that are concrete
	 * 
	 */
	boolean nonEssentialDesc() {
		if (childrenTraceStates.size() == 0
			&& qgn != null
			&& qgn.getChildrenSize() == 0)
			//trace states of a leave qgn
			//even though no essential desc
			//it is not a redundant node
			return false;

		//clone childrenTraceStates
		List curChildrenStates = new ArrayList();
		for (Iterator it = childrenTraceStates.iterator(); it.hasNext();)
			curChildrenStates.add(it.next());

		while (curChildrenStates.size() > 0) {
			List newCurChildrenStates = new ArrayList();
			for (Iterator it = curChildrenStates.iterator(); it.hasNext();) {
				TraceState curChildState = (TraceState) it.next();
				if (curChildState.getSgn().isConcrete())
					//does exist concrete trace state
					return false;
				newCurChildrenStates.addAll(
					curChildState.getChildrenTraceStates());
			}
			curChildrenStates.clear();
			curChildrenStates = newCurChildrenStates;

		}

		return true;

	}

	/**
	 * @return autoStates a list of automata states
	 * 
	 */
	public List getAutoStates() {

		List autoStates = new ArrayList();

		List opsOnDest = qgn.getOpsOnDest();

		if (opsOnDest.size() > 0) {
			PureNavigateAutoStream op =
				(PureNavigateAutoStream) opsOnDest.get(0);
			ExtendedAutomata auto = op.getAutomata();

			autoStates =
				auto.getFrStateHash((XATStreamOperator) op, qgn.getTagName());
		} else {
			//might be a root node
			//find a qgn which is associated with dest ops
			TraceState curState = this;
			QueryGraphNode curQgn = curState.qgn;
			Vector path = new Vector();
			while (curQgn != null && curQgn.getOpsOnDest().size() == 0) {
				path.add(curState);
				curState = curState.getParentTraceState();
				curQgn = curState.qgn;
			}

			//construct navigation step
			List navSteps = new ArrayList();
			for (int i = 0; i < path.size(); i++) {
				TraceState traceState = (TraceState) path.get(i);
				if (traceState.sgn.isConcrete())
					navSteps.add(traceState.sgn.getTagName());
			}

			if (qgn == null) {
				//THIS state is associated with a qgn that is between the query tree root node
				//and its next entry node
				//find the auto first
				curState = this;
				curQgn = curState.qgn;
				while (curQgn.getOpsOnDest().size() == 0) {
					curQgn = (QueryGraphNode) curQgn.getChild(0);
				}
				//must find one 
				PureNavigateAutoStream op =
					(PureNavigateAutoStream) curQgn.getOpsOnDest().get(0);
				ExtendedAutomata auto = op.getAutomata();

				//find the automata states for this trace state
				ExtendedState stateForOp = (ExtendedState) auto.getRootState();
				for (Iterator it2 = navSteps.iterator(); it2.hasNext();) {
					String navStepName = (String) it2.next();
					stateForOp =
						(ExtendedState) stateForOp.getSingleTransit(
							navStepName);
				}
				autoStates.add(stateForOp);
			} else {
				//not of an intermediate node between the query tree root and the next entry node
				PureNavigateAutoStream op =
					(PureNavigateAutoStream) curQgn.getOpsOnDest().get(0);
				ExtendedAutomata auto = op.getAutomata();
				//curState is the entry state of this state
				List statesForOp =
					auto.getFrStateHash(op, curState.sgn.getTagName());

				for (Iterator it = statesForOp.iterator(); it.hasNext();) {
				//the path is bottom-up, we trace the automata states left-right, so should be the reverse direction
				
					ExtendedState stateForOp = (ExtendedState) it.next();
					//for (Iterator it2 = navSteps.iterator(); it2.hasNext();) {
					for (int i=navSteps.size()-1; i>=0; i--){
						//String navStepName = (String) it2.next();
						String navStepName = (String)navSteps.get(i);
						stateForOp =
							(ExtendedState) stateForOp.getSingleTransit(
								navStepName);
					}
					autoStates.add(stateForOp);

				}
			}

		} //end of else

		return autoStates;
	}

	/*
	 * whether another state must occur after this within their common ancestor
	 */
	public boolean before(TraceState anotherState, int suspensionMethod) {

		List thisAnces = getAllAnces();

	//	if (thisAnces.contains(anotherState))
		for (Iterator it = thisAnces.iterator(); it.hasNext();){
			//another state is ancestor of this state
			TraceState ance = (TraceState)it.next();
			if (ance.getSgn().getTagName().equals(anotherState.getSgn().getTagName()))
			return false;
		}

		List anotherAnces = anotherState.getAllAnces();
		
		boolean anotherAncesContains = false;
		for (Iterator it = anotherAnces.iterator(); it.hasNext();){
			TraceState anotherAnce = (TraceState)it.next();
			if (anotherAnce.getSgn().getTagName().equals(this.getSgn().getTagName()))
				anotherAncesContains = true;
				
		}

		if (anotherAncesContains)
			//e.g., 
			// auction
			//  /    \
			//seller   bid
			// |        |
			// *       bidder
			// |        |
			//phone    sameAddr
			//if another state is same Addr and this state is bid
			//sameAddr 
			if (suspensionMethod == QueryGraph.PUSH)
				//when open tag of bid is encountered, before sameAddr
				return true;
			else
				return false;

		for (int i = 0; i < thisAnces.size(); i++) {
			TraceState thisAnce = (TraceState) thisAnces.get(i);
			for (int j = 0; j < anotherAnces.size(); j++) {
				TraceState anotherAnce = (TraceState) anotherAnces.get(j);
				if (thisAnce.getSgn().getTagName().equals(anotherAnce.getSgn().getTagName())) {
					//revisit: is name equivalent enough
					//find common ancestor tracestate
					SchemaGraphNode commonSgn = thisAnce.sgn;
					TraceState thisAnceChild =
						(TraceState) thisAnces.get(i - 1);
					SchemaGraphNode thisAnceChildSgn = thisAnceChild.sgn;
					List afterThisAnceChild =
						commonSgn.nodeTypesMustAfter(
							thisAnceChildSgn.getTagName());

					TraceState anotherAnceChild =
						(TraceState) anotherAnces.get(j - 1);
					String anotherAnceChildType =
						anotherAnceChild.sgn.getTagName();
					if (afterThisAnceChild.contains(anotherAnceChildType))
						//another state does not necessariarly occur after the initiatingstate
						return true;
				}
			}
		}

		return false;

	}

	private List getAllAnces() {
		List ances = new ArrayList();
		ances.add(this);

		TraceState anceState = parentTraceState;
		while (anceState != null) {
			ances.add(anceState);
			anceState = anceState.parentTraceState;
		}

		return ances;
	}

}
