/*
 * Created on Apr 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.rules;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.PureNavigateAutoStream;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.SuspensionEdge;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NavigationStep;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NodeStepImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.TraceState;

/**
 * @author suhong
 * introduce the exclusive types
 */
public class ExclusivePatternIntro extends RuleImp {

	/**
	 * @param ruleName
	 * @param sg
	 */
	public ExclusivePatternIntro(SchemaGraph sg) {
		super("exclusive", sg);

	}

	/**no matter of what noPotentialRedun is, it does not affect the findAllMatchings
	 * 1. if the ending marks with type A of type B are found, the computations definitely fails, there will be no futher checking at all
	 * 2. there cannot be a checking before a checking by the ending markings found in exclusivepatterninto rule
	 * because for the previous checking, the type must either
	 * (1) coexist with both type A and B 
	 * (2) or an exclusive type B itself
	 * (1) cannot occur; (2) can occur, but then the later checking will not take place	 * 
	 * therefore any matching found by exclusivepatternintro would not bring any potential redun
	 * @param parent QueryGraphNode 
	 * @param noPotentialRedun boolean
	 */
	public List findAllMatchings(
		TraceState startingState,
		QueryGraphNode desc,
		boolean noPotentialRedun) {
		List matchings = new ArrayList();

		//given a descendant state, find its starting state
		HashMap stateToStartingState = new HashMap();

		List parentStates = new ArrayList();
		parentStates.add(startingState);
		int parentStateNum = parentStates.size();

		while (parentStateNum > 0) {
			List newParentStates = new ArrayList();

			for (Iterator it = parentStates.iterator(); it.hasNext();) {
				TraceState parentState = (TraceState) it.next();
				List childStates = parentState.getChildrenTraceStates();
				for (Iterator it2 = childStates.iterator(); it2.hasNext();) {

					TraceState childState = (TraceState) it2.next();
					QueryGraphNode childQgn = childState.getQgn();

					//find the branch where dest is on
					if (childState.getDescStates(desc).size() == 0)
						continue;

					if (childQgn != null
						&& childQgn.getType() == QueryGraphNode.NONFILTER)
						//non-filtering node needs not to be considered
						continue;

					if (childQgn == null
						|| (childQgn
							!= null & childQgn.getOpsOnEntry().size()
							== 0))
						//not leave yet
						newParentStates.add(childState);

					//further check whether the parent is only allowed in parent at most once
					//if more than once, it is not transitive
					//  a
					//  |
					//  b
					//  |
					//  c
					//suppose c is exclusive of d in b, if b can occur in a multiple times
					//then the occurrence of d does not necessarily mean there won't be c within a

					if (childState.getExclusiveSgnNum() > 0) {
						//find a child state with exclusive types
						//find all other states that start from the same starting state
						//and are bound to the same query tree node as the childState is bound to
						QueryGraphNode qgn = childState.getQgn();
						List siblingStates = startingState.getDescStates(qgn);

						//compare, find if there is any common one
						for (Iterator it3 =
							childState
								.getExclusiveSgns(startingState)
								.iterator();
							it3.hasNext();
							) {
							SchemaGraphNode exclusiveSgn =
								(SchemaGraphNode) it3.next();

							boolean foundInCurSiblingState = false;
							if (siblingStates.size() == 1)
								//the exclusive one must come from only ng
								//i.e.,    choice
								//         /    \
								//     sameAdd sequence
								//               /  \
								//            shipTo billTo
								//siblingStates.size()==1,sameAddr is exclusive of shipTo and billTo
								foundInCurSiblingState = true;
							else {

								for (Iterator it4 = siblingStates.iterator();
									it4.hasNext();
									) {
									TraceState siblingState =
										(TraceState) it4.next();
									if (siblingState == childState)
										//does not compare with itself
										continue;

									List siblingExclusiveSgns =
										siblingState.getExclusiveSgns(
											startingState);
									if (siblingExclusiveSgns == null) {
										//this sibling does not have any exclusive state
										//therefore there is no common exclusive state
										break;
									}

									for (Iterator it5 =
										siblingExclusiveSgns.iterator();
										it5.hasNext();
										) {
										SchemaGraphNode siblingExclusiveSgn =
											(SchemaGraphNode) it5.next();
										if (exclusiveSgn
											== siblingExclusiveSgn) {
											foundInCurSiblingState = true;
											break;
										}
									}
									if (!foundInCurSiblingState)
										//this exclusive sgn is not found in the exclusive list of the current sibling state
										//is not a common one
										break; //break out of it4
								} //end of it4
							}
							if (foundInCurSiblingState) {
								//must be found in all sibling states
								Object[] matching = new Object[5];

								//record the starting state
								matching[0] = startingState;
								//the exlusive sgns
								matching[1] = exclusiveSgn;
								//the state which is exclusive of exclusiveSgn
								matching[2] = childState;
								//the ancestor entry state
								/*matching[3] =
									startingState.furtherestStartingState();*/
								matching[3] =
									childState.propagatableStartingStates();
								//whether this matching surely works
								matching[4] =
									new Boolean(isSurelyWorking(matching));
								matchings.add(matching);

							}
						} //end of it3

					} //end of if (childState.getExclusiveSgnNum() > 0) 
				} //end of for (Iterator it2 = childStates.iterator(); it2.hasNext();)

			} //end of for (Iterator it = parentStates.iterator(); it.hasNext();) 
			//to next parent states

			parentStates.clear();
			parentStates = newParentStates;
			parentStateNum = parentStates.size();

		} //end of while

		//} //end of current starting state

		/*String output = "from exclusivePatternInto:\n";
		for (Iterator it = matchings.iterator(); it.hasNext();) {
			Object[] matching = (Object[]) it.next();
			for (int i = 0; i < matching.length; i++)
				output = output + matching[i] + " ";
			output = output + "\n";
		}
		
		if (matchings.size() > 0)
			System.out.println(output);*/

		return matchings;
	}

	/**translate matchings into query plan
		 * @param matching Object[]
		 */
	public void translateBackToPlan(Object[] matching) {

		TraceState startingState = (TraceState) matching[0];
		SchemaGraphNode exclusiveSgn = (SchemaGraphNode) matching[1];
		TraceState stateExclusiveToSgn = (TraceState) matching[2];
		//TraceState ancestorEntryState = (TraceState) matching[3];
		List propagatableEntryStates = (List) matching[3];

		QueryGraphNode startingQgn = startingState.getQgn();
		List navs = startingQgn.getOpsOnDest();
		//an arbitry nav's destination is on the starting state
		PureNavigateAutoStream nav = (PureNavigateAutoStream) navs.get(0);
		ExtendedAutomata auto = nav.getAutomata();

		ExtendedState checkedOpAutoState =
			(ExtendedState) stateExclusiveToSgn.getAutoStates().get(0);

		List entryStates = startingState.getAutoStates();

		for (Iterator it2 = entryStates.iterator(); it2.hasNext();) {
			ExtendedState entryState = (ExtendedState) it2.next();

			//add this exclusiveSgn into the automata
			//i.e., create a new state for it

			//find which automata state this destState is added into
			Vector chain = startingState.pathDownToDesc(stateExclusiveToSgn);
			ExtendedState curAutoState = entryState;
			for (int i = 0; i < chain.size() - 1; i++) {
				SchemaGraphNode sgn = ((TraceState) chain.get(i)).getSgn();
				String transitName = sgn.getTagName();
				if (transitName.equals(SchemaGraphNode.CHOICE)
					|| transitName.equals(SchemaGraphNode.SEQUENCE))
					continue;
				curAutoState =
					(ExtendedState) curAutoState.getSingleTransit(transitName);
			}

			NavigationStep[] forAddingDestState = new NavigationStep[1];
			forAddingDestState[0] = new NodeStepImp(exclusiveSgn.getTagName());
			
			ExtendedState destState =
				(ExtendedState) auto.addPath(curAutoState, forAddingDestState);

			//set up completeTreeCount/... for destState
			//since the destState is a new state, the count hasn't been set
			//like other states mapped from an explict extract operator
			setUpCountForNewState(destState, checkedOpAutoState);

			List entryAutoStates = new ArrayList();
			
			for (int i = 1; i < propagatableEntryStates.size(); i++) {
				//the 0th one is the state whose failure is interested
				//no need to cut it
				TraceState ancestorEntryState =
					(TraceState) propagatableEntryStates.get(i);
				entryAutoStates.addAll(ancestorEntryState.getAutoStates());
			}

			SuspensionEdge edge = new SuspensionEdge(1, null, entryAutoStates);

			destState.addSuspensionEdgeAtPush(edge);

			//if (destState.getTransits()!=null || destState.hasLambdaTransit() || destState.hasSelfStarTransit() || destState.hasStarTransit())
			
				entryAutoStates.add(0, destState);
		
			//register the mapping relationship between destState and qgn
			QueryGraph qg = startingQgn.getQg();
			List traceStates = new ArrayList();
			traceStates.add(stateExclusiveToSgn);
			qg.getAutoStateToTraceStates().put(destState, traceStates);
		}

		String output = "from exclusivePatternInto:\n";

		for (int i = 0; i < matching.length; i++)
			output = output + matching[i] + "&& ";
		output = output + "\n";

		System.out.println(output);

		System.out.println(auto);

	}

	public void setUpCountForNewState(
		ExtendedState newState,
		ExtendedState exclusiveState) {

		Set predecessors = exclusiveState.getPredecessors();
		for (Iterator it = predecessors.iterator(); it.hasNext();) {
			ExtendedState preState = (ExtendedState) it.next();
			if (preState.getCompleteCount() > 0)
				newState.setCompleteCount(newState.getCompleteCount() + 1);

			if (preState.getTypedValCount() > 0)
				newState.setTypedValCount(newState.getTypedValCount() + 1);

			if (preState.getDomCount() > 0)
				newState.setDomCount(newState.getDomCount() + 1);

		}

	}

	private boolean isSurelyWorking(Object[] matching) {
		TraceState startingState = (TraceState) matching[0];
		//the exlusive sgns
		SchemaGraphNode exclusiveSgn = (SchemaGraphNode) matching[1];
		//the state which is exclusive of exclusiveSgn
		TraceState childState = (TraceState) matching[2];

		if (startingState.noOptionalOccurInBetween(childState)
			&& childState.getSureExclusiveSgns(startingState).contains(
				exclusiveSgn))
			//this sgn surely helps
			return true;
		else
			return false;

	}
}
