/*
 * Created on Feb 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.rules;

import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.TraceState;

/**
 * @author suhong
 *
 * defining rules
 */
public interface Rule {
	/**
	 * fire on query graph node qn, if noPotentialRedun is true
	 * only allows finding ending marks that would never bring redundancy 
	 * otherwise, allows finding ending marks that may possibly bring redundancy
	 * at run time
	 * note, however, in either case, there would not be absolute redundancy
	 * @param qn
	 * @param surelyWorkingOnly
	 */
	boolean fire(TraceState startingState, QueryGraphNode desc, boolean noPotentialRedun, List matchings);

	/**  
	 * @param parent QueryGraphNode
	 * @param noPotentialRedun boolean
	 * find all the matchings with the current parent which must be an entry node
	 * 
	 */
	List findAllMatchings(TraceState parentState, QueryGraphNode desc, boolean noPotentialRedun);

    /**
     * translate found matchings into the query plan
     * @param matching
     */
	void translateBackToPlan(Object[] matching);

	String getRuleName();
	void setRuleName(String ruleName);

}
