/*
 * Created on Feb 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.rules;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.FindOpVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.XATStreamOperator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.schedulemode
	.SelfPartitionDelimiInvoking;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.sqloperator
	.StructuralJoinStream;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.ExtractStream;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.PureNavigateAutoStream;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.xmloperator
	.SuspensionEdge;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NavigationStep;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NodeStepImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.GraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.TraceState;

/**
 * @author suhong
 *
 * filtering pattern shortcut by other patterns
 */
public class UncertainBoundaryPattern extends RuleImp {
	//entry nodes that have been applied the rule
	List appliedOnes = new ArrayList();

	//	states that have been applied
	HashMap statesToMatching = new HashMap();

	//states that have surely working one
	List stateMatchingSure = new ArrayList();
	
	boolean allStartingStateHas = true;

	//whether exclusive rule is allowed to apply
	boolean exclusiveApplied = false;

	public UncertainBoundaryPattern(SchemaGraph sg) {
		super("inter boundary pattern", sg);
	}

	public void setExclusiveApplied(boolean exclusiveApplied) {
		this.exclusiveApplied = exclusiveApplied;
	}

	/**
	 * @param startingState TraceState
	 * @param noPotentialRedun boolean 
	 * @param matchings List
	 * @return boolean indicate whether an surely-working ending mark for starting state has been found
	 * 
	 */
	public boolean findAllMatchings(
		TraceState startingState,
		QueryGraphNode desc,
		boolean noPotentialRedun,
		List matchings) {
		boolean foundSureOne = true;

		if (startingState.getQgn() == desc)
			return false;

		if (statesToMatching.get(startingState) != null) {
			if (stateMatchingSure.contains(startingState))
				return true;
			else
				return false;
		}

		QueryGraphNode parent = startingState.getQgn();
		GraphNode[] children = parent.getChildren();
		int childrenNum = children.length;

		for (int i = 0; i < childrenNum; i++) {
			//process descendant node clustered based on child query nodes respectively
			QueryGraphNode child = (QueryGraphNode) children[i];

			if (child.getDestQgn() != desc)
				continue;

			if (child.getTraceStates().size() == 0)
				//an EMPTY node does not any tracestates
				continue;

			if (child.getType() == QueryGraphNode.NONFILTER)
				//a non-filtering child needs not to be considered
				continue;

			//the starting state of the entry node of the child node
			QueryGraphNode entryQgn = child.getEntryQgn();
			TraceState entryQgnState = startingState.getEntryState(entryQgn);

			//states of child dervied from the entry qgn's starting state
			List childStates = startingState.getDescStates(child);

			if (startingState
				.minOccurPositive(child) //|| (exclusiveApplied
			//	&& entryQgnState.isTakenCareByOccur(child))
			) {
				//this child surely occurs or already has a surely-working ending mark
				//if its children are not ensured, direct check whether this child's sibling can serve as ending mark
				//	directCheckSibling = true;
				if (child.getChildrenSize() == 0)
					//if this child is a leaf, process next child
					continue;
				else {
					//if this child is not a leaf, find whether this state has been applied before
					//if not, check each state of this child
					if (!child.isNonSelDest()) {

						for (Iterator it = childStates.iterator();
							it.hasNext();
							) {
							TraceState childState = (TraceState) it.next();
							if (statesToMatching.get(childState) == null) {
								List newMatchings = new ArrayList();
								boolean sureOne =
									findAllMatchings(
										childState,
										desc,
										noPotentialRedun,
										newMatchings);
								matchings.addAll(newMatchings);
								statesToMatching.put(childState, newMatchings);
								if (sureOne)
									stateMatchingSure.add(childState);
							}
						} //end of for
					} //end of if (!child.isNonSelDest)
				} //end of else
			} //end of if

			//if (!startingState.minOccurPositive(child) && noPotentialRedun)
			//child may not occur and no potentialRedun
			//continue;
			//now check whether any tracestate of this child renders results
			//the child is not a leaf yet

			//now find the last type among childStates within parentType  
			TraceState lastChildState = startingState.findLastState(child);

			boolean checkChildSibling = true;

			if (lastChildState != null) {
				//check whether the last child state can occur multiple times in its parent state
				SchemaGraphNode lastChildSgn = lastChildState.getSgn();
				SchemaGraphNode parentSgn = startingState.getSgn();

				int maxOccur =
					parentSgn.getMaxOccurrence(lastChildSgn.getTagName());
				
				
				if (maxOccur == 1) {
					//cannot be multiple
					//if multiple, there can not be marks for any trace states below lastChildState
					//we find whether within the lastChildState, there are marks
					//boolean childMustOccur =
					//	startingState.minOccurPositive(lastChildState);
					int minOccur =
						parentSgn.getMinOccurrence(lastChildSgn.getTagName());
					//whether this last child state is a definite appearing one within its starting state
					if (lastChildState.getChildrenTraceStates().size() > 0
						&& (minOccur > 0 || !noPotentialRedun)) {
						//the last child state must occur within the starting state when potentialRedun is not allowed
						//or potentialRedun is allowed
						//check the subtree rooted at lastChildState to find the ending marks                  

						List marksWithinLastChildState = new ArrayList();
						boolean sureMark =
							findAllMatchings(
								lastChildState,
								desc,
								noPotentialRedun,
								marksWithinLastChildState);

						matchings.addAll(marksWithinLastChildState);

						if (sureMark && minOccur > 0)
							//if the last child state surely occur and within it a surely-working ending mark is found						
							//no need to use sibling of the last child as ending marks of last child	
							checkChildSibling = false;

					} //end of if startingState.minOccurPositive(lastChildState)					
				} //end of  if (maxOccur==1){
				/*else {
					//maxOccur>1
					//continue traverse down for finding ending marks of descendant states
					QueryGraphNode nextEntryNode = parent.getDestQgn();
					if (nextEntryNode != null
						&& !appliedOnes.contains(nextEntryNode)) {
						matchings.addAll(
							findAllMatchings(nextEntryNode, desc, noPotentialRedun));
						appliedOnes.add(nextEntryNode);
					} //end of if (nextEntryNode != null) 
				
				} //end of else */
			} //end of if (lastChildState != null) 

			if (!checkChildSibling)
				continue;

			//see whether must use marks from sibling of last child type 
			SchemaGraphNode startingSgn = startingState.getSgn();
			if (lastChildState != null) {
				//the ending marks of last child states are still needed
				List typesAfter =
					startingSgn.nodeTypesMustAfter(
						lastChildState.getSgn().getTagName());

				if (typesAfter.size() == 0)
					//no sure one can be found
					//if any child does not have a surely-working one
					//then the parent does not have a surely-working ending mark
					foundSureOne = false;

				//whether we can find one in type after that surely works
				boolean foundInTypeAfter = false;
				for (int j = 0; j < typesAfter.size(); j++) {
					String typeAfter = (String) typesAfter.get(j);
					int minOccur = startingSgn.getMinOccurrence(typeAfter);

					boolean connect = false;
					//whether this typeAfter exists in the tree
					for (int k = 0; k < childrenNum; k++) {
						QueryGraphNode siblingChild =
							(QueryGraphNode) children[k];
						List siblingChildStates = siblingChild.getTraceStates();
						for (Iterator it = siblingChildStates.iterator();
							it.hasNext();
							) {
							TraceState siblingChildState =
								(TraceState) it.next();
							if (siblingChildState
								.getSgn()
								.getTagName()
								.equals(typeAfter)) {
								//connect this patten
								connect = true;
								Object[] matching = new Object[6];
								//i.e., the starting state
								matching[0] = startingState;
								//record the initiating state
								matching[1] = siblingChildState;
								//record the operator whose results will be checked
								//there might be multiple operators associated with the qgn
								//choose an arbitrary one since these operators have same outputs
								QueryGraphNode destQgn =
									lastChildState.getQgn().getDestQgn();
								if (destQgn == null)
									//the lastChildState.getQgn() itself is a destination qgn
									destQgn = lastChildState.getQgn();

								//the extract operator that should be invoked when introduced state is activated
								matching[2] =
									FindOpVisitor.findAssociatedExtract(
										(DagNode)
											((PureNavigateAutoStream) destQgn
											.getOpsOnDest()
											.get(0))
											.getNode());
								//whether the initiating state is existing		
								matching[3] = new Boolean(true);
								//matching[4] =	startingState.furtherestStartingState();
								matching[4] =
									startingState.propagatableStartingStates();

								if (minOccur > 0) {
									matching[5] = new Boolean(true);
									matchings.add(matching);
									return true;
								} else {
									//minOccur = 0
									matching[5] = new Boolean(false);
									if (!noPotentialRedun)
										//allows redun
										matchings.add(matching);
								}
							}
						}
					}
					if (!connect) {
						//has to introduce the pattern then
						SchemaGraphNode introducedStateSgn =
							sg.getNodeForName(typeAfter);
						TraceState introducedState =
							new TraceState(introducedStateSgn, startingState);
						Object[] matching = new Object[6];
						matching[0] = startingState;
						matching[1] = introducedState;
						//find which operator lastChildState.getQgn() is on the path of
						//find the extract operator
						QueryGraphNode destQgn =
							lastChildState.getQgn().getDestQgn();
						if (destQgn == null)
							//the lastChildState.getQgn() itself is a destination qgn
							destQgn = lastChildState.getQgn();

						//the extract operator that should be invoked when introduced state is activated
						matching[2] =
							FindOpVisitor.findAssociatedExtract(
								(DagNode) ((PureNavigateAutoStream) destQgn
									.getOpsOnDest()
									.get(0))
									.getNode());

						//the state is not pre-exisiting		
						matching[3] = new Boolean(false);
						//matching[4] = startingState.furtherestStartingState();
						matching[4] =
							startingState.propagatableStartingStates();

						if (minOccur > 0) {
							matchings.add(matching);
							foundInTypeAfter = true;
							matching[5] = new Boolean(true);
							//return true;
						} else {
							matching[5] = new Boolean(false);
							//minOccur = 0
							if (!noPotentialRedun)
								//allows redun
								matchings.add(matching);
						}
					} //end of if !connect
					//check whether typeAfter is surely-appearing one
					//if yes, we can stop
					if (foundInTypeAfter)
						break;

				} //end of for (int j = 0; j < typesAfter.size(); j++)
				foundSureOne = foundInTypeAfter;
			} //end of if (lastChildState != null)
			else
				//lastChildState == null
				foundSureOne = false;

		} //end of for

		//finished checking all child states of the starting state
		return foundSureOne;
	}

	/**
	 * @param matching Object[]	 * 
	 */
	public void translateBackToPlan(Object[] matching) {
		TraceState startingState = (TraceState) matching[0];
		QueryGraph qg = startingState.getQgn().getQg();

		ExtractStream invokedExtract = (ExtractStream) matching[2];
		//		the extract may have a direct structural join over it
		//e.g., 
		//                    InTimeSj
		//                  /         \
		//             ExtractColl    ExtractUnnest
		//                 |           |
		//               nav           |
		//                 \           /
		//                       nav
		//for extractunnest, we check intimeSJ instead of extractunnest itself
		//because when an output tuple of extractunnest is generated, 
		//it is sent to intimeSJ, therefore the output stays at intimesj  
		ExtendedState invokedExtractAutoState = invokedExtract.getOpState();

		List groupbyOps = invokedExtractAutoState.getGroupbyOps();
		SelfPartitionDelimiInvoking checkedOp = invokedExtract;
		if (groupbyOps.size() > 0)
			//the last one might be the same as invokedExtract
			//or might be a structuralJoin
			checkedOp = findCheckedOp(groupbyOps);

		ExtendedAutomata auto = invokedExtract.getAutomata();
		//TraceState ancestorEntryState = (TraceState) matching[4];
		List propagatableEntryStates = (List) matching[4];

		//find the automata state for starting state
		List startingAutoStates = new ArrayList();
		startingAutoStates = startingState.getAutoStates();

		//the automata states that shortcutting should lead to
		List propagatableAutoStates = new ArrayList();

		for (Iterator it = propagatableEntryStates.iterator(); it.hasNext();) {
			TraceState propagatableEntryState = (TraceState) it.next();
			propagatableAutoStates.addAll(
				propagatableEntryState.getAutoStates());
		}

		boolean preexisting = ((Boolean) matching[3]).booleanValue();

		//		find the trace state chain from starting state to desc state
		TraceState descState = (TraceState) matching[1];

		for (Iterator it = startingAutoStates.iterator(); it.hasNext();) {
			ExtendedState startingAutoState = (ExtendedState) it.next();
			ExtendedState destState = null;

			Vector chain = startingState.pathDownToDesc(descState);

			if (!preexisting) {
				NavigationStep[] forAddingDestState =
					new NavigationStep[chain.size()];

				for (int i = 0; i < chain.size(); i++) {
					String sgnName =
						((TraceState) chain.get(i)).getSgn().getTagName();
					if (!sgnName.equals(SchemaGraphNode.CHOICE)
						&& !sgnName.equals(SchemaGraphNode.SEQUENCE))
						//qgn might be null for special trace state such as seq or choice
						forAddingDestState[i] = new NodeStepImp(sgnName);
				}

				destState =
					(ExtendedState) auto.addPath(
						startingAutoState,
						forAddingDestState);
			} else {
				//destState is exsiting
				//find destState
				ExtendedState curState = startingAutoState;
				for (int i = 0; i < chain.size(); i++) {
					TraceState intermediateState = (TraceState) chain.get(i);
					if (intermediateState.getSgn().isConcrete())
						//qgn might be null for special trace state such as seq or choice
						curState =
							(ExtendedState) curState.getSingleTransit(
								intermediateState.getSgn().getTagName());
				}
				destState = curState;
			} //end of if

			SuspensionEdge edge = null;

			//the auto state which initiates the checking should be supended if checking fails
			//must be at the head, the order matters
			//the dest state has following
		//	if (destState.getTransits()!=null || destState.hasLambdaTransit() || destState.hasSelfStarTransit() || destState.hasStarTransit())
				propagatableAutoStates.add(0, destState);

			edge = new SuspensionEdge(1, checkedOp, propagatableAutoStates);
			
			((ExtendedState)propagatableAutoStates.get(propagatableAutoStates.size()-1)).addOpResetPartitionChecked((XATStreamOperator)checkedOp);	
			((SelfPartitionDelimiInvoking)checkedOp).setNeedSetPartitionCheck();

			destState.addSuspensionEdgeAtPush(edge);

			List traceStates = new ArrayList();
			traceStates.add(descState);
			qg.getAutoStateToTraceStates().put(destState, traceStates);

		}

		String output = "from uncertainBoundaryPattern:\n";

		for (int i = 0; i < matching.length; i++)
			output = output + matching[i] + "&& ";
		output = output + "\n";

		System.out.println(output);

		System.out.println(auto);

	}

	/*
	 * find the checked op from the groupops associated with a state
	 */
	public SelfPartitionDelimiInvoking findCheckedOp(List groupbyOps) {
		//if there is a sj, the last sj is the checkedop
		//else the only extract
		StructuralJoinStream sj = null;
		ExtractStream extract = null;
		for (Iterator it = groupbyOps.iterator(); it.hasNext();) {
			XATStreamOperator op = (XATStreamOperator) it.next();
			if (op instanceof StructuralJoinStream)
				sj = (StructuralJoinStream) op;
			else if (op instanceof ExtractStream)
				extract = (ExtractStream) op;
		}

		if (sj != null)
			return (SelfPartitionDelimiInvoking) sj;
		else
			return extract;
		/*{
			if (extractColl != null)
				//there is no sj but there is an extract
				return (SelfPartitionDelimiInvoking) extractColl;
			else //there is 
				return (SelfPartitionDelimiInvoking) groupbyOps.get(
					groupbyOps.size() - 1);
		}*/

	}

	/**
	 * @param parent QueryGraphNode the node to apply the rule on
	 * @param noPotentialRedun boolean whether potential redun is allowed or not
	 * @return List all matchings found with parent 
	 */
	public List findAllMatchings(
		TraceState startingState,
		QueryGraphNode desc,
		boolean noPotentialRedun) {
		List matchings = new ArrayList();
		QueryGraphNode parent = startingState.getQgn();

		List parentStates = parent.getTraceStates();

		//conceptually, we do not have duplate tracestates of the same type assocaited with a query tree node
		//we therefore apply on distinct trace states
		List alreadyAppliedTraceStateNames = new ArrayList();
		for (Iterator it = parentStates.iterator(); it.hasNext();) {
			TraceState parentState = (TraceState) it.next();
			String parentStateName = parentState.getSgn().getTagName();
			if (!alreadyAppliedTraceStateNames.contains(parentStateName)) {
				//have not apply before yet
				alreadyAppliedTraceStateNames.add(parentStateName);
				if (!findAllMatchings(
					parentState,
					desc,
					noPotentialRedun,
					matchings))
					allStartingStateHas = false;
			}
		}

		/*String output = "from uncertainBoundaryPattern:\n";
		for (Iterator it = matchings.iterator(); it.hasNext();) {
			Object[] matching = (Object[]) it.next();
			for (int i = 0; i < matching.length; i++)
				output = output + matching[i] + ";";
			output = output + "\n";
		}
		
		if (matchings.size() > 0)
			System.out.println(output);*/

		return matchings;
	}

}