package edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager;

import org.apache.xml.serialize.*;
/**
 * Insert the type's description here.
 * Creation date: (1/19/2003 12:15:22 PM)
 * @author: Hong Su
 */
import java.io.*;
import org.w3c.dom.*;

public class Finer_StreamStoreMgrKey implements Serializable {

    // flag indicating whether the key refers to a string or a dom object
    private short keyType = 0;
    public final static short STRING = 1;
    public final static short DOM = 2;

    //reference to the string buffer in the store manager
    private StringBuffer str = null;
    private int start = 0;
    private int end = 0;

    private Node domNode;
    
/**
 * a key for string representation
 * @param str java.lang.String
 */
public Finer_StreamStoreMgrKey(StringBuffer str, int start) {
	this.str = str;
	this.start = start;
	keyType = STRING;
	}
/**
 * a key for dom tree representation
 * @param domEle org.w3c.dom.Element
 */
public Finer_StreamStoreMgrKey(Node domNode) {
	this.domNode = domNode;
	keyType = DOM;
	}
/**
 * get the dom tree representation
 * @return org.w3c.dom.Node
 */
public Node getDomNode() {
	return domNode;
}
/**
 * get the key's type
 * @return int
 */
public short getKeyType() {
	return keyType;
}
/**
 * Resolve the reference representation of a string
 * Creation date: (1/31/2003 10:13:22 AM)
 * @return java.lang.StringBuffer
 */
private String resolve() {
	
	return str.substring(start,end);
	
}
/**
 * set end
 * Creation date: (1/31/2003 10:12:05 AM)
 * @param newEnd int
 */
public void setEnd(int newEnd) {
	end = newEnd;
}
/**
 * print to string
 * Creation date: (1/31/2003 9:58:34 AM)
 * @return java.lang.String
 */
public String toString() {

    if (keyType == STRING) {
        return resolve();
    } else
        if (keyType == DOM) {
            if (domNode instanceof Node) {
                Document dDOMTree = ((Node) domNode).getOwnerDocument();
                OutputFormat format = new OutputFormat(dDOMTree); //Serialize DOM
                StringWriter stringOut = new StringWriter(); //Writer will be a String
                Serializer serial = new XMLSerializer();
                serial.setOutputFormat(format);
                serial.setOutputCharStream(stringOut);
                try {
                    DOMSerializer ds = serial.asDOMSerializer();
                    ds.serialize((Element) domNode);
                } catch (java.io.IOException ioe) {
                    ioe.printStackTrace(System.err);
                }
                String s = stringOut.toString();
                if (s.substring(0, 5).equals("<?xml")) {
                    int i = s.indexOf('\n');
                    s = s.substring(i + 1);
                }

                return s;
            } else
                if (domNode instanceof Attr) {
                    return ((Attr) domNode).getValue();
                }
        }

    return null;

}
}
