/*
 * Created on Jan 21, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automatainout;

import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;

/**
 * @author suhong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class BranchStatistics implements Cloneable { 
	
	DagNode entryNode;	
	//starting point is added, not exist in the original plan before
	//boolean startingPointAdded = false;
	
	//the one that goes into the structural join
	//there can more than one ending point
	//for example, an extract can have multiple navunnest operators
	List endingNodes;
	//selectivity of the starting point
	private double startingNodeSel;
	//unit cost of the branch
	private double unitCost;
	//cost of the branch, i.e., unitCost * descSel
	private double cost;
	//probability of the branch yields something
	private double probNotEmpty;
	//rank value
	private double rankVal;
	//the selectivity of the fan out branch with the source tokenNav
	//private double fanOutSelWithinSource;
	
	public BranchStatistics(DagNode entryNode, List endingNodes, double startingNodeSel, double unitCost,double probNotEmpty){
		this.entryNode = entryNode;
		this.endingNodes = endingNodes;
		this.startingNodeSel = startingNodeSel;
		this.unitCost = unitCost;
		this.probNotEmpty = probNotEmpty;
		this.rankVal = computeBranchRank(startingNodeSel, unitCost, probNotEmpty);
		
	}
	
	public DagNode getEntryNode(){
		return entryNode;
	}
	
	public List getEndingNodes(){
		return endingNodes;
	}
	
	public double getStartingNodeSel(){
		return startingNodeSel;
	}
	
	public double getUnitCost(){
		return unitCost;
	}
	
	public double getCost(){
		return cost;
	}
	
	public double getProbNotEmpty(){
		return probNotEmpty;
	}

	public double getRankVal(){
		return rankVal;

	}
		  

	
	public void setCost(double cost){
		this.cost = cost;
	}	
	
	/*
	 * @param startingPointSel int the selectivity of the starting point @param
	 * branchCost the cost of the branch @param notEmptyProb the probability of
	 * the branch yielding some result within the scope of the structural join
	 * @return the rank value
	 */
	double computeBranchRank(double startingPointSel, double branchCost,
			double notEmptyProb) {
		if (notEmptyProb==1)
			return CostComp.INFINITY;
		
		double rank = startingPointSel * branchCost / (1 - notEmptyProb);
		
		return rank;
	}
	
	
	/*public void setFanOutSelWithinSource(double fanOutSelWithinSource){
		this.fanOutSelWithinSource = fanOutSelWithinSource;
	}
	
	public double getFanOutSelWithinSource(){
		return fanOutSelWithinSource;
	}*/

	
	public String toString(){
		return entryNode.toString() + "s-" + startingNodeSel +"u-" +unitCost + "p-" + probNotEmpty;
	}
	
	public Object clone(){
		Object o = null;
		try{
			o = super.clone();
		}catch (Exception e){
			System.out.println("error when cloning branch statistics");
			return null;
		}
		return o;
	}
	
	public List getEndingOps(){
		List endingOps = new ArrayList();
		for (int i=0; i<endingNodes.size(); i++)
			endingOps.add(((DagNode)endingNodes.get(i)).getOperator());
		return endingOps;
		
	}
	

}
