/*
 * Created on Mar 17, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automatainout;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.FindOpVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AffectedPart;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ContinuousOpt {

	//tokenNavs in plan
	static public List tokenNavsInPlan = new ArrayList();

	//nodeNavs in plan
	static public List nodeNavsInPlan = new ArrayList();

	static boolean betterPlanFound = false;


	/*
	 * public static CopiedDag getBestPlan(){ return bestResult.getTempPlan(); }
	 */
	/*
	 * @return boolean whether the current reasoning generates a better plan
	 * than the original plan
	 */
	public static boolean getBetterPlanFound() {
		return betterPlanFound;
	}

	/*
	 * will be invoked periodically @param auto ExtendedAutomata the auto
	 * associated with runningplan @param double threshold @param List
	 * navsChanged the list of navs whose moving should be considered @param
	 * runningPlan XATDag the currently running plan
	 */
	public static SimulateMoveResult reasoning(ExtendedAutomata auto,
			double threshold, List navsChanged, SimulateMoveResult lastBestResult) {

		betterPlanFound = false;

		//the alternative plans expanded from last plan
		//List curAlternativePlans = new ArrayList();

		//prepare plans that duplicate the curPlan
		List plansNeedRecompute = RuntimeOptUtil
				.initializeOpsNeedRecompute(navsChanged, lastBestResult);
		List plansNeedNotRecompute = new ArrayList();

		//the best plan in current move
		SimulateMoveResult bestResult = null;
		
		DagNode lastNodeMovedInLast = null;
		
		
		while (true) {
			//sorted version of plansNeedRecompute

//			move out ops whose cost changes, recompute their cost
			double maxRecomputeCostCut = CostComp.NEGAINFINITY;
			SimulateMoveResult maxRecomputeResult = null;
			int num = plansNeedRecompute.size();
			for (int i = 0; i < num; i++) {

				SimulateMoveResult oldResult = (SimulateMoveResult) plansNeedRecompute
						.get(i);

				if (oldResult.getMovedNodeInTemp().getOperator() instanceof PureNavigateAutoStream)
					//should pull out
					RuntimeOptUtil.estimateMoveOut(oldResult);
				else
					//should push in
					RuntimeOptUtil.estimateMoveIn(oldResult);

				//PlanManipulator.insertIntoSortedList(curAlternativePlans,
					//	oldResult);
				if (oldResult.getCostCut()>maxRecomputeCostCut){
					maxRecomputeCostCut = oldResult.getCostCut();
					maxRecomputeResult = oldResult;
				}
			}


			/**
			 * **************decide which operator to move
			 * out/in*****************
			 */
			
			//the maximal cost gain of the unrecomputed plans
			SimulateMoveResult maxNonRecomputeResult = null;
			double maxNonRecomputeCostCut = CostComp.NEGAINFINITY;
			if (plansNeedNotRecompute.size() > 0) {
				maxNonRecomputeResult = (SimulateMoveResult) plansNeedNotRecompute
						.get(0);
				maxNonRecomputeCostCut = maxNonRecomputeResult.getCostCut();
			}

			if (maxRecomputeCostCut > maxNonRecomputeCostCut) {
				if (maxRecomputeCostCut <= 0)
					//even the maximal one does not bring performance gain
					break;

				bestResult = maxRecomputeResult;
			} else {
				if (maxNonRecomputeCostCut <= 0)
					break;

				bestResult = maxNonRecomputeResult;
			}

			betterPlanFound = true;
			

			//adjust the cost cut to the best plan
			/*for (Iterator it = curAlternativePlans.iterator(); it.hasNext();) {
				SimulateMoveResult result = (SimulateMoveResult) it.next();
				result
						.setCostCut(result.getCostCut()
								- bestResult.getCostCut());
			}
			for (Iterator it = plansNeedNotRecompute.iterator(); it.hasNext();) {
				SimulateMoveResult result = (SimulateMoveResult) it.next();
				result
						.setCostCut(result.getCostCut()
								- bestResult.getCostCut());
			}*/

			CopiedDag curPlan = bestResult.getTempPlan();
			
			DagNode lastNodeMovedInBest = bestResult.getMovedNodeInTemp();
			DagNode lastNodeMovedInOld = curPlan.getOldNode(lastNodeMovedInBest);
			XATStreamOperator lastOpMovedInOld = (XATStreamOperator)lastNodeMovedInOld.getOperator();

			/** **adjust the two lists**** */
			/*List descendantTokenNavs = null;
			List ancestorNodeNavs = null;
			if (lastOpMovedInOld instanceof PureNavigateAutoStream)
				descendantTokenNavs = FindOpVisitor
					.quickGetDescTokenNavs(lastNodeMovedInOld);
			else 
				ancestorNodeNavs = FindOpVisitor
					.quickGetAncestorNodeNavs(lastNodeMovedInOld);*/
			List relatedTokenNavs = null;
			if (lastOpMovedInOld instanceof PureNavigateAutoStream)
				relatedTokenNavs = FindOpVisitor.quickGetRelatedTokenNavs(lastNodeMovedInOld);
			else{
				PureNavigateAutoStream frTokenNav = (PureNavigateAutoStream)RuntimeOptUtil.nodeNavToTokenNav.get(lastOpMovedInOld);
				relatedTokenNavs = FindOpVisitor.quickGetRelatedTokenNavs((DagNode)frTokenNav.getNode());
			}
				

			for (Iterator it = plansNeedNotRecompute.iterator(); it.hasNext();) {
				SimulateMoveResult oldResult = (SimulateMoveResult) it.next();
				
				if (oldResult == bestResult){
					it.remove();
					continue;
				}				
				
				DagNode movedNode = oldResult.getMovedNodeInTemp();
				XATStreamOperator movedOp = (XATStreamOperator) movedNode
						.getOperator();

				//those operators whose moving out/moving in need not to be
				// reconsidered
				//descendant tokenNav and ancestor nodeNav of last node moved
				if (movedOp instanceof PureNavigateAutoStream) {
				/*	NavigateStream resultFrNodeNav = (NavigateStream)RuntimeOptUtil.tokenNavToNodeNav.get(movedOp);
					//moved op results from being pushed in
					if (ancestorNodeNavs.contains(resultFrNodeNav)){
						it.remove();
						continue;
					}
					if (FindOpVisitor.quickGetAncestorNodeNavs((DagNode)resultFrNodeNav.getNode()).contains(lastOpMovedInOld)){
						it.remove();
						continue;
					}*/
					if (relatedTokenNavs.contains(movedOp)){
						it.remove();
						continue;
					}
					
					
				} else {
					PureNavigateAutoStream resultFrTokenNav = (PureNavigateAutoStream)RuntimeOptUtil.nodeNavToTokenNav.get(movedOp);
					if (relatedTokenNavs.contains(resultFrTokenNav)){
						it.remove();
						continue;
					}
					//moveNode is a nodeNav
					/*if (descendantTokenNavs.contains(resultFrTokenNav)){
						it.remove();
						continue;
					}	
					if (FindOpVisitor.quickGetDescTokenNavs((DagNode)resultFrTokenNav.getNode()).contains(lastOpMovedInOld)){
						it.remove();
						continue;
					}*/
					
				}
				

				//if tempPlan also introduces the same extract, should use the
				// adopted extract rather than its own extract
				/*
				 * Map oldTokenNavToNewExtractMap = oldResult.getAffectedPart()
				 * .getNewTokenNavToExtract(); Set entries =
				 * newTokenNavToNewExtractMap.keySet(); for (Iterator it2 =
				 * entries.iterator(); it2.hasNext();) { PureNavigateAutoStream
				 * tokenNav = (PureNavigateAutoStream) it2 .next();
				 * ExtractStream oldExtract = (ExtractStream)
				 * oldTokenNavToNewExtractMap .get(tokenNav); if (oldExtract !=
				 * null) { XATStreamOperator newExtract = (XATStreamOperator)
				 * newTokenNavToNewExtractMap .get(tokenNav);
				 * oldTokenNavToNewExtractMap.put(tokenNav, newExtract); DagNode
				 * extractNode = (DagNode) oldExtract.getNode();
				 * extractNode.setOperator(newExtract);
				 * tempPlan.registerOpToNode(newExtract, extractNode); } }
				 */
				//should incorporate previous changed part with new changed
				// part
				
				
				

				//move out lastNodeMovedInOriginal in oldResult as well
				CopiedDag tempPlan = oldResult.getTempPlan();
				DagNode lastNodeMovedInThisTemp = tempPlan
						.getNewNodeFromOldNode(lastNodeMovedInOld);
				oldResult.setMovedNode(lastNodeMovedInThisTemp);
				

				if (!PlanManipulator.needRecompute(movedOp, lastOpMovedInOld)){
					//place this plan to the list of newPlansNeedRecompute
					it.remove();
					PlanManipulator.insertIntoSortedList(plansNeedNotRecompute,
							oldResult);
					oldResult.setCostCut(oldResult.getCostCut()+bestResult.getCostCut());
				}
				else
					plansNeedRecompute.add(oldResult);
					

			}

			for (Iterator it = plansNeedRecompute.iterator(); it.hasNext();) {
				SimulateMoveResult oldResult = (SimulateMoveResult) it.next();
				if (oldResult == bestResult){
					it.remove();
					continue;
				}				

				DagNode movedNode = oldResult.getMovedNodeInTemp();
				XATStreamOperator movedOp = (XATStreamOperator) movedNode
						.getOperator();

				//those operators whose moving out/moving in need not to be
				// reconsidered
				//descendant tokenNav and ancestor nodeNav of last node moved
				if (movedOp instanceof PureNavigateAutoStream) {
					/*NavigateStream resultFrNodeNav = (NavigateStream)RuntimeOptUtil.tokenNavToNodeNav.get(movedOp);
					//moved op results from being pushed in
					if (ancestorNodeNavs.contains(resultFrNodeNav)){
						it.remove();
						continue;
					}
					List resultFrNodeNavAnces = FindOpVisitor.quickGetAncestorNodeNavs((DagNode)resultFrNodeNav.getNode());
					if (resultFrNodeNavAnces.contains(lastOpMovedInOld)){
						it.remove();
						continue;
					}*/
					if (relatedTokenNavs.contains(movedOp)){
						it.remove();
						continue;
					}
					
				} else {
					PureNavigateAutoStream resultFrTokenNav = (PureNavigateAutoStream)RuntimeOptUtil.nodeNavToTokenNav.get(movedOp);
					//moveNode is a nodeNav
					/*if (descendantTokenNavs.contains(resultFrTokenNav)){
						it.remove();
						continue;
					}
					List resultFrTokenNavDescs = FindOpVisitor.quickGetDescTokenNavs((DagNode)resultFrTokenNav.getNode());
					if (resultFrTokenNavDescs.contains(lastOpMovedInOld)){
						it.remove();
						continue;
					}*/
					if (relatedTokenNavs.contains(resultFrTokenNav)){
						it.remove();
						continue;
					}
					
				}
				
				AffectedPart deltaOldResultAffectedPart = oldResult.getDeltaAffectedPart();
				oldResult.updateNavLists(deltaOldResultAffectedPart);
				oldResult.getAffectedPart().incorporateAffectedPart(
						deltaOldResultAffectedPart);

				
				//move out lastNodeMovedInOriginal in oldResult as well
				CopiedDag tempPlan = oldResult.getTempPlan();
				DagNode lastNodeMovedInThisTemp = tempPlan
						.getNewNodeFromOldNode(lastNodeMovedInOld);
				oldResult.setMovedNode(lastNodeMovedInThisTemp);
				
				
				if (!PlanManipulator.needRecompute(movedOp, lastOpMovedInOld)){
					PlanManipulator.insertIntoSortedList(plansNeedNotRecompute,
							oldResult);
					oldResult.setCostCut(oldResult.getCostCut()+bestResult.getCostCut());
				}
					

			}
			
			/** *****update all auxilary structures**** */
			//including topology and statistics
			AffectedPart deltaAffectedPart = bestResult.getDeltaAffectedPart();
			//Map newTokenNavToNewExtractMap = deltaAffectedPart
			//	.getNewTokenNavToExtract();
			bestResult.updateNavLists(deltaAffectedPart);
			bestResult.getAffectedPart().incorporateAffectedPart(
					deltaAffectedPart);
			RuntimeOptUtil.adoptDeltaAffectedPart(bestResult.getAffectedPart());	
			

			if (plansNeedRecompute.size() == 0
					&& plansNeedNotRecompute.size() == 0)
				//no more move can be made
				break;
		}

		if (betterPlanFound) {
			RuntimeOptUtil.setInputPlan(bestResult.getTempPlan());
			System.out.println(bestResult.getTempPlan());
		}

		return bestResult;
	}

	/*
	 * @param oldResult SimulateMoveResult the curPlan and next move to take
	 * @param changeScript the global change script @return boolean whether move
	 * out or not move out the nav (if it is a tokenNav) or move in the nav (if
	 * it is a nodeNav)
	 */
	static void move(SimulateMoveResult oldResult) {
		DagNode nodeToBeMoved = oldResult.getMovedNodeInTemp();
		CopiedDag tempPlan = oldResult.getTempPlan();
		NavigateStream nav = (NavigateStream) nodeToBeMoved.getOperator();

		if (nav instanceof PureNavigateAutoStream)
			RuntimeOptUtil.moveOut(oldResult, nodeToBeMoved);
		else
			//must be a nodeNav
			RuntimeOptUtil.moveIn(oldResult, nodeToBeMoved);
	}

	
}