/*
 * a copy of a subplan in the dag
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automatainout;

import java.util.HashMap;
import java.util.Map;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CopiedDag extends XATDagImp implements XATDag {

	Map newNodeToOldNodes = new HashMap();

	Map oldNodeToNewNodes = new HashMap();

	//given a new node, map to the old node of which the new node is a copy
	Map newNodeToOriginalOldNodes = new HashMap();

	Map originalOldNodeToNewNodes = new HashMap();

	//the entry node
	//DagNode tokenNavNode;

	//given an operator, find its node in this dag
	Map opToNode = new HashMap();

	//whether this copy is from the original
	/*
	 * @param tokenNavNode Dagnode @param originalNode whether the tokenNavNode
	 * is a node in the original plan copy a dag, preparing for moving out
	 * tokenNavNode has to copy the whole plan
	 */
	public CopiedDag(XATDag dag) {

		if (dag instanceof CopiedDag)
			copyNode((DagNode) dag.getRoot(), (CopiedDag) dag);
		else
			//dag is the initial plan
			copyNode((DagNode) dag.getRoot(), null);

	}


	public DagNode getOldNode(DagNode newNode) {
		DagNode oldNode = (DagNode) newNodeToOldNodes.get(newNode);
		return oldNode;
	}

	public DagNode getNewNodeFromOldNode(DagNode oldNode) {
		DagNode newNode = (DagNode) oldNodeToNewNodes.get(oldNode);		
		return newNode;
	}

	public DagNode getNewNodeFromOriginalOldNode(DagNode originalOldNode) {
		DagNode newNode = (DagNode) originalOldNodeToNewNodes
				.get(originalOldNode);
		return newNode;
	}

	public DagNode getOriginalOldNode(DagNode newNode) {
		DagNode oldNode = (DagNode) newNodeToOriginalOldNodes.get(newNode);
		return oldNode;
	}

	void mapNewNode(DagNode newNode, DagNode oldNode) {
		newNodeToOldNodes.put(newNode, oldNode);
	}

	void mapOldNode(DagNode oldNode, DagNode newNode) {
		oldNodeToNewNodes.put(oldNode, newNode);
	}

	void mapNewNodeWithOriginalNode(DagNode newNode, DagNode oldNode) {
		newNodeToOriginalOldNodes.put(newNode, oldNode);
	}

	void mapOriginalOldNode(DagNode oldNode, DagNode newNode) {
		originalOldNodeToNewNodes.put(oldNode, newNode);
	}

	/*
	 * @param oldNode DagNode the node to be copied @param commonConfineSj the
	 * structural join node that confines both oldNode and all its siblings
	 * @return DagNode the copy of the oldNode copy the subplan rooted at the
	 * commonConfineSj
	 */
	/*
	 * DagNode copyNode(DagNode oldNode, StructuralJoinStream commonConfineSj) {
	 * 
	 * DagNode newNode = new DagNodeImp();
	 * newNode.setOperator(oldNode.getOperator()); mapNewNode(newNode, oldNode);
	 * mapOldNode(getOldNode(oldNode), newNode);
	 * 
	 * int newNodeParents = oldNode.getParentsSize(); for (int i = 0; i <
	 * newNodeParents; i++) { DagNode parentNode = (DagNode)
	 * oldNode.getParent(i); XATStreamOperator parentOp = (XATStreamOperator)
	 * parentNode .getOperator();
	 * 
	 * if (parentOp == commonConfineSj) continue;
	 * 
	 * DagNode copiedParentNode = copyNode(parentNode, commonConfineSj);
	 * newNode.addParent(copiedParentNode); copiedParentNode.addChild(newNode); }
	 * 
	 * return newNode; }
	 */

	/*
	 * @return DagNode[] the first is the copied, the second is the root
	 */
	DagNode copyNode(DagNode oldNode, CopiedDag dagOldNodeIn) {

		DagNode newNode = new DagNodeImp();
		newNode.setOperator(oldNode.getOperator());

		DagNode oldOldNode = null;

		if (dagOldNodeIn != null)
			oldOldNode = dagOldNodeIn.getOriginalOldNode(oldNode);

		if (oldOldNode == null) {
			//oldNode does not exist in dag before dagOldNodeIn
			mapNewNodeWithOriginalNode(newNode, oldNode);
			mapOriginalOldNode(oldNode, newNode);
		} else {
			//otherwise, use the node when it first appears
			mapNewNodeWithOriginalNode(newNode, oldOldNode);
			mapOriginalOldNode(oldOldNode, newNode);
		}

		mapNewNode(newNode, oldNode);
		mapOldNode(oldNode, newNode);

		opToNode.put(oldNode.getOperator(), newNode);

		int newNodeParents = oldNode.getParentsSize();

		if (newNodeParents == 0)
			this.addRoot(newNode);

		int childSize = oldNode.getChildrenSize();

		for (int i = 0; i < childSize; i++) {
			DagNode childNode = (DagNode) oldNode.getChild(i);
			XATStreamOperator childOp = (XATStreamOperator) childNode
					.getOperator();

			DagNode copiedChildNode = getNode(childOp);
			if (copiedChildNode == null)
				copiedChildNode = copyNode(childNode, dagOldNodeIn);

			newNode.addChild(copiedChildNode);
			copiedChildNode.addParent(newNode);
		}

		/*
		 * for (int i = 0; i < newNodeParents; i++) { DagNode parentNode =
		 * (DagNode) oldNode.getParent(i); XATStreamOperator parentOp =
		 * (XATStreamOperator) parentNode .getOperator();
		 * 
		 * DagNode copiedParentNode = getNode(parentOp); if (copiedParentNode ==
		 * null) //this node has not been copied yet copiedParentNode=
		 * copyNode(parentNode, dagOldNodeIn);
		 * 
		 * newNode.addParent(copiedParentNode);
		 * copiedParentNode.addChild(newNode); }
		 */

		return newNode;
	}

	public DagNode getNode(XATStreamOperator op) {
		return (DagNode) opToNode.get(op);
	}

	public void registerOpToNode(XATStreamOperator op, DagNode node) {
		opToNode.put(op, node);
	}

}