/*
 * Created on Feb 6, 2005
 *
 * To change the templafte for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automatainout;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.InTimeSJStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.XMLScanStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AffectedSj;
import edu.wpi.cs.dsrg.xmldb.xat.component.statistics.StatisticsCollector;

/**
 * @author suhong revisit
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CostComp {

	static int INFINITY = 1000;

	static int NEGAINFINITY = -1000;

	/*
	 * @param startingNode Dag the starting node of a branch @param endingNode
	 * the ending node of a branch, which must be a structural join the cost
	 * acutally does not include the ending node and the starting node @return
	 * double compute the statistics for the branch
	 */
	/*
	 * public static BranchStatistics getBranchSta(DagNode entryNode, List
	 * endingNodes) { double startingNodeSel = ((OpStatistics) RuntimeOptUtil
	 * .getOpToStatistics().get(entryNode)).getSel(); double unitCost = 0;
	 * double cost = 0; double probNotEmpty = 1; double branchSel = 1;
	 * 
	 * DagNode curNode = (DagNode) entryNode.getParent(0); if (curNode !=
	 * endingNode) { //no op on the branch int num = curNode.getParentsSize();
	 * 
	 * for (int i = 0; i < num; i++) { DagNode parentNode = (DagNode)
	 * curNode.getParent(i); BranchStatistics parentBranchSta =
	 * computeBranchStatistics(parentNode); unitCost = unitCost + branchSel *
	 * parentBranchSta.getCost(); branchSel = branchSel *
	 * parentBranchSta.getStartingNodeSel(); probNotEmpty = probNotEmpty *
	 * parentBranchSta.getProbNotEmpty(); } }
	 * 
	 * BranchStatistics branchSta = new BranchStatistics(entryNode, endingNode,
	 * startingNodeSel, unitCost, probNotEmpty);
	 * 
	 * return branchSta; }
	 */

	/*
	 * @param fanInSj DagNode a structural join node @param branchStas List a
	 * list of branchstas @return List a list of sorted branchsta also set the
	 * cost of each branch
	 */
	static List sortBranches(List branchStas) {
		List sortedBranches = new ArrayList();

		int branchNum = branchStas.size();

		double curOverallBranchSel = 1;

		for (int i = 0; i < branchNum; i++) {
			BranchStatistics branchSta = (BranchStatistics) branchStas.get(i);
			double rankVal = branchSta.getRankVal();

			int sortedNum = sortedBranches.size();
			if (sortedNum == 0) {
				sortedBranches.add(branchSta);
			} else
				for (int j = 0; j < sortedNum; j++) {
					BranchStatistics sortedBranchSta = (BranchStatistics) sortedBranches
							.get(j);
					double sortedRankVal = sortedBranchSta.getRankVal();
					if (rankVal >= sortedRankVal) {
						sortedBranches.add(j + 1, branchSta);
						curOverallBranchSel = branchSta.getProbNotEmpty();
						break;
					}
				}

		}

		//set cost of each branch
		for (int i = 0; i < branchNum; i++) {
			BranchStatistics branchSta = (BranchStatistics) branchStas.get(i);
			branchSta.setCost(curOverallBranchSel * branchSta.getUnitCost());
			curOverallBranchSel = curOverallBranchSel
					* branchSta.getProbNotEmpty();
		}

		return sortedBranches;
	}

	/*
	 * merge the passive branch into active branch both branches are optimal
	 * within themself @param activeNode DagNode @param passiveNode DagNode an
	 * entry node @return BranchStatistics the statistics of the new branch
	 * merged
	 *  
	 */
	public static BranchStatistics mergeTwoBranches(DagNode activeSourceNode,
			DagNode passiveSourceNode, CopiedDag tempPlan, List removedSjs,
			List affectedSjs, Map newEntryOpToInputSj) {

		List sortedOpSta = new ArrayList();

		OpStatistics activeSourceOpSta = StatisticsCollector.getOpSta((XATStreamOperator) activeSourceNode
				.getOperator());

		DagNode activeNode = activeSourceNode;
		XATStreamOperator activeOp = (XATStreamOperator) activeNode
				.getOperator();
		OpStatistics activeOpSta = StatisticsCollector.getOpSta(activeOp);
		//the entry node does not involve in the merging
		XATStreamOperator passiveSourceOp = (XATStreamOperator) passiveSourceNode
				.getOperator();
		OpStatistics passiveSourceOpSta = StatisticsCollector.getOpSta(passiveSourceOp);
		sortedOpSta.add(passiveSourceOpSta);
		DagNode passiveNode = (DagNode) passiveSourceNode.getParent(0);
		XATStreamOperator passiveOp = (XATStreamOperator) passiveNode
				.getOperator();
		OpStatistics passiveOpSta = StatisticsCollector.getOpSta(passiveOp);

		DagNode endingPoint = null;

		while (!(passiveOp instanceof StructuralJoinStream)) {
			double passiveOpRank = passiveOpSta.getRank();

			while (!(activeOp instanceof StructuralJoinStream)) {

				activeOpSta = StatisticsCollector.getOpSta(activeOp);
				double activeOpRank = activeOpSta.getRank();

				if (activeOpRank >= passiveOpRank) {
					sortedOpSta.add(passiveOpSta);
					break;
				} else
					sortedOpSta.add(activeOpSta);

				if (activeNode.getParentsSize() > 1)
					//cannot insert any operator after it
					//otherwise duplciates appear
					break;
				else {
					activeNode = activeNode.getParent(0);
					activeOp = (XATStreamOperator) activeNode.getOperator();
				}
			}//end of inner while

			if (activeOp instanceof StructuralJoinStream)
				//insert at the end
				sortedOpSta.add(passiveOpSta);
			//passive side has not finished yet, find the ending point
			endingPoint = passiveNode;
			passiveNode = passiveNode.getParent(0);
			passiveOp = (XATStreamOperator) passiveNode.getOperator();
			passiveOpSta = StatisticsCollector.getOpSta(passiveOp);

		}//end of outer while

		if (!(activeOp instanceof StructuralJoinStream)) {
			//active op side has not finished yet
			sortedOpSta.add(activeOpSta);
			while (!(activeOp instanceof StructuralJoinStream)) {
				endingPoint = activeNode;
				activeNode = activeNode.getParent(0);
				activeOp = (XATStreamOperator) activeNode.getOperator();
			}
		}

		PlanManipulator.connect(sortedOpSta, activeNode, tempPlan);

		if (activeNode.getChildrenSize() == 1) {
			removedSjs.add(activeOp);
			//remove this structural join
			DagNode sjOnlyChild = (DagNode) activeNode.getChild(0);
			for (Iterator it = activeNode.getParents(); it.hasNext();) {
				DagNode sjParent = (DagNode) it.next();
				sjParent.addChild(sjOnlyChild);
				sjOnlyChild.addParent(sjParent);
				sjParent.deleteChild(activeNode);
			}
			activeNode.deleteAllParents();
			sjOnlyChild.deleteParent(activeNode);

			StructuralJoinStream sj = (StructuralJoinStream) activeNode
					.getOperator();
			int affectedSjNum = affectedSjs.size();
			for (int i = 0; i < affectedSjNum; i++) {
				AffectedSj affectedSj = (AffectedSj) affectedSjs.get(i);
				if (affectedSj.getSj() == sj) {
					StructuralJoinStream parentAffectedSj = (StructuralJoinStream) RuntimeOptUtil
							.getEntryOpToInputSj().get(sj);
					affectedSj.setSj(parentAffectedSj);
					affectedSj.setSjRemoved(true);
					//the remove of sj causes the relationship of
					// entryToInputSj changes
					//update the mapping relationship
					//	newEntryOpToInputSj.put(passiveSourceNode.getOperator(),
					//		parentAffectedSj);
					/*
					 * DagNode passiveSourceNodeInOriginal =
					 * tempPlan.getOriginalOldNode(passiveSourceNode); DagNode
					 * tokenNavOfPassiveSourceNode
					 * =(DagNode)passiveSourceNodeInOriginal.getChild(0); List
					 * descs =
					 * FindOpVisitor.getAncesTokenNavs(tokenNavOfPassiveSourceNode);
					 * for (Iterator it = descs.iterator();it.hasNext();){
					 * XATStreamOperator ancesTokenNav =
					 * (XATStreamOperator)it.next(); XATStreamOperator entryOp =
					 * PlanManipulator
					 * .getEntryOpFromTokenNav((DagNode)ancesTokenNav.getNode());
					 * newEntryOpToInputSj.put(entryOp, parentAffectedSj); }
					 */
					break;
				}
			}
		}

		BranchStatistics branchSta = computeBranchStatistics(passiveSourceNode);

		return branchSta;

	}

	/*
	 * revisit @param startingPoint DagNode a node identifies a branch @return
	 * double the cost of the branch which does not include the cost of the
	 * starting point
	 */
	public static BranchStatistics computeBranchStatistics(DagNode entryNode) {

		XATStreamOperator entryOp = (XATStreamOperator) entryNode.getOperator();
		OpStatistics entryOpSta = (OpStatistics) RuntimeOptUtil
				.getOpToStatistics().get(entryOp);
		if (entryOpSta == null) {
			//the entryNode is a new one resulted from the rewriting
			if (entryOp instanceof ExtractStream) {
				StatisticsCollector.setUpExtractSta((ExtractStream) entryOp);
			} else {
				//entryOp is SJoin
			}
		}
		double entrySel = entryOpSta.getSel();

		List endingNodes = PlanManipulator.findEndingPointsFromEntry(entryNode);

		double unitCostSum = 0;
		double overallProbNotEmpty = 1;

		for (Iterator it = entryNode.getParents(); it.hasNext();) {
			double unitCost = 0;
			double sel = 1;
			double probNotEmpty = 1;
			DagNode nodeOnBranch = (DagNode) it.next();
			XATStreamOperator opOnBranch = (XATStreamOperator) nodeOnBranch
					.getOperator();

			while (!(opOnBranch instanceof StructuralJoinStream)) {
				OpStatistics opSta = StatisticsCollector.getOpSta(opOnBranch);
				double localUnitCost = opSta.getUnitCost();
				double localSel = opSta.getSel();
				double localProbNotEmpty = opSta.getProbNotEmpty();

				unitCost = unitCost + sel * localUnitCost;
				sel = sel * localSel;
				probNotEmpty = probNotEmpty * localProbNotEmpty;

				nodeOnBranch = (DagNode) nodeOnBranch.getParent(0);
				opOnBranch = (XATStreamOperator) nodeOnBranch.getOperator();
			}

			probNotEmpty = 1 - Math.pow(1 - probNotEmpty, entrySel);

			unitCostSum += unitCost;
			overallProbNotEmpty *= probNotEmpty;
		}

		return new BranchStatistics(entryNode, endingNodes, entrySel,
				unitCostSum, overallProbNotEmpty);

	}

	/*
	 * @oarm entryNode DagNode get an entry node @return double \prod_{op \in
	 * between entryNode and bottommost tokenNav} sel(op)
	 *  
	 */
	public static double getOverallSel(DagNode node) {

		XATStreamOperator op = (XATStreamOperator) node.getOperator();

		if (op instanceof PureNavigateAutoStream) {
			DagNode child = (DagNode) node.getChild(0);
			if (child.getOperator() instanceof XMLScanStream)
				//op is the bottommost tokenNav
				return 1;
			else {
				//not the bottommost tokenNav
				OpStatistics opSta = (OpStatistics) RuntimeOptUtil
						.getOpToStatistics().get(op);
				double localSel = opSta.getSel();
				return localSel * getOverallSel(child);
			}
		} else if (op instanceof ExtractStream) {
			//child must be a tokenNav
			DagNode child = (DagNode) node.getChild(0);
			return getOverallSel(child);
		} else {
			double overallSel = 1;
			int childrenSize = node.getChildrenSize();
			for (int i = 0; i < childrenSize; i++) {
				DagNode child = (DagNode) node.getChild(i);
				overallSel = overallSel * getOverallSel(child);
			}
			return overallSel;
		}

	}

	/*
	 * @oarm entryNode DagNode get an entry node @return double \prod_{op \in
	 * between entryNode and bottommost tokenNav} sel(op)
	 *  
	 */
	public static double getOverallSelFromInputSJ(XATStreamOperator sjoin) {

		double overallSel = 1;

		DagNode fanOutNode = (DagNode) ((InTimeSJStream) sjoin)
				.getBranchNavOp().getNode();
		PureNavigateAutoStream fanOutOp = (PureNavigateAutoStream) fanOutNode
				.getOperator();

		DagNode curNode = fanOutNode;
		DagNode childNode = (DagNode) fanOutNode.getChild(0);
		XATStreamOperator childOp = (XATStreamOperator) childNode.getOperator();
		while (!(childOp instanceof XMLScanStream)) {
			//curnode is not bottommost tokenNav yet
			double sel = ((OpStatistics) RuntimeOptUtil.getOpToStatistics()
					.get(childOp)).getSel();
			overallSel = overallSel * sel;
			curNode = childNode;
			childNode = (DagNode) childNode.getChild(0);
			childOp = (XATStreamOperator) childNode.getOperator();
		}
		return overallSel;

	}

	
	/*
	 * @param entryNode DagNode an entry node of subplan the input sj must have
	 * a fan-out tokenNav @return double return the overall selectivity of the
	 * fan-out tokenNav
	 */
	public static double getOverallSelOfEntry(DagNode entryNode) {
		double overallSel = 1;

		XATStreamOperator entryOp = (XATStreamOperator) entryNode.getOperator();
		DagNode fanOutNode = null;
		PureNavigateAutoStream fanOutOp = null;
		if (entryOp instanceof InTimeSJStream)
			fanOutNode = (DagNode) ((InTimeSJStream) entryOp).getBranchNavOp()
					.getNode().getChild(0);
		else
			//entryop must be an extract
			fanOutNode = (DagNode) entryOp.getNode().getChild(0);
		fanOutOp = (PureNavigateAutoStream) fanOutNode.getOperator();

		DagNode curNode = fanOutNode;
		DagNode childNode = (DagNode) fanOutNode.getChild(0);
		XATStreamOperator childOp = (XATStreamOperator) childNode.getOperator();
		while (!(childOp instanceof XMLScanStream)) {
			//curnode is not bottommost tokenNav yet
			double sel = ((OpStatistics) RuntimeOptUtil.getOpToStatistics()
					.get(childOp)).getSel();
			overallSel = overallSel * sel;
			curNode = childNode;
			childNode = (DagNode) childNode.getChild(0);
			childOp = (XATStreamOperator) childNode.getOperator();
		}
		return overallSel;

	}
	
			

}