/*
 * Created on Mar 22, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automatainout;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.statistics.StatisticsCollector;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OnetimeOpt {
	//	all the tokenNav operators in the plan
	static List tokenNavsInPlan = new ArrayList();

	/*
	 * will be invoked periodically
	 */
	public void reasoning(ExtendedAutomata auto, double threshold) {

		//the alternative plans expanded from last plan
		List curAlternativePlans = new ArrayList();

		ChangeScript changeScript = new ChangeScript();
		//prepare plans that duplicate the curPlan
		List plansNeedRecompute = RuntimeOptUtil
				.initializeOpsNeedRecompute(tokenNavsInPlan);
		List plansNeedNotRecompute = new ArrayList();

		//the last node (in the currently running plan) whose moving out/in is
		// adopted
		DagNode lastNodeMovedInOriginal = null;

		while (true) {

			curAlternativePlans.clear();
			List newPlansNeedRecompute = new ArrayList();

			//move out ops whose cost changes, recompute their cost
			int num1 = plansNeedRecompute.size();
			for (int i = 0; i < num1; i++) {
				SimulateMoveResult oldResult = (SimulateMoveResult) plansNeedRecompute
						.get(i);

				DagNode navChanged = oldResult.getMovedNodeInTemp();
				XATStreamOperator navOp = (XATStreamOperator) navChanged
						.getOperator();

				SimulateMoveResult newResult;
				if (navOp instanceof PureNavigateAutoStream)
					//should pull out
					newResult = RuntimeOptUtil.estimateMoveOut(
							(PureNavigateAutoStream) navOp, oldResult
									.getTempPlan());
				else
					//should push in
					newResult = RuntimeOptUtil.estimateMoveIn(
							(NavigateStream) navOp, oldResult.getTempPlan());

				double costChange = newResult.getCostChange();
				//adjust the position of newSimulateMoveOutResult
				PlanManipulator.insertIntoSortedList(curAlternativePlans,
						newResult);
			}

			/** **************decide which operator to move out***************** */
			SimulateMoveResult maxOverallResult;
			SimulateMoveResult maxRecomputeResult = null;
			double maxRecomputeCostChange = OpStatistics.INFINITY;
			if (curAlternativePlans.size() > 0) {
				maxRecomputeResult = (SimulateMoveResult) curAlternativePlans
						.get(0);
				//the maximal cost gain of the recomputed operators
				maxRecomputeCostChange = maxRecomputeResult.getCostChange();
			}
			//the maximal cost gain of the unrecomputed plans
			SimulateMoveResult maxNonRecomputeResult = null;
			double maxNonRecomputeCostChange = OpStatistics.INFINITY;
			if (plansNeedNotRecompute.size() > 0) {
				maxNonRecomputeResult = (SimulateMoveResult) plansNeedNotRecompute
						.get(0);
				maxNonRecomputeCostChange = maxNonRecomputeResult
						.getCostChange();
			}

			if (maxRecomputeCostChange < maxNonRecomputeCostChange) {
				if (maxRecomputeCostChange > 0)
					//even the maximal one does not bring performance gain
					break;
				maxOverallResult = maxRecomputeResult;
				curAlternativePlans.remove(maxRecomputeResult);

			} else {
				if (maxNonRecomputeCostChange > 0)
					break;

				maxOverallResult = maxNonRecomputeResult;
				//now adopt the change by actually moving out/in the node
				CopiedDag lastTempPlan = maxNonRecomputeResult.getTempPlan();

				moveOut(maxNonRecomputeResult, changeScript);
				plansNeedNotRecompute.remove(maxNonRecomputeResult);
			}

			//change the changescript
			changeScript.adoptChanges(maxOverallResult
					.getChangeToChangeScript());

			CopiedDag curPlan = maxOverallResult.getTempPlan();
			DagNode lastNodeMovedInTemp = maxOverallResult.getMovedNodeInTemp();
			lastNodeMovedInOriginal = curPlan
					.getOriginalOldNode(lastNodeMovedInTemp);

			/** **adjust the two lists**** */
			for (Iterator it = plansNeedNotRecompute.iterator(); it.hasNext();) {
				SimulateMoveResult oldResult = (SimulateMoveResult) it.next();
				CopiedDag tempPlan = oldResult.getTempPlan();
				DagNode movedNode = oldResult.getMovedNodeInTemp();
				DagNode movedNodeInOriginal = tempPlan
						.getOriginalOldNode(movedNode);
				List opsMovedAsSideEffect = oldResult.getOpsMovedAsSideEffect();

				DagNode nodeMoved = oldResult.getTempPlan()
						.getNewNodeFromOriginalOldNode(lastNodeMovedInOriginal);

				//those operators whose moving out/moving in need not to be
				// reconsidered
				if (opsMovedAsSideEffect.contains(nodeMoved)) {
					it.remove();
					continue;
				}

				moveOut(oldResult, changeScript);
				if (PlanManipulator.needRecompute(movedNodeInOriginal,
						lastNodeMovedInOriginal))
					PlanManipulator.insertIntoSortedList(newPlansNeedRecompute,
							oldResult);

			}

			for (Iterator it = curAlternativePlans.iterator(); it.hasNext();) {
				SimulateMoveResult oldResult = (SimulateMoveResult) it.next();
				CopiedDag tempPlan = oldResult.getTempPlan();
				DagNode movedNode = oldResult.getMovedNodeInTemp();
				DagNode movedNodeInOriginal = tempPlan
						.getOriginalOldNode(movedNode);
				List opsMovedAsSideEffect = oldResult.getOpsMovedAsSideEffect();

				DagNode nodeMoved = oldResult.getTempPlan()
						.getNewNodeFromOriginalOldNode(lastNodeMovedInOriginal);

				//those operators whose moving out/moving in need not to be
				// reconsidered
				if (opsMovedAsSideEffect.contains(nodeMoved)) {
					it.remove();
					continue;
				}

				moveOut(oldResult, changeScript);
				if (PlanManipulator.needRecompute(movedNodeInOriginal,
						lastNodeMovedInOriginal))
					PlanManipulator.insertIntoSortedList(plansNeedRecompute,
							oldResult);
				else
					PlanManipulator.insertIntoSortedList(plansNeedNotRecompute,
							oldResult);

			}

			plansNeedRecompute = newPlansNeedRecompute;
		}
	}

	/*
	 * @param oldResult SimulateMoveResult the curPlan and next move to take
	 * @param changeScript the global change script @return ChangeScript delta
	 * change script move out the nav
	 */
	static void moveOut(SimulateMoveResult oldResult, ChangeScript changeScript) {
		ChangeToChangeScript changeToChangeScript = null;

		CopiedDag tempPlan = oldResult.getTempPlan();
		DagNode nodeToBeMoved = oldResult.getMovedNodeInTemp();
		NavigateStream nav = (NavigateStream) nodeToBeMoved.getOperator();

		List opsMovedAsSideEffect = new ArrayList();

		RuntimeOptUtil.moveOut((PureNavigateAutoStream) nav, tempPlan);

		oldResult.setOpsMovedAsSideEffect(opsMovedAsSideEffect);

		oldResult.setChangeToChangeScript(changeToChangeScript);

		return;
	}
}