/*
 * Created on Jan 21, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.automatainout;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OpStatistics {
	//	given an operator, find object[4] in the list
	//object[0] = operator
	//object[1] = cost
	//object[2] = selectivity, number of output for an input
	//object[3] = probability of generating something for an input
	//i.e., for a navunnest, object[2] = object[3]
	//for a navnest_{$a, p1} object[2] is the number of p1 within $a
	//object[3] is the prob that $a will have sth
	//i.e., object[2] = object[3] * proba (number of p1|$a have p1)

	private XATStreamOperator op;

	private double unitCost;

	private double cost;

	private double sel;

	private double probNotEmpty;

	private double rank;
	
	public OpStatistics(XATStreamOperator op) {
		this.op = op;
	}

	public OpStatistics(XATStreamOperator op, double unitCost, double cost,
			double sel, double probNotEmpty) {
		this.op = op;
		this.unitCost = unitCost;
		this.cost = cost;
		this.sel = sel;
		this.probNotEmpty = probNotEmpty;
		computeRank();

	}
		
	public XATStreamOperator getOp() {
		return op;
	}

	public double getUnitCost() {
		return unitCost;
	}

	public double getCost() {
		return cost;
	}

	public double getSel() {
		return sel;
	}

	public double getProbNotEmpty() {
		return probNotEmpty;
	}


	public void setCost(double cost) {
		this.cost = cost;

	}

	public void setUnitCost(double unitCost) {
		this.unitCost = unitCost;
		computeRank();
	}

	public void setSel(double sel) {
		this.sel = sel;
        computeRank();
	}

	public void setProbNotEmpty(double probNotEmpty) {
		this.probNotEmpty = probNotEmpty;
	}

	public double getRank() {
		return rank;
	}

	public void computeRank() {
		if (sel == 1)
			rank = CostComp.INFINITY;
		else
			rank = unitCost / (1 - sel);
	}

	public String toString() {
		String output = "";
		output = output + op;
		return output;
	}

}