package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;





/**
 * Insert the type's description here.
 * Creation date: (2/7/2003 9:42:31 AM)
 * @author: Hong Su
 */
public class CharListener extends Thread{

	private Socket socket;
	private BufferedReader in;
	private PrintWriter out;
	private boolean docEOF = false;
	private XMLReader parser = null;

	//the flag indicating whether into token or queue
	private boolean intoQueue = true;
	private XATTokenQueue tokenQueue;	
	public EmptySAXHandler exec;
	private int port;

	private StringBuffer charBuffer;
	private int capacity;

	private String xmlFileName;
/**
 * initialize socket
 */
public CharListener(int port, int capacity, boolean intoQueue) {

    this.intoQueue = intoQueue;

    this.port = port;

    this.capacity = capacity;

    if (intoQueue)
        tokenQueue = new XATTokenQueue();
    

}
/**
 * initialize socket
 */
public CharListener(int capacity, boolean intoQueue, String xmlFileName) {

    this.capacity = capacity;

    this.intoQueue = intoQueue;

    this.xmlFileName = xmlFileName;

    if (intoQueue)
        tokenQueue = new XATTokenQueue();
   

}
/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 8:53:37 PM)
 * @return java.lang.StringBuffer
 */
public java.lang.StringBuffer getCharBuffer() {
	return charBuffer;
}
/**
 * Insert the method's description here.
 * Creation date: (4/14/2003 11:35:23 PM)
 * @return int
 */
public int getPort() {
	return port;
}
/**
 * Insert the method's description here.
 * Creation date: (4/16/2003 11:06:59 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTokenQueue
 */
public XATTokenQueue getTokenQueue() {
	return tokenQueue;
}
/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 3:36:13 PM)
 */
public void readFrBufferRun() {
    /*try {
        XMLReader parser =
            XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");

        exec = new EmptySAXHandler(tokenQueue);

        parser.setContentHandler(exec);

        parser.setFeature("http://xml.org/sax/features/validation", false);
        //The only way that the parser can determine if text is ignorable is by reading the associated grammar and having a content model for the document.
        //a dtd is needed always
        parser.setFeature(
            "http://apache.org/xml/features/nonvalidating/load-external-dtd",
            true);

        parser.parse(new InputSource(new StringReader(charBuffer.toString())));
    } catch (Exception e) {
        e.printStackTrace();
        System.exit(-1);
    }*/

}
/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 3:36:13 PM)
 */
public void readFrFileRun() {
 /*   try {
        XMLReader parser =
            XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");

        exec = new EmptySAXHandler(tokenQueue);

        parser.setContentHandler(exec);

        parser.setFeature("http://xml.org/sax/features/validation", false);
        //The only way that the parser can determine if text is ignorable is by reading the associated grammar and having a content model for the document.
        //a dtd is needed always
        parser.setFeature(
            "http://apache.org/xml/features/nonvalidating/load-external-dtd",
            true);

        System.out.println("parsing " + xmlFileName);
        parser.parse(new InputSource(new FileReader(xmlFileName)));

        //free space of exec
        exec = null;

        
    } catch (Exception e) {
        e.printStackTrace();
        System.exit(-1);
    }*/

}
/**
 * Insert the method's description here.
 * Creation date: (3/26/2003 2:08:39 PM)
 */
public void run() {
  
    try {

        //get parser
        try {
            InetAddress addr = InetAddress.getByName(null);

            //socket = new Socket(addr, CharSenders.PORT);
            socket = new Socket(addr, port);

            System.out.println("send a request: " + socket);

            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));

            /*   String line = null;
            
                StringBuffer er = new StringBuffer();
                
                while (!((line=in.readLine())==null)){
                   er.append(line); 
                }
            
                System.out.println(er);*/

            XMLReader parser =
                XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");

            parser.setContentHandler(exec);

            parser.setFeature("http://xml.org/sax/features/validation", false);
            //The only way that the parser can determine if text is ignorable is by reading the associated grammar and having a content model for the document.
            //a dtd is needed always
            parser.setFeature(
                "http://apache.org/xml/features/nonvalidating/load-external-dtd",
                true);

            /*if (exec.getStartTagCount() == 0) {
                out =
                    new PrintWriter(
                        new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())));
                out.println("EOF");
            }*/

           
            long beginTime = 0;
            long endTime = 0;
            beginTime = System.currentTimeMillis();

            System.out.println("begin parsing\n");
            parser.parse(new InputSource(in));

            endTime = System.currentTimeMillis();
            System.out.println("parse need:" + (endTime - beginTime));
        }// catch (Exception e) {
         //   e.printStackTrace();   
         //   throw e; 
        //}
        finally {
            System.out.println("listener closing...");
            socket.close();             
        }
    } catch (Exception e) {
        e.printStackTrace();
        System.out.println("char listeners errors");
        System.exit(-1);
    }
  
    //print what is in the buffer
    /*for (int i = 0; i < tokenBuffer.length; i++) {
        if (tokenBuffer[i] == null)
            break;
        System.out.println(tokenBuffer[i]);
    }*/

}
/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 8:53:37 PM)
 * @param newCharBuffer java.lang.StringBuffer
 */
public void setCharBuffer(java.lang.StringBuffer newCharBuffer) {
	charBuffer = newCharBuffer;
}
/**
 * Insert the method's description here.
 * Creation date: (4/14/2003 11:35:23 PM)
 * @param newPort int
 */
public void setPort(int newPort) {
	port = newPort;
}
/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 11:17:16 AM)
 * @param newXmlFileName java.lang.String
 */
public void setXmlFileName(java.lang.String newXmlFileName) {
	xmlFileName = newXmlFileName;
}
}
