package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators;

/**
 * Insert the type's description here.
 * Creation date: (2/7/2003 9:47:25 AM)
 * @author: Hong Su
 */
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.helpers.AttributesImpl;

/**
 * Insert the type's description here.
 * Creation date: (1/21/2003 10:04:21 AM)
 * @author: Hong Su
 */

public class EmptySAXHandler implements ContentHandler {
    private int tokenCount = 0;

    ObjectOutputStream oos = null;
    FileOutputStream fos = null;
    BufferedOutputStream bos = null;

/**
 * EmptySAXHandler constructor comment.
 */
public EmptySAXHandler(String tokenFileName) {
    super();

    try {
        fos = new FileOutputStream(tokenFileName);
        bos = new BufferedOutputStream(fos);
        oos = new ObjectOutputStream(bos);
    } catch (IOException e) {
        e.printStackTrace();
        System.exit(-1);
    }

}
/**
 * characters method comment.
 */
public void characters(char[] ch, int start, int length)
    throws org.xml.sax.SAXException {

    tokenCount++;

    String pcdata = (new String(ch, start, length)).trim();

    if (pcdata.length() == 0)
        //do not process blank
        return;

    // XMLToken newToken = new XMLToken(XMLToken.PCDATA, pcdata, null);

    try {
       // oos.writeObject(new XMLToken(XMLToken.PCDATA, pcdata, null));
       new XMLToken(XMLToken.PCDATA, pcdata, null).writeExternal(oos);
    } catch (IOException e) {
        e.printStackTrace();
        System.exit(-1);
    }

    //pcdataCount++;

    //free the space
    ch = null;

}
/**
 * endDocument method comment.
 */
public void endDocument() throws org.xml.sax.SAXException {
    System.out.println(
        "************************************************************************");
  // System.out.println(
  //      "parsing done: " + (startTagCount * 2 + pcdataCount) + " tokens in total.");

  System.out.println("parsing done : " + tokenCount + "tokens in total.");

    //add a special EOF token

    //XMLToken token = new XMLToken(XMLToken.EOF, null, null);

    try {
        //oos.writeObject(new XMLToken(XMLToken.EOF, null, null));
        new XMLToken(XMLToken.EOF, "", null).writeExternal(oos);
        oos.flush();
    } catch (IOException e) {
        e.printStackTrace();
        System.exit(-1);
    }

    try {
        oos.close();

        bos.close();

        fos.close();
    } catch (IOException e) {
        e.printStackTrace();
        System.exit(-1);
    }

}
/**
 * endElement method comment.
 */
public void endElement(
    java.lang.String uri,
    java.lang.String localName,
    java.lang.String qName)
    throws org.xml.sax.SAXException {

    // XMLToken newToken = new XMLToken(XMLToken.CLOSE, localName, null);
    tokenCount++;

    try {
       // oos.writeObject(new XMLToken(XMLToken.CLOSE, localName, null));
       new XMLToken(XMLToken.CLOSE, localName, null).writeExternal(oos);
    } catch (IOException e) {
        e.printStackTrace();
        System.exit(-1);
    }

}
/**
 * endPrefixMapping method comment.
 */
public void endPrefixMapping(java.lang.String arg1) throws org.xml.sax.SAXException {}
/**
 * ignorableWhitespace method comment.
 */
public void ignorableWhitespace(char[] arg1, int arg2, int arg3) throws org.xml.sax.SAXException {}
/**
 * processingInstruction method comment.
 */
public void processingInstruction(java.lang.String arg1, java.lang.String arg2) throws org.xml.sax.SAXException {}
/**
 * setDocumentLocator method comment.
 */
public void setDocumentLocator(org.xml.sax.Locator arg1) {}
/**
 * skippedEntity method comment.
 */
public void skippedEntity(java.lang.String arg1) throws org.xml.sax.SAXException {}
/**
 * startDocument method comment.
 */
public void startDocument() throws org.xml.sax.SAXException {
    System.out.println("startDocument");
    

}
/**
 * startElement method comment.
 */
public void startElement(
    java.lang.String uri,
    java.lang.String localName,
    java.lang.String qName,
    org.xml.sax.Attributes attrs)
    throws org.xml.sax.SAXException {

   // startTagCount++;

   tokenCount ++;
   
    
    XMLToken newToken = null;

    //creat open tag
    if (attrs.getLength() > 0) {

        Attributes tokenAttrs = new AttributesImpl(attrs);

        newToken = new XMLToken(XMLToken.OPEN, localName, tokenAttrs);
    } else
        newToken = new XMLToken(XMLToken.OPEN, localName, null);

     try {
        //oos.writeObject(newToken);
        newToken.writeExternal(oos);
    } catch (IOException e) {
        e.printStackTrace();
        System.exit(-1);
    }

}
/**
 * startPrefixMapping method comment.
 */
public void startPrefixMapping(java.lang.String arg1, java.lang.String arg2) throws org.xml.sax.SAXException {}
}
