package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import java.util.ArrayList;
import java.util.Random;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * A super class for all classes that can generate the tuples
 * @author: Luping Ding
 */

public abstract class AttributeGenerator {
	public static final int ASC = 0;
	public static final int DESC = 1;
	public static final int RANDOM = 2;
	/** Stores the name of the attribute that is only the
	 * schema information 
	 */
	protected String attributeName; 
	/** Data range of the join value. */
	/** Modified by Yali zhu 
	 * Change the integer field range to an arraylist (starttuplenum, range, starttuplenum, range ...)
	 */
 	protected ArrayList rangeList;
	/** current range is [0, range) */
	protected int range;
 	/** the index points to the next starttuplenum */
 	protected int rangeIndex = 0; 
 	/** the next tuple number that need to change the range */
 	protected int nextRangeNum = 0;
 	/** the data arrival pattern, in order of asc, desc or random. */
	protected int order;
	/** total number of tuples in stream. */
	protected int numValues;
	/**The random generator to generate new random numbers*/
	public static Random generator;
	/** generated attributed count */
	public int count = 0;
	/**
	 * TupleGenerator constructor comment.
	 */
	
	public AttributeGenerator() {
		if (this.rangeList == null)
			this.rangeList = new ArrayList();
		//this.rangeList.add(new Integer(0));
		//this.rangeList.add(new Integer(1000));
		//this.rangeIndex += 2;
		this.range = 1000;
		this.order = AttributeGenerator.ASC;
		this.numValues = 20000;
		generator = new Random();
		this.count = 0;
		this.nextRangeNum = numValues;
	}
	
	public AttributeGenerator(int range, int order, int numValues){
		if (range <= 0) {
			System.out.println("Wrong range!");
			//throw new WrongDataRangeException();
			return;
		}
		if (this.rangeList == null)
				this.rangeList = new ArrayList();
		//this.rangeList.add(new Integer(0));
		//this.rangeList.add(new Integer(range));
		//this.rangeIndex += 2;	
		this.range = range;
		this.order = order;
		this.numValues = numValues;
		generator = new Random(System.currentTimeMillis());
		this.count = 0;
		this.nextRangeNum = numValues;
	}

	/**
	 * Returns the new Random number with in a particular range
	 * @param range
	 * @return
	 */
	public static int nextInt(int range) {
		return(generator.nextInt(range));
	}

	/**
	 * Returns the next generated value
	 */
	public abstract Object getNextValue() throws StreamEmptyException;

	/**
	 * @return
	 */
	public String getAttributeName() {	
		return attributeName;
	}

	public int getRange() {
		return range;
	}
	//public int getCurrentRange() {
	//	return ((Integer)rangeList.get(this.rangeIndex - 1)).intValue();
	//}
	
	public int getOrder() {
		return order;
	}
	
	public int getNumValues() {
		return numValues;
	}
	
	/**
	 * @param string
	 */
	public void setAttributeName(String string) {
		attributeName = string;
	}

	public void setRange(int range) {
		this.range = range;
	}
	
	public void setNextRange(int startTupleNum, int range)
	{
		this.rangeList.add(new Integer(startTupleNum));
		this.rangeList.add(new Integer(range));
		this.nextRangeNum = ((Integer)(rangeList.get(0))).intValue();
	}
	
	public void setOrder(int order) {
		this.order = order;
	}
	
	public void setNumValues(int numValues) {
		this.numValues = numValues;
	}
}
