/*
 * Created on 2003-10-14
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;
import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.randomgenerators.PoissonRandomGenerator;
import java.util.Random;
import java.util.ArrayList;

/**
 * @author Luping Ding
 */
public class AuctionPunctAttributeGenerator
	extends ClusterAttributeGenerator {

	/** average number of distinct values within a punctuated segment. */
	int avgDistinctValues;
	/** random generator for number of distinct values within a punctuated segment. */
	PoissonRandomGenerator numDistinctValueRandom;
	/** random generator for choosing values within a punctuated segment. */
	Random valueRandom;
	/** the index inside segmentValues indicating the value to be returned. */
	int retValueIndex;
	/** stores the values generated for the current puncted segment. */
	ArrayList segmentValues;

	int numSegValues;
	
	int segValueCount;
	
	int currentValue;
	
	public AuctionPunctAttributeGenerator() {
		super();
		avgDistinctValues = 10;
		numDistinctValueRandom = new PoissonRandomGenerator(avgDistinctValues);
		valueRandom = new Random();
	}
	
	public AuctionPunctAttributeGenerator(int startValue, int range, int numValues,
		int avgDistinctValues, int granularity) {
		super(startValue, range, AttributeGenerator.ASC, numValues, granularity);
		this.avgDistinctValues = avgDistinctValues;
		numDistinctValueRandom = new PoissonRandomGenerator(avgDistinctValues);
		valueRandom = new Random();
	}
	
	public Object getNextValue() throws StreamEmptyException {
		if (numValueCount == numValues) {
			throw new StreamEmptyException();
		} 

		if (count == 0) {
			if (index == vals.length) {
				throw new StreamEmptyException();
			}

			currentValue = vals[index];

			while (count == 0) {
				count = (int)segmentSizeRandom.generateRandom();
			}
			if (count > numValues-numValueCount) {
				count = numValues - numValueCount;
			}
			
			int numDistinctValues = (int)numDistinctValueRandom.generateRandom();
			int[] distinctValues = new int[numDistinctValues];
			for (int i=0; i<numDistinctValues; i++) {
				if (index+i >= range) {
					int diff = index+i-range;
					distinctValues[i] = vals[range-1]+diff;
				} else {
					distinctValues[i] = vals[index+i];
				}
			}
			
			segmentValues = new ArrayList();
			numSegValues = 0;
			for (int i=0; i<count; i++) {
				int nextIndex = valueRandom.nextInt(numDistinctValues);
				if (nextIndex == 0) {
					numSegValues ++;
				}
				segmentValues.add(new Integer(distinctValues[nextIndex]));
			}
			segValueCount = numSegValues;
			index ++;
			retValueIndex = 0;
		}
		
		Integer retValue = (Integer)segmentValues.get(retValueIndex);
		retValueIndex ++;
		count --;
		numValueCount ++;
		if (retValue.intValue() == currentValue) {
			segValueCount --;
			if (segValueCount == 0) {
				return new String(retValue+"#");
			} else {
				return retValue;
			}
		} else {
			return retValue;
		}
	}
}
