/*
 * Created on 2003-10-14
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.randomgenerators.PoissonRandomGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * @author Luping Ding
 */
public class ClusterAttributeGenerator extends ControlledAttributeGenerator {
	/** average number of tuples within a punctuated segment. */
	protected int avgSegmentSize;
	/** random generator for segment size. */
	protected PoissonRandomGenerator segmentSizeRandom;
	/** the granularity of the punctuation. */
	protected int granularity;
	/** granularity count for the current range punctuation. */
	protected int granCount;
	/** lower bound of the current range punctuation. */
	protected int lowerBound;
	/** number of tuples to be generated for the current punctuated segment. */
	protected int count;
	
	protected int randomIndex;
	
	public ClusterAttributeGenerator() {
		super();
		avgSegmentSize = numValues/range;
		granularity = 1;
		segmentSizeRandom = new PoissonRandomGenerator(avgSegmentSize);
		lowerBound = 0;
		count = 0;
	}
	
	public ClusterAttributeGenerator(int startValue, int range, int order, int numValues, int granularity) {
		super(startValue, range, order, numValues);
		this.avgSegmentSize = numValues/range;
		this.granularity = granularity;
		segmentSizeRandom = new PoissonRandomGenerator(avgSegmentSize);
		lowerBound = 0;
		count = 0;
	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext.AttributeGenerator#getNextValue()
	 */
	public Object getNextValue() throws StreamEmptyException {
		int retValue = 0;
		//int randomIndex = 0;
		if (numValueCount == numValues) {
			throw new StreamEmptyException();
		} 
		
		if (count == 0) {
			if (index == range) {
				throw new StreamEmptyException();
			}
			while (count == 0) {
				count = (int)segmentSizeRandom.generateRandom();
			}
			if (count > (numValues - numValueCount)) {
				count = numValues - numValueCount;
			}
			
			if (order == AttributeGenerator.RANDOM) {
				randomIndex = AttributeGenerator.nextInt(range);
				while (flags[randomIndex]) {
					randomIndex = AttributeGenerator.nextInt(range);
				}
				flags[randomIndex] = true;
			}
		} 
			
		if (order == AttributeGenerator.ASC) {
			retValue = vals[index];			
		} else if (order == AttributeGenerator.DESC) {
			retValue = vals[range-index-1];
		} else {
			retValue = vals[randomIndex];
		}

		count --;
		numValueCount ++;

		if (count == 0) {
			index ++;
			//return new Integer(retValue);
			return new String(retValue + "#");
		} else {
			return new Integer(retValue);
		}
	}		
}
