package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * This class is the super class of all the punctuation
 * related data generators. 
 * @author Luping Ding
 */
public abstract class ControlledAttributeGenerator extends AttributeGenerator {
	/**Used to store the data values to be generated
	 * Note this is initialized and used only in the
	 * Controlled category */
	protected int[] vals;
	/**Stores the flags for each value in vals whether 
	 * it has been generated or not. */
	protected boolean[] flags;
	/**Stores the current index inside the vals array*/ 
	protected int index;
	
	protected int numValueCount;
	
	public ControlledAttributeGenerator() {
		super();
		vals = new int[range];
		flags = new boolean[range];
		for (int i = 0; i < range; i++) {
			vals[i] = i;
			flags[i] = false;
		}
		index = 0;
		numValueCount = 0;
	}
	
	public ControlledAttributeGenerator(int startValue, int range, int order, int numValues) {
		super(range, order, numValues);
		vals = new int[range];
		flags = new boolean[range];
		for (int i = 0; i < range; i++) {
			vals[i] = startValue+i;
			flags[i] = false;
		}
		index = 0;
		numValueCount = 0;
	}
	
	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext.AttributeGenerator#getNextValue()
	 */
	public abstract Object getNextValue() throws StreamEmptyException;
}
