package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import java.util.ArrayList;

/**
 * Stores the basic information corresponding to each elemet in the
 * config file.
 * @author Luping Ding
 *
 */
public class Element {
	/**Stores an array list that points to the children element*/
	protected ArrayList al = null;	
	
	protected Element parent = null;
	/**Stores the name of the element*/
	protected String name = null; 
	
	/**
	 * Constructs a new Element
	 * @param name
	 */
	public Element(String name,Element parent) {		
		this.name = name;		
		this.parent = parent;
	}
	
	/**
	 * Adds a child to the already existing list of children
	 * @param ch
	 */
	public void addChildElement(Element ch)
	{
		if(al == null)
		{
			al = new ArrayList();
		}
		al.add(ch);
	}
	
	/**
	 * Returns reference to the parent element of this element
	 * In case the element is itself the root.
	 * It returns the null
	 * @return Element
	 */
	public Element getParent()
	{
		return(parent);
	}
	/**
	 * Returns the name of the element
	 * @return
	 */
	public String getName() {
		return name;
	}

	public Object getElement(int index)
	{
		if (index < al.size())
			return al.get(index);
		else
			return null;
	}
}
