package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import java.io.IOException;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;



/**
 * This class is used to generate the data. 
 * This class has the main method and takes as 
 * input a data config file which gives the information
 * about the streams to be generated and the stream output
 * file name
 * @author Luping Ding
 */

public class GenerateData {

	/**
	 * @param args
	 */
	public static void main(String args[])
	{
		try {
			
			if(args.length != 1)
			{
				System.out.println("Usage: GenerateData fileName");
				System.exit(0);
			}
			
			DataConfigFileParser cfp = new DataConfigFileParser(args[0]);
			
			TupleGenerator[] tg = cfp.getTupleGenerators();
			/** Added by Yali Zhu
			 * updated the range arraylist based on config file
			 */
			cfp.setRangeList(tg);
			for(int i=0;i<tg.length;i++)
			{
				try {
					tg[i].writeTuples();
				} catch (StreamEmptyException e1) {				
					System.out.println("Compelted "+i+"th Stream");							
				}
			}			
			
		} catch (IOException e) {			
			e.printStackTrace();
		}	

	}
}
