package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * This class is to generate tuples occurring only once 
 * for each distinct value of the specified attribute. 
 * It is used to generate the data for the 
 * One side stream of a one-to-many join
 * Creation date: (11/21/2002 1:29:45 PM)
 * @author: Luping Ding
 */
public class RandomAttributeGenerator extends ControlledAttributeGenerator {

	/**
	 * Constructs a new Unique tuple Generator
	 */
	public RandomAttributeGenerator() {
		super();
	}
	
	public RandomAttributeGenerator(int startValue, int range, int numValues) {
		super(startValue, range, AttributeGenerator.ASC, numValues);
		/*
		if (range < numValues) {
			System.out.println("Wrong range!");
			return;
		}
		*/
	}

	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext.AttributeGenerator#getNextValue()
	 */
	public Object getNextValue() throws StreamEmptyException {
		int retValue = 0;		      		
		//if (index == vals.length) {
		if(numValueCount == numValues) {
			throw new StreamEmptyException();
		} else {
			int randomIndex = AttributeGenerator.nextInt(range);
			retValue = vals[randomIndex];
		}
		numValueCount ++;
		return(new Integer(retValue));
	}		
}
