package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * A class that generates data values uniformly over a particular range
 * @author Luping Ding
 */
public class RandomUniformAttributeGenerator extends AttributeGenerator {
	//int count;
	/**
	 * @param intRange
	 * @param i
	 */
	public RandomUniformAttributeGenerator(int range, int numValues) {
		super(range, AttributeGenerator.RANDOM, numValues);	
		count = 0;
	}

	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext.AttributeGenerator#getNextValue()
	 */
	public Object getNextValue() throws StreamEmptyException {
		if(count >= numValues)
		throw (new StreamEmptyException());
		
		/** modified by Yali Zhu
		 * change the current range based on tuple counts
		 */
		if(count >= this.nextRangeNum)
		{
			range = ((Integer)(rangeList.get(rangeIndex+1))).intValue();
			if(rangeList.size() <= (rangeIndex + 2))
			{
				nextRangeNum = this.numValues;
			}
			else
			{
				rangeIndex += 2;
				nextRangeNum = ((Integer)(rangeList.get(rangeIndex))).intValue();
			}
		}
		count = count + 1;			
		return(new Integer (AttributeGenerator.nextInt(range)));
	}

}
