package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * This class is to generate tuples occurring only once 
 * for each distinct value of the specified attribute. 
 * It is used to generate the data for the 
 * One side stream of a one-to-many join
 * Creation date: (11/21/2002 1:29:45 PM)
 * @author: Luping Ding
 */
public class UniqueAttributeGenerator extends ControlledAttributeGenerator {

	/**
	 * Constructs a new Unique tuple Generator
	 */
	public UniqueAttributeGenerator() {
		super();
	}
	
	public UniqueAttributeGenerator(int startValue, int range, int order, int numValues) {
		super(startValue, range, order, numValues);
		if (range < numValues) {
			System.out.println("Wrong range!");
			return;
		}
	}

	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext.AttributeGenerator#getNextValue()
	 */
	public Object getNextValue() throws StreamEmptyException {
		int retValue = 0;		      		
		//if (index == vals.length) {
		if(numValueCount == numValues) {
			throw new StreamEmptyException();
		} else {
			if (order == AttributeGenerator.ASC) {
				retValue = vals[index];			
			} else if (order == AttributeGenerator.DESC) {
				retValue = vals[range-index-1];
			} else {
				int randomIndex = AttributeGenerator.nextInt(range);
				while (flags[randomIndex]) {
					randomIndex = AttributeGenerator.nextInt(range);
				}
				flags[randomIndex] = true;
				retValue = vals[randomIndex];
			}
			index ++;
		}
		numValueCount ++;
		return(new Integer(retValue));
	}		
}
