package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.randomgenerators;

/**
 * Insert the type's description here.
 * Creation date: (2/7/2003 4:14:48 PM)
 * @author: Yali Zhu
 */
public class GaussianRandomGenerator extends RandomGenerator {
	private int iset=0;
    private double gset;
/**
 * Insert the method's description here.
 * Creation date: (5/7/2003 4:55:06 AM)
 * @param newSeed long
 */
public GaussianRandomGenerator(long newSeed) {
    seed = newSeed;
}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2003 10:09:10 PM)
 * @return double
 */
public double gaussianRand() {

   
   double fac,rsq,v1,v2;

   uniformRand();

   if (seed < 0) iset=0;        /* Reinitialize. */
   if (iset == 0)                /* We don't have an extra deviate handy, so */
   {
      do
      {
         v1 = 2.0*uniformRand()-1.0;  /* pick two uniform numbers in the square ex- */
         v2 = 2.0*uniformRand()-1.0;  /* tending from -1 to +1 in each direction, */
         rsq = v1*v1 + v2*v2;                 /* see if they are in the unit circle, */

      } while (rsq >= 1.0 || rsq == 0.0); /* and if they are not, try again.*/

      fac = Math.sqrt((double)(-2.0 * Math.log((double)rsq)/rsq));

	/* Now make the Box-Muller transformation to get two normal deviates. Return one and */
	/* save the other for next time. */

      gset = v1*fac;
      iset = 1;                   /* Set ag. */
      return v2*fac;
   }
   else                        /* We have an extra deviate handy, */
   {
      iset=0;                  /* so unset the ag, */
      return gset;             /* and return it.*/
   }
}
/**
 * Insert the method's description here.
 * Creation date: (2/7/2003 4:14:48 PM)
 */
public double generateRandom() {
    return gaussianRand();
}
}
