package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.xml;

/**
 * Insert the type's description here.
 * Creation date: (3/26/2003 2:27:58 PM)
 * @author: Hong Su
 */
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class CharSenders extends Thread {

    public final static int PORT = 12260;

    protected java.lang.StringBuffer[] charBuffers;
    //100M file	
    public final static int CAPACITY = 100000000;
    protected BufferedReader[] fileReaders;
    protected java.lang.String[] remainingLines = null;
    protected boolean[] refills;
    protected int[] fillingCounts;
    //number of input stream sources
    protected int srcNum;
    protected ServerSocket[] sockets;

/**
 * DataSender constructor comment.
 */
public CharSenders(String[] fileNames) {

    super();

    srcNum = fileNames.length;

    charBuffers = new StringBuffer[srcNum];
    fileReaders = new BufferedReader[srcNum];
    fillingCounts = new int[srcNum];
    refills = new boolean[srcNum];
    remainingLines = new String[srcNum];

    for (int i = 0; i < srcNum; i++) {

        charBuffers[i] = new StringBuffer(CAPACITY);

        try {

            fileReaders[i] = new BufferedReader(new FileReader(fileNames[i]));
            System.out.println("open once");
           
        } catch (IOException e) {
            e.printStackTrace();
        }

        fillingCounts[i] = 1;

        refills[i] = true;


        //read file into the buffer for the first time
        fillMemories();

    }

}
/**
 * Insert the method's description here.
 * Creation date: (3/26/2003 10:59:20 PM)
 */
public void fillMemories() {
    for (int i = 0; i < srcNum; i++) {
        try {
            String line = null;
            while ((line = fileReaders[i].readLine()) != null) {

                if (charBuffers[i].length() + line.length() <= CAPACITY) {
                    charBuffers[i].append(line);
                    if (charBuffers[i].length() == CAPACITY){
	                    System.out.println("capacity filled, file not finished yet");
                        break;
                    }
                    //dataBuffer.append("\n");
                } else {
                    int cutPos = CAPACITY - charBuffers[i].length();
                    charBuffers[i].append(line.substring(0, cutPos));
                    remainingLines[i] = line.substring(cutPos, line.length());
                    //     System.out.println(dataBuffer.toString());
                    // System.out.println("remainingLine:" + remainingLine);
                    System.out.println("capacity filled, file not finished yet");
                    break;
                }

            }

            if (line == null) {
                //finished during the first load
                refills[i] = false;
            } else
                refills[i] = true;

            // System.out.println(dataBuffer.length());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 3:35:45 PM)
 * @return java.lang.StringBuffer[]
 */
public java.lang.StringBuffer[] getCharBuffers() {
	return charBuffers;
}
/**
 * Insert the method's description here.
 * Creation date: (5/29/2003 1:20:56 PM)
 * @param p java.io.ObjectInputStream
 * @param capacity int
 * @param tokenQueue edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.XATTokenQueue
 */
static public void loadFrFileToQueue() {

   /* try {
        XMLToken token = null;

        FileInputStream fis = new FileInputStream(tokenFileName);
        BufferedInputStream bis = new BufferedInputStream(fis);

        ObjectInputStream ois = new ObjectInputStream(bis);

        while (true) {
            try {
                token = (XMLToken) p.readObject();
            } catch (EOFException e) {
                //there is no more content,
                break;
            }

            tokenQueue.enqueue(token);

        }

        //indicate successfully filling the token queue

    } catch (Exception e) {
        e.printStackTrace();
        System.exit(-1);

    }*/
}
/**
 * Insert the method's description here.
 * Creation date: (3/26/2003 2:39:10 PM)
 */
public static void main(String[] args) throws Exception {
    if (args.length<2){
    	System.out.println("usuage:");
    	System.out.println("CharSenders -fileName -repeatingTimes");
    	System.out.println("fileName: the token file to be sent");
    	System.out.println("repeatingTime: send the token file how many times");
    	return;
    }

    String tokenFileName = args[0];

    int repeatingTimes = Integer.parseInt(args[1]);

    ServerSocket serverSocket = null;
    Socket socket = null;

    FileInputStream fis = null;
    BufferedInputStream bis = null;
    ObjectInputStream ois = null;

    BufferedOutputStream bos = null;
    ObjectOutputStream oos = null;

    try {
        serverSocket = new ServerSocket(PORT);
    } catch (Exception e) {
        serverSocket.close();
        e.printStackTrace();
        System.exit(-1);
    }

    for (int i = 0; i < repeatingTimes; i++) {
        //set up the sockets

        try {

            socket = serverSocket.accept();

            socket.setTcpNoDelay(true);

            //socket.setSendBufferSize(200000000);

            System.out.println("connection accepted:" + socket);

        } catch (Exception e1) {
            System.out.println("set up error.");
            socket.close();
            e1.printStackTrace();
        }

        try {
            fis = new FileInputStream(tokenFileName);
            bis = new BufferedInputStream(fis);
            ois = new ObjectInputStream(bis);

            bos = new BufferedOutputStream(socket.getOutputStream());
            oos = new ObjectOutputStream(bos);

            XMLToken token = new XMLToken();

            System.out.println("reading now");

            int count = 0, flushCount = 0;

            while (true) {

                try {
                    //token = (XMLToken) ois.readObject();
                    token.readExternal(ois);
                } catch (Exception e) {
                    //there is no more content, flush the buffer
                    oos.flush();
                    System.out.println("eof now");
                    e.printStackTrace();
                    break;
                }

                count++;

                flushCount++;

                //oos.writeObject(token);
                token.writeExternal(oos);

                //at least 0.2M
                if (flushCount == 1000) {
                    //  System.out.println("sending " + count);
                    flushCount = 0;
                    oos.flush();

                    if (count % 1000000 == 0) {
                        // rebuild every 2M tokens                               
                        oos = new ObjectOutputStream(bos);
                    }

                    /*Runtime runtime = Runtime.getRuntime();
                    //free memory less than 10M
                    // if (runtime.freeMemory() < 10000000)
                    //    sleep(1000);
                    // }
                    
                     if (count>2000000)
                     sleep(500);
                    else
                     if (count > 5000000)
                      sleep(1000);
                      else
                      sleep(100);*/
                }

            } //end of while

        } catch (Exception e1) {
            // any exception, close corresponding socket throwing such exceptions
            e1.printStackTrace();
            System.out.println("senders error");
        } finally {
            System.out.println("closing all input streams and output streams");
            if (ois != null)
                ois.close();
            if (bis != null)
                bis.close();
            if (fis != null)
                fis.close();
            if (oos != null)
                oos.close();
            if (bos != null)
                bos.close();

            socket.close();

        }
    }

    serverSocket.close();

}
/**
 * Insert the method's description here.
 * Creation date: (3/26/2003 2:39:10 PM)
 */
public static void mainbak(String[] args) {

    String tokenFileName = args[0];

    ServerSocket serverSocket = null;
    Socket socket = null;
    //PrintWriter out = null;

    ObjectOutputStream out = null;

    //set up the sockets
    try {
        serverSocket = new ServerSocket(PORT);

        try {
            
	        
            socket = serverSocket.accept();

            socket.setTcpNoDelay(true);

            

            //socket.setSendBufferSize(200000000);

            System.out.println("connection accepted:" + socket);

            //out = new PrintWriter(
            //        new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())),
            //        true);

            //80M
           // out =
           //     new ObjectOutputStream(new BufferedOutputStream(socket.getOutputStream()));
           out = new ObjectOutputStream(socket.getOutputStream());

        } catch (Exception e1) {
	        System.out.println("set up error.");
            socket.close();
            e1.printStackTrace();
        }
    } catch (Exception e2) {
        try {
            serverSocket.close();
            e2.printStackTrace();
        } catch (Exception e3) {
            e3.printStackTrace();
        }
    }

    FileInputStream fis = null;
    BufferedInputStream bis = null;
    ObjectInputStream ois = null;

    try {
        fis = new FileInputStream(tokenFileName);
        bis = new BufferedInputStream(fis);

        ois = new ObjectInputStream(bis);

        XMLToken token = null;

        System.out.println("reading now");

        int count = 0;

        int flushCount = 0;

        while (true) {

            try {
                token = (XMLToken) ois.readObject();
            } catch (Exception e) {
                //there is no more content, should not be here anyway, break when EOF is seen
                out.flush();
                System.out.println("eof now");
                e.printStackTrace();
                break;
            }

            if (token.getType() == XMLToken.EOF)
                System.out.println("eof encountered");

            count++;

            flushCount ++;

            
            out.writeObject(token);

            out.flush();

          //  System.out.println("after write");

          //at least 0.2M
          if (flushCount == 1000){
             System.out.println("sending " + count);
             flushCount = 0;
             out.flush();
            /* if (count>2000000)
             sleep(500);
            else
             if (count > 5000000)
              sleep(1000);
              else
              sleep(100);*/
            }

           // out.flush();

           

          //  System.out.println("after flush");
        }//end of while

      //  System.out.println("break from while");

    } catch (Exception e1) {
        // any exception, close corresponding socket throwing such exceptions
        e1.printStackTrace();
        System.out.println("senders error");
    } finally {
        try {
	        System.out.println("closing socket...");
            socket.close();
            serverSocket.close();
            if (ois != null)
                fis.close();
            if (bis != null)
                bis.close();
            if (fis != null)
                fis.close();
        } catch (Exception e2) {
            e2.printStackTrace();
        } finally {
            System.exit(-1);
        }
    }

}
/**
 * refills the ithe memory
 * Creation date: (3/27/2003 11:24:06 AM)
 */
public void refillMemory(int i) {

    //whether after this round of filling, there is still data in the file
    refills[i] = false;

    try {
        String line = new String();

        if (!(remainingLines[i].length() == 0))
            //there is remainingLine needs to be put into the buffer
            {
            line = remainingLines[i];
            remainingLines[i] = new String();
        } else
            line = fileReaders[i].readLine();

        int loadPos = 0;

        if (line == null) {
            //nothing to fill anymore, neither filling line nor new lines from the file
            //delete all existing
            charBuffers[i].delete(0, charBuffers[i].length());
            return;
        }

        fillingCounts[i]++;

        while (!(line == null)) {
            //there is yet something

            if (loadPos + line.length() <= CAPACITY) {
                //the current line can fit in
                charBuffers[i].replace(loadPos, loadPos + line.length(), line);
                loadPos = loadPos + line.length();
                if (loadPos == CAPACITY) {
                    refills[i] = true;
                    break;
                } else {
                    line = fileReaders[i].readLine();
                    if (line == null) {
                        //finished
                        System.out.println("finished....");
                        charBuffers[i].delete(loadPos, CAPACITY);
                    }
                }
            } else {
                //only fills what can fit
                charBuffers[i].replace(
                    loadPos,
                    CAPACITY,
                    line.substring(0, CAPACITY - loadPos));
                //System.out.println("replace:"+dataBuffer.length()); 
                remainingLines[i] = line.substring(CAPACITY - loadPos, line.length());
                //System.out.println("during refill, remainingLine: " + remainingLine);
                //do not fill anymore
                refills[i] = true;
                break;
            }

        } //end of while

    } //end of try

    catch (Exception e) {
        e.printStackTrace();
    }

}
/**
 * Insert the method's description here.
 * Creation date: (3/26/2003 2:39:10 PM)
 */
public void run() {

   /* ServerSocket serverSocket = null;
    Socket socket = null;
    PrintWriter out = null;

    //set up the sockets
    try {
        serverSocket = new ServerSocket(PORT);

        try {
            socket = serverSocket.accept();

            System.out.println("connection accepted:" + socket);

            out = new PrintWriter(
                    new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())),
                    true);

        } catch (Exception e) {
            socket.close();
            e.printStackTrace();           
        }
    } catch (Exception e1) {
        try {
            serverSocket.close();
            e1.printStackTrace();
        } catch (Exception e2) {
            e2.printStackTrace();
        }
    }

    try {
        FileInputStream fis = new FileInputStream(tokenFileName);
        BufferedInputStream bis = new BufferedInputStream(fis);

        ObjectInputStream ois = new ObjectInputStream(bis);

        XMLToken token = null;

        while (true) {

            try {
                token = (XMLToken) ois.readObject();
            } catch (EOFException e) {
                //there is no more content, should not be here anyway, break when EOF is seen
                break;
            }

            out.print(token);

            out.flush();
        }

    } catch (Exception e1) {
        // any exception, close corresponding socket throwing such exceptions
        e1.printStackTrace();
        System.out.println("senders error");
    }finally{
        try {
            socket.close();
            serverSocket.close();
        } catch (Exception e2) {
            e2.printStackTrace();
        } finally {
            System.exit(-1);
        }
    }*/

}
}
