package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration;

import java.io.Serializable;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
import java.net.*;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 10, 2004
 * 
 * Represents an Application that is listening for the output of the
 * query plan.
 * 
 */
public class Application extends XATPropertiesImp implements Serializable {

	/**
	 * 
	 */
	public Application() {
		setDefaultProperties();
	}
	public String getIPAddress() {
		return this.getProperty("HOST_ADDRESS");
	}

	public String getMachineName() {
		return this.getProperty("NAME");
	}
	public int getPort() {
		return Integer.parseInt(this.getProperty("PORT"));
	}

	public void setApplicationName(String name) {
		try {
			this.setProperty("NAME", name);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp#setDefaultProperties()
	 */
	protected void setDefaultProperties() {

		super.setDefaultProperties();
		addProperty("NAME", "localhost");
		addProperty("HOST_ADDRESS", "127.0.0.1");
		addProperty("PORT", "16001");
		addProperty("CONNECTS_TO", "1");
	}

	public void setIPAddress(String address) {
		try {
			InetAddress[] ia = InetAddress.getAllByName(address);
			String r = ia[0].getHostAddress().toString();
			this.setProperty("HOST_ADDRESS", r);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void setPort(int port) {
		try {
			this.setProperty("PORT", Integer.toString(port));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public String toString(){
		return "Application: " + this.getProperty("HOST_ADDRESS") + ":" + this.getProperty("PORT") + " to Query Plan " + this.getProperty("CONNECTS_TO");
	}

}
