/*
 * Created on Oct 23, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.*;
import java.util.*;
import java.io.*;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Oct 23, 2003
 * 
 * Insert comments here.
 */
public class DistributionConfiguration extends XATPropertiesImp implements Serializable {
	ArrayList everyTimeOperator;
	ArrayList machines;
	String managerIPaddress;
	ArrayList periodicOperator;
	ArrayList everyTimeSystem;
	
	ArrayList periodicTree;
	ArrayList printerColumnNames;
	ArrayList printerOutputFormat;
	ArrayList queryPlans;
	ArrayList servers;
	ArrayList streams;
	ArrayList applications;
	
	/**
	 * 
	 */
	public DistributionConfiguration() {
		super();
		machines = new ArrayList();
		queryPlans = new ArrayList();
		streams = new ArrayList();
		servers = new ArrayList();
		periodicTree = new ArrayList();
		everyTimeOperator = new ArrayList();
		periodicOperator = new ArrayList();
		printerOutputFormat = new ArrayList();
		printerColumnNames = new ArrayList();
		applications = new ArrayList();
		everyTimeSystem = new ArrayList();
		setDefaultProperties();
	}
	
	public void addMachine(Machine m){
		machines.add(m);
	}
	
	public void addQueryPlan(QueryPlan qp){
		queryPlans.add(qp);
	}
	public void addServer(Server s){
		servers.add(s);
	}
	public void addStream(Stream s){
		streams.add(s);
	}
	public void addApplication(Application a){
		applications.add(a);
	}
	
	/**
	 * @return
	 */
	public Iterator getEveryTimeOperator() {
		return everyTimeOperator.iterator();
	}
	
	public Iterator getEveryTimeSystem() {
		return everyTimeSystem.iterator();
	}
	
	public Machine getMachine(String machineName){
		
		for(Iterator i = machines.iterator(); i.hasNext();){
			Machine m = (Machine) i.next();
			
			if(m.getMachineName().equals(machineName))
				return m;
		}
		
		return null;
	}
	public Machine getMachine(String ipAddress, int port){
		
		for(Iterator i = machines.iterator(); i.hasNext();){
			Machine m = (Machine) i.next();
			
			if(m.getIPAddress().equals(ipAddress) &&
			   m.getPort() == port)
				return m;
		}
		
		return null;
	}
	public Iterator getMachines(){
		return machines.iterator();
	}
	
	public Machine[] getMachineArray(){
		Machine[] m = new Machine[this.machines.size()];
		
		Iterator i = this.getMachines();
		int j = 0;
		
		while(i.hasNext()){
			m[j] = (Machine) i.next();
			j++;	
		}
		
		return m;
	}
	
	public Iterator getApplications(){
		return applications.iterator();
	}
	
	public Application[] getApplicationArray(){
		Application[] a = new Application[this.applications.size()];
		
		Iterator i = this.getApplications();
		int j = 0;
		
		while(i.hasNext()){
			a[j] = (Application) i.next();
			j++;	
		}
		
		return a;
	}
	
	public String getManagerIPAddress(){
		return this.managerIPaddress;
	}

	/**
	 * @return
	 */
	public Iterator getPeriodicOperator() {
		return periodicOperator.iterator();
	}

	/**
	 * @return
	 */
	public Iterator getPeriodicTree() {
		return periodicTree.iterator();
	}

	/**
	 * @return
	 */
	public Iterator getPrinterColumnNames() {
		return printerColumnNames.iterator();
	}

	/**
	 * @return
	 */
	public Iterator getPrinterOutputFormat() {
		return printerOutputFormat.iterator();
	}
	
	public Iterator getQueryPlans(){
		return queryPlans.iterator();
	}
	
	public QueryPlan[] getQueryPlanArray(){
		QueryPlan[] qp = new QueryPlan[this.queryPlans.size()];
		
		Iterator i = this.getQueryPlans();
		int j = 0;
		
		while(i.hasNext()){
			qp[j] = (QueryPlan) i.next();
			j++;	
		}
		
		return qp;
	}
	
	public Iterator getServers(){
		return servers.iterator();
	}
	public Stream getStream(String streamName){
		
		for(Iterator i = streams.iterator(); i.hasNext();){
			Stream s = (Stream) i.next();
			
			if(s.getName().equals(streamName))
				return s;
		}
		
		return null;
	}
	
	public Iterator getStreams(){
		return streams.iterator();
	}
	
	public Stream[] getStreamArray(){
		Stream[] s = new Stream[this.streams.size()];
		
		Iterator i = this.getStreams();
		int j = 0;
		
		while(i.hasNext()){
			s[j] = (Stream) i.next();
			j++;	
		}
		return s;
	}
	
	public int machineCount(){
		return machines.size();
	}
	public void removeMachine(String ipAddress, int port){
		
		for(int i=0 ; i < machines.size(); i++){
			Machine m = (Machine) machines.get(i);
			
			if(m.getIPAddress().equals(ipAddress) && m.getPort() == port)
				machines.remove(i);
		}
	}
	
	/**
	* called by the constructor.  this will set the default properties
	* that the ALL query objects will support. Each subclass should override
	* this method and add their own unique properties, but should also call
	* super.setDefaultProperties() so that the common properties may be set.
	*/   
	protected void setDefaultProperties(){
		super.setDefaultProperties();
		addProperty("QueueManager", "on");
		addProperty("StatisticsGatherer","on");
		addProperty("AVERAGE_WEIGHT","1");
		addProperty("PRINT_OUT_META_INFORMATION", "1");
		addProperty("STREAM_CONFIG_FILE_NAME", "none");
		addProperty("EXECUTION_DURATION","60000");	
		addProperty("DISTRIBUTION_PATTERN","edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern.NoDistribution");
		addProperty("WORKLOAD_COST_MODEL","1");	
		addProperty("STREAM_DURATION","60000");	
		addProperty("DISTRIBUTION_DELAY","10000");	
		addProperty("REDISTRIBUTION_POLICY","1");
		addProperty("REDISBRIBUTION_TIME","10000");
		addProperty("STATE_SIZE_THRESHOLD","-1");
		addProperty("REDISTRIBUTION_PERCENT","50");
		addProperty("REDISTRIBUTION_SCOPE", "global");
		addProperty("MAX_QUEUE_SIZE", "500");
		addProperty("EXECUTION_CONTROLLER", "edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.DistributedExecutionController");
		addProperty("DATA_MODEL","edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATMemoryQueueImp");
		//addProperty("MIGRATION_STRATEGY", "off");
		//addProperty("MIGRATION_INTERVAL", "5000");
	}
	
	public void setEveryTimeOperator(Iterator eto){
		
		for(Iterator i = eto; i.hasNext();){
			NameValuePair pair = (NameValuePair) i.next();
			everyTimeOperator.add(pair);
		}
	}
	
	public void setEveryTimeSystem(Iterator ets){
		
		for(Iterator i = ets; i.hasNext();){
			NameValuePair pair = (NameValuePair) i.next();
			everyTimeSystem.add(pair);
		}
	}
	
	public void setManagerIPAddress(String ipAddress){
		this.managerIPaddress = ipAddress;
	}

	public void setPeriodicOperator(Iterator po){
		
		for(Iterator i = po; i.hasNext();){
			NameValuePair pair = (NameValuePair) i.next();
			periodicOperator.add(pair);
		}
	}
	
	public void setPeriodicTree(Iterator pt){
		for(Iterator i = pt; i.hasNext();){
			NameValuePair pair = (NameValuePair) i.next();
			periodicTree.add(pair);
		}
	}
	
	public void setPrinterColumnNames(Iterator pcn){
		for(Iterator i = pcn; i.hasNext();){
			NameValuePair pair = (NameValuePair) i.next();
			printerColumnNames.add(pair);
		}
	}
	
	public void setPrinterOutputFormat(Iterator pof){
		
		for(Iterator i = pof; i.hasNext();){
			NameValuePair pair = (NameValuePair) i.next();
			printerOutputFormat.add(pair);
		}
	}
	
	public String toString(){
		
		String ret = new String();
		Enumeration e = getProperties();
		
		// First put system properties
		ret += "System Properties: \n";
		ret += "------------------ \n";
		while(e.hasMoreElements()){
			String name = (String) e.nextElement();
			String property = getProperty(name);
			ret += name + " , " + property + "\n";
		}
		
		ret += "\nMachines: \n";
		ret += "--------- \n";
	
		for(Iterator i = machines.iterator();i.hasNext();){
			Machine m = (Machine) i.next();
			ret += m.toString();	
		}
		
		ret += "\nQuery Plans: \n";
		ret += "-------------- \n";
	
		for(Iterator i = queryPlans.iterator();i.hasNext();){
			QueryPlan qp = (QueryPlan) i.next();
			ret += qp.toString();	
		}
		ret += "\n";
		
		ret += "\nApplications: \n";
		ret += "-------------- \n";
	
		for(Iterator i = applications.iterator();i.hasNext();){
			Application a = (Application) i.next();
			ret += a.toString();	
		}
		ret += "\n";
		
		ret += "\nStreams: \n";
		ret += "-------------- \n";
	
		for(Iterator i = streams.iterator();i.hasNext();){
			Stream s = (Stream) i.next();
			ret += s.toString();	
		}
		ret += "\n";
		
		ret += "\nServers: \n";
		ret += "-------------- \n";
	
		for(Iterator i = servers.iterator();i.hasNext();){
			Server s = (Server) i.next();
			ret += s.toString();	
		}
		ret += "\n";
		
		return ret;	
	}

}
