package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection;

import java.io.ObjectOutputStream;
import java.net.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.Packet;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 30, 2004
 * 
 * This class will give repeated connection requests to the Client to which it is connected.
 * This class will server to be a test for how many connection requests a client can handle
 * without significantly reducing the performance of the system.
 * 
 */
public class ConnectionTester {

	private static String USAGE = "Usage: java ConnectionTester <ip address> <port> <messages per second>";
	
	public static void main(String[] args) {
		try {
			if(args.length != 3){
				System.out.println(USAGE);
				return;
				
			}	
			
			String ipAddress = args[0];
			int port = Integer.parseInt(args[1]);
			int messagesPerSecond = Integer.parseInt(args[2]);
			System.out.println("Connecting to: " + ipAddress + ":" + port);
			System.out.println("Sending " + messagesPerSecond + " messages per second.");
			Socket s = new Socket(ipAddress, port);
			ObjectOutputStream out = new ObjectOutputStream(s.getOutputStream());
			while(true){
				
				for(int i = 0; i < messagesPerSecond; i++){
					Connection c = new Activate("1");
					Packet p = new Packet("tester",c);
					out.writeObject(p);
				}
				
				Thread.sleep(1000);
				
				
			}
			
		} catch (NumberFormatException e) {
			System.out.println(USAGE);
			System.exit(1);
		} catch (UnknownHostException uhe){
			System.out.println(uhe.getMessage());
		} catch (Exception e){
			e.printStackTrace();
		}
		
		
			
	}
}
