package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection;

import java.io.Serializable;
import java.util.*;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 16, 2004
 * 
 * Insert comments here.
 */
public class LightWeightStats implements Connection, Serializable {

	private ArrayList stats;
	
	public LightWeightStats() {
		this.stats = new ArrayList();
	}
	
	/**
	 * Default Constructor.
	 */
	public LightWeightStats(ArrayList stats) {
		this.stats = stats;
	}
	
	/**
	 * 
	 * Default Constructor.
	 */
	public LightWeightStats(String[] stats) {
		this.stats = new ArrayList();
		for(int i=0; i< stats.length ; i++){
			this.stats.add(stats[i]);
		}
	}

	public ArrayList getStats(){
		return this.stats;
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getClassName()
	 */
	public String getClassName() {
		return this.getClass().getName();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromIPAddress()
	 */
	public String getFromIPAddress() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromOperator()
	 */
	public String getFromOperator() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromPort()
	 */
	public int getFromPort() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromQueueNumber()
	 */
	public int getFromQueueNumber() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getStreamLength()
	 */
	public int getStreamLength() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getStreamName()
	 */
	public String getStreamName() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToIPAddress()
	 */
	public String getToIPAddress() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToOperator()
	 */
	public String getToOperator() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToPort()
	 */
	public int getToPort() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToQueueNumber()
	 */
	public int getToQueueNumber() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	public String toString(){
		return "Lightweight Stat: " + stats;
	}
}
