package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection;


import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;


/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 11, 2004
 * 
 * This class reperesents the operator and queue number for which a Connection will be made.
 */
public class OperatorQueue {

	private XATStreamOperator operator;
	private int queueNum;

	/**
	 * 
	 */
	public OperatorQueue(XATStreamOperator operator, int queueNum) {
			this.operator = operator;
			this.queueNum = queueNum;
	}
	
	

	/**
	 * @return
	 */
	public XATStreamOperator getOperator() {
		return operator;
	}

	/**
	 * @return
	 */
	public int getQueueNum() {
		return queueNum;
	}

	public String toString(){
		return operator.toShortString() + ":" + queueNum;
	}
}
