package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.costmodel;

import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.*;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 16, 2004
 * 
 * Represents a table for Lightweight statistics
 * 
 * Key: Machine
 * Value: LightWeightStatistics for the machine
 * 
 */
public class StatisticsTable {

	private Hashtable table;
	
	/**
	 *  Constructs a new Cost table
	 */
	public StatisticsTable(Machine[] m) {
		table = new Hashtable(m.length);
		
		for(int i = 0; i < m.length; i++){
			table.put(m[i],new LightWeightStatistic());
		}
	}
	
	public synchronized void put(Machine m, LightWeightStatistic lws){
		table.put(m,lws);
	}
	
	public synchronized LightWeightStatistic get(Machine m){
		return (LightWeightStatistic) table.get(m);
	}
	
	public String toString(){
		String ret = new String();
		ret+= "\n           Statistic Table            \n";
		ret+= "--------------------------------------\n";
		for(Enumeration e = table.keys(); e.hasMoreElements();){
			
			Machine m = (Machine) e.nextElement();
			LightWeightStatistic l = (LightWeightStatistic) table.get(m);
			ret += m.getMachineName() + " | " + l.toString() +"\n";
			
		}
		return ret;
	}
	
	public int size(){
		return table.size();
	}
	
	public Enumeration keys(){
		return this.table.keys();
	}
}
