package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet;
import java.io.Serializable;
/**
 * @author 
 * This class encapsulates the stream name and the 
 * tuple the stream name is used as the identifier
 */
public class Packet implements Serializable{
	/**Stores the reference to the control message*/
	private String controlMessage = null;

	/**Stores the reference to the stream name*/	
	private String identifier = null;
	/**Stores the reference to the tuple*/
	private Object o = null;
	public Packet(String controlMessage)
	{
		if(controlMessage == null)
		 throw new IllegalArgumentException();
		 
		this.controlMessage = controlMessage;
	}
	
	/**
	 * Constructs a new Packet
	 */
	public Packet(String identifier,Object o)
	{		
		if(identifier == null || o == null)
		 	throw new IllegalArgumentException();
		this.identifier = identifier;
		this.o = o;
	}
	
	public Packet(String identifier,Object o,String message)
	{
		if( identifier == null)
			throw new IllegalArgumentException("PACKET: The identifier is null.");
		if(o == null)
			throw new IllegalArgumentException("PACKET: The object is null.");
		if(message == null)
			throw new IllegalArgumentException("PACKET: The message is null.");
			
			this.identifier = identifier;
			this.o = o;
			this.controlMessage = message;
	}
	
	public Packet(String name,String message)
	{
		this.identifier = name;
		this.controlMessage = message;
	}
	/**
	 * Gets the control message.
	 * 
	 * @return The control message
	 */
	public String getControlMessage() {
		return controlMessage;
	}
	
	/**
	 * Gets the packet identifier.
	 * 
	 * @return The packet identifeir
	 */
	public String getIdentifier()
	{
		return(this.identifier);
	}

	public void setIdentifier(String id){
		this.identifier = id;
	}
	/**
	 * 
	 * Gets the object from the packet.
	 * 
	 * @return
	 */
	public Object getObject()
	{
		return(o);
	}
	
	/**
	 * Returns the Packet as a string.
	 */
	public String toString(){
		String ret = new String();
		ret += this.getObject().toString();
		
		return ret;
	}

}
