package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet;

import java.util.ArrayList;

/**
 * @author
 * 
 * This class holds the packets that are receieved but not yet enqueued
 */

public class PacketPool {
	/**Stores the reference to the array list storing the packets*/
	ArrayList packets = null;
	
	/**
	 * Constructs a packet pool
	 */
	public PacketPool() {
		this.packets = new ArrayList();		
	}
	
	/**
	 * Adds the packet to the packet pool
	 * @param p
	 */
	public synchronized void addPacket(Packet p)
	{
		packets.add(p);
		if(packets.size() == 1)
			notify();
	}
	
	/**
	 * Removes the 1st packet from the packet pool and returns it
	 * @return Packet
	 * @throws InterruptedException
	 */
	public synchronized Packet removePacket() throws InterruptedException
	{
		if(packets.size() == 0)
		{
			wait();
		}
		return((Packet)packets.remove(0));
	}
	
	public synchronized int size(){
		return packets.size();
	}
}
