package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.*;
import java.io.FileWriter;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Dec 15, 2003
 * 
 * The packet feeder takes tuples from the packet pool and places them
 * at the input queues of the operator that is to process it.
 * 
 */
public class TupleFeeder implements Runnable {

	private PacketPool pool;
	private ConnectionTable table;
	private boolean enable;
	
	/**
	 * @param port
	 * @param receivePool
	 * @param tree
	 * @throws IOException
	 */
	public TupleFeeder(PacketPool receivePool, ConnectionTable ct){
		this.pool = receivePool;
		this.table = ct;	
		this.enable = true;	
	}
	
	public synchronized void run(){
		
		XATStreamOperator op;
		String from;
		//File f;
		//FileWriter outWriter = null;
		
		try{
		
		//f = new File("fed_into_input_queues.txt");
		//outWriter = new FileWriter(f);
		//outWriter.write("start it up...\n");
		}catch (Exception e){}
		
		while(enable){
			Packet p = null;
			OperatorQueue oq;
			try{
				//while(pool.size() < 200)
				//	this.wait();
				
				// get the packet
				p = pool.removePacket();
				//outWriter.write(p+"\n");
				// find out where this packet needs to go.
				from = p.getIdentifier();

				// Op will be the operator to which this tuple should go.
				oq = table.getConnection(from);
				op = oq.getOperator();				
				
				if(op != null){
				
					if((p.getObject() instanceof XATQueueSchema)){				
						op.getInputQueue(oq.getQueueNum()).setSchema((XATQueueSchema)p.getObject());
					}
					else{
						//	Add the tuple to the input queue
						// Make sure to add it to the right queue!!!
						try {
							FileWriter out = new FileWriter("tuples.txt", true);
							out.write("Putting tuple \n    " + ((XATTuple)p.getObject()).toString() + "\nin queue \n    " + op.getInputQueue(oq.getQueueNum()) + "\n");
							out.close();
						} catch (Exception ex) {
							ex.printStackTrace();
						}
						
						op.getInputQueue(oq.getQueueNum()).enqueue((XATTuple) p.getObject(), null);
					}
				}
			} catch(NullPointerException npe){
				System.out.println(npe.getMessage());
				npe.printStackTrace();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
		
		return;
	}
	
	public void requestStop(){
		this.enable = false;
	}
	
}
