package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet;

import java.io.File;
import java.io.FileWriter;
import java.io.ObjectOutputStream;
import java.net.Socket;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.*;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Dec 15, 2003
 * 
 * The packet sender takes tuples from the packet pool and sends them to other
 * machines in the network.
 * 
 */
public class TupleSender implements Runnable {

	private PacketPool pool;
	private ConnectionTable table;
	private boolean enable;
	
	/**
	 * @param port
	 * @param receivePool
	 * @param tree
	 * @throws IOException
	 */
	public TupleSender(PacketPool sendPool, ConnectionTable ct){
		this.pool = sendPool;
		this.table = ct;	
		this.enable = true;	
	}
	
	public void run(){
		
		XATStreamOperator op;
		Socket sendTo;
		ObjectOutputStream outputStream =null;
		File f;
		FileWriter outWriter = null;
		
		// find out where this packet needs to go.
		
		try{
		
			sendTo = new Socket("127.0.0.1",16001);	
			outputStream = new ObjectOutputStream(sendTo.getOutputStream());
			Packet p = new Packet("newquery","My First Query","newquery");
			outputStream.writeObject(p);
			f = new File("sending_to_application.txt");
			outWriter = new FileWriter(f);
			
		}catch(Exception e){}
		
		while(enable || pool.size() > 0){
		
			try{
		
				// get the packet
				Packet p = pool.removePacket();
		
				if(outputStream != null){
					outputStream.writeObject(p);	
					outWriter.write(p.toString()+"\n");
				}
				
		
			} catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	
	public void requestStop(){
		this.enable = false;
	}
}
