package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.QueryPlan;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 10, 2004
 * 
 * This abstract class represents the DesignPattern that Raindrop will use.
 * 
 */
public abstract class DesignPattern implements XATDesignPattern {

	//Private Members
	protected Machine[] machines;
	protected QueryPlan[] queryPlans;

	

	/**
	 * 
	 * @param m -The Machines Available for Distribution.
	 * @param s -The Streams Available to connect to.
	 * @param a -The Applications to Send the query results.
	 * @param qp -The query plans to distribute.
	 */
	public DesignPattern(Machine[] m, QueryPlan[] qp) {
		
		this.machines = m;
		this.queryPlans = qp;		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern.XATDesignPattern#distribute()
	 */
	public abstract DistributionTable distribute();

}
