package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.redistribution;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.costmodel.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern.DistributionTable;
//import java.util.*;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 24, 2004
 * 
 * Insert comments here.
 */
public class BalanceTest {

	/**
	 * 
	 */
	public BalanceTest() {
		super();
	}

	public static void main(String[] args) {
		
		try {
			CostTable ct = new CostTable(5);
			
			Machine m1 = new Machine();
			m1.setIPAddress("1.1.1.1");
			m1.setPort(8000);
			m1.setMachineName("Machine 1");
			
			Machine m2 = new Machine();
			m2.setIPAddress("2.2.2.2");
			m2.setPort(8000);
			m2.setMachineName("Machine 2");
			
			Machine m3 = new Machine();
			m3.setIPAddress("3.3.3.3");
			m3.setPort(8000);
			m3.setMachineName("Machine 3");
			
			Machine m4 = new Machine();
			m4.setIPAddress("4.4.4.4");
			m4.setPort(8000);
			m4.setMachineName("Machine 4");
			
			Machine m5 = new Machine();
			m5.setIPAddress("5.5.5.5");
			m5.setPort(8000);
			m5.setMachineName("Machine 5");
			
			XATNode n1 = new XATNodeImp();
			n1.setOperator(new ProbabilisticSingleStreamOperatorImp(n1));
			((XATStreamOperator) n1.getOperator()).setProperty("OBJECT_ID","1");
			((XATStreamOperator) n1.getOperator()).setActive(true);
			
			XATNode n2 = new XATNodeImp();
			n2.setOperator(new ProbabilisticSingleStreamOperatorImp(n2));
			((XATStreamOperator) n2.getOperator()).setProperty("OBJECT_ID","2");
			((XATStreamOperator) n2.getOperator()).setActive(true);
			
			XATNode n3 = new XATNodeImp();
			n3.setOperator(new ProbabilisticSingleStreamOperatorImp(n3));
			((XATStreamOperator) n3.getOperator()).setProperty("OBJECT_ID","3");
			((XATStreamOperator) n3.getOperator()).setActive(true);
			
			XATNode n4 = new XATNodeImp();
			n4.setOperator(new ProbabilisticSingleStreamOperatorImp(n4));
			((XATStreamOperator) n4.getOperator()).setProperty("OBJECT_ID","4");
			((XATStreamOperator) n4.getOperator()).setActive(true);
			
			XATNode n5 = new XATNodeImp();
			n5.setOperator(new ProbabilisticSingleStreamOperatorImp(n5));
			((XATStreamOperator) n5.getOperator()).setProperty("OBJECT_ID","5");
			((XATStreamOperator) n5.getOperator()).setActive(true);
			
			XATNode n6 = new XATNodeImp();
			n6.setOperator(new ProbabilisticSingleStreamOperatorImp(n6));
			((XATStreamOperator) n6.getOperator()).setProperty("OBJECT_ID","6");
			((XATStreamOperator) n6.getOperator()).setActive(true);
			
			XATNode n7 = new XATNodeImp();
			n7.setOperator(new ProbabilisticSingleStreamOperatorImp(n7));
			((XATStreamOperator) n7.getOperator()).setProperty("OBJECT_ID","7");
			((XATStreamOperator) n7.getOperator()).setActive(true);
			
			XATNode n8 = new XATNodeImp();
			n8.setOperator(new ProbabilisticSingleStreamOperatorImp(n8));
			((XATStreamOperator) n8.getOperator()).setProperty("OBJECT_ID","8");
			((XATStreamOperator) n8.getOperator()).setActive(true);
			
			XATNode n9 = new XATNodeImp();
			n9.setOperator(new ProbabilisticSingleStreamOperatorImp(n9));
			((XATStreamOperator) n9.getOperator()).setProperty("OBJECT_ID","9");
			((XATStreamOperator) n9.getOperator()).setActive(true);
			
			XATNode n10 = new XATNodeImp();
			n10.setOperator(new ProbabilisticSingleStreamOperatorImp(n10));
			((XATStreamOperator) n10.getOperator()).setProperty("OBJECT_ID","10");
			((XATStreamOperator) n10.getOperator()).setActive(true);
			
			XATNode n11 = new XATNodeImp();
			n11.setOperator(new ProbabilisticSingleStreamOperatorImp(n11));
			((XATStreamOperator) n11.getOperator()).setProperty("OBJECT_ID","11");
			((XATStreamOperator) n11.getOperator()).setActive(true);
			
			XATNode n12 = new XATNodeImp();
			n12.setOperator(new ProbabilisticSingleStreamOperatorImp(n12));
			((XATStreamOperator) n12.getOperator()).setProperty("OBJECT_ID","12");
			((XATStreamOperator) n12.getOperator()).setActive(true);
			
			XATNode n13 = new XATNodeImp();
			n13.setOperator(new ProbabilisticSingleStreamOperatorImp(n13));
			((XATStreamOperator) n13.getOperator()).setProperty("OBJECT_ID","13");
			((XATStreamOperator) n13.getOperator()).setActive(true);
			
			XATNode n14 = new XATNodeImp();
			n14.setOperator(new ProbabilisticSingleStreamOperatorImp(n14));
			((XATStreamOperator) n14.getOperator()).setProperty("OBJECT_ID","14");
			((XATStreamOperator) n14.getOperator()).setActive(true);
			
			ct.put(m1,1);
			ct.put(m2,.5);
			ct.put(m3,1);
			ct.put(m4,.2);
			ct.put(m5,.7);
			
			ct.putRawCost(m1,1000);
			ct.putRawCost(m2,500);
			ct.putRawCost(m3,1000);
			ct.putRawCost(m4,200);
			ct.putRawCost(m5,700);
			
			ct.put(m1,new NodeCost(n1,.6));
			ct.put(m1,new NodeCost(n2,.2));
			ct.put(m1,new NodeCost(n3,.1));
			ct.put(m1,new NodeCost(n4,.1));
			
			ct.put(m2,new NodeCost(n5,.6));
			ct.put(m2,new NodeCost(n6,.4));
			
			ct.put(m3,new NodeCost(n7,.4));
			ct.put(m3,new NodeCost(n8,.6));
			ct.put(m3,new NodeCost(n9,0));
			ct.put(m3,new NodeCost(n10,0));
			
			ct.put(m4,new NodeCost(n11,1));
			
			ct.put(m5,new NodeCost(n12, .5));
			ct.put(m5,new NodeCost(n13, .25));
			ct.put(m5,new NodeCost(n14, .25));
			
			Balance b = new Balance();
			
			DistributionTable t = ct.convertToDistributionTable();
			System.out.println(t);
			
			System.out.println(ct);
			DistributionTable dt = b.redistribute(null,ct,null,null);
			
			System.out.println(dt);
			
			DistributionTable diff = t.difference(dt);
			
			System.out.println(diff);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
