package edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller;

import java.io.BufferedWriter; 
import java.net.NetworkInterface;
import java.net.SocketException;
import java.io.FileWriter;
import java.io.ObjectInputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.lang.reflect.Constructor;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Application;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.DistributionConfiguration;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.QueryPlan;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Server;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Stream;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.manager.DistributionManager;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryplangenerator.QueryPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.queryplangenerator.QueryPlanGeneratorImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.scheduler.XATPreference;
import edu.wpi.cs.dsrg.xmldb.xat.component.scheduler.XATSchedulingAlgorithm;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsPrinter;
import edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client.Listener;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.*;
/**
 * This is the Experiment Environment setup.  It will parse the
 * configuration file and run the stream controller and execution controller.
 * It also supports batched experiments.  After the exec controller is done, the
 * whole experiment can be performed again.  
 * @author: Timothy M. Sutherland
 */
public class DistributedSystemSetup
	extends XATPropertiesImp
	implements Runnable, Listener {
	private String clientName;
	private java.lang.String configName;
	private boolean isClient;
	private int clientPort = -1;
	/**Stores the reference to the thread in which the execution controller runs*/
	private Thread systemThread = null;

	/**
	 * * ExperimentSetup constructor comment.
	 */
	public DistributedSystemSetup(int port) {
		super();
		this.systemThread = Thread.currentThread();
		isClient = true;
		clientPort = port;
	}
	/**
	 * ExperimentSetup constructor comment.
	 */
	public DistributedSystemSetup(String configFileName) {
		super();

		configName = configFileName;
		this.systemThread = Thread.currentThread();
		isClient = false;
	}

	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client.Listener#endOfStream()
	 */
	public void endOfStream() {
		this.systemThread.interrupt();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/10/03 12:07:38 PM)
	 * @return java.lang.Thread
	 */
	public java.lang.Thread getSystemThread() {
		return Thread.currentThread();
	}
	/**
	 * When an object implementing interface <code>Runnable</code> is used 
	 * to create a thread, starting the thread causes the object's 
	 * <code>run</code> method to be called in that separately executing 
	 * thread. 
	 * <p>
	 * The general contract of the method <code>run</code> is that it may 
	 * take any action whatsoever.
	 *
	 * @see     java.lang.Thread#run()
	 */
	public void run() {
		try {

			if (isClient) {

				InetAddress addr = InetAddress.getLocalHost();

				//Get IP Address
				byte[] ipAddr = addr.getAddress();
				Machine thisMachine;
				//Convert to dot representation
				String ipAddrStr = "";
				for (int i = 0; i < ipAddr.length; i++) {
					if (i > 0) {
						ipAddrStr += ".";
					}
					ipAddrStr += ipAddr[i] & 0xFF;
				}

				// Wait for the server to tell us our operation information.
//				if (clientPort==8001){
//					ipAddrStr="130.215.28.127";
//				}
//				if(clientPort==8002){
//					ipAddrStr="130.215.27.216";
//				}
				
				ServerSocket startup = new ServerSocket(clientPort);

				System.out.println(
					"Waiting For Distribution Manager on port "
						+ clientPort
						+ "..." + "at IP " + ipAddrStr);
				// Wait for incoming connection
				Socket incoming = startup.accept();

				ObjectInputStream in =
					new ObjectInputStream(incoming.getInputStream());
				DistributionConfiguration configurationObject =
					(DistributionConfiguration) in.readObject();

				System.out.println(
					"Received the configuration settings from the server.");
				//System.out.println(configurationObject.toString());

				// Setup main system settings
				Enumeration e = configurationObject.getProperties();
				while (e.hasMoreElements()) {
					String name = (String) e.nextElement();
					String value = configurationObject.getProperty(name);
					System.setProperty(name, value);
				}
                
				//hard-coding for demo
				
			    
				//@TODO look at this, see if there is a better way to do this.
				//----
				if (configurationObject.getMachine(ipAddrStr, clientPort)
					!= null) {
					clientName =
						configurationObject
							.getMachine(ipAddrStr, clientPort)
							.getMachineName();
					thisMachine =
						configurationObject.getMachine(ipAddrStr, clientPort);
				} else if (configurationObject.getMachine("127.0.0.1", clientPort)
			     != null) {
					clientName =
						configurationObject
								.getMachine("127.0.0.1", clientPort)
								.getMachineName();
					thisMachine =
						configurationObject.getMachine("127.0.0.1", clientPort);
			 } else {
					String localhost = new String("127.0.0.1");
					
					try{
						int foundflag = 0;
					    Enumeration netInterfaces=NetworkInterface.getNetworkInterfaces();
					    //mjba changed for demo to catch IP of last Network Interface
//					    NetworkInterface ni=(NetworkInterface)netInterfaces.nextElement();
//					    while(netInterfaces.hasMoreElements()){
//					          ni=(NetworkInterface)netInterfaces.nextElement();
//					    }
					    System.out.println("Test C0de" + netInterfaces.toString());					    
					       while(netInterfaces.hasMoreElements() && 0 == foundflag ){
					          NetworkInterface ni=(NetworkInterface)netInterfaces.nextElement();
					             //System.out.println(ni.getName());
					           System.out.println("While netInterfaces loop");
					           Enumeration c_inets = ni.getInetAddresses();
					           InetAddress ip=null;
					           while(c_inets.hasMoreElements() && 0 == foundflag){
					             ip=(InetAddress)c_inets.nextElement();
					             String tmp_add=ip.getHostAddress();
					             //check whether the address is right or not
					             int ch_num=-1;
					             ch_num=tmp_add.indexOf(":");
					             if((ch_num==-1) && configurationObject.getMachine(tmp_add, clientPort) != null){
					             //if((ch_num==-1) && configurationObject.getMachine(tmp_add, clientPort) != null && tmp_add.startsWith("10.0.")){
					                  ipAddrStr=tmp_add;
					                  System.out.println("foundflag=1");
					                  foundflag = 1;
					                  System.out.println("Found IP is: " + ipAddrStr);
					                 }
					            }
					       }
							if (0 == foundflag)
							{
								System.err.println("No machines found that match a network interface.  Client may crash.");
							}
					    
					}catch(SocketException sep){
					        System.err.println("Unknown network interfaces"+sep.getMessage());
					 } 
				//mjba hardcoding code for the demo	
// 				thisMachine=null;	
//				if(clientPort==8001){
//					    System.out.println("Machine 1 port is 8001"); 
//						clientName="Machine 1";
//						ipAddrStr="130.215.28.127";
//						thisMachine =
//                 				configurationObject.getMachine(ipAddrStr, clientPort);
//					}
					
//					if(clientPort==8002){
//						System.out.println("Machine 2 port is 8002"); 
//						clientName="Machine 2";
//						ipAddrStr="130.215.27.216";
// 					     thisMachine =
//                 				configurationObject.getMachine(ipAddrStr, clientPort);	
//					}		
					
   				clientName =
						configurationObject
							.getMachine(ipAddrStr, clientPort)
							.getMachineName();
							thisMachine =
					configurationObject.getMachine(ipAddrStr, clientPort);
				}
				 

				////------

				//Get the execution Controller
				
				String eController = configurationObject.getProperty("EXECUTION_CONTROLLER");
				Constructor[] c1 = Class.forName(eController).getConstructors();
				Constructor construct;
				ExecutionController exec = null;
				
				for(int i = 0; i < c1.length; i++){
					construct = c1[i];
					Class[] parameters = construct.getParameterTypes();
				
					if(parameters.length == 2){
						exec = (ExecutionController) construct.newInstance(new Object[] {configurationObject, clientName});
					}
				}
			
				if(exec == null){
					throw new Exception("The Execution Controller could not be instantiated.");
				}
				// set up the statistics printer

				String s = new String();
				boolean printMeta =
					new Boolean(this.getProperty("PRINT_OUT_META_INFORMATION"))
						.booleanValue();
				/** now set up the meta information of the printer */
				if (printMeta) {
					StatisticsPrinter printer = exec.getPrinter();
					String newLine = "\n";
					if (printer.getFormat() == StatisticsPrinter.HTML) {
						newLine = "|";
					}
					s = s + "Execution Controller properties:" + newLine;
					for (Enumeration f = exec.getProperties();
						f.hasMoreElements();
						) {
						String name = (String) f.nextElement();
						s = s + name + ": " + exec.getProperty(name) + newLine;
					}

					s = s + "SchedulerProperties: " + newLine;
					for (Enumeration f =
						exec.getCurrentScheduler().getProperties();
						f.hasMoreElements();
						) {
						String name = (String) f.nextElement();
						s =
							s
								+ name
								+ ": "
								+ exec.getCurrentScheduler().getProperty(name)
								+ newLine;
					}
					printer.setMetaInformation(s);
				}

				// Start execution 		

				Thread execThread = new Thread(exec);
				execThread.setName("Execution");

				Thread printerThread = new Thread(exec.getPrinter());
				printerThread.setName("Statistics Printer");
				printerThread.setDaemon(true);

				Thread receiverThread = new Thread(exec.getTupleReceiver());
				receiverThread.setName("Packet Receiver");
				receiverThread.setDaemon(true);

				Thread connectionThread =
					new Thread(exec.getConnectionListener());
				connectionThread.setName("Connection Listener");
				connectionThread.setDaemon(true);

				Thread feederThread = new Thread(exec.getTupleFeeder());
				feederThread.setName("Tuple Feeder");
				feederThread.setDaemon(true);

				Thread distributorThread =
					new Thread(exec.getTupleDistributor());
				distributorThread.setName("Tuple Distributor");
				distributorThread.setDaemon(true);

				Thread senderThread = new Thread(exec.getTupleSender());
				senderThread.setName("Tuple Sender");
				senderThread.setDaemon(true);


				connectionThread.start();
				printerThread.start();
				receiverThread.start();
				feederThread.start();
				distributorThread.start();
				//senderThread.start();
				execThread.start();
				
				if (thisMachine.getProperty("GUI").equals("on")) {
					Thread guiThread = new Thread((CAPE_GUIQueryEngine)exec.getGUI());
					guiThread.setName("GUI");
					guiThread.setDaemon(true);
					guiThread.start();
				}
				
				systemThread.interrupt();
			}

			// Otherwise this is the server so we have to take care of the
			// setup. We will get all of the configuration settings from the
			// configuration file that was passed to this class. We will then 
			// give this information to the Distribution Manager, and let it
			// control the distributed execution.

			else {
				DistributedConfigFileParser config =
					new DistributedConfigFileParser(configName);

				DistributionConfiguration dconfig =
					new DistributionConfiguration();

				try {
					InetAddress addr = InetAddress.getLocalHost();

					// Get IP Address
					byte[] ipAddr = addr.getAddress();

					// Convert to dot representation
					String ipAddrStr = "";
					for (int i = 0; i < ipAddr.length; i++) {
						if (i > 0) {
							ipAddrStr += ".";
						}
						ipAddrStr += ipAddr[i] & 0xFF;
					}
				    //hardcoding the IP address of the distribution manager
					//mjba
				   // String ipAddrStr="130.215.28.127";
				    dconfig.setManagerIPAddress(ipAddrStr);
					System.out.println(
						"The Distribution Manager is at: " + ipAddrStr);

				} catch (UnknownHostException e) {
					System.out.println(
						"Cannot resolve local IP address. Now Exiting.");
					System.exit(1);
				}

				// set up the system properties
				for (Iterator i = config.getSystemProperties(); i.hasNext();) {
					NameValuePair pair = (NameValuePair) i.next();
					dconfig.setProperty(pair.getName(), pair.getValue());
					System.setProperty(pair.getName(), pair.getValue());
				}
				for (Iterator i = config.getExperimentProperties();
					i.hasNext();
					) {
					NameValuePair pair = (NameValuePair) i.next();
					dconfig.setProperty(pair.getName(), pair.getValue());
				}
				for (Iterator i = config.getDistributionProperties();
					i.hasNext();
					) {
					NameValuePair pair = (NameValuePair) i.next();
					dconfig.setProperty(pair.getName(), pair.getValue());
				}

				// now get the statistics to gather
				Iterator periodicTree = config.getPeriodicTreeStatistics();
				Iterator everyTimeOperator =
					config.getEveryTimeOperatorStatistics();
				Iterator periodicOperator =
					config.getPeriodicOperatorStatistics();
				Iterator everyTimeSystem = config.getEveryTimeSystemStatistics();

				dconfig.setEveryTimeOperator(everyTimeOperator);
				dconfig.setPeriodicOperator(periodicOperator);
				dconfig.setPeriodicTree(periodicTree);
				dconfig.setEveryTimeSystem(everyTimeSystem);
				

				// now get the statistics to print

				Iterator printerOutputFormat =
					config.getOutputFormatProperties();
				Iterator printerColumns = config.getColumnNamesForOutput();

				dconfig.setPrinterOutputFormat(printerOutputFormat);
				dconfig.setPrinterColumnNames(printerColumns);

				// now get the machines
				int machineCount = 0;

				for (Iterator i = config.getMultipleAttributes("machine");
					i.hasNext();
					) {
					Machine m = new Machine();
					for (Iterator j = (Iterator) i.next(); j.hasNext();) {
						NameValuePair pair = (NameValuePair) j.next();
						m.setProperty(pair.getName(), pair.getValue());
					}
					// now get the preferences and scheduling algorithms
					for (Iterator q =
						config.getMachineSchedulingAlgorithms(machineCount);
						q.hasNext();
						) {
						NameValuePair pair = (NameValuePair) q.next();
						XATSchedulingAlgorithm sa =
							new XATSchedulingAlgorithm();
						sa.setAlgorithmClassName(pair.getValue());
						sa.setAlgorithmName(pair.getName());
						m.addSchedulingAlgorithm(sa);
					}

					for (Iterator q = config.getPreferences(machineCount);
						q.hasNext();
						) {
						XATPreference p = (XATPreference) q.next();
						m.addSchedulingPreference(p);
					}

					//This line resoleves the IP address if the hostname
					//is given in the configuration file.

					m.setIPAddress(m.getIPAddress());
					dconfig.addMachine(m);
					machineCount++;
				}

				// now get the query plans

				int queryCount = 0;
				int objectID = 1;
				int treeID = 1;
				for (Iterator i = config.getMultipleAttributes("QueryPlan");
					i.hasNext();
					) {
					QueryPlan qp = new QueryPlan(treeID);
					QueryPlanGenerator gen = null;
					ArrayList temp = new ArrayList();
					for (Iterator j = (Iterator) i.next(); j.hasNext();) {
						NameValuePair pair = (NameValuePair) j.next();
						if (pair
							.getName()
							.equals(QueryPlanGeneratorImp.factoryID)) {
							System.setProperty(pair.getName(), pair.getValue());
							gen = QueryPlanGeneratorImp.newInstance();
							gen.setDataModel(dconfig.getProperty("DATA_MODEL"));
						} else {
							/** if the generator has not been instantiated yet, store the pair in the temp list*/
							if (gen == null) {
								temp.add(pair);
							} else {
								/** otherwise, just set that property */
								gen.setProperty(
									pair.getName(),
									pair.getValue());
							}
						}
						qp.setProperty(pair.getName(), pair.getValue());
					}

					//add in the rest of the properties
					for (Iterator r = temp.iterator(); r.hasNext();) {
						NameValuePair pair = (NameValuePair) r.next();
						gen.setProperty(pair.getName(), pair.getValue());
					}
					qp.setQueryPlanGenerator(gen);
					qp.generateQueryPlan();
					objectID = qp.numberQueryPlanOperators(objectID);
					dconfig.addQueryPlan(qp);
					queryCount++;
					treeID++;
				}

				// now get the streams

				// these are stored in a seperate file so we need to parse it.

				DistributedConfigFileParser streamConfig =
					new DistributedConfigFileParser(
						dconfig.getProperty("STREAM_CONFIG_FILE_NAME"));

				for (Iterator i = streamConfig.getServers(); i.hasNext();) {
					Server s = (Server) i.next();
					dconfig.addServer(s);
				}

				for (Iterator i = streamConfig.getStreams(); i.hasNext();) {
					Stream s = (Stream) i.next();

					// now we have to add the server object to the stream so we know 
					// which server generates each stream.

					String serverName = s.getProperty("server");

					for (Iterator j = dconfig.getServers(); j.hasNext();) {
						Server temp = (Server) j.next();
						if (serverName.equals(temp.getName())) {
							s.setServer(temp);
						}
					}
					dconfig.addStream(s);
				}

				// and finally the applications...
				for (Iterator i = config.getMultipleAttributes("Application");
					i.hasNext();
					) {
					Application a = new Application();
					for (Iterator j = (Iterator) i.next(); j.hasNext();) {
						NameValuePair pair = (NameValuePair) j.next();
						a.setProperty(pair.getName(), pair.getValue());
					}

					dconfig.addApplication(a);
				}

				//

				System.out.println(dconfig.toString());

				DistributionManager dm = new DistributionManager(dconfig);
				Thread distributionManagerThread = new Thread(dm);
				distributionManagerThread.setName("Distribution Manager");
				distributionManagerThread.start();

				systemThread.interrupt();
			}

		} catch (Exception e) {
			try {
				//exception error thrown by the distribut manager on the laptops- mjba Aug 6, 2004
				BufferedWriter out = new BufferedWriter(new FileWriter("resources/PWJoin/exception.txt"));
				//BufferedWriter out = new BufferedWriter(new FileWriter("exception.txt"));
				out.write(e+"\n");
				out.flush();
				out.close();
			} catch(Exception e2) {
				e2.printStackTrace();
			}
			System.out.println(e.toString());
			e.printStackTrace();
			return;
		}
		return;

	}
	/**
	* called by the constructor.  this will set the default properties
	* that the ALL query objects will support. Each subclass should override
	* this method and add their own unique properties, but should also call
	* super.setDefaultProperties() so that the common properties may be set.
	*/
	protected void setDefaultProperties() {
		super.setDefaultProperties();
		addProperty("PRINT_OUT_META_INFORMATION", "1");
	}

}
