package edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller;

import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.ConnectionListener;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleDistributor;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleFeeder;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleReceiver;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.packet.TupleSender;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsPrinter;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 22, 2004
 * 
 * Basic Execution Controller. This class actually doesnt do anything but encapsulate the
 * specific execution controllers that we use.
 * 
 */
public abstract class ExecutionController extends XATQueryObjectImp implements Runnable {

	/**
	 * Returns the current scheduling algorithm in use.
	 * @return
	 */
	public abstract edu.wpi.cs.dsrg.xmldb.xat.component.scheduler.XATScheduler getCurrentScheduler();
	
	
	public abstract StatisticsPrinter getPrinter();
	public abstract void setLightweightStats(ArrayList stats);
	public abstract TupleReceiver getTupleReceiver();
	public abstract ConnectionListener getConnectionListener();
	public abstract TupleFeeder getTupleFeeder();
	public abstract TupleDistributor getTupleDistributor();
	public abstract TupleSender getTupleSender();
	public abstract CAPE_GUI getGUI();
	public abstract edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree[] getTree();
	public abstract void run();
	public abstract String toString();
	
	
}
