package edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller;

import java.io.Serializable;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.LightWeightQueryObject;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 11, 2004
 * 
 * Insert comments here.
 */
public class SystemObject extends XATQueryObjectImp implements Serializable {

	private String systemName;
	/**
	 * 
	 */
	public SystemObject() {
		this.systemName = "Default System";
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp#setDefaultStatistics()
	 */
	protected void setDefaultStatistics() {
		
		super.setDefaultStatistics();
		addStatistic("USED_MEMORY");
		addStatistic("FREE_MEMORY");
		addStatistic("TOTAL_MEMORY");
		addStatistic("USED_MEMORY_PERCENTAGE");
	}
	
	public String toString(){
		return this.systemName;
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject#getLightWeightQueryObject()
	 */
	public LightWeightQueryObject getLightWeightQueryObject() {
		return new LightWeightQueryObject("SystemObject",this.getClass().getName(),true);
	}
}
