package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

/**
 * XAT to DOT parser.
 * Creation date: (2/26/2002 7:45:04 PM)
 * @author: Michal Andrzej Dobosz
 */

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.updateoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;

import java.lang.reflect.Array;
import java.util.Hashtable;

public class DagParser extends edu.wpi.cs.dsrg.demo.raindropdemo.XATParser {

    protected Hashtable visitedNodes = new Hashtable();

    public DagParser(XATTree xattree) {
        super(xattree);
        System.out.println("\nEntering the KEY string generating section!\n");
    }
    /**
     * Prints a node in the XAT
     * If printNode is sent the root node of an XAT as input,
     * the whole tree is printed out.
     */
    protected void printNode(XATNode node, String parent) {
	    if(node == null){
		    // do nothing.
		    return;
	    }
	    if (!visitedNodes.containsKey(node)){
			XATNode[] children = node.getChildren();
			String child = (String)visit(node.getOperator());
			
			
			System.out.println("the operator is: "+child+" "+ node.getOperator());
			
			
			visitedNodes.put(node,child);
			
			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + ";\n";
			}
			for(int i = 0; i < Array.getLength(children); i++) {
				if(node.getOperator() instanceof LeftOuterJoin && i == 0){
					printNode(children[i], child, " [label=\"Left\"] ");
				}else
					printNode(children[i], child);
			}
	    } else {
			String child = (String)visitedNodes.get(node);
			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + ";\n";
			}
	    }
    }
    /**
     * Prints a node in the XAT with different style.
     * If printNode is sent the root node of an XAT as input,
     * the whole tree is printed out.
     */
    protected void printNode(XATNode node, String parent, String style) {
	    if(node == null){
		    // do nothing.
		    return;
	    }
		if (!visitedNodes.containsKey(node)){
	        XATNode[] children = node.getChildren();
	        String child = (String)visit(node.getOperator());

			visitedNodes.put(node,child);

	        if(parent == null) {
		        parent = child;
	        }
	        else if(child != null) {
				dottree += "\t" + parent + " -> " + child + style + ";\n";
	        }
	        for(int i = 0; i < Array.getLength(children); i++) {
	            printNode(children[i], child);
	        }
		}else{
			String child = (String)visitedNodes.get(node);
			if(parent == null) {
				parent = child;
			}
			else if(child != null) {
				dottree += "\t" + parent + " -> " + child + style + ";\n";
			}
		}
    }
}
