package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import javax.swing.*;

import edu.wpi.cs.dsrg.xmldb.xat.component.xatdaggeneration.DagQueryDecorrelation;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.utils.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class DecorrelationStep extends ProcessStep {
/**
 * DecorrelationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public DecorrelationStep(XATTree userXAT) {
	super(userXAT);
	setTabName("Decorelate");
	setTabTip("Decorelate the XML Algebra Tree");
	setContentPane(new JScrollPane());
}
/**
 * DecorrelationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public DecorrelationStep(XATTree userXAT, XATTree viewXAT) {
	super(userXAT, viewXAT);
	setTabName("Decorelate");
	setTabTip("Decorelate the XML Algebra Tree");
	setContentPane(new JSplitPane(JSplitPane.VERTICAL_SPLIT));
	JSplitPane thisPane = (JSplitPane)getContentPane();
	thisPane.setOneTouchExpandable(true);
	thisPane.setDoubleBuffered(true);
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {

	XATTree tree; 
	if(queryType == this.USER_QUERY){
  		tree = getUserTree();
	} else {
		tree = getViewTree();
	}
    NodeContainer nc;
    NodeListener nl;
    GrappaPanel gp;

    // perferm decorrelation
    DagQueryDecorrelation qd = new DagQueryDecorrelation((XATDag)tree);
    tree = qd.getDecorTree();

    // compute the binding table after decorrelation
    BindingTableComputer btc = new BindingTableComputer();
    BindingTable bt = btc.computeBindingTable( tree );
    tree.setBindingTable(bt);
    
    GrappaCreator gc = new GrappaCreator(tree, true);
    gp = gc.getGrappaPanel();
    nc = gc.getNodeContainer();
    nl = gc.getNodeListener();

    if (queryType == this.USER_QUERY) {
        setUserTree(tree);
        setUserGrappaPanel(gp);
        setUserNodeContainer(nc);
        setUserNodeListener(nl);
    } else {
        setViewTree(tree);
        setViewGrappaPanel(gp);
        setViewNodeContainer(nc);
        setViewNodeListener(nl);
    }

    return gp;
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeView() {
	if(!isViewDone()){
		setViewDone(true);
		return execute(VIEW_QUERY);
	}
	else return getViewGrappaPanel();
}
}
