package edu.wpi.cs.dsrg.xmldb.xat.component.gui;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.demo.*;
import java.awt.*;
import javax.swing.*;
/**
 * Insert the type's description here.
 * Creation date: (5/31/02 7:20:53 PM)
 * @author: Brian Murphy
 */
public class DocViewStep extends ProcessStep {
	private String userXQuery;
	private String viewXQuery;

	PaneLex userXQueryPane;
	PaneLex viewXQueryPane;

/**
 * DocViewStep constructor comment.
 */
protected DocViewStep() {
	super();
}

/**
 * DocViewStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public DocViewStep(XATTree userXAT, XATTree viewXAT, String userQueryFile, String viewQueryFile) {
	super(userXAT, viewXAT);
	setTabName("View XQuery");
	setTabTip("View XML and XQuery Documents");

	userXQuery = userQueryFile;
	viewXQuery = viewQueryFile;

	setContentPane(new JSplitPane(JSplitPane.VERTICAL_SPLIT));
	JSplitPane thisPane = (JSplitPane)getContentPane();
	thisPane.setOneTouchExpandable(true);
	thisPane.setDoubleBuffered(true);
}

/**
 * DocViewStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public DocViewStep(XATTree userXAT, String userQueryFile) {
	super(userXAT);
	setTabName("View XQuery");
	setTabTip("View XML and XQuery Documents");
	
    System.out.println("Getting ready to XQuery:\n\n"+userQueryFile);
	

	userXQuery = userQueryFile;

	setContentPane(new JScrollPane());
}

/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected javax.swing.JPanel execute(int queryType) {
	
	if(queryType == this.USER_QUERY){
  		this.userXQueryPane = new PaneLex();
		userXQueryPane.execString(getUserXQuery(), PaneLex.XQUERY);
		return userXQueryPane;
	} else {
  		this.viewXQueryPane = new PaneLex();
		viewXQueryPane.execString(getViewXQuery(), PaneLex.XQUERY);
		return viewXQueryPane;
	}
	
}

/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeUser(){
	if(!isUserDone()){
		setUserDone(true);
		return execute(USER_QUERY);
	}
	else 
	{
		return this.userXQueryPane;} 
}

/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeView() {
	if(!isViewDone()){
		setViewDone(true);
		return execute(VIEW_QUERY);
	}
	else return this.viewXQueryPane;
}

/**
 * Insert the method's description here.
 * Creation date: (5/31/02 7:44:03 PM)
 * @return java.lang.String
 */
public String getUserXQuery() {
	return userXQuery;
}

/**
 * Insert the method's description here.
 * Creation date: (5/31/02 7:44:03 PM)
 * @return java.lang.String
 */
public String getViewXQuery() {
	return viewXQuery;
}
}