package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import att.grappa.*;
import edu.wpi.cs.dsrg.demo.ReWriteGUI;
import edu.wpi.cs.dsrg.demo.raindropdemo.RDPlanGenerationStep;
import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.sqlgeneration.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import xacute.quilt.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class ExecutionGUI extends XQueryGUI {
/**
 * ExecutionGUI constructor comment.
 * @param userQuery_in java.lang.String
 * @param viewQuery_in java.lang.String
 * @param username_in java.lang.String
 * @param password_in java.lang.String
 * @param uRI_in java.lang.String
 * @param type int
 * @exception edu.wpi.cs.dsrg.xmldb.xat.component.gui.OracleConnectionException The exception description.
 */
public ExecutionGUI(String userQuery_in, String username_in, String password_in, String uRI_in) throws OracleConnectionException {
	super(userQuery_in, username_in, password_in, uRI_in);
	/** Now create the steps for this GUI and add then them to the stepVector*/
	
	System.out.println("1 "+userQuery_in+" 1");
	System.out.println("2 "+username_in+" 2");
	System.out.println("3 "+password_in+" 3");
	System.out.println("4 "+uRI_in+" 4");
	
	

	
	
	DocViewStep dvs = new DocViewStep(getUxat(), userQuery_in);
	

	
	//System.out.println("xxx"+getUserQuery());
	
	TreeGenerationStep tgs = new TreeGenerationStep(getUxat(), getUserQuery());
	RDPlanGenerationStep rdp = new RDPlanGenerationStep(getUxat(), getUserQuery(), ITEM_PLAIN, ITEM_PLAIN, ITEM_PLAIN);
	
	//DecorrelationStep ds = new DecorrelationStep(getUxat());
	//ReWriteStep rws = new ReWriteStep(getUxat(), this);
	//QueryGenerationStep qgs = new QueryGenerationStep(getUxat());
	//SchemaComputerStep scs = new SchemaComputerStep(getUxat());
	
	ExecutionStep qes = new ExecutionStep(getUxat(),getUsername(), getPassword(), getURI());
	
	stepVector.addElement(dvs);
	stepVector.addElement(tgs);
	stepVector.addElement(rdp);
	
	//stepVector.addElement(ds);	
	//stepVector.addElement(rws);
	//stepVector.addElement(qgs);
	//stepVector.addElement(scs);
	
	stepVector.addElement(qes);


	
}


/**
 * ExecutionGUI constructor comment.
 * @param userQuery_in java.lang.String
 * @param viewQuery_in java.lang.String
 * @param username_in java.lang.String
 * @param password_in java.lang.String
 * @param uRI_in java.lang.String
 * @param type int
 * @exception edu.wpi.cs.dsrg.xmldb.xat.component.gui.OracleConnectionException The exception description.
 */
public ExecutionGUI(String userQuery_in, String viewQuery_in, String username_in, String password_in, String uRI_in) throws OracleConnectionException {
	super(userQuery_in, viewQuery_in, username_in, password_in, uRI_in);
	
	/** Now create the steps for this GUI and add then them to the stepVector*/
	DocViewStep dvs = new DocViewStep(getUxat(), getVxat(), userQuery_in, viewQuery_in);
	TreeGenerationStep tgs = new TreeGenerationStep(getUxat(), getVxat(), getUserQuery(), getViewQuery());
	DecorrelationStep ds = new DecorrelationStep(getUxat(), getVxat());
	MergeStep ms = new MergeStep(getUxat(), getVxat());
	ReWriteStep rws = new ReWriteStep(getUxat(), getVxat(), this);
	QueryGenerationStep qgs = new QueryGenerationStep(getUxat(), getVxat());
	SchemaComputerStep scs = new SchemaComputerStep(getUxat(), getVxat());
	ExecutionStep qes = new ExecutionStep(getUxat(), getVxat(),getUsername(), getPassword(), getURI());
	stepVector.addElement(dvs);
	stepVector.addElement(tgs);
	stepVector.addElement(ds);	
	stepVector.addElement(ms);
	stepVector.addElement(rws);
	stepVector.addElement(scs);
	stepVector.addElement(qgs);
	stepVector.addElement(qes);
	
}
}
