package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import java.awt.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;
import edu.wpi.cs.dsrg.xmldb.xat.component.operatorexec.DagExecuteVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.component.operatorexec.ExecuteVisitor;
import javax.swing.*;
import xacute.quilt.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class ExecutionStep extends ProcessStep {
	protected java.lang.String userName;
	protected java.lang.String password;
	protected java.lang.String URI;
    protected static long timeBegin;
    protected static long timeExec;
	
/**
 * ExecutionStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public ExecutionStep(XATTree userXAT, XATTree viewXAT, String uName, String pw, String newURI) {
	super(userXAT, viewXAT);
	setTabName("Execute Query");
	setTabTip("Execute the Query on a Database");
	userName = uName;
	password = pw;
	URI = newURI;
	setContentPane(new JScrollPane());
}
/**
 * ExecutionStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public ExecutionStep(XATTree userXAT, String uName, String pw, String newURI) {
	super(userXAT);
	setTabName("Execute Query");
	setTabTip("Execute the Query on a Database");
	userName = uName;
	password = pw;
	URI = newURI;
	setContentPane(new JScrollPane());
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {

	XATTree tree = getUserTree();
    NodeContainer nc;
    NodeListener nl;
    GrappaPanel gp;

    // execute the query and store it into an XAT table
    DagExecuteVisitor qe = new DagExecuteVisitor(getURI(), getUserName(), getPassword());
    if(this.DEBUG)
    	System.setProperty("DEBUG_ExecuteVisitor", "OK");

	timeBegin = System.currentTimeMillis();

    qe.visit(tree);
    if(tree.getRoot() != null){
	    setTable((XATTable)tree.getRoot().getOperator().getOutputDataSource());
    }
    
    timeExec = System.currentTimeMillis() - timeBegin;

    System.out.println("Execution Time!:" + timeExec + "\n");
    
    try {
        System.out.println(
            getTable().getColumn(getTable().getNumberOfColumns()).toString());
    } catch (Exception e) {
        System.err.println(e.toString());
        e.printStackTrace(System.out);
    }

    // create a new GrappaPanel from this XAT
    GrappaCreator gc = new GrappaCreator(tree, true);
    gp = gc.getGrappaPanel();
    nc = gc.getNodeContainer();
    nl = gc.getNodeListener();
    setUserTree(tree);
    setUserGrappaPanel(gp);
    setUserNodeContainer(nc);
    setUserNodeListener(nl);

    return gp;
}
/**
 * Insert the method's description here.
 * 
 * @return java.lang.String
 */
public java.lang.String getPassword() {
	return password;
}
/**
 * Insert the method's description here.
 * 
 * @return java.lang.String
 */
public java.lang.String getURI() {
	return URI;
}
/**
 * Insert the method's description here.
 * 
 * @return java.lang.String
 */
public java.lang.String getUserName() {
	return userName;
}
/**
 * Updates the Scroll Pane by setting the viewport view and revalidating
 * 
 * @param grappaPanel att.grappa.GrappaPanel
 */
public void updateContentPane(JPanel grappaPanel,int mappingWay, int flagNum, String userQ, int paraSet) {

    // get the current content pane.
    JComponent theContent = this.getContentPane();
    theContent.setDoubleBuffered(true);

    JScrollPane js = ((JScrollPane) this.getContentPane());

	JPanel jMergePanel = new JPanel();
    jMergePanel.setLayout(new BorderLayout());
    JLabel jMergeLabel = new JLabel("Executation Time for the XQuery is: " + timeExec);

    JPanel jmPanel = new JPanel();
    jmPanel.add(grappaPanel);
    jMergePanel.add(jMergeLabel, BorderLayout.NORTH);
    jMergePanel.add(jmPanel, BorderLayout.CENTER);

    js.setViewportView(jMergePanel);
    theContent.revalidate();

}
}
