package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
//import java.util.Random;

import javax.swing.JFrame;

import edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.SystemObject;

import ptolemy.plot.PlotLive;

/**
 * This class simulates a GUI without actually running anything, i.e. all the
 * data comes from files.
 * 
 * Creation Date: (Jul 27, 2004 3:15:21 PM)
 * @author Natasha Bogdanova
 */
public class GUISimulation extends PlotLive {

	/** The update frequency in milliseconds. This specifies how often to add a new point
	 * to the plot that represents the latest statistic value for each data set. */
	private static long _freq = 1000;

	/** The position on the x-axis to plot the data point. */
	private double x_pos;

	/** Vector of Strings containing the statistics to plot. */
	private ArrayList _stats;

	/** Vector of <code>XATQueryObject</code>s to plot statistics for. */
	private ArrayList _queryObjects;

	/** The <code>SystemObject</code> to plot statistics for. */
	private SystemObject _systemObject;

	/** X-axis range minimum */
	final private int X_MIN = 0;

	/** X-axis range maximum */
	final private int X_MAX = 100;

	/** Y-axis range minimum */
	final private int Y_MIN = 0;

	/** Y-axis range maximum */
	final private int Y_MAX = 100;

	/** Plot graph width */
	final private int PLOT_WIDTH = 600;

	/** Plot graph height */
	final private int PLOT_HEIGHT = 300;

	/** Plot title */
	final private String TITLE = "CAPE Plot";

	/** X-axis label */
	final private String X_LABEL = "Time";

	/** Y-axis label */
	final private String Y_LABEL = "Statistics";

	/** @serial Value being plotted */
	private double _count = 0.0;
	private double x = 0.0;
	private double y = 0.0;

	public static void main(String[] args) {
		final GUISimulation guiSimulation = new GUISimulation();
		System.runFinalizersOnExit(true);
		JFrame frame = new JFrame("GUI Simulation");
		frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent event) {
					guiSimulation.stop();
					System.exit(0);
				}
			});
		frame.getContentPane().add("Center", guiSimulation);
		frame.show();
		guiSimulation.setButtons(true);
		guiSimulation.setBars(0.1, 0);
		guiSimulation.start();
		frame.pack();
		
		/*
		if(stats instanceof ArrayList)_stats = (ArrayList)stats;
		if(queryObjects instanceof ArrayList) _queryObjects = (ArrayList)queryObjects;
		else if(queryObjects instanceof SystemObject){
			_queryObjects = new ArrayList();
			_queryObjects.add(queryObjects);
		}
		_freq = Long.parseLong(freq);
		initLegend();
		initGraph();
		*/
	}

	/** Add points to the plot.  This is called by the base class
	 *  run() method when the plot is live.
	 */
	public synchronized void addPoints() {
		// You could plot multiple points at a time here
		// for faster response, but in our case, we really need
		// to slow down the response for visual aesthetics.
		addPoint(0, 0, 20, false);
		addPoint(0, 0.11, 30, false);
		addPoint(0, 0.22, 50, false);
		//_count += 1.0;
		
		for (int i = 0; i < 1000; i++) {}
		x = Runtime.getRuntime().totalMemory();
		y = Runtime.getRuntime().freeMemory();
		
		this.fillPlot();
		try {
			Thread.sleep(_freq);
		} catch (InterruptedException e) {}
	}


	/** Makes a legend of all the statistics. */
	/*private void initLegend(){
		int count = 0;
		//Constructs a key for the legend in the following format: 
		//XATQueryObject:Statistic for each queryObject
		for(Iterator e = _queryObjects.iterator(); e.hasNext();){
			XATQueryObject qo = ((XATQueryObject)e.next());
			//for each statistic
			for(Iterator e2 = _stats.iterator(); e2.hasNext();){
				//Make some replacements for shorter legend names
				String name = e2.next().toString();
				name = name.replaceAll("NUMBER", "#");
		
				String key = new String("");
				if(qo instanceof XATTree){
					key += "T"+qo.getProperty("TREE_ID")+":";
				}else if(qo instanceof XATQueue){
					key += "Q"+((XATQueue)qo).getQueueNumber()+":";
				}else if(qo instanceof XATStreamOperator){
					key += "O"+qo.getProperty("OBJECT_ID")+":";
				}else if(qo instanceof SystemObject){
					key += "S:";
				}
				key += name;
				addLegend(count, key);
				count++;
			}
		}
	}*/

	/** Initializes the plot by setting:
	 * <ul>
	 * <li>the plot title
	 * <li>the size of the plot (width and height)
	 * <li>x and y minimum and maximum range values
	 * <li>x and y axis labels
	 * <li>whether or not to display buttons (i.e. print button) and
	 * <li>the mark style (i.e. "dots").
	 * </ul> */
	/*private void initGraph(){
		//@TODO make a loading... popup while graph initializes
		setTitle(TITLE);
		setSize(PLOT_WIDTH, PLOT_HEIGHT);
		setXRange(X_MIN, X_MAX);
		setYRange(Y_MIN, Y_MAX);
		setXLabel(X_LABEL);
		setYLabel(Y_LABEL);
		setButtons(true); //display print, resize, etc. buttons
		setMarksStyle("dots");
	}*/

	/** Adds a new point to the plot every user-specified millisecond. */
	/*public synchronized void addPoints() {
		StatisticsGatherer myG = StatisticsGatherer.getStatisticsGather();
		int dataset = 0;
		//for each queryObject
		for(Iterator e = _queryObjects.iterator(); e.hasNext();){
			XATQueryObject qo = (XATQueryObject)e.next();
			//for each statistic
			for(Iterator e2 = _stats.iterator(); e2.hasNext();){
				addPoint(dataset, x_pos, Double.parseDouble(myG.getValue((String)e2.next(), qo)), true);
				//e2.next();
				//addPoint(dataset, x_pos, Math.random(), true);
				dataset++;
			}
		}
		x_pos += _freq;
		fillPlot();
		try {
			Thread.sleep(_freq);
		} catch (InterruptedException e) {}
	}*/
}
