package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import edu.wpi.cs.dsrg.utils.BindingTable;
import java.util.*;
import edu.wpi.cs.dsrg.utils.Debugger;
import javax.swing.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.querymerger.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class MergeStep extends ProcessStep {
/**
 * MergeStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public MergeStep(XATTree userXAT, XATTree viewXAT) {
	super(userXAT, viewXAT);
	setTabName("Merge");
	setTabTip("Merge the XML Algebra Trees");
	setContentPane(new JScrollPane());
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {
    XATTree tree = getUserTree();
    NodeContainer nc;
    NodeListener nl;
    GrappaPanel gp;

    XATTree vxat = this.getViewTree();
    MergeVisitor mergeV = new MergeVisitor(tree, vxat);
    mergeV.mergeTrees();
    BindingTable newUserTable = mergeV.getUserXAT().getBindingTable();
//    BindingTable newUserTable = mergeV.mergeBindingTables(getUserBindingTable(), getViewBindingTable());
    setUserBindingTable(newUserTable);

	
	if(DEBUG){
		Debugger d1 = new Debugger(tree);
		d1.printTree();
	}

	GrappaCreator gc = new GrappaCreator(tree, true);
    gp = gc.getGrappaPanel();
    nc = gc.getNodeContainer();
    nl = gc.getNodeListener();
    setUserTree(tree);
    setUserGrappaPanel(gp);
    setUserNodeContainer(nc);
    setUserNodeListener(nl);

    return gp;
}
}
