package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.*;
import javax.swing.*;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.sqlgeneration.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class QueryGenerationStep extends ProcessStep {
/**
 * QueryGenerationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public QueryGenerationStep(XATTree userXAT){
	super(userXAT);	
	setTabName("Generate SQL");
	setTabTip("Generate the Sequel Query");
	setContentPane(new JScrollPane());
}
/**
 * QueryGenerationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public QueryGenerationStep(XATTree userXAT, XATTree viewXAT){
	super(userXAT, viewXAT);	
	setTabName("Generate SQL");
	setTabTip("Generate the Sequel Query");
	setContentPane(new JScrollPane());
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {
    // pass in the binding hashtable to the sql generator    
    QueryGenerator sqlGen = new QueryGenerator(getUserBindingTable());
    XATTree tree = getUserTree();
    NodeContainer nc;
    NodeListener nl;
    GrappaPanel gp;
    try {
/*
        Vector classListOrder = new Vector();
        classListOrder.addElement(
            "edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWritePositionRules");
        //instantiate the rules class 
        ReWriteRules rulesOrder = new ReWriteRules(classListOrder);

        //now make the order of rules to look at
        Vector orderPos = new Vector();
        orderPos.addElement(
            "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.GroupByImp");
        orderPos.addElement(
            "edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.FunctionImp");

        //set the variable table in the rules class to be the hashtable from PT
        rulesOrder.setVariableTable(tree.getBindingTable());

        //create the traversal strategy
        ReWriteTraversal traverseOrder =
            new ReWriteTraversal(tree, rulesOrder, orderPos);

        traverseOrder.doPushdown(traverseOrder.DOWN);
*/
        sqlGen.generateQuery(tree, sqlGen.FULL, QueryTypes.SQL);
    } catch (Exception e) {
        System.err.println(e.toString());
        e.printStackTrace(System.out);
        System.exit(-1);
    }

    // create a new GrappaPanel from this XAT
    
	System.out.println("tryitFirst"+tree);
    
    GrappaCreator gc = new GrappaCreator(tree, true);
    gp = gc.getGrappaPanel();
    nc = gc.getNodeContainer();
    nl = gc.getNodeListener();
    setUserTree(tree);
    setUserGrappaPanel(gp);
    setUserNodeContainer(nc);
    setUserNodeListener(nl);

    return gp;
}
}
