package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import edu.wpi.cs.dsrg.demo.*;
import javax.swing.*;
import java.util.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class ReWriteStep extends ProcessStep {
	/**
	 * @param tree
	 * @param tree2
	 * @param executionGUI
	 */

	/**
	 * @param tree
	 * @param tree2
	 * @param executionGUI
	 */
	public ReWriteStep(XATTree tree, XATTree tree2, ExecutionGUI executionGUI) {
		
		// TODO Auto-generated constructor stub
	}
	protected XQueryGUI xGui;
/**
 * The XQuery GUI is needed so that this may call back to the XQueryGUI and set
 * the ReWriteStep tab to be selected.  This is after the ReWriteGUI notifies
 * this step and gives it the final tree
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public ReWriteStep(XATTree userXAT, XATTree viewXAT, XQueryGUI gui) {
	super(userXAT, viewXAT);
	setTabName("ReWrite");
	setTabTip("ReWrite the Selected Nodes");	
	setContentPane(new JScrollPane());
	xGui = gui;
}
/**
 * The XQuery GUI is needed so that this may call back to the XQueryGUI and set
 * the ReWriteStep tab to be selected.  This is after the ReWriteGUI notifies
 * this step and gives it the final tree
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public ReWriteStep(XATTree userXAT, XQueryGUI gui) {
	super(userXAT);
	setTabName("ReWrite");
	setTabTip("ReWrite the Selected Nodes");	
	setContentPane(new JScrollPane());
	xGui = gui;
}
/**
 * Show the ReWriteGUI, 
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {

    NodeContainer nc;
    NodeListener nl;
    GrappaPanel gp;

    ReWriteGUI aReWriteGUI;
    aReWriteGUI = new ReWriteGUI();
    aReWriteGUI.setBindingTable(this.getUserBindingTable());
    aReWriteGUI.setTree(this.getUserTree());
    //give the ReWriteGUI this step so that it may be called back later when ReWriting is done
    aReWriteGUI.setCallbackGUI(this);
    aReWriteGUI.run();

    //show the tree
    XATTree tree = getUserTree();

    GrappaCreator gc = new GrappaCreator(tree, true);
    gp = gc.getGrappaPanel();
    nc = gc.getNodeContainer();
    nl = gc.getNodeListener();
    setUserTree(tree);
    setUserGrappaPanel(gp);
    setUserNodeContainer(nc);
    setUserNodeListener(nl);

    return gp;

    //return new JPanel();
}
/**
 * Insert the method's description here.
 * 
 * @return edu.wpi.cs.dsrg.xmldb.xat.component.gui.XQueryGUI
 */
public XQueryGUI getXGui() {
	return xGui;
}
/**
 * Insert the method's description here.
 * 
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public void reWriteGUICallBack(XATTree tree) {
	
		setUserTree(tree);
		Vector tempV = xGui.getStepVector();
		int position = 0;
		//find which step is the ReWriteStep
		for (int i = 0; i < tempV.size(); i++){
			ProcessStep ps = (ProcessStep)tempV.elementAt(i);
			if(ps instanceof ReWriteStep){
				position = i;
				break;
			}
		}
		//update the grappa panel and such to reflect this new tree
		GrappaCreator gp = new GrappaCreator(getUserTree(), true);
		setUserGrappaPanel(gp.getGrappaPanel());
		setUserNodeListener(gp.getNodeListener());
		setUserNodeContainer(gp.getNodeContainer());
		
		//then set that tab to be selected, this fires the tab selection event which will update the rewrite display
		//first have to select another tab so that the display will refresh
		xGui.getTabbedpane().setSelectedIndex(position - 1);
		xGui.getTabbedpane().setSelectedIndex(position);
		System.out.println("Does it show this?");
		return;
	
	}
/**
 * Insert the method's description here.
 * 
 * @param newXGui edu.wpi.cs.dsrg.xmldb.xat.component.gui.XQueryGUI
 */
public void setXGui(XQueryGUI newXGui) {
	xGui = newXGui;
}
}
