package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import edu.wpi.cs.dsrg.xmldb.xat.component.schemacleanup.TreeCleanupVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.component.schemacleanup.SchemaCleanupVisitor;
import javax.swing.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class SchemaComputerStep extends ProcessStep {
/**
 * SchemaComputerStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public SchemaComputerStep(XATTree userXAT) {
	super(userXAT);
	setTabName("Compute Schema");
	setTabTip("Compute the Schema");
	setContentPane(new JScrollPane());
}
/**
 * SchemaComputerStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public SchemaComputerStep(XATTree userXAT, XATTree viewXAT) {
	super(userXAT, viewXAT);
	setTabName("Compute Schema");
	setTabTip("Compute the Schema");
	setContentPane(new JScrollPane());
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {

    XATTree tree;
    NodeContainer nc;
    NodeListener nl;
    GrappaPanel gp;

    // compute the schema and store it into an XAT table
    TreeCleanupVisitor sc = new TreeCleanupVisitor();
    sc.visit(getUserTree());
    //SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
	//sc.computeSchema(getUserTree());

    // create a new GrappaPanel from this XAT
    GrappaCreator gc = new GrappaCreator(getUserTree(), true);
    gp = gc.getGrappaPanel();
    nc = gc.getNodeContainer();
    nl = gc.getNodeListener();

    setUserGrappaPanel(gp);
    setUserNodeContainer(nc);
    setUserNodeListener(nl);

    return gp;
}
}
