package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

/**
 * Converts an XATTable into a JTable.
 * Creation date: (5/11/2002 4:45:54 PM)
 * @author: Michal Andrzej Dobosz
 */

import java.util.Vector;
import javax.swing.JTable;
import javax.swing.table.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;
 
public class TableCreator {
	private JTable jtable = null;
	private Vector rowList = null;
	private Vector colNames = null;
	
	/**
	 * TableCreator constructor comment.
	 */
	public TableCreator(XATTable table) {
		// initialize the column names and the column list
		rowList = table.getRowList();
		colNames = table.getColNames();

		/*
		// retreive the size of the vectors
		int listSize = colList.size();
		int namesSize = colNames.size();

		// schema computation has been performed, but not query execution
		if(listSize == 0 && namesSize != 0) {
			Vector newColumn = new Vector();
			
			// create a new column filled with bogus data
      		for(int i = 0; i < namesSize; i++) {
        		newColumn.addElement(new String("No Data"));
      		}

      		// add this column to the column list
      		colList.addElement(newColumn);
      		colList.addElement(newColumn);
      		colList.addElement(newColumn);
		} else

		// neither schema computation nor query execution have been performed
		if(listSize == 0 && namesSize == 0) {
			Vector newColumn = new Vector();

			// create a new column filled with bogus data
      		for(int i = 0; i < 3; i++) {
        		newColumn.addElement(new String("No Data"));
      		}

      		// add this column to the column list
      		colList.addElement(newColumn);
      		colList.addElement(newColumn);
      		colList.addElement(newColumn);
			colNames.addElement("No Data");
			colNames.addElement("No Data");
			colNames.addElement("No Data");
		}

		// schema computation and query execution have been performed
		jtable = new JTable(colList, colNames);
		*/
		
		jtable = new JTable();
		// get table model
		DefaultTableModel model = (DefaultTableModel)jtable.getModel();
		// update the data.
		model.setDataVector(rowList, colNames);
		// resize the table to fit.
		jtable.sizeColumnsToFit(jtable.AUTO_RESIZE_SUBSEQUENT_COLUMNS);
		// update the contained gui component.
		model.fireTableChanged(null);
	}

	/**
	 * Returns the JTable created by this class.
	 */
	public JTable getTable() {
		return jtable;
	}

	public void debugJTable() {
        int numRows = jtable.getRowCount();
        int numCols = jtable.getColumnCount();
        javax.swing.table.TableModel model = jtable.getModel();

        System.out.println("Value of data: ");
        for(int i = 0; i < numRows; i++) {
            System.out.print("    row " + i + ":");
            for(int j = 0; j < numCols; j++) {
	            // limit the size to display if that data is too huge.
	            String value = model.getValueAt(i, j).toString();
	            if(value.length() > 100){
		            value = value.substring(0, 100);
		            value = value + " ... TRUNKED ... ";
	            }
                System.out.print(" || " + value);
            }
            System.out.println();
        }
        System.out.println("--------------------------");
    }
}
