package edu.wpi.cs.dsrg.xmldb.xat.component.gui.listeners;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JScrollPane;

import edu.wpi.cs.dsrg.xmldb.xat.component.gui.CAPE_GUI;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils.CAPETab;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils.JTabbedPaneCAPE;

/** The listener that updates all of the open statistic table(s) every
 * <code>UPDATE_STATISTICS_MILLISECONDS</code>. */
public class UpdateStatisticTableListener implements ActionListener{
	
	/** The <code>CAPE_GUI</code>. */
	private CAPE_GUI _gui;
	
	/** Constructor associates the given <code>gui</code> with this listener. */
	public UpdateStatisticTableListener(CAPE_GUI gui){
		_gui = gui;
	}
	
	/** Handles the action event. */
	public void actionPerformed(ActionEvent evt){
		try{
			JTabbedPaneCAPE tp = _gui.getGraphManager().getStatsTabbedPane();
			
			//for each tab (or statistic table)
			for(int i=0; i<tp.getTabCount(); i++){
				JScrollPane tablePane = _gui.getTableMaker().makeTable(((CAPETab)tp.getIconAt(i)).getXATQueryObject());
				tp.setComponentAt(i, tablePane);
			}
		}catch(Exception e){System.err.println("UpdateStatisticTableListener: Error handing action event.");}
	}
}