package edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * Filters out all files that do not have the extension ".csv".
 * 
 * Creation Date: (Jul 20, 2004 11:12:00 AM)
 * @author Natasha Bogdanova
 */
public class CSVFileFilter extends FileFilter {

	/**
	 * Default constructor.
	 */
	public CSVFileFilter() {
		super();
	}

	/**
	 * Returns true of the given file's name ends with ".csv".
	 * 
	 * Creation Date: (Jul 20, 2004 11:12:58 AM)
	 * @author Natasha Bogdanova
	 * @param inFile File
	 * @return boolean
	 */
	public boolean accept(File inFile) {
		if (inFile.isDirectory())
			return true;
		else
			return inFile.getName().toLowerCase().endsWith(".csv");
	}

	/**
	 * Returns the description of this filter.
	 * 
	 * Creation Date: (Jul 20, 2004 11:14:47 AM)
	 * @author Natasha Bogdanova
	 * @return String
	 */
	public String getDescription() {
		return "CSV Files";
	}

}
