package edu.wpi.cs.dsrg.xmldb.xat.component.gui.utils;

import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.ImageIcon;
import java.awt.event.KeyEvent;

import edu.wpi.cs.dsrg.xmldb.xat.component.gui.CAPE_GUI;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.listeners.*;

/** The <code>JMenuBar</code> specific to the CAPE. */
public class JMenuBarCAPE extends JMenuBar{
	
	/** The <code>CAPE_GUI</code>. */
	private CAPE_GUI _gui;
	
	/** Constructor associates the given <code>gui</code> with this menu bar. */
	public JMenuBarCAPE(CAPE_GUI gui){
		_gui = gui;
	}
	
	/** Creates the menu bar for this <code>CAPE_GUI</code>.
	 * @return the menu bar for this <code>CAPE_GUI</code> */
	public JMenuBar createJMenuBarCAPE(){
		JMenuBar menuBar = new JMenuBar();
		JMenu menu, subMenu;
		JMenuItem menuItem;
		
		//create menu icons
		java.net.URL exitURL = CAPE_GUI.class.getResource("images/exit.png");
		ImageIcon exit = new ImageIcon(exitURL, "Exit");
		java.net.URL customURL = CAPE_GUI.class.getResource("images/customize.png");
		ImageIcon custom = new ImageIcon(customURL, "Customize Graph");
		java.net.URL plotURL = CAPE_GUI.class.getResource("images/plot.png");
		ImageIcon plot = new ImageIcon(plotURL, "Plot Statistics");
		java.net.URL treeURL = CAPE_GUI.class.getResource("images/tree.png");
		ImageIcon tree = new ImageIcon(treeURL, "Tree Statistics");
		java.net.URL sysURL = CAPE_GUI.class.getResource("images/system.png");
		ImageIcon sys = new ImageIcon(sysURL, "System Statistics");
		java.net.URL opURL = CAPE_GUI.class.getResource("images/operator.png");
		ImageIcon op = new ImageIcon(opURL, "Operator Statistics");
		java.net.URL qURL = CAPE_GUI.class.getResource("images/queue.png");
		ImageIcon q = new ImageIcon(qURL, "Queue Statistics");
		java.net.URL fURL = CAPE_GUI.class.getResource("images/open_file.png");
		ImageIcon f = new ImageIcon(fURL, "File Statistics");
	
		//Create File Menu
		menu = new JMenu("File");
		menu.setMnemonic('F');
		menuBar.add(menu);
		
		menuItem = new JMenuItem("Exit", exit);
		menuItem.setMnemonic('X');
		menuItem.setActionCommand("EXIT");
		menuItem.addActionListener(new CAPEListener(_gui));
		menu.add(menuItem);
		
		//Create View Menu
		menu = new JMenu("View");
		menu.setMnemonic('V');
		menuBar.add(menu);
		
		menuItem = new JMenuItem("Customize Graph...", custom);
		menuItem.setActionCommand("CUSTOMIZE");
		menuItem.addActionListener(new CAPEListener(_gui));
		menu.add(menuItem);
		
		menu = new JMenu("Tools");
		menu.setMnemonic('T');
		menuBar.add(menu);
		
		// Table Statistics -->
		subMenu = new JMenu("Table Statistics");	
		menuItem = new JMenuItem("Tree Statistics", tree);
		menuItem.setActionCommand("DISPLAY_TREE_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("System Statistics", sys);
		menuItem.setActionCommand("DISPLAY_SYSTEM_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		menu.add(subMenu);
		
		// Plot Statistics -->
		subMenu = new JMenu("Plot Statistics");		
		menuItem = new JMenuItem("Tree", tree);
		menuItem.setActionCommand("PLOT_TREE_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		
		menuItem = new JMenuItem("Queue", q);
		menuItem.setActionCommand("PLOT_QUEUE_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("Operator", op);
		menuItem.setActionCommand("PLOT_OPERATOR_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("System", sys);
		menuItem.setActionCommand("PLOT_SYSTEM_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("From File", f);
		menuItem.setActionCommand("PLOT_FILE_STATS");
		menuItem.setMnemonic('P');
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		menu.add(subMenu);
		
		// Select Statistics to Display -->
		subMenu = new JMenu("Select Statistics for Table(s)         ");
		menuItem = new JMenuItem("Tree", tree);
		menuItem.setActionCommand("SELECT_TREE_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("Queue", q);
		menuItem.setActionCommand("SELECT_QUEUE_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("Operator", op);
		menuItem.setActionCommand("SELECT_OPERATOR_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("System", sys);
		menuItem.setActionCommand("SELECT_SYSTEM_STATS");
		menuItem.addActionListener(new CAPEListener(_gui));
		subMenu.add(menuItem);
		menu.add(subMenu);
		
		menu = new JMenu("Help");
		menu.setMnemonic('H');
		menuBar.add(menu);
		
		menuItem = new JMenuItem("Help");
		menuItem.setActionCommand("HELP");
		menuItem.addActionListener(new CAPEListener(_gui));
		menu.add(menuItem);
		
		menuItem = new JMenuItem("About CAPE...");
		menuItem.setActionCommand("ABOUT_CAPE");
		menuItem.addActionListener(new CAPEListener(_gui));
		menu.add(menuItem);
		
		return menuBar;
	}
}