package edu.wpi.cs.dsrg.xmldb.xat.component.migrationcontroller;

import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
/**
 * Insert the type's description here.
 * Creation date: (3/28/2003 2:33:17 PM)
 * @author: Yali Zhu
 */
public class ManualQueryPlanGenerator {
/**
 * ManualQueryPlanGenerator constructor comment.
 */
public ManualQueryPlanGenerator() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (6/22/2003 5:10:55 AM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag
 */
public XATDag makeNewPlan() {
	return makeNewPlan2();
}
/**
 * Insert the method's description here.
 * A join C join B
 * Create plan A join C, then AC join with B (predicate on A and B)
 *
 *      ABC
 *    AC
 *
 * Creation date: (4/6/2003 3:08:51 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public XATDag makeNewPlan1() {

    System.out.println("1st New Plan");
    XATDag dag = new XATDagImp();

    /* create source nodes */
    DagNode sourceNodeA = new DagNodeImp();
    Source sourceOpA = new SourceImp(sourceNodeA);
    sourceOpA.setName("A");
    sourceNodeA.setOperator(sourceOpA);

    DagNode sourceNodeB = new DagNodeImp();
    Source sourceOpB = new SourceImp(sourceNodeB);
    sourceOpB.setName("B");
    sourceNodeB.setOperator(sourceOpB);

    DagNode sourceNodeC = new DagNodeImp();
    Source sourceOpC = new SourceImp(sourceNodeC);
    sourceOpC.setName("C");
    sourceNodeC.setOperator(sourceOpC);

    /* create node and operator AC */
    DagNode nodeAC = new DagNodeImp();  
	WBinaryJoinOperatorImp wbjoinopAC =
        new WBinaryJoinOperatorImp(nodeAC);
//    wbjoinopAC.setJoinPredicate("Col1", "Col3", BinCOMPExpressionStr.EQ);
    nodeAC.setOperator(wbjoinopAC);
    nodeAC.addChild(sourceNodeA);
    nodeAC.addChild(sourceNodeC);
    sourceNodeA.setParent(nodeAC);
    sourceNodeC.setParent(nodeAC);

    // set state's schema
    Vector stateAcols = new Vector();
    stateAcols.add("Col1");
    XATQueueSchema stateASchema = new XATQueueSchema(stateAcols);
    //wbjoinopAC.getLeftState().setSchema(stateASchema);
    Vector stateCcols = new Vector();
    stateCcols.add("Col3");
    XATQueueSchema stateCSchema = new XATQueueSchema(stateCcols);
    //wbjoinopAC.getRightState().setSchema(stateCSchema);

    // set output Q
    XATQueue outputQAC = new XATMemoryQueueImp(wbjoinopAC);
    Vector queueACcols = new Vector();
    queueACcols.add("Col1");
    queueACcols.add("Col3");
    XATQueueSchema queueACschema = new XATQueueSchema(queueACcols);
    outputQAC.setSchema(queueACschema);
    try {
        wbjoinopAC.setOutputQueue(outputQAC);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    /** create node and operator ABC on top of AC */
    DagNode nodeABC = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABC =
        new WBinaryJoinOperatorImp(nodeABC);
//    wbjoinopABC.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    nodeABC.setOperator(wbjoinopABC);

    nodeABC.addChild(nodeAC);
    nodeABC.addChild(sourceNodeB);
    nodeAC.setParent(nodeABC);
    sourceNodeB.setParent(nodeABC);

    // set state's schema
    Vector stateACcols = new Vector();
    stateACcols.add("Col1");
    stateACcols.add("Col3");
    XATQueueSchema stateACSchema = new XATQueueSchema(stateACcols);
    //wbjoinopABC.getLeftState().setSchema(stateACSchema);
    Vector stateBcols = new Vector();
    stateBcols.add("Col2");
    XATQueueSchema stateBSchema = new XATQueueSchema(stateBcols);
    //wbjoinopABC.getRightState().setSchema(stateBSchema);

    // set output Q
    XATQueue outputQABC = new XATMemoryQueueImp(wbjoinopABC);
    Vector queueABCcols = new Vector();
    queueABCcols.add("Col1");
    queueABCcols.add("Col2");
    queueABCcols.add("Col3");
    XATQueueSchema queueABCschema = new XATQueueSchema(queueABCcols);
    outputQABC.setSchema(queueABCschema);
    try {
        wbjoinopABC.setOutputQueue(outputQABC);
        outputQABC.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    // set input Q
    wbjoinopABC.addInputQueue(outputQAC);
    wbjoinopABC.setDebug(false);

    dag.setRoot(nodeABC);
    return dag;
}
/**
 * Insert the method's description here.
 *
 * A (Col1) join B (Col2) join C (Col3) join D (Col4)
 * query plan: B join C first, then join with D, then join with A
 *
 *       ABCD
 *         BCD
 *       BC
 *
 * Creation date: (6/18/2003 10:31:14 AM)
 */
public XATDag makeNewPlan2() {
	
	System.out.println("2nd New Plan");
    XATDag dag = new XATDagImp();

    /* create source nodes and operators */
    DagNode sourceNodeA = new DagNodeImp();
    Source sourceOpA = new SourceImp(sourceNodeA);
    sourceOpA.setName("A");
    sourceNodeA.setOperator(sourceOpA);

    DagNode sourceNodeB = new DagNodeImp();
    Source sourceOpB = new SourceImp(sourceNodeB);
    sourceOpB.setName("B");
    sourceNodeB.setOperator(sourceOpB);

    DagNode sourceNodeC = new DagNodeImp();
    Source sourceOpC = new SourceImp(sourceNodeC);
    sourceOpC.setName("C");
    sourceNodeC.setOperator(sourceOpC);

    DagNode sourceNodeD = new DagNodeImp();
    Source sourceOpD = new SourceImp(sourceNodeD);
    sourceOpD.setName("D");
    sourceNodeD.setOperator(sourceOpD);
    
    /** create node and operator BC */
    DagNode nodeBC = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopBC = new WBinaryJoinOperatorImp(nodeBC);
//	wbjoinopBC.setJoinPredicate("Col2", "Col3", BinCOMPExpressionStr.EQ);
    nodeBC.setOperator(wbjoinopBC);

    // connect with stream nodes
    sourceNodeB.setParent(nodeBC);
    nodeBC.addChild(sourceNodeB);
    sourceNodeC.setParent(nodeBC);
    nodeBC.addChild(sourceNodeC);

    // set state schema
    Vector stateBcols = new Vector();
    stateBcols.add("Col2");
    XATQueueSchema stateBSchema = new XATQueueSchema(stateBcols);
    //wbjoinopBC.getLeftState().setSchema(stateBSchema);
    Vector stateCcols = new Vector();
    stateCcols.add("Col3");
    XATQueueSchema stateCSchema = new XATQueueSchema(stateCcols);
    //wbjoinopBC.getRightState().setSchema(stateCSchema);    

    // set output Q
    XATQueue outputQBC = new XATMemoryQueueImp(wbjoinopBC);
    Vector queueBCcols = new Vector();
    queueBCcols.add("Col2");
    queueBCcols.add("Col3");
    XATQueueSchema schemaBC = new XATQueueSchema(queueBCcols);
    outputQBC.setSchema(schemaBC);
    try {
        wbjoinopBC.setOutputQueue(outputQBC);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    /** create node and operator BCD on top of BC */
    DagNode nodeBCD = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopBCD = new WBinaryJoinOperatorImp(nodeBCD);
//    wbjoinopBCD.setJoinPredicate("Col3", "Col4", BinCOMPExpressionStr.EQ);
    nodeBCD.setOperator(wbjoinopBCD);
    nodeBC.setParent(nodeBCD);
    nodeBCD.addChild(nodeBC);
    sourceNodeD.setParent(nodeBCD);
    nodeBCD.addChild(sourceNodeD);

    // set state's schema
    Vector stateBCcols = new Vector();
    stateBCcols.add("Col2");
    stateBCcols.add("Col3");
    XATQueueSchema stateBCSchema = new XATQueueSchema(stateBCcols);
    //wbjoinopBCD.getLeftState().setSchema(stateBCSchema);
    Vector stateDcols = new Vector();
    stateDcols.add("Col4");
    XATQueueSchema stateDSchema = new XATQueueSchema(stateDcols);
    //wbjoinopBCD.getRightState().setSchema(stateDSchema);

	//set output Q
    XATQueue outputQBCD = new XATMemoryQueueImp(wbjoinopBCD);
    Vector queueBCDcols = new Vector();
    queueBCDcols.add("Col2");
    queueBCDcols.add("Col3");
    queueBCDcols.add("Col4");
    XATQueueSchema schemaBCD = new XATQueueSchema(queueBCDcols);
    outputQBCD.setSchema(schemaBCD);
    try {
        wbjoinopBCD.setOutputQueue(outputQBCD);
        //outputQBCD.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    // set input Q
    wbjoinopBCD.addInputQueue(outputQBC);
    //wbjoinopABC.setNthInputQueue(outputQBC, 1);


    /** create node and operator ABCD on top of BCD */
    DagNode nodeABCD = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABCD = new WBinaryJoinOperatorImp(nodeABCD);
//    wbjoinopABCD.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    nodeABCD.setOperator(wbjoinopABCD);
    nodeABCD.addChild(sourceNodeA);
    nodeABCD.addChild(nodeBCD);
    sourceNodeA.setParent(nodeABCD);    
    nodeBCD.setParent(nodeABCD);   

    // set state's schema
    Vector stateAcols = new Vector();
    stateAcols.add("Col1");
    XATQueueSchema stateASchema = new XATQueueSchema(stateAcols);
    //wbjoinopABCD.getLeftState().setSchema(stateASchema);
    Vector stateBCDcols = new Vector();
    stateBCDcols.add("Col2");
    stateBCDcols.add("Col3");
    stateBCDcols.add("Col4");
    XATQueueSchema stateBCDSchema = new XATQueueSchema(stateBCDcols);
    //wbjoinopABCD.getRightState().setSchema(stateBCDSchema);
    
	//set output Q
    XATQueue outputQABCD = new XATMemoryQueueImp(wbjoinopABCD);
    Vector queueABCDcols = new Vector();
    queueABCDcols.add("Col1");
    queueABCDcols.add("Col2");
    queueABCDcols.add("Col3");
    queueABCDcols.add("Col4");  
    XATQueueSchema schemaABCD = new XATQueueSchema(queueABCDcols);
    outputQABCD.setSchema(schemaABCD);
    try {
        wbjoinopABCD.setOutputQueue(outputQABCD);
        outputQABCD.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }
    // set input Q, first input Q is reserved for streamQ of A
    wbjoinopABCD.setNthInputQueue(outputQBCD, 1);
  
    dag.setRoot(nodeABCD);
    return dag;
}
/**
 * Insert the method's description here.
 * Creation date: (6/18/2003 10:31:49 AM)
 * complex query plan with matching state in the middle of the box.
 * test the genericity of moving state strategy
 *
 * A join B join C join D join E   output queue schema = ABCDE
 *
 *        ABCDE
 *     ABCD
 *   ABC
 *      BC
 *
 */
public XATDag makeNewPlan3() {

	System.out.println("3nd New Plan");
	XATDag dag = new XATDagImp();

    /* create source nodes and operators */
    DagNode sourceNodeA = new DagNodeImp();
    Source sourceOpA = new SourceImp(sourceNodeA);
    sourceOpA.setName("A");
    sourceNodeA.setOperator(sourceOpA);

    DagNode sourceNodeB = new DagNodeImp();
    Source sourceOpB = new SourceImp(sourceNodeB);
    sourceOpB.setName("B");
    sourceNodeB.setOperator(sourceOpB);

    DagNode sourceNodeC = new DagNodeImp();
    Source sourceOpC = new SourceImp(sourceNodeC);
    sourceOpC.setName("C");
    sourceNodeC.setOperator(sourceOpC);

    DagNode sourceNodeD = new DagNodeImp();
    Source sourceOpD = new SourceImp(sourceNodeD);
    sourceOpD.setName("D");
    sourceNodeD.setOperator(sourceOpD);

    DagNode sourceNodeE = new DagNodeImp();
    Source sourceOpE = new SourceImp(sourceNodeE);
    sourceOpE.setName("E");
    sourceNodeE.setOperator(sourceOpE);
     
    /** create node and operator BC */
    DagNode nodeBC = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopBC = new WBinaryJoinOperatorImp(nodeBC);
//	wbjoinopBC.setJoinPredicate("Col2", "Col3", BinCOMPExpressionStr.EQ);
    nodeBC.setOperator(wbjoinopBC);

    // connect with stream nodes  
    nodeBC.addChild(sourceNodeB);
    nodeBC.addChild(sourceNodeC);
    sourceNodeB.setParent(nodeBC);
    sourceNodeC.setParent(nodeBC);
    

    // set state schema
    Vector stateBcols = new Vector();
    stateBcols.add("Col2");
    XATQueueSchema stateBSchema = new XATQueueSchema(stateBcols);
    //wbjoinopBC.getLeftState().setSchema(stateBSchema);
    Vector stateCcols = new Vector();
    stateCcols.add("Col3");
    XATQueueSchema stateCSchema = new XATQueueSchema(stateCcols);
    //wbjoinopBC.getRightState().setSchema(stateCSchema);    

    // set output Q
    XATQueue outputQBC = new XATMemoryQueueImp(wbjoinopBC);
    Vector queueBCcols = new Vector();
    queueBCcols.add("Col2");
    queueBCcols.add("Col3");
    XATQueueSchema schemaBC = new XATQueueSchema(queueBCcols);
    outputQBC.setSchema(schemaBC);
    try {
        wbjoinopBC.setOutputQueue(outputQBC);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    /** create node and operator ABC on top of BC */
    DagNode nodeABC = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABC = new WBinaryJoinOperatorImp(nodeABC);
//    wbjoinopABC.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    nodeABC.setOperator(wbjoinopABC);
       
    nodeABC.addChild(sourceNodeA);
    nodeABC.addChild(nodeBC);
    sourceNodeA.setParent(nodeABC);
    nodeBC.setParent(nodeABC);   

    // set state's schema
    Vector stateAcols = new Vector();
    stateAcols.add("Col1");
    XATQueueSchema stateASchema = new XATQueueSchema(stateAcols);
    //wbjoinopABC.getLeftState().setSchema(stateASchema);
    Vector stateBCcols = new Vector();
    stateBCcols.add("Col2");
    stateBCcols.add("Col3");
    XATQueueSchema stateBCSchema = new XATQueueSchema(stateBCcols);
    //wbjoinopABC.getRightState().setSchema(stateBCSchema);

	//set output Q
    XATQueue outputQABC = new XATMemoryQueueImp(wbjoinopABC);
    Vector queueABCcols = new Vector();
    queueABCcols.add("Col1");
    queueABCcols.add("Col2");
    queueABCcols.add("Col3");
    XATQueueSchema schemaABC = new XATQueueSchema(queueABCcols);
    outputQABC.setSchema(schemaABC);
    try {
        wbjoinopABC.setOutputQueue(outputQABC);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    // set input Q, first position reserved for streamQ of A
    //wbjoinopABC.addInputQueue(outputQBC);
    wbjoinopABC.setNthInputQueue(outputQBC, 1);


    /** create node and operator ABCD on top of ABC */
    DagNode nodeABCD = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABCD = new WBinaryJoinOperatorImp(nodeABCD);
//    wbjoinopABCD.setJoinPredicate("Col3", "Col4", BinCOMPExpressionStr.EQ);
    nodeABCD.setOperator(wbjoinopABCD);
    nodeABCD.addChild(nodeABC);
    nodeABCD.addChild(sourceNodeD);
    nodeABC.setParent(nodeABCD);  
    sourceNodeD.setParent(nodeABCD);    
     

    // set state's schema    
    Vector stateABCcols = new Vector();
    stateABCcols.add("Col1");
    stateABCcols.add("Col2");
    stateABCcols.add("Col3");
    XATQueueSchema stateABCSchema = new XATQueueSchema(stateABCcols);
    //wbjoinopABCD.getLeftState().setSchema(stateABCSchema);
    Vector stateDcols = new Vector();
    stateDcols.add("Col4");
    XATQueueSchema stateDSchema = new XATQueueSchema(stateDcols);
    //wbjoinopABCD.getRightState().setSchema(stateDSchema);

	//set output Q
    XATQueue outputQABCD = new XATMemoryQueueImp(wbjoinopABCD);
    Vector queueABCDcols = new Vector();
    queueABCDcols.add("Col1");
    queueABCDcols.add("Col2");
    queueABCDcols.add("Col3");
    queueABCDcols.add("Col4");
    XATQueueSchema schemaABCD = new XATQueueSchema(queueABCDcols);
    outputQABCD.setSchema(schemaABCD);
    try {
        wbjoinopABCD.setOutputQueue(outputQABCD);
        //outputQABCD.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }
    // set input Q
    wbjoinopABCD.addInputQueue(outputQABC);

    /** create node and operator ABCDE on top of ABCD */
    DagNode nodeABCDE = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABCDE = new WBinaryJoinOperatorImp(nodeABCDE);
//    wbjoinopABCDE.setJoinPredicate("Col4", "Col5", BinCOMPExpressionStr.EQ);
    nodeABCDE.setOperator(wbjoinopABCDE);
    nodeABCDE.addChild(nodeABCD);
    nodeABCDE.addChild(sourceNodeE);
    nodeABCD.setParent(nodeABCDE);  
    sourceNodeE.setParent(nodeABCDE);    
     

    // set state's schema    
    Vector stateABCDcols = new Vector();
    stateABCDcols.add("Col1");
    stateABCDcols.add("Col2");
    stateABCDcols.add("Col3");
    stateABCDcols.add("Col4");
    XATQueueSchema stateABCDSchema = new XATQueueSchema(stateABCDcols);
    //wbjoinopABCDE.getLeftState().setSchema(stateABCDSchema);
    Vector stateEcols = new Vector();
    stateEcols.add("Col5");
    XATQueueSchema stateESchema = new XATQueueSchema(stateEcols);
    //wbjoinopABCDE.getRightState().setSchema(stateESchema);

	//set output Q
    XATQueue outputQABCDE = new XATMemoryQueueImp(wbjoinopABCDE);
    Vector queueABCDEcols = new Vector();
    queueABCDEcols.add("Col1");
    queueABCDEcols.add("Col2");
    queueABCDEcols.add("Col3");
    queueABCDEcols.add("Col4");
    queueABCDEcols.add("Col5");
    XATQueueSchema schemaABCDE = new XATQueueSchema(queueABCDEcols);
    outputQABCDE.setSchema(schemaABCDE);
    try {
        wbjoinopABCDE.setOutputQueue(outputQABCDE);
        outputQABCDE.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }
    // set input Q
    wbjoinopABCDE.addInputQueue(outputQABCD);

  
    dag.setRoot(nodeABCDE);
    return dag;
}
/**
 * Insert the method's description here.
 * Creation date: (6/22/2003 5:11:20 AM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag
 */
public XATDag makeOldPlan() {
	return makeOldPlan2();
}
/**
 * Creation date: (4/6/2003 3:08:27 PM)
 * Insert the method's description here.
 *
 * A join B join C
 * Create plan A join B, then AB join C with join predicate on A and C
 *
 *         ABC
 *       AB
 *
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public XATDag makeOldPlan1() {

	System.out.println("1st Old Plan");
    XATDag dag = new XATDagImp();

    DagNode node1 = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinop1 =
        new WBinaryJoinOperatorImp(node1);
    wbjoinop1.setWindowSize(1000);
//    wbjoinop1.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    node1.setOperator(wbjoinop1);

    DagNode sourceNode1 = new DagNodeImp();
    Source sourceOp1 = new SourceImp(sourceNode1);
    sourceOp1.setName("A");
    sourceNode1.setOperator(sourceOp1);
    sourceNode1.setParent(node1);
    node1.addChild(sourceNode1);

    DagNode sourceNode2 = new DagNodeImp();
    Source sourceOp2 = new SourceImp(sourceNode2);
    sourceOp2.setName("B");
    sourceNode2.setOperator(sourceOp2);
    sourceNode2.setParent(node1);
    node1.addChild(sourceNode2);

    XATQueue outputQ1 = new XATMemoryQueueImp(wbjoinop1);
    Vector cols1 = new Vector();
    cols1.add("Col1");
    cols1.add("Col2");

    // set state schema for each join operators

    XATQueueSchema schema1 = new XATQueueSchema(cols1);
    outputQ1.setSchema(schema1);

    try {
        wbjoinop1.setOutputQueue(outputQ1);
        //outputQ1.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop1.setDebug(false);
    //wbjoinop.setDebug(true);

    /** put another window join node on top */
    DagNode node2 = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinop2 =
        new WBinaryJoinOperatorImp(node2);
    wbjoinop2.setWindowSize(1000);
//    wbjoinop2.setJoinPredicate("Col1", "Col3", BinCOMPExpressionStr.EQ);
    node2.setOperator(wbjoinop2);
    node1.setParent(node2);
    node2.addChild(node1);

    DagNode sourceNode3 = new DagNodeImp();
    Source sourceOp3 = new SourceImp(sourceNode3);
    sourceOp3.setName("C");
    sourceNode3.setOperator(sourceOp3);
    sourceNode3.setParent(node2);
    node2.addChild(sourceNode3);

    XATQueue outputQ2 = new XATMemoryQueueImp(wbjoinop2);
    Vector cols2 = new Vector();
    cols2.add("Col1");
    cols2.add("Col2");
    cols2.add("Col3");

    XATQueueSchema schema2 = new XATQueueSchema(cols2);
    outputQ2.setSchema(schema2);

    try {
        wbjoinop2.setOutputQueue(outputQ2);
        outputQ2.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop2.addInputQueue(outputQ1);
    wbjoinop2.setDebug(false);
    //wbjoinop.setDebug(true);

    dag.setRoot(node2);

    return dag;
}
/**
 * Insert the method's description here.
 *
 * A join B join C join D
 * query plan: A join B first, then join with C, then join with D
 *
 *       ABCD
 *     ABC
 *   AB
 *
 * Creation date: (6/18/2003 10:31:33 AM)
 */
public XATDag makeOldPlan2() {

	System.out.println("2nd Old Plan");
    XATDag dag = new XATDagImp();

    /* create source nodes and operators */
    DagNode sourceNodeA = new DagNodeImp();
    Source sourceOpA = new SourceImp(sourceNodeA);
    sourceOpA.setName("A");
    sourceNodeA.setOperator(sourceOpA);

    DagNode sourceNodeB = new DagNodeImp();
    Source sourceOpB = new SourceImp(sourceNodeB);
    sourceOpB.setName("B");
    sourceNodeB.setOperator(sourceOpB);

    DagNode sourceNodeC = new DagNodeImp();
    Source sourceOpC = new SourceImp(sourceNodeC);
    sourceOpC.setName("C");
    sourceNodeC.setOperator(sourceOpC);

    DagNode sourceNodeD = new DagNodeImp();
    Source sourceOpD = new SourceImp(sourceNodeD);
    sourceOpD.setName("D");
    sourceNodeD.setOperator(sourceOpD);
    
    /** create node and operator AB */
    DagNode nodeAB = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopAB = new WBinaryJoinOperatorImp(nodeAB);
//	wbjoinopAB.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    nodeAB.setOperator(wbjoinopAB);

    // connect with stream nodes
    nodeAB.addChild(sourceNodeA);
    nodeAB.addChild(sourceNodeB);
    sourceNodeA.setParent(nodeAB);  
    sourceNodeB.setParent(nodeAB);    

    // set state schema
    Vector stateAcols = new Vector();
    stateAcols.add("Col1");
    XATQueueSchema stateASchema = new XATQueueSchema(stateAcols);
    //wbjoinopAB.getLeftState().setSchema(stateASchema);
    Vector stateBcols = new Vector();
    stateBcols.add("Col2");
    XATQueueSchema stateBSchema = new XATQueueSchema(stateBcols);
    //wbjoinopAB.getRightState().setSchema(stateBSchema);    

    // set output Q
    XATQueue outputQAB = new XATMemoryQueueImp(wbjoinopAB);
    Vector queueABcols = new Vector();
    queueABcols.add("Col1");
    queueABcols.add("Col2");
    XATQueueSchema schemaAB = new XATQueueSchema(queueABcols);
    outputQAB.setSchema(schemaAB);
    try {
        wbjoinopAB.setOutputQueue(outputQAB);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    /** create node and operator ABC on top of AB */
    DagNode nodeABC = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABC = new WBinaryJoinOperatorImp(nodeABC);
//    wbjoinopABC.setJoinPredicate("Col2", "Col3", BinCOMPExpressionStr.EQ);
    nodeABC.setOperator(wbjoinopABC);
    nodeABC.addChild(nodeAB);   
    nodeABC.addChild(sourceNodeC);
    nodeAB.setParent(nodeABC);
    sourceNodeC.setParent(nodeABC);

    // set state's schema
    Vector stateABcols = new Vector();
    stateABcols.add("Col1");
    stateABcols.add("Col2");
    XATQueueSchema stateABSchema = new XATQueueSchema(stateABcols);
    //wbjoinopABC.getLeftState().setSchema(stateABSchema);
    Vector stateCcols = new Vector();
    stateCcols.add("Col3");
    XATQueueSchema stateCSchema = new XATQueueSchema(stateCcols);
    //wbjoinopABC.getRightState().setSchema(stateCSchema);

	//set output Q
    XATQueue outputQABC = new XATMemoryQueueImp(wbjoinopABC);
    Vector queueABCcols = new Vector();
    queueABCcols.add("Col1");
    queueABCcols.add("Col2");
    queueABCcols.add("Col3");
    XATQueueSchema schemaABC = new XATQueueSchema(queueABCcols);
    outputQABC.setSchema(schemaABC);
    try {
        wbjoinopABC.setOutputQueue(outputQABC);
        //outputQBCD.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    // set input Q
    wbjoinopABC.addInputQueue(outputQAB);


    /** create node and operator ABCD on top of ABC */
    DagNode nodeABCD = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABCD = new WBinaryJoinOperatorImp(nodeABCD);
//    wbjoinopABCD.setJoinPredicate("Col3", "Col4", BinCOMPExpressionStr.EQ);
    nodeABCD.setOperator(wbjoinopABCD);
    nodeABCD.addChild(nodeABC);
    nodeABCD.addChild(sourceNodeD);
    nodeABC.setParent(nodeABCD);  
    sourceNodeD.setParent(nodeABCD);       

    // set state's schema
    Vector stateABCcols = new Vector();
    stateABCcols.add("Col1");
    stateABCcols.add("Col2");
    stateABCcols.add("Col3");
    XATQueueSchema stateABCSchema = new XATQueueSchema(stateABCcols);
    //wbjoinopABCD.getLeftState().setSchema(stateABCSchema);
    Vector stateDcols = new Vector();
    stateDcols.add("Col4");
    XATQueueSchema stateDSchema = new XATQueueSchema(stateDcols);
    //wbjoinopABCD.getRightState().setSchema(stateDSchema);

	//set output Q
    XATQueue outputQABCD = new XATMemoryQueueImp(wbjoinopABCD);
    Vector queueABCDcols = new Vector();
    queueABCDcols.add("Col1");
    queueABCDcols.add("Col2");
    queueABCDcols.add("Col3");
    queueABCDcols.add("Col4");
    XATQueueSchema schemaABCD = new XATQueueSchema(queueABCDcols);
    outputQABCD.setSchema(schemaABCD);
    try {
        wbjoinopABCD.setOutputQueue(outputQABCD);
        outputQABCD.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }
    // set input Q
    wbjoinopABCD.addInputQueue(outputQABC);
  
    dag.setRoot(nodeABCD);
    return dag;
}
/**
 * Insert the method's description here.
 * complex query plan with matching state in the middle of the box.
 * test the genericity of moving state strategy
 *
 * A join B join C join D join E
 *
 *        ABCDE
 *     ABC     DE
 *   AB
 *
 * Creation date: (6/18/2003 10:32:03 AM)
 */
public XATDag makeOldPlan3() {

	System.out.println("3nd Old Plan");
	XATDag dag = new XATDagImp();

    /* create source nodes and operators */
    DagNode sourceNodeA = new DagNodeImp();
    Source sourceOpA = new SourceImp(sourceNodeA);
    sourceOpA.setName("A");
    sourceNodeA.setOperator(sourceOpA);

    DagNode sourceNodeB = new DagNodeImp();
    Source sourceOpB = new SourceImp(sourceNodeB);
    sourceOpB.setName("B");
    sourceNodeB.setOperator(sourceOpB);

    DagNode sourceNodeC = new DagNodeImp();
    Source sourceOpC = new SourceImp(sourceNodeC);
    sourceOpC.setName("C");
    sourceNodeC.setOperator(sourceOpC);

    DagNode sourceNodeD = new DagNodeImp();
    Source sourceOpD = new SourceImp(sourceNodeD);
    sourceOpD.setName("D");
    sourceNodeD.setOperator(sourceOpD);

    DagNode sourceNodeE = new DagNodeImp();
    Source sourceOpE = new SourceImp(sourceNodeE);
    sourceOpE.setName("E");
    sourceNodeE.setOperator(sourceOpE);
     
    /** create node and operator AB */
    DagNode nodeAB = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopAB = new WBinaryJoinOperatorImp(nodeAB);
//	wbjoinopAB.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    nodeAB.setOperator(wbjoinopAB);

    // connect with stream nodes
    nodeAB.addChild(sourceNodeA);
    nodeAB.addChild(sourceNodeB);
    sourceNodeA.setParent(nodeAB);  
    sourceNodeB.setParent(nodeAB);    

    // set state schema
    Vector stateAcols = new Vector();
    stateAcols.add("Col1");
    XATQueueSchema stateASchema = new XATQueueSchema(stateAcols);
    //wbjoinopAB.getLeftState().setSchema(stateASchema);
    Vector stateBcols = new Vector();
    stateBcols.add("Col2");
    XATQueueSchema stateBSchema = new XATQueueSchema(stateBcols);
    //wbjoinopAB.getRightState().setSchema(stateBSchema);    

    // set output Q
    XATQueue outputQAB = new XATMemoryQueueImp(wbjoinopAB);
    Vector queueABcols = new Vector();
    queueABcols.add("Col1");
    queueABcols.add("Col2");
    XATQueueSchema schemaAB = new XATQueueSchema(queueABcols);
    outputQAB.setSchema(schemaAB);
    try {
        wbjoinopAB.setOutputQueue(outputQAB);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    /** create node and operator DE */
    DagNode nodeDE = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopDE = new WBinaryJoinOperatorImp(nodeDE);
//	wbjoinopDE.setJoinPredicate("Col4", "Col5", BinCOMPExpressionStr.EQ);
    nodeDE.setOperator(wbjoinopDE);

    // connect with stream nodes
    nodeDE.addChild(sourceNodeD);
    nodeDE.addChild(sourceNodeE);
    sourceNodeD.setParent(nodeDE);  
    sourceNodeE.setParent(nodeDE);    

    // set state schema
    Vector stateDcols = new Vector();
    stateDcols.add("Col4");
    XATQueueSchema stateDSchema = new XATQueueSchema(stateDcols);
    //wbjoinopDE.getLeftState().setSchema(stateDSchema);
    Vector stateEcols = new Vector();
    stateEcols.add("Col5");
    XATQueueSchema stateESchema = new XATQueueSchema(stateEcols);
    //wbjoinopDE.getRightState().setSchema(stateESchema);    

    // set output Q
    XATQueue outputQDE = new XATMemoryQueueImp(wbjoinopDE);
    Vector queueDEcols = new Vector();
    queueDEcols.add("Col4");
    queueDEcols.add("Col5");
    XATQueueSchema schemaDE = new XATQueueSchema(queueDEcols);
    outputQDE.setSchema(schemaDE);
    try {
        wbjoinopDE.setOutputQueue(outputQDE);
    } catch (XATQueueException e) {
        System.out.println(e);
    }
    
    /** create node and operator ABC on top of AB */
    DagNode nodeABC = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABC = new WBinaryJoinOperatorImp(nodeABC);
//    wbjoinopABC.setJoinPredicate("Col2", "Col3", BinCOMPExpressionStr.EQ);
    nodeABC.setOperator(wbjoinopABC);
    nodeABC.addChild(nodeAB);   
    nodeABC.addChild(sourceNodeC);
    nodeAB.setParent(nodeABC);
    sourceNodeC.setParent(nodeABC);

    // set state's schema
    Vector stateABcols = new Vector();
    stateABcols.add("Col1");
    stateABcols.add("Col2");
    XATQueueSchema stateABSchema = new XATQueueSchema(stateABcols);
    //wbjoinopABC.getLeftState().setSchema(stateABSchema);
    Vector stateCcols = new Vector();
    stateCcols.add("Col3");
    XATQueueSchema stateCSchema = new XATQueueSchema(stateCcols);
    //wbjoinopABC.getRightState().setSchema(stateCSchema);

	//set output Q
    XATQueue outputQABC = new XATMemoryQueueImp(wbjoinopABC);
    Vector queueABCcols = new Vector();
    queueABCcols.add("Col1");
    queueABCcols.add("Col2");
    queueABCcols.add("Col3");
    XATQueueSchema schemaABC = new XATQueueSchema(queueABCcols);
    outputQABC.setSchema(schemaABC);
    try {
        wbjoinopABC.setOutputQueue(outputQABC);
        //outputQBCD.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    // set input Q
    wbjoinopABC.addInputQueue(outputQAB);


    /** create node and operator ABCDE on top of ABC and DE*/
    DagNode nodeABCDE = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinopABCDE = new WBinaryJoinOperatorImp(nodeABCDE);
//    wbjoinopABCDE.setJoinPredicate("Col3", "Col4", BinCOMPExpressionStr.EQ);
    nodeABCDE.setOperator(wbjoinopABCDE);
    nodeABCDE.addChild(nodeABC);
    nodeABCDE.addChild(nodeDE);
    nodeABC.setParent(nodeABCDE);  
    nodeDE.setParent(nodeABCDE);       

    // set state's schema
    Vector stateABCcols = new Vector();
    stateABCcols.add("Col1");
    stateABCcols.add("Col2");
    stateABCcols.add("Col3");
    XATQueueSchema stateABCSchema = new XATQueueSchema(stateABCcols);
    //wbjoinopABCDE.getLeftState().setSchema(stateABCSchema);
    Vector stateDEcols = new Vector();
    stateDEcols.add("Col4");
    stateDEcols.add("Col5");
    XATQueueSchema stateDESchema = new XATQueueSchema(stateDEcols);
    //wbjoinopABCDE.getRightState().setSchema(stateDESchema);

	//set output Q
    XATQueue outputQABCDE = new XATMemoryQueueImp(wbjoinopABCDE);
    Vector queueABCDEcols = new Vector();
    queueABCDEcols.add("Col1");
    queueABCDEcols.add("Col2");
    queueABCDEcols.add("Col3");
    queueABCDEcols.add("Col4");
    queueABCDEcols.add("Col5");
    XATQueueSchema schemaABCDE = new XATQueueSchema(queueABCDEcols);
    outputQABCDE.setSchema(schemaABCDE);
    try {
        wbjoinopABCDE.setOutputQueue(outputQABCDE);
        outputQABCDE.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }
    // set input Q
    wbjoinopABCDE.addInputQueue(outputQABC);
    wbjoinopABCDE.addInputQueue(outputQDE);
  
    dag.setRoot(nodeABCDE);
    return dag;
}
/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 12:01:27 AM)
 */
public XATTree makeSingleJoinPlan() {
   
	XATTree tree = new XATTreeImp();

    XATNode node1 = new XATNodeImp();
    WBinaryJoinOperatorImp wbjoinop =
        new WBinaryJoinOperatorImp(node1);
    wbjoinop.setWindowSize(1000);
//    wbjoinop.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    node1.setOperator(wbjoinop);

    DagNode sourceNode1 = new DagNodeImp();
    Source sourceOp1 = new SourceImp(sourceNode1);
    sourceOp1.setName("A");
    sourceNode1.setOperator(sourceOp1);
    sourceNode1.setParent(node1);
    node1.addChild(sourceNode1);

    DagNode sourceNode2 = new DagNodeImp();
    Source sourceOp2 = new SourceImp(sourceNode2);
    sourceOp2.setName("B");
    sourceNode2.setOperator(sourceOp2);
    sourceNode2.setParent(node1);
    node1.addChild(sourceNode2);

    XATQueue outputQ = new XATMemoryQueueImp(wbjoinop);
    Vector cols3 = new Vector();
    cols3.add("Col1");
    cols3.add("Col2");
  
    XATQueueSchema schema3 = new XATQueueSchema(cols3);
    outputQ.setSchema(schema3);

    try {
        wbjoinop.setOutputQueue(outputQ);
        outputQ.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop.setDebug(false);
    //wbjoinop.setDebug(true);
    tree.setRoot(node1);

    return tree;
}
}
