package edu.wpi.cs.dsrg.xmldb.xat.component.migrationcontroller;

//import edu.wpi.cs.dsrg.xmldb.xat.component.migrationexception.*;
//import streamgenerator.*;
import java.util.*;

//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.migrationexception.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;
//import edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client.Stream;

/**
 * Insert the type's description here.
 * Creation date: (4/3/2003 10:35:18 PM)
 * @author: Yali Zhu
 */
public class MigrationController implements Runnable{
	private XATBox oldBox;
	private XATBox newBox;
	//private XATTree tree;
	private XATQueue[] matchInterQs = null;
	private XATStreamOperator[] matchCustomers = null;
	//private XATStreamController streamControl = null;
	//private State[] allOldStates;             // for checking completion of migration
	private XATStreamOperator[] allOldOperators; // for checking completion of migration
	private XATStreamOperator oldBoxRootOperator;
	XATTree tree;
/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 9:03:27 AM)
 */
//public MigrationController(XATTree tree, XATBox oldBox) {
//    super();
//
//    this.tree = tree;
//    //this.dag = XATDagImp.convertTreeToDag(tree);
//    this.oldBox = oldBox;
//	allOldOperators = oldBox.getAllOperators();
//	oldBoxRootOperator = oldBox.getBoxRootOperator();
//}

/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 9:03:27 AM)
 */
public MigrationController(XATTree tree, XATBox oldBox, XATBox newBox) {
    super();

    this.oldBox = oldBox;
    this.newBox = newBox;
    this.tree = tree;
	allOldOperators = oldBox.getAllOperators();
	oldBoxRootOperator = oldBox.getBoxRootOperator();
}
/**
 * Insert the method's description here.
 *
 * Check to see if two boxes are exchangable with each other,
 * which means if they have the same set of inputQs and outputQ.
 *
 * Creation date: (5/21/2003 7:15:29 AM)
 * @return boolean
 * @param b1 migrationcontroller.XATBox
 * @param b2 migrationcontroller.XATBox
 */
//public boolean boxesExchangable(XATBox b1, XATBox b2) {
//
//	/** check if inputQs match */
//	/** check if outputQs match */
//	
//	return false;
//}
/**
 * Insert the method's description here.
 *
 * This method go to each input stream Q and check all first tuple in each queue
 * to get their largest timestamp T.
 * It then process all tuples from each stream Q that has timestamp smaller than T.
 * It does this by processing all leaf operators first, then the level above it, util
 * the root operator is processed.
 *
 * We compute new unmatched states in new box by joining matched states in old box. However,
 * some tuples in unmatched state in old box, although purged from matched states in old box,
 * may still be able to join with some future tuples.
 * 
 * The purpose of this method is to make sure all tuples in unmatched states of old box are no
 * longer needed for any tuples that gets processed after migration setup.
 * 
 * Creation date: (6/1/2003 7:00:57 AM)
 */
public void cleanAccumulatedTuples() {

/*
 * @TODO subtract useful information from unmatched old states, so that we don't need to trace down to the leaf level.
 */
    long latestTimeStamp = 0;
    long firstTimeStamp = 0;

    System.out.println("clean accummulated tuples in old box");
    
    /* first figure out the timestamp that the max timestamp 
     * of all tuples in box input queues should be greater than. 
     */
     
    XATQueue[] inputQs = oldBox.getInputQs();
     
    //long timestamp = 0;
    long maxFirstTimestamp = 0;
    long tempstamp;
    
    for(int i=0; i<inputQs.length; i++) {
    	List customers = inputQs[i].getQueueCustomer();
    	for(int j=0; j<customers.size(); j++) {
    		if(((XATStreamOperator)customers.get(j)).isBoxOperator()) {
    			tempstamp = inputQs[i].peek(customers.get(j)).getMaxTimeStamp();
    			if(tempstamp > maxFirstTimestamp) {
    				maxFirstTimestamp = tempstamp;
    			}
    		}
    	}
    }
    
    XATStreamOperator[] boxoperators = oldBox.getAllOperators();
    boolean done=false;
    while(!done) {
    	done = true;
	    for(int i=boxoperators.length-1; i>=0; i--) {
    		if(boxoperators[i].isOldBoxLeaf()) {
    			if(boxoperators[i].cleanAccumulatedTuples(maxFirstTimestamp))
    				done = false; 
    		}
    		else {
    			if(boxoperators[i].cleanAllAccumulatedTuples()) 
    				done = false;
    		}
	    }
    }
}

/**
 * Insert the method's description here.
 *
 * Used for migration strategy 2: clean up all tuples in intermediate queue before recompute unmatched states.
 *
 * Creation date: (5/25/2003 4:33:08 AM)
 */
private void cleanupBoxInterQueues() throws WrongOperatorTypeException {

    XATStreamOperator[] oldOperators = oldBox.getAllOperators();
    int totalCount = oldOperators.length;
    int finishCount = 0;

    while (finishCount < totalCount) {
        finishCount = 0;
        for (int i = 0; i < totalCount; i++) {
            if (oldOperators[i] instanceof WBinaryJoinOperator) {
                if (((WBinaryJoinOperator) oldOperators[i]).runForMigration1() < 0)
                    finishCount++;
            } else
                throw new WrongOperatorTypeException("Expecting an instance of WBinaryOperator!");

        }
    }
}
/**
 *
 * Insert the method's description here.
 * connect old and new boxes
 * 1) Connects the output queue of those two boxes.
 * 2) Connects input queues of old box to operators in new box. 
 *    We can match the inputQ's schema to operator's state schema 
 *    in order to figure out which queue goes to which operator, and left or right. 
 *
 * Creation date: (4/6/2003 11:53:00 AM)
 */
private void connectNewBox() {

    /** first connects old and new boxes' output q */
    /** At this time it only works for one output Q from a Box.                */
    /** If both box has more than one root (output Q), this code does not work.*/
    XATQueue outputQ = oldBox.getOutputQ();

    XATStreamOperator oldBoxRootOperator = oldBox.getBoxRootOperator();
    XATStreamOperator newBoxRootOperator = newBox.getBoxRootOperator();
    XATNode oldBoxRootNode = (DagNode)oldBoxRootOperator.getNode();
    XATNode newBoxRootNode = (DagNode)newBoxRootOperator.getNode();
    outputQ.addNewOwner(newBoxRootOperator);
    newBoxRootOperator.setOutputQueue(outputQ);

    /** Add new box's root to current dag */
    if (oldBoxRootNode.getParent() == null) {
      	tree.setRoot(newBoxRootNode);
    } else {
        oldBoxRootNode.getParent().addChild(newBoxRootNode);
        newBoxRootNode.setParent(oldBoxRootNode.getParent());
    }

    /** share old box's input Qs with operators in new box */
    XATQueue[] oldInputQs = oldBox.getInputQs();
    XATStreamOperator[] newBoxOperators = newBox.getAllOperators();

    for (int i = 0; i < newBoxOperators.length; i++) {
        Iterator it = newBoxOperators[i].getInputQueues();
        while (it.hasNext()) {
            XATQueue queue = (XATQueue) it.next();
            if (newBox.isBoxInputQ(queue)) {

                for (int j = 0; j < oldInputQs.length; j++) {
                    if (queue.getSchema().equals(oldInputQs[j].getSchema())) {
                        newBoxOperators[i].replaceInputQueue(queue, oldInputQs[j]);
                        break;
                    }
                }
            }
        }
    }

}
/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 9:50:17 AM)
 */
private void disconnectOldBox() {

    /** disconnect inputQs from leaf operators in old box */
    /** and delete all old nodes in old box from current dag */
    XATStreamOperator[] allOldOperators = oldBox.getAllOperators();
    XATQueue[] oldInputQueues = oldBox.getInputQs();
    
    XATQueue queue;
    int size = allOldOperators.length;

    for (int i = 0; i < size; i++) {

        Iterator it = allOldOperators[i].getInputQueues();
        while (it.hasNext()) {
            queue = (XATQueue) it.next();
            if (oldBox.isBoxInputQ(queue))
                queue.unregister(allOldOperators[i]);
        }
        /** delete an old node from dag by disconnect it from all its children */
         DagNode currentNode = (DagNode) allOldOperators[i].getNode();
         if (currentNode.getParent() != null) {
         	currentNode.deleteAllParents();
         }
    }

	/** reset old box input queue to be non-oldBoxInputQueue */
	int inputQCount = oldInputQueues.length;
	for(int i=0; i<inputQCount; i++)
	{
		oldInputQueues[i].setOldBoxInput(false);
	}
    
    XATStreamOperator oldRootOperator = oldBox.getBoxRootOperator();
    DagNode oldRootNode = (DagNode) oldRootOperator.getNode();

    /** if the root of old box is the root of the whole dag, delete it from dag's root list */
    if (oldRootNode.getParent() != null) {
        //dag.deleteRoot(oldRootNode);
    //else {
        /** otherwise delete the old box root node from all its parents */
        Iterator it = oldRootNode.getParents();
        while (it.hasNext()) {
            ((DagNode) it.next()).deleteChild(oldRootNode);
        }
    }
}

/*   WBinaryJoinOperator leaf = (WBinaryJoinOperator) oldleaves[i];
   queueL = leaf.getLeftInputQueue();
   queueR = leaf.getRightInputQueue();

   queueL.setOldBoxInput(false);
   queueR.setOldBoxInput(false);
   queueL.removeOwner(leaf);
   queueR.removeOwner(leaf);
} */

/** delete nodes in oldbox from current Dag */
/*XATNode[] oldNodes = oldBox.getAllNodes();
try {
    for (int i = 0; i < oldNodes.length; i++)
        dag.deleteNode(oldNodes[i]);

} catch (XATTreeNodeHasNoParentException e) {
    System.out.println(e);
} 
}*/
/**
 * Insert the method's description here.
 * Creation date: (6/25/2003 6:39:32 AM)
 */
//private void disconnectOldStates() {
//	/** disconnect old states from old operators in old box */
//    XATStreamOperator[] allOldOperators = oldBox.getAllOperators();
//    int count = allOldOperators.length;
//    for (int i=0; i< count; i++) {
//	    if (allOldOperators[i] instanceof WBinaryJoinOperator) {
//		    WBinaryJoinOperator tempOp = (WBinaryJoinOperator)allOldOperators[i];
//		    tempOp.getLeftState().getStateQueue().unregister(tempOp);
//		    tempOp.getRightState().getStateQueue().unregister(tempOp);
//	    }
//    }   
//    
//    /** now set all existing states to be unmatched */
//	XATStreamOperator[] allNewOperators = newBox.getAllOperators();
//	count = allNewOperators.length;
//	for (int i=0; i< count; i++) {
//		if (allNewOperators[i] instanceof WBinaryJoinOperator) {
//			WBinaryJoinOperator tempOp = (WBinaryJoinOperator)allNewOperators[i];
//			tempOp.getLeftState().setMatched(false);
//			tempOp.getRightState().setMatched(false);
//		}
//	}   
//}
    
    
    
/**
 * Insert the method's description here.
 *
 * Before run this method, the scheduler and exec controller must be halted.
 * And after this method, the setTree method in pushtuplethrough scheduler must be called again
 * to reset the tree.
 *
 * Creation date: (4/6/2003 9:43:14 AM)
 */
public void finishMigration1() {
    disconnectOldBox();
    XATStreamOperator rootOp = newBox.getBoxRootOperator();
    if (rootOp instanceof WBinaryJoinOperator)
         ((WBinaryJoinOperator) rootOp).enqueueKeptTuples();
}
/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 9:43:28 AM)
 */
public void finishMigration2() {}
/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 5:59:03 AM)
 * @param state1 queryplanelements.WState
 * @param state2 queryplanelements.WState
 */
//public ArrayList joinStates(
//    WFIFOState lstate,
//    WFIFOState rstate,
//    WBinaryJoinOperator operator) {
//
//    /* join both states' tuples that within timewindow from each other */
//    ArrayList newTuples = new ArrayList();
//
//    XATQueue queue1 = lstate.getStateQueue();
//    XATQueue queue2 = rstate.getStateQueue();
//    int size1 = queue1.getQueueSize(operator);
//    int size2 = queue2.getQueueSize(operator);
//
//    XATTuple[] tuples1 = queue1.peek(size1, operator);
//    XATTuple[] tuples2 = queue2.peek(size2, operator);
//
//    for (int i = 0; i < size1; i++)
//        for (int j = 0; j < size2; j++)
//            if (operator.joinable(tuples1[i], tuples2[j])) {
//                int lPos = operator.getLPos();
//                int rPos = operator.getRPos();
//                if (operator.evalJoinPredicate(tuples1[i], lPos, tuples2[j], rPos))
//                    newTuples.add(
//                        operator.join(tuples1[i], tuples2[j]));
//            }
//    return newTuples;
//}
/**
 * Insert the method's description here.
 * mark operator in old box to be old
 * mark the box root operator
 * mark the box leaf operator
 * Creation date: (4/6/2003 11:59:16 AM)
 */
private void markOldBox() {

    int i, size;

    /** set all operators in old box as old operator */
    XATStreamOperator[] allOperators = oldBox.getAllOperators();

    size = allOperators.length;
    for (i = 0; i < size; i++) {
        if (allOperators[i] instanceof WBinaryJoinOperator)
             ((WBinaryJoinOperator) allOperators[i]).setAsOldOperator();
    }

    /** set box root operator in old box as boxRootOperator */
    XATStreamOperator rootOperator = oldBox.getBoxRootOperator();
    if (rootOperator instanceof WBinaryJoinOperator) {
        ((WBinaryJoinOperator) rootOperator).setAsOldBoxRoot();
        ((WBinaryJoinOperator) rootOperator).setOldBoxOperators(allOldOperators);
    }

    /** set all leaf operators in old box as box leaf */
    XATStreamOperator[] leafOperators = oldBox.getBoxLeafOperators();
    size = leafOperators.length;
    for (i = 0; i < size; i++) {
        if (leafOperators[i] instanceof WBinaryJoinOperator)
             ((WBinaryJoinOperator) leafOperators[i]).setAsOldBoxLeaf();
    }

    /** set all box input Qs as boxInputQ */
    XATQueue[] inputQs = oldBox.getInputQs();
    size = inputQs.length;
    for (i = 0; i < size; i++) {
        inputQs[i].setOldBoxInput(true);
    }
}
/**
 * Insert the method's description here.
 * Creation date: (6/2/2003 10:41:47 AM)
 */
private void matchOldInterQWithOldCustomer() {

    ArrayList matchQueueList = new ArrayList();
    ArrayList matchCustomerList = new ArrayList();

    int operatorcount = allOldOperators.length;
    for (int i = 0; i < operatorcount; i++) {

        Iterator it = allOldOperators[i].getInputQueues();
        while (it.hasNext()) {
            XATQueue queue = (XATQueue) it.next();
            if (!oldBox.isBoxInputQ(queue)) {
                matchQueueList.add(queue);
                matchCustomerList.add(allOldOperators[i]);
            }
        }
    }

    matchInterQs = (XATQueue[])matchQueueList.toArray(new XATQueue[] {});
    matchCustomers = (XATStreamOperator[])matchCustomerList.toArray(new XATStreamOperator[] {});
}
/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 4:19:09 AM)
 */
private void matchStates() {

    //WOperatorState[] oldStates = oldBox.getAllStates();
    //WOperatorState[] newStates = newBox.getAllStates();

	XATStreamOperator[] oldoperators = oldBox.getAllOperators();
	XATStreamOperator[] newoperators = newBox.getAllOperators();
	
    /** go through two state lists and match all states that have the same schema (ID) */
    int oldsize = oldoperators.length;
    int newsize = newoperators.length;

    for (int i = 0; i < oldsize; i++) {
        for (int j = 0; j < newsize; j++) {
        	oldoperators[i].matchStates(newoperators[j]);
        }
    }

 
}

/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 4:53:12 AM)
 * @param operator edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
 * @param state queryplanelements.WState
 */
public void recomputeState(XATStreamOperator operator) {

	/** for unmatched states, re-compute them recursively (go to its children)        */
	/** recompute each new state recursively from its children's states          */
	boolean isdone = false;
	XATStreamOperator[] newoperators = newBox.getAllOperators();
	int newsize = newoperators.length;

	while (!isdone) {
		isdone = true;

		for (int i = newsize - 1; i >= 0; i--) {
			if (newoperators[i].hasUnmatchedState()) {
				if (newoperators[i].recomputeUnmatchedState() == false)
					isdone = false;
			}
		}
	}
}

/**
 * This method replaceOldBoxByNewBox is the temp solution for 
 * moving state migration for Trees instead of DAG structure.
 * Since each tree can only have one root, and each node
 * can only have one parent, migration controller can not plug in 
 * the new box and later disconnect the old box. Instead, is has to
 * replace the old box by the new box right away, so that no node
 * will have multiple parents at any time during the migration.
 */
public void replaceOldBoxByNewBox() {
	/** first connects old and new boxes' output q */
	/** At this time it only works for one output Q from a Box.                */
	/** If both box has more than one root (output Q), this code does not work.*/
	XATQueue outputQ = oldBox.getOutputQ();

	XATStreamOperator oldBoxRootOperator = oldBox.getBoxRootOperator();
	XATStreamOperator newBoxRootOperator = newBox.getBoxRootOperator();
	XATNode oldBoxRootNode = oldBoxRootOperator.getNode();
	XATNode newBoxRootNode = newBoxRootOperator.getNode();
	outputQ.addNewOwner(newBoxRootOperator);
	outputQ.removeOwner(oldBoxRootOperator);
	newBoxRootOperator.setOutputQueue(outputQ);

	/** replace tree's current root (which is the old box's root) by the new box's root. */
	if (oldBoxRootNode.getParent() == null) {
		tree.setRoot(newBoxRootNode);
	} else {
		int position = oldBoxRootNode.getParent().getIndexOf(oldBoxRootNode); 
		oldBoxRootNode.getParent().setChild(position, newBoxRootNode);
		newBoxRootNode.setParent(oldBoxRootNode.getParent());
	}

	/** share old box's input Qs with operators in new box */
	//XATStreamOperator[] oldLeafOperators = oldBox.getBoxLeafOperators();
	XATQueue[] oldInputQs = oldBox.getInputQs();
	XATStreamOperator[] newLeafOperators = newBox.getBoxLeafOperators();

	for (int i = 0; i < newLeafOperators.length; i++) {
		Iterator it = newLeafOperators[i].getInputQueues();
		while (it.hasNext()) {
			XATQueue queue = (XATQueue) it.next();
			if (newBox.isBoxInputQ(queue)) {
				for (int j = 0; j < oldInputQs.length; j++) {
					if (queue.getSchema().getColNames().equals(oldInputQs[j].getSchema().getColNames())) {
						newLeafOperators[i].replaceInputQueue(queue, oldInputQs[j]);
						break;
					}
				}
			}
		}
	}
	
	/** disconnect inputQs from leaf operators in old box */
	/** and delete all old nodes in old box from current dag */
	XATStreamOperator[] allOldOperators = oldBox.getAllOperators();
	XATQueue queue;
	int size = allOldOperators.length;
	for (int i = 0; i < size; i++) {
		Iterator it = allOldOperators[i].getInputQueues();
		while (it.hasNext()) {
			queue = (XATQueue) it.next();
			//if (oldBox.isBoxInputQ(queue))
			queue.unregister(allOldOperators[i]);
			Object owner = queue.getQueueOwner().get(0);
			if(owner instanceof XATStreamOperator) {
				allOldOperators[i].getNode().deleteChild(((XATStreamOperator)owner).getNode());
			}
		}
	}
}

/**
 * Insert the method's description here.
 * Monitor if the migration is done: this is indicated by if in the last operator,
 *
 * numOfChildren == numOfChildrenDone.
 *
 * If this happens, the migration monitor should disconnect the old box from the query plan, including:
 * 1) disconnect input queues
 * 2) disconnect output queue
 * 3) terminate the migration thread.
 * Creation date: (4/22/2003 4:49:47 AM)
 */
public void run() {

    int index = 0;
    boolean isDone = false;

    try {
        int oldOperatorCount = allOldOperators.length;
        System.out.println(" Monitor parallel migration to be over. ");
        /** wait until all old tuples are out of old box */
        while (!isDone) {
            Thread.sleep(500);
            //System.out.println("\n Check if migration is over " + index + "\n");
            //index++;
            isDone = true;
            for (int i = 0; i < oldOperatorCount; i++) {
                if (!((WBinaryJoinOperator) allOldOperators[i]).getAllOldPurgedFlag()) {
                    isDone = false;
                    break;
                }
            }
        }
    } catch (InterruptedException e) {
        System.out.println(e);
        System.out.println("*** Migration monitor interrupted ***");
    }

    //System.out.println("\n\n\n Migration is done! \n\n\n");
    return;
}
/**
 * Insert the method's description here.
 * Creation date: (6/2/2003 12:45:46 AM)
 * @param newBox queryplanelements.XATBox
 */
public void setNewBox(XATBox newBox) {
    this.newBox = newBox;
}
/**
 * Insert the method's description here.
 * This method will do the following:
 *
 * 1. connect old and new query plan boxes
 * 2. mark all operators in old plan
 * 3. mark the last operator in old plan
 * 4. get the currentSystemTime, and record it in all old operators as migrationStartTime
 *
 * Creation date: (4/3/2003 10:40:39 PM)
 */
public void setupPTMigration() {

    markOldBox();
	/* for method 2 of migration 1 */
    XATStreamOperator newRoot = newBox.getBoxRootOperator();
    if (newRoot instanceof WBinaryJoinOperator)
         ((WBinaryJoinOperator) newRoot).setAsNewBoxRoot();

    //matchOldInterQWithOldCustomer();
    /*try {
        cleanupBoxInterQueues();
    } catch (WrongOperatorTypeException e) {
        System.out.println(e);
        return;
    }*/
    //System.out.println("connecting new Boxes");
    connectNewBox();
    //System.out.println("Done set up migration 1");
}
/**
 * Insert the method's description here.
 * Creation date: (4/3/2003 10:40:39 PM)
 */
public void setupMSMigration() {

	cleanAccumulatedTuples();
	//markOldBox();
    //connectNewBox();
    matchStates();
    //disconnectOldStates();
    replaceOldBoxByNewBox();
    //disconnectOldBox();
}
}
