package edu.wpi.cs.dsrg.xmldb.xat.component.migrationexperiments;

//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.migrationcontroller.*;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WOperatorState;
/**
 * Insert the type's description here.
 * Creation date: (3/27/2003 8:15:49 PM)
 * @author: Yali Zhu
 */
public class TestMigration extends XATPropertiesImp{
	//private queryplanelements.UtilityOperator utilityOp;
/**
 * TestMigration constructor comment.
 */
public TestMigration() {
	super();
}
/**
 * Starts the application.
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) {

    try {
        ConfigFileParser config = new ConfigFileParser(args[0]);

        /** first set up the system properties */
        for (Iterator i = config.getSystemProperties(); i.hasNext();) {
            NameValuePair pair = (NameValuePair) i.next();
            System.setProperty(pair.getName(), pair.getValue());
        }

        System.out.println("gets here! 1");
        TestMigration tm1 = new TestMigration();
        //tm1.newTestWithoutMigration(config);
        //tm1.newTestWithMigration(config);
		tm1.testSingleStreamJoin(config);
        
        /*try {
            tm1.testStaticMigration(config);
        } catch (Exception e) {
            System.out.println(e);
        }*/
    } catch (Exception e) {
        System.out.println(e);
    }

    return;
}
/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 3:08:51 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
private XATDag makeNewQueryPlan() {
    XATDag dag = new XATDagImp();

    DagNode node1 = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinop1 =
        new WBinaryJoinOperatorImp(node1);

    // set state's schema
    Vector statecols1 = new Vector();
    statecols1.add("Col1");
    XATQueueSchema stateSchema1 = new XATQueueSchema(statecols1);
    ((WOperatorState)wbjoinop1.getLeftState()).setSchema(stateSchema1);

    Vector statecols2 = new Vector();
    statecols2.add("Col3");
    XATQueueSchema stateSchema2 = new XATQueueSchema(statecols2);
	((WOperatorState)wbjoinop1.getRightState()).setSchema(stateSchema2);

    wbjoinop1.setWindowSize(1000);
//    wbjoinop1.setJoinPredicate("Col1", "Col3", BinCOMPExpressionStr.EQ);
    node1.setOperator(wbjoinop1);

    DagNode sourceNode1 = new DagNodeImp();
    Source sourceOp1 = new SourceImp(sourceNode1);
    sourceOp1.setName("A");
    sourceNode1.setOperator(sourceOp1);
    sourceNode1.setParent(node1);
    node1.addChild(sourceNode1);

    DagNode sourceNode2 = new DagNodeImp();
    Source sourceOp2 = new SourceImp(sourceNode2);
    sourceOp2.setName("C");
    sourceNode2.setOperator(sourceOp2);
    sourceNode2.setParent(node1);
    node1.addChild(sourceNode2);

    XATQueue outputQ1 = new XATMemoryQueueImp(wbjoinop1);
    Vector cols1 = new Vector();
    cols1.add("Col1");
    cols1.add("Col3");

    XATQueueSchema schema1 = new XATQueueSchema(cols1);
    outputQ1.setSchema(schema1);

    try {
        wbjoinop1.setOutputQueue(outputQ1);
        outputQ1.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop1.setDebug(false);
    //wbjoinop.setDebug(true);

    /** put another window join node on top */
    DagNode node2 = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinop2 =
        new WBinaryJoinOperatorImp(node2);
    wbjoinop2.setWindowSize(1000);
//    wbjoinop2.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    node2.setOperator(wbjoinop2);
    node1.setParent(node2);
    node2.addChild(node1);

    // set state's schema
    Vector statecols3 = new Vector();
    statecols3.add("Col1");
    statecols3.add("Col3");
    XATQueueSchema stateSchema3 = new XATQueueSchema(statecols3);
	((WOperatorState)wbjoinop2.getLeftState()).setSchema(stateSchema3);

    Vector statecols4 = new Vector();
    statecols4.add("Col2");
    XATQueueSchema stateSchema4 = new XATQueueSchema(statecols4);
	((WOperatorState)wbjoinop2.getRightState()).setSchema(stateSchema4);

    DagNode sourceNode3 = new DagNodeImp();
    Source sourceOp3 = new SourceImp(sourceNode3);
    sourceOp3.setName("B");
    sourceNode3.setOperator(sourceOp3);
    sourceNode3.setParent(node2);
    node2.addChild(sourceNode3);

    XATQueue outputQ2 = new XATMemoryQueueImp(wbjoinop2);
    Vector cols2 = new Vector();
    cols2.add("Col1");
    cols2.add("Col3");
    cols2.add("Col2");

    XATQueueSchema schema2 = new XATQueueSchema(cols2);
    outputQ2.setSchema(schema2);

    try {
        wbjoinop2.setOutputQueue(outputQ2);
        outputQ2.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop2.addInputQueue(outputQ1);
    wbjoinop2.setDebug(false);
    //wbjoinop.setDebug(true);

    dag.setRoot(node2);

    return dag;
}
/**
 * Insert the method's description here.
 * Creation date: (4/6/2003 3:08:27 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
private XATDag makeOldQueryPlan() {

    XATDag dag = new XATDagImp();

    DagNode node1 = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinop1 =
        new WBinaryJoinOperatorImp(node1);
    wbjoinop1.setWindowSize(1000);
//    wbjoinop1.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    node1.setOperator(wbjoinop1);

    DagNode sourceNode1 = new DagNodeImp();
    Source sourceOp1 = new SourceImp(sourceNode1);
    sourceOp1.setName("A");
    sourceNode1.setOperator(sourceOp1);
    sourceNode1.setParent(node1);
    node1.addChild(sourceNode1);

    DagNode sourceNode2 = new DagNodeImp();
    Source sourceOp2 = new SourceImp(sourceNode2);
    sourceOp2.setName("B");
    sourceNode2.setOperator(sourceOp2);
    sourceNode2.setParent(node1);
    node1.addChild(sourceNode2);

    XATQueue outputQ1 = new XATMemoryQueueImp(wbjoinop1);
    Vector cols1 = new Vector();
    cols1.add("Col1");
    cols1.add("Col2");

    // set state schema for each join operators

    XATQueueSchema schema1 = new XATQueueSchema(cols1);
    outputQ1.setSchema(schema1);

    try {
        wbjoinop1.setOutputQueue(outputQ1);
        outputQ1.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop1.setDebug(false);
    //wbjoinop.setDebug(true);

    /** put another window join node on top */
    DagNode node2 = new DagNodeImp();
    WBinaryJoinOperatorImp wbjoinop2 =
        new WBinaryJoinOperatorImp(node2);
    wbjoinop2.setWindowSize(1000);
//    wbjoinop2.setJoinPredicate("Col1", "Col3", BinCOMPExpressionStr.EQ);
    node2.setOperator(wbjoinop2);
	node1.setParent(node2);
	node2.addChild(node1);
	
    DagNode sourceNode3 = new DagNodeImp();
    Source sourceOp3 = new SourceImp(sourceNode3);
    sourceOp3.setName("C");
    sourceNode3.setOperator(sourceOp3);
    sourceNode3.setParent(node2);
    node2.addChild(sourceNode3);

    XATQueue outputQ2 = new XATMemoryQueueImp(wbjoinop2);
    Vector cols2 = new Vector();
    cols2.add("Col1");
    cols2.add("Col2");
    cols2.add("Col3");

    XATQueueSchema schema2 = new XATQueueSchema(cols2);
    outputQ2.setSchema(schema2);

    try {
        wbjoinop2.setOutputQueue(outputQ2);
        outputQ2.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    wbjoinop2.addInputQueue(outputQ1);
    wbjoinop2.setDebug(false);
    //wbjoinop.setDebug(true);

    dag.setRoot(node2);

    return dag;
}
	/**
    * called by the constructor.  this will set the default properties
    * that the ALL query objects will support. Each subclass should override
    * this method and add their own unique properties, but should also call
    * super.setDefaultProperties() so that the common properties may be set.
    */   
	protected void setDefaultProperties(){
		addProperty("TIMES_TO_RUN", "5");
		addProperty("PRINT_OUT_META_INFORMATION", "false");
		
		
		}

/**
 * Insert the method's description here.
 * Creation date: (4/21/2003 8:59:09 AM)
 * @param arg java.lang.String
 */
public void newTestWithMigration(ConfigFileParser config) {

    try {

        //System.out.println("Config file is " + arg);

        /** create dag, configFileParse, streamController and execController */
        XATDag oldDag = makeOldQueryPlan();
        //ConfigFileParser config = new ConfigFileParser(arg);

//        XATStreamController streamControl =
//            XATStreamControllerImp.getStreamController();
//        streamControl.setConfigFileParser(config);
//        streamControl.setSystemThread(Thread.currentThread());
//        streamControl.init();
//        streamControl.setQueryTree(oldDag);
//        streamControl.connectStreamsWithTree();
//        streamControl.setYieldRate(0.5);
        //streamControl.setDebug(true);

        ExecController exec = new ExecController(oldDag);
        exec.setProperty("DEQUEUE_FACTOR", "0.1");
        exec.setProperty("YIELD_RATE", "0.8");
        exec.setProperty("GLOBAL_TIME_WINDOW", "1000");
        //exec.setProperty("DEBUG", "true");

        /** Start running streams and execController for a while */
//        Thread streamT = new Thread(streamControl);
//        streamT.setName("Stream Thread");
        Thread execT = new Thread(exec);
        execT.setName("Exec Thread");
        System.out.println(
            "\n\n\n**************** Start stream Thread 1 ********************\n\n\n");
//        streamT.start();
        Thread.sleep(1000);
        System.out.println(
            "\n\n\n**************** Start Exec Thread 1 ********************\n\n\n");
        execT.start();

        /** After a while, pause execController thread to connect new box */
        Thread.sleep(10000);
        System.out.println(
            "\n\n\n**************** Suspend Exec Thread 1 ********************\n\n\n");
        execT.suspend();

        /** Setup new query plan and migration controller */
        XATBox oldBox = new XATBox((DagNode)oldDag.getRoot(), oldDag);
        XATDag newDag = makeNewQueryPlan();
        XATBox newBox = new XATBox((DagNode)newDag.getRoot(), newDag);
        
        MigrationController mcontrol = new MigrationController(oldDag, oldBox, newBox);
        mcontrol.setupPTMigration();

        //XATDag combinedDag = mcontrol.getDag();
        XATStreamOperator[] oldOperators = oldBox.getAllOperators();
        XATStreamOperator[] oldRootOperators = new XATStreamOperator[1];
        oldRootOperators[1] = oldBox.getBoxRootOperator();
        
        XATStreamOperator[] newOperators = newBox.getAllOperators();
        XATStreamOperator[] newRootOperators = new XATStreamOperator[1];
        newRootOperators[1] = newBox.getBoxRootOperator();

        /**  Restart execController thread.
         * Meanwhile, migration control monitors old box and disconnect it as needed */
        System.out.println(
            "\n\n\n**************** ReStart exec Thread 2 ********************\n\n\n");
        //exec.reset(combinedDag);
        exec.addOperatorsToRun(newOperators, newRootOperators);
        execT.resume();
        mcontrol.run();
        System.out.println("\n\n\n************ Migration finished **************\n\n\n");

        /** stop execController thread again to disconnect old box */
        execT.suspend();
        mcontrol.finishMigration1();
        System.out.println("\n\n\n************* ReStart stream thread with new query plan only *************\n\n\n");
       
        exec.removeOperatorsToRun(oldOperators, oldRootOperators);
        execT.resume();

//        while (streamT.isAlive() || execT.isAlive())
            Thread.sleep(1000);

        /** clean up the garbage after the first running */
        Runtime.getRuntime().gc();
    } catch (Exception e) {
        System.out.println(e);
    }

}

/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 2:07:30 PM)
 */
public void newTestWithoutMigration(ConfigFileParser config) {
    try {
        //TestMigration tm = new TestMigration();
        //ManualQueryPlanGenerator plangenerator = new ManualQueryPlanGenerator();
        //XATTree tree = plangenerator.makeQueryPlan();
        //XATTree tree = makeOldQueryPlan();
        XATDag dag = makeNewQueryPlan();

        //ConfigFileParser config = new ConfigFileParser(arg);
//        XATStreamController streamControl =
//            XATStreamControllerImp.getStreamController();
//        streamControl.setConfigFileParser(config);
//        streamControl.setSystemThread(Thread.currentThread());
//        streamControl.init();
//        streamControl.setQueryTree(dag);
//        streamControl.connectStreamsWithTree();
//        streamControl.setYieldRate(0.5);
        //streamControl.setDebug(true);

        ExecController exec = new ExecController(dag);
        exec.setProperty("DEQUEUE_FACTOR", "0.1");
        exec.setProperty("YIELD_RATE", "0.8");
        exec.setProperty("GLOBAL_TIME_WINDOW", "1000");
        //exec.setProperty("DEBUG", "true");

        int howMany = 1;
        for (int i = 0; i < howMany; i++) {
//            Thread streamT = new Thread(streamControl);
//            streamT.setName("Stream Thread");
            Thread execT = new Thread(exec);
            execT.setName("Exec Thread");
            System.out.println(
                "\n\n\n**************** Start stream Thread 1 ********************\n\n\n");
//            streamT.start();
            Thread.sleep(1000);
            System.out.println(
                "\n\n\n**************** Start Exec Thread 1 ********************\n\n\n");
            execT.start();

//            while (streamT.isAlive() || execT.isAlive())
                Thread.sleep(2000);

            /** reset the statistics gatherer */
            //StatisticsGatherer.getStatisticsGather().reset();
            /** clean up the garbage after the first running */
            Runtime.getRuntime().gc();

        }
    } catch (Exception e) {
        System.out.println(e.toString());
    }
}

/**
 * Insert the method's description here.
 * Creation date: (3/21/2003 3:05:19 PM)
 */
public void testSingleStreamJoin(ConfigFileParser config) {

    int counter = Integer.parseInt(this.getProperty("TIMES_TO_RUN"));
    for (int i = 0; i < counter; i++) {
        System.out.println("\n\n\nRun Test " + i);
        XATDag dag = new XATDagImp();

        DagNode node1 = new DagNodeImp();
        WBinaryJoinOperatorImp wbjoinop =
            new WBinaryJoinOperatorImp(node1);
        //wbjoinop.setWindwoSize(1000);
//        wbjoinop.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
        node1.setOperator(wbjoinop);

        DagNode sourceNode1 = new DagNodeImp();
        Source sourceOp1 = new SourceImp(sourceNode1);
        sourceOp1.setName("A");
        sourceNode1.setOperator(sourceOp1);
        sourceNode1.setParent(node1);
        node1.addChild(sourceNode1);

        DagNode sourceNode2 = new DagNodeImp();
        Source sourceOp2 = new SourceImp(sourceNode2);
        sourceOp2.setName("B");
        sourceNode2.setOperator(sourceOp2);
        sourceNode2.setParent(node1);
        node1.addChild(sourceNode2);

        XATQueue outputQ = new XATMemoryQueueImp(wbjoinop);
        Vector cols3 = new Vector();
        cols3.add("Col1");
        cols3.add("Col2");
        XATQueueSchema schema3 = new XATQueueSchema(cols3);
        outputQ.setSchema(schema3);

        wbjoinop.setOutputQueue(outputQ);
        outputQ.register(this);
        dag.setRoot(node1);

        /** init streams */
        try {
//            XATStreamController streamControl =
//                XATStreamControllerImp.getStreamController();
//            streamControl.setConfigFileParser(config);
//            streamControl.setSystemThread(Thread.currentThread());
//            streamControl.init();
//            streamControl.initReductionFactors();
//            streamControl.setQueryTree(dag);
//            streamControl.connectStreamsWithTree();
//            streamControl.setYieldRate(0.1);
            //streamControl.setDebug(true);

            ExecController exec = new ExecController(dag);
            exec.setProperty("DEQUEUE_FACTOR", "0.1");
            exec.setProperty("YIELD_RATE", "0.8");
            exec.setProperty("GLOBAL_TIME_WINDOW", "5000");
            //exec.setProperty("DEBUG", "true");

//            Thread streamT = new Thread(streamControl);
//            streamT.setName("Stream Thread");
//            exec.setStreamThread(streamT);
            Thread execT = new Thread(exec);
            execT.setName("Exec Thread");
            System.out.println(
                "**************** Start stream Thread 1 ********************");
//            streamT.start();
            System.out.println("**************** Start Exec Thread 1 ********************");
            execT.start();

//            while (streamT.isAlive() || execT.isAlive())
                Thread.sleep(2000);

            int howmany = wbjoinop.getOutputQueue().getQueueSize(this);
            /*for (int i = 0; i < howmany; i++) {
                try {
                    XATStreamTuple tuple =
                        (XATStreamTuple) (wbjoinop.getOutputQueue().dequeue(this));
                    System.out.println(tuple.toString());
                } catch (XATQueueException e) {
                    System.out.println(e);
                    return;
                }
            }*/
            System.out.println("Number of joined tuples is " + howmany);

            /** reset the statistics gatherer */
            //StatisticsGatherer.getStatisticsGather().reset();
            /** clean up the garbage after the first running */

            Runtime.getRuntime().gc();

        } catch (InterruptedException e) {
            System.out.println(e);
        } catch (XATQueueException e) {
            System.out.println(e);
        } catch (Exception e) {
            System.out.println(e);
        }
    }
    return;
}

/**
 * Insert the method's description here.
 * Creation date: (4/15/2003 2:15:50 AM)
 */
public void testStaticMigration(ConfigFileParser config) throws Exception {

    XATDag oldDag = makeOldQueryPlan();
    XATDag newDag = makeNewQueryPlan();

    //ConfigFileParser config = new ConfigFileParser(arg);
//    XATStreamController streamControl =
//        XATStreamControllerImp.getStreamController();
//    streamControl.setConfigFileParser(config);
//    streamControl.setSystemThread(Thread.currentThread());
//    streamControl.init();
//    streamControl.setQueryTree(oldDag);
//    streamControl.connectStreamsWithTree();
//    streamControl.setYieldRate(0.5);
//    streamControl.setDebug(true);

    XATBox oldBox = new XATBox((DagNode) oldDag.getRoot(), oldDag);
    XATBox newBox = new XATBox((DagNode) newDag.getRoot(), newDag);

    MigrationController mcontrol = new MigrationController(oldDag, oldBox, newBox);
    mcontrol.setupPTMigration();
    
    //XATDag combinedDag = mcontrol.getDag();
//    DagNode[] oldNodes = oldDag.convertToDagArray();
//    DagNode[] newNodes = newDag.convertToDagArray();
//    int size1 = oldNodes.length;
//    int size2 = newNodes.length;
//    XATNode[] nodes = new XATNode[size1 + size2];
//    for (int i = 0; i < size1; i++)
//        nodes[i] = oldNodes[i];
//    for (int i = size1; i < size1 + size2; i++)
//        nodes[i] = newNodes[i];
//
//    int nodecount = nodes.length;
//    WBinaryJoinOperator[] operators = new WBinaryJoinOperator[nodecount];
//
//    for (int i = 0; i < nodecount; i++) {
//        operators[i] = (WBinaryJoinOperator) nodes[i].getOperator();
//    }

    //scheduler.setTree(combinedDag);

    /*while (mcontrol.run() != 0) {
        //migration not finished
        streamControl.run();
        for (int i = 0; i < nodecount; i++)
            operators[i].run();

    } */

    mcontrol.finishMigration1();
    //XATDag afterDag = mcontrol.getDag();
//    while (true) {
//        streamControl.run();
//        for (int i = 0; i < nodecount; i++)
//            operators[i].run();
//    }
}
}
