package edu.wpi.cs.dsrg.xmldb.xat.component.migrationexperiments;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
//import java.io.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.migrationcontroller.*;
//import edu.wpi.cs.dsrg.xmldb.xat.component.scheduler.*;
//import edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.*;
//import streamgenerator.*;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
/**
 * Insert the type's description here.
 * Creation date: (3/27/2003 8:15:49 PM)
 * @author: Yali Zhu
 */
public class TestMigration1 extends XATPropertiesImp{
	//private queryplanelements.UtilityOperator utilityOp;
/**
 * TestMigration constructor comment.
 */
public TestMigration1() {
	super();
	setDefaultProperties();
}
/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 11:07:30 AM)
 * @param dag edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag
 */
public void initOperatorsInDag(XATDag dag) {
    XATNode[] nodes = dag.convertToArray();
    int nodeCount = nodes.length;
    XATOperator operator;

    /** if it's a window binary join operator, initialize it based on join predicate */
    for (int i = 0; i < nodeCount; i++) {
        operator = nodes[i].getOperator();
        if (operator instanceof WBinaryJoinOperator) {
             ((WBinaryJoinOperator) operator).init();
             ((WBinaryJoinOperator) operator).setWindowSize(Long.parseLong(this.getProperty("GLOBAL_TIME_WINDOW")));
        }
    }
    return;
}
/**
 * Starts the application.
 * @param args an array of command-line arguments
 *
 * args[0]: config file 
 * args[1]: n -- window size
 * args[2]: 0 -- without migration
 *          1 -- with migration 1
 * 			2 -- with migration 2
 *          3 -- single window join operator
 *
 */
public static void main(java.lang.String[] args) {

    try {
	    /** clean up garbage before running */
        Runtime.getRuntime().gc();
	    
        ConfigFileParser config = new ConfigFileParser(args[0]);

        /** first set up the system properties */
        for (Iterator i = config.getSystemProperties(); i.hasNext();) {
            NameValuePair pair = (NameValuePair) i.next();
            System.setProperty(pair.getName(), pair.getValue());
        }

        /** init global_time_window */
        TestMigration1 tm1 = new TestMigration1();
        tm1.setProperty("GLOBAL_TIME_WINDOW", "" + args[1]);

        int flag = Integer.parseInt(args[2]);
        switch (flag) {
            case 0 :
                tm1.testWithoutMigration(config, args[3]);
                break;
            case 1 :
                tm1.testWithMigration1(config);
                break;
            case 2 :
                tm1.testWithMigration2(config);
                break;
            case 3 :
                tm1.testSingleStreamJoin(config);
                break;
            default :
                break;
        }

    } catch (Exception e) {
        System.out.println(e);
    }

    return;
}
/**
* called by the constructor.  this will set the default properties
* that the ALL query objects will support. Each subclass should override
* this method and add their own unique properties, but should also call
* super.setDefaultProperties() so that the common properties may be set.
*/
protected void setDefaultProperties() {
    addProperty("TIMES_TO_RUN", "1");
    addProperty("PRINT_OUT_META_INFORMATION", "false");
    addProperty("GLOBAL_TIME_WINDOW", "1000");
}
/**
 * Insert the method's description here.
 * Creation date: (3/21/2003 3:05:19 PM)
 */
public void testSingleStreamJoin(ConfigFileParser config) {

    int counter = Integer.parseInt(this.getProperty("TIMES_TO_RUN"));
    for (int i = 0; i < counter; i++) {
	    System.out.println("Test Single Window Join");
        System.out.println("global time window = " + this.getProperty("GLOBAL_TIME_WINDOW"));
        XATDag dag = new XATDagImp();
        long starttime = System.currentTimeMillis();

        DagNode node1 = new DagNodeImp();
        WBinaryJoinOperatorImp wbjoinop =
            new WBinaryJoinOperatorImp(node1);
//        wbjoinop.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
        node1.setOperator(wbjoinop);

        DagNode sourceNode1 = new DagNodeImp();
        Source sourceOp1 = new SourceImp(sourceNode1);
        sourceOp1.setName("A");
        sourceNode1.setOperator(sourceOp1);
        sourceNode1.setParent(node1);
        node1.addChild(sourceNode1);

        DagNode sourceNode2 = new DagNodeImp();
        Source sourceOp2 = new SourceImp(sourceNode2);
        sourceOp2.setName("B");
        sourceNode2.setOperator(sourceOp2);
        sourceNode2.setParent(node1);
        node1.addChild(sourceNode2);

        XATQueue outputQ = new XATMemoryQueueImp(wbjoinop);
        Vector cols3 = new Vector();
        cols3.add("Col1");
        cols3.add("Col2");
        XATQueueSchema schema3 = new XATQueueSchema(cols3);
        outputQ.setSchema(schema3);

        wbjoinop.setOutputQueue(outputQ);
        outputQ.register(this);
        dag.setRoot(node1);

        try {
//            XATStreamController streamControl =
//                XATStreamControllerImp.getStreamController();
//            streamControl.setConfigFileParser(config);
//            streamControl.setSystemThread(Thread.currentThread());
//            streamControl.init();
//            streamControl.initReductionFactors();
//            streamControl.setQueryTree(dag);
//            streamControl.connectStreamsWithTree();
//            initOperatorsInDag(dag);
//            streamControl.setYieldRate(0.1);
            //streamControl.setDebug(true);

            ExecController exec = new ExecController(dag);
            exec.setProperty("DEQUEUE_FACTOR", "0.1");
            exec.setProperty("DEQUEUE_HOWMANY", "10");
            exec.setProperty("YIELD_RATE", "0.8");
            //exec.setProperty("DEBUG", "true");

//            Thread streamT = new Thread(streamControl);
//            streamT.setName("Stream Thread");
//            exec.setStreamThread(streamT);
            Thread execT = new Thread(exec);
            execT.setName("Exec Thread");
            System.out.println("Start stream Thread ");
//            streamT.start();
            System.out.println("Start Exec Thread ");
            execT.start();

            try {
//                streamT.join();
                execT.join();
            } catch (InterruptedException e) {
                System.out.println("Main Thread Interrupted");
            }

            long endtime = System.currentTimeMillis();
            int howmany = wbjoinop.getOutputQueue().getQueueSize(this);
            System.out.println("\nTotal Running Time = " + (endtime - starttime));
            System.out.println("Number of joined tuples is " + howmany);

            /** clean up the garbage after the first running */
            Runtime.getRuntime().gc();

        } catch (InterruptedException e) {
            System.out.println(e);
        } catch (XATQueueException e) {
            System.out.println(e);
        } catch (Exception e) {
            System.out.println(e);
        }
    }
    return;
}
/**
 * Insert the method's description here.
 * Creation date: (4/21/2003 8:59:09 AM)
 * @param arg java.lang.String
 */
public void testWithMigration1(ConfigFileParser config) {

    try {
        
        System.out.println("Test with parallel migration");
        StringBuffer metadata = new StringBuffer();
        metadata.append("Test with parallel migration\n");
        metadata.append(
            "global time window = " + this.getProperty("GLOBAL_TIME_WINDOW") + "\n");
        long initialRunTime = 10000;
        long starttime = System.currentTimeMillis();
        long currentTime = 0;
        metadata.append("initial run time = " + initialRunTime + "\n");

        /** create dag, configFileParse, streamController and execController */
        ManualQueryPlanGenerator planGenerator = new ManualQueryPlanGenerator();
        XATDag oldDag = planGenerator.makeOldPlan();
        XATQueue outputQueue =
            ((XATStreamOperator) oldDag.getRoot().getOperator()).getOutputQueue();

//        XATStreamController streamControl =
//            XATStreamControllerImp.getStreamController();
//        streamControl.setConfigFileParser(config);
//        streamControl.setSystemThread(Thread.currentThread());
//        streamControl.init();
//        streamControl.initReductionFactors();
//        streamControl.setQueryTree(oldDag);
//        streamControl.connectStreamsWithTree();
        initOperatorsInDag(oldDag);
        //streamControl.setDebug(true);

        ExecController exec = new ExecController(oldDag);
        exec.setProperty("DEQUEUE_FACTOR", "0.1");
        exec.setProperty("DEQUEUE_HOWMANY", "10");
        exec.setProperty("YIELD_RATE", "0.8");
        exec.setMetaData(metadata);
        //exec.addMetaData(metadata.toString());
        //exec.setProperty("DEBUG", "true");

        /** Start running streams and execController for a while */
//        Thread streamT = new Thread(streamControl);
//        exec.setStreamThread(streamT);
        Thread execT = new Thread(exec);
//        streamT.setName("Stream Thread");
        execT.setName("Exec Thread");
        //System.out.println("Start stream Thread");
//        streamT.start();
        //System.out.println("Start Exec Thread");
        execT.start();

        /** After initialRunTime, pause execController thread to do setup migration */
        Thread.sleep(initialRunTime);
        currentTime = System.currentTimeMillis() - starttime;
        System.out.println("Try to Suspend Exec Thread at " + currentTime);  
        exec.execSuspend();
        while (System.getProperty("ProceedFlag").equalsIgnoreCase("false"))
            Thread.sleep(10);
        System.setProperty("ProceedFlag", "false");
        currentTime = System.currentTimeMillis() - starttime;
        metadata.append("PM starts at " + currentTime + "\n");      
        //execT.suspend();       

        /** Setup new query plan and migration controller */
        XATBox oldBox =
            new XATBox((DagNode) oldDag.getRoot(), oldDag);
        XATDag newDag = planGenerator.makeNewPlan();
//        streamControl.connectStreamsWithTree(newDag);
        initOperatorsInDag(newDag);
        XATBox newBox =
            new XATBox((DagNode) newDag.getRoot(), newDag);

        MigrationController mcontrol = new MigrationController(oldDag, oldBox, newBox);
        mcontrol.setupPTMigration();

        XATStreamOperator[] oldOperators = oldBox.getAllOperators();
        XATStreamOperator[] oldRootOperators = new XATStreamOperator[1];
        oldRootOperators[0] = oldBox.getBoxRootOperator();

        XATStreamOperator[] newOperators = newBox.getAllOperators();
        XATStreamOperator[] newRootOperators = new XATStreamOperator[1];
        newRootOperators[0] = newBox.getBoxRootOperator();
        
        /* for method 2 of migration 1 */
		exec.addOperatorsToRun(newOperators, newRootOperators);
        exec.addQueuesToCollect(newBox.getInterQs());
        //exec.addStatesToCollect(newBox.getAllStates());
        
        /**  Restart execController thread. */
        /**  Migration control monitors old box to finish*/
        //System.out.println("Try to Resume exec Thread");
        //execT.resume();
        exec.execResume();
        mcontrol.run();
        currentTime = System.currentTimeMillis() - starttime;
        System.out.println("Migration finished at " + currentTime);      

        /** stop execController thread again to disconnect old box */
        //execT.suspend();
        System.out.println("Try to Suspend Exec Thread again");
        exec.execSuspend();
        while (System.getProperty("ProceedFlag").equalsIgnoreCase("false"))
            Thread.sleep(10);
        System.setProperty("ProceedFlag", "false");
        
        mcontrol.finishMigration1();
        System.out.println("ReStart exec thread with new query plan only");

        exec.removeOperatorsToRun(oldOperators, oldRootOperators);
        exec.removeQueuesToCollect(oldBox.getInterQs());
        //exec.removeStatesToCollect(oldBox.getAllStates());

        //exec.addOperatorsToRun(newOperators, newRootOperators);
        //exec.addQueuesToCollect(newBox.getInterQs());
        //exec.addStatesToCollect(newBox.getAllStates());
        
        //execT.resume();
        //System.out.println("Try to Resume exec Thread");
        currentTime = System.currentTimeMillis() - starttime;
        metadata.append("PM ends at " + currentTime + "\n");
        exec.execResume();

        try {
//            streamT.join();
            execT.join();
        } catch (InterruptedException e) {
            System.out.println("Main Thread Interrupted");
        }

        long endtime = System.currentTimeMillis();
        System.out.println("\nTotal Running Time = " + (endtime - starttime));
        int howmany = outputQueue.getQueueSize(planGenerator);
        System.out.println("Number of joined tuples is " + howmany);
        //outputQueue.dequeue(howmany, planGenerator);

        /** clean up the garbage after the first running */
        //System.out.println("gc starts");
        Runtime.getRuntime().gc();
        //System.out.println("gc ends");
    } catch (Exception e) {
        System.out.println(e);
    }

}
/**
 * Insert the method's description here.
 * Creation date: (5/25/2003 8:43:11 AM)
 * @param config edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.ConfigFileParser
 */
public void testWithMigration2(ConfigFileParser config) {
    try {
        System.out.println("Test with moving state migration");
        System.out.println(
            "global time window = " + this.getProperty("GLOBAL_TIME_WINDOW"));
        long initialRunTime = 10000;
        StringBuffer metadata = new StringBuffer();
        metadata.append("Test with moving state migration\n");
        metadata.append(
            "global time window = " + this.getProperty("GLOBAL_TIME_WINDOW") + "\n");
        metadata.append("initial run time = " + initialRunTime + "\n");

        long starttime = System.currentTimeMillis();
        long currentTime = 0;

        /** create dag, configFileParse, streamController and execController */
        ManualQueryPlanGenerator planGenerator = new ManualQueryPlanGenerator();
        XATDag oldDag = planGenerator.makeOldPlan();
        XATQueue outputQueue =
            ((XATStreamOperator) oldDag.getRoot().getOperator()).getOutputQueue();

//        XATStreamController streamControl =
//            XATStreamControllerImp.getStreamController();
//        streamControl.setConfigFileParser(config);
//        streamControl.setSystemThread(Thread.currentThread());
//        streamControl.init();
//        streamControl.initReductionFactors();
//        streamControl.setQueryTree(oldDag);
//        streamControl.connectStreamsWithTree();
//        initOperatorsInDag(oldDag);
//        streamControl.setYieldRate(0.5);
        //streamControl.setDebug(true);

        ExecController exec = new ExecController(oldDag);
        exec.setProperty("DEQUEUE_FACTOR", "0.1");
        exec.setProperty("DEQUEUE_HOWMANY", "10");
        exec.setProperty("YIELD_RATE", "0.8");
        exec.setMetaData(metadata);
        //exec.addMetaData(metadata.toString());
        //exec.setProperty("DEBUG", "true");

        /** Start running streams and execController for a while */
//        Thread streamT = new Thread(streamControl);
//        streamT.setName("Stream Thread");
//        exec.setStreamThread(streamT);
        Thread execT = new Thread(exec);
        execT.setName("Exec Thread");
//        streamT.start();
        //Thread.sleep(1000);    
        execT.start();

        /** After a while, pause execController thread to connect new box */
        Thread.sleep(initialRunTime);
        currentTime = System.currentTimeMillis() - starttime;
        System.out.println("Try to Suspend Exec Thread at " + currentTime);      
        //execT.suspend();
        exec.execSuspend();
        while (System.getProperty("ProceedFlag").equalsIgnoreCase("false"))
            Thread.sleep(10);
        System.setProperty("ProceedFlag", "true");
		currentTime = System.currentTimeMillis() - starttime;
		metadata.append("MM starts at " + currentTime + "\n");
        
        /** setup oldbox */
        XATBox oldBox =
            new XATBox((DagNode) oldDag.getRoot(), oldDag);
        XATStreamOperator[] oldOperators = oldBox.getAllOperators();
        XATStreamOperator[] oldRootOperators = new XATStreamOperator[1];
        oldRootOperators[0] = oldBox.getBoxRootOperator();


        /*init migration controller and clean accumulated tuples from old box */
        MigrationController mcontrol = new MigrationController(oldDag, oldBox, null);
        //System.out.println("Clean accumulated tuples");
        mcontrol.cleanAccumulatedTuples();

        /* setup new box. connect it to current dag, recompute states and disconnect old box from current dag */
        XATDag newDag = planGenerator.makeNewPlan();
//        streamControl.connectStreamsWithTree(newDag);
        initOperatorsInDag(newDag);
        XATBox newBox =
            new XATBox((DagNode) newDag.getRoot(), newDag);
        mcontrol.setNewBox(newBox);
        mcontrol.setupMSMigration();

        /* add operators in new box and remove operators in new box from exec controller */
        XATStreamOperator[] newOperators = newBox.getAllOperators();
        XATStreamOperator[] newRootOperators = new XATStreamOperator[1];
        newRootOperators[0] = newBox.getBoxRootOperator();
        exec.removeOperatorsToRun(oldOperators, oldRootOperators);
        exec.removeQueuesToCollect(oldBox.getInterQs());
        //exec.removeStatesToCollect(oldBox.getAllStates());
        exec.addOperatorsToRun(newOperators, newRootOperators);
        exec.addQueuesToCollect(newBox.getInterQs());
        //exec.addStatesToCollect(newBox.getAllStates());

        /**  Restart execController thread. */
        currentTime = System.currentTimeMillis() - starttime;
		metadata.append("MM ends at " + currentTime + "\n");
        System.out.println("Migration finished at " + currentTime);
        //execT.resume();
        //System.out.println("Try to Resume exec Thread");
        exec.execResume();

        try {
            //System.out.println("Waiting for stream and exec threads to finish");
//            streamT.join();
            execT.join();
        } catch (InterruptedException e) {
            System.out.println("Main Thread Interrupted");
        }

        long endtime = System.currentTimeMillis();
        System.out.println("\nTotal running time = " + (endtime - starttime));

        int howmany = outputQueue.getQueueSize(planGenerator);
        /*for (int k = 0; k < howmany; k++) {
            try {
                XATStreamTuple tuple = (XATStreamTuple) (outputQueue.dequeue(planGenerator));
                System.out.println(tuple.toString());
            } catch (XATQueueException e) {
                System.out.println(e);
                return;
            }
        }*/
        System.out.println("Number of joined tuples is " + howmany);        
		//outputQueue.dequeue(howmany, planGenerator);
		
        /** clean up the garbage after the first running */
  		//System.out.println("gc starts");
        Runtime.getRuntime().gc();
        //System.out.println("gc ends");

    } catch (Exception e) {
        System.out.println(e);
    }
}
/**
 * Insert the method's description here.
 * Creation date: (4/20/2003 2:07:30 PM)
 */
public void testWithoutMigration(ConfigFileParser config, String arg) {
    try {
        long starttime = System.currentTimeMillis();
        ManualQueryPlanGenerator planGenerator = new ManualQueryPlanGenerator();

        int option = Integer.parseInt(arg);
        XATDag dag;
        StringBuffer metadata = new StringBuffer();    
        switch (option) {
            case 0 :
                dag = planGenerator.makeOldPlan();
                System.out.println("Old Plan");
                metadata.append("Old Plan\n");
                break;
            case 1 :
                dag = planGenerator.makeNewPlan();
                System.out.println("New Plan");
                metadata.append("New Plan\n");
                break;
            default :
                return;
        }
        metadata.append("global time window = " + this.getProperty("GLOBAL_TIME_WINDOW") + "\n");

//        XATStreamController streamControl =
//            XATStreamControllerImp.getStreamController();
//        streamControl.setConfigFileParser(config);
//        streamControl.setSystemThread(Thread.currentThread());
//        streamControl.init();
//        streamControl.initReductionFactors();
//        streamControl.setQueryTree(dag);
//        streamControl.connectStreamsWithTree();
        initOperatorsInDag(dag);
        //streamControl.setYieldRate(0.5);
        //streamControl.setDebug(true);

        ExecController exec = new ExecController(dag);
        exec.setProperty("DEQUEUE_FACTOR", "0.1");
        exec.setProperty("DEQUEUE_HOWMANY", "10");
        exec.setProperty("YIELD_RATE", "0.8");
        exec.setMetaData(metadata);
        //exec.addMetaData(metadata.toString());
        //exec.setProperty("GLOBAL_TIME_WINDOW", ""+Long.parseLong(this.getProperty("GLOBAL_WINDOW")));
        //exec.setProperty("DEBUG", "true");

        int howMany = 1;
        for (int i = 0; i < howMany; i++) {
//            Thread streamT = new Thread(streamControl);
//            streamT.setName("Stream Thread");
//            exec.setStreamThread(streamT);
            Thread execT = new Thread(exec);
            execT.setName("Exec Thread");
            //System.out.println("\n****** Start stream Thread 1 ******");
//            streamT.start();
            //Thread.sleep(1000);
            //System.out.println("****** Start Exec Thread 1 ******");
            execT.start();

            try {
                System.out.println("Waiting for stream and exec threads to finish");
//                streamT.join();
                execT.join();
            } catch (InterruptedException e) {
                System.out.println("Main Thread Interrupted");
            }

            long endtime = System.currentTimeMillis();
            System.out.println("\nTotal running time = " + (endtime - starttime));

            XATQueue outputQueue =
                ((XATStreamOperator) dag.getRoot().getOperator()).getOutputQueue();
            int howmany = outputQueue.getQueueSize(planGenerator);
            /*for (int k = 0; k < howmany; k++) {
                try {
                    XATStreamTuple tuple = (XATStreamTuple) (outputQueue.dequeue(planGenerator));
                    System.out.println(tuple.toString());
                } catch (XATQueueException e) {
                    System.out.println(e);
                    return;
                }
            }*/
            System.out.println("Number of joined tuples is " + howmany);
			//outputQueue.dequeue(howmany, planGenerator);
			
            /** clean up the garbage after the first running */
            //Runtime.getRuntime().gc();
            System.out.println("End of this test");

        }
    } catch (Exception e) {
        System.out.println(e.toString());
    }
}
}
