package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicateBitRepresentation
	.ExtPredicateBitSet;

/**
 * Doubly LinkedList of tuples sorted by timestamp (in increasing order).
 * Creation date: (1/24/2003 7:39:49 PM)
 * @author: Administrator
 */
public class JugglerTupleList
	extends edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp
	implements Serializable {
	/** Prev. */
	protected JugglerTupleList prev;

	/** Our tuple*/
	JugglerTuple tuple;

	/** Next. */
	protected JugglerTupleList next;

	protected int count;
	/**
	 * TupleList constructor comment.
	 */
	public JugglerTupleList() {
		super();
		count = 0;
	}
	/**
	 * TupleList constructor comment.
	 */
	public JugglerTupleList(JugglerTuple t) {
		super();
		count = 1;
		tuple = t;
	}

	//	link in new Tuple
	public JugglerTupleList(JugglerTupleList newTuple) {
		super();
		arrayCell = newTuple.arrayCell;
		count = newTuple.count;
		next = newTuple.next;
		prev = newTuple.prev;
		timeStamp = newTuple.timeStamp;
		tuple = newTuple.tuple;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:50:48 PM)
	 * @param tpl juggler.stream.TupleList
	 * @return Iterator
	 */
	public Iterator appendTupleList(JugglerTupleList tpl) {
		JugglerTupleList t1 = this;

		//if this is null, append into this directly
		if (this.getTuple() == null) {
			this.setTuple(tpl.getTuple());
			this.setCount(this.getCount() + 1);
			if (tpl.next != null) ///////
				this.setNext(tpl.getNext());
			if (tpl.prev != null) ///////
				this.setPrev(tpl.getPrev());
			return new JugglerTupleListIterator(this);
		}

		//
		while (t1.getNext() != null) {
			t1 = t1.getNext();
		}
		t1.setNext(tpl);
		t1.getNext().setPrev(t1);
		
		while(t1.getPrev() != null){
			t1 = t1.getPrev();
		}

		return new JugglerTupleListIterator(t1);
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 11:46:38 PM)
	 * @return int
	 */
	public int getCount() {
		return count;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/15/2003 12:38:21 PM)
	 * @return juggler.stream.TupleList
	 */
	public JugglerTupleList getFirstHalfJoinedTuple() {

		try {
			JugglerTupleList firstHalf = null;
			JugglerTupleList nextTupleList = this.getJugglerTupleListClone();

			while (nextTupleList != null
				&& nextTupleList.getTuple().firstHalfJoinedTupleMarker == false) {
				if (nextTupleList != null) {
					if (firstHalf == null) {
						firstHalf =
							new JugglerTupleList(nextTupleList.getTuple());
					} else {
						firstHalf.setNext(
							new JugglerTupleList(nextTupleList.getTuple()));
						firstHalf.next.setPrev(firstHalf);
						firstHalf = firstHalf.getNext();
					}
				}
				nextTupleList = (JugglerTupleList) nextTupleList.getNext();

			}

			//append the last tuplelist
			if ((firstHalf != null) && (nextTupleList != null)) {
				firstHalf.setNext(
					new JugglerTupleList(nextTupleList.getTuple()));
			} else {
				if (tuple.firstHalfJoinedTupleMarker)
					firstHalf = new JugglerTupleList(this.getTuple());
			}

			while (firstHalf.prev != null)
				firstHalf = firstHalf.prev;

			return firstHalf;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 10:05:50 AM)
	 * @return juggler.stream.Tuple
	 */
	public JugglerTuple getFirstTuple() {
		JugglerTupleList tempPrev = this.getPrev();
		JugglerTuple tempCurr = this.getTuple();

		//if we are already at the head of the list
		//return this Tuple
		if (tempPrev == null)
			return tempCurr;

		//if we are not at the head of the list
		//traverse to the head 
		while (tempPrev != null) {
			JugglerTupleList temptempPrev = tempPrev.getPrev();
			tempCurr = tempPrev.getTuple();
			tempPrev = temptempPrev;
		}
		return tempCurr;
	}
	/**
	 * Returns the last tuple in the TupleList.
	 * Creation date: (1/28/2003 10:12:09 AM)
	 * @return juggler.stream.Tuple
	 */
	public JugglerTuple getLastTuple() {
		JugglerTupleList tempNext = next;
		JugglerTuple tempCurr = this.getTuple();

		//if we are already at the tail of the list
		//return this Tuple
		if (tempNext == null)
			return tempCurr;

		//if we are not at the head of the list
		//traverse to the head 
		while (tempNext != null) {
			tempCurr = tempNext.getTuple();
			tempNext = tempNext.getNext();
		}
		return tempCurr;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:10:00 PM)
	 * @return juggler.stream.TupleList
	 */
	public JugglerTupleList getNext() {
		return next;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:10:00 PM)
	 * @return juggler.stream.TupleList
	 */
	public JugglerTupleList getPrev() {
		return prev;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/15/2003 12:38:21 PM)
	 * @return juggler.stream.TupleList
	 */
	public JugglerTupleList getSecondtHalfJoinedTuple() {
		JugglerTupleList secondHalf = null;
		try {
			//JugglerTupleList firstHalf =
			//	(JugglerTupleList) this.getFirstHalfJoinedTuple();
			JugglerTupleList nextTupleList = this;

			while (nextTupleList != null
				&& nextTupleList.getTuple().firstHalfJoinedTupleMarker == false) {
				nextTupleList = nextTupleList.getNext();
				//firstHalf.setNext(nextTupleList);
			}

			if (nextTupleList.getTuple().firstHalfJoinedTupleMarker)
				nextTupleList = nextTupleList.getNext();

			secondHalf = nextTupleList;
			if (secondHalf != null)
				secondHalf.setPrev(null);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return secondHalf;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/15/2003 1:17:18 PM)
	 * @return java.util.ArrayList
	 */
	public ArrayList getStreamNames() {
		ArrayList collectedStreamNames = new ArrayList();
		JugglerTupleList nextTupleList = this;

		while (nextTupleList != null) {
			JugglerTuple aTuple = nextTupleList.getTuple();
			ArrayList tupleStreamNames = aTuple.getStreamNames();
			for (int i = 0; i < tupleStreamNames.size(); i++) {
				String aStreamName = (String) tupleStreamNames.get(i);
				collectedStreamNames.add(aStreamName);
			}
			nextTupleList = nextTupleList.getNext();
		}

		return collectedStreamNames;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:08:47 PM)
	 * @return juggler.stream.Tuple
	 */
	public JugglerTuple getTuple() {
		return tuple;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:14:51 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesEqual(JugglerTuple tuple) {
		JugglerTuple t = this.getFirstTuple();
		JugglerTupleList thisTupleList = this;
		JugglerTupleList tTupleList = new JugglerTupleList();

		//start from the begining of the TupleList and traverse until we
		//are at where the timestamps are equal
		while (t.getJugglerTimeStamp() < tuple.getJugglerTimeStamp()) {
			thisTupleList = thisTupleList.next; //gets the next tupleList
			t = thisTupleList.getTuple();
		}
		while (t.getJugglerTimeStamp() == tuple.getJugglerTimeStamp()) {
			tTupleList.insertByTime(t);
			thisTupleList = thisTupleList.next; //gets the prev tupleList
			t = thisTupleList.getTuple();
		}

		return tTupleList;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:13:29 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesGreater(JugglerTuple tuple) {
		JugglerTuple t = this.getLastTuple();
		JugglerTupleList thisTupleList = this;
		JugglerTupleList tTupleList = new JugglerTupleList();

		while (t.getJugglerTimeStamp() > tuple.getJugglerTimeStamp()) {
			tTupleList.insertByTime(t);
			thisTupleList = thisTupleList.prev; //gets the prev tupleList
			t = thisTupleList.getTuple();
		}
		return tTupleList;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:19:04 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesGreaterAndEq(JugglerTuple tuple) {
		JugglerTuple t = this.getLastTuple();
		JugglerTupleList thisTupleList = this;
		JugglerTupleList tTupleList = new JugglerTupleList();

		while (t.getJugglerTimeStamp() >= tuple.getJugglerTimeStamp()) {
			tTupleList.insertByTime(t);
			thisTupleList = thisTupleList.prev; //gets the prev tupleList
			t = thisTupleList.getTuple();
		}
		return tTupleList;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:07:03 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesLess(JugglerTuple tuple) {
		JugglerTuple t = this.getFirstTuple();
		JugglerTupleList thisTupleList = this;
		JugglerTupleList tTupleList = new JugglerTupleList();

		while (t.getJugglerTimeStamp() < tuple.getJugglerTimeStamp()) {
			tTupleList.insertByTime(t);
			thisTupleList = thisTupleList.next; //gets the next tupleList
			t = thisTupleList.getTuple();
		}
		return tTupleList;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:17:55 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesLessAndEq(JugglerTuple tuple) {
		JugglerTuple t = this.getFirstTuple();
		JugglerTupleList thisTupleList = this;
		JugglerTupleList tTupleList = new JugglerTupleList();

		while (t.getJugglerTimeStamp() <= tuple.getJugglerTimeStamp()) {
			tTupleList.insertByTime(t);
			thisTupleList = thisTupleList.next; //gets the next tupleList
			t = thisTupleList.getTuple();
		}
		return tTupleList;
	}
	/**Insert and return tupleList where belongs. If this doesn't
	* return 'this' it is because we are adding to the front of the list.
	* @param t Tuple
	* @return TupleList
	*/
	public JugglerTupleList insertByTime(JugglerTuple t) {
		if (t.later(tuple)) {
			// insert into next
			JugglerTupleList n = next;
			JugglerTupleList p = this;
			while (n != null) {
				if (n.tuple.later(t)) {
					// must add to previous
					JugglerTupleList newT = new JugglerTupleList(t);
					newT.setPrev(n.prev);
					newT.setNext(n);

					n.prev.setNext(newT);
					n.setPrev(newT);

					return this; // safely added after
				}

				p = n;
				n = n.next;
			}

			p.next = new JugglerTupleList(t);
			p.next.prev = p;
			return this; // safely added into next.

		} else {
			// belongs in prev
			JugglerTupleList p = prev;
			JugglerTupleList n = this;
			while (p != null) {
				// if previous tuple
				if (t.later(p.tuple)) {
					JugglerTupleList newT = new JugglerTupleList(t);

					newT.setNext(next);
					newT.setPrev(p);

					next.setPrev(newT);
					p.setNext(newT);
					return newT;
				}

				n = p;
				p = p.prev;
			}

			n.prev = new JugglerTupleList(t);
			n.prev.next = n;
			return n.prev; // will become new head in the list.
		}
	}
	/**Insert and return tupleList where belongs. If this doesn't
	* return 'this' it is because we are adding to the front of the list.
	* @param t Tuple
	* @return TupleList
	*/
	public JugglerTupleList insertByTime(JugglerTupleList tList) {
		JugglerTuple t = tList.getFirstTuple();
		if (t.later(tuple)) {
			// insert into next
			JugglerTupleList n = next;
			JugglerTupleList p = this;
			while (n != null) {
				if (n.tuple.later(t)) {
					// must add to previous
					JugglerTupleList newT = new JugglerTupleList(tList);
					newT.setPrev(n.prev);
					newT.setNext(n);

					n.prev.setNext(newT);
					n.setPrev(newT);

					return this; // safely added after
				}

				p = n;
				n = n.next;
			}

			p.next = new JugglerTupleList(tList);
			p.next.prev = p;
			return this; // safely added into next.

		} else {
			// belongs in prev
			JugglerTupleList p = prev;
			JugglerTupleList n = this;
			while (p != null) {
				// if previous tuple
				if (t.later(p.tuple)) {
					JugglerTupleList newT = new JugglerTupleList(tList);

					newT.setNext(next);
					newT.setPrev(p);

					next.setPrev(newT);
					p.setNext(newT);
					return newT;
				}

				n = p;
				p = p.prev;
			}

			n.prev = new JugglerTupleList(tList);
			n.prev.next = n;
			return n.prev; // will become new head in the list.
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/3/2003 10:10:52 PM)
	 * @return boolean
	 */
	public boolean isEmpty() {
		if (this.getPrev() == null
			&& this.getTuple() == null
			&& this.getNext() == null)
			return true;
		else
			return false;
	}
	/** If called at head, just return next.
	* @return TupleList
	*/
	public JugglerTupleList remove() {
		if (prev != null) {
			prev.setNext(next);
			next.setPrev(prev);
			return prev;
		} else {
			if (this.next != null) {
				this.setTuple(this.getNext().getTuple());
				this.setNext(null);
			} else {
				return null;
			}
			return this;
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:22:41 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public void removeTuple(JugglerTuple tuple) {
		long timestamp = tuple.getJugglerTimeStamp();
		JugglerTupleList t1 = this;
		while (true) {
			if (t1.getTuple().getJugglerTimeStamp() < timestamp)
				t1 = t1.getNext();
			if (t1.getTuple().getJugglerTimeStamp() == timestamp) {
				if (prev == null) { // if its the head...
					remove(); //remove the tuple list 
					return;
				} else {
					JugglerTupleList previousTL = t1.getPrev();
					JugglerTupleList nextTL = t1.getNext();
					previousTL.setNext(nextTL);
					t1 = null;
				}
			}

		}

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 11:46:38 PM)
	 * @param newCount int
	 */
	public void setCount(int newCount) {
		count = newCount;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:10:00 PM)
	 * @param newNext juggler.stream.TupleList
	 */
	public void setNext(JugglerTupleList newNext) {
		next = newNext;
		next.count = count + 1;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:10:00 PM)
	 * @param newPrev juggler.stream.TupleList
	 */
	public void setPrev(JugglerTupleList newPrev) {
		prev = newPrev;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:08:47 PM)
	 * @param newTuple juggler.stream.Tuple
	 */
	public boolean setTupleReference_XATTuple(JugglerTupleList newTuple) {
		if (newTuple != null) {
			JugglerTupleList tempTL = newTuple;
			JugglerTuple temptuple = tempTL.getFirstTuple();
			while (temptuple != null) {
				tuple = temptuple.getJugglerClone();
				tuple.firstHalfJoinedTupleMarker =
					temptuple.firstHalfJoinedTupleMarker;
				tuple.setValues(temptuple.getValues());
				tuple.possibleQuerySatisfied = temptuple.possibleQuerySatisfied;
				tuple.predicates = temptuple.predicates;
				tuple.streamIDs = temptuple.streamIDs;
				tuple.streamNames = temptuple.streamNames;
				//tuple.setTimeStamp(temptuple.getTimeStamp());
				count++;
				tempTL = tempTL.getNext();
				if (tempTL != null)
					temptuple = tempTL.getFirstTuple();
				else
					temptuple = null;
			}
			return true;
		} else {
			boolean isNotNull = false;
			while (this.tuple != null) {
				if (next != null)
					this.getNext().setTupleReference(null);
				if (prev != null)
					this.getPrev().setTupleReference(null);
				isNotNull = this.tuple.setTupleReference_XATTuple(null);
				this.tuple = null;
				this.arrayCell = null;
			}
			if (!isNotNull)
				return false;
			else //this should not happen
				return true;
		}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:08:47 PM)
	 * @param newTuple juggler.stream.Tuple
	 */
	public boolean setTupleReference(JugglerTupleList newTuple) {
		if (newTuple != null) {
			JugglerTupleList tempTL = newTuple;
			JugglerTuple temptuple = tempTL.getFirstTuple();
			while (temptuple != null) {
				tuple = temptuple.getJugglerClone();
				tuple.firstHalfJoinedTupleMarker =
					temptuple.firstHalfJoinedTupleMarker;
				tuple.setValues(temptuple.getValues());
				tuple.possibleQuerySatisfied = temptuple.possibleQuerySatisfied;
				tuple.predicates = temptuple.predicates;
				tuple.streamIDs = temptuple.streamIDs;
				tuple.streamNames = temptuple.streamNames;
				//tuple.setTimeStamp(temptuple.getTimeStamp());
				count++;
				tempTL = tempTL.getNext();
				if (tempTL != null)
					temptuple = tempTL.getFirstTuple();
				else
					temptuple = null;
			}
			return true;
		} else {
			boolean isNotNull = false;
			while (this.tuple != null) {
				if (next != null)
					this.getNext().setTupleReference(null);
				if (prev != null)
					this.getPrev().setTupleReference(null);
				isNotNull = this.tuple.setTupleReference(null);
				this.tuple = null;
				this.arrayCell = null;
			}
			if (!isNotNull)
				return false;
			else //this should not happen
				return true;
		}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:08:47 PM)
	 * @param newTuple juggler.stream.Tuple
	 */
	public void setTuple(JugglerTuple newTuple) {
		tuple = newTuple;
		count++;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 11:41:58 PM)
	 * @return int
	 */
	public int size() {
		JugglerTupleList tempNext = next;
		while (tempNext != null) {
			tempNext = tempNext.next;
			count++;
		}
		return count;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/16/2003 9:17:45 PM)
	 * @return java.lang.String
	 */
	public String toString() {

		String tupleListString = "";
		/*while (next != null){
			tupleListString += ":: Tuple: " + tuple.toString();
		}*/
		return tupleListString;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/22/2003 6:37:49 PM)
	 */
	public void updatePredicateBitSetsInTupleList() {
		JugglerTupleList current = this;
		ExtPredicateBitSet pbs = tuple.getPredicates();
		while (next != null && current != null) {
			if (pbs != null)
				current.getTuple().setPredicates(
					(ExtPredicateBitSet) pbs.getClone());
			else
				current.getTuple().setPredicates(null);
			current = current.getNext();
		}

	}

	/**
		 * Insert the method's description here.
		 * Creation date: (4/22/2003 6:37:49 PM)
		 */
	public void setJoinTupleMarkerAfterJoining() {
		JugglerTupleList current = this;
		while (current != null) {
			current.getTuple().setFirstHalfJoinedTupleMarker(false);
			if (current.getNext() == null)
				current.getTuple().setFirstHalfJoinedTupleMarker(true);
			current = current.getNext();
		}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (5/20/2003 3:04:15 PM)
	 * @return juggler.stream.JugglerTuple
	 * @param StreamName java.util.ArrayList
	 */
	public JugglerTuple getTupleStream(ArrayList StreamName) {
		JugglerTupleList currTupleList = this;

		while (currTupleList.getTuple() != null) {
			if ((currTupleList.getTuple().getStreamNames())
				.containsAll(StreamName))
				return currTupleList.getTuple();
			currTupleList = currTupleList.getNext();
		}

		return null;
	}

	/**
					 * Sets the predicate bitset of the tuple.
					 * Creation date: (1/10/2003 12:06:02 AM)
					 * @param newPredicates juggler.stream.PredicateBitSet
					 */
	public JugglerTupleList getJugglerTupleListClone() {
		JugglerTupleList newTL = new JugglerTupleList();
		JugglerTupleList temp = this;

		JugglerTupleList nextTempTL = new JugglerTupleList();

		while (temp != null) {
			if (temp.tuple == null)
				break;
			newTL.tuple = temp.tuple.getJugglerClone();

			if (temp.next != null) {
				newTL.next = new JugglerTupleList();
				newTL.next.prev = new JugglerTupleList();
				newTL.next.prev = newTL;
			}
			if (newTL.prev != null) {
				//to make sure this isn't hte first tuple when prev is null
				newTL.prev.next = new JugglerTupleList();
				newTL.prev.next = newTL;
			}

			temp = temp.next;
			if (temp != null)
				newTL = newTL.next;
			else {
				if (newTL.next != null) { //add the last tuple reference
					//newTL.next.prev = new JugglerTupleList();
					//newTL.next.prev.setTupleReference(newTL);
				}
			}
		}

		/*
				while (temp != null) {
		
					newTL.tuple = temp.tuple.getJugglerClone();
				
				if (temp.prev != null)
					newTL.prev = temp.prev.getJugglerTupleListClone();
				else 
					newTL.prev = null;
				if (temp.next != null)
					newTL.next = temp.next.getJugglerTupleListClone();
				else
					newTL.next = null;
				temp = temp.next;
				}  */

		newTL = newTL.getFirstTupleList();

		return newTL;
	}
	/**
	 * @param b
	 */
	public void setFullTuple(boolean b) {
		// TODO Auto-generated method stub
		tuple.firstHalfJoinedTupleMarker = b;
	}

	/**
		 * @param b
		 */
	public boolean equals(JugglerTupleList n) {
		boolean isEqual = false;

		while (prev != null && n != null) {
			if (prev.tuple.equals(n.tuple)) {
				prev = prev.getPrev();
				n = n.getPrev();
			} else {
				return false;
			}
		}

		while (next != null && n != null) {
			if (next.tuple.equals(n.tuple)) {
				next = next.getNext();
				n = n.getNext();
			} else {
				return false;
			}
		}

		if (tuple != null && n != null) {
			if (tuple.equals(n.tuple)) {
				isEqual = true;
			} else {
				return false;
			}
		}
		return isEqual;

	}

	/**
			 * @param b
			 */
	public long getJugglerTimeStamp(ArrayList streamNames, int columnInt)
		throws XATTimeStampException {
		long temp = -1;
		JugglerTuple t = this.getTupleStream(streamNames);
		if (t.getTimeStamp() != null) {
			temp = t.getTimeStamp().getTimeStamp(columnInt);
			return temp;
		} else {
			return this.getTimeStamp().getTimeStamp(columnInt);
		}
	}
	/**
	 * 
	 */
	public ArrayList getAllTupleValues() {
		JugglerTupleList temp = this;
		JugglerTupleList tempNext = next;

		ArrayList tupleValues = new ArrayList();

		while (temp != null) {
			tupleValues.addAll(temp.getTuple().getValues());
			temp = temp.next;
		}

		return tupleValues;

	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 10:05:50 AM)
	 * @return juggler.stream.Tuple
	 */
	public JugglerTupleList getFirstTupleList() {
		JugglerTupleList tempPrev = this.prev;
		JugglerTuple tempCurr = this.getTuple();

		//if we are already at the head of the list
		//return this Tuple
		if (tempPrev == null)
			return this;

		//if we are not at the head of the list
		//traverse to the head 
		while (tempPrev.prev != null) {
			JugglerTupleList temptempPrev = tempPrev.getPrev();
			tempPrev = temptempPrev;
		}
		return tempPrev;
	}
	/**
		 * Insert the method's description here.
		 * Creation date: (1/28/2003 10:05:50 AM)
		 * @return juggler.stream.Tuple
		 */
	public JugglerTupleList getLastTupleList() {
		JugglerTupleList tempNext = this.next;
		JugglerTuple tempCurr = this.getTuple();

		//if we are already at the head of the list
		//return this Tuple
		if (tempNext == null)
			return this;

		//if we are not at the head of the list
		//traverse to the head 
		while (tempNext.next != null) {
			JugglerTupleList temptempNext = tempNext.getNext();
			tempNext = temptempNext;
		}
		return tempNext;
	}
	/**
	 * @param tuple
	 * @return
	 */
	public JugglerTupleList insertByTimeInWinTupleList(JugglerTuple tuple) {
		if (tuple.later(this.getTuple())) {
			// insert into next
			JugglerTupleList n = next;
			JugglerTupleList p = this;
			while (n != null && n.tuple != null) {
				if (n.getFirstTuple().later(tuple)) {
					// must add to previous
					JugglerTupleList newT = new JugglerTupleList(tuple);
					newT.setPrev(n.getPrev());
					newT.setNext(n);

					n.getPrev().setNext(newT);
					n.setPrev(newT);

					return this; // safely added after
				}

				p = n;
				n = n.getNext();
			}

			p.setNext(new JugglerTupleList(tuple));
			p.getNext().setPrev(p);
			return this; // safely added into next.

		} else {
			// belongs in prev
			JugglerTupleList p = prev;
			JugglerTupleList n = this;
			while (p != null) {
				// if previous tuple
				if (tuple.later(p.getTuple())) {
					JugglerTupleList newT = new JugglerTupleList(tuple);

					newT.setNext(next);
					newT.setPrev(p);

					next.setPrev(newT);
					p.setNext(newT);
					return newT;
				}

				n = p;
				p = p.getPrev();
			}

			n.setPrev(new JugglerTupleList(tuple));
			n.getPrev().setNext(n);
			return n.getPrev(); // will become new head in the list.
		}
	}
	/**
	 * @param tupleStreamNameToJoin
	 * @return
	 */
	public JugglerTuple getTupleStream_XATTuple(ArrayList StreamName) {
		JugglerTupleList currTupleList = this;

		while (currTupleList.getTuple() != null) {
			if (currTupleList
				.getTuple()
				.getStreamNames()
				.containsAll(StreamName))
				return currTupleList.getTuple();
			currTupleList = currTupleList.getNext();
		}

		return null;
	}
	/**
	 * @param tempTL
	 */
	public void appendTupleList_IfNotContained_XATTuple(JugglerTuple tempTL) {

		JugglerTuple tupleTemp = tempTL;

		if (this.getFirstTuple() == null) {
			this.appendTuple_XATTuple(tempTL);
			return;
		}

		JugglerTupleList newAppendedList = this;

		JugglerTupleList temp = this.getFirstTupleList();
		while (temp != null) {
			if (temp.tuple.equals(tupleTemp)) {
				temp.tuple.getPredicates().combineBitSets(
					tupleTemp.getPredicates());
				return;
			}
			temp = temp.next;
		}
		//if not in the list, append it to the end.
		this.appendTuple_XATTuple(tempTL);
		return;
	}
	/**
	 * @param tuple
	 */
	private void appendTuple_XATTuple(JugglerTuple tpl) {
		if (this.tuple == null) {
			this.setTuple(tpl);
			//this.setCountWinTupleLists(this.getCountWinTupleLists()+1);
		} else {
			JugglerTupleList jTL = this;
			while (jTL.getNext() != null) {
				jTL = jTL.getNext();
			}
			JugglerTupleList newNext = new JugglerTupleList(tpl);
			newNext.setPrev(jTL);
			jTL.next = newNext;
		}

	}
	/**
	 * @param aStr
	 * @return
	 */
	public JugglerTuple getTupleWithStream_XATTuple(String aStr) {
		JugglerTupleList currTupleList = this;
		
		if((currTupleList == null) || (currTupleList.tuple == null))
			return null;

		while (currTupleList.getTuple() != null) {
			if (currTupleList.getTuple().getStreamNames().contains(aStr))
				return currTupleList.getTuple();
			currTupleList = currTupleList.getNext();
			if(currTupleList == null)
				break;
		}

		return null;
	}
	/**
	 * @return
	 */
	public long getJugglerMaxTimeStamp() {
		long temp = -1;
		//JugglerTupleList tempClone = this.getJugglerTupleListClone();
		try {
			if ((timeStamp == null)) {
				return tuple.getJugglerTimeStamp();
			} else {
				temp = timeStamp.getMaxTimeStamp();
			}
		} catch (XATTimeStampException e) {
		}
		return temp;
	}
	/**
		 * @return
		 */
	public long getJugglerTimeStamp() {
		long temp = -1;
		//JugglerTupleList tempClone = this.getJugglerTupleListClone();
		try {
			if ((timeStamp == null)) {
				return tuple.getJugglerTimeStamp();
			} else {
				temp = timeStamp.getMaxTimeStamp();
			}
		} catch (XATTimeStampException e) {
		}
		return temp;
	}
	/**
	 * @param list
	 * @return
	 */
	public boolean later(JugglerTupleList list) {
		JugglerTuple thisTuple = this.getTupleStream(this.getStreamNames());
		JugglerTuple compareTuple = list.getTupleStream(this.getStreamNames());
		return thisTuple.later(compareTuple);
	}

	/**
		 * @param list
		 * @return
		 */
	public boolean later(JugglerTupleList list, int colInt) {
		JugglerTuple thisTuple = this.getTupleStream(this.getStreamNames());
		JugglerTuple compareTuple = list.getTupleStream(this.getStreamNames());
		return thisTuple.later(compareTuple, colInt);
	}
	/**Insert and return tupleList where belongs. If this doesn't
		* return 'this' it is because we are adding to the front of the list.
		* @param t JugglerTupleList
		* @return JugglerWindowTupleList
		*/
	public JugglerTupleList insertByTimeInWinTupleList(
		JugglerTuple tuple,
		ArrayList streamNames,
		int columnInt) {
			if (tuple.later(this.getTuple())) {
				// insert into next
				JugglerTupleList n = next;
				JugglerTupleList p = this;
				while (n != null && n.tuple != null) {
					if (n.getFirstTuple().later(tuple)) {
						// must add to previous
						JugglerTupleList newT = new JugglerTupleList(tuple);
						newT.setPrev(n.getPrev());
						newT.setNext(n);

						n.getPrev().setNext(newT);
						n.setPrev(newT);

						return this; // safely added after
					}

					p = n;
					n = n.getNext();
				}

				p.setNext(new JugglerTupleList(tuple));
				p.getNext().setPrev(p);
				return this; // safely added into next.

			} else {
				// belongs in prev
				JugglerTupleList p = prev;
				JugglerTupleList n = this;
				while (p != null) {
					// if previous tuple
					if (tuple.later(p.getTuple())) {
						JugglerTupleList newT = new JugglerTupleList(tuple);

						newT.setNext(next);
						newT.setPrev(p);

						next.setPrev(newT);
						p.setNext(newT);
						return newT;
					}

					n = p;
					p = p.getPrev();
				}

				n.setPrev(new JugglerTupleList(tuple));
				n.getPrev().setNext(n);
				return n.getPrev(); // will become new head in the list.
			}
	}

}
