package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import sun.security.krb5.internal.crypto.j;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparableTupleValues
	.KeyDouble;
/**
 * Stores tuples as a doubly linked list of tuples ordered by timestamps.
 * Creation date: (5/18/2003 11:57:02 AM)
 * @author: Asima Silva
 */
public class JugglerWindowTupleList
	extends JugglerTupleList
	implements Serializable {
	protected JugglerTupleList jList;
	protected JugglerWindowTupleList prevWTL;
	protected JugglerWindowTupleList nextWTL;

	/**
	 * JugglerWindowTupleList constructor.
	 */
	public JugglerWindowTupleList() {
	}
	/**
	 * JugglerWindowTupleList constructor.
	 * @param tList juggler.stream.JugglerTupleList
	 */
	public JugglerWindowTupleList(
		JugglerTupleList tList,
		boolean byReference) {
		if (byReference) {
			if (jList == null)
				jList = tList.getJugglerTupleListClone();
			this.jList.setTupleReference(tList);
			this.setTuple(jList.getFirstTuple());
			if (!jList.isEmpty())
				this.arrayCell = jList.getFirstTuple().getArrayData();
			else
				this.arrayCell = null;
		} else {
			if (jList == null) {
				//if(jList != null) {
				//this.setTupleReference(jList.getFirstTuple());
				//countWinTupleLists = countWinTupleLists+1;
				//}
				//else {
			if (tList != null){
				jList = tList.getJugglerTupleListClone();
				this.setTuple(jList.getFirstTuple().getJugglerClone());
				
			}
			}
		}

	}
	/**
	 * Appends the tuplelist, tpl to the end of the current JugglerWindowTupleList.
	 * Creation date: (1/27/2003 11:50:48 PM)
	 * @param tpl juggler.stream.JugglerTupleList
	 * @return Iterator
	 */
	public Iterator appendTupleList(JugglerTupleList tpl) {
		JugglerWindowTupleList t1 = this;

		//if this is null, append into this directly
		if (this.getTuple() == null) {
			JugglerWindowTupleList tplWTL =
				new JugglerWindowTupleList(tpl, false);
			this.setTuple(tplWTL.getTuple());
			this.setJList(tplWTL.getJList());
			this.setCount(this.getCount() + 1);

			return new JugglerWindowTupleListIterator(this);
		}

		//
		while (t1.getNextWinTL() != null) {
			t1 = t1.getNextWinTL();
		}
		JugglerWindowTupleList tplWTL = new JugglerWindowTupleList(tpl, false);
		while(tplWTL.getNextWinTL() != null){
			tplWTL = tplWTL.getNextWinTL();
		}
		tplWTL.setPrevWTL(t1);
		t1.setNextWTL(tplWTL);
		//if(t1.getPrevWinTL() != null)
		//t1.getPrevWinTL().nextWTL.setTupleReference(t1.getNextWinTL());
		
		while(t1.getPrevWinTL() != null)
			t1 = t1.getPrevWinTL();

		return new JugglerWindowTupleListIterator(t1);
	}

	/**
	 * Returns the first tuple in the JugglerWindowTupleList.
	 * Creation date: (1/28/2003 10:05:50 AM)
	 * @return juggler.stream.JugglerWindowTupleList
	 */
	public JugglerWindowTupleList getFirstWinTupleList() {
		JugglerWindowTupleList tempPrev = this.prevWTL;
		JugglerWindowTupleList tempCurr = this;

		//if we are already at the head of the list
		//return this Tuple
		if (tempPrev == null)
			return tempCurr;

		//if we are not at the head of the list
		//traverse to the head 
		while (tempPrev != null) {
			JugglerWindowTupleList temptempPrev = tempPrev.getPrevWinTL();
			tempCurr = tempPrev;
			tempPrev = temptempPrev;
		}
		return tempCurr;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/18/2003 1:01:15 PM)
	 * @return juggler.stream.JugglerTupleList
	 */
	public JugglerTupleList getJList() {
		return jList;
	}
	/**
	 * Returns the last tuple in the TupleList.
	 * Creation date: (1/28/2003 10:12:09 AM)
	 * @return juggler.stream.Tuple
	 */
	public JugglerWindowTupleList getLastWinTupleList() {
		JugglerWindowTupleList tempNext = this.nextWTL;
		JugglerWindowTupleList tempCurr = this;

		//if we are already at the tail of the list
		//return this Tuple
		if (tempNext == null)
			return tempCurr;

		//if we are not at the head of the list
		//traverse to the head 
		while (tempNext != null) {
			tempCurr = tempNext;
			tempNext = tempNext.getNextWinTL();
		}
		return tempCurr;
	}
	/**
	 * Returns the next JugglerWindowTupleList.
	 * Creation date: (5/19/2003 9:58:45 PM)
	 * @return juggler.exploitationstructures.JugglerWindowTupleList
	 */
	public JugglerWindowTupleList getNextWinTL() {
		return nextWTL;
	}
	/**
	 * Returns the previous JugglerWindowTupleList.
	 * Creation date: (5/19/2003 9:58:20 PM)
	 * @return juggler.exploitationstructures.JugglerWindowTupleList
	 */
	public JugglerWindowTupleList getPrevWinTL() {
		return prevWTL;
	}
	/**
	 * Returns ??? JugglerTupleList????.
	 * Creation date: (1/28/2003 2:14:51 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesEqual(JugglerTupleList tupleList) {
		return (getTuplesEqual(tupleList.getFirstTuple()));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:13:29 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesGreater(JugglerTupleList tupleList) {
		return (getTuplesGreater(tupleList.getFirstTuple()));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:19:04 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesGreaterAndEq(JugglerTupleList tupleList) {
		return (getTuplesGreaterAndEq(tupleList.getFirstTuple()));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:07:03 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesLess(JugglerTupleList tupleList) {
		return (getTuplesLess(tupleList.getFirstTuple()));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 2:17:55 PM)
	 * @return juggler.stream.TupleList
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTupleList getTuplesLessAndEq(JugglerTupleList tupleList) {
		return (getTuplesLessAndEq(tupleList.getFirstTuple()));
	}

					/**Insert and return tupleList where belongs. If this doesn't
					* return 'this' it is because we are adding to the front of the list.
					* @param t JugglerTupleList
					* @return JugglerWindowTupleList
					*/
					public JugglerWindowTupleList insertByTimeInWinTupleList(
						JugglerTupleList tList,
						ArrayList streamNames,
						int columnInt) {
						JugglerWindowTupleListIterator JWTLIt =
							new JugglerWindowTupleListIterator(this);
						while (JWTLIt.hasNext()) {
							JugglerTupleList aTL = (JugglerTupleList) JWTLIt.next();
							if (aTL.equals(tList))
								return new JugglerWindowTupleList();
						}
				
						JugglerTupleList latestTL = this.jList;
						JugglerWindowTupleList temp = this;
						JugglerWindowTupleList thisLatest = temp;
				/*
						//get to the beginning of liset
						while (temp.getPrevWinTL() != null) {
							temp = temp.getPrevWinTL();
						}	*/
						//find the place where tList needs to be inserted
				
						while (temp.getNextWinTL() != null) {
							if (tList.later(latestTL, columnInt)) {
								latestTL = temp.jList;
								break;
							}
							temp = temp.getNextWinTL();
							if (temp == null)
								break;
							thisLatest = temp;
							latestTL = temp.jList;
						}
				
						JugglerTuple t = tList.getFirstTuple();
				
						if (tList.later(latestTL, columnInt)) {
							// insert into next
							JugglerWindowTupleList n = thisLatest.nextWTL;
							JugglerWindowTupleList p = thisLatest;
							while (n != null && n.jList != null) {
							
								if(tList.later(n.jList, columnInt)){
									p = n;
									n = n.getNextWinTL();
									continue;
								}
								if (tList.later(p.jList, columnInt)) {
									// must add to previous
									JugglerWindowTupleList newT =
										new JugglerWindowTupleList(tList, true);
									newT.setPrevWTL(n.getPrevWinTL());
									newT.setNextWTL(n);
				
									n.getPrevWinTL().setNextWTL(newT);
									n.setPrevWTL(newT);
									
									while(newT.getPrevWinTL() != null){
										newT = newT.getPrevWinTL();
									}
				
									return newT; // safely added after
								}
				
								p = n;
								n = n.getNextWinTL();
							}
				
							p.setNextWTL(new JugglerWindowTupleList(tList, true));
							p.getNextWinTL().setPrevWTL(p);
							while(p.getPrevWinTL() != null){
								p = p.getPrevWinTL();
							}
							return p; // safely added into next.
				
						} else {
				
							// belongs in prev
							JugglerWindowTupleList p = thisLatest.prevWTL;
							JugglerWindowTupleList n = thisLatest;
							while (p != null) {
								// if previous tuple
								if (t.later(p.getTuple())) {
									JugglerWindowTupleList newT =
										new JugglerWindowTupleList(tList, true);
				
									newT.setNextWTL(p);
									if(p.getPrevWinTL() != null)
										newT.setPrevWTL(p.getPrevWinTL());
									if(newT.nextWTL != null)
										newT.nextWTL.setPrevWTL(newT);
									if(newT.getPrevWinTL() != null) {
										newT.getPrevWinTL().setNextWTL(newT);
									}
									while(newT.getPrevWinTL() != null){
										newT = newT.getPrevWinTL();
									}
									return newT;
								}
				
								n = p;
								p = p.getPrevWinTL();
							}
				
							n.setPrevWTL(new JugglerWindowTupleList(tList, true));
							n.getPrevWinTL().setNextWTL(n);
							return n.getPrevWinTL(); // will become new head in the list.
						}
					}

	/**Insert and return tupleList where belongs. If this doesn't
	* return 'this' it is because we are adding to the front of the list.
	* @param t JugglerTupleList
	* @return JugglerWindowTupleList
	*/
	public JugglerWindowTupleList insertByTimeInWinTupleList_Old(
		JugglerTupleList tList,
		ArrayList streamNames,
		int columnInt) {
		JugglerWindowTupleListIterator JWTLIt =
			new JugglerWindowTupleListIterator(this);
		while (JWTLIt.hasNext()) {
			JugglerTupleList aTL = (JugglerTupleList) JWTLIt.next();
			if (aTL.equals(tList))
				return new JugglerWindowTupleList();
		}

		JugglerTupleList latestTL = this.jList;
		JugglerWindowTupleList temp = this;
		JugglerWindowTupleList thisLatest =
			this.getJugglerTupleWindowListClone();
		/*	if(temp.getNextWinTL() != null){
		
			while(tList.later(temp.jList, columnInt)){
				latestTL = temp.jList;
				temp = temp.getNextWinTL();
				if(temp == null)
					break;
				thisLatest = thisLatest.getNextWinTL();
			}*/
		while (temp.getNextWinTL() != null) {
			temp = temp.getNextWinTL();
		}
		latestTL = temp.jList;
		JugglerTuple t = tList.getFirstTuple();

		if (tList.later(latestTL, columnInt)) {
			// insert into next
			JugglerWindowTupleList n = thisLatest.nextWTL;
			JugglerWindowTupleList p = thisLatest;
			while (n != null && n.jList != null) {
				if (n.getFirstTuple().later(t)) {
					// must add to previous
					JugglerWindowTupleList newT =
						new JugglerWindowTupleList(tList, true);
					newT.setPrevWTL(n.getPrevWinTL());
					newT.setNextWTL(n);

					n.getPrevWinTL().setNextWTL(newT);
					n.setPrevWTL(newT);

					return temp; // safely added after
				}

				p = n;
				n = n.getNextWinTL();
			}

			p.setNextWTL(new JugglerWindowTupleList(tList, true));
			p.getNextWinTL().setPrevWTL(p);
			return p.getFirstWinTupleList(); // safely added into next.

		} else {

			// belongs in prev
			JugglerWindowTupleList p = thisLatest.prevWTL;
			JugglerWindowTupleList n = thisLatest;
			while (p != null) {
				// if previous tuple
				if (t.later(p.getTuple())) {
					JugglerWindowTupleList newT =
						new JugglerWindowTupleList(tList, true);

					newT.setNextWTL(n);
					newT.setPrevWTL(p);

					newT.nextWTL.setPrevWTL(newT);
					newT.getPrevWinTL().setNextWTL(newT);
					return newT;
				}

				n = p;
				p = p.getPrevWinTL();
			}

			n.setPrevWTL(new JugglerWindowTupleList(tList, true));
			n.getPrevWinTL().setNextWTL(n);
			return n.getPrevWinTL(); // will become new head in the list.
		}
	}
	/**
	 * Removes a tuple from the JugglerWindowTupleList.
	 * Creation date: (1/27/2003 11:22:41 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerWindowTupleList removeTupleList(JugglerTupleList tuple) {
		long timestamp = tuple.getFirstTuple().getJugglerTimeStamp();
		JugglerWindowTupleList t1 = this;
		while (true) {
			if (t1.jList.getFirstTuple().getJugglerTimeStamp() < timestamp)
				t1 = t1.nextWTL;

			boolean notfound = true;
			while (notfound) {
				if (t1.jList.equals(tuple))
					notfound = false;
				else {
					t1 = t1.nextWTL;
				}
				if (t1 == null)
					return t1;
			}
			if (t1.jList.getFirstTuple().getJugglerTimeStamp() == timestamp) {
				if (t1.prevWTL == null) { // if its the head...
					t1.jList = t1.jList.remove(); //remove the tuple list
					//countWinTupleLists--;
					if (t1.jList != null) {
						t1.setJList(jList);
					} else {
						t1.prevWTL = null;
						t1 = t1.nextWTL;
						if (t1 != null)
							t1.prevWTL = null;
						//t1.data = null;
					}
					return t1;
				} else {
					if (t1.prevWTL != null)
						t1.prevWTL.setNextWTL(t1.nextWTL);
					if (t1.nextWTL != null)
						t1.nextWTL.setPrevWTL(t1.prevWTL);
					if (t1.jList != null)
						t1.jList = t1.jList.remove();
					if (t1.prevWTL != null)
						t1 = t1.prevWTL;
					return t1;
				}
			}
		}

	}

	/**
	 * Insert the method's description here.
	 * Creation date: (2/3/2003 10:10:52 PM)
	 * @return boolean
	 */
	public boolean isEmpty() {
		if (this.getPrevWinTL() == null
			&& this.jList == null
			&& this.getNextWinTL() == null)
			return true;
		else if (
			this.getPrevWinTL() == null
				&& this.jList.isEmpty()
				&& this.getNextWinTL() == null)
			return true;
		else
			return false;
	}

	/**
		 * Insert the method's description here.
		 * Creation date: (1/27/2003 11:08:47 PM)
		 * @param newTuple juggler.stream.Tuple
		 */
	public boolean setTupleReference_XATTuple(JugglerWindowTupleList newTuple) {
		boolean isNotNull = false;
		if (newTuple != null) {
			JugglerWindowTupleList tempTuple = newTuple;
			JugglerTupleList tempTL = tempTuple.getJList();
			while (tempTL != null) {
				isNotNull = jList.setTupleReference_XATTuple(tempTL);
				prevWTL = tempTuple.prevWTL;
				nextWTL = tempTuple.nextWTL;
			}
		} else {
			if (this != null) {
				while (this.jList != null) {
					if (prevWTL != null) {
						this.prevWTL = null;
					}
					isNotNull = this.jList.setTupleReference_XATTuple(null);
					this.jList = null;
					for (int i = 0; i < arrayCell.length; i++) {
						XATDataValue element = (XATDataValue) arrayCell[i];
						element = null;
					}
					this.arrayCell = null;

					//this = this.getNextWinTL();
					if (this.jList != null)
						this.setTupleReference_XATTuple(null);

					if (nextWTL != null) {
						this.nextWTL = null;
					}

					if (timeStamp != null)
						this.timeStamp = null;

				}
			} else
				return true;
		}

		if (!isNotNull) {
			this.jList = null;
			this.prevWTL = null;
			this.nextWTL = null;
			this.arrayCell = null;
		}
		return isNotNull;
	}

	/**
		 * Insert the method's description here.
		 * Creation date: (1/27/2003 11:08:47 PM)
		 * @param newTuple juggler.stream.Tuple
		 */
	public boolean setTupleReference(JugglerWindowTupleList newTuple) {
		boolean isNotNull = false;
		if (newTuple != null) {
			JugglerWindowTupleList tempTuple = newTuple;
			JugglerTupleList tempTL = tempTuple.getJList();
			while (tempTL != null) {
				isNotNull = jList.setTupleReference(tempTL);
				prevWTL = tempTuple.prevWTL;
				nextWTL = tempTuple.nextWTL;
			}
		} else {
			if (this != null) {
				while (this.jList != null) {
					if (prevWTL != null) {
						this.prevWTL = null;
					}
					isNotNull = this.jList.setTupleReference(null);
					this.jList = null;
					for (int i = 0; i < arrayCell.length; i++) {
						KeyDouble element = (KeyDouble) arrayCell[i];
						element = null;
					}
					this.arrayCell = null;

					//this = this.getNextWinTL();
					if (this.jList != null)
						this.setTupleReference(null);

					if (nextWTL != null) {
						this.nextWTL = null;
					}

				}
			} else
				return true;
		}

		if (!isNotNull) {
			this.jList = null;
			this.prevWTL = null;
			this.nextWTL = null;
			this.arrayCell = null;
		}
		return isNotNull;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (5/18/2003 1:01:15 PM)
	 * @param newJList juggler.stream.JugglerTupleList
	 */
	public void setJList(JugglerTupleList newJList) {
		jList = newJList;
		if (newJList != null)
			jList.setTuple(newJList.getFirstTuple());
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/19/2003 9:58:45 PM)
	 * @param newNext juggler.exploitationstructures.JugglerWindowTupleList
	 */
	public void setNextWTL(JugglerWindowTupleList newNext) {
		nextWTL = newNext;
		if (newNext != null) {
			if (nextWTL != null) {
				nextWTL.arrayCell = newNext.arrayCell;
				nextWTL.setJList(newNext.jList);
			}
		} else {
			if (nextWTL != null) {
				nextWTL.arrayCell = null;
				nextWTL.setJList(null);
			}
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/19/2003 9:58:20 PM)
	 * @param newPrev juggler.exploitationstructures.JugglerWindowTupleList
	 */
	public void setPrevWTL(JugglerWindowTupleList newPrev) {
		prevWTL = newPrev;
		if (newPrev != null) {
			prevWTL.arrayCell = newPrev.arrayCell;
			prevWTL.setJList(newPrev.jList);
		} else {
			prevWTL.arrayCell = null;
			prevWTL.setJList(null);
		}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 11:41:58 PM)
	 * @return int
	 */
	public int size() {

		JugglerWindowTupleList temp = this.getFirstWinTupleList();
		int count = 1;

		if (temp.jList == null)
			return 0;
		if (temp.nextWTL == null)
			return 1;

		JugglerWindowTupleList tempNext = nextWTL;
		while (tempNext != null && tempNext.getJList() != null) {
			tempNext = tempNext.nextWTL;
			count++;

		}
		return count;

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/16/2003 9:17:45 PM)
	 * @return java.lang.String
	 */
	public String toString() {

		String tupleListString = "";
		tupleListString += this.getStreamNames().toString();
		//+"\n"+ "Number of JugglerTupleLists: " + this.size() ;
		return tupleListString;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/27/2003 11:50:48 PM)
	 * @param tpl juggler.stream.TupleList
	 * @return Iterator
	 */
	public Iterator appendTupleList(JugglerWindowTupleList tpl) {
		if (this.jList == null) {
			JugglerWindowTupleList tplWTL =
				(JugglerWindowTupleList) tpl.getJugglerTupleWindowListClone();
			this.jList = tplWTL.jList;
			this.nextWTL = tplWTL.nextWTL;
			this.prevWTL = tplWTL.prevWTL;
			this.tuple = tplWTL.tuple;


			JugglerWindowTupleList temp = this.getJugglerTupleWindowListClone();
			while(temp.getPrevWinTL() != null){
				temp = temp.getPrevWinTL();
			}

			return new JugglerWindowTupleListIterator(temp);
		} else {
			JugglerWindowTupleList jWTL = this;
			while (jWTL.getNextWinTL() != null) {
				jWTL = jWTL.getNextWinTL();
			}
			JugglerWindowTupleList tplWTL =
				(JugglerWindowTupleList) tpl.getJugglerTupleWindowListClone();

			tplWTL.setPrevWTL(jWTL);
			jWTL.nextWTL = tplWTL;

			while (jWTL.prevWTL != null) {
				jWTL = jWTL.prevWTL;
			}

			return new JugglerWindowTupleListIterator(jWTL);
		}

	}

	/**
	 * Insert the method's description here.
	 * Creation date: (5/20/2003 3:04:15 PM)
	 * @return juggler.stream.JugglerTuple
	 * @param StreamName java.util.ArrayList
	 */
	public JugglerTupleList getTupleListStream(ArrayList StreamName) {
		JugglerWindowTupleList currTupleList = this;

		while (currTupleList.getJList() != null) {
			if (StreamName.containsAll(currTupleList.getStreamNames()))
				return currTupleList.getJList();
			currTupleList = currTupleList.getNextWinTL();
		}

		return null;
	}
	/**
	 * @param list
	 */
	public void appendTupleList_IfNotContained(JugglerWindowTupleList list) {
		JugglerWindowTupleList tupleTemp = list;
		JugglerWindowTupleListIterator tupleTempIt = new JugglerWindowTupleListIterator(tupleTemp);

		if (this.getFirstWinTupleList().jList == null) {
			this.appendTupleList(list);
			return;
		}

		JugglerWindowTupleList newAppendedList = this;
		JugglerWindowTupleList temp = this.getJugglerTupleWindowListClone();

		while (tupleTempIt.hasNext()) {
			JugglerTupleList newTuple = (JugglerTupleList) tupleTempIt.next();
			while (newAppendedList.getPrevWinTL() != null) {
				newAppendedList = newAppendedList.getPrevWinTL();
			}
			while (newAppendedList != null) {
				if (newAppendedList.jList.equals(newTuple)) {
					newAppendedList
						.jList
						.getFirstTuple()
						.getPredicates()
						.combineBitSets(
						list.jList.getFirstTuple().getPredicates());
					break;
				} 
				newAppendedList = newAppendedList.getNextWinTL();
			}
			newAppendedList = this;
			newAppendedList.appendTupleList(newTuple);
			tupleTemp = tupleTemp.getNextWinTL();
		}

	}

	/**
	 * @param list
	 */
	public void appendTupleList_IfNotContained(JugglerTupleList list) {

		JugglerTupleList tupleTemp = list;

		if (this.getFirstWinTupleList().jList == null) {
			this.appendTupleList(list);
			return;
		}

		JugglerWindowTupleList newAppendedList = this;

		JugglerWindowTupleList temp = this;
		while(temp.getPrevWinTL() != null){
			temp = temp.getPrevWinTL();
		}
		
		while (temp != null) {
			if (temp.jList.equals(tupleTemp)) {
				temp.jList.getFirstTuple().getPredicates().combineBitSets(
					tupleTemp.getFirstTuple().getPredicates());
				return;
			}
			temp = temp.nextWTL;
		}
		//if not in the list, append it to the end.
		this.appendTupleList(tupleTemp);
		return;
	}

	/**
						 * Sets the predicate bitset of the tuple.
						 * Creation date: (1/10/2003 12:06:02 AM)
						 * @param newPredicates juggler.stream.PredicateBitSet
						 */
	public JugglerWindowTupleList getJugglerTupleWindowListClone() {
		JugglerWindowTupleList newTL = new JugglerWindowTupleList();
		JugglerWindowTupleList temp = this;

		JugglerWindowTupleList nextTempTL = new JugglerWindowTupleList();

		while (temp != null && temp.jList != null) {
			newTL.jList = temp.jList.getJugglerTupleListClone();
			newTL.tuple = temp.tuple.getJugglerClone();

			if (temp.nextWTL != null) {
				newTL.nextWTL = new JugglerWindowTupleList();
				newTL.nextWTL.prevWTL = new JugglerWindowTupleList();
				newTL.nextWTL.prevWTL = newTL;

			}
			if (newTL.prevWTL != null) {
				//to make sure this isn't hte first tuple when prev is null
				newTL.prevWTL.nextWTL = new JugglerWindowTupleList();
				newTL.prevWTL.nextWTL = newTL;
			}

			temp = temp.nextWTL;
			if (temp != null)
				newTL = newTL.nextWTL;
			else {
				if (newTL.nextWTL != null) { //add the last tuple reference
					//newTL.next.prev = new JugglerTupleList();
					//newTL.next.prev.setTupleReference(newTL);
				}
			}
		}

		if (newTL != null) {
			while (newTL.prevWTL != null) {
				newTL = newTL.prevWTL;
			}
		}

		return newTL;
	}

}
