package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple;

import java.util.NoSuchElementException;
/**
 * Returns simplifying iterator over JugglerTupleList
 * Creation date: (1/25/2003 12:03:19 AM)
 * @author: Administrator
 */
public class JugglerWindowTupleListIterator implements java.util.Iterator {
	/** Head. */
	JugglerWindowTupleList head;
/**
 * TupleListIterator constructor. The head specifes the first element in the 
 * JugglerWindowTupleList.
 */
public JugglerWindowTupleListIterator(JugglerWindowTupleList head) {
	super();

	this.head = head;
}
/**
 * Returns the head of the JugglerWindowTupleList.
 * Creation date: (1/28/2003 11:33:16 PM)
 * @return juggler.stream.JugglerWindowTupleList
 */
public JugglerWindowTupleList getHead() {
	return head;
}
/**
 * Returns the head of the JugglerWindowTupleList.
 * Creation date: (1/29/2003 10:31:33 PM)
 * @return juggler.stream.JugglerWindowTupleList
 */
public JugglerWindowTupleList getWindowTupleList() {
	return head;
}
	/**
	 * Returns <tt>true</tt> if the iteration has more elements. (In other
	 * words, returns <tt>true</tt> if <tt>next</tt> would return an element
	 * rather than throwing an exception.)
	 *
	 * @return <tt>true</tt> if the iterator has more elements.
	 */
public boolean hasNext() {
	return (head != null);
}
	/**
	 * Returns the next element in the interation.
	 *
	 * @returns the next element in the interation.
	 * @exception NoSuchElementException iteration has no more elements.
	 */
public Object next() {
	if (head == null) throw new NoSuchElementException ("No More Tuples.");
		
	JugglerWindowTupleList tl = head;
	head = head.nextWTL;
	return tl.jList;
}
	/**
	 * 
	 * Removes from the underlying collection the last element returned by the
	 * iterator (optional operation).  This method can be called only once per
	 * call to <tt>next</tt>.  The behavior of an iterator is unspecified if
	 * the underlying collection is modified while the iteration is in
	 * progress in any way other than by calling this method.
	 *
	 * @exception UnsupportedOperationException if the <tt>remove</tt>
	 *		  operation is not supported by this Iterator.
	 
	 * @exception IllegalStateException if the <tt>next</tt> method has not
	 *		  yet been called, or the <tt>remove</tt> method has already
	 *		  been called after the last call to the <tt>next</tt>
	 *		  method.
	 */
public void remove() {
	// this could be supported! And could be a way of managing the cleanup
	throw new NoSuchElementException ("Unsupported.");

}
/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 11:33:16 PM)
 * @param newHead juggler.stream.TupleList
 */
public void setHead(JugglerWindowTupleList newHead) {
	head = newHead;
}
}
