package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation;

import java.io.Serializable;
import java.util.BitSet;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;
/**
 * Insert the type's description here.
 * Creation date: (5/5/2003 11:59:00 AM)
 * @author: Asima Silva
 */
public class ExtGeneralTypeBitSet implements IExtPredicateTypeBitSet, Serializable{

/* ArrayList of Predicate BitSets to represent if teh predicate is Relevant or Evaluated */	
protected GeneralPredicateBitSet isEvaluated_Relevant;
	protected GeneralPredicateBitSet predBSList;
/**
 * AttributeTypeBitSet constructor comment.
 */
public ExtGeneralTypeBitSet() {
	super();
	predBSList = new GeneralPredicateBitSet();
	isEvaluated_Relevant = new GeneralPredicateBitSet(this.getPredType());
	this.predBSList = new GeneralPredicateBitSet(this.getPredType());
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:25:57 PM)
 * @param predName java.lang.String
 */
public ExtGeneralTypeBitSet(String predName) {
	super();
	isEvaluated_Relevant = new GeneralPredicateBitSet(predName);
	predBSList = new GeneralPredicateBitSet(predName);
	}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 1:11:30 PM)
 * @return java.lang.Object
 */
public Object getClone() {
	ExtGeneralTypeBitSet extpbs = new ExtGeneralTypeBitSet();
	try {
		extpbs.predBSList = (GeneralPredicateBitSet) predBSList.getClone();
		extpbs.isEvaluated_Relevant= (GeneralPredicateBitSet) isEvaluated_Relevant.getClone();
		
	}
	catch (Exception e) {
        System.out.println(e.toString());
        e.printStackTrace();
	}
	
  
    return extpbs;
}
/**
 * Insert the method's description here.
 * Creation date: (4/28/2003 2:12:38 PM)
 * @return java.util.ArrayList
 */
public GeneralPredicateBitSet getIsEvaluated_Relevant() {
	return isEvaluated_Relevant;
}
/**
 * Insert the method's description here.
 * Creation date: (5/6/2003 11:27:47 PM)
 * @return juggler.stream.PredicateBitSet
 */
public GeneralPredicateBitSet getPredBSList() {
	return predBSList;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:26:33 PM)
 * @return java.lang.String
 */
public java.lang.String getPredType() {
	return predBSList.getPredicateType();
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 11:50:17 AM)
 * @return java.util.ArrayList
 */
public java.util.ArrayList getSetBitIndexes(){
return predBSList.getSetBitIndexes();
}
/**
 * Returns true if the bitset[] is a superset of the attribute bitset[] of this predicateBitSet.
 * Creation date: (1/9/2003 11:48:46 PM)
 * @return boolean
 * @param param ArrayList
 * @exception java.lang.IndexOutOfBoundsException The exception description.
 */
public boolean isSuperset(BitSet[] param, BitSet[] isEvalRel) {
    //if the given bitset is anded with parameter bitset 
    //if it results in the same value as attribute bitset, then this is a superset

    for (int i = 0; i < predBSList.getPredicateBitSets().length; i++) {
        BitSet thisEvalRel = (BitSet) isEvaluated_Relevant.getPredicateBitSets()[i];
        BitSet paramEalRel = (BitSet) isEvalRel[i];

        //check if the list is even relevant for the query
        BitSet resultBS = (BitSet)thisEvalRel.clone();
        BitSet clearBS = new BitSet(thisEvalRel.size());
        resultBS.or(thisEvalRel);
        if (resultBS.equals(clearBS))
            continue;

        //check if the list was even compared for the tuple
        
        BitSet paramResultBS =(BitSet) paramEalRel.clone();
        BitSet paramClearBS = new BitSet(paramEalRel.size());
        paramResultBS.or(paramClearBS);
        if (paramResultBS.equals(paramClearBS))
            continue;

        //this implies that some parts of the list are relevant to the query, and the list has been processed by the tuple
        //there fore if any part of the list is set/relevant, it also must be set for the tuple
        for (int j = 0; j < thisEvalRel.size(); j++) {
            BitSet paramBS = (BitSet) param[i];
            BitSet thisBS = (BitSet) predBSList.getPredicateBitSets()[i];
            //for each predicate int this list taht is relevant to the query and the tuple
            if (thisEvalRel.get(j)) {
                if (paramBS.get(j))
                    continue;
                else
                    return false;
            }
        }
    }

    return true;
}
/**
 * Insert the method's description here.
 * Creation date: (5/6/2003 9:44:19 PM)
 * @return boolean
 * @param extPBS juggler.stream.ExtGeneralTypeBitSet
 */
public boolean isSuperset(ExtGeneralTypeBitSet extPBS) throws java.lang.IndexOutOfBoundsException {

	if (this.getPredBSList().isSuperset(extPBS.getPredBSList()))
		return true;
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (4/28/2003 2:12:38 PM)
 * @param newIsEvaluated_Relevant_Attribute java.util.ArrayList
 */
public void setIsEvaluated_Relevant(GeneralPredicateBitSet newIsEvaluated_Relevant) {
	isEvaluated_Relevant = newIsEvaluated_Relevant;
}
/**
 * Insert the method's description here.
 * Creation date: (3/11/2003 10:34:59 PM)
 * @param bp juggler.predicatestructure.BitPosition
 */
public void setMostCoveringBits(BitPosition bp) {
    int listIndex = bp.getPredListIndex();

    GeneralPredicateBitSet bs = (GeneralPredicateBitSet) isEvaluated_Relevant;
    bs.setMostCoveringBits(bp);

    predBSList.setMostCoveringBits(bp);

}
/**
 * Insert the method's description here.
 * Creation date: (3/11/2003 10:34:59 PM)
 * @param bp juggler.predicatestructure.BitPosition
 */
public void setMostCoveringBits(BitPosition bp, int sizeList) throws IndexOutOfBoundsException {
    int listIndex = bp.getPredListIndex();
    
//chec for exception!!!!
   isEvaluated_Relevant.setMostCoveringBits(bp);
   predBSList.setMostCoveringBits(bp);

}
/**
 * Insert the method's description here.
 * Creation date: (5/6/2003 11:27:47 PM)
 * @param newBSList juggler.stream.PredicateBitSet
 */
public void setPredBSList(GeneralPredicateBitSet newBSList) {
	predBSList = newBSList;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:24:49 PM)
 * @param newPredicateTypeName int
 */
public void setPredicateTypeName(String newPredicateTypeName) {
	this.setPredicateTypeName(newPredicateTypeName);
}
/**
 * List Index is one greater than its position in the arrayList
 * Creation date: (3/8/2003 9:09:09 PM)
 * @return java.lang.String
 */
public String toString() {

    String extgenps = "";
    extgenps += "Predicate Type: " + this.getPredType() + "\n";
    extgenps += "Relevant:\n";
    GeneralPredicateBitSet relPredTypeList =
        (GeneralPredicateBitSet) isEvaluated_Relevant;
    extgenps += relPredTypeList.toString();
	extgenps += "Predicates Satisfied: \n";
    extgenps += predBSList.toString();

    return extgenps;

}

/**
 * Insert the method's description here.
 * Creation date: (4/14/2003 6:58:27 PM)
 * @param param juggler.stream.PredicateBitSet
 */
public void combineBitSets(ExtGeneralTypeBitSet param) {
   this.isEvaluated_Relevant.combineBitSets(param.isEvaluated_Relevant);
   this.predBSList.combineBitSets(param.predBSList);
}
}
