package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;
/**
 * Insert the type's description here.
 * Creation date: (5/5/2003 1:44:15 PM)
 * @author: Asima Silva
 */
public class GeneralPredicateBitSet implements IPredicateBitSet, Serializable {
/* ArrayList of BitSets */	
public BitSet[] predicateBitSets;
	protected java.lang.String predicateTypeName;
/**
 * GeneralPredicateBitSet constructor comment.
 */
public GeneralPredicateBitSet() {
	super();
	predicateBitSets = new BitSet[1];
	predicateTypeName = "";
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:04:33 PM)
 * @param predicateTypeName java.lang.String
 */
public GeneralPredicateBitSet(String newpredicateTypeName) {
	super();
	predicateTypeName = newpredicateTypeName;
	predicateBitSets = new BitSet[1];
	}
/**
 * Insert the method's description here.
 * Creation date: (4/14/2003 6:58:27 PM)
 * @param param juggler.stream.PredicateBitSet
 */
public void combineBitSets(IPredicateBitSet param) {
    //or all the bitsets, of this tuple and of the other tuple's predicate bitset parameter
    for (int attr = 0; attr < predicateBitSets.length; attr++) {
        BitSet attrBS = (BitSet) predicateBitSets[attr];
        if (param.getPredicateBitSets().length > 0) {
            BitSet paramBS = (BitSet) param.getPredicateBitSets()[attr];
            attrBS.or(paramBS);
        }
    }
}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 1:11:30 PM)
 * @return java.lang.Object
 */
public Object getClone() {
    GeneralPredicateBitSet pbs = new GeneralPredicateBitSet();
    pbs.setPredicateBitSets(new BitSet[this.predicateBitSets.length]);
    try {

	    for (int i = 0; i < this.predicateBitSets.length; i++) {
		    BitSet aPBS = (BitSet) predicateBitSets[i]; 
		    if(aPBS != null)
        pbs.predicateBitSets[i] = (BitSet) aPBS.clone();

	    }
            pbs.predicateTypeName = predicateTypeName;

    } catch (Exception e) {
        System.out.println(e.toString());
        e.printStackTrace();
    }
    return pbs;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 12:36:54 PM)
 * @return juggler.stream.IPredicateBitSet
 */
public BitSet[] getPredicateBitSets() {
	return this.predicateBitSets;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:02:59 PM)
 * @return java.lang.String
 */
public java.lang.String getPredicateType() {
	return predicateTypeName;
}
/**
 * Returns the bit positions of all the set attributes.
 * Creation date: (1/9/2003 11:52:49 PM)
 * @return ArrayList
 */
public ArrayList getSetBitIndexes() {

    int size = this.getPredicateBitSets().length;
    ArrayList bitPositions = new ArrayList(size);

    BitPosition tempBP = new BitPosition();

    for (int i = 0; i < predicateBitSets.length; i++) {
        //get the attribute bitset in order
        tempBP.setPredListIndex(i);
        BitSet bset = (BitSet) predicateBitSets[i];
        //traverse each bit in the attribute bitset to see if its set
        for (int j = 0; j < bset.size(); j++) {
            if (bset.get(j)) {
                //if this is set then create the bitPosition and set in our array
                tempBP.setPredIndex(j);

                try {
                    bitPositions.add((BitPosition) tempBP.clone());
                } catch (CloneNotSupportedException e) {
                    System.err.println();
                    e.printStackTrace();
                }
            }
        }
    }
    return bitPositions;
}
/**
 * List Index is one greater than its position in the arrayList
 * Creation date: (3/8/2003 9:09:09 PM)
 * @return java.lang.String
 */
public String getSetBitsToString() {

    String predBSstring = "";

    if (this.getPredicateBitSets() != null) {

        ArrayList attrBitPos = this.getSetBitIndexes();
        predBSstring += "Attribute BitPositions" + "\n";

        //the index of the array list is the index of the list
        for (int i = 0; i < attrBitPos.size(); i++) {
            BitSet attrbp = (BitSet) attrBitPos.get(i);
            for (int s = 0; s < attrbp.size(); s++) {
                if (attrbp.get(s)) {
                    predBSstring += "List: " + i + " Predicate Index: " + s + "\n";
                }
            }

        }
        predBSstring += "\n";

    }

    return predBSstring;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 1:44:15 PM)
 * @return java.util.ArrayList
 */
public ArrayList getUnsetBitIndexes() {
	return null;
}
/**
 * Returns the bit positions of all the unset attributes.
 * Creation date: (1/9/2003 11:50:20 PM)
 * @return ArrayList
 */
public ArrayList getUnSetBitIndexes() {
    ArrayList bp = new ArrayList(predicateBitSets.length);

    BitPosition tempBP = new BitPosition();

    for (int i = 0; i < predicateBitSets.length; i++) {
        //get the attribute bitset in order
        tempBP.setPredListIndex(i);
        BitSet bset = (BitSet) predicateBitSets[i];
        //traverse each bit in the  attribute bitset to see if its set
        for (int j = 0; j < bset.size(); j++) {
            if (!bset.get(j))
                tempBP.setPredIndex(j);
        }

        try {
            bp.add((BitPosition) tempBP.clone());
        } catch (CloneNotSupportedException e) {
            System.err.println();
            e.printStackTrace();
        }
    }
    return bp;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 12:36:54 PM)
 * @return boolean
 * @param paramBS juggler.stream.IPredicateBitSet
 */
public boolean isSuperset(BitSet paramBS) {
	//if the given bitset is anded with parameter bitset 
    //if it results in the same value as attribute bitset, then this is a superset

    for(int i = 0; i < predicateBitSets.length; i++) {
        BitSet andBS = (BitSet) predicateBitSets[i];
        BitSet resultBS = (BitSet) andBS.clone();
        resultBS.and(paramBS);
        if (resultBS.equals(andBS))
            return true;
        else
            return false;
    }
    return false;
}
/**
 * Returns true if the bitset[] is a superset of the attribute bitset[] of this predicateBitSet.
 * Creation date: (1/9/2003 11:48:46 PM)
 * @return boolean
 * @param param ArrayList
 * @exception java.lang.IndexOutOfBoundsException The exception description.
 */
public boolean isSuperset(GeneralPredicateBitSet param)
     {
    return this.isSuperSetOfAll(param.getPredicateBitSets());
}
/**
 * Returns true if the bitset[] is a superset of the attribute bitset[] of this predicateBitSet.
 * Creation date: (1/9/2003 11:48:46 PM)
 * @return boolean
 * @param param ArrayList
 * @exception java.lang.IndexOutOfBoundsException The exception description.
 */
public boolean isSuperSetOfAll(BitSet[] param)
    throws java.lang.IndexOutOfBoundsException {
    //if the given bitset is anded with parameter bitset 
    //if it results in the same value as attribute bitset, then this is a superset

    if (param.length != predicateBitSets.length)
        throw new IndexOutOfBoundsException("The attribute bitset parameter passes in is not the appropriate size.");

    for (int i = 0; i < predicateBitSets.length; i++) {

		 
        BitSet andBS = (BitSet) predicateBitSets[i];
        BitSet currBSToTest = (BitSet) param[i];
        BitSet currBSClone = (BitSet) currBSToTest.clone();
        BitSet resultBS = (BitSet) currBSToTest.clone();

        resultBS.and(currBSClone);
        if (!resultBS.equals(andBS))
            return false;
    }
    return true;
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:03:45 PM)
 * @param bp juggler.predicatestructure.BitPosition
 */
public void setBitPosition(BitPosition bp) {
	
    int listIndex = bp.getPredListIndex();
    BitSet attributePredList = (BitSet) this.getPredicateBitSets()[listIndex];
    if (bp.getPredIndex() >= 0)
    attributePredList.set(bp.getPredIndex());
    	

}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 12:36:54 PM)
 * @return java.lang.String
 */
public String setBitsToString() {
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (3/11/2003 10:34:59 PM)
 * @param bp juggler.predicatestructure.BitPosition
 */
public void setMostCoveringBits(BitPosition bp) {
    int listIndex = bp.getPredListIndex();

    BitSet bs = (BitSet) predicateBitSets[listIndex];

    int sizeOfCovBits = bp.getPredIndex();
    for (int i = 0; i <= sizeOfCovBits; i++) {
        bs.set(i);
    }

}
/**
 * Sets the size of the attribute bitset.
 * Creation date: (1/9/2003 11:56:24 PM)
 * @param attrBitSize juggler.predicatestructure.BitPosition
 */
public void setNumBits(BitPosition attrBitSize) {
    //get the appropriate attribute bitset
    BitSet tempBS = (BitSet) predicateBitSets[attrBitSize.getPredListIndex()];
    
    	tempBS.set(attrBitSize.getPredIndex());

    	this.predicateBitSets[attrBitSize.getPredIndex()] = tempBS; 
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 12:36:54 PM)
 * @param newBS java.util.ArrayList
 */
public void setPredicateBitSets(BitSet[] newBS) {
	predicateBitSets = newBS;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:02:59 PM)
 * @param newPredicateType java.lang.String
 */
public void setPredicateType(java.lang.String newPredicateType) {
	predicateTypeName = newPredicateType;
}
/**
 * List Index is one greater than its position in the arrayList
 * Creation date: (3/8/2003 9:09:09 PM)
 * @return java.lang.String
 */
public String toString() {

    String predBSstring = "";

    if (this.predicateBitSets.length != 0) {

        BitSet[] predBitSets = this.getPredicateBitSets();
        predBSstring += this.getPredicateType() + " BitPositions" + "\n";

        for (int i = 0; i < predBitSets.length; i++) {
            BitSet predbs = (BitSet) predBitSets[i];
            for (int s = 0; s < predbs.size(); s++) {
                int listIndexAttr = i;
                if (predbs.get(s)) {
	                predBSstring += "List: " + listIndexAttr + " Predicate Index: " + s;
                    predBSstring += " set" + "\n";
                }
            }
        }

        predBSstring += "\n";

    }

  
    return predBSstring;

}
}
