package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;

import java.io.Serializable;
import java.util.Collections;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyInterface;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate;

/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 8:19:17 PM)
 * @author: Administrator
 */
public class AttrPredOrderList extends OrderList implements Serializable{
/**
 * AttrPredOrderList constructor comment.
 */
public AttrPredOrderList() {
	super();
}
/**
 * Deletes the specified predicate from the list.
 * Creation date: (1/9/2003 8:29:31 PM)
 * @param predicate juggler.predicatestructure.AttrPredicate
 */
public void deletePredicate(AttrPredicate predicate) {}
/**
 * Inserts the Predicate in the Predicate Linked List.
 * It returns the corresponding BitPosition of the Predicate.
 * Creation date: (1/9/2003 8:03:41 PM)
 * @return juggler.predicatestructure.BitPosition
 * @param predicate juggler.predicatestructure.Predicate
 */
public BitPosition insertPredicate(
AttrPredicate predicate) {

	//check if the predicate already exists
	if (predicateList.contains(predicate)) {
		AttrPredicate p =
			(AttrPredicate) predicateList.get(predicateList.indexOf(predicate));
			//add in the query number iDs for the predicate
		Iterator qIt = predicate.getQueryNumIDs().iterator();
		while (qIt.hasNext()) {
			String itemp = (String) qIt.next();
			if (!p.getQueryNumIDs().contains(itemp))
				p.addQueryID(new Integer(itemp).intValue());
		}
		return (new BitPosition(this.getListIndex(), predicateList.indexOf(predicate)));
	}

	int index = 0;

	if (predicateList.isEmpty()) {
		predicateList.add(0, predicate);
		//return the first predicate bitposition
		return (new BitPosition(this.getListIndex(), 0));
	} else {
		Iterator list = predicateList.iterator();
		while (list.hasNext()) {
			AttrPredicate p = (AttrPredicate) list.next();
			index = Collections.binarySearch(predicateList, predicate);
			//if the key is the greatest
			//if the index is between 0 and predicateList size
			if (index < predicateList.size() && index >= 0) {
				predicateList.add(index, predicate);
				break;
			}
			//if the index is the list size, it is greater than all the predicates in the list
			if (index == predicateList.size()) {
				predicateList.add(predicateList.size() + 1, predicate);
				break;
				//if the index should be somewhere in the middle of the list
			} else {
				//inserts the predicate in teh appropriate position
				predicateList.add(Math.abs(index) - 1, predicate);
				break;
			}
		}
	}
	return null;
}

/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:29:31 PM)
 * @param predListName java.lang.String
 */
public AttrPredOrderList(String predListName) {
	super();
	this.setListName(predListName);
	
	}

/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Insert code to compare the receiver and obj here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: obj might be an instance of any class
	//return super.equals(obj);
	AttrPredOrderList o = (AttrPredOrderList) obj;

	if (o.getColumn1() == this.getColumn1()
		&& o.getOp().equals(this.getOp())
		&& o.getStreamName1().equals(this.getStreamName1()))
		return true;
	else
		return false;
}

/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 9:30:05 PM)
 * @return java.lang.String
 */
public String toString() {

	String predListStr = "";
	
	Iterator it = this.getList().iterator();
	while (it.hasNext()) {
		AttrPredicate p = (AttrPredicate) it.next();
		predListStr += p.toString() + "\n";
	}

	return predListStr;
}

/**
 * Finds the most covering predicate for the specified tuple.
 * Creation date: (1/9/2003 8:12:57 PM)
 * @param tuple juggler.stream.Tuple
 * @return int
 */
public int findMostCovering(JugglerTuple tuple) {
	
KeyInterface compareToValue;

	java.util.LinkedList llist = this.getList();
	edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate pTemp = null;

	while (!llist.isEmpty()) {
		int index = llist.size()/2;

		AttrPredicate p = (AttrPredicate) llist.get(index);

		int predResult = p.evaluate(tuple);

		//if the predicate is equal, then try to find the one that is the most covering predicate
		if (predResult == 0) {
			pTemp = p;
			java.util.Iterator subListIt = llist.iterator();
			boolean foundAnotherMostCovering = false;
			while (subListIt.hasNext()) {
				p = (AttrPredicate) subListIt.next();
				predResult = p.evaluate(tuple) ;
				if (predResult == 0) 
					pTemp = p;
		
					//found the most covering
				if (predResult > 0)
					break;
			}	
			break;
		}
		//if the predicate is greater, then find the predicate in the lower part of the list
		if (predResult == -1) {
			//if htis is the last predicate to be tested and to avoid looping 
			if (index == 0) {
				return -1;
			}
			// changed from sublist(0, index+1)
			llist = new java.util.LinkedList (this.getList().subList(0, index));
		}
		//if the predicate is lesser, then find the predicate in the higher part of the list
		if (predResult == 1) {
			//if htis is the last predicate to be tested and to avoid looping
			//changed from this.getList().size()
			if (index == llist.size()-1) {
				pTemp = (AttrPredicate) llist.get(index);

				//if its an equal operator, do not accept any predResult except 0
				if (p.getOp().toString() == "=")
					return -1;
				
				return index;
			}
			llist =  new java.util.LinkedList(this.getList().subList(index, this.getList().size()));
		}
		
		
	}
	//returns the index of hte most covering predicate
	return this.getList().indexOf(pTemp);
	}
/**
 * @param firstTuple
 * @return
 */
public int findMostCovering_XATTuple(JugglerTuple tuple) {
		
	KeyInterface compareToValue;

		java.util.LinkedList llist = this.getList();
		edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate pTemp = null;

		while (!llist.isEmpty()) {
			int index = llist.size()/2;

			AttrPredicate p = (AttrPredicate) llist.get(index);

			int predResult = p.evaluate_XATTuple(tuple);

			//if the predicate is equal, then try to find the one that is the most covering predicate
			if (predResult == 0) {
				pTemp = p;
				java.util.Iterator subListIt = llist.iterator();
				boolean foundAnotherMostCovering = false;
				while (subListIt.hasNext()) {
					p = (AttrPredicate) subListIt.next();
					predResult = p.evaluate_XATTuple(tuple) ;
					if (predResult == 0) 
						pTemp = p;
		
						//found the most covering
					if (predResult > 0)
						break;
				}	
				break;
			}
			//if the predicate is greater, then find the predicate in the lower part of the list
			if (predResult == -1) {
				//if htis is the last predicate to be tested and to avoid looping 
				if (index == 0) {
					return -1;
				}
				// changed from sublist(0, index+1)
				llist = new java.util.LinkedList (this.getList().subList(0, index));
			}
			//if the predicate is lesser, then find the predicate in the higher part of the list
			if (predResult == 1) {
				//if htis is the last predicate to be tested and to avoid looping
				//changed from this.getList().size()
				if (index == llist.size()-1) {
					pTemp = (AttrPredicate) llist.get(index);

					//if its an equal operator, do not accept any predResult except 0
					if (p.getOp().toString() == "=")
						return -1;
				
					return index;
				}
				llist =  new java.util.LinkedList(this.getList().subList(index, this.getList().size()));
			}
		
		
		}
		//returns the index of hte most covering predicate
		return this.getList().indexOf(pTemp);
}
}
