package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleListIterator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.IPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;

/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 8:39:25 PM)
 * @author: Administrator
 */
public class AttrPredOrderListS extends OrderListS implements Serializable{
/**
 * PredOrderListS constructor comment.
 */
public AttrPredOrderListS() {
	super();
	//PredOrderLists = new ArrayList();
	
}
/**
 * Insert the method's description here.
 * Creation date: (3/4/2003 9:39:13 PM)
 * @param attrPred AttrPredicate
 */
public void insertIntoPredList(AttrPredicate attrPred) {

	//see if you can find a pred list for this predicate
	boolean foundList = false;
	//ArrayList bitPositions = new ArrayList();
    
	for (int i = 0; i < OrderLists.size(); i++) {
		AttrPredOrderList attrPredList = (AttrPredOrderList) OrderLists.get(i);
		if (attrPred.getOp().equals(attrPredList.getOp())
			&& attrPred.getS1().getStreamName() == attrPredList.getStreamName1()
			&& attrPred.getS1().getColumn() == attrPredList.getColumn1()) {
			//bitPositions.add(attrPredList.insertPredicate(attrPred));
			attrPredList.insertPredicate(attrPred);
			foundList = true;
		}
	}

	if (foundList == false) {
		//this implies that there is not PredOrderList created for this predicate
		AttrPredOrderList attrList = new AttrPredOrderList();
		attrList.setColumn1(attrPred.getS1().getColumn());
		attrList.setOp(attrPred.getOp());
		attrList.setStreamName1(attrPred.getS1().getStreamName());
		attrList.setListIndex(this.getOrderLists().size());
		//bitPositions.add(attrList.insertPredicate(attrPred));
		attrList.insertPredicate(attrPred);
		this.insertOrderList(attrList);

	}

	//return bitPositions;
}
/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 9:30:05 PM)
 * @return java.lang.String
 */
public String toString() {

	String orderList = "";
	for (int i = 0; i < this.getOrderLists().size(); i++) {
		AttrPredOrderList attrOrderList = (AttrPredOrderList) this.getOrderLists().get(i);
		orderList += "ListIndex: " +attrOrderList.getListIndex() +"\n ";
		orderList += attrOrderList.toString()+"\n"+"\n";
	}
	return orderList;
}

/**
 * Find most covering predicates for each predicate list in PredOrderLists.
 * The bitsets will be set on teh first tuple the tupleList
 * ArrayList of BitPositions
 * Creation date: (1/9/2003 8:50:54 PM)
 * @param tuple juggler.stream.JugglerTuple
 */
public JugglerTupleList findMostCovering(JugglerTupleList tuples) {
	ArrayList coveringBitPositions = new ArrayList();

	Iterator it = this.OrderLists.iterator();

	int setListIndex = 0;
	int setIndex = 0;

	while (it.hasNext()) {
		AttrPredOrderList olist = (AttrPredOrderList) it.next();
		setListIndex = olist.getListIndex();
		JugglerTupleListIterator tuplesIt =
			new JugglerTupleListIterator(tuples);

		while (tuplesIt.hasNext()) {
			JugglerTuple tuple = (JugglerTuple) tuplesIt.next();
			//if the list applies to the tuple's streamName
			if (tuple.getStreamNames().containsAll(olist.getStreamName1())) {
				setIndex = olist.findMostCovering(tuple);
				if (setIndex >= 0) {
					BitPosition bp =
						new BitPosition(setListIndex, setIndex);

					//set the the tuple's bit position
					tuples.getTuple().getPredicates().getAppropriatePredicateTypeExt("attribute").setMostCoveringBits(bp, olist.size());
				}
			}
			else
				tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("attribute").getPredicateBitSets()[setListIndex] = new BitSet(olist.size());
		}
	}
	return tuples;
}

/**
 * Sets the predicate bits of the tuple.
 * Creation date: (1/9/2003 8:45:20 PM)
 * @param tuple juggler.stream.Tuple
 * @param ArrayList bitPositions
 */
public void setPredicates(JugglerTuple tuple, ArrayList bitPositions) {

	Iterator it = bitPositions.iterator();

	while (it.hasNext()) {
		BitPosition bp = (BitPosition) it.next();
			
	}
}
/**
 * @param tuples
 * @return
 */
public JugglerTupleList findMostCovering_XATTuple(JugglerTupleList tuples) {
	ArrayList coveringBitPositions = new ArrayList();

	Iterator it = this.OrderLists.iterator();

	int setListIndex = 0;
	int setIndex = 0;

	while (it.hasNext()) {
		AttrPredOrderList olist = (AttrPredOrderList) it.next();
		setListIndex = olist.getListIndex();
		JugglerTupleListIterator tuplesIt =
			new JugglerTupleListIterator(tuples);

		while (tuplesIt.hasNext()) {
			JugglerTuple tuple = (JugglerTuple) tuplesIt.next();
			//if the list applies to the tuple's streamName
			if (tuple.getStreamNames().containsAll(olist.getStreamName1())) {
				setIndex = olist.findMostCovering_XATTuple(tuple);
				if (setIndex >= 0) {
					BitPosition bp =
						new BitPosition(setListIndex, setIndex);

					//set the the tuple's bit position
					tuples.getTuple().getPredicates().getAppropriatePredicateTypeExt("attribute").setMostCoveringBits(bp, olist.size());
				}
			}
			else
				tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("attribute").getPredicateBitSets()[setListIndex]= new BitSet(olist.size());
		}
	}
	return tuples;
}
}
