package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;



import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.IPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 8:39:25 PM)
 * @author: Administrator
 */
public  class OrderListS implements Serializable{
	protected ArrayList OrderLists;
/**
 * PredOrderListS constructor comment.
 */
public OrderListS() {
	super();
	OrderLists = new ArrayList();
}
/**
 * Deletes a predicate order list.
 * Creation date: (1/9/2003 8:43:57 PM)
 * @param predOrderList juggler.predicatelists.OrderList
 */
public void deletePredOrderList(OrderList predOrderList) {

	this.OrderLists.remove(predOrderList);
	
	}
/**
 * Returns the bit position of the predicate.
 * Creation date: (1/9/2003 8:54:28 PM)
 * @return juggler.predicatestructure.BitPosition
 * @param param juggler.predicatestructure.Predicate
 */
public BitPosition getBitPosition(Predicate param) {
	return param.getBit();
}
/**
 * Returns the predicate order lists.
 * Creation date: (1/9/2003 8:41:19 PM)
 * @return ArrayList
 */
public ArrayList getOrderLists() {
	return OrderLists;
}
/**
 * Insert the method's description here.
 * Creation date: (3/4/2003 9:39:13 PM)
 * @param jwPred Predicate
 */
public void insertIntoPredList(Predicate jwPred) {

    boolean foundList = false;
    //ArrayList bitPositions = new ArrayList();

    for (int i = 0; i < OrderLists.size(); i++) {
        JWPredOrderList jwPredList = (JWPredOrderList) OrderLists.get(i);

        Operator optemp = jwPred.getOp();
        Operator optempList = jwPredList.getOp();
        // if the S1 = pred.S1 and S2 = pred.S2. and operator = pred.op
        if (jwPred.getOp().equals(jwPredList.getOp())
            && jwPred.getS1().getColumn() == jwPredList.getColumn1()
            && jwPred.getS1().getStreamName() == jwPredList.getStreamName1()
            && jwPred.getS2().getColumn() == jwPredList.getColumn2()
            && jwPred.getS2().getStreamName() == jwPredList.getStreamName2()) {
            //normalize to pred.s1's string
            jwPred.normalize(jwPred.getS1().getStreamName());
            //returns bitPositions!!!!! add the BitPosition 
            //bitPositions.add(jwPredList.insertPredicate(jwPred));
            jwPredList.insertPredicate(jwPred);
            foundList = true;
        }

            //if S1 = pred.S2 and s2 = pred.S1 and operator (opposite) pred.op
        if (jwPred.getOp().getOppositeOperatorName().equals(jwPredList.getOp().getOpName())
            && jwPred.getS2().getColumn() == jwPredList.getColumn1()
            && jwPred.getS2().getStreamName() == jwPredList.getStreamName1()
            && jwPred.getS1().getColumn() == jwPredList.getColumn2()
            && jwPred.getS1().getStreamName() == jwPredList.getStreamName2())
            {
			jwPred.normalize(jwPred.getS2().getStreamName());
			//returns BitPositions!!!!! add BitPositions
            //bitPositions.add(jwPredList.insertPredicate(jwPred));
            jwPredList.insertPredicate(jwPred);
            foundList = true;
        }

    }

    if (foundList == false) {
        //this implies that there is not PredOrderList created for this predicate
        JWPredOrderList jwList = new JWPredOrderList();
        jwList.setColumn1(jwPred.getS1().getColumn());
        jwList.setOp(jwPred.getOp());
        jwList.setStreamName1(jwPred.getS1().getStreamName());
        jwList.setListIndex(this.getOrderLists().size());
        jwList.setColumn2(jwPred.getS2().getColumn());
        jwList.setColumnInt1(jwPred.getS1().getColumnID());
        jwList.setColumnInt2(jwPred.getS2().getColumnID());
        jwList.setStreamName2(jwPred.getS2().getStreamName());
        //bitPositions.add(jwList.insertPredicate(jwPred));
        jwList.insertPredicate(jwPred);
        this.insertOrderList(jwList);

    }

   // return bitPositions;
}
/**
 * Inserts the predicate order list in the array of order lists.
 * Creation date: (1/9/2003 8:42:32 PM)
 * @param predOrderList juggler.predicatelists.OrderList
 */
public void insertOrderList(OrderList predOrderList) {

    this.OrderLists.add(predOrderList);
}
/**
 * Sets the array of predicate order lists.
 * Creation date: (1/9/2003 8:41:19 PM)
 * @param newPredOrderLists juggler.predicatelists.OrderList[]
 */
public void setOrderLists(ArrayList newPredOrderLists) {
	OrderLists = newPredOrderLists;
}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 9:47:48 PM)
 * @return int
 */
public int size() {
	
	return OrderLists.size();
}
/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 9:30:05 PM)
 * @return java.lang.String
 */
public String toString() {

	String orderList = "";
	for (int i = 0; i < this.getOrderLists().size(); i++) {
		JWPredOrderList jwOrderList = (JWPredOrderList) this.getOrderLists().get(i);
		orderList += "ListIndex: " +jwOrderList.getListIndex()+ "\n ";
		orderList += jwOrderList.toString()+"\n"+"\n";
	}
	return orderList;
}

/**
 * Returns the predicate specified by the bit position.
 * Creation date: (1/9/2003 8:47:53 PM)
 * @return juggler.predicatestructure.Predicate
 * @param param juggler.predicatestructure.BitPosition
 */
public IPredicate getPredicate(BitPosition param) {
	return this.getPredicate(param);
}

/**
 * Finds largest set bit index for the specified list index. Returns -1 if no index was found for the list
 * Creation date: (4/12/2003 11:50:21 PM)
 * @return int
 * @param listIndex int
 * @param setBitIndexes java.util.ArrayList
 */
public int findLargestSetBitIndexForList(int listIndex, ArrayList setBitIndexes) {
	int maxBitIndex = -1;

	for (int i = 0; i < setBitIndexes.size(); i++) {
		BitPosition setBS = (BitPosition) setBitIndexes.get(i);
		if (setBS.getPredListIndex() == listIndex)
			maxBitIndex = Math.max(maxBitIndex, setBS.getPredIndex());
	}
	return maxBitIndex;
}

/**
 * Find most covering predicates for each predicate list in PredOrderLists.
 * ArrayList of BitPositions
 * Creation date: (1/9/2003 8:50:54 PM)
 * @param tuple juggler.stream.Tuple
 */
public ArrayList findMostCovering(JugglerTuple tuple) {

    Iterator it = OrderLists.iterator();

    while (it.hasNext()) {
        OrderList ol = (OrderList) it.next();
        int listIndex = ol.getListIndex();

        //should check if this list applies to this tuple???
                //if there has been a bitset evalutated

        int bitIndex = ol.findMostCovering(tuple);

        if (bitIndex >= 0) {
			BitPosition bp =
                new BitPosition(listIndex, bitIndex);
            //if its a join predicate, set the join predicate
            if (ol.getListName() == "join")
                tuple.getPredicates().getAppropriatePredicateTypeBitSet("join").setBitPosition(bp);
            //if its a window predicate, set the window predicate
            if (ol.getListName() == "window")
                tuple.getPredicates().getAppropriatePredicateTypeBitSet("window").setBitPosition(bp);

        }
    }
    return null;

}
}
