package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;

import java.util.ArrayList;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.GreaterThanOp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.LessThanOp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttributePredicatePart;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.PredicatePart;
/**
 * Insert the type's description here.
 * Creation date: (2/12/2003 10:58:34 PM)
 * @author: Administrator
 */
public class PredicateListDriver {
/**
 * PredicateListDriver constructor comment.
 */
public PredicateListDriver() {
	super();
}
/**
 * Starts the application.
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) {

	PredicateListDriver driver = new PredicateListDriver();

	//driver.testAttr();

   driver.testJoin();
}
/**
 * Insert the method's description here.
 * Creation date: (2/19/2003 8:38:43 PM)
 */
public void testAttr() {
	ArrayList streamNameB = new ArrayList();
	streamNameB.add("B");
	ArrayList streamNameH = new ArrayList();
	streamNameB.add("H");
	ArrayList streamNameT = new ArrayList();
	streamNameB.add("T");
	ArrayList streamNameK = new ArrayList();
	streamNameB.add("K");
	
	
	// attribute predicate 1: B.pressure *3 + 2 > 90
    AttributePredicatePart testaValue1 =
        new AttributePredicatePart(new KeyDouble(90));
    //stream name = "B", column name ="pressure", columnID = 1, factor =3, add = 2, sub = 0
    PredicatePart testaPredPart1 = new PredicatePart(streamNameB, "pressure", 1, 3, 2, 0);
    Operator testop1 = new GreaterThanOp();
    AttrPredicate testaPred1 =
        new AttrPredicate(testaPredPart1, testaValue1, testop1);
    testaPred1.normalize(streamNameB);
    testaPred1.addQueryID(1);

    // attribute predicate 2: B.pressure *3 + 1 > 90
    AttributePredicatePart testaValue2 =
        new AttributePredicatePart(new KeyDouble(90));
    //stream name = "B", column name ="pressure", columnID = 1, factor =3, add = 1, sub = 0
    PredicatePart testaPredPart2 = new PredicatePart(streamNameB, "pressure", 1, 3, 1, 0);
    Operator testop2 = new GreaterThanOp();
    AttrPredicate testaPred2 =
        new AttrPredicate(testaPredPart2, testaValue2, testop2);
    testaPred2.normalize(streamNameB);
    testaPred2.addQueryID(2);

    // attribute predicate 3: B.pressure *2 + 2 > 90
    AttributePredicatePart testaValue3 =
        new AttributePredicatePart(new KeyDouble(90));
    //stream name = "B", column name ="pressure", columnID = 1, factor =2, add = 2, sub = 0
    PredicatePart testaPredPart3 = new PredicatePart(streamNameB, "pressure", 1, 3, 2, 0);
    Operator testop3 = new GreaterThanOp();
    AttrPredicate testaPred3 =
        new AttrPredicate(testaPredPart3, testaValue3, testop3);
    testaPred3.normalize(streamNameB);
    testaPred3.addQueryID(3);

    AttrPredOrderList aList = new AttrPredOrderList();
    aList.setColumn1("pressure");
    aList.setListIndex(1);
    aList.setOp(new GreaterThanOp());
  
    aList.setStreamName1(streamNameB);
    aList.insertPredicate(testaPred1);
    aList.insertPredicate(testaPred2);
    aList.insertPredicate(testaPred3);

    System.out.println(aList.toString());

	JugglerTuple tuples[] = new JugglerTuple[10];

    ArrayList streamIDs = new ArrayList(3);
    streamIDs.add(new Integer(1));
    streamIDs.add(new Integer(2));

    ArrayList streamNames = new ArrayList();
    streamNames.add(streamNameB);

    for (int i = 0; i < 10; i++) {
        Vector tupleVal = new Vector(2);
        for (int j = 0; j < 2; j++) {
            int value = (int) (Math.random() * 100);
            tupleVal.add(j, new KeyDouble(value));
        }
		JugglerTuple t = new JugglerTuple(tupleVal);
        t.setStreamIDs(streamIDs);
        t.setStreamNames(streamNames);
        tuples[i] = t;
    }

    for (int j = 0; j < 10; j++) {
        JugglerTuple tempTuple = (JugglerTuple) tuples[j];
        int pIndex = aList.findMostCovering(tempTuple);
        //if no predicate applies, the index returned is -1
        AttrPredicate p;
        if (pIndex >= 0)
            p = (AttrPredicate) aList.getList().get(pIndex);
    }
	
	}
/**
 * Insert the method's description here.
 * Creation date: (2/19/2003 8:40:26 PM)
 */
public void testJoin() {

	ArrayList streamNameB = new ArrayList();
	streamNameB.add("B");
	ArrayList streamNameH = new ArrayList();
	streamNameB.add("H");
	ArrayList streamNameT = new ArrayList();
	streamNameB.add("T");
	ArrayList streamNameK = new ArrayList();
	streamNameB.add("K");

    /*************************************/
    //join predicate 1: B.pressure > T.fluct
    //BitPosition jbp1 = new BitPosition(0, 0);
    //stream name = "B", column name ="pressure", columnID = 1, factor =1, add = 0, sub = 0
    PredicatePart jPredPart11 = new PredicatePart(streamNameB, "pressure", 1, 1, 0, 0);
    //stream name = "T", column name ="fluct", columnID = 2, factor =1, add = 0, sub = 0
    PredicatePart jPredPart12 = new PredicatePart(streamNameT, "fluct", 2, 1, 0, 0);
    Operator op1 = new GreaterThanOp();
    Predicate jPred1 = new Predicate(jPredPart11, jPredPart12, op1);
    //jPred1.setQueryNumIDs(QueryNumIDs);
    //System.out.println(jPred1.toString());

    //join predicate 2:  T.fluct < B.pressure * 2
    //BitPosition jbp1 = new BitPosition(0, 0);
    //stream name = "B", column name ="pressure", columnID = 1, factor =1, add = 0, sub = 0
    PredicatePart jPredPart21 = new PredicatePart(streamNameT, "fluct", 2, 2, 0, 0);
    //stream name = "T", column name ="fluct", columnID = 2, factor =1, add = 0, sub = 0
    PredicatePart jPredPart22 = new PredicatePart(streamNameB, "pressure", 1, 1, 0, 0);
    Operator op2 = new LessThanOp();
    Predicate jPred2 = new Predicate(jPredPart21, jPredPart22, op2);
    //jPred1.setQueryNumIDs(QueryNumIDs);
   // System.out.println(jPred2.toString());

    //join predicate 3: B.pressure > T.fluct - 4
    //BitPosition jbp1 = new BitPosition(0, 0);
    //stream name = "B", column name ="pressure", columnID = 1, factor =1, add = 0, sub = 0
    PredicatePart jPredPart31 = new PredicatePart(streamNameB, "pressure", 1, 1, 0, 0);
    //stream name = "T", column name ="fluct", columnID = 2, factor =1, add = 0, sub = 0
    PredicatePart jPredPart32 = new PredicatePart(streamNameT, "fluct", 2, 1, 0, 4);
    Operator op3 = new GreaterThanOp();
    Predicate jPred3 = new Predicate(jPredPart31, jPredPart32, op3);
    //jPred1.setQueryNumIDs(QueryNumIDs);
    //System.out.println(jPred3.toString());

    jPred1.normalize(streamNameB);
    jPred2.normalize(streamNameB);
    jPred3.normalize(streamNameB);

    JWPredOrderList jList = new JWPredOrderList();
    jList.insertPredicate(jPred1);
    jList.insertPredicate(jPred2);
    jList.insertPredicate(jPred3);

    System.out.println(jList.toString());

	JugglerTuple tuples[] = new JugglerTuple[10];

    ArrayList streamIDs = new ArrayList(3);
    streamIDs.add(new Integer(1));
    streamIDs.add(new Integer(2));

    ArrayList streamNames = new ArrayList();
    streamNames.add("T");

    for (int i = 0; i < 10; i++) {
        Vector tupleVal = new Vector(2);
        for (int j = 0; j < 3; j++) {
            int value = (int) (Math.random() * 100);
            tupleVal.add(j, new KeyDouble(value));
        }
		JugglerTuple t = new JugglerTuple(tupleVal);
        t.setStreamIDs(streamIDs);
        t.setStreamNames(streamNames);
        tuples[i] = t;
    }

    //this is the tuple all the other T tuples will be compared to
    Vector BtupleVal = new Vector();
    BtupleVal.add(new KeyDouble(50));
    BtupleVal.add(new KeyDouble(50));
    JugglerTuple Btuple = new JugglerTuple(BtupleVal);

    for (int j = 0; j < 10; j++) {
        JugglerTuple tempTuple = (JugglerTuple) tuples[j];
        int pIndex = jList.findMostCovering2(Btuple, tempTuple);
        //if no predicate applies, the index returned is -1
        Predicate p;
        if (pIndex >= 0) {
            p = (Predicate) jList.getList().get(pIndex);
            System.out.println(Btuple + " " + tempTuple + " " + p.toString());
        }
    }

}
}
