package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure;


import java.io.Serializable;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyInterface;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;
/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 12:15:05 AM)
 * @author: Administrator
 */
public class AttrPredicate implements IPredicate, Serializable{
	protected PredicatePart s1;
	protected AttributePredicatePart value;
	protected Operator op;
	protected ArrayList queryNumIDs;
	protected BitPosition bitposition;
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 12:39:11 PM)
 * @param pPart juggler.predicatestructure.PredicatePart
 * @param value double
 */
public AttrPredicate(PredicatePart pPart, AttributePredicatePart value) {
	this.setS1(pPart);
	this.setValue(value);
	this.queryNumIDs = new ArrayList();
	}
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 12:39:11 PM)
 * @param pPart juggler.predicatestructure.PredicatePart
 * @param value double
 * @param bp 	juggler.predicatestructure.BitPosition
 */
public AttrPredicate(PredicatePart pPart, AttributePredicatePart value, BitPosition bp) {
	this.setS1(pPart);
	this.setValue(value);
	this.setBitposition(bp);
		this.queryNumIDs = new ArrayList();
	}
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 12:39:11 PM)
 * @param pPart juggler.predicatestructure.PredicatePart
 * @param value double
 * @param op 	juggler.predicatestructure.Operator
 * @param bp 	juggler.predicatestructure.BitPosition
 */
public AttrPredicate(PredicatePart pPart, AttributePredicatePart value, Operator op) {
	this.setS1(pPart);
	this.setValue(value);
	this.setOp(op);
		this.queryNumIDs = new ArrayList();
	}
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 12:39:11 PM)
 * @param pPart juggler.predicatestructure.PredicatePart
 * @param value double
 * @param op 	juggler.predicatestructure.Operator
 * @param bp 	juggler.predicatestructure.BitPosition
 */
public AttrPredicate(PredicatePart pPart, AttributePredicatePart value, Operator op, BitPosition bp) {
	this.setS1(pPart);
	this.setValue(value);
	this.setOp(op);
	this.setBitposition(bp);
		this.queryNumIDs = new ArrayList();
	}
/**
 * Adds queryID to this attribute predicate.
 * Creation date: (1/9/2003 12:32:49 AM)
 * @param queryID int
 */
public void addQueryID(int queryID) {
	Integer qn = new Integer(queryID);
	if (!queryNumIDs.contains(qn))
		queryNumIDs.add(qn.toString());
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 9:14:12 PM)
 * @return int
 * @param p1 juggler.predicatestructure.AttrPredicate
 * @param p2 juggler.predicatestructure.AttrPredicate
 */
public int compare(AttrPredicate p2) {

	this.normalize();
	p2.normalize();
/*
	double factor1 = this.getS1().getFactor();
	double add1 = this.getS1().getAdd();
	double sub1 = this.getS1().getSub();

	double factor2 = p2.getS1().getFactor();
	double add2 = p2.getS1().getAdd();
	double sub2 = p2.getS1().getSub();

	int factorComp = (new Double(factor1)).compareTo(new Double (factor2));
	//if the factor is differnt, stop now and return its value
	if (factorComp > 0 || factorComp < 0)
		return factorComp;
		
	//if the factor is not different, test add and sub terms
	if (factorComp == 0) {

		//test equalities first
		//add and sub both equal
		if (add1 == add2 && sub1 == sub2)
			return 0;

			//check which was greater difference, the add or sub
		double addDiff = Math.abs(add1-add2);
		double subDiff = Math.abs(sub1-sub2);

		//if the difference of add is greater, return its comparator result
		if (addDiff > subDiff){
			int addComp = (new Double(add1)).compareTo(new Double(add2));
			return addComp;
		}

		//if the difference of sub is greater, return its comparator result
		if (subDiff > addDiff){
			int subComp = (new Double(sub1)).compareTo(new Double(sub2));
			return subComp;
		}	
		
	}*/

	//return (p2.getValue().getValue().compareTo(this.getValue().getValue()));
	return(this.getValue().getValue().compareTo(p2.getValue().getValue()));
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 9:32:04 PM)
 * @return int
 * @param p2 org.omg.CORBA.Object
 */
public int compareTo( Object p2) {
	AttrPredicate ap2 = (AttrPredicate) p2;
	return (this.compare(ap2));
}
/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Insert code to compare the receiver and obj here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: obj might be an instance of any class
	//return super.equals(obj);
	AttrPredicate a = (AttrPredicate) obj;

	//doesn't need to have the same queryID numbers
	if (a.getOp().equals(this.getOp())
		//&& a.getQueryNum() == this.getQueryNum()
		&& this.getS1().equals(a.getS1())
		&& this.getValue().equals(a.getValue()))
		return true;
	else
		return false;
}
/**
 * Returns the bitposition of this predicate.
 * Creation date: (1/9/2003 12:27:04 AM)
 * @return predicatestructure.BitPosition
 */
public BitPosition getBit() {
	return bitposition;
}
/**
 * Return the predicate's operator.
 * Creation date: (1/9/2003 12:25:13 AM)
 * @return predicatestructure.Operator
 */
public Operator getOp() {
	return op;
}
/**
 * Returns the Query Number ID's Queries which share this predicate.
 * Creation date: (1/9/2003 12:25:55 AM)
 * @return int[]
 */
public ArrayList getQueryNumIDs() {
	return queryNumIDs;
}
/**
 * Returns the predicate part of the attribute predicate
 * Creation date: (1/9/2003 12:24:10 AM)
 * @return predicatestructure.PredicatePart
 */
public PredicatePart getS1() {
	return s1;
}
/**
 * Insert the method's description here.
 * Creation date: (2/20/2003 1:12:52 AM)
 * @return java.lang.String
 */
public String getType() {
	return "Attribute";
}
/**
 * Returns the constant of the attribute predicate.
 * Creation date: (1/9/2003 12:24:48 AM)
 * @return predicatestructure.AttributePredicatePart
 */
public AttributePredicatePart getValue() {
	return value;
}
/**
 * Generates a hash code for the receiver.
 * This method is supported primarily for
 * hash tables, such as those provided in java.util.
 * @return an integer hash code for the receiver
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Insert code to generate a hash code for the receiver here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: if two objects are equal (equals(Object) returns true) they must have the same hash code
	return super.hashCode();
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 11:11:37 PM)
 * @return juggler.predicatestructure.AttrPredicate
 * @param p juggler.predicatestructure.AttrPredicate
 */
public void normalize() {

	AttributePredicatePart newVal = this.getValue();
	double f1 = ((KeyDouble)this.getS1().getFactor()).getKey();
	double a1 = ((KeyDouble)this.getS1().getAdd()).getKey();
	double s1 = ((KeyDouble)this.getS1().getSub()).getKey();

	if (a1 != 0) {
		KeyDouble k =new KeyDouble(a1);
		newVal.getValue().subKey(k);
		this.getS1().setAdd(new KeyDouble(0));
	}

	if (s1 != 0) {
		KeyDouble k =new KeyDouble(s1);
		newVal.getValue().addKey(k);
		this.getS1().setSub(new KeyDouble(0));
	}
	
	if (f1 != 0 && f1 !=1 ) {
		KeyDouble k = new KeyDouble (f1);
		newVal.getValue().divideKey(k);
		this.getS1().setFactor(new KeyDouble(1));
	}

	this.setValue(newVal);

}
/**
 * Sets the bitposition of the attribute predicate.
 * Creation date: (1/9/2003 12:27:04 AM)
 * @param newBitposition predicatestructure.BitPosition
 */
public void setBitposition(BitPosition newBitposition) {
	bitposition = newBitposition;
}
/**
 * Sets the operator of the attribute predicate.
 * Creation date: (1/9/2003 12:25:13 AM)
 * @param newOp predicatestructure.Operator
 */
public void setOp(Operator newOp) {
	op = newOp;
}
/**
 * Sets the query Num Ids of this attribute predicate.Make sure the queryNumIDs are strings!!! 
 * Creation date: (1/9/2003 12:25:55 AM)
 * @param newQueryNumIDs int[]
 */
public void setQueryNumIDs(ArrayList newQueryNumIDs) {
	queryNumIDs = newQueryNumIDs;
}
/**
 * Sets the attribute predicate part of this predicate.
 * Creation date: (1/9/2003 12:24:10 AM)
 * @param newS1 predicatestructure.PredicatePart
 */
public void setS1(PredicatePart newS1) {
	s1 = newS1;
}
/**
 * Sets the constant value of this attribute predicate.
 * Creation date: (1/9/2003 12:24:48 AM)
 * @param newValue predicatestructure.AttributePredicatePart
 */
public void setValue(AttributePredicatePart newValue) {
	value = newValue;
}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	return (this.getS1().toString() + this.getOp().toString() + this.getValue().toString());
}

/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 5:28:29 PM)
 * @param streamName ArrayList
 */
public void normalize(ArrayList streamName) {
	if (streamName.equals(s1.getStreamName()))
		this.normalize();
	else
		return;
	
	}

/**
 * Insert the method's description here.
 * Creation date: (2/9/2003 11:20:59 PM)
 * @return boolean
 * @param t juggler.stream.Tuple
 */
public int evaluate_XATTuple(JugglerTuple t) {
	Operator op = this.getOp();
	
	KeyInterface val = (KeyInterface) this.getValue().getValue();
		
	int colIndex = this.getS1().getColumnID();


	KeyInterface tupleVal = new KeyDouble(t.getCell(colIndex).convertToDouble().doubleValue());
		
		/**/
	KeyInterface tempFactor = (KeyInterface) this.getS1().getFactor();
	KeyInterface tempAdd = (KeyInterface) this.getS1().getAdd();
	KeyInterface tempSub = (KeyInterface) this.getS1().getSub();
		
	double tempVal = 0.0;

	tempVal = ((KeyDouble) val).getKey() / ((KeyDouble) tempFactor).getKey();
	tempVal = tempVal - ((KeyDouble) tempAdd).getKey();
	tempVal = tempVal + ((KeyDouble) tempSub).getKey();

	KeyDouble tempValue = new KeyDouble(tempVal);

/**/


		int ret = tupleVal.compareTo(tempValue);

		return (ret);
}

/**
 * Insert the method's description here.
 * Creation date: (2/9/2003 11:20:59 PM)
 * @return boolean
 * @param t juggler.stream.Tuple
 */
public int evaluate(JugglerTuple t) {
	Operator op = this.getOp();

	KeyInterface val = (KeyInterface) this.getValue().getValue();
		
	int colIndex = this.getS1().getColumnID();

	KeyInterface tupleVal = (KeyInterface)(t.getCell(colIndex));
		
		/**/
	KeyInterface tempFactor = (KeyInterface) this.getS1().getFactor();
	KeyInterface tempAdd = (KeyInterface) this.getS1().getAdd();
	KeyInterface tempSub = (KeyInterface) this.getS1().getSub();
		
	double tempVal = 0.0;

	tempVal = ((KeyDouble) val).getKey() / ((KeyDouble) tempFactor).getKey();
	tempVal = tempVal - ((KeyDouble) tempAdd).getKey();
	tempVal = tempVal + ((KeyDouble) tempSub).getKey();

	KeyDouble tempValue = new KeyDouble(tempVal);

/**/


		int ret = tupleVal.compareTo(tempValue);

		return (ret);
}

/**
 * Insert the method's description here.
 * Creation date: (2/9/2003 9:40:37 PM)
 * @return boolean
 * @param t juggler.stream.Tuple
 */
public boolean satisfies(JugglerTuple t) {
	KeyInterface val =(KeyInterface) this.getValue();
	int columnID = this.getS1().getColumnID();

	if (this.getOp().evaluate(t, columnID, val))
		return true;
	else
		return false;
}

/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 2:49:14 PM)
 * @return java.util.ArrayList
 */
public ArrayList getStreamNames(){
		return this.getS1().getStreamName();
}
}
