package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure;

import java.io.Serializable;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyInterface;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyLong;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.GreaterThanEqualToOp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.GreaterThanOp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.LessThanEqualToOp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.LessThanOp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;

/**
 * Insert the type's description here.
 * Creation date: (1/8/2003 11:57:24 PM)
 * @author: Administrator
 */
public class Predicate implements Comparable, IPredicate, Serializable{
	protected PredicatePart s1;
	protected PredicatePart s2;
	protected Operator op;
	protected BitPosition bit;
	protected ArrayList queryNumIDs;
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 1:13:02 PM)
 * @param pp1 juggler.predicatestructure.PredicatePart
 * @param pp2 juggler.predicatestructure.PredicatePart
 */
public Predicate(PredicatePart pp1, PredicatePart pp2) {
	this.setPredicateParts(pp1, pp2);
		this.queryNumIDs = new ArrayList();
	
	}
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 1:14:37 PM)
 * @param pp1 juggler.predicatestructure.PredicatePart
 * @param pp2 juggler.predicatestructure.PredicatePart
 * @param nOp juggler.predicatestructure.Operator
 */
public Predicate(PredicatePart pp1, PredicatePart pp2, Operator nOp) {
	this.setPredicateParts(pp1, pp2);
	this.setOp(nOp);
		this.queryNumIDs = new ArrayList();
	}
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 1:14:37 PM)
 * @param pp1 juggler.predicatestructure.PredicatePart
 * @param pp2 juggler.predicatestructure.PredicatePart
 * @param nOp juggler.predicatestructure.Operator
 * @param bp  juggler.predicatestructure.BitPosition
 */
public Predicate(PredicatePart pp1, PredicatePart pp2, Operator nOp, BitPosition bp) {
	this.setPredicateParts(pp1, pp2);
	this.setOp(nOp);
	this.setBit(bp);
		this.queryNumIDs = new ArrayList();
	}
/**
 * Adds the queryNum to the Query ID list.
 * this is used when multiple queries shares same predicates
 * Creation date: (1/9/2003 12:12:57 AM)
 * @param queryNumID int
 */
public void addQueryID(int queryNumID) {
    Integer qn = new Integer(queryNumID);
    if (!queryNumIDs.contains(qn))
        queryNumIDs.add(qn.toString());
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 9:49:43 PM)
 * @return int
 * @param p1 juggler.predicatestructure.Predicate
 * @param p2 juggler.predicatestructure.Predicate
 */
public int compare( Predicate p2) {
	//assumes that predicate parts s1 and s2 are set as
	//being normalized  on s1 of both p1 and p2
	//and inserted by s2 on both p1 and p2
	KeyDouble factor12 = (KeyDouble)this.getS2().getFactor();
	KeyDouble add12 = (KeyDouble)this.getS2().getAdd();
	KeyDouble sub12 = (KeyDouble)this.getS2().getSub();

	KeyDouble factor22 = (KeyDouble)p2.getS2().getFactor();
	KeyDouble add22 = (KeyDouble)p2.getS2().getAdd();
	KeyDouble sub22 = (KeyDouble)p2.getS2().getSub();

	int factorComp = (new Double(factor12.getKey())).compareTo(new Double (factor22.getKey()));
	//if the factor is differnt, stop now and return its value
	if (factorComp > 0 || factorComp < 0)
		return factorComp;
		
	//if the factor is not different, test add and sub terms
	if (factorComp == 0) {

		//test equalities first
		//add and sub both equal
		if (add12.getKey() == add22.getKey() && sub12.getKey() == sub22.getKey())
			return 0;

			//check which was greater difference, the add or sub
		double addDiff = Math.abs(add12.getKey()-add22.getKey());
		double subDiff = Math.abs(sub12.getKey()-sub22.getKey());

		//if the difference of add is greater, return its comparator result
		if (addDiff > subDiff){
			int addComp = (new Double(add12.getKey())).compareTo(new Double(add22.getKey()));
			return addComp;
		}

		//if the difference of sub is greater, return its comparator result
		if (subDiff > addDiff){
			int subComp = (new Double(-sub12.getKey())).compareTo(new Double(-sub22.getKey()));
			return subComp;
		}
		
			
		
	}
	return 0;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 9:48:11 PM)
 * @return int
 * @param p1 Object
 * @param p2 Object
 */
public int compareTo(Object p2) {
	Predicate pp2 = (Predicate) p2;
	return (this.compare(pp2));
}
/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Insert code to compare the receiver and obj here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: obj might be an instance of any class
	Predicate p = (Predicate) obj;

    //doesn't need to have the same queryID numbers
    if (p.getOp().equals(this.getOp()) 
        //&& a.getQueryNum() == this.getQueryNum()
        && this.getS1().equals(p.getS1())
        && this.getS2().equals(p.getS2()))
        return true;
    else
        return false;
}
/**
 * Returns the Predicate's bit position (2 dimensional)
 * Creation date: (1/9/2003 12:03:57 AM)
 * @return predicatestructure.BitPosition
 */
public BitPosition getBit() {
	return bit;
}
/**
 * Returns operator in this predicate
 * Creation date: (1/9/2003 12:02:54 AM)
 * @return predicatestructure.Operator
 */
public Operator getOp() {
	return op;
}
/**
 * Returns the Query Number's IDs
 * Creation date: (1/9/2003 12:04:18 AM)
 * @return int
 */
public ArrayList getQueryNumIDs() {
	return queryNumIDs;
}
/**
 * Returns the first predicate part.
 * Creation date: (1/8/2003 11:59:38 PM)
 * @return predicatestructure.PredicatePart
 */
public PredicatePart getS1() {
	return s1;
}
/**
 * Returns the second predicate part.
 * Creation date: (1/8/2003 11:59:59 PM)
 * @return predicatestructure.PredicatePart
 */
public PredicatePart getS2() {
	return s2;
}
/**
 * Insert the method's description here.
 * Creation date: (2/20/2003 1:12:21 AM)
 * @return java.lang.String
 */
public String getType() {
	return "JoinWindow";
}
/**
 * Generates a hash code for the receiver.
 * This method is supported primarily for
 * hash tables, such as those provided in java.util.
 * @return an integer hash code for the receiver
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Insert code to generate a hash code for the receiver here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: if two objects are equal (equals(Object) returns true) they must have the same hash code
	return super.hashCode();
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 10:14:45 PM)
 * @return juggler.predicatestructure.Operator
 * @param op juggler.predicatestructure.Operator
 */
public Operator reverseOp(Operator op) {
	//if teh operator is not equals,
		//then the operator needs to change
		if (op.toString() != "=") {
			if (op.toString() == ">") {
				return (new LessThanOp());
			}
			if (op.toString() == "<") {
				return (new GreaterThanOp());
			}
			if (op.toString() == "<=") {
				return(new GreaterThanEqualToOp());
			}
			if (op.toString() == ">=") {
				return(new LessThanEqualToOp());
			}	
		}//ends if for operators changing
		return null;
}
/**
 * Sets the bit position of this predicate.
 * Creation date: (1/9/2003 12:03:57 AM)
 * @param newBit predicatestructure.BitPosition
 */
public void setBit(BitPosition newBit) {
	bit = newBit;
}
/**
 * Sets the operator of this predicate.
 * Creation date: (1/9/2003 12:02:54 AM)
 * @param newOp predicatestructure.Operator
 */
public void setOp(Operator newOp) {
	op = newOp;
}
/**
 * Sets both the predicate parts of this predicate.
 * Creation date: (1/9/2003 12:05:30 AM)
 * @param s1 predicatestructure.PredicatePart
 * @param s2 predicatestructure.PredicatePart
 */
public void setPredicateParts(PredicatePart s1, PredicatePart s2) {
	this.setS1(s1);
	this.setS2(s2);
	}
/**
 * Sets the query number ID for this predicate
 * Creation date: (1/9/2003 12:04:18 AM)
 * @param newQueryNum int
 */
public void setQueryNumIDs(ArrayList newQueryNum) {
	queryNumIDs = newQueryNum;
}
/**
 * Sets the first predicate part of this predicate.
 * Creation date: (1/8/2003 11:59:38 PM)
 * @param newS1 predicatestructure.PredicatePart
 */
public void setS1(PredicatePart newS1) {
	s1 = newS1;
}
/**
 * Sets the second predicate part of this predicate.
 * Creation date: (1/8/2003 11:59:59 PM)
 * @param newS2 predicatestructure.PredicatePart
 */
public void setS2(PredicatePart newS2) {
	s2 = newS2;
}
/**
 * Insert the method's description here.
 * Creation date: (2/11/2003 3:04:35 PM)
 * @return java.lang.String
 */
public String toString() {
	return (this.getS1().toString()+ this.getOp().toString() + this.getS2().toString());
}

/**
 * Sets the normalized PredicatePart as its first predicate part.
 * Creation date: (2/12/2003 9:58:03 PM)
 * @return void
 * @param p juggler.predicatestructure.Predicate
 * @param streamName ArrayList
 */
public void normalize(ArrayList streamName) {
	PredicatePart p1 = this.getS1();
	PredicatePart p2 = this.getS2();

	PredicatePart normalizedPP;
	PredicatePart newRepPP;
	if (p1.getStreamName().equals(streamName)){
		normalizedPP = p1;
		newRepPP = p2;
	}
	else {
		normalizedPP = p2;
		newRepPP = p1;
		
		//then the operator needs to change, reverse it
		Operator op = reverseOp(this.getOp());
		this.setOp(op);
		
	}//ends else

	//now normalize
	double factor1 =((KeyDouble) normalizedPP.getFactor()).getKey();
	double factor2 =((KeyDouble) newRepPP.getFactor()).getKey();
	double add1 = ((KeyDouble)normalizedPP.getAdd()).getKey();
	double add2 = ((KeyDouble)newRepPP.getAdd()).getKey();
	double sub1 = ((KeyDouble)normalizedPP.getSub()).getKey();
	double sub2 = ((KeyDouble)newRepPP.getSub()).getKey();

	//factor of s1 = 1
	//add of s1 = 0
	//sub of s1 = 0
	if (add1 != 0) {
		newRepPP.setAdd(new KeyDouble(add2+sub1));
		normalizedPP.setAdd(new KeyDouble(0));
	}
	if (sub1 != 0) {
		newRepPP.setSub(new KeyDouble(sub2-add1));
		normalizedPP.setSub(new KeyDouble(0));
	}
	if (factor1 !=0) {
		newRepPP.setFactor(new KeyDouble(factor2/factor1));
		normalizedPP.setFactor(new KeyDouble(1));
	}

	//normalized size will be set as the first attribute predicate
	this.setS1(normalizedPP);
	this.setS2(newRepPP);
}

/**
 * This is not relevant for window or join predicates.
 * Creation date: (2/17/2003 5:34:37 PM)
 * @param tuple edu.wpi.cs.heineman.structure.Tuple
 * @return int
 */
public int evaluate(JugglerTuple tuple) {
	return -100;
	}

	/**
	 * This is not relevant for window or join predicates.
	 * Creation date: (2/17/2003 5:34:37 PM)
	 * @param tuple edu.wpi.cs.heineman.structure.Tuple
	 * @return int
	 */
	public int evaluate_XATTuple(JugglerTuple tuple) {
		return -100;
		}

/**
 * Compares the tuple1's S1 value to tuple2's S2.
 * Creation date: (2/17/2003 5:35:02 PM)
 * @param tuple juggler.stream.Tuple
 * @return int
 */
public int evaluate_XATTuple(JugglerTuple tuple1, JugglerTuple tuple2) throws XATTimeStampException {
    //make sure the tuple has the S2 streamName
    if (!tuple2.getStreamNames().containsAll(this.getS2().getStreamName())){
		return -100;
    }
    
    KeyInterface tupleVal;
    if(this.getS2().column.equals("ts"))
    	tupleVal = new KeyDouble(new Long(tuple2.getTimeStamp().getMaxTimeStamp()).doubleValue());

    else
    tupleVal =
        (KeyInterface) tuple2.getColumnValue(this.getS2().getColumnID());

    KeyInterface tempFactor = (KeyInterface) this.getS2().getFactor();
    KeyInterface tempAdd = (KeyInterface) this.getS2().getAdd();
    KeyInterface tempSub = (KeyInterface) this.getS2().getSub();

    KeyInterface tempTupleValue; 

    double tempTV = 0.0;

    tempTV = ((KeyDouble) tupleVal).getKey() * ((KeyDouble) tempFactor).getKey();
    tempTV = tempTV + ((KeyDouble) tempAdd).getKey();
    tempTV = tempTV - ((KeyDouble) tempSub).getKey();

    tempTupleValue = new KeyDouble(tempTV);


	KeyInterface compareTupleValueToS1;
	
	if(this.s1.getColumn().equals("ts")) 
		compareTupleValueToS1 = new KeyDouble(new Long(tuple1.getTimeStamp().getMaxTimeStamp()).doubleValue());

	else
		compareTupleValueToS1=
		(KeyInterface) tuple1.getColumnValue((this.getS1().getColumnID()));

    //return compareTupleValueToS1.compareTo(tempTupleValue);
    Operator op = this.getOp();

    //if this is a ts comparison...
    String predPart1Column = this.getS1().getColumn();
    String predPart2Column = this.getS2().getColumn();
    if (predPart1Column.equals("ts") && predPart2Column.equals("ts"))
    	return op.satisfies(new KeyLong(tuple1.getJugglerTimeStamp()), new KeyLong(tuple2.getJugglerTimeStamp()));

    return op.satisfies(compareTupleValueToS1, tempTupleValue);

}

/**
 * Compares the tuple1's S1 value to tuple2's S2.
 * Creation date: (2/17/2003 5:35:02 PM)
 * @param tuple juggler.stream.Tuple
 * @return int
 */
public int evaluate(JugglerTuple tuple1, JugglerTuple tuple2) {
    //make sure the tuple has the S2 streamName
    if (!this.getS2().getStreamName().containsAll(tuple2.getStreamNames()))
        return -100;

    KeyInterface tupleVal =
        (KeyInterface) tuple2.getCell(this.getS2().getColumnID());

    KeyInterface tempFactor = (KeyInterface) this.getS2().getFactor();
    KeyInterface tempAdd = (KeyInterface) this.getS2().getAdd();
    KeyInterface tempSub = (KeyInterface) this.getS2().getSub();

    KeyInterface tempTupleValue; 

    double tempTV = 0.0;

    tempTV = ((KeyDouble) tupleVal).getKey() * ((KeyDouble) tempFactor).getKey();
    tempTV = tempTV + ((KeyDouble) tempAdd).getKey();
    tempTV = tempTV - ((KeyDouble) tempSub).getKey();

    tempTupleValue = new KeyDouble(tempTV);


	KeyInterface compareTupleValueToS1 =
		(KeyInterface) tuple1.getCell((this.getS1().getColumnID()));

    //return compareTupleValueToS1.compareTo(tempTupleValue);
    Operator op = this.getOp();

    //if this is a ts comparison...
    String predPart1Column = this.getS1().getColumn();
    String predPart2Column = this.getS2().getColumn();
    if (predPart1Column.equals("ts") && predPart2Column.equals("ts"))
    	return op.satisfies(new KeyLong(tuple1.getJugglerTimeStamp()), new KeyLong(tuple2.getJugglerTimeStamp()));

    return op.satisfies(compareTupleValueToS1, tempTupleValue);

}

/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 2:49:14 PM)
 * @return java.util.ArrayList
 */
public ArrayList getStreamNames(){
	ArrayList allStreamNames = new ArrayList();
	allStreamNames.addAll(this.getS1().getStreamName());
	allStreamNames.addAll(this.getS2().getStreamName());
		return allStreamNames;
}
}
