package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation.ExtPredicateBitSet;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation.GeneralPredicateBitSet;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.IPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;

/**
 * Insert the type's description here.
 * Creation date: (1/12/2003 10:24:28 PM)
 * @author: Administrator
 */
public class QueryDependentEncoding implements Serializable{
	protected ArrayList queryNums;
	protected java.lang.String nodeName;
/* QueryQEDs	*/
protected java.util.ArrayList queryQEDs;
/**
 * QueryDependentEncoding constructor comment.
 */
public QueryDependentEncoding() {
	super();
	queryQEDs = new ArrayList();
	queryNums = new ArrayList();
	nodeName = "";
}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:31:19 AM)
 * @param query juggler.query.Query
 */
public void addQuery(Query query) {

	this.getQueryQEDs().add(query);
	
	}
/**
 * Returns the node's name.
 * Creation date: (1/12/2003 10:25:05 PM)
 * @return java.lang.String[]
 */
public java.lang.String getNodeName() {
	return nodeName;
}
/**
 * Return the query IDs in the QDE.
 * Creation date: (1/12/2003 10:24:46 PM)
 * @return ArrayList
 */
public ArrayList getQueryNums() {
	return queryNums;
}
/**
 * QueryIDs should start at  0, -1 is considered null. !!!!
 * For this reason when retrieving a queryQED from the list, its index is the queryNum. 
 * Creation date: (3/10/2003 10:07:05 PM)
 * @param pred juggler.predicatestructure.IPredicate
 */
public void registerPredicates(IPredicate pred) {
    ArrayList queryIDs = pred.getQueryNumIDs();

    BitPosition bp = pred.getBit();
    String type = pred.getType();

    //for each query that contains the predicate
    for (int i = 0; i < queryIDs.size(); i++) {
        String temp = (String) queryIDs.get(i);
        Integer tempInt = new Integer(temp);
        int queryID = tempInt.intValue();

        //to keep track of which queries are contained in this querydependent encoding
		if (!this.getQueryNums().contains(String.valueOf(queryID)))
			this.getQueryNums().add(String.valueOf(queryID));
        
        QueryQED tempQ = (QueryQED) this.getQueryQED(queryID);

        //add the predicate stream list to teh queryQED
        ArrayList predicateStreamNames = pred.getStreamNames();
        for(int j = 0; j < predicateStreamNames.size(); j++) {
			if (!tempQ.getPredicateStreams().contains(predicateStreamNames.get(j)))
				tempQ.getPredicateStreams().add(predicateStreamNames.get(j));
        }

        //set the bit position with the appropriate bit list
        if (type.equals("Attribute")) {
            tempQ.getPredicates().setBitPosition(bp, "attribute");
			continue;
        }
      
            Predicate p = (Predicate) pred;
        if (type.equals("JoinWindow") && !p.getS1().getColumn().equals("ts")) {
            tempQ.getPredicates().setBitPosition(bp, "join");
            continue;
        }
        else //(type.equals("JoinWindow"))
            tempQ.getPredicates().setBitPosition(bp, "window");
    }

}
/**
 * QDE's node name that contains it.
 * Creation date: (1/12/2003 10:25:05 PM)
 * @param newNodeNames java.lang.String[]
 */
public void setNodeName(java.lang.String newNodeName) {
	nodeName = newNodeName;
}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:30:35 AM)
 * @param newQueries java.util.ArrayList
 */
public void setQueries(java.util.ArrayList newQueries) {
	queryQEDs = newQueries;
}
/**
 * Sets the query IDs for the QDE.
 * Creation date: (1/12/2003 10:24:46 PM)
 * @param newQueryNums int[]
 */
public void setQueryNums(ArrayList newQueryNums) {
	queryNums = newQueryNums;
}
/**
 * Insert the method's description here.
 * Creation date: (3/8/2003 9:01:37 PM)
 * @return java.lang.String
 */
public String toString() {
	String qdeString = "";

	for (int i = 0; i < this.getQueryQEDs().size(); i++){
		 QueryQED queryQED = (QueryQED) this.queryQEDs.get(i);
		qdeString += "Query: " + queryQED.getQueryNum() + "\n"+ queryQED.toString() + "\n";
	
	}
	return qdeString;
}

/**
 * Returns the queryIDs of all the queries this pBitSet satisfies 
 * Creation date: (1/12/2003 10:28:23 PM)
 * @return ArrayList
 * @param pBitSet juggler.query.ExtPredicateBitSet
 */
public ArrayList getSuperSetofQuery(ExtPredicateBitSet pBitSet) {

	ArrayList satisfiedQueryIDList = new ArrayList(); 
	
	for (int i = 0;i < this.getQueryQEDs().size();i++) {
		QueryQED q = (QueryQED) this.getQueryQEDs().get(i);
		ExtPredicateBitSet queryPB = q.getPredicates();
		//make sure the parameter BitSets is a superset of the query's BitSets
		if (queryPB.isSuperset(pBitSet))
			satisfiedQueryIDList.add(new Integer (q.getQueryNum()));
	}
	return satisfiedQueryIDList;
}

/**
 * Returns true if the tuple's predicate bitset satisfies at least one query in
 * the QDE.
 * Creation date: (1/12/2003 10:28:23 PM)
 * @return boolean
 * @param pBitSet juggler.query.ExtPredicateBitSet
 */
public boolean isSuperSet(ExtPredicateBitSet pBitSet) {

	boolean doesSatisfyAQuery = false;
	
	for (int i = 0;i < this.getQueryQEDs().size();i++) {
		QueryQED q = (QueryQED) this.getQueryQEDs().get(i);
		GeneralPredicateBitSet queryPB = q.getPredicates().getPredBSList();
		//make sure the parameter BitSets is a superset of the query's BitSets
		if (queryPB.isSuperset(pBitSet.getPredBSList()))
			doesSatisfyAQuery = true;
	}
	return doesSatisfyAQuery;
}

/**
 * Returns the union of all teh bits of the two  Predicate BitSet parameters.
 * Creation date: (2/25/2003 2:31:34 PM)
 * @param pBS ArrayList
 * @param tBS ArrayList
 * @return void
 */
public void setBits(
    BitSet[] pBS,
    BitSet[] evalpBS,
    BitSet[] tBS,
    BitSet[] evaltBS) {

   // ArrayList resultPredBS = new ArrayList(pBS.size());
    //if the tuple's bitset has not been initialized.
    if (tBS == null) {
        tBS = pBS;
        //return tBS;
    }

    //for each predicate list
    for (int i = 0; i < pBS.length; i++) {
       // BitSet tempPredBS = (BitSet) ((BitSet) pBS.get(i)).clone();
       // BitSet tempTupleBS = (BitSet) tBS.get(i);

        //uniion all the attribute bits
       // tempPredBS.or(tempTupleBS);
       // resultPredBS.add(i, tempPredBS);

        //union all teh eval bits
        BitSet evalPredBS = (BitSet) ((BitSet) evalpBS[i]).clone();
        BitSet evalTupleBS = (BitSet) evaltBS[i];
        evalTupleBS.or(evalPredBS);

    }
    //return resultPredBS;
}

/**
 * Sets the tuple's relevant attribute predicate bitset. All, one or two parameters
 * can be set. Each parameter indicates which predicate
 * type needs to be compared.
 Assumes query numbers start from 0, onwards in order.
 * Creation date: (1/12/2003 10:29:14 PM)
 * @param join boolean
 * @param window boolean
 * @param tuple juggler.stream.JugglerTuple
 */
public void setRelevantAttrBits(
    boolean join,
    boolean window,
	JugglerTupleList tuples) {
    ExtPredicateBitSet tPS = tuples.getFirstTuple().getPredicates();

    //evaluted predicates bitsets
    BitSet[] evaluatedPred;
    BitSet[] isRelvantPred;
    ArrayList queryIDs = new ArrayList();

    //retrieves all teh relevant query IDs of the evaluated predicates (join or window)
    if (join) {
        evaluatedPred = ((GeneralPredicateBitSet)tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("join")).getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("join").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0) 
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "join");
        else 
        queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "join");
        tuples.getFirstTuple().setQuerySatisfied(queryIDs);
    }
    if (window) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("window").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("window").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "window");
        else 
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "window");
			tuples.getFirstTuple().setQuerySatisfied(queryIDs);

    }

    for (int i = 0; i < queryIDs.size(); i++) {
        int queryNum = ((Integer) queryIDs.get(i)).intValue();
        QueryQED tempQuery = (QueryQED) queryQEDs.get(queryNum);
        //gets the query bitsets
        BitSet[] queryPred = tempQuery.getPredicates().getAppropriatePredicateTypeBitSet("attribute").getPredicateBitSets();

        if (queryIDs.contains(new Integer(tempQuery.getQueryNum()))) {
            //union the bits ==> set the relevenat query bits in the attributes
            //this will correspond to the satisfied queries of the evaluated predicate
            /* ArrayList newTupleAttrBS = */
            this.setBits(
                queryPred,
                tempQuery.getPredicates().getAppropriatePredicateTypeExt("attribute").getIsEvaluated_Relevant().getPredicateBitSets(),
                tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("attribute").getPredicateBitSets(),
                tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("attribute").getPredicateBitSets());
            //tuples.getFirstTuple().getBS().setAttribute(newTupleAttrBS);
        }
    }

}

/**
 * Sets the tuple's relevant join predicate bitset. All, one or two parameters
 * can be set. Each parameter indicates which predicate
 * type needs to be compared.
 * Creation date: (1/12/2003 10:29:14 PM)
 * @param attr boolean
 * @param window boolean
 * @param tuple juggler.stream.JugglerTuple
 */
public void setRelevantJoinBits(
    boolean attr,
    boolean window,
	JugglerTupleList tuples) {
    ExtPredicateBitSet tPS = tuples.getFirstTuple().getPredicates();

    BitSet[] evaluatedPred;
    BitSet[] isRelvantPred;
    ArrayList queryIDs = new ArrayList();

    //retrieves all teh relevant query IDs of the evaluated predicates (attr or window)
    if (attr) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("attribute").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("attribute").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "attribute");
        else
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "attribute");
    }
    if (window) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("window").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("window").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "window");
        else
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "window");
        tuples.getFirstTuple().setQuerySatisfied(queryIDs);
    }

    for (int i = 0; i < queryIDs.size(); i++) {
        int queryIndex = ((Integer) queryIDs.get(i)).intValue();
        QueryQED tempQuery = (QueryQED) queryQEDs.get(queryIndex);
        BitSet[] queryPred = tempQuery.getPredicates().getAppropriatePredicateTypeBitSet("join").getPredicateBitSets();

        if (queryIDs.contains(new Integer(tempQuery.getQueryNum()))) {
            //union the bits ==> set the relevenat query bits in the attributes
            //this will correspond to the satisfied queries of the evaluated predicate
            /*ArrayList newTupleAttrBS = */
            this.setBits(
                queryPred,
                tempQuery.getPredicates().getIsEvaluated_Relevant("join").getPredicateBitSets(),
                tPS.getAppropriatePredicateTypeBitSet("join").getPredicateBitSets(),
                tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("join").getPredicateBitSets());
            // tuples.getFirstTuple().getBS().setJoin(newTupleAttrBS);
        }
    }

}

/**
 * Sets the tuple's relevant window predicate bitset. All, one or two parameters
 * can be set. Each parameter indicates which predicate
 * type needs to be compared.
 * Creation date: (1/12/2003 10:29:14 PM)
 * @param attr boolean
 * @param join boolean
 * @param tuple juggler.stream.JugglerTuple
 */
public void setRelevantWindowBits(
    boolean attr,
    boolean join,
	JugglerTupleList tuples) {
    ExtPredicateBitSet tPS = tuples.getFirstTuple().getPredicates();

    BitSet[] evaluatedPred;
    BitSet[] isRelvantPred;
    ArrayList queryIDs = new ArrayList();

    //retrieves all teh relevant query IDs of the evaluated predicates (attr or window)
    if (attr) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("attribute").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("attribute").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "attribute");
        else
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "attribute");
        tuples.getFirstTuple().setQuerySatisfied(queryIDs);
    }
    if (join) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("join").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("join").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "join");
        else
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "join");
        tuples.getFirstTuple().setQuerySatisfied(queryIDs);
    }

    for (int i = 0; i < queryIDs.size(); i++) {
        int queryNum = ((Integer) queryIDs.get(i)).intValue();
        QueryQED tempQuery = (QueryQED) queryQEDs.get(queryNum);
        BitSet[] queryPred = tempQuery.getPredicates().getAppropriatePredicateTypeBitSet("window").getPredicateBitSets();

        if (queryIDs.contains(new Integer(tempQuery.getQueryNum()))) {
            //union the bits ==> set the relevenat query bits in the attributes
            //this will correspond to the satisfied queries of the evaluated predicate
            /*ArrayList newTupleAttrBS = */
            this.setBits(
                queryPred,
                tempQuery.getPredicates().getIsEvaluated_Relevant("window").getPredicateBitSets(),
                tPS.getAppropriatePredicateTypeBitSet("window").getPredicateBitSets(),
                tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("window").getPredicateBitSets());
            //tuples.getFirstTuple().getBS().setWindow(newTupleAttrBS);
        }
    }

}

/**
 * Returns the queryIDs of all the queries this BitSet[] satisfies 
 * Creation date: (1/12/2003 10:28:23 PM)
 * @return ArrayList
 * @param attrBitSet BitSet[]
 */
public ArrayList getSuperSetofQuery(BitSet[] attrBitSet, BitSet[] relArrBS, String predName) {

	ArrayList satisfiedQueryIDList = new ArrayList();  
	
	for (int i = 0;i < this.getQueryQEDs().size();i++) {
		QueryQED q = (QueryQED) this.getQueryQEDs().get(i);
		//make sure the parameter BitSets is a superset of the query's BitSets
		ExtPredicateBitSet extps = q.getPredicates();
		if (extps.isSuperset(attrBitSet, relArrBS, predName))
			satisfiedQueryIDList.add(new Integer (q.getQueryNum()));
			
	}
	return satisfiedQueryIDList;
}

/**
 * Returns the queryIDs of all the queries this BitSet[] satisfies 
 * Creation date: (1/12/2003 10:28:23 PM)
 * @return ArrayList
 * @param attrBitSet BitSet[]
 */
public ArrayList getSuperSetofQuery(BitSet[] winBitSet, BitSet[] winRelBS, ArrayList possibleQueries, String predName) {

	ArrayList satisfiedQueryIDList = new ArrayList();
	
	for (int i = 0;i < possibleQueries.size();i++) {
		int queryNum = ((Integer) possibleQueries.get(i)).intValue();
		QueryQED q = (QueryQED) this.getQueryQEDs().get(queryNum);
	
		//make sure the parameter BitSets is a superset of the query's BitSets
		if(q.getPredicates().isSuperset(winBitSet, winRelBS, predName))
			satisfiedQueryIDList.add(new Integer (q.getQueryNum()));
	}
	return satisfiedQueryIDList;
}

/**
 * Returns the union of all teh bits of the two  Predicate BitSet parameters.
 * Creation date: (2/25/2003 2:31:34 PM)
 * @param pBS ArrayList
 * @param tBS ArrayList
 * @return void
 */
public void clearBits(
    BitSet[] pBS,
    BitSet[] evalpBS,
    BitSet[] tBS,
    BitSet[] evaltBS) {

    //if the tuple's bitset has not been initialized.
    if (tBS == null) {
        tBS = pBS;
    }

    //for each predicate list
    for (int i = 0; i < pBS.length; i++) {

        //union all teh eval bits
        BitSet evalPredBS = (BitSet) ((BitSet) evalpBS[i]).clone();
        BitSet evalTupleBS = (BitSet) evaltBS[i];
        evalTupleBS.andNot(evalPredBS);

    }
}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 11:27:58 PM)
 * @return java.util.ArrayList
 * @param newFoundQueryIDs java.util.ArrayList
 * @param oldQueryIDs java.util.ArrayList
 */
public ArrayList compareNewFoundQueryIDs(ArrayList newFoundQueryIDs, ArrayList oldQueryIDs) {
	ArrayList unsatisfiedQueries = new ArrayList();
	for (int i = 0; i < oldQueryIDs.size(); i++){
		Integer anOldQueryID = (Integer) oldQueryIDs.get(i);
		if (newFoundQueryIDs.indexOf(anOldQueryID) < 0)
			unsatisfiedQueries.add(anOldQueryID);				
	}
	return unsatisfiedQueries;
}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 11:36:12 PM)
 * @param tuples juggler.stream.JugglerTupleList
 * @param predicateTypeName java.lang.String
 */
public void removeQueryPredicates(
    JugglerTupleList tuples,
    ArrayList unsatisfiedQueryIDs,
    String predicateTypeName) {

    for (int i = 0; i < unsatisfiedQueryIDs.size(); i++) {
        int queryNum = ((Integer) unsatisfiedQueryIDs.get(i)).intValue();
        QueryQED tempQuery = (QueryQED) queryQEDs.get(queryNum);
        //gets the query bitsets
        BitSet[] queryPred =
            tempQuery
                .getPredicates()
                .getAppropriatePredicateTypeBitSet(predicateTypeName)
                .getPredicateBitSets();

        if (unsatisfiedQueryIDs.contains(new Integer(tempQuery.getQueryNum()))) {
            // clear the bits that are needed for this query
            //this will correspond to the unsatisfied queries of the evaluated predicate
            this.clearBits(
                queryPred,
                tempQuery
                    .getPredicates()
                    .getAppropriatePredicateTypeExt(predicateTypeName)
                    .getIsEvaluated_Relevant()
                    .getPredicateBitSets(),
                tuples
                    .getFirstTuple()
                    .getPredicates()
                    .getAppropriatePredicateTypeBitSet(predicateTypeName)
                    .getPredicateBitSets(),
                tuples
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant(predicateTypeName)
                    .getPredicateBitSets());
        }
    }
}

/**
 * Sets the tuple's relevant attribute predicate bitset. All, one or two parameters
 * can be set. Each parameter indicates which predicate
 * type needs to be compared.
 Assumes query numbers start from 0, onwards in order.
 * Creation date: (1/12/2003 10:29:14 PM)
 * @param join boolean
 * @param window boolean
 * @param tuple juggler.stream.JugglerTuple
 */
public void setRelevantBits(boolean attr,
    boolean join,
    boolean window,
	JugglerTupleList tuples, String currentPredicateTypeName) {
    ExtPredicateBitSet tPS = tuples.getFirstTuple().getPredicates();

    //evaluted predicates bitsets
    BitSet[] evaluatedPred;
    BitSet[] isRelvantPred;
    ArrayList queryIDs = new ArrayList();
    ArrayList nowUnsatisfiedQueryIDs = new ArrayList();

     //retrieves all teh relevant query IDs of the evaluated predicates (attr or window)
    if (attr) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("attribute").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("attribute").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "attribute");
        else {
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "attribute");
        	nowUnsatisfiedQueryIDs = compareNewFoundQueryIDs(queryIDs, tuples.getFirstTuple().getQuerySatisfied());
       	}
            tuples.getFirstTuple().setQuerySatisfied(queryIDs);
    }
    //retrieves all teh relevant query IDs of the evaluated predicates (join or window)
    if (join) {
        evaluatedPred = ((GeneralPredicateBitSet)tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("join")).getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("join").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0) 
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "join");
        else {
        queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "join");
        nowUnsatisfiedQueryIDs = compareNewFoundQueryIDs(queryIDs, tuples.getFirstTuple().getQuerySatisfied());
        }
        tuples.getFirstTuple().setQuerySatisfied(queryIDs);
    }
    if (window) {
        evaluatedPred = tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet("window").getPredicateBitSets();
        isRelvantPred =
            tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant("window").getPredicateBitSets();
        if (tuples.getFirstTuple().getQuerySatisfied().size() == 0)
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, "window");
        else {
            queryIDs = this.getSuperSetofQuery(evaluatedPred, isRelvantPred, tuples.getFirstTuple().getQuerySatisfied(), "window");
        nowUnsatisfiedQueryIDs = compareNewFoundQueryIDs(queryIDs, tuples.getFirstTuple().getQuerySatisfied());
            }
            tuples.getFirstTuple().setQuerySatisfied(queryIDs);

    }

    if (nowUnsatisfiedQueryIDs.size() > 0)
    	removeQueryPredicates(tuples, nowUnsatisfiedQueryIDs, currentPredicateTypeName);

    for (int i = 0; i < queryIDs.size(); i++) {
        int queryNum = ((Integer) queryIDs.get(i)).intValue();
        QueryQED tempQuery = (QueryQED) queryQEDs.get(queryNum);
        //gets the query bitsets
        BitSet[] queryPred = tempQuery.getPredicates().getAppropriatePredicateTypeBitSet(currentPredicateTypeName).getPredicateBitSets();

        if (queryIDs.contains(new Integer(tempQuery.getQueryNum()))) {
            //union the bits ==> set the relevenat query bits in the attributes
            //this will correspond to the satisfied queries of the evaluated predicate
            this.setBits(
                queryPred,
                tempQuery.getPredicates().getAppropriatePredicateTypeExt(currentPredicateTypeName).getIsEvaluated_Relevant().getPredicateBitSets(),
                tuples.getFirstTuple().getPredicates().getAppropriatePredicateTypeBitSet(currentPredicateTypeName).getPredicateBitSets(),
                tuples.getFirstTuple().getPredicates().getIsEvaluated_Relevant(currentPredicateTypeName).getPredicateBitSets());
        }
    }
	
}

/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:30:35 AM)
 * @return java.util.ArrayList
 */
public QueryQED getQueryQED(int queryID) {
	for(int i = 0; i < queryQEDs.size(); i++){
		QueryQED aQuery = (QueryQED) queryQEDs.get(i);
		if(aQuery.getQueryNum() == queryID)
			return aQuery;
	}
	return null;
	//return (QueryQED)queryQEDs.get(queryID);
}

/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:30:35 AM)
 * @return java.util.ArrayList
 */
public ArrayList getQueryQEDs() {
	
	return queryQEDs;
}
}
