package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query;

import java.io.Serializable;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation.ExtGeneralTypeBitSet;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation.ExtPredicateBitSet;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation.GeneralPredicateBitSet;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DeepCopyMaker;

/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 11:05:03 PM)
 * @author: Administrator
 */
public class QueryQED /* implements Cloneable*/ implements Serializable{
	protected int QueryNum;
	protected ArrayList streams;
	protected ExtPredicateBitSet predicates;
	protected java.util.ArrayList predicateStreams;
/**
 * Query constructor comment.
 */
public QueryQED() {
	super();
	ArrayList predicateNames = new ArrayList();
	predicateNames.add("attribute");
	predicateNames.add("join");
	predicateNames.add("window");
	predicates = new ExtPredicateBitSet(predicateNames);
	streams = new ArrayList();
	QueryNum = -1;
	predicateStreams = new ArrayList();
}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 1:10:42 PM)
 * @return java.lang.Object
 */
public Object getClone() {
    QueryQED q = new QueryQED();
  
        q.predicates =
            (ExtPredicateBitSet) 
                this.getPredicates().getClone();
        q.QueryNum = this.getQueryNum();
        try {
        q.streams =
            (ArrayList) DeepCopyMaker.makeDeepCopy(this.getStreams());
    } catch (Exception e) {
        System.out.println(e.toString());
    }
    return q;
}
/**
 * Returns the PredicateBitSet representation of this query.
 * Creation date: (1/10/2003 12:13:30 AM)
 * @return juggler.query.ExtPredicateBitSet
 */
public ExtPredicateBitSet getPredicates() {
	return predicates;
}
/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 2:46:57 PM)
 * @return java.util.ArrayList
 */
public java.util.ArrayList getPredicateStreams() {
	return predicateStreams;
}
/**
 * Returns the unique query number for this query.
 * Creation date: (1/9/2003 11:05:53 PM)
 * @return int
 */
public int getQueryNum() {
	return QueryNum;
}
/**
 * Returns the streamIDs of the streams of the query.
 * Creation date: (1/9/2003 11:07:00 PM)
 * @return String[]
 */
public ArrayList getStreams() {
	return streams;
}
/**
 * Returns true if tuple's attribute bitset is a superset of any of the query's attribute bitset.
 * Creation date: (1/10/2003 12:12:13 AM)
 * @return boolean
 * @param attrTuple java.util.BitSet
 */
public boolean isSuperset(java.util.BitSet attrTuple, String predName) {

	ExtGeneralTypeBitSet gbs = (ExtGeneralTypeBitSet) this.getPredicates().getAppropriatePredicateTypeExt(predName);
	GeneralPredicateBitSet pbs = gbs.getPredBSList();

    if (pbs.isSuperset(attrTuple))
        return true;
    else
        return false;
}
/**
 * Returns true if the tuple's ExtPredicateBitSet is a superset of the query's predicateBitSet
 * Creation date: (1/10/2003 12:17:08 AM)
 * @param tuplePredicateBitSet juggler.query.ExtPredicateBitSet
 */
public boolean isSuperset(
ExtPredicateBitSet tuplePredicateBitSet) {
	    //bitsets of attribute, join, window


	 return   (this.getPredicates().isSuperset(tuplePredicateBitSet));
}
/**
 * Sets the predicate bitset of this query.
 * Creation date: (1/10/2003 12:13:30 AM)
 * @param newPredicates juggler.query.ExtPredicateBitSet
 */
public void setPredicates(ExtPredicateBitSet newPredicates) {
	predicates = newPredicates;
}
/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 2:46:57 PM)
 * @param newPredicateStreams java.util.ArrayList
 */
public void setPredicateStreams(java.util.ArrayList newPredicateStreams) {
	predicateStreams = newPredicateStreams;
}
/**
 * Sets the query ID.
 * Creation date: (1/9/2003 11:05:53 PM)
 * @param newQueryNum int
 */
public void setQueryNum(int newQueryNum) {
	QueryNum = newQueryNum;
}
/**
 * Sets the streamIDs of that this query will join.
 * Creation date: (1/9/2003 11:07:00 PM)
 * @param newStreams ArrayList
 */
public void setStreams(ArrayList newStreams) {
	streams = newStreams;
}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
    // Insert code to print the receiver here.
    // This implementation forwards the message to super. You may replace or supplement this.

    String queryQED = "";
    queryQED += "QueryNum:" + this.getQueryNum() + "\n" + "\n";
    if (predicates != null)
        queryQED += predicates.toString();

    return queryQED;
}
}
