package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.BinaryVSMulti;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.XATJugglerOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.XATJugglerOperatorImp;

import java.util.*;


/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Apr 2, 2004
 * 
 * Insert comments here.
 */
public class BK_TH_JugglerPlan {

	public static XATDag createPlan(){
		
		XATDag tree = new XATDagImp();
		
		DagNode d1 = new DagNodeImp();
		DagNode d2 = new DagNodeImp();
		DagNode d3 = new DagNodeImp();
		DagNode d4 = new DagNodeImp();
		DagNode d5 = new DagNodeImp();
		DagNode d6 = new DagNodeImp();
		DagNode d7 = new DagNodeImp();
		
		
		tree.addRoot(d7);
		
		// 1st tier
		d7.addChild(d5);
		d7.addChild(d6);
		
		//2nd tier
		d5.addChild(d1);
		d5.addChild(d4);
		
		d6.addChild(d3);
		d6.addChild(d4);
		
		
		// streams
		
		d1.addStream("B");
		d2.addStream("H");
		d3.addStream("T");
		d4.addStream("K");
		
		
		// Now make operators
		SchemaNameChangeOperator o1,o2,o3,o4;
		XATStreamOperator o5, o6, o7;
		
		o1 = new SchemaNameChangeOperatorImp(d1);
		o1.setStreamName("B");
		d1.setOperator((o1));
				
		o2 = new SchemaNameChangeOperatorImp(d2);
		o2.setStreamName("H");
		d2.setOperator((o2));
		
		o3 = new SchemaNameChangeOperatorImp(d3);
		o3.setStreamName("T");
		d3.setOperator((o3));
		
		o4 = new SchemaNameChangeOperatorImp(d4);
		o4.setStreamName("K");
		d4.setOperator((o4));
		
		
		o5 = new XATJugglerOperatorImp(d5);
		((XATJugglerOperator) o5).initialize(/*num of queues */
													"1",
													/*query information */
													"Query ID = 1; BK;",
													/*attr predicates*/
													"Query ID = 1;B.pressure(0) gt 90;K.fluid(0) gt 200;" 
													/*join predicates */
													,"Query ID = 1;B.pressure(0) lt K.fluid(0);" 
													/*window predicates */
													,"Query ID = 1;B.ts(0) lt K.ts(0);"
													);
		
		
		d5.setOperator((o5));
		
		o6 = new XATJugglerOperatorImp(d6);
		((XATJugglerOperator) o6).initialize(/*num of queues */
													"1",
													/*query information */
													"Query ID = 1; TH;",
													/*attr predicates*/
													"Query ID = 1;H.beatrate(0) gt 115;T.fluct(0) lt 200;" 
													/*join predicates */
													,"Query ID = 1;T.incr(2) lt H.beatrate(0);" 
													/*window predicates */
													,"Query ID = 1;T.ts(0) gt H.ts(0);"
													);
		
		
		d6.setOperator((o6));
		
		o7 = new XATJugglerOperatorImp(d7);
		((XATJugglerOperator) o7).initialize(/*num of queues */
													"1",
													/*query information */
													"Query ID = 1; BHTK;",
													/*attr predicates*/
													"Query ID = 1;" 
													/*join predicates */
													,"Query ID = 1;B.pressure(0) = H.vib(1);B.temp(1) = T.deg(1);K.fluid(0) = T.fluct(0);H.vib(1) lt K.fluid(0);" 
													/*window predicates */
													,"Query ID = 1;B.ts(0) lt H.ts(0);B.ts(0) lt T.ts(0);T.ts(0) lt K.ts(0);H.ts(0) lt K.ts(0);"
													);
		
		
		d7.setOperator((o7));
		
		
		
		
		// Now connect the queues
		
		XATQueue q1 = new XATQueueImp();
		q1.setQueueName("B");
		o1.addInputQueue(q1);
		
		XATQueue q2 = new XATQueueImp();
		q2.setQueueName("H");
		o2.addInputQueue(q2);
		
		XATQueue q3 = new XATQueueImp();
		q3.setQueueName("T");
		o3.addInputQueue(q3);
		
		XATQueue q4 = new XATQueueImp();
		q4.setQueueName("K");
		o4.addInputQueue(q4);
		
		
		XATQueue q5 = o1.getOutputQueue();
		XATQueue q6 = o2.getOutputQueue();
		XATQueue q7 = o3.getOutputQueue();
		XATQueue q8 = o4.getOutputQueue();
		
		o5.addInputQueue(q5);
		o5.addInputQueue(q8);
		
		o6.addInputQueue(q6);
		o6.addInputQueue(q7);
		
		XATQueue q9 = o5.getOutputQueue();
		XATQueue q10 = o6.getOutputQueue();
		
		o7.addInputQueue(q9);
		o7.addInputQueue(q10);
		
			
		return tree;
		
	}
	
	
	public static void main(String[] args){
		
		System.out.println(createPlan());
	}
}
