package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.*;
import java.util.*;


/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Apr 2, 2004
 * 
 * Insert comments here.
 */
public class JugglerPlan {

	public static XATDag createPlan(){
		
		XATDag tree = new XATDagImp();
		
		DagNode d1 = new DagNodeImp();
		DagNode d2 = new DagNodeImp();
		DagNode d3 = new DagNodeImp();
		DagNode d4 = new DagNodeImp();
		DagNode d5 = new DagNodeImp();
		DagNode d6 = new DagNodeImp();
		DagNode d7 = new DagNodeImp();
		DagNode d8 = new DagNodeImp();
		DagNode d9 = new DagNodeImp();
		DagNode d10 = new DagNodeImp();
		DagNode d11 = new DagNodeImp();
		DagNode d12 = new DagNodeImp();
		
		tree.addRoot(d10);
		tree.addRoot(d11);
		
		// 1st tier
		d10.addChild(d12);
		d11.addChild(d12);
		
		d12.addParent(d10);
		d12.addParent(d11);
		
		d12.addChild(d9);
		d12.addChild(d8);
		
		// 2nd tier
		d9.addChild(d5);
		d9.addChild(d6);
		d9.addChild(d7);
		
		
		d5.addParent(d9);
		d6.addParent(d9);
		d7.addParent(d9);
		d8.addParent(d12);
		
		// 3rd tier
		
		d5.addChild(d1);
		d6.addChild(d2);
		d7.addChild(d3);
		d8.addChild(d4);
		
		d1.addParent(d5);
		d2.addParent(d6);
		d3.addParent(d7);
		d4.addParent(d8);
		
		// streams
		
		d1.addStream("Nile");
		d2.addStream("Nile");
		d3.addStream("Nile");
		d4.addStream("Nile");
		
		
		// Now make operators
		SchemaNameChangeOperator o1,o2,o3,o4;
		XATStreamOperator o5,o6,o7,o8,o9,o10,o11,o12;
		
		o1 = new SchemaNameChangeOperatorImp(d1);
		o1.setStreamName("B");
		
		d1.setOperator((o1));
		
		o2 = new SchemaNameChangeOperatorImp(d2);
		o2.setStreamName("H");
		d2.setOperator((o2));
				
		o3 = new SchemaNameChangeOperatorImp(d3);
		o3.setStreamName("T");
		d3.setOperator((o3));
				
		o4 = new SchemaNameChangeOperatorImp(d4);
		o4.setStreamName("K");
		d4.setOperator((o4));
		
		o5 = new ProbabilisticSingleStreamOperatorImp(d5);
		d5.setOperator(o5);
		
		o6 = new ProbabilisticSingleStreamOperatorImp(d6);
		d6.setOperator(o6);
				
		o7 = new ProbabilisticSingleStreamOperatorImp(d7);
		d7.setOperator(o7);
				
		o8 = new ProbabilisticSingleStreamOperatorImp(d8);
		d8.setOperator(o8);
				
		o9 = new XATJugglerOperatorImp(d9);
		((XATJugglerOperator) o9).initialize("1","Query ID = 0; BHT;","Query ID = 0;B.objectID(6) gt 900;B.objectID(6) lt 4000;","Query ID = 0;B.objectID(6) gt H.objectID(6);B.objectID(6) gt H.objectID(6);","Query ID = 0;B.ts(0) lt H.ts(0);B.ts(0) lt H.ts(0);");
		d9.setOperator(o9);
		
		o10 = new ProbabilisticSingleStreamOperatorImp(d10);
		d10.setOperator(o10);
				
		o11 = new ProbabilisticSingleStreamOperatorImp(d11);
		d11.setOperator(o11);
		
		o12 = new XATJugglerOperatorImp(d12);
		((XATJugglerOperator) o12).initialize("2","Query ID = 0; BHTK;Query ID = 1; BHTK;","Query ID = 0;K.objectID(6) lt 4000;Query ID = 1;K.objectID(6) lt 4000;","Query ID = 0;K.objectID(6) gt H.objectID(6);Query ID = 1;K.objectID(6) gt H.objectID(6);","Query ID = 0;B.ts(0) lt K.ts(0);Query ID = 1;B.ts(0) lt K.ts(0);");
		d12.setOperator(o12);
		
		// Now connect the queues
		
		XATQueue q1 = new XATQueueImp();
		q1.setQueueName("Nile");
		o1.addInputQueue(q1);
		
		XATQueue q2 = new XATQueueImp();
		q2.setQueueName("Nile");
		o2.addInputQueue(q2);
		
		XATQueue q3 = new XATQueueImp();
		q3.setQueueName("Nile");
		o3.addInputQueue(q3);
		
		XATQueue q4 = new XATQueueImp();
		q4.setQueueName("Nile");
		o4.addInputQueue(q4);
		
		XATQueue q5 = o1.getOutputQueue();
		o5.addInputQueue(q5);
		
		XATQueue q6 = o2.getOutputQueue();
		o6.addInputQueue(q6);
				
		XATQueue q7 = o3.getOutputQueue();
		o7.addInputQueue(q7);
				
		XATQueue q8 = o4.getOutputQueue();
		o8.addInputQueue(q8);
		
		XATQueue q9 = o5.getOutputQueue();
		o9.addInputQueue(q9);
		
		XATQueue q10 = o6.getOutputQueue();
		o9.addInputQueue(q10);
				
		XATQueue q11 = o7.getOutputQueue();
		o9.addInputQueue(q11);
		
		XATQueue q12 = o9.getOutputQueue();
		o12.addInputQueue(q12);
		
		XATQueue q13 = o8.getOutputQueue();
		o12.addInputQueue(q13);
		
		Iterator i = o12.getOutputQueues();
		
		XATQueue q14 = (XATQueue) i.next();
		o10.addInputQueue(q14);
		
		XATQueue q15 = (XATQueue) i.next();
		o11.addInputQueue(q15);
			
		return tree;
		
	}
	
	
	public static void main(String[] args){
		
		System.out.println(createPlan());
	}
}
