package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.OverlapPredicates;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.XATJugglerOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.XATJugglerOperatorImp;

import java.util.*;


/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Apr 2, 2004
 * 
 * Insert comments here.
 */
public class twentyFivePer_JugglerPlan {

	public static XATDag createPlan(){
		
		XATDag tree = new XATDagImp();
		
		DagNode d1 = new DagNodeImp();
		DagNode d2 = new DagNodeImp();
		DagNode d3 = new DagNodeImp();
	
		
		tree.addRoot(d1);
		
		// 1st tier
		d1.addChild(d2);
		d1.addChild(d3);
		
		d2.addParent(d1);
		d3.addParent(d1);
		
		// streams
		
		d2.addStream("B");
		d3.addStream("H");
		
		
		// Now make operators
		SchemaNameChangeOperator o2,o3;
		XATStreamOperator o1;
		
		
		o2 = new SchemaNameChangeOperatorImp(d2);
		o2.setStreamName("B");
		d2.setOperator((o2));
				
		o3 = new SchemaNameChangeOperatorImp(d3);
		o3.setStreamName("H");
		d3.setOperator((o3));
				
		o1 = new XATJugglerOperatorImp(d1);
		((XATJugglerOperator) o1).initialize(/*num of queues */
											"3",
											/*query information */
											"Query ID = 1; BH;Query ID = 2; BH;Query ID = 3; BH;",
											/*attr predicates*/
											"Query ID = 1;B.pressure(0) gt 90;" +
											"Query ID = 2;B.pressure(0) gt 110;H.beatrate(0) gt 115;"+
											"Query ID = 3;B.pressure(0) gt 110;H.beatrate(0) gt= 115;H.vib(1) gt 80;"+
											"Query ID = 4;B.pressure(0) gt 110;H.beatrate(0) lt 115;H.vib(1) lt 80;B.temp(1) gt 90;"+
											"Query ID = 5;B.pressure(0) gt 110;H.beatrate(0) = 115;H.vib(1) = 100;B.temp(1) = 98;"
											/*join predicates */
											,"Query ID = 1;B.pressure(0) gt H.vib(1);" +
											"Query ID = 2;B.pressure(0) gt= H.vib(1);B.pressure(0) gt H.beatrate(0);"+
											"Query ID = 3;B.pressure(0) gt= H.vib(1);B.pressure(0) lt H.beatrate(0);B.temp(1) gt H.beatrate(0);"+
											"Query ID = 4;B.pressure(0) gt= H.vib(1);B.pressure(0) = H.beatrate(0);B.temp(1) gt= H.beatrate(0);B.temp(1) gt H.vib(1);"+
											"Query ID = 5;B.pressure(0) lt H.vib(1);B.pressure(0) gt= H.beatrate(0);B.temp(1) lt H.beatrate(0);B.temp(1) gt= H.vib(1);"
											/*window predicates */
											,"Query ID = 1;B.ts(0) gt H.ts(0);"+
											"Query ID = 2;B.ts(0) lt H.ts(0);"+
											"Query ID = 3;B.ts(0) lt H.ts(0);"+
											"Query ID = 4;B.ts(0) lt= H.ts(0);"+
											"Query ID = 5;B.ts(0) gt= H.ts(0);"
											);
		
		
		d1.setOperator(o1);
		
		// Now connect the queues
		
		XATQueue q2 = new XATQueueImp();
		q2.setQueueName("B");
		o2.addInputQueue(q2);
		
		XATQueue q3 = new XATQueueImp();
		q3.setQueueName("H");
		o3.addInputQueue(q3);
		
		XATQueue q4 = o2.getOutputQueue();
		XATQueue q5 = o3.getOutputQueue();
		
		o1.addInputQueue(q4);
		o1.addInputQueue(q5);
		
		
			
		return tree;
		
	}
	
	
	public static void main(String[] args){
		
		System.out.println(createPlan());
	}
}
