package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.UpdateSelectivities;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.XATJugglerOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan.XATJugglerOperatorImp;

import java.util.*;


/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Apr 2, 2004
 * 
 * Insert comments here.
 */
public class BH_T_JugglerPlan {

	public static XATDag createPlan(){
		
		XATDag tree = new XATDagImp();
		
		DagNode d1 = new DagNodeImp();
		DagNode d2 = new DagNodeImp();
		DagNode d3 = new DagNodeImp();
		DagNode d4 = new DagNodeImp();
		DagNode d5 = new DagNodeImp();
		
		
		tree.addRoot(d5);
		
		// 1st tier
		d5.addChild(d3);
		d5.addChild(d4);
		
		//1st tier
		d4.addChild(d1);
		d4.addChild(d2);
		
		// streams
		
		d1.addStream("B");
		d2.addStream("H");
		d3.addStream("T");
		
		
		// Now make operators
		SchemaNameChangeOperator o1,o2,o3;
		XATStreamOperator o4, o5;
		
		o1 = new SchemaNameChangeOperatorImp(d1);
		o1.setStreamName("B");
		d1.setOperator((o1));
				
		o2 = new SchemaNameChangeOperatorImp(d2);
		o2.setStreamName("H");
		d2.setOperator((o2));
		
		o3 = new SchemaNameChangeOperatorImp(d3);
		o3.setStreamName("T");
		d3.setOperator((o3));
		
		o4 = new XATJugglerOperatorImp(d4);
		((XATJugglerOperator) o4).initialize(/*num of queues */
													"1",
													/*query information */
													"Query ID = 1; BH;",
													/*attr predicates*/
													"Query ID = 1;B.pressure(0) gt 90;H.beatrate(0) gt 115;" 
													/*join predicates */
													,"Query ID = 1;B.pressure(0) = H.vib(1);" 
													/*window predicates */
													,"Query ID = 1;B.ts(0) gt H.ts(0);"
													);
		
		
		d4.setOperator((o4));
		
		o5 = new XATJugglerOperatorImp(d5);
		((XATJugglerOperator) o5).initialize(/*num of queues */
											"1",
											/*query information */
											"Query ID = 1; BHT;",
											/*attr predicates*/
											"Query ID = 1;T.fluct(0) lt 200;" 
											/*join predicates */
											,"Query ID = 1;B.temp(1) = T.deg(1);H.vib(1) lt T.fluct(0);" 
											/*window predicates */
											,"Query ID = 1;B.ts(0) lt T.ts(0);H.ts(0) lt T.ts(0);"
											);
		
		
				d5.setOperator((o5));
		
		
		
		// Now connect the queues
		
		XATQueue q1 = new XATQueueImp();
		q1.setQueueName("B");
		o1.addInputQueue(q1);
		
		XATQueue q2 = new XATQueueImp();
		q2.setQueueName("H");
		o2.addInputQueue(q2);
		
		XATQueue q3 = new XATQueueImp();
		q3.setQueueName("T");
		o3.addInputQueue(q3);
		
		XATQueue q4 = o1.getOutputQueue();
		XATQueue q5 = o2.getOutputQueue();
		o4.addInputQueue(q4);
		o4.addInputQueue(q5);
		
		XATQueue q6 = o4.getOutputQueue();
		o4.addInputQueue(q6);
		o4.addInputQueue(q3);
		
		
			
		return tree;
		
	}
	
	
	public static void main(String[] args){
		
		System.out.println(createPlan());
	}
}
