/*
 * Created on Jan 2, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan;

import java.util.ArrayList;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;

/**
 * @author asilva
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class XATJugglerOperatorDriver {

	public static void main(String[] args) {
		XATJugglerOperatorDriver driver = new XATJugglerOperatorDriver();
		//driver.testQuery10();
		//driver.testQuery10_Queue(); //this works! 4 output -- change timestamp
		//driver.testQuery10_EmptyQueueAtStartup(); //this works also
		//driver.testQuery10_Queue_WithTwoOperators(); //this owrks, firt one puts out 4 , second one puts out 3; requires change of ts
		//driver.testQuery10_Queue_XATTuple();
		driver.testQuery10_Queue_WithTwoOperators_JoinedXATTuple();
	}

	/**
	 * Doesn't return any joined tuples
	 * entering the operator are done properly.
	 * Creation date: (3/5/2003 11:01:09 PM)
	 */
	public void testQuery10() {

		ArrayList streamNameB = new ArrayList();
		streamNameB.add("B");
		ArrayList streamNameH = new ArrayList();
		streamNameH.add("H");
		ArrayList streamNameT = new ArrayList();
		streamNameT.add("T");
		ArrayList streamNameK = new ArrayList();
		streamNameK.add("K");

		//****** 1. define Queries

		//Query 0
		//Query String format: "Query ID = n; streams;"
		String query0 = "Query ID = 0; BHTK;";

		//Select     H.alert
		//From  B, H, K, T
		//Window    T.ts > B.ts 
		//MaxWindow  4sec
		//Where      B.pressure > 90 and
		//  H.beatrate = 52 and
		//   B.temp > H.vib

		//T.ts > B.ts
		String winStr = "Query ID = 0;T.ts(0) > B.ts(0);";

		//  B.temp > H.vib
		String joinStr = "Query ID = 0;B.temp(2) > H.vib(2);";

		//B.pressure > 90
		String attrStr = "Query ID = 0;B.pressure(1) > 90;";

		//  H.beatrate = 52 
		attrStr += "H.beatrate(1) = 52;";

		//Query 1
		//Select    B.alert
		//From     B, T, H
		//Window    B.ts > T.ts and 
		//   B.ts < H.ts
		//MaxWindow  6sec
		//Where    B.pressure > 120
		//T.fluct * 2 = 103 and 
		//B.pressure > 2 * T.fluct
		//B.temp > H.vib

		//Query String format: "Query ID = n; streams;"
		String query1 = "Query ID = 1; BHT;";

		//B.pressure > 2 * T.fluct
		String joinStr1 = "Query ID = 1;B.pressure(1) > T.fluct(3)*2;";

		//B.temp > H.vib
		joinStr1 += "B.temp(2) > H.vib(2);";

		// B.ts > T.ts 
		String winStr1 = "Query ID = 1;B.ts(0) > T.ts(0);";

		// B.ts < H.ts
		winStr1 += "B.ts(0) < H.ts(0);";

		//   B.pressure > 120
		String attrStr1 = "Query ID = 1;B.pressure(1) > 120;";

		//T.fluct * 2= 103
		attrStr1 += "T.fluct(3)*2 = 103;";

		String query = query0 + query1;
		attrStr = attrStr + attrStr1;
		winStr = winStr + winStr1;
		joinStr = joinStr + joinStr1;

		XATNode jugglerNode = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp =
			new XATJugglerOperatorImp(jugglerNode);
		jugglerOp.initialize("2", query, attrStr, joinStr, winStr);

		System.out.println(jugglerOp.getPredicateManager().queryToString());

	}

	/**
	 * Doesn't return any joined tuples
	 * entering the operator are done properly.
	 * Creation date: (3/5/2003 11:01:09 PM)
	 */
	public void testQuery10_Queue() {

		ArrayList streamNameB = new ArrayList();
		streamNameB.add("B");
		ArrayList streamNameH = new ArrayList();
		streamNameH.add("H");
		ArrayList streamNameT = new ArrayList();
		streamNameT.add("T");
		ArrayList streamNameK = new ArrayList();
		streamNameK.add("K");

		//****** 1. define Queries

		//Query 0
		//Query String format: "Query ID = n; streams;"
		String query0 = "Query ID = 0; BHTK;";

		//Select     H.alert
		//From  B, H, K, T
		//Window    T.ts > B.ts 
		//MaxWindow  4sec
		//Where      B.pressure > 90 and
		//  H.beatrate = 52 and
		//   B.temp > H.vib

		//T.ts > B.ts
		String winStr = "Query ID = 0;T.ts(0) > B.ts(0);";

		//  B.temp > H.vib
		String joinStr = "Query ID = 0;B.temp(2) > H.vib(2);";

		//B.pressure > 90
		String attrStr = "Query ID = 0;B.pressure(1) > 90;";

		//  H.beatrate = 52 
		attrStr += "H.beatrate(1) = 52;";

		//Query 1
		//Select    B.alert
		//From     B, T, H
		//Window    B.ts > T.ts and 
		//   B.ts < H.ts
		//MaxWindow  6sec
		//Where    B.pressure > 120
		//T.fluct * 2 = 103 and 
		//B.pressure > 2 * T.fluct
		//B.temp > H.vib

		//Query String format: "Query ID = n; streams;"
		String query1 = "Query ID = 1; BHT;";

		//B.pressure > 2 * T.fluct
		String joinStr1 = "Query ID = 1;B.pressure(1) > T.fluct(3)*2;";

		//B.temp > H.vib
		joinStr1 += "B.temp(2) > H.vib(2);";

		// B.ts > T.ts 
		String winStr1 = "Query ID = 1;B.ts(0) > T.ts(0);";

		// B.ts < H.ts
		winStr1 += "B.ts(0) < H.ts(0);";

		//   B.pressure > 120
		String attrStr1 = "Query ID = 1;B.pressure(1) > 120;";

		//T.fluct * 2= 103
		attrStr1 += "T.fluct(3)*2 = 103;";

		String query = query0 + query1;
		attrStr = attrStr + attrStr1;
		winStr = winStr + winStr1;
		joinStr = joinStr + joinStr1;

		XATNode jugglerNode = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp =
			new XATJugglerOperatorImp(jugglerNode);
		jugglerOp.initialize("3", query, attrStr, joinStr, winStr);

		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());

		System.out.println(jugglerOp.getPredicateManager().queryToString());

		//****** 3. Create the tuples in teh system
		//Stream B-- ts, pressure, temp, alert
		ArrayList tuples_B = new ArrayList();

		ArrayList streamIDs_B = new ArrayList(1);
		streamIDs_B.add(new Integer(1));

		Vector B_ts = new Vector(10);
		B_ts.add(0, new KeyDouble(6));
		B_ts.add(1, new KeyDouble(1));
		B_ts.add(2, new KeyDouble(7));
		B_ts.add(3, new KeyDouble(2));
		B_ts.add(4, new KeyDouble(8));

		Vector B_pressure = new Vector(10);
		B_pressure.add(0, new KeyDouble(85));
		B_pressure.add(1, new KeyDouble(97));
		B_pressure.add(2, new KeyDouble(100));
		B_pressure.add(3, new KeyDouble(150));
		B_pressure.add(4, new KeyDouble(150));

		Vector B_temp = new Vector(10);
		B_temp.add(0, new KeyDouble(101));
		B_temp.add(1, new KeyDouble(101));
		B_temp.add(2, new KeyDouble(101));
		B_temp.add(3, new KeyDouble(101));
		B_temp.add(4, new KeyDouble(101));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(4);
			tupleVal.add(0, (KeyDouble) B_ts.get(i));
			tupleVal.add(1, (KeyDouble) B_pressure.get(i));
			tupleVal.add(2, (KeyDouble) B_temp.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_B);
			t.setStreamNames(streamNameB);
			//tuples_B.add(t);
			tuples_B.add(tList);
		}

		//Stream H-- ts, beatrate, vib
		ArrayList tuples_H = new ArrayList();

		ArrayList streamIDs_H = new ArrayList(1);
		streamIDs_H.add(new Integer(1));

		ArrayList streamNames_H = new ArrayList();
		streamNames_H.add(streamNameH);

		Vector H_ts = new Vector(10);
		H_ts.add(0, new KeyDouble(6));
		H_ts.add(1, new KeyDouble(1));
		H_ts.add(2, new KeyDouble(7));
		H_ts.add(3, new KeyDouble(2));
		H_ts.add(4, new KeyDouble(8));

		Vector H_beatrate = new Vector(10);
		H_beatrate.add(0, new KeyDouble(52));
		H_beatrate.add(1, new KeyDouble(50));
		H_beatrate.add(2, new KeyDouble(50));
		H_beatrate.add(3, new KeyDouble(50));
		H_beatrate.add(4, new KeyDouble(50));

		Vector H_vib = new Vector(10);
		H_vib.add(0, new KeyDouble(90));
		H_vib.add(1, new KeyDouble(98));
		H_vib.add(2, new KeyDouble(98));
		H_vib.add(3, new KeyDouble(98));
		H_vib.add(4, new KeyDouble(89));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(3);
			tupleVal.add(0, (KeyDouble) H_ts.get(i));
			tupleVal.add(1, (KeyDouble) H_beatrate.get(i));
			tupleVal.add(2, (KeyDouble) H_vib.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_H);
			t.setStreamNames(streamNameH);
			tuples_H.add(tList);
			//tuples_H.add(t);
		}

		//Stream T-- ts, fluct, degrees, fluct, incr
		ArrayList tuples_T = new ArrayList();

		ArrayList streamIDs_T = new ArrayList(1);
		streamIDs_T.add(new Integer(1));

		Vector T_ts = new Vector(10);
		T_ts.add(0, new KeyDouble(1));
		T_ts.add(1, new KeyDouble(6));
		T_ts.add(2, new KeyDouble(2));
		T_ts.add(3, new KeyDouble(7));
		T_ts.add(4, new KeyDouble(3));

		Vector T_fluct = new Vector(10);
		T_fluct.add(0, new KeyDouble(103));
		T_fluct.add(1, new KeyDouble(99));
		T_fluct.add(2, new KeyDouble(99));
		T_fluct.add(3, new KeyDouble(99));
		T_fluct.add(4, new KeyDouble(206));

		Vector T_degrees = new Vector(10);
		T_degrees.add(0, new KeyDouble(98));
		T_degrees.add(1, new KeyDouble(98));
		T_degrees.add(2, new KeyDouble(98));
		T_degrees.add(3, new KeyDouble(98));
		T_degrees.add(4, new KeyDouble(100));

		Vector T_incr = new Vector(10);
		T_incr.add(0, new KeyDouble(101));
		T_incr.add(1, new KeyDouble(101));
		T_incr.add(2, new KeyDouble(101));
		T_incr.add(3, new KeyDouble(101));
		T_incr.add(4, new KeyDouble(104));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(5);
			tupleVal.add(0, (KeyDouble) T_ts.get(i));
			tupleVal.add(1, (KeyDouble) T_fluct.get(0));
			tupleVal.add(2, (KeyDouble) T_degrees.get(i));
			tupleVal.add(3, (KeyDouble) T_fluct.get(i));
			tupleVal.add(4, (KeyDouble) T_incr.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_T);
			t.setStreamNames(streamNameT);
			tuples_T.add(tList);
			//tuples_T.add(t);
		}

		//Stream K-- ts, fluid
		ArrayList tuples_K = new ArrayList();

		ArrayList streamIDs_K = new ArrayList(1);
		streamIDs_K.add(new Integer(1));

		Vector K_ts = new Vector(10);
		K_ts.add(0, new KeyDouble(1));
		K_ts.add(1, new KeyDouble(6));
		K_ts.add(2, new KeyDouble(2));
		K_ts.add(3, new KeyDouble(7));
		K_ts.add(4, new KeyDouble(3));

		Vector K_fluid = new Vector(10);
		K_fluid.add(0, new KeyDouble(100));
		K_fluid.add(1, new KeyDouble(150));
		K_fluid.add(2, new KeyDouble(150));
		K_fluid.add(3, new KeyDouble(75));
		K_fluid.add(4, new KeyDouble(150));

		for (int i = 0; i < 1; i++) {
			Vector tupleVal = new Vector(2);
			tupleVal.add(0, (KeyDouble) K_ts.get(i));
			tupleVal.add(1, (KeyDouble) K_fluid.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_K);
			t.setStreamNames(streamNameK);
			//tuples_K.add(t);
			tuples_K.add(tList);
		}

		//****** 4. Enter the tuples in the system

		//apply attribute predicates first
		jugglerOp.getPredicateManager().enterTuplesOptimized(tuples_B);
		//predOrderMan.enterTuplesOptimized(tuples_H);
		//predOrderMan.enterTuplesOptimized(tuples_T);
		jugglerOp.getPredicateManager().enterTuplesOptimized(tuples_K);

		//****** 5. Create new set of tuples to join
		ArrayList newJoinTuples = new ArrayList();

		// B = ts, pressure, temp

		// T = ts, fluct, degrees, fluct, incr
		Vector tupleValToJoin_T = new Vector(5);
		tupleValToJoin_T.add(0, new KeyDouble(1));
		tupleValToJoin_T.add(1, new KeyDouble(103));
		tupleValToJoin_T.add(2, new KeyDouble(101));
		tupleValToJoin_T.add(3, new KeyDouble(103));
		tupleValToJoin_T.add(4, new KeyDouble(98));

		JugglerTuple newT_T = new JugglerTuple(tupleValToJoin_T);
		newT_T.setStreamNames(streamNameT);
		JugglerTupleList newT_T_List = new JugglerTupleList(newT_T);

		JugglerTupleList newH_T = (JugglerTupleList) tuples_H.get(0);

		try {
			if ((newT_T_List.getTuple().getTimeStamp().getMaxTimeStamp())
				> (newH_T.getTuple().getTimeStamp().getMaxTimeStamp())) {
				newT_T_List.setTimeStamp(newT_T.getTimeStamp());
			} else
				newT_T_List.setTimeStamp(newH_T.getTimeStamp());
		} catch (XATTimeStampException e) {
		}

		//newT_T_List.getTuple().setFirstHalfJoinedTupleMarker(false);
		newT_T_List.appendTupleList(newH_T);
		newT_T_List.setJoinTupleMarkerAfterJoining();

		newJoinTuples.add(newT_T_List);

		//****** 6. Get the resulting tuples

		XATQueue TH_Q = jugglerOp.getNthInputQueue(0);

		TH_Q.enqueue(newJoinTuples, jugglerOp);

		jugglerOp.run();

		/*
		
		ArrayList outputTuplesList = predOrderMan.processTuples(newJoinTuples.iterator());
		Iterator outputTuples = outputTuplesList.iterator();
		*/

		// Iterator outputTuples = predOrderMan.getIntermediateBuffer().iterator();
		String result = "Resulting tuples are: \n";
		/*
		while (outputTuples.hasNext()) {
			JugglerTupleList resultTupleList = (JugglerTupleList) outputTuples.next();
			result += "Queries Satisfied: " + resultTupleList.getFirstTuple().getQuerySatisfied().toString() +" ";
			result += resultTupleList.getStreamNames().toString() + " ";
			JugglerTupleListIterator resultListIt = new JugglerTupleListIterator(resultTupleList);
			while (resultListIt.hasNext()) {
				JugglerTuple atuple = (JugglerTuple) resultListIt.next();
				result += atuple.toString() + " ";
			}
			result +="\n";
			result += resultTupleList.getFirstTuple().getPredicates().toString();
			result += "\n \n \n";
		}
		System.out.println(result);		
		
		System.out.println("DONE");*/
	}

	/**
	 * Doesn't return any joined tuples
	 * entering the operator are done properly.
	 * Creation date: (3/5/2003 11:01:09 PM)
	 */
	public void testQuery10_Queue_XATTuple() {

		ArrayList streamNameB = new ArrayList();
		streamNameB.add("B");
		ArrayList streamNameH = new ArrayList();
		streamNameH.add("H");
		ArrayList streamNameT = new ArrayList();
		streamNameT.add("T");
		ArrayList streamNameK = new ArrayList();
		streamNameK.add("K");

		//****** 1. define Queries

		//Query 0
		//Query String format: "Query ID = n; streams;"
		String query0 = "Query ID = 0; BHTK;";

		//Select     H.alert
		//From  B, H, K, T
		//Window    T.ts > B.ts 
		//MaxWindow  4sec
		//Where      B.pressure > 90 and
		//  H.beatrate = 52 and
		//   B.temp > H.vib

		//T.ts > B.ts
		String winStr = "Query ID = 0;T.ts(0) > B.ts(0);";

		//  B.temp > H.vib
		String joinStr = "Query ID = 0;B.temp(2) > H.vib(7);";

		//B.pressure > 90
		String attrStr = "Query ID = 0;B.pressure(1) > 90;";

		//  H.beatrate = 52 
		attrStr += "H.beatrate(6) = 52;";

		//Query 1
		//Select    B.alert
		//From     B, T, H
		//Window    B.ts > T.ts and 
		//   B.ts < H.ts
		//MaxWindow  6sec
		//Where    B.pressure > 120
		//T.fluct * 2 = 103 and 
		//B.pressure > 2 * T.fluct
		//B.temp > H.vib

		//Query String format: "Query ID = n; streams;"
		String query1 = "Query ID = 1; BHT;";

		//B.pressure > 2 * T.fluct
		String joinStr1 = "Query ID = 1;B.pressure(1) > T.fluct(3)*2;";

		//B.temp > H.vib
		joinStr1 += "B.temp(2) > H.vib(7);";

		// B.ts > T.ts 
		String winStr1 = "Query ID = 1;B.ts(0) > T.ts(0);";

		// B.ts < H.ts
		winStr1 += "B.ts(0) < H.ts(5);";

		//   B.pressure > 120
		String attrStr1 = "Query ID = 1;B.pressure(1) > 120;";

		//T.fluct * 2= 103
		attrStr1 += "T.fluct(3)*2 = 103;";

		String query = query0 + query1;
		attrStr = attrStr + attrStr1;
		winStr = winStr + winStr1;
		joinStr = joinStr + joinStr1;

		XATNode jugglerNode = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp =
			new XATJugglerOperatorImp(jugglerNode);
		jugglerOp.setParsePlan(false);
		jugglerOp.initialize("3", query, attrStr, joinStr, winStr);

		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());

		System.out.println(jugglerOp.getPredicateManager().queryToString());

		//****** 3. Create the tuples in teh system
		//Stream B-- ts, pressure, temp, alert
		XATTuple[] tuples_B = new XATTuple[5];

		ArrayList streamIDs_B = new ArrayList(1);
		streamIDs_B.add(new Integer(1));

		Vector B_ts = new Vector(10);
		B_ts.add(0, "6");
		B_ts.add(1, "1");
		B_ts.add(2, "7");
		B_ts.add(3, "2");
		B_ts.add(4, "8");

		Vector B_pressure = new Vector(10);
		B_pressure.add(0, "85");
		B_pressure.add(1, "97");
		B_pressure.add(2, "100");
		B_pressure.add(3, "150");
		B_pressure.add(4, "150");

		Vector B_temp = new Vector(10);
		B_temp.add(0, "101");
		B_temp.add(1, "101");
		B_temp.add(2, "101");
		B_temp.add(3, "101");
		B_temp.add(4, "101");

		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleB = new XATDataValue[3];

			tupleB[0] = new XATDataValueImp((String) B_ts.get(i));
			tupleB[1] = new XATDataValueImp((String) B_pressure.get(i));
			tupleB[2] = new XATDataValueImp((String) B_temp.get(i));

			XATTuple t = new XATTupleImp(tupleB);
			tuples_B[i] = t;
		}

		//Stream H-- ts, beatrate, vib
		XATTuple[] tuples_H = new XATTuple[5];

		ArrayList streamIDs_H = new ArrayList(1);
		streamIDs_H.add(new Integer(1));

		ArrayList streamNames_H = new ArrayList();
		streamNames_H.add(streamNameH);

		Vector H_ts = new Vector(10);
		H_ts.add(0, "6");
		H_ts.add(1, "1");
		H_ts.add(2, "7");
		H_ts.add(3, "2");
		H_ts.add(4, "8");

		Vector H_beatrate = new Vector(10);
		H_beatrate.add(0, "52");
		H_beatrate.add(1, "50");
		H_beatrate.add(2, "50");
		H_beatrate.add(3, "50");
		H_beatrate.add(4, "50");

		Vector H_vib = new Vector(10);
		H_vib.add(0, "90");
		H_vib.add(1, "98");
		H_vib.add(2, "98");
		H_vib.add(3, "98");
		H_vib.add(4, "89");

		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleH = new XATDataValue[3];

			tupleH[0] = new XATDataValueImp((String) H_ts.get(i));
			tupleH[1] = new XATDataValueImp((String) H_beatrate.get(i));
			tupleH[2] = new XATDataValueImp((String) H_vib.get(i));

			XATTuple t = new XATTupleImp(tupleH);
			tuples_H[i] = t;
		}

		//Stream T-- ts, fluct, degrees, fluct, incr
		XATTuple[] tuples_T = new XATTuple[5];

		ArrayList streamIDs_T = new ArrayList(1);
		streamIDs_T.add(new Integer(1));

		Vector T_ts = new Vector(10);
		T_ts.add(0, "1");
		T_ts.add(1, "6");
		T_ts.add(2, "2");
		T_ts.add(3, "7");
		T_ts.add(4, "3");

		Vector T_fluct = new Vector(10);
		T_fluct.add(0, "103");
		T_fluct.add(1, "99");
		T_fluct.add(2, "99");
		T_fluct.add(3, "99");
		T_fluct.add(4, "206");

		Vector T_degrees = new Vector(10);
		T_degrees.add(0, "98");
		T_degrees.add(1, "98");
		T_degrees.add(2, "98");
		T_degrees.add(3, "98");
		T_degrees.add(4, "100");

		Vector T_incr = new Vector(10);
		T_incr.add(0, "101");
		T_incr.add(1, "101");
		T_incr.add(2, "101");
		T_incr.add(3, "101");
		T_incr.add(4, "104");

		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleT = new XATDataValue[5];

			tupleT[0] = new XATDataValueImp((String) T_ts.get(i));
			tupleT[1] = new XATDataValueImp((String) T_fluct.get(0));
			tupleT[2] = new XATDataValueImp((String) T_degrees.get(i));
			tupleT[3] = new XATDataValueImp((String) T_fluct.get(i));
			tupleT[4] = new XATDataValueImp((String) T_incr.get(i));

			XATTuple t = new XATTupleImp(tupleT);
			tuples_T[i] = t;
		}

		//Stream K-- ts, fluid
		XATTuple[] tuples_K = new XATTuple[1];

		ArrayList streamIDs_K = new ArrayList(1);
		streamIDs_K.add(new XATDataValueImp("1"));

		Vector K_ts = new Vector(5);
		K_ts.add(0, "1");
		K_ts.add(1, "6");
		K_ts.add(2, "2");
		K_ts.add(3, "7");
		K_ts.add(4, "3");

		Vector K_fluid = new Vector(5);
		K_fluid.add(0, "100");
		K_fluid.add(1, "150");
		K_fluid.add(2, "150");
		K_fluid.add(3, "75");
		K_fluid.add(4, "150");

		for (int i = 0; i < 1; i++) {
			XATDataValue[] tupleK = new XATDataValue[2];

			tupleK[0] = new XATDataValueImp((String) K_ts.get(i));
			tupleK[1] = new XATDataValueImp((String) K_fluid.get(i));

			XATTuple t = new XATTupleImp(tupleK);

			tuples_K[i] = t;
		}

		//****** 4. Enter the tuples in the system
		for (int i = 0; i < jugglerOp.getInputQueueCount(); i++) {
			XATQueue aqueue = jugglerOp.getNthInputQueue(i);
			XATQueueSchema schema = new XATQueueSchema();
			String queueName = "";
			if (i == 0) {
				for(int m = 0; m < streamNameB.size(); m++)
				 queueName += (String)streamNameB.get(m);
			}
			if (i == 1) {
				streamNameH.addAll(streamNameT);
				for(int j = 0; j < streamNameH.size(); j++)
				 queueName += (String)streamNameH.get(j);
			}
			if (i == 2) {
				for(int k = 0; k < streamNameK.size(); k++)
								 queueName += (String)streamNameK.get(k);
			}
			schema.setName(queueName);
			aqueue.setSchema(schema);
			//jugglerOp.setNthInputQueue(aqueue, i);
		}
		
		jugglerOp.getNthInputQueue(0).enqueue(tuples_B, jugglerOp);
		jugglerOp.getNthInputQueue(2).enqueue(tuples_K, jugglerOp);
		
		jugglerOp.run_XATTuple();
		//apply attribute predicates first

		//jugglerOp.getPredicateManager().enterTuplesOptimized_XATTuples(
			//tuples_B);
		//predOrderMan.enterTuplesOptimized(tuples_H);
		//predOrderMan.enterTuplesOptimized(tuples_T);
		//jugglerOp.getPredicateManager().enterTuplesOptimized_XATTuples(
			//tuples_K);

		//****** 5. Create new set of tuples to join
		XATTuple[] newJoinTuples = new XATTuple[1];

		// B = ts, pressure, temp

		// T = ts, fluct, degrees, fluct, incr
		XATDataValue[] tupleValToJoin_T = new XATDataValue[5];
		tupleValToJoin_T[0] = new XATDataValueImp("1");
		tupleValToJoin_T[1] = new XATDataValueImp("103");
		tupleValToJoin_T[2] = new XATDataValueImp("101");
		tupleValToJoin_T[3] = new XATDataValueImp("103");
		tupleValToJoin_T[4] = new XATDataValueImp("98");

		XATTuple newT_T = new XATTupleImp(tupleValToJoin_T);
		//newT_T.setStreamNames(streamNameT);
		//JugglerTupleList newT_T_List = new JugglerTupleList(newT_T);

		XATTuple newH_H = (XATTuple) tuples_H[0];

		XATDataValue[] htTuples =
			new XATDataValueImp[newT_T.getArrayData().length
				+ newH_H.getArrayData().length];
		htTuples[0] = newT_T.getCell(0);
		htTuples[1] = newT_T.getCell(1);
		htTuples[2] = newT_T.getCell(2);
		htTuples[3] = newT_T.getCell(3);
		htTuples[4] = newT_T.getCell(4);
		htTuples[newT_T.getLength()] = newH_H.getCell(0);
		htTuples[newT_T.getLength()+1] = newH_H.getCell(1);
		htTuples[newT_T.getLength()+2] = newH_H.getCell(2);
		
		
		XATTuple newH_T = new XATTupleImp(htTuples);
		//((JugglerTuple)newH_T).j

		//newT_T_List.getTuple().setFirstHalfJoinedTupleMarker(false);
		//newT_T_List.appendTupleList(newH_T);
		//(newT_T_List).setJoinTupleMarkerAfterJoining();

		newJoinTuples[0] = newH_T;

		//****** 6. Get the resulting tuples

		XATQueue TH_Q = jugglerOp.getNthInputQueue(1);

		TH_Q.enqueue(newJoinTuples, jugglerOp);

		jugglerOp.run_XATTuple();

		/*
		
		ArrayList outputTuplesList = predOrderMan.processTuples(newJoinTuples.iterator());
		Iterator outputTuples = outputTuplesList.iterator();
		*/

		// Iterator outputTuples = predOrderMan.getIntermediateBuffer().iterator();
		String result = "Resulting tuples are: \n";
		/*
		while (outputTuples.hasNext()) {
			JugglerTupleList resultTupleList = (JugglerTupleList) outputTuples.next();
			result += "Queries Satisfied: " + resultTupleList.getFirstTuple().getQuerySatisfied().toString() +" ";
			result += resultTupleList.getStreamNames().toString() + " ";
			JugglerTupleListIterator resultListIt = new JugglerTupleListIterator(resultTupleList);
			while (resultListIt.hasNext()) {
				JugglerTuple atuple = (JugglerTuple) resultListIt.next();
				result += atuple.toString() + " ";
			}
			result +="\n";
			result += resultTupleList.getFirstTuple().getPredicates().toString();
			result += "\n \n \n";
		}
		System.out.println(result);		
		
		System.out.println("DONE");*/
	}

	/**
	 * Doesn't return any joined tuples
	 * entering the operator are done properly.
	 * Creation date: (3/5/2003 11:01:09 PM)
	 */
	public void testQuery10_Queue_WithTwoOperators() {

		ArrayList streamNameB = new ArrayList();
		streamNameB.add("B");
		ArrayList streamNameH = new ArrayList();
		streamNameH.add("H");
		ArrayList streamNameT = new ArrayList();
		streamNameT.add("T");
		ArrayList streamNameK = new ArrayList();
		streamNameK.add("K");

		//****** 1. define Queries

		//Query 0
		//Query String format: "Query ID = n; streams;"
		String Operator1_query0 = "Query ID = 0; BHT;";
		String Operator2_query0 = "Query ID = 0; BHTK;";

		//Select     H.alert
		//From  B, H, K, T
		//Window    T.ts > B.ts 
		// and H.ts > B.ts
		//MaxWindow  4sec
		//Where      B.pressure > 90 and
		//  H.beatrate = 52 and
		//   B.temp > H.vib

		//T.ts > B.ts
		String Operator1_winStr = "Query ID = 0;T.ts(0) > B.ts(0);";
		//H.ts > B.ts
		//Operator1_winStr += "H.ts(0) > B.ts(0);";
		//H.ts >= K.ts
		String Operator2_winStr = "Query ID = 0;H.ts(0) >= K.ts(0);";

		//  B.temp > H.vib
		String Operator1_joinStr = "Query ID = 0;B.temp(2) > H.vib(2);";
		// B.temp > T.incr
		//Operator1_joinStr += "B.temp(2) > T.incr(4);";
		//T.incr < K.fluid
		String Operator2_joinStr = "Query ID = 0;T.incr(4) < K.fluid(1);";

		//B.pressure > 90
		String Operator1_attrStr = "Query ID = 0;B.pressure(1) > 90;";
		//  H.beatrate = 52 
		//Operator1_attrStr += "H.beatrate(1) = 52;";
		//K.fluid <= 150 
		String Operator2_attrStr = "Query ID = 0;K.fluid(1) <= 150;";

		//Query 1
		//Select    B.alert
		//From     B, T, H
		//Window    B.ts > T.ts and 
		//   B.ts < H.ts
		//MaxWindow  6sec
		//Where    B.pressure > 120
		//T.fluct * 2 = 103 and 
		//B.pressure > 2 * T.fluct
		//B.temp > H.vib

		//Query String format: "Query ID = n; streams;"
		String Operator1_query1 = "Query ID = 1; BHT;";

		//B.pressure > 2 * T.fluct
		Operator1_joinStr += "Query ID = 1;B.pressure(1) > T.fluct(3)*2;";
		//B.temp > H.vib
		Operator1_joinStr += "B.temp(2) > H.vib(2);";

		// B.ts > T.ts 
		Operator1_winStr += "Query ID = 1;B.ts(0) > T.ts(0);";
		// B.ts < H.ts
		Operator1_winStr += "B.ts(0) < H.ts(0);";

		//   B.pressure > 120
		Operator1_attrStr += "Query ID = 1;B.pressure(1) > 120;";
		//T.fluct * 2= 103
		Operator1_attrStr += "T.fluct(3)*2 = 103;";

		String Operator1_query = Operator1_query0 + Operator1_query1;

		XATNode jugglerNode = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp1 =
			new XATJugglerOperatorImp(jugglerNode);
		jugglerOp1.initialize(
			"2",
			Operator1_query,
			Operator1_attrStr,
			Operator1_joinStr,
			Operator1_winStr);

		XATNode jugglerNode2 = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp2 =
			new XATJugglerOperatorImp(jugglerNode2);
		jugglerOp2.initialize(
			"2",
			Operator2_query0,
			Operator2_attrStr,
			Operator2_joinStr,
			Operator2_winStr);

		System.out.println("\n\n\nOperator 1:\n");

		System.out.println(
			jugglerOp1
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp1
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp1
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());

		System.out.println(jugglerOp1.getPredicateManager().queryToString());

		System.out.println("\n\n\nOperator 2:\n");
		System.out.println(
			jugglerOp2
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp2
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp2
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());

		System.out.println(jugglerOp2.getPredicateManager().queryToString());

		//****** 3. Create the tuples in teh system
		//Stream B-- ts, pressure, temp, alert
		ArrayList tuples_B = new ArrayList();

		ArrayList streamIDs_B = new ArrayList(1);
		streamIDs_B.add(new Integer(1));

		Vector B_ts = new Vector(10);
		B_ts.add(0, new KeyDouble(6));
		B_ts.add(1, new KeyDouble(1));
		B_ts.add(2, new KeyDouble(7));
		B_ts.add(3, new KeyDouble(2));
		B_ts.add(4, new KeyDouble(8));

		Vector B_pressure = new Vector(10);
		B_pressure.add(0, new KeyDouble(85));
		B_pressure.add(1, new KeyDouble(97));
		B_pressure.add(2, new KeyDouble(100));
		B_pressure.add(3, new KeyDouble(150));
		B_pressure.add(4, new KeyDouble(150));

		Vector B_temp = new Vector(10);
		B_temp.add(0, new KeyDouble(101));
		B_temp.add(1, new KeyDouble(101));
		B_temp.add(2, new KeyDouble(101));
		B_temp.add(3, new KeyDouble(101));
		B_temp.add(4, new KeyDouble(101));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(4);
			tupleVal.add(0, (KeyDouble) B_ts.get(i));
			tupleVal.add(1, (KeyDouble) B_pressure.get(i));
			tupleVal.add(2, (KeyDouble) B_temp.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_B);
			t.setStreamNames(streamNameB);
			//tuples_B.add(t);
			tuples_B.add(tList);
		}

		//Stream H-- ts, beatrate, vib
		ArrayList tuples_H = new ArrayList();

		ArrayList streamIDs_H = new ArrayList(1);
		streamIDs_H.add(new Integer(1));

		ArrayList streamNames_H = new ArrayList();
		streamNames_H.add(streamNameH);

		Vector H_ts = new Vector(10);
		H_ts.add(0, new KeyDouble(6));
		H_ts.add(1, new KeyDouble(1));
		H_ts.add(2, new KeyDouble(7));
		H_ts.add(3, new KeyDouble(2));
		H_ts.add(4, new KeyDouble(8));

		Vector H_beatrate = new Vector(10);
		H_beatrate.add(0, new KeyDouble(52));
		H_beatrate.add(1, new KeyDouble(50));
		H_beatrate.add(2, new KeyDouble(50));
		H_beatrate.add(3, new KeyDouble(50));
		H_beatrate.add(4, new KeyDouble(50));

		Vector H_vib = new Vector(10);
		H_vib.add(0, new KeyDouble(90));
		H_vib.add(1, new KeyDouble(98));
		H_vib.add(2, new KeyDouble(98));
		H_vib.add(3, new KeyDouble(98));
		H_vib.add(4, new KeyDouble(89));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(3);
			tupleVal.add(0, (KeyDouble) H_ts.get(i));
			tupleVal.add(1, (KeyDouble) H_beatrate.get(i));
			tupleVal.add(2, (KeyDouble) H_vib.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_H);
			t.setStreamNames(streamNameH);
			tuples_H.add(tList);
			//tuples_H.add(t);
		}

		//Stream T-- ts, fluct, degrees, fluct, incr
		ArrayList tuples_T = new ArrayList();

		ArrayList streamIDs_T = new ArrayList(1);
		streamIDs_T.add(new Integer(1));

		Vector T_ts = new Vector(10);
		T_ts.add(0, new KeyDouble(1));
		T_ts.add(1, new KeyDouble(6));
		T_ts.add(2, new KeyDouble(2));
		T_ts.add(3, new KeyDouble(7));
		T_ts.add(4, new KeyDouble(3));

		Vector T_fluct = new Vector(10);
		T_fluct.add(0, new KeyDouble(103));
		T_fluct.add(1, new KeyDouble(99));
		T_fluct.add(2, new KeyDouble(99));
		T_fluct.add(3, new KeyDouble(99));
		T_fluct.add(4, new KeyDouble(206));

		Vector T_degrees = new Vector(10);
		T_degrees.add(0, new KeyDouble(98));
		T_degrees.add(1, new KeyDouble(98));
		T_degrees.add(2, new KeyDouble(98));
		T_degrees.add(3, new KeyDouble(98));
		T_degrees.add(4, new KeyDouble(100));

		Vector T_incr = new Vector(10);
		T_incr.add(0, new KeyDouble(101));
		T_incr.add(1, new KeyDouble(101));
		T_incr.add(2, new KeyDouble(101));
		T_incr.add(3, new KeyDouble(101));
		T_incr.add(4, new KeyDouble(104));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(5);
			tupleVal.add(0, (KeyDouble) T_ts.get(i));
			tupleVal.add(1, (KeyDouble) T_fluct.get(0));
			tupleVal.add(2, (KeyDouble) T_degrees.get(i));
			tupleVal.add(3, (KeyDouble) T_fluct.get(i));
			tupleVal.add(4, (KeyDouble) T_incr.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_T);
			t.setStreamNames(streamNameT);
			tuples_T.add(tList);
			//tuples_T.add(t);
		}

		//Stream K-- ts, fluid
		ArrayList tuples_K = new ArrayList();

		ArrayList streamIDs_K = new ArrayList(1);
		streamIDs_K.add(new Integer(1));

		Vector K_ts = new Vector(10);
		K_ts.add(0, new KeyDouble(1));
		K_ts.add(1, new KeyDouble(6));
		K_ts.add(2, new KeyDouble(2));
		K_ts.add(3, new KeyDouble(7));
		K_ts.add(4, new KeyDouble(3));

		Vector K_fluid = new Vector(10);
		K_fluid.add(0, new KeyDouble(100));
		K_fluid.add(1, new KeyDouble(150));
		K_fluid.add(2, new KeyDouble(150));
		K_fluid.add(3, new KeyDouble(75));
		K_fluid.add(4, new KeyDouble(150));

		for (int i = 0; i < 5; i++) {
			Vector tupleVal = new Vector(2);
			tupleVal.add(0, (KeyDouble) K_ts.get(i));
			tupleVal.add(1, (KeyDouble) K_fluid.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_K);
			t.setStreamNames(streamNameK);
			//tuples_K.add(t);
			tuples_K.add(tList);
		}

		//****** 4. Add the queues
		XATQueue B_Queue = new XATQueueImp();
		B_Queue.setSchema(new XATQueueSchema());
		B_Queue.getSchema().setName("B");
		
		XATQueue TH_Queue = new XATQueueImp();
		TH_Queue.setSchema(new XATQueueSchema());
		TH_Queue.getSchema().setName("TH");

		//input queue of Operator 1
		//jugglerOp1.getNthInputQueue(0).unregister(jugglerOp1);
		jugglerOp1.setNthInputQueue(B_Queue, 0);
		//jugglerOp1.getNthInputQueue(1).unregister(jugglerOp1);
		jugglerOp1.setNthInputQueue(TH_Queue, 1);

		//output queue of Operator 1 and input queue of Operator 2
		XATQueue BHT_Queue_query0 = new XATQueueImp();
		BHT_Queue_query0.setSchema(new XATQueueSchema());
		BHT_Queue_query0.getSchema().setName("BHT");
		jugglerOp1.setNthOuputQueue(BHT_Queue_query0, 0);
		jugglerOp2.setNthInputQueue(jugglerOp1.getNthOutputQueue(0), 0);

		XATQueue BHT_Queue_query1 = new XATQueueImp();
		BHT_Queue_query1.setSchema(new XATQueueSchema());
		BHT_Queue_query1.getSchema().setName("BHT");
		jugglerOp1.setNthOuputQueue(BHT_Queue_query1, 1);

		//INput Queue of Operator 2
		XATQueue K_Queue = new XATQueueImp();
		K_Queue.setSchema(new XATQueueSchema());
		K_Queue.getSchema().setName("K");
		jugglerOp2.setNthInputQueue(K_Queue, 1);

		//Output queues of Operator 2
		XATQueue BHTK_Queue = new XATQueueImp();
		BHTK_Queue.setSchema(new XATQueueSchema());
		BHTK_Queue.getSchema().setName("BHTK");
		jugglerOp2.setNthOuputQueue(BHTK_Queue, 0);
		


		//apply attribute predicates first
		jugglerOp1.getPredicateManager().enterTuplesOptimized(tuples_B);
		jugglerOp1.getPredicateManager().enterTuplesOptimized(tuples_H);
		jugglerOp1.getPredicateManager().enterTuplesOptimized(tuples_T);
		jugglerOp2.getPredicateManager().enterTuplesOptimized(tuples_K);

		//		****** 4. Enter the tuples in the system

		//****** 5. Create new set of tuples to join
		ArrayList newJoinTuples = new ArrayList();

		// B = ts, pressure, temp

		// T = ts, fluct, degrees, fluct, incr
		Vector tupleValToJoin_T = new Vector(5);
		tupleValToJoin_T.add(0, new KeyDouble(1));
		tupleValToJoin_T.add(1, new KeyDouble(103));
		tupleValToJoin_T.add(2, new KeyDouble(101));
		tupleValToJoin_T.add(3, new KeyDouble(103));
		tupleValToJoin_T.add(4, new KeyDouble(98));

		JugglerTuple newT_T = new JugglerTuple(tupleValToJoin_T);
		newT_T.setStreamNames(streamNameT);
		JugglerTupleList newT_T_List = new JugglerTupleList(newT_T);

		JugglerTupleList newH_T = (JugglerTupleList) tuples_H.get(0);

		try {
			if ((newT_T_List.getTuple().getTimeStamp().getMaxTimeStamp())
				> (newH_T.getTuple().getTimeStamp().getMaxTimeStamp())) {
				newT_T_List.setTimeStamp(newT_T.getTimeStamp());
			} else
				newT_T_List.setTimeStamp(newH_T.getTimeStamp());
		} catch (XATTimeStampException e) {
		}

		//newT_T_List.getTuple().setFirstHalfJoinedTupleMarker(false);
		newT_T_List.appendTupleList(newH_T);
		newT_T_List.setJoinTupleMarkerAfterJoining();

		newJoinTuples.add(newT_T_List);

		//****** 6. Get the resulting tuples
		//enqueue in TH Queue
		jugglerOp1.getNthInputQueue(1).enqueue(newJoinTuples, jugglerOp1);

		System.out.println("Operator 1:\n");
		jugglerOp1.run_Old();

		XATQueue BHT_Q_Operator1Output_Query0 = jugglerOp1.getNthOutputQueue(0);
		XATQueue BHT_Q_Operator1Output_Query1 = jugglerOp1.getNthOutputQueue(1);

		System.out.println("Operator 2:\n");
		jugglerOp2.run_Old();
		XATQueue BHTK_Q_Operator1Output_Query0 =
			jugglerOp2.getNthOutputQueue(0);

		/*
		result = "Resulting tuples for Operator 2 (Query 0) are: \n";
		outputTuplesArray = (ArrayList) BHT_Q_Operator1Output_Query0.dequeueN(BHT_Q_Operator1Output_Query0.getQueueSize(), jugglerOp1);
		outputTuples = outputTuplesArray.iterator();
						while (outputTuples.hasNext()) {
							JugglerTupleList resultTupleList = (JugglerTupleList) outputTuples.next();
							result += "Queries Satisfied: " + resultTupleList.getFirstTuple().getQuerySatisfied().toString() +" ";
							result += resultTupleList.getStreamNames().toString() + " ";
							JugglerTupleListIterator resultListIt = new JugglerTupleListIterator(resultTupleList);
							while (resultListIt.hasNext()) {
								JugglerTuple atuple = (JugglerTuple) resultListIt.next();
								result += atuple.toString() + " ";
							}
							result +="\n";
							//result += resultTupleList.getFirstTuple().getPredicates().toString();
							//result += "\n \n \n";
						}
						System.out.println(result);		
						System.out.println("DONE \n\n");
		*/
	}

	/**
	 * Doesn't return any joined tuples
	 * entering the operator are done properly.
	 * Creation date: (3/5/2003 11:01:09 PM)
	 */
	public void testQuery10_Queue_WithTwoOperators_JoinedXATTuple() {
	
		ArrayList streamNameB = new ArrayList();
		streamNameB.add("B");
		ArrayList streamNameH = new ArrayList();
		streamNameH.add("H");
		ArrayList streamNameT = new ArrayList();
		streamNameT.add("T");
		ArrayList streamNameK = new ArrayList();
		streamNameK.add("K");
	
		//****** 1. define Queries
	
		//Query 0
		//Query String format: "Query ID = n; streams;"
		String Operator1_query0 = "Query ID = 0; BHT;";
		String Operator2_query0 = "Query ID = 0; BHTK;";
	
		//Select     H.alert
		//From  B, H, K, T
		//Window    T.ts > B.ts 
		// and H.ts > B.ts
		//MaxWindow  4sec
		//Where      B.pressure > 90 and
		//  H.beatrate = 52 and
		//   B.temp > H.vib
	
		//T.ts > B.ts
		String Operator1_winStr = "Query ID = 0;T.ts(0) > B.ts(0);";
		//H.ts > B.ts
		//Operator1_winStr += "H.ts(0) > B.ts(0);";
		//H.ts >= K.ts
		String Operator2_winStr = "Query ID = 0;H.ts(5) >= K.ts(0);";
	
		//  B.temp > H.vib
		String Operator1_joinStr = "Query ID = 0;B.temp(2) > H.vib(7);";
		// B.temp > T.incr
		//Operator1_joinStr += "B.temp(2) > T.incr(4);";
		//T.incr < K.fluid
		String Operator2_joinStr = "Query ID = 0;T.incr(4) < K.fluid(1);";
	
		//B.pressure > 90
		String Operator1_attrStr = "Query ID = 0;B.pressure(1) > 90;";
		//  H.beatrate = 52 
		//Operator1_attrStr += "H.beatrate(1) = 52;";
		//K.fluid <= 150 
		String Operator2_attrStr = "Query ID = 0;K.fluid(1) <= 150;";
	
		//Query 1
		//Select    B.alert
		//From     B, T, H
		//Window    B.ts > T.ts and 
		//   B.ts < H.ts
		//MaxWindow  6sec
		//Where    B.pressure > 120
		//T.fluct * 2 = 103 and 
		//B.pressure > 2 * T.fluct
		//B.temp > H.vib
	
		//Query String format: "Query ID = n; streams;"
		String Operator1_query1 = "Query ID = 1; BHT;";
	
		//B.pressure > 2 * T.fluct
		Operator1_joinStr += "Query ID = 1;B.pressure(1) > T.fluct(3)*2;";
		//B.temp > H.vib
		Operator1_joinStr += "B.temp(2) > H.vib(7);";
	
		// B.ts > T.ts 
		Operator1_winStr += "Query ID = 1;B.ts(0) > T.ts(0);";
		// B.ts < H.ts
		Operator1_winStr += "B.ts(0) < H.ts(5);";
	
		//   B.pressure > 120
		Operator1_attrStr += "Query ID = 1;B.pressure(1) > 120;";
		//T.fluct * 2= 103
		Operator1_attrStr += "T.fluct(3)*2 = 103;";
	
		String Operator1_query = Operator1_query0 + Operator1_query1;
	
		XATNode jugglerNode = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp1 =
			new XATJugglerOperatorImp(jugglerNode);
		jugglerOp1.initialize(
			"2",
			Operator1_query,
			Operator1_attrStr,
			Operator1_joinStr,
			Operator1_winStr);
	
		XATNode jugglerNode2 = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp2 =
			new XATJugglerOperatorImp(jugglerNode2);
		jugglerOp2.initialize(
			"2",
			Operator2_query0,
			Operator2_attrStr,
			Operator2_joinStr,
			Operator2_winStr);
	
		System.out.println("\n\n\nOperator 1:\n");
	
		System.out.println(
			jugglerOp1
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp1
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp1
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());
	
		System.out.println(jugglerOp1.getPredicateManager().queryToString());
	
		System.out.println("\n\n\nOperator 2:\n");
		System.out.println(
			jugglerOp2
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp2
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp2
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());
	
		System.out.println(jugglerOp2.getPredicateManager().queryToString());
	
		//****** 3. Create the tuples in teh system
		//Stream B-- ts, pressure, temp, alert
		XATTuple[] tuples_B = new XATTuple[5];
	
		ArrayList streamIDs_B = new ArrayList(1);
		streamIDs_B.add(new Integer(1));
	
		Vector B_ts = new Vector(10);
		B_ts.add(0, "6");
		B_ts.add(1, "1");
		B_ts.add(2, "7");
		B_ts.add(3, "2");
		B_ts.add(4, "8");
	
		Vector B_pressure = new Vector(10);
		B_pressure.add(0, "85");
		B_pressure.add(1, "97");
		B_pressure.add(2, "100");
		B_pressure.add(3, "150");
		B_pressure.add(4, "150");
	
		Vector B_temp = new Vector(10);
		B_temp.add(0, "101");
		B_temp.add(1, "101");
		B_temp.add(2, "101");
		B_temp.add(3, "101");
		B_temp.add(4, "101");
	
		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleB = new XATDataValue[3];

						tupleB[0] = new XATDataValueImp((String) B_ts.get(i));
						tupleB[1] = new XATDataValueImp((String) B_pressure.get(i));
						tupleB[2] = new XATDataValueImp((String) B_temp.get(i));

						XATTuple t = new XATTupleImp(tupleB);
						tuples_B[i] = t;
			
		}
	
		//Stream H-- ts, beatrate, vib
		XATTuple[] tuples_H = new XATTuple[5];
	
		ArrayList streamIDs_H = new ArrayList(1);
		streamIDs_H.add(new Integer(1));
	
		ArrayList streamNames_H = new ArrayList();
		streamNames_H.add(streamNameH);
	
		Vector H_ts = new Vector(10);
		H_ts.add(0, "6");
		H_ts.add(1, "1");
		H_ts.add(2, "7");
		H_ts.add(3, "2");
		H_ts.add(4, "8");
	
		Vector H_beatrate = new Vector(10);
		H_beatrate.add(0, "52");
		H_beatrate.add(1, "50");
		H_beatrate.add(2, "50");
		H_beatrate.add(3, "50");
		H_beatrate.add(4, "50");
	
		Vector H_vib = new Vector(10);
		H_vib.add(0, "90");
		H_vib.add(1, "98");
		H_vib.add(2, "98");
		H_vib.add(3, "98");
		H_vib.add(4, "89");
	
		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleH = new XATDataValue[3];

			tupleH[0] = new XATDataValueImp((String) H_ts.get(i));
			tupleH[1] = new XATDataValueImp((String) H_beatrate.get(i));
			tupleH[2] = new XATDataValueImp((String) H_vib.get(i));

			XATTuple t = new XATTupleImp(tupleH);
			tuples_H[i] = t;
		}
	
		//Stream T-- ts, fluct, degrees, fluct, incr
		XATTuple[] tuples_T = new XATTuple[5];
	
		ArrayList streamIDs_T = new ArrayList(1);
		streamIDs_T.add(new Integer(1));
	
		Vector T_ts = new Vector(10);
		T_ts.add(0, "1");
		T_ts.add(1, "6");
		T_ts.add(2, "2");
		T_ts.add(3, "7");
		T_ts.add(4, "3");
	
		Vector T_fluct = new Vector(10);
		T_fluct.add(0, "103");
		T_fluct.add(1, "99");
		T_fluct.add(2, "99");
		T_fluct.add(3, "99");
		T_fluct.add(4, "206");
	
		Vector T_degrees = new Vector(10);
		T_degrees.add(0, "98");
		T_degrees.add(1, "98");
		T_degrees.add(2, "98");
		T_degrees.add(3, "98");
		T_degrees.add(4, "100");
	
		Vector T_incr = new Vector(10);
		T_incr.add(0, "101");
		T_incr.add(1, "101");
		T_incr.add(2, "101");
		T_incr.add(3, "101");
		T_incr.add(4, "104");
	
		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleT = new XATDataValue[5];

			tupleT[0] = new XATDataValueImp((String) T_ts.get(i));
			tupleT[1] = new XATDataValueImp((String) T_fluct.get(0));
			tupleT[2] = new XATDataValueImp((String) T_degrees.get(i));
			tupleT[3] = new XATDataValueImp((String) T_fluct.get(i));
			tupleT[4] = new XATDataValueImp((String) T_incr.get(i));

			XATTuple t = new XATTupleImp(tupleT);
			tuples_T[i] = t;
		}
	
		//Stream K-- ts, fluid
		XATTuple[] tuples_K = new XATTuple[5];
	
		ArrayList streamIDs_K = new ArrayList(1);
		streamIDs_K.add(new Integer(1));
	
		Vector K_ts = new Vector(10);
		K_ts.add(0, "1");
		K_ts.add(1, "6");
		K_ts.add(2, "2");
		K_ts.add(3, "7");
		K_ts.add(4, "3");
	
		Vector K_fluid = new Vector(10);
		K_fluid.add(0, "100");
		K_fluid.add(1, "150");
		K_fluid.add(2, "150");
		K_fluid.add(3, "75");
		K_fluid.add(4, "150");
	
		for (int i = 0; i < 5; i++) {
			XATDataValue[] tupleK = new XATDataValue[2];

			tupleK[0] = new XATDataValueImp((String) K_ts.get(i));
			tupleK[1] = new XATDataValueImp((String) K_fluid.get(i));

			XATTuple t = new XATTupleImp(tupleK);

			tuples_K[i] = t;
		}
	
		//****** 4. Add the queues
		XATQueue B_Queue = new XATQueueImp();
		B_Queue.setSchema(new XATQueueSchema());
		B_Queue.getSchema().setName("B");
		
		XATQueue TH_Queue = new XATQueueImp();
		TH_Queue.setSchema(new XATQueueSchema());
		TH_Queue.getSchema().setName("TH");
	
		//input queue of Operator 1
		//jugglerOp1.getNthInputQueue(0).unregister(jugglerOp1);
		jugglerOp1.setNthInputQueue(B_Queue, 0);
		//jugglerOp1.getNthInputQueue(1).unregister(jugglerOp1);
		jugglerOp1.setNthInputQueue(TH_Queue, 1);
	
		//output queue of Operator 1 and input queue of Operator 2
		XATQueue BHT_Queue_query0 = new XATQueueImp();
		BHT_Queue_query0.setSchema(new XATQueueSchema());
		BHT_Queue_query0.getSchema().setName("BHT");
		jugglerOp1.setNthOuputQueue(BHT_Queue_query0, 0);
		jugglerOp2.setNthInputQueue(jugglerOp1.getNthOutputQueue(0), 0);
	
		XATQueue BHT_Queue_query1 = new XATQueueImp();
		BHT_Queue_query1.setSchema(new XATQueueSchema());
		BHT_Queue_query1.getSchema().setName("BHT");
		jugglerOp1.setNthOuputQueue(BHT_Queue_query1, 1);
	
		//INput Queue of Operator 2
		XATQueue K_Queue = new XATQueueImp();
		K_Queue.setSchema(new XATQueueSchema());
		K_Queue.getSchema().setName("K");
		jugglerOp2.setNthInputQueue(K_Queue, 1);
	
		//Output queues of Operator 2
		XATQueue BHTK_Queue = new XATQueueImp();
		BHTK_Queue.setSchema(new XATQueueSchema());
		BHTK_Queue.getSchema().setName("BHTK");
		jugglerOp2.setNthOuputQueue(BHTK_Queue, 0);
		
	
	
		//apply attribute predicates first
		jugglerOp1.getNthInputQueue(0).enqueue(tuples_B, jugglerOp1);
		jugglerOp2.getNthInputQueue(1).enqueue(tuples_K, jugglerOp1);
	
		jugglerOp1.run_XATTuple();
		jugglerOp2.run_XATTuple();
	
		//		****** 4. Enter the tuples in the system
	
		//****** 5. Create new set of tuples to join
		ArrayList newJoinTuples = new ArrayList();
	
		// B = ts, pressure, temp
	
		// T = ts, fluct, degrees, fluct, incr
		Vector tupleValToJoin_T = new Vector(5);
		tupleValToJoin_T.add(0, "1");
		tupleValToJoin_T.add(1, "103");
		tupleValToJoin_T.add(2, "101");
		tupleValToJoin_T.add(3, "103");
		tupleValToJoin_T.add(4, "98");
		
		XATDataValue[] newtupleVal = new XATDataValue[5];

		newtupleVal[0] = new XATDataValueImp((String) tupleValToJoin_T.get(0));
		newtupleVal[1] = new XATDataValueImp((String) tupleValToJoin_T.get(1));
		newtupleVal[2] = new XATDataValueImp((String) tupleValToJoin_T.get(2));
		newtupleVal[3] = new XATDataValueImp((String) tupleValToJoin_T.get(3));
		newtupleVal[4] = new XATDataValueImp((String) tupleValToJoin_T.get(4));
		
	
		XATTupleImp newT_T = new XATTupleImp(newtupleVal);
		XATTuple newH_H = (XATTuple) tuples_H[0];
		XATDataValue[] newT_HData = new XATDataValue[newT_T.getArrayData().length + newH_H.getArrayData().length];
		for (int i = 0; i < newT_T.getArrayData().length; i++) {
			newT_HData[i] = (XATDataValue)newT_T.getArrayData()[i];	
		}
		for (int j = newT_T.getArrayData().length; j < newT_HData.length; j++) {
			newT_HData[j] = (XATDataValue)newH_H.getArrayData()[j-5];	
		}
		XATTupleImp newT_H = new XATTupleImp(newT_HData);
	
	
		//****** 6. Get the resulting tuples
		//enqueue in TH Queue
		jugglerOp1.getNthInputQueue(1).enqueue(newT_H, jugglerOp1);
	
		System.out.println("Running Operator  1:\n");
		jugglerOp1.run_XATTuple();
	
		XATQueue BHT_Q_Operator1Output_Query0 = jugglerOp1.getNthOutputQueue(0);
		XATQueue BHT_Q_Operator1Output_Query1 = jugglerOp1.getNthOutputQueue(1);
	
		System.out.println("Running Operator  2:\n");
		jugglerOp2.run_XATTuple();
		XATQueue BHTK_Q_Operator1Output_Query0 =
			jugglerOp2.getNthOutputQueue(0);
		
		System.out.println("Testing Window Exploitation Structures  2:\n");
		jugglerOp1.getNthInputQueue(0).enqueue(tuples_B[0], jugglerOp1);
		jugglerOp1.run_XATTuple();
		jugglerOp1.getNthInputQueue(0).enqueue(tuples_B[1], jugglerOp1);
		jugglerOp1.run_XATTuple();
		
			
		//test the window exp structure cleanup
	
		/*
		result = "Resulting tuples for Operator 2 (Query 0) are: \n";
		outputTuplesArray = (ArrayList) BHT_Q_Operator1Output_Query0.dequeueN(BHT_Q_Operator1Output_Query0.getQueueSize(), jugglerOp1);
		outputTuples = outputTuplesArray.iterator();
						while (outputTuples.hasNext()) {
							JugglerTupleList resultTupleList = (JugglerTupleList) outputTuples.next();
							result += "Queries Satisfied: " + resultTupleList.getFirstTuple().getQuerySatisfied().toString() +" ";
							result += resultTupleList.getStreamNames().toString() + " ";
							JugglerTupleListIterator resultListIt = new JugglerTupleListIterator(resultTupleList);
							while (resultListIt.hasNext()) {
								JugglerTuple atuple = (JugglerTuple) resultListIt.next();
								result += atuple.toString() + " ";
							}
							result +="\n";
							//result += resultTupleList.getFirstTuple().getPredicates().toString();
							//result += "\n \n \n";
						}
						System.out.println(result);		
						System.out.println("DONE \n\n");
		*/
	}

	/**
	 * Doesn't return any joined tuples
	 * entering the operator are done properly.
	 * Creation date: (3/5/2003 11:01:09 PM)
	 */
	public void testQuery10_EmptyQueueAtStartup() {

		ArrayList streamNameB = new ArrayList();
		streamNameB.add("B");
		ArrayList streamNameH = new ArrayList();
		streamNameH.add("H");
		ArrayList streamNameT = new ArrayList();
		streamNameT.add("T");
		ArrayList streamNameK = new ArrayList();
		streamNameK.add("K");

		//****** 1. define Queries

		//Query 0
		//Query String format: "Query ID = n; streams;"
		String query0 = "Query ID = 0; BHTK;";

		//Select     H.alert
		//From  B, H, K, T
		//Window    T.ts > B.ts 
		//MaxWindow  4sec
		//Where      B.pressure > 90 and
		//  H.beatrate = 52 and
		//   B.temp > H.vib

		//T.ts > B.ts
		String winStr = "Query ID = 0;T.ts(0) > B.ts(0);";

		//  B.temp > H.vib
		String joinStr = "Query ID = 0;B.temp(2) > H.vib(2);";

		//B.pressure > 90
		String attrStr = "Query ID = 0;B.pressure(1) > 90;";

		//  H.beatrate = 52 
		attrStr += "H.beatrate(1) = 52;";

		//Query 1
		//Select    B.alert
		//From     B, T, H
		//Window    B.ts > T.ts and 
		//   B.ts < H.ts
		//MaxWindow  6sec
		//Where    B.pressure > 120
		//T.fluct * 2 = 103 and 
		//B.pressure > 2 * T.fluct
		//B.temp > H.vib

		//Query String format: "Query ID = n; streams;"
		String query1 = "Query ID = 1; BHT;";

		//B.pressure > 2 * T.fluct
		String joinStr1 = "Query ID = 1;B.pressure(1) > T.fluct(3)*2;";

		//B.temp > H.vib
		joinStr1 += "B.temp(2) > H.vib(2);";

		// B.ts > T.ts 
		String winStr1 = "Query ID = 1;B.ts(0) > T.ts(0);";

		// B.ts < H.ts
		winStr1 += "B.ts(0) < H.ts(0);";

		//   B.pressure > 120
		String attrStr1 = "Query ID = 1;B.pressure(1) > 120;";

		//T.fluct * 2= 103
		attrStr1 += "T.fluct(3)*2 = 103;";

		String query = query0 + query1;
		attrStr = attrStr + attrStr1;
		winStr = winStr + winStr1;
		joinStr = joinStr + joinStr1;

		XATNode jugglerNode = new XATNodeImp();
		XATJugglerOperatorImp jugglerOp =
			new XATJugglerOperatorImp(jugglerNode);
		jugglerOp.initialize("3", query, attrStr, joinStr, winStr);

		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getAttributePredicateManager()
				.getPredicateList()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getJoinPredicateManager()
				.getPredicateOrderLists()
				.toString());
		System.out.println("\n\n");
		System.out.println(
			jugglerOp
				.getPredicateManager()
				.getWindowPredicateManager()
				.getPredicateOrderLists()
				.toString());

		System.out.println(jugglerOp.getPredicateManager().queryToString());

		//****** 3. Create the tuples in teh system

		//Stream H-- ts, beatrate, vib
		ArrayList tuples_H = new ArrayList();

		ArrayList streamIDs_H = new ArrayList(1);
		streamIDs_H.add(new Integer(1));

		ArrayList streamNames_H = new ArrayList();
		streamNames_H.add(streamNameH);

		Vector H_ts = new Vector(10);
		H_ts.add(0, new KeyDouble(6));

		Vector H_beatrate = new Vector(10);
		H_beatrate.add(0, new KeyDouble(52));

		Vector H_vib = new Vector(10);
		H_vib.add(0, new KeyDouble(90));

		for (int i = 0; i < 1; i++) {
			Vector tupleVal = new Vector(3);
			tupleVal.add(0, (KeyDouble) H_ts.get(i));
			tupleVal.add(1, (KeyDouble) H_beatrate.get(i));
			tupleVal.add(2, (KeyDouble) H_vib.get(i));

			JugglerTuple t = new JugglerTuple(tupleVal);
			JugglerTupleList tList = new JugglerTupleList(t);
			t.setStreamIDs(streamIDs_H);
			t.setStreamNames(streamNameH);
			tuples_H.add(tList);
			//tuples_H.add(t);
		}
		//****** 4. Enter the tuples in the system

		//****** 5. Create new set of tuples to join
		ArrayList newJoinTuples = new ArrayList();

		// B = ts, pressure, temp

		// T = ts, fluct, degrees, fluct, incr
		Vector tupleValToJoin_T = new Vector(5);
		tupleValToJoin_T.add(0, new KeyDouble(1));
		tupleValToJoin_T.add(1, new KeyDouble(103));
		tupleValToJoin_T.add(2, new KeyDouble(101));
		tupleValToJoin_T.add(3, new KeyDouble(103));
		tupleValToJoin_T.add(4, new KeyDouble(98));

		JugglerTuple newT_T = new JugglerTuple(tupleValToJoin_T);
		newT_T.setStreamNames(streamNameT);
		JugglerTupleList newT_T_List = new JugglerTupleList(newT_T);

		JugglerTupleList newH_T = (JugglerTupleList) tuples_H.get(0);

		try {
			if ((newT_T_List.getTuple().getTimeStamp().getMaxTimeStamp())
				> (newH_T.getTuple().getTimeStamp().getMaxTimeStamp())) {
				newT_T_List.setTimeStamp(newT_T.getTimeStamp());
			} else
				newT_T_List.setTimeStamp(newH_T.getTimeStamp());
		} catch (XATTimeStampException e) {
		}

		//newT_T_List.getTuple().setFirstHalfJoinedTupleMarker(false);
		newT_T_List.appendTupleList(newH_T);
		newT_T_List.setJoinTupleMarkerAfterJoining();

		newJoinTuples.add(newT_T_List);

		//****** 6. Get the resulting tuples

		XATQueue TH_Q = jugglerOp.getNthInputQueue(0);

		TH_Q.enqueue(newJoinTuples, jugglerOp);

		jugglerOp.run();

		/*
		
		ArrayList outputTuplesList = predOrderMan.processTuples(newJoinTuples.iterator());
		Iterator outputTuples = outputTuplesList.iterator();
		*/

		// Iterator outputTuples = predOrderMan.getIntermediateBuffer().iterator();
		String result = "Resulting tuples are: \n";
		/*
		while (outputTuples.hasNext()) {
			JugglerTupleList resultTupleList = (JugglerTupleList) outputTuples.next();
			result += "Queries Satisfied: " + resultTupleList.getFirstTuple().getQuerySatisfied().toString() +" ";
			result += resultTupleList.getStreamNames().toString() + " ";
			JugglerTupleListIterator resultListIt = new JugglerTupleListIterator(resultTupleList);
			while (resultListIt.hasNext()) {
				JugglerTuple atuple = (JugglerTuple) resultListIt.next();
				result += atuple.toString() + " ";
			}
			result +="\n";
			result += resultTupleList.getFirstTuple().getPredicates().toString();
			result += "\n \n \n";
		}
		System.out.println(result);		
		
		System.out.println("DONE");*/
	}
}
