/*
 * Created on 2003-10-22
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.basics;

import java.util.Set;
import java.util.Iterator;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.punctuations.Punct;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.basics.HashBucket;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.algorithms.JoinOperator;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WindowHashState extends HashState {
	public WindowHashState() {
		super();
	}
	
	public WindowHashState(JoinOperator joinOp) {
		super(joinOp);
	}
	
	public void probe(Object value, XATTuple newTuple) {
		long newTimestamp = 0;
		try {
			newTimestamp = newTuple.getTimeStamp().getMinTimeStamp();
			this.setLatestTimestamp(newTimestamp);
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		Object key = joinOp.hash(value);
		Object tBucket = state.get(key);
				
		if (tBucket == null) {
			return;
		}
		
		HashBucket bucket = (HashBucket) tBucket;

		int cursor = 0;
		while (cursor < bucket.sizeOfTupleList()) {
			XATTuple t = (XATTuple) bucket.getTuple(cursor);
			try {
				long timestamp = t.getTimeStamp().getMinTimeStamp();
				if ((timestamp+window) < newTimestamp) {
					bucket.removeTuple(cursor);
				} else {
					break;
				}
			} catch(Exception e) {
				e.printStackTrace();
			}
		}
		
		while (cursor < bucket.sizeOfTupleList()) {	
			XATTuple t = (XATTuple) bucket.getTuple(cursor);
			if (t.getCell(joinPos).getValue().equals(value)) {
				this.joinOp.increNumOutTuples(1);
				//System.out.println("Output: "+value);
				/*
				if (indication == JoinOperatorImp.LEFT) {
					XATTuple xt = joinOp.joinTuples(t, newTuple);
					joinOp.getOutputQueue().enqueue(xt, this);
				} else {
					XATTuple xt = joinOp.joinTuples(newTuple, t);
					joinOp.getOutputQueue().enqueue(xt, this);
				}
				*/
			}
			cursor ++;
		}
		purgeByWindow(key);
	}
	
	public void optimizedWindowProbe(Object value, XATTuple newTuple) {
		long newTimestamp = 0;
		try {
			newTimestamp = newTuple.getTimeStamp().getMinTimeStamp();
			this.setLatestTimestamp(newTimestamp);
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		Object key = joinOp.hash(value);
		Object tBucket = state.get(key);
				
		if (tBucket == null) {
			return;
		}
		
		HashBucket bucket = (HashBucket) tBucket;

		int cursor = 0;
		while (cursor < bucket.sizeOfTupleList()) {
			XATTuple t = (XATTuple) bucket.getTuple(cursor);
			try {
				long timestamp = t.getTimeStamp().getMinTimeStamp();
				if ((timestamp+window) < newTimestamp) {
					//begin: further optimization
					if (t.getIfLastTuple()) {
						//propagate punct
						joinOp.increNumOutPuncts(1);
						Object propValue = t.getCell(joinPos).getValue();
						((Punct)punctSet.get(propValue)).setValid(false);
					}
					//end: further optimization
					bucket.removeTuple(cursor);
				} else {
					break;
				}
			} catch(Exception e) {
				e.printStackTrace();
			}
		}
		
		while (cursor < bucket.sizeOfTupleList()) {	
			XATTuple t = (XATTuple) bucket.getTuple(cursor);
			if (t.getCell(joinPos).getValue().equals(value)) {
				this.joinOp.increNumOutTuples(1);
				//System.out.println("Output: "+value);
				/*
				if (indication == JoinOperatorImp.LEFT) {
					XATTuple xt = joinOp.joinTuples(t, newTuple);
					joinOp.getOutputQueue().enqueue(xt, this);
				} else {
					XATTuple xt = joinOp.joinTuples(newTuple, t);
					joinOp.getOutputQueue().enqueue(xt, this);
				}
				*/
			}
			cursor ++;
		}
		optPurgeByWindow(key);
	}
	
	
	private void optPurgeByWindow(Object skipKey) {
		long latestTime = oppositeState.getLatestTimestamp();
		Set keys = state.keySet();
		Iterator it = keys.iterator();
		while (it.hasNext()) {
			Object nextKey = it.next();
			if (nextKey.equals(skipKey)) {
				continue;
			}
			Object oBucket = state.get(nextKey);
			if (oBucket == null) {
				continue;
			}
			HashBucket bucket = (HashBucket)oBucket;
			
			int tCursor = 0;
			while (tCursor < bucket.sizeOfTupleList()) {
				XATTuple t = bucket.getTuple(tCursor);
				try {
					long timestamp = t.getTimeStamp().getMinTimeStamp();
					if ((timestamp+window) < latestTime) {
						bucket.removeTuple(tCursor);
					} else {
						break;
					}
				} catch(Exception e) {
					e.printStackTrace();
				}
			}
		}
	}

	private void purgeByWindow(Object skipKey) {
		long latestTime = oppositeState.getLatestTimestamp();
		Set keys = state.keySet();
		Iterator it = keys.iterator();
		while (it.hasNext()) {
			Object nextKey = it.next();
			if (nextKey.equals(skipKey)) {
				continue;
			}
			Object oBucket = state.get(nextKey);
			if (oBucket == null) {
				continue;
			}
			HashBucket bucket = (HashBucket)oBucket;
			
			int tCursor = 0;
			while (tCursor < bucket.sizeOfTupleList()) {
				XATTuple t = bucket.getTuple(tCursor);
				try {
					long timestamp = t.getTimeStamp().getMinTimeStamp();
					if ((timestamp+window) < latestTime) {
						//begin: further optimization
						if (t.getIfLastTuple()) {
							//propagate punct
							joinOp.increNumOutPuncts(1);
							Object propValue = t.getCell(joinPos).getValue();
							((Punct)punctSet.get(propValue)).setValid(false);
						}
						//end: further optimization
						bucket.removeTuple(tCursor);
					} else {
						break;
					}
				} catch(Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	public void purgeByPunct(Object punctVal) {
		Object key = joinOp.hash(punctVal);
		Object ro = state.get(key);
		if (ro != null) {
			HashBucket bucket = (HashBucket) ro;

			int tCursor = 0;
			while(tCursor < bucket.sizeOfTupleList()) {
				XATTuple t = bucket.getTuple(tCursor);
				Object joinValue = t.getCell(joinPos).getValue(); 
				if (joinValue.equals(punctVal)) {
					//System.out.println("Purge: "+punctVal);
					bucket.removeTuple(tCursor);
				} else {
					tCursor++;
				}
			}
		}
	}
}
