/*
 * Created on 2003-10-22
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.basics;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.punctuations.Punct;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.pjoin.algorithms.JoinOperator;

/**
 * @author lisading
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WindowNLoopState extends NLoopState {
	public WindowNLoopState() {
		super();
	}
	
	public WindowNLoopState(JoinOperator joinOp) {
		super(joinOp);
	}
	
	public void probe(Object value, XATTuple newTuple) {
		long newTimestamp = 0;
		try {
			newTimestamp = newTuple.getTimeStamp().getMinTimeStamp();
		} catch(Exception e) {
			e.printStackTrace();
		}

		int cursor = 0;
		while (cursor < numTuples) {
			XATTuple t = (XATTuple) tupleList.get(cursor);
			try {
				long timestamp = t.getTimeStamp().getMinTimeStamp();
				if ((timestamp+window) < newTimestamp) {
					removeTuple(cursor);
				} else {
					break;
				}
			} catch(Exception e) {
				e.printStackTrace();
			}
		}
			
		while (cursor < numTuples) {
			XATTuple t = (XATTuple) tupleList.get(cursor);
			if (t.getCell(joinPos).getValue().equals(value)) {
				this.joinOp.increNumOutTuples(1);
				//System.out.println("Output: "+value);
				/*
				if (indication == JoinOperatorImp.LEFT) {
					XATTuple xt = joinOp.joinTuples(t, newTuple);
					joinOp.getOutputQueue().enqueue(xt, this);
				} else {
					XATTuple xt = joinOp.joinTuples(newTuple, t);
					joinOp.getOutputQueue().enqueue(xt, this);
				}
				*/
			}
			cursor ++;
		}
	}
	
	public void optimizedWindowProbe(Object value, XATTuple newTuple) {
		long newTimestamp = 0;
		try {
			newTimestamp = newTuple.getTimeStamp().getMinTimeStamp();
		} catch(Exception e) {
			e.printStackTrace();
		}

		int cursor = 0;
		while (cursor < numTuples) {
			XATTuple t = (XATTuple) tupleList.get(cursor);
			try {
				long timestamp = t.getTimeStamp().getMinTimeStamp();
				if ((timestamp+window) < newTimestamp) {
					//begin: further optimization
					if (t.getIfLastTuple()) {
						//propagate punct
						joinOp.increNumOutPuncts(1);
						Object propValue = t.getCell(joinPos).getValue();
						((Punct)punctSet.get(propValue)).setValid(false);
					}
					//end: further optimization
					removeTuple(cursor);
				} else {
					break;
				}
			} catch(Exception e) {
				e.printStackTrace();
			}
		}
			
		while (cursor < numTuples) {
			XATTuple t = (XATTuple) tupleList.get(cursor);
			if (t.getCell(joinPos).getValue().equals(value)) {
				this.joinOp.increNumOutTuples(1);
				//System.out.println("Output: "+value);
				/*
				if (indication == JoinOperatorImp.LEFT) {
					XATTuple xt = joinOp.joinTuples(t, newTuple);
					joinOp.getOutputQueue().enqueue(xt, this);
				} else {
					XATTuple xt = joinOp.joinTuples(newTuple, t);
					joinOp.getOutputQueue().enqueue(xt, this);
				}
				*/
			}
			cursor ++;
		}
	}

	public void purgeByPunct(Object punctVal) {
		int tCursor = 0;
		while (tCursor < numTuples) {
			XATTuple t = (XATTuple)tupleList.get(tCursor);
			Object joinValue = t.getCell(joinPos).getValue(); 
			if (joinValue.equals(punctVal)) {
				//System.out.println("Purge: "+punctVal);
				removeTuple(tCursor);
			} else {
				tCursor++;
			}
		}
	}
}
