package edu.wpi.cs.dsrg.xmldb.xat.component.sqlgeneration;

import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;
import java.util.Vector;
/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class IncrementalXQuery extends IncrementalQuery {
	/**for clause */
 	protected Vector forV;
	/**let clause */ 	
	protected Vector let;
	/**where clause */
	protected Vector where;
	/**nested return clause */
	protected Vector returnIn;
	/**outer return clause */
	protected Vector returnOut;

	
/**
 * IncrementalXQuery constructor comment.
 */
public IncrementalXQuery() {
	forV = new Vector();
	let = new Vector();
	returnIn = new Vector();
	returnOut = new Vector();
	where = new Vector();
	
}
public void addClause(QueryFragment fragment) {
	
    //create a copy of fragment
    QueryFragment newFrag = (QueryFragment) fragment.clone();
    switch (newFrag.getClauseType()) {
        case QueryTypes.LET:
            {
	            /*
	            * if we are adding a DISTINCT column to the Select clause,
	            * we have to modify the existing SELECT clause whose name matches 
	            * that of the distinct.  Otherwise, you end up with multiple copies of the
	            * same column
	            */
	            /*
	            String name = newFrag.getName();
	            //found a Distinct 
	            if(name.indexOf("DISTINCT") > 0){
					//iterate through the let clauses in the let Vector;
					for (int i = 0; i < let.size(); i++){
						QueryFragment temp = (QueryFragment)let.elementAt(i);
						String fragName = temp.getName();
						//see if the DISTINCT's column name matches the one from this fragment
						if(name.indexOf(fragName) > 0){
							//if it does match
							String newName = "DISTINCT(" + fragName + ")";
							temp.setName(newName);
							break;
						}	
					}
	            }else{
	            */
              	  let.addElement(newFrag);
	            //}
                break;
            }
        case QueryTypes.FOR :
            {
                forV.addElement(newFrag);
                break;
            }
        case QueryTypes.WHERE :
            {
                where.addElement(newFrag);
                break;
            }
        case QueryTypes.OUTER_RETURN :
            {
                returnOut.addElement(newFrag);
                break;
            }
        case QueryTypes.INNER_RETURN :
            {
                returnIn.addElement(newFrag);
                break;
            }

        default :
            { //this happens only with Source operators that wont be converted so SQL, nothing happens though

            }
    }

}
public String getStatement() throws SQLNoStatementExists { 
    //make sure the statement has a forV clause, otherwise it is invalid
    if (forV.size() == 0) {
        throw new SQLNoStatementExists();
    }
    String sqlReturn = new String("");
    QueryFragment s1;
    sqlReturn = "FOR ";
    //there will really only be 1 FOR binding
    for (int i = 0; i < forV.size(); i++) {
        s1 = (QueryFragment) forV.elementAt(i);
        sqlReturn =
            sqlReturn + s1.getBinding() + " IN document(\"" + s1.getName() + "\")";
    }
    sqlReturn = sqlReturn + " LET ";
    for (int i = 0; i < let.size(); i++) {
        s1 = (QueryFragment) let.elementAt(i);
        sqlReturn = sqlReturn + s1.getBinding() + " := " + s1.getName() + ",";
    }

    //trim the last comma
    sqlReturn = sqlReturn.substring(0, (sqlReturn.length() - 1));

    //if there is a where clause, then add it
    //WHERE, ORDERBY, and GROUPBY just have columns names or expressions so there is no binding
    if (where.size() > 0) {
        sqlReturn = sqlReturn + " WHERE ";
        for (int i = 0; i < where.size(); i++) {
            s1 = (QueryFragment) where.elementAt(i);
            sqlReturn = sqlReturn + s1.getName() + " AND ";
        }
        //trim the last AND
        sqlReturn = sqlReturn.substring(0, (sqlReturn.length() - 4));

    }

    if (returnIn.size() > 0) {
        sqlReturn = sqlReturn + " RETURN ";
        for (int i = 0; i < returnIn.size(); i++) {
            s1 = (QueryFragment) returnIn.elementAt(i);
            sqlReturn = sqlReturn + s1.getName() + ",";
        }
        //trim the last comma
        sqlReturn = sqlReturn.substring(0, (sqlReturn.length() - 1));

        /***********  Not Sure how to deal with outer tags*/
        /*	     
        	if (returnOut.size() > 0) {
                sqlReturn = sqlReturn + " RETURN ";
                for (int i = 0; i < returnIn.size(); i++) {
                    s1 = (QueryFragment) returnIn.elementAt(i);
                    sqlReturn = sqlReturn + s1.getName() + ",";
                }
                //trim the last comma
        	    sqlReturn = sqlReturn.substring(0, (sqlReturn.length() - 2));
        
        	    
            }
        */
    }
    return sqlReturn;
}
/**
 * Insert the method's description here.
 * 
 */
public void initialize() {

    forV = new Vector();
    let = new Vector();
    returnIn = new Vector();
    returnOut = new Vector();
    where = new Vector();

}
}
