/*
 * Created on Feb 21, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.statistics;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.XATPhyTreeTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.DemandDrivenInvoking;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.InTimeSJStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.InTimeSJStreamImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NavigationStep;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AffectedPart;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AffectedSj;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RuleBaseRaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.CopiedDag;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.PlanManipulator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.RuntimeOptUtil;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.SimulateMoveResult;


/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PlanMigrator {

	public static void migrateToNew(SimulateMoveResult bestResult) {
		ExtendedAutomata automata = null;
		CopiedDag bestPlan = bestResult.getTempPlan();

		List nodes = XATPhyTreeTraversal.treeBottomUpTraverse(bestPlan);
		int size = nodes.size();
		for (int i = 0; i < size; i++) {
			DagNode node = (DagNode) nodes.get(i);
			XATStreamOperator op = (XATStreamOperator) node.getOperator();
			//op is now associated with nodes in previous plan
			//we need to associate it with the nodes in the best plan
			op.setNode(node);
			for (Iterator it = op.getOutputQueues(); it.hasNext(); )
				((XATQueueImp)it.next()).resetCustomerNum();
			
			op.resetOutputPositions();
			if (op instanceof XATStreamOpRunCore && !(op instanceof PureNavigateAutoStream) && !(op instanceof ExtractStream)){
				((XATStreamOpRunCore)op).getAllInvokingModes().resetChildOps();
				if (!(op instanceof StructuralJoinStream)){
					//op has only one child
					List evalOrder = new ArrayList();
					evalOrder.add(op.getNode().getChild(0).getOperator());
					((DemandDrivenInvoking)op).setBranchEvalOrder(evalOrder);
				}
			}
		}

		AffectedPart affectedPart = bestResult.getAffectedPart();
		List addedSjs = affectedPart.getAddedSjs();
		int addedSjNum = addedSjs.size();
		for (int i = 0; i<addedSjNum; i++){
			InTimeSJStream addedSj = (InTimeSJStream)addedSjs.get(i);
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp)RuntimeOptUtil.getEntryOpToInputSj().get(addedSj);
	        inputSj.addEntry(addedSj);		
	        //associate the states with the sj
	        associateSj(addedSj);
		}
		
		List removedSjs = affectedPart.getRemovedSjs();
		int removedSjNum = removedSjs.size();
		for (int i = 0; i<removedSjNum; i++){
			InTimeSJStream removedSj = (InTimeSJStream)removedSjs.get(i);
            InTimeSJStreamImp inputSj = (InTimeSJStreamImp)RuntimeOptUtil.getEntryOpToInputSj().get(removedSj);
            inputSj.removeEntry(removedSj);	
            cutAssociatedSj(removedSj);
		}
		
		//remove the auto states
		List removedTokenNavs = affectedPart.getRemovedTokenNavs();  
		int removedTokenNavNum = removedTokenNavs.size();
		for (int i = 0; i < removedTokenNavNum; i++) {
			PureNavigateAutoStream removedTokenNav = (PureNavigateAutoStream) removedTokenNavs
					.get(i);
			automata = removedTokenNav.getAutomata();
			removeAutoStates(removedTokenNav);

			//also remove it from the input sj's entry op list
			XATStreamOperator entryOp = PlanManipulator
					.getEntryOpFromTokenNav((DagNode)removedTokenNav.getNode());
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp) RuntimeOptUtil.getEntryOpToInputSj()
					.get(entryOp);
			if (removedSjs.contains(inputSj))
				inputSj = (InTimeSJStreamImp)RuntimeOptUtil.getEntryOpToInputSj().get(inputSj);
			inputSj.removeEntry(entryOp);
			
			//get rid of its statistics
			RuntimeOptUtil.cleanOpSta(removedTokenNav);

		}

		//add the auto states
		List addedTokenNavs = affectedPart.getAddedTokenNavs();
		int addedTokenNavNum = addedTokenNavs.size();
		for (int i = 0; i < addedTokenNavNum; i++) {
			PureNavigateAutoStream addedTokenNav = (PureNavigateAutoStream) addedTokenNavs
					.get(i);
			addAutoStates(addedTokenNav);
			automata = addedTokenNav.getAutomata();

			//			also remove it from the input sj's entry op list
			XATStreamOperator entryOp = PlanManipulator
					.getEntryOpFromTokenNav((DagNode)addedTokenNav.getNode());		
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp) RuntimeOptUtil.getEntryOpToInputSj()
					.get(entryOp);
			if (bestPlan.getNode(inputSj)!=null)
				//RuntimeOptUtil maintains all the past mapping
				//so we have to make sure inputSj does exist in the current plan
				inputSj.addEntry(entryOp);			
			else{
				PureNavigateAutoStream tokenNavChild = (PureNavigateAutoStream)addedTokenNav.getNode().getChild(0).getOperator();
				inputSj = (InTimeSJStreamImp) RuntimeOptUtil.getTokenNavToFanInSj().get(tokenNavChild);
				inputSj.addEntry(entryOp);
			}
			
			//get rid of the statistics of the removed nodeNav
			NavigateStream nodeNav = (NavigateStream)RuntimeOptUtil.tokenNavToNodeNav.get(addedTokenNav);
			RuntimeOptUtil.cleanOpSta(nodeNav);
		}
		
		

		//set up queues
		List affectedSjs = affectedPart.getAffectedSjs();
		int affectedSjSize = affectedSjs.size();
		for (int i = 0; i < affectedSjSize; i++) {
			AffectedSj affectedSj = (AffectedSj) affectedSjs.get(i);
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp) affectedSj.getSj();
			//inputSj.resetOutputPositions();

			ExtractStream entryOp = (ExtractStream) affectedSj.getEntryOp();
			if (affectedSj.isEntryOpAdded()){
				associateExtract(entryOp);
				inputSj.addEntry(entryOp);
			}
			if (affectedSj.isEntryOpRemoved()){
				cutAssociatedExtract(entryOp);
				inputSj.removeEntry(entryOp);
			}
			
			if (affectedSj.isSjRemoved())
				inputSj.addEntry(affectedSj.getEntryOp());			

			//must set up the extra queue
			//set up queue
			List curList = new ArrayList();
			curList.add(entryOp.getNode());
			List newCurList = new ArrayList();
			while (curList.size() > 0) {
				for (Iterator it = curList.iterator(); it.hasNext();) {
					DagNode curNode = (DagNode) it.next();
					XATStreamOperator curOp = (XATStreamOperator) curNode
							.getOperator();

					for (Iterator it2 = curNode.getParents(); it2.hasNext();) {
						DagNode parentNode = (DagNode) it2.next();
						XATStreamOperator parentOp = (XATStreamOperator) parentNode
								.getOperator();
						parentOp.setInputQueue(curOp.getOutputQueue());
						if (!(parentOp instanceof StructuralJoinStream))
							newCurList.add(parentNode);
					}
				}

				curList = newCurList;
				newCurList = new ArrayList();

			}
			entryOp.setUpCellNum();
			entryOp.setStoreMgr(automata.getStoreMgr());
			
			/*if (affectedSj.isEntryOpAdded())		
				sj.addEntry(entryOp);
			else if (affectedSj.isEntryOpRemoved())
				sj.removeEntry(entryOp);*/
		}
		
        //recompute schema
		RuleBaseRaindropLogicalPlanGenerator.maximize(bestPlan);
		RuleBaseRaindropLogicalPlanGenerator.minimize(bestPlan);

	}

	/*
	 * @param entryNode DagNode the entry node @param inputSj DagNode the
	 * structural join the entry node lies on an input subplan remove the old
	 * input subplan from the structural join
	 */
	static void cutOldNodeToInputSj(DagNode entryNode, DagNode inputSj) {

		DagNode curNode = (DagNode) entryNode;
		while (!(curNode.getParent(0) == inputSj)) {
			curNode = (DagNode) curNode.getParent(0);
		}
		inputSj.deleteChild(curNode);

		InTimeSJStreamImp inputSjOp = (InTimeSJStreamImp) inputSj.getOperator();
		inputSjOp.getAllInvokingModes().resetChildOps();
		inputSjOp.resetOutputPositions();
	}

	static void removeAutoStates(PureNavigateAutoStream tokenNav) {
		ExtendedAutomata auto = tokenNav.getAutomata();
		NavigationStep[] steps = tokenNav.getDestination();
		DagNode childNode = (DagNode) tokenNav.getNode().getChild(0);
		PureNavigateAutoStream childTokenNav = (PureNavigateAutoStream) childNode
				.getOperator();

		//the state corresponds to the entry node of the tokenNav
		List startStates = auto.getFrStateHash(childTokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.deleteTransit(steps[0].getStepValue());
		}
	}

	static void addAutoStates(PureNavigateAutoStream tokenNav) {
		ExtendedAutomata auto = tokenNav.getAutomata();
		NavigationStep[] steps = tokenNav.getDestination();

		//the state corresponds to the entry node of the tokenNav
		List encodingStates = (List) auto.getTokenNavMaptoStates()
				.get(tokenNav);

		ExtendedState stateEncodingFirstStep = (ExtendedState) encodingStates
				.get(0);
		stateEncodingFirstStep.getParentState().addTransit(
				steps[0].getStepValue(), stateEncodingFirstStep);

	}

	static void associateExtract(ExtractStream newExtract) {
		DagNode extractNode = (DagNode) newExtract.getNode();

		DagNode childNode = (DagNode) extractNode.getChild(0);
		PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) childNode
				.getOperator();

		ExtendedAutomata auto = tokenNav.getAutomata();
		List startStates = auto.getFrStateHash(tokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.addExtractOp(newExtract);
		}

		//also, if the corresponding faninsj is removed, we
		//also need to add this operator into the groupOp list of the state

	}
	
	static void cutAssociatedExtract(ExtractStream oldExtract){
		DagNode extractNode = (DagNode) oldExtract.getNode();
		DagNode childNode = (DagNode) extractNode.getChild(0);
		PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) childNode
				.getOperator();

		ExtendedAutomata auto = tokenNav.getAutomata();
		List startStates = auto.getFrStateHash(tokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.removeExtractOp(oldExtract);
		}

	}
	
	static void associateSj(InTimeSJStream inputSj){
		PureNavigateAutoStream tokenNav = inputSj.getBranchNavOp();
		
		ExtendedAutomata auto = tokenNav.getAutomata();
		List startStates = auto.getFrStateHash(tokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.addGroupbyOp(inputSj);
		}		
	}
	
	static void cutAssociatedSj(InTimeSJStream inputSj){
		PureNavigateAutoStream tokenNav = inputSj.getBranchNavOp();
		
		ExtendedAutomata auto = tokenNav.getAutomata();
		List startStates = auto.getFrStateHash(tokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.removeGroupbyOp(inputSj);
		}
	}
}