/*
 * Created on Feb 21, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.statistics;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.XATPhyTreeTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.InTimeSJStreamImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NavigationStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AffectedPart;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AffectedSj;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RuleBaseRaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.ChangePrimitive;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.ChangeScript;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.CopiedDag;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.PlanManipulator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.RuntimeOptUtil;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.SimulateMoveResult;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.testfiles.TestSXE;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PlanMigratorBak {

	public static void migrateToNew(SimulateMoveResult bestResult) {
		ExtendedAutomata automata = null;
		CopiedDag bestPlan = bestResult.getTempPlan();

		List nodes = XATPhyTreeTraversal.treeBottomUpTraverse(bestPlan);
		int size = nodes.size();
		for (int i = 0; i < size; i++) {
			DagNode node = (DagNode) nodes.get(i);
			XATStreamOperator op = (XATStreamOperator) node.getOperator();
			//op is now associated with nodes in previous plan
			//we need to associate it with the nodes in the best plan
			op.setNode(node);
		}

		AffectedPart affectedPart = bestResult.getAffectedPart();
		//remove the auto states
		List removedTokenNavs = affectedPart.getRemovedTokenNavs();
		int removedTokenNavNum = removedTokenNavs.size();
		for (int i = 0; i < removedTokenNavNum; i++) {
			PureNavigateAutoStream removedTokenNav = (PureNavigateAutoStream) removedTokenNavs
					.get(i);
			automata = removedTokenNav.getAutomata();
			removeAutoStates(removedTokenNav);

			//also remove it from the input sj's entry op list
			XATStreamOperator entryOp = PlanManipulator
					.getEntryOpFromTokenNav(removedTokenNav);
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp) RuntimeOptUtil.entryOpToInputSj
					.get(entryOp);
			inputSj.removeEntry(entryOp);

		}

		//add the auto states
		List addedTokenNavs = affectedPart.getAddedTokenNavs();
		int addedTokenNavNum = addedTokenNavs.size();
		for (int i = 0; i < addedTokenNavNum; i++) {
			PureNavigateAutoStream addedTokenNav = (PureNavigateAutoStream) addedTokenNavs
					.get(i);
			addAutoStates(addedTokenNav);
			automata = addedTokenNav.getAutomata();

			//			also remove it from the input sj's entry op list
			XATStreamOperator entryOp = PlanManipulator
					.getEntryOpFromTokenNav(addedTokenNav);				
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp) RuntimeOptUtil.entryOpToInputSj
					.get(entryOp);
			if (bestPlan.getNode(inputSj)!=null)
				//RuntimeOptUtil maintains all the past mapping
				//so we have to make sure inputSj does exist in the current plan
				inputSj.addEntry(entryOp);
		}
		

		//set up queues
		List affectedSjs = affectedPart.getAffectedSjs();
		int affectedSjSize = affectedSjs.size();
		for (int i = 0; i < affectedSjSize; i++) {
			AffectedSj affectedSj = (AffectedSj) affectedSjs.get(i);
			InTimeSJStreamImp inputSj = (InTimeSJStreamImp) affectedSj.getSj();
			inputSj.getAllInvokingModes().resetChildOps();
			inputSj.resetOutputPositions();

			ExtractStream entryOp = (ExtractStream) affectedSj.getEntryOp();
			if (affectedSj.isEntryOpAdded())
				associateExtract(entryOp);
			if (affectedSj.isEntryOpRemoved())
				cutAssociatedExtract(entryOp);

			//must set up the extra queue
			//set up queue
			List curList = new ArrayList();
			curList.add(entryOp.getNode());
			List newCurList = new ArrayList();
			while (curList.size() > 0) {
				for (Iterator it = curList.iterator(); it.hasNext();) {
					DagNode curNode = (DagNode) it.next();
					XATStreamOperator curOp = (XATStreamOperator) curNode
							.getOperator();

					for (Iterator it2 = curNode.getParents(); it2.hasNext();) {
						DagNode parentNode = (DagNode) it2.next();
						XATStreamOperator parentOp = (XATStreamOperator) parentNode
								.getOperator();
						parentOp.setInputQueue(curOp.getOutputQueue());
						if (!(parentOp instanceof StructuralJoinStream))
							newCurList.add(parentNode);
					}
				}

				curList = newCurList;
				newCurList = new ArrayList();

			}
			entryOp.setUpCellNum();
			entryOp.setStoreMgr(automata.getStoreMgr());
			InTimeSJStreamImp sj = (InTimeSJStreamImp) affectedSj.getSj();
			if (affectedSj.isEntryOpAdded())		
				sj.addEntry(entryOp);
			else if (affectedSj.isEntryOpRemoved())
				sj.removeEntry(entryOp);
		}
		
        //recompute schema
		RuleBaseRaindropLogicalPlanGenerator.maximize(bestPlan);
		RuleBaseRaindropLogicalPlanGenerator.minimize(bestPlan);

	}

	/*
	 * @param originalPlan XATDag @param changePrimitives List apply the change
	 * primitives to the original plan modify in place
	 */
	public static void migrateBasedOnScript(XATDag originalPlan,
			ChangeScript changeScript) {
		List delPrimitives = changeScript.getDelPrimitives();
		int delNum = delPrimitives.size();

		for (int i = 0; i < delNum; i++) {
			ChangePrimitive changePrimitive = (ChangePrimitive) delPrimitives
					.get(i);

			DagNode entryNode = changePrimitive.getNode();

			DagNode inputSj = (DagNode) ((XATStreamOperator) startingPointToInputSj
					.get(PlanManipulator.getStartingPoint(entryNode)))
					.getNode();
			cutOldNodeToInputSj(entryNode, inputSj);

			DagNode childNode = (DagNode) entryNode.getChild(0);
			childNode.deleteParent(entryNode);

			//remove the automata states for the deleted tokenNav node
			removeAutoStates(entryNode);
		}

		List insertPrimitives = changeScript.getInsertPrimitives();
		int insertNum = insertPrimitives.size();

		for (int i = 0; i < insertNum; i++) {
			//			remember to set up queue
			ChangePrimitive changePrimitive = (ChangePrimitive) insertPrimitives
					.get(i);
			DagNode entryNode = changePrimitive.getNode();

			XATStreamOperator fanInSj = (XATStreamOperator) startingPointToInputSj
					.get(entryNode);
			DagNode fanInSjNode = (DagNode) fanInSj.getNode();

			for (Iterator it = entryNode.getParents(); it.hasNext();) {
				DagNode parent = (DagNode) it.next();
				parent.deleteChild(entryNode);
			}
			entryNode.deleteAllParents();

			DagNode branchHead = changePrimitive.getBranchHeadNode();
			entryNode.addParent(branchHead);

			//			set up queue
			XATStreamOperator entryOp = (XATStreamOperator) entryNode
					.getOperator();
			XATStreamOperator branchHeadOp = (XATStreamOperator) branchHead
					.getOperator();
			branchHeadOp.setInputQueue(entryOp.getOutputQueue());

			XATNode[] children = new XATNode[1];
			children[0] = entryNode;
			branchHead.setChildren(children);

			DagNode branchTail = branchHead;
			DagNode lastNode = null;
			while (!(branchTail.getParent(0).getOperator() instanceof StructuralJoinStream)) {
				lastNode = branchTail;
				branchTail = branchTail.getParent(0);
				//set up queue
				XATStreamOperator lastOp = (XATStreamOperator) lastNode
						.getOperator();
				XATStreamOperator branchTailOp = (XATStreamOperator) branchTail
						.getOperator();
				branchTailOp.setInputQueue(lastOp.getOutputQueue());

			}
			branchTail.getParent(0).deleteChild(branchTail);
			branchTail.deleteParent(branchTail.getParent(0));

			branchTail.deleteAllParents();
			branchTail.addParent(fanInSjNode);
			fanInSjNode.addChild(branchTail);

			//			set up queue
			XATStreamOperator branchTailOp = (XATStreamOperator) branchTail
					.getOperator();
			fanInSj.setInputQueue(branchTailOp.getOutputQueue());

		}

		List replacePrimitives = changeScript.getReplacePrimitives();
		int replaceNum = replacePrimitives.size();

		for (int i = 0; i < replaceNum; i++) {

			ChangePrimitive changePrimitive = (ChangePrimitive) replacePrimitives
					.get(i);
			//must be replace
			DagNode entryNode = changePrimitive.getNode();

			DagNode inputSj = (DagNode) startingPointToInputSj.get(entryNode);
			cutOldNodeToInputSj(entryNode, inputSj);

			DagNode child = (DagNode) entryNode.getChild(0);
			child.deleteParent(entryNode);
			DagNode branchHead = changePrimitive.getBranchHeadNode();
			child.addParent(branchHead);
			branchHead.addChild(child);

			//set up queue
			XATStreamOperator childOp = (XATStreamOperator) child.getOperator();
			XATStreamOperator branchHeadOp = (XATStreamOperator) branchHead
					.getOperator();
			branchHeadOp.setInputQueue(childOp.getOutputQueue());

			DagNode branchTail = branchHead;
			DagNode lastNode = null;
			while (!(branchTail.getParent(0).getOperator() instanceof StructuralJoinStream)) {
				lastNode = branchTail;
				branchTail = branchTail.getParent(0);
				//set up queue
				XATStreamOperator lastOp = (XATStreamOperator) lastNode
						.getOperator();
				XATStreamOperator branchTailOp = (XATStreamOperator) branchTail
						.getOperator();
				branchTailOp.setInputQueue(lastOp.getOutputQueue());

			}

			branchTail.addParent(inputSj);
			inputSj.addChild(branchTail);

			//			set up queue
			XATStreamOperator branchTailOp = (XATStreamOperator) branchTail
					.getOperator();
			XATStreamOperator inputSjOp = (XATStreamOperator) inputSj
					.getOperator();
			inputSjOp.setInputQueue(branchTailOp.getOutputQueue());

			//					must add a new extract operator
			//associate the new extract operator with the state
			associateExtract(branchHead);

		}

		//recompute schema
		TestSXE.treeSchema(originalPlan);
		recomputeQueueSchema(originalPlan);
		System.out.println("migration finished");
		System.out.println(originalPlan);

	}

	/*
	 * @param entryNode DagNode the entry node @param inputSj DagNode the
	 * structural join the entry node lies on an input subplan remove the old
	 * input subplan from the structural join
	 */
	static void cutOldNodeToInputSj(DagNode entryNode, DagNode inputSj) {

		DagNode curNode = (DagNode) entryNode;
		while (!(curNode.getParent(0) == inputSj)) {
			curNode = (DagNode) curNode.getParent(0);
		}
		inputSj.deleteChild(curNode);

		InTimeSJStreamImp inputSjOp = (InTimeSJStreamImp) inputSj.getOperator();
		inputSjOp.getAllInvokingModes().resetChildOps();
		inputSjOp.resetOutputPositions();
	}

	static void removeAutoStates(PureNavigateAutoStream tokenNav) {
		ExtendedAutomata auto = tokenNav.getAutomata();
		NavigationStep[] steps = tokenNav.getDestination();
		DagNode childNode = (DagNode) tokenNav.getNode().getChild(0);
		PureNavigateAutoStream childTokenNav = (PureNavigateAutoStream) childNode
				.getOperator();

		//the state corresponds to the entry node of the tokenNav
		List startStates = auto.getFrStateHash(childTokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.deleteTransit(steps[0].getStepValue());
		}
	}

	static void addAutoStates(PureNavigateAutoStream tokenNav) {
		ExtendedAutomata auto = tokenNav.getAutomata();
		NavigationStep[] steps = tokenNav.getDestination();

		//the state corresponds to the entry node of the tokenNav
		List encodingStates = (List) auto.getTokenNavMaptoStates()
				.get(tokenNav);

		ExtendedState stateEncodingFirstStep = (ExtendedState) encodingStates
				.get(0);
		stateEncodingFirstStep.getParentState().addTransit(
				steps[0].getStepValue(), stateEncodingFirstStep);

	}

	static void associateExtract(ExtractStream newExtract) {
		DagNode extractNode = (DagNode) newExtract.getNode();

		DagNode childNode = (DagNode) extractNode.getChild(0);
		PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) childNode
				.getOperator();

		ExtendedAutomata auto = tokenNav.getAutomata();
		List startStates = auto.getFrStateHash(tokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.addExtractOp(newExtract);
		}

		//also, if the corresponding faninsj is removed, we
		//also need to add this operator into the groupOp list of the state

	}
	
	static void cutAssociatedExtract(ExtractStream oldExtract){
		DagNode extractNode = (DagNode) oldExtract.getNode();

		DagNode childNode = (DagNode) extractNode.getChild(0);
		PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) childNode
				.getOperator();

		ExtendedAutomata auto = tokenNav.getAutomata();
		List startStates = auto.getFrStateHash(tokenNav);

		for (int i = 0; i < startStates.size(); i++) {
			ExtendedState startState = (ExtendedState) startStates.get(i);
			startState.resumeExtractOp();
		}

	}
}