/*
 * Created on Jan 18, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.statistics;

import java.util.ArrayList;
import java.util.HashMap;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.StructuralJoinStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavUnnestStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.XMLScanStream;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedState;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.BranchStatistics;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.ContinuousOpt;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.CostComp;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.NavOpStatistics;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.OpStatistics;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.PlanManipulator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.RuntimeOptUtil;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.SjToBranchStaMapContent;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class StatisticsCollector {
	static boolean firstTimeCollect = true;

	//a set of constants
	//this indicate a certain statistics property does not apply on a certain
	// operator
	public static int NOCARE = -100;

	//the cost of state transition when the stack top is not empty
	//10^{-6}m
	//1.361
	public static double STATE_COMPARE_COST = 1.361;

	//0.779
	//the cost of state transition when the stack top is empty
	public static double STATE_EASYCOMPARE_COST = 0.779;

	//using testnodevisit. 2.763
	public static double NODENAV_VISIT_COST = 1.622;

	//1.631
	//the cost of storing a token
	public static double TOKEN_STORE = 1.631;

	//given a tokenNav, find the sum of the transitions that activate states
	public static Map tokenNavtoActivateCount = new HashMap();

	//given a tokenNav/nodeNav, find the sum of the transitions that start from
	// non-empty stack top/the number of nodes within the entry node
	public static Map navtoStartCountSum = new HashMap();

	//given a tokenNav, find the number of tokens within a destination element
	// located by this TokenNav
	public static Map tokenNavtoTokenCountSum = new HashMap();

	static int desiredBottomDestCount = 0;

	//given an extract, the size of the element it is extracting
	//extractnest_{\$a, p}\$b's ele size gives the overall size of all $b's
	//in a destination
	static Map extractToEleSize = new HashMap();

	//the bottommost tokenNav
	static PureNavigateAutoStream bottommostTokenNav = null;

	public static void setDesiredBottomDestCount(int newDesiredBottomDestCount) {
		desiredBottomDestCount = newDesiredBottomDestCount;
	}

	public static void resumeFirstTimeCollect() {
		firstTimeCollect = true;
	}

	public static void setBottommostTokenNav(
			PureNavigateAutoStream newBottommostTokenNav) {
		bottommostTokenNav = newBottommostTokenNav;

	}

	static public void initializeTokenNavtoStartCount(
			PureNavigateAutoStream tokenNav) {
		navtoStartCountSum.put(tokenNav, new Integer(0));
	}

	static public void initializeTokenNavtoActivateCount(
			PureNavigateAutoStream tokenNav) {
		tokenNavtoActivateCount.put(tokenNav, new Integer(0));
	}

	static public void initializeOpSta(XATStreamOperator op) {
		//sel =1, probNotEmpty =1 is the value for the bottommost TokenNav
		//the real value of other tokenNavs will be set up during the
		// statistics collection
		OpStatistics opSta = new OpStatistics(op, 0, 0, 1, 1);
		RuntimeOptUtil.getOpToStatistics().put(op, opSta);
	}

	/*
	 * @param automata ExtendedAutomata the automta the collector monitors
	 * @param double threshold @return List a list of tokenNav/nodeNav operators
	 * that need to be considered to be pulled out/pushed in statistics have
	 * been collected before now we observe whether statistics collected this
	 * period are different from the statistics collected from last period if
	 * different, update statistics
	 */
	static public List continuousCollect(ExtendedAutomata automata,
			double threshold, int newDesiredBottomDestCount) {

		desiredBottomDestCount = newDesiredBottomDestCount;

		//the list of tokenNav/nodeNav that will be tried to be pulled
		// out/pushed in
		List navsChanged = new ArrayList();

		//checking on tokenNavs
		boolean bottommostTokenNavChanged = findTokenNavsToTry(navsChanged,
				automata, threshold, firstTimeCollect, desiredBottomDestCount);

		firstTimeCollect = false;

		//checking on nodeNavs
		setupStaForOutAutoOps(navsChanged, bottommostTokenNav, threshold);

		if (bottommostTokenNavChanged)
			//remove the bottommost TokenNav
			//this tokenNav should never be considered being moved out
			navsChanged.remove(0);

		return navsChanged;

	}

	public static void getBottomTokenNavTokenNum(ExtendedAutomata automata) {
		PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) ContinuousOpt.tokenNavsInPlan
				.get(0);
		ClassExecTimeKeeper timeKeeper = tokenNav.getTimeKeeper();
		List states = (List) automata.getTokenNavMaptoStates().get(tokenNav);
		int stateNum = states.size();

		//we care only about the last state
		ExtendedState destState = (ExtendedState) states.get(stateNum - 1);
		//bottomDestActivateCount = destState.getActivateCount();

		int tokenCount = timeKeeper.getCurTokenCount();
		int startTokenCount = timeKeeper.getCurStartTokenCount();

		System.out.println(tokenCount + " tokens of bottommost TokenNavs");
		System.out.println(startTokenCount
				+ " start tokens of bottommost TokenNavs");
	}

	/*
	 * @param navsChanged List the tokennavs that will be considered pulling out
	 * @param automata ExtendedAutomata @param threshold double when the change
	 * 0 <threshold <1 surpasses the threshold, pulling out the tokenNav is
	 * considered @return boolean whether the bottommost Tokennav is changed too
	 */
	static boolean findTokenNavsToTry(List navsChanged,
			ExtendedAutomata automata, double threshold, boolean firstTime,
			int desiredBottomDestCount) {
		boolean bottommostTokenNavChanged = false;

		List destStates = new ArrayList();

		//now checking all nav operators
		int tokenNavNum = ContinuousOpt.tokenNavsInPlan.size();

		for (int i = 0; i < tokenNavNum; i++) {

			PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) ContinuousOpt.tokenNavsInPlan
					.get(i);
			NavigateStream nodeNav = null;

			boolean isTokenNav = true;

			int startCountSum = 0;
			double navProbNotEmpty = 0;
			int tokenCountSum = 0;
			ClassExecTimeKeeper keeper = null;
			NavOpStatistics opSta = (NavOpStatistics) RuntimeOptUtil
					.getOpToStatistics().get(tokenNav);

			if (opSta != null) {
				//tokenNav is in current running plan
				keeper = tokenNav.getTimeKeeper();
			} else {
				isTokenNav = false;
				nodeNav = (NavigateStream) RuntimeOptUtil.tokenNavToNodeNav
						.get(tokenNav);
				keeper = nodeNav.getTimeKeeper();
				opSta = (NavOpStatistics) RuntimeOptUtil.getOpToStatistics()
						.get(nodeNav);
			}

			startCountSum = keeper.getDeltaStartTokenCount()
					/ desiredBottomDestCount;
			navProbNotEmpty = keeper.getNotEmptyCount()
					/ (double) desiredBottomDestCount;
			tokenCountSum = keeper.getDeltaTokenCount()
					/ desiredBottomDestCount;

			//whether to update statistics
			boolean updateStatistics = false;

			if (!firstTimeCollect) {
				//not the first time collecting statistics
				int beforeStartCountSum = opSta.getStartCountSum();

				/** *************************************************** */
				//the first factor: whether \sigma(n_{originate}(q)) is
				// increased$
				if (outThreshold(startCountSum, beforeStartCountSum, threshold))
					//we may consider pull this out
					updateStatistics = true;

				/** *************************************************** */
				//the second factor: whether \sigma_{tokenNav \not=> \emptyset}
				// is
				// increased
				//\sigma_{tokenNav \not=> \emptyset} = \sigma_{entryop \not=>
				// \emptyset}
				//actually the probability of the subplan that will be moved
				// out of
				// the automata
				double oldNavNotEmptyProb = opSta.getProbNotEmpty();
				if (outThreshold(navProbNotEmpty, oldNavNotEmptyProb, threshold))
					updateStatistics = true;

				//the third factor: the extra data that has to be stored if the
				// operator is pulled out
				double oldTokenCountSum = opSta.getTokenCountSum();
				if (outThreshold(tokenCountSum, oldTokenCountSum, threshold))
					updateStatistics = true;

			}

			if (firstTimeCollect || updateStatistics) {

				navsChanged.add(tokenNav);

				//update the statistics
				opSta.setProbNotEmpty(navProbNotEmpty);
				opSta.setStartCountSum(startCountSum);
				opSta.setTokenCountSum(tokenCountSum);

				double sel = (double) keeper.getOutputCount()
						/ keeper.getInputCount();
				double unitCost = 0;
				double cost = 0;

				if (isTokenNav) {
					if (tokenNav != bottommostTokenNav) {

						//the cost to find all the navigation steps but the
						// last
						// navigation step
						unitCost = startCountSum
								* (STATE_COMPARE_COST - STATE_EASYCOMPARE_COST);
						//unitcost = cost/number of entry element
						OpStatistics tokenNavOpSta = new OpStatistics(tokenNav,
								unitCost, cost, sel, navProbNotEmpty);
						RuntimeOptUtil.getOpToStatistics().put(tokenNav,
								tokenNavOpSta);

					} else
						//set up the other statistics
						setupStaForOutAutoOps(null, bottommostTokenNav, 0);
				} else {
					//a nodeNav
					unitCost = startCountSum * NODENAV_VISIT_COST;
					OpStatistics nodeNavOpSta = new OpStatistics(nodeNav,
							unitCost, cost, sel, navProbNotEmpty);
					RuntimeOptUtil.getOpToStatistics().put(nodeNav,
							nodeNavOpSta);

				}

			}

			keeper.reset();

		}//end of for (int i = 0; i < tokenNavNum; i++)

		computeChangedBranchSta(navsChanged);

		//reset all dest states's count
		int destStateNum = destStates.size();
		for (int i = 0; i < destStateNum; i++) {
			ExtendedState destState = (ExtendedState) destStates.get(i);
			destState.reset();
		}

		return bottommostTokenNavChanged;

	}

	private static int setupStartCountSumFrTokenNav(
			PureNavigateAutoStream tokenNav) {
		return tokenNav.getTimeKeeper().getDeltaStartTokenCount()
				/ desiredBottomDestCount;

	}

	/*
	 * @param navsChanged List the list of navigate operators whose statistics
	 * change surpasses the threshold @param destNav PureNavigateAutoStream the
	 * bottommost tokenNav set up opToStatistics for automata-outside operators
	 * @param double threshold 0 <threshold <1
	 */
	static void setupStaForOutAutoOps(List navsChanged,
			PureNavigateAutoStream destNav, double threshold) {
		StructuralJoinStream fanInSj = (StructuralJoinStream) RuntimeOptUtil
				.getTokenNavToFanInSj().get(destNav);
		DagNode fanInSjNode = (DagNode) fanInSj.getNode();
		Vector nodes = DagTraversal.dagTopDownTraverse(fanInSjNode);

		int nodeSize = nodes.size();
		for (int i = 0; i < nodeSize; i++) {
			DagNode node = (DagNode) nodes.get(i);
			XATStreamOperator op = (XATStreamOperator) node.getOperator();

			if (!(op instanceof PureNavigateAutoStream)
					&& !(op instanceof ExtractStream)
					&& !(op instanceof XMLScanStream)) {

				ClassExecTimeKeeper keeper = ((XATStreamOpRunCore) op)
						.getTimeKeeper();
				double sel = (double) keeper.getOutputCount()
						/ (double) keeper.getInputCount();
				double notEmptyProb = keeper.getNotEmptyCount()
						/ (double) desiredBottomDestCount;
				double unitCost = (double) keeper.getTime()
						/ (double) keeper.getInputCount();
				double cost = (double) keeper.getTime()
						/ (double) desiredBottomDestCount;

				OpStatistics oldOpSta = (OpStatistics) RuntimeOptUtil
						.getOpToStatistics().get(op);
				if (oldOpSta != null) {
					//this only happens in the continuous scenario
					double oldNotEmptyProb = oldOpSta.getProbNotEmpty();
					double oldUnitCost = oldOpSta.getUnitCost();

					//if unitCost or notEmptyProb decreases
					if (outThreshold(unitCost, oldUnitCost, threshold)
							|| outThreshold(notEmptyProb, oldNotEmptyProb,
									threshold))
						if (op instanceof NavigateStream)
							navsChanged.add(op);
				}

				OpStatistics opSta = new OpStatistics(op, unitCost, cost, sel,
						notEmptyProb);
				RuntimeOptUtil.getOpToStatistics().put(op, opSta);
				//reset timekeeper
				((XATStreamOpRunCore) op).getTimeKeeper().reset();

			} else if (op instanceof ExtractStream) {
				//infer extract's sta from its tokenNavs
				setUpExtractSta((ExtractStream) op);
				//reset timekeeper
				((XATStreamOpRunCore) op).getTimeKeeper().reset();
			}
		}
	}

	/*
	 * compute the statistics for all input subplans in a plan
	 */
	static void computeChangedBranchSta(List changedTokenNavs) {

		int num = changedTokenNavs.size();
		List allSjs = new ArrayList();
		for (int i = 0; i < num; i++) {
			PureNavigateAutoStream tokenNav = (PureNavigateAutoStream) changedTokenNavs
					.get(i);
			XATStreamOperator entryOp = PlanManipulator
					.getEntryOpFromTokenNav((DagNode) tokenNav.getNode());

			ExtractStream extract = findExtractOp(tokenNav);

			if (extract != null)
				computeInputSubplanSta(extract);

			if (entryOp != extract && tokenNav != bottommostTokenNav)
				//entryop must be a structural join
				computeInputSubplanSta(entryOp);

		}

	}

	/*
	 * @param sj XATStreamOperator a structural join operator @param branchSta
	 * statistics of a branch register this branch sta in sjToBranchSta the
	 * input subplans to sj are sorted based on the ranking function
	 */

	static void computeSjToBranchSta(StructuralJoinStream sj,
			BranchStatistics branchSta) {
		double overallSel = CostComp.getOverallSelFromInputSJ(sj);

		SjToBranchStaMapContent sjToBranchStaMapContent = (SjToBranchStaMapContent) RuntimeOptUtil.sjToBranchStatistics
				.get(sj);
		List sortedBranches = null;

		if (sjToBranchStaMapContent == null) {
			//this sj has not registered before
			sortedBranches = new ArrayList();
			sortedBranches.add(branchSta);
			sjToBranchStaMapContent = new SjToBranchStaMapContent(sj,
					sortedBranches);
			RuntimeOptUtil.sjToBranchStatistics
					.put(sj, sjToBranchStaMapContent);
		} else {
			//register already
			//insert branch into the list
			sortedBranches = sjToBranchStaMapContent.getSortedBranchStas();

			double branchRankVal = branchSta.getRankVal();
			boolean inserted = false;

			List evalOrder = sjToBranchStaMapContent.getEvalOrder();
			int count = 0;
			for (Iterator it = sortedBranches.iterator(); it.hasNext();) {
				count++;
				BranchStatistics currentBranchSta = (BranchStatistics) it
						.next();
				if (currentBranchSta.getEntryNode().getOperator() == branchSta
						.getEntryNode().getOperator()) {
					it.remove();
					count--;
					continue;
				}
				double curRankVal = currentBranchSta.getRankVal();

				if (curRankVal > branchRankVal)
					//insert into this position
					//also adjust eval order
					inserted = true;
			}

			if (inserted)
				sortedBranches.add(count, branchSta);
			else
				//add into the last position
				sortedBranches.add(branchSta);
		}

		//compute cost of each branch
		int num = sortedBranches.size();
		double overallProbNotEmpty = 1;
		for (int i = 0; i < num; i++) {
			BranchStatistics sortedBranchSta = (BranchStatistics) sortedBranches
					.get(i);
			//			//compute cost
			if (sortedBranchSta.getUnitCost() == 0)
				sortedBranchSta.setCost(0);
			else
				sortedBranchSta.setCost(overallSel * overallProbNotEmpty
						* sortedBranchSta.getUnitCost());

			overallProbNotEmpty = overallProbNotEmpty
					* sortedBranchSta.getProbNotEmpty();
		}
	}

	/*
	 * @param tokenNavNode DagNode @return ExtractStream if tokenNavNode has any
	 * parent extractOp, return it otherwise return null
	 */
	static ExtractStream findExtractOp(PureNavigateAutoStream tokenNav) {
		DagNode tokenNavNode = (DagNode) tokenNav.getNode();
		int num = tokenNavNode.getParentsSize();

		for (int i = 0; i < num; i++) {
			DagNode parentNode = tokenNavNode.getParent(i);
			XATStreamOperator parentOp = (XATStreamOperator) parentNode
					.getOperator();
			if (parentOp instanceof ExtractStream)
				return (ExtractStream) parentOp;

		}

		return null;
	}

	/*
	 * @param startingPoint DagNode an entry operator of an input subplan
	 * compute the statistics about this input subplan @param changedSjs List
	 * the sjs that have initial entries
	 */
	static void computeInputSubplanSta(XATStreamOperator entryOp) {

		/*
		 * DagNode entryNode = (DagNode) entryOp.getNode(); DagNode parentNode =
		 * (DagNode) entryNode.getParent(0); XATStreamOperator parentOp =
		 * (XATStreamOperator) parentNode .getOperator();
		 * 
		 * BranchStatistics branchSta = null;
		 * 
		 * if (parentOp instanceof StructuralJoinStream) { //the branch is an
		 * empty one //just create a place holder for it //entry and ending
		 * point are the same List endingNodes = new ArrayList();
		 * endingNodes.add(entryNode); branchSta = new
		 * BranchStatistics(entryNode, endingNodes, 1, 0, 1);
		 * RuntimeOptUtil.getBranchToStatistics().put(entryOp, branchSta); }
		 * else { OpStatistics entrySta = (OpStatistics)
		 * RuntimeOptUtil.getOpToStatistics() .get(entryNode.getOperator());
		 * double entrySel = entrySta.getSel();
		 * 
		 * double sel = 1; double unitCost = 0; double probNotEmpty = 1; DagNode
		 * lastNode = null; while (!(parentOp instanceof StructuralJoinStream)) {
		 * //the branch is not empty OpStatistics parentOpSta = (OpStatistics)
		 * RuntimeOptUtil.getOpToStatistics() .get(parentOp); unitCost =
		 * unitCost + sel * parentOpSta.getUnitCost(); sel = sel *
		 * parentOpSta.getSel(); probNotEmpty = probNotEmpty *
		 * parentOpSta.getProbNotEmpty();
		 * 
		 * lastNode = parentNode; parentNode = (DagNode)
		 * parentNode.getParent(0); parentOp = (XATStreamOperator)
		 * parentNode.getOperator(); }
		 * 
		 * double branchProbNotEmpty = 1 - Math .pow(1 - probNotEmpty,
		 * entrySel);
		 * 
		 * branchSta = new BranchStatistics(entryNode, lastNode, sel, unitCost,
		 * branchProbNotEmpty);
		 * RuntimeOptUtil.getBranchToStatistics().put(entryOp, branchSta); }
		 */
		BranchStatistics branchSta = CostComp
				.computeBranchStatistics((DagNode) entryOp.getNode());
		RuntimeOptUtil.getBranchToStatistics().put(entryOp, branchSta);

		//now parentOp is a structuralJoinStream
		computeSjToBranchSta((StructuralJoinStream) RuntimeOptUtil
				.getEntryOpToInputSj().get(entryOp), branchSta);
	}

	/*
	 * @param extract ExtractStream set up statistics for this extract from its
	 * token
	 */
	public static void setUpExtractSta(ExtractStream extract) {
		PureNavigateAutoStream childTokenNav = (PureNavigateAutoStream) extract
				.getNode().getChild(0).getOperator();
		OpStatistics opSta = (OpStatistics) RuntimeOptUtil.getOpToStatistics()
				.get(childTokenNav);
		double sel = opSta.getSel();
		//the cost of extracting the data is in proportion to the size of the
		// element

		double cost = ((Integer) tokenNavtoTokenCountSum.get(childTokenNav))
				.intValue()
				* TOKEN_STORE;
		double probNotEmpty = opSta.getProbNotEmpty();
		OpStatistics newOpSta = new OpStatistics(extract, NOCARE, cost, sel,
				probNotEmpty);
		RuntimeOptUtil.getOpToStatistics().put(extract, newOpSta);

	}

	public static OpStatistics getOpSta(XATStreamOperator op) {
		OpStatistics opSta = (OpStatistics) RuntimeOptUtil.getOpToStatistics()
				.get(op);
		OpStatistics tempOpSta;
		if (opSta != null)
			return opSta;

		if (!(op instanceof PureNavigateAutoStream)) {
			//op does not exist before
			//op must be a node navigate operator
			XATStreamOperator mappedFrTokenNav = (XATStreamOperator) RuntimeOptUtil.nodeNavToTokenNav
					.get(op);
			tempOpSta = (OpStatistics) RuntimeOptUtil.getOpToStatistics().get(
					mappedFrTokenNav);
			//opSta = new OpStatistics(op);
			double probNotEmpty = tempOpSta.getProbNotEmpty();
			double sel = 0;
			if (op instanceof NavUnnestStream)
				sel = tempOpSta.getSel();
			else
				//op is navcollection
				sel = tempOpSta.getProbNotEmpty();
			//the cost of finding all navigation steps but the last navigation
			// step
			double unitCost = tempOpSta.getUnitCost()
					* StatisticsCollector.NODENAV_VISIT_COST
					/ (StatisticsCollector.STATE_COMPARE_COST - StatisticsCollector.STATE_EASYCOMPARE_COST);
			//plus the cost of finding the last navigation step
			unitCost = unitCost
					+ StatisticsCollector.NODENAV_VISIT_COST
					* ((Integer) StatisticsCollector.tokenNavtoActivateCount
							.get(mappedFrTokenNav)).intValue();
			opSta = new OpStatistics(op, unitCost, StatisticsCollector.NOCARE,
					sel, probNotEmpty);
			RuntimeOptUtil.getOpToStatistics().put(op, opSta);
		} else {
			//estimate the cost of a tokenNav from nodeNav
			XATStreamOperator mappedFrNodeNav = (XATStreamOperator) RuntimeOptUtil.tokenNavToNodeNav
					.get(op);
			ClassExecTimeKeeper keeper = ((XATStreamOpRunCore) mappedFrNodeNav)
					.getTimeKeeper();
			tempOpSta = (OpStatistics) RuntimeOptUtil.getOpToStatistics().get(
					mappedFrNodeNav);
			//opSta = new OpStatistics(op);
			double probNotEmpty = tempOpSta.getProbNotEmpty();
			double sel = 0;
			if (mappedFrNodeNav instanceof NavUnnestStream)
				sel = tempOpSta.getSel();
			else
				//op is navcollection
				sel = keeper.getItemCountWithinEntrySum()
						/ keeper.getInputCount();

			//the cost of finding all navigation steps but the last navigation
			// step
			double unitCost = tempOpSta.getUnitCost()
					* (StatisticsCollector.STATE_COMPARE_COST - StatisticsCollector.STATE_EASYCOMPARE_COST)
					/ StatisticsCollector.NODENAV_VISIT_COST;
			//plus the cost of finding the last navigation step
			unitCost = unitCost
					+ (StatisticsCollector.STATE_COMPARE_COST - StatisticsCollector.STATE_EASYCOMPARE_COST)
					* keeper.getInputCount() / desiredBottomDestCount;
			opSta = new OpStatistics(op, unitCost, StatisticsCollector.NOCARE,
					sel, probNotEmpty);
			RuntimeOptUtil.getOpToStatistics().put(op, opSta);

		}
		//add an entry for this op in opToStatistics

		return opSta;
	}

	/*
	 * @param curVal double current value @param oldval double old value @param
	 * threshold, must be a positive @return boolean whether the difference
	 * between curVal and oldVar falls within the threshold
	 */
	private static boolean outThreshold(double curVal, double oldVal,
			double threshold) {
		if (curVal > oldVal && curVal > (1 + threshold) * oldVal)
			return true;

		if (curVal < oldVal && curVal < (1 - threshold) * oldVal)
			return true;

		return false;

	}

}