package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators;
import java.io.Serializable;

/**
 * @author 
 * This class encapsulates the stream name and the 
 * tuple the stream name is used as the identifier
 */
public class Packet implements Serializable{
	/**Stores the reference to the stream name*/	
	private String identifier = null;
	/**Stores the reference to the tuple*/
	private Object o = null;
	/**Stores the reference to the control message*/
	private String controlMessage = null;
	
	/**
	 * Constructs a new Packet
	 */
	public Packet(String identifier,Object o)
	{		
		if(identifier == null || o == null)
		 	throw new IllegalArgumentException();
		this.identifier = identifier;
		this.o = o;
	}
	
	public Packet(String name,String message)
	{
		this.identifier = name;
		this.controlMessage = message;
	}
	
	public Packet(String identifier,Object o,String message)
	{
		if( identifier == null || o == null || message == null)
			throw new IllegalArgumentException();
			
			this.identifier = identifier;
			this.o = o;
			this.controlMessage = message;
	}
	
	public Packet(String controlMessage)
	{
		if(controlMessage == null)
		 throw new IllegalArgumentException();
		 
		this.controlMessage = controlMessage;
	}
	
	public String getIdentifier()
	{
		return(this.identifier);
	}

	/**
	 * @return
	 */
	public Object getObject()
	{
		return(o);
	}
	/**
	 * @return
	 */
	public String getControlMessage() {
		return controlMessage;
	}

}
