package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObjectImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.LightWeightQueryObject;

/**
 * @author Administrator
 * This class mainly keeps the queue and the stream together
 * There is an instance of this class for each stream element
 * in the configuration file
 */
public class Stream extends XATQueryObjectImp{
	/**Stores the reference to the stream name*/
	private String streamName = null;
	/**Stores the reference to the XATQueue that belongs to this stream*/
	private XATQueue xatQueue = null;
	/**
	 * Constructs a new stream
	 * @param streamName
	 */
	public Stream(String streamName)
	{
		this.streamName = streamName;
		this.xatQueue = new XATQueueImp(this);
	}
	
	/**
	 * This method adds the tuple to the XATQueue
	 * @param t
	 */
	public void addTuple(XATTuple t)
	{
		this.xatQueue.enqueue(t,this);
	}

	/**
	 * @return
	 */
	public XATQueue getStreamQueue() {		
		return this.xatQueue;
	}
	
	/**
	 * Sets the schema of the queue with the given schema
	 * @param schema
	 */
	public void setXATQueueSchema(XATQueueSchema schema)
	{
		this.xatQueue.setSchema(schema);
	}
	
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject#getLightWeightQueryObject()
	 */
	public LightWeightQueryObject getLightWeightQueryObject() {
		return new LightWeightQueryObject("Stream",this.getClass().getName(),true);
	}

}
