package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.io.FileNotFoundException;

/**
 * @author 
 * This class is used to make the tuple readers
 */
public class Factory {

private static Factory factory = null;
	/**
	* Constructs a new factory 
	*/
	private Factory()
	{}
 	
 	public static Factory getInstance()
 	{
 		if(factory == null)
 		 return(new Factory());
 		else
 			return(factory);
 	}
 	
 
	
	/**
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 * @param rg
	 */
	public StreamTupleReader makeStreamTupleReader(String identifier,String[] inputFileNames,String attrDelimeter, char recDelimeter, Schema schema, RandomGenerator rg) throws FileNotFoundException {
		StreamTupleReader str = new StreamTupleReaderDistImp(identifier,inputFileNames,attrDelimeter,recDelimeter,schema,rg);
		return(str);		
	}

	/**
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 * @param columnName
	 */
	public StreamTupleReader makeStreamTupleReader(String identifier,String[] inputFileNames,String attrDelimeter, char recDelimeter, Schema schema, String columnName,String format) throws FileNotFoundException {
		StreamTupleReader str = new StreamTupleReaderColumnImp(identifier,inputFileNames,attrDelimeter,recDelimeter,schema,columnName,format);
		return(str);		
	}
 
}
