package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.util.EmptyStackException;

import edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.exceptions.NoItemsInListException;

/**
 * @author Luping Ding
 * A class that implements a linear link list. The list maintains
 * the objects within it in the ascending order of the key values
 * The main used methods will be the removeFirst and the insert methods
 * optimization could be that when insering nodes into the list.
 * We search for a position from the back of the list
 * That might take fewer number of comparisons
 */
public class Linearlist {
	/**Stores the referebce to the head of the list*/
	private Node head = null;
		
	/**
	 * Constructs a new Linear List
	 */
	public Linearlist() {		
		head = null;						
	}
	
	/**
	 * Inserts the node into the link list
	 * At the propert order
	 * @param key
	 * @param o
	 */
	public void insertIntoList(long key,Object o)
	{
		Node prev = head;
		Node current = head;
		
		//Insert into the first position of the List
		
		if( head == null)
		{
			Node temp = new Node(key,o,head);			
			head = temp;
		}
		else if(key < head.getKey())
			{		
				Node temp = new Node(key,o,head);							
				head = temp;			
			}		
		else
		{			
		//Insert the node in the middlef of the list
		while(current != null)
		{
			if(key >= current.getKey())
			{
			prev = current;
			current = current.getNext();
			}
			else
				break;
		}
			Node temp = new Node(key,o,current);
			prev.setNext(temp);
		}
	}
		
	
	/**
	 * Removes the object given as the parameter from the list
	 * @param o
	 * @return
	 */
	
	public Object removeNode(Object o)
	{
		Node prev = head;
		Node current = head;
		Node temp = null;
		
		if(o == head.getO())
		{
			temp = head;
			head = head.getNext();				
		}
		else
		{
		
			while(current != null )
				{
					if(o != current.getO())
					{
					prev = current;
					current = current.getNext();					
					}
					else
						break;
				}
				if(current == null)
				{
					throw new IllegalArgumentException("No such value in list");		
				}
				
				temp = current;
				
				prev.setNext(current.getNext());
		}			
		
			return(temp.getO());
	}
	
	/**
	 * Removes the first node from the list and returns that node
	 * @return
	 */
	public Object removeFirst() throws NoItemsInListException
	{		
		if(head == null)
		{
			throw new EmptyStackException();
		}			
		Node temp = null;					
		temp = head;
		head = head.getNext();										
		return(temp.getO());		
	}
	
	/**
	 * If the list is empty this returns true or else returns false
	 * @return
	 */
	public boolean isEmpty()
	{
		if (head == null)
			return true;
		else
			return false;
	}


	public long getFirstKey()
	{
		return(head.getKey());
	}
/**
 * @see java.lang.Object#toString()
 */
public String toString()
{
	Node temp = head;
	String newString = "";
	while(temp != null)
	{
		newString += temp.getKey()+" ";
	 	temp = temp.getNext();	 	
	}
	return(newString);
 }

/**
 * @return
 */
public Object getFirst() {
	return (head.getO());
 }
}

class Node
{
	/**Stores the reference to the next node*/
	private Node next = null;
	/**Since it is a linear list need to store the key value on which 
	 * it is sorted*/
	private long key = 0;
	/**Stores the data item in the list*/
	private Object o = null;
	
	
	/**
	 * Constructs a new Node
	 * @param o
	 * @param next
	 */
	public Node(long key,Object o,Node next)
	{
		this.key = key;
		if(o == null)		
			throw(new IllegalArgumentException());		
		else
		{		
		this.o = o;
		this.next = next;
		}
	}
	
	/**
	 * Constructs a new Node
	 * @param key
	 * @param o
	 */
	public Node(long key,Object o)
	{
		this.key = key;
		if(o == null)
			throw(new IllegalArgumentException());
		else
		{		
		this.o = o;		
		}
	}
	
	/**
	 * @return
	 */
	public long getKey() {
		return key;
	}

	/**
	 * @return
	 */
	public Node getNext() {
		return next;
	}

	/**
	 * @return
	 */
	public Object getO() {
		return o;
	}

	/**
	 * @param node
	 */
	public void setNext(Node node) {
		next = node;
	}

}