package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.io.IOException;


import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * Defines an interface to be published by any sort of the tuple reader
 * The tuple reader reads the tuple from the stream sets its time stamp 
 * and then sends the tuple to the stream when asked for.
 * @author Luping Ding
 */
public interface StreamTupleReader {
	
	/**
	 * Reads the next stream Tuple from the file and returns
	 * the value. Note this tuple could either be a strExpression tuple
	 * data tuple
	 * @return XATStreamTuple
	 * @throws IOException
	 */
	public XATTuple getNextTuple(long currentTimeStamp) throws IOException,RecordParseException;

	/**
	 * Returns the XATQueue schema for the tuples that the tuple reader reads
	 */
	public XATQueueSchema getXATSchema();
	
	
	
}
