package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;

import java.io.FileNotFoundException;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;

/**
 * @author 
 *
 * This class sets the time stamp once it reads the values from the file
 * One main issue to be resolved here is the mapping of the column value to the
 * time stamp 
 */
public class StreamTupleReaderColumnImp
	extends StreamTupleReaderTextImp
	implements StreamTupleReader {
	/**Stores the name of the column that is to be used as the time stamp*/
	private String columnName;
	/**Stores the format of the column which is to be used as time stamp*/
	private String format;
	/**Used to parse the date to convert into a real time stamp*/
	SimpleDateFormat formatter = null;
	/**Stores the timestamp to referece timeStamp all the other time stamps are set with reference to this time stamp*/
	Date refDate= null;
	
	/**
	 * @param inputFileName
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 */
	public StreamTupleReaderColumnImp(
		String identifier,
		String[] inputFileNames,
		String attrDelimeter,
		char recDelimeter,
		Schema schema,
		String columnName,
		String format) throws FileNotFoundException {
		super(identifier,inputFileNames, attrDelimeter, recDelimeter, schema);
		this.columnName = columnName;
		this.format = format;	
		System.out.println("Date Format: "+format);
		formatter = new SimpleDateFormat(this.format);												  
	}

	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server.StreamTupleReaderTextImp#setTimeStamp(long, edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 * Still have to implement this method the main function
	 * reading the value of the cloumn using the schema 
	 * and then mapping this value into a time stamp and then 
	 * writing this new value
	 */
	public void setTimeStamp(long currentTimeStamp, XATTuple tuple) throws RecordParseException 
	{
		int position = schema.getPosition(columnName);
		XATDataValue value = tuple.getCell(position);
		String date = value.convertToString();
		Date newDate;
		
		
			try {
				//System.out.println("Date: "+date);
				newDate = formatter.parse(date);
			} catch (ParseException e) {
				throw(new RecordParseException(e));			
			}		
		if(this.refDate == null)
			refDate = newDate;
				
		long timeStamp = newDate.getTime()-this.refDate.getTime();
		try {
			XATTimeStamp xast = new XATTimeStampImp();
			xast.setTimeStamp(timeStamp, tuple);
			tuple.setTimeStamp(xast);
		} catch (XATTimeStampException e) {
			e.printStackTrace();
		}
		
	}

	
}
