package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;


import java.io.FileNotFoundException;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;

/**
 * @author Administrator
 * This class sets the time stamps of the XATTuples using the
 * distribution generator. 
 */
public class StreamTupleReaderDistImp
	extends StreamTupleReaderTextImp
	implements StreamTupleReader {

	private RandomGenerator rg = null;
	
	/**
	 * @param inputFileName
	 * @param attrDelimeter
	 * @param recDelimeter
	 * @param schema
	 * @param rg
	 */
	public StreamTupleReaderDistImp(
		String identifier,
		String[] inputFileNames,
		String attrDelimeter,
		char recDelimeter,
		Schema schema,
		RandomGenerator rg) throws FileNotFoundException {
		super(identifier,inputFileNames, attrDelimeter, recDelimeter, schema);
		this.rg = rg;		
	}

	
	/**
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server.StreamTupleReaderTextImp#setTimeStamp(edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple)
	 */
	public void setTimeStamp(long currentTimeStamp,XATTuple tuple) {
			double d = rg.generateRandom(currentTimeStamp);
			long timeStamp = (long) (d + currentTimeStamp);			
			XATTimeStamp xast = new XATTimeStampImp();			
			try {
				//This method sets the time stamps and uses the current tuple
				//to set the start and the end time stamps
				xast.setTimeStamp(timeStamp,tuple);
				
				tuple.setTimeStamp(xast);
								
			} catch (XATTimeStampException e) {				
				e.printStackTrace();
			}	

	}


	

	
}
