package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
import java.io.IOException;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;


/**
 * Defines an interface
 * @author: Yali Zhu
 */
public interface XATStream {

/**
 * This method should make a new Tuple set the time stamp and
 * the return the new XATTuple to the stream controller
 * @param position int
 * @param value int
 */
XATTuple makeNewTuple(long newGlobalTimer) throws IOException,RecordParseException;

/**
 * @param flag
 * @return
 */
boolean setDebug(boolean flag);

/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
String toString();

/**
 * Called when the stream is to be removed from the system
 * Closes all open files and performs all other necessary cleanup
 * operations 
 */
public void cleanup();

/**
 * Returns true if the stream has ended
 * @return
 */
public boolean isOver();

/**
 * This method is used to start the stream
 */
public void startStream();


/**
 * @return
 */
public String getStreamName();

public int getStreamNumber();
/**
 * This returns the queue schema for the stream
 * @return
 */
public XATQueueSchema getXATSchema();


}
