/*
 * Created on 2004-7-30
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.common.dag;

import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.exception.*;

/**
 * @author lingw
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DagReWriteTraversal extends ReWriteTraversal {

	/**
	 * @param tree
	 * @param rule
	 * @param order
	 */
	public DagReWriteTraversal(XATTree tree, ReWriteRules rule, Vector order) {
		super(tree, rule, order);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param tree
	 * @param rule
	 * @param order
	 * @param step
	 */
	public DagReWriteTraversal(
		XATTree tree,
		ReWriteRules rule,
		Vector order,
		boolean step) {
		super(tree, rule, order, step);
		// TODO Auto-generated constructor stub
	}

	protected void visitMatchNode(XATNode currentNode, XATTree curTree) {
		if (isOperatorPushedDown(currentNode.getOperator())) {
			return;
		}
		XATNode parent = currentNode;
		XATNode[] children = null;
		XATNode child = null;
		ReWriteResult result = new ReWriteResult();
		//if we want to pushUp, then we evaluate the currentNode with its parent
		//if we want to pushDown, then we evaluate the currentNode with its child
		//if parent has multiple parents or children, not rewritable
		/*if (parent.getChildrenSize() != 1) {
			System.out.println(
				"Error: Non-linear tree is not rewritable for now.");
			return;
		}*/

		//Ling Wang: We now start allow multiSourceOperator Rewrite. e.g., NatureJoin
		if (((DagNode) parent).getParentsSize() != 1)
			return;

		//otherwise, take the only child and rewrite
		children = parent.getChildren();
		for (int i = 0; i < children.length; i++) {
			child = (XATNode) children[i];
			try{
				result = (ReWriteResult) reWriteRule.evaluateRules(parent, child);
			}catch (ReWriteRulesNoRulesFound e){
				continue;
			}

			//This should not happen, unlesss all child agrees with swapping
			if (result.isSwapped()) {
				//currentNode = new XATNodeImp();
				setIsChanged(true);
				//then update the childset
				//getChildren(childSet, currentNode);
			}

			if (result.isFinalPosition()) {
				setOperatorPushedDown(parent.getOperator(), true);
			}

			//if the node parent should be deleted, then do so
			if (result.isDeleteParentNode()) {
				setIsChanged(true);
				//delete parent node
				deleteParentNode(curTree, parent, child);
				if (isDebug()) {
					System.out.println("Deleted " + parent.toString());
				}
			} //if the child node should be deleted, then do so
			if (result.isDeleteChildNode()) {
				setIsChanged(true);
				curTree.deleteNode(child);
				if (isDebug()) {
					System.out.println("Deleted " + child);
				}
			} //if the currentNode was moved, then dont change it
			if (result.isMoved()) {
			} //if the currentNode was moved, then dont change it
			if (result.isReplaced()) {
				setIsChanged(true);
			} //update currentNode
			currentNode = parent;
		}

	}

	private void deleteParentNode(
		XATTree curtree,
		XATNode parent,
		XATNode child) {
		
		//first disconnect child with parent
		((DagNode) child).deleteParent((DagNode) parent);

		//int deleteChildIndex = parent.getIndexOf(child);
		XATNode[] children = parent.getChildren();

		//find the left child	
		XATNode nonDelChild = null;
		boolean first = true; //flag for first non deleted child
		for (int i = 0; i < children.length; i++) {
			//if (i != deleteChildIndex){
				nonDelChild = children[i];
				((DagNode) nonDelChild).deleteParent(parent);

				//now deleting the Nature Join Node
				//add all its children as new child for its parent
				Iterator itparent = parent.getParents();
				while (itparent.hasNext()) {
					DagNode curParent = (DagNode) itparent.next();
					((DagNode) nonDelChild).addParent(curParent);
					if (first){
						int curIndex = ((DagNode) curParent).getIndexOfChild((DagNode) parent);
						curParent.setChild(curIndex,nonDelChild);
					}
					else{
						curParent.addChild(nonDelChild);
					}
				}
				first = false;
			//}
		}
		((DagNode)parent).deleteAllParents();
		for (int i =0; i<children.length; i++){
			parent.deleteChild(children[i]);
		}
	}
}