package edu.wpi.cs.dsrg.xmldb.xat.recursion;

/**
 * ExtractStream must be inside automata, it can only be invoked by PureNavigateAuto
 * 
 
 * Creation date: (1/15/2003 7:51:19 PM)
 * @author: Hong Su
 */

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.*;

//do not add XATSingleQRunCore since its imp is extended from operator that implemetns XATSingleQRunCore
public interface ExtractStream extends AutomataEnabled, DataDrivenInvoking, SelfPartitionDelimiInvoking, XATStreamOpRunCore  {
	public static final int COMPLETE_TREE = 0;
	
	public static final int DOM = 1;
	public static final int TYPED_VALUE = 2;
	//this is for counting occurrence
	public static final int NODE_ID = 3;	
	public static final int ATTRS = 4;
	public static final int EXISTENTIAL = 5;
	public static final int KEEP_PARENT = 6;  
	

	
	
	
	/**
	 * Insert the method's description here.
	 * Creation date: (1/16/2003 11:53:40 AM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata
	 */
	ExtendedAutomata getAutomata();
	
    

	
	/**
	 * Insert the method's description here.
	 * Creation date: (4/19/2003 10:56:53 PM)
	 */
	ExtendedState getOpState();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/20/2003 9:31:24 PM)
	 * @return int
	 * @param storingMethod int
	 */
	//int getPosInTupleForStoringMethod(int storingMethod);
	/**
	 * Insert the method's description here.
	 * Creation date: (1/30/2003 10:36:24 AM)
	 * @return edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.StreamStoreMgr
	 */
	Finer_StreamStoreMgr getStoreMgr();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/15/2003 8:24:53 PM)
	 * @return int
	 */
	int[] getStoringMethods();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/16/2003 11:09:15 PM)
	 */

	/**
	 * Insert the method's description here.
	 * Creation date: (2/19/2003 10:07:41 AM)
	 * @return int
	 */
	int getTupleColNum();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:41:06 PM)
	 * @return boolean
	 */
	boolean isAttrs();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:41:40 PM)
	 * @return boolean
	 */
	boolean isCompleteTree();
	/**
	 * Insert the method's description here.
	 * Creation date: (2/15/2003 9:18:02 PM)
	 * @return boolean
	 */
	boolean isDom();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:41:06 PM)
	 * @return boolean
	 */
	boolean isNodeId();
	/**
	 * Insert the method's description here.
	 * Creation date: (1/18/2003 4:41:22 PM)
	 * @return boolean
	 */
	boolean isTypedValue();

	
	/**
	 * Insert the method's description here.
	 * Creation date: (4/19/2003 10:56:53 PM)
	 */
	void setOpState(ExtendedState opState);
	/**
	 * Insert the method's description here.
	 * Creation date: (1/30/2003 10:35:24 AM)
	 * @param newStorage edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.StreamStoreMgr
	 */
	void setStoreMgr(Finer_StreamStoreMgr newStoreMgr);
	/**
	 * Insert the method's description here.
	 * Creation date: (1/31/2003 11:40:51 AM)
	 * @param storingMethod int
	 */
	void setStoringMethod(int storingMethod);
	
	int getItemCountWithinEntry();

	void setUpCellNum(); 
	public void runPushStackWithRecur(int tokenId, int startTokenId);
	public void runPopStackWithRecur(int tokenId, int startTokenId);
  
}
