/*
 * Created on Dec 6, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.recursion;
import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.*;

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal;

/**
 * @author samanwei
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PhysicalPlanGenForRecur extends InheritableVisitor {
		/*
		 * for a 
		 *              NaturalJoin
		 *                /       \
		 *     NavUnnest($a/b->$b) NavUnnest($a/c->$c)
		 *                \        /
		 *              NavUnnest($o/a->$a)
		 * 
		 * linearize it to
		 *                   
		 *              NavUnnest($a/c->$c)   
		 *                   |
		 *              NavUnnest($a/b->$b)
		 *                   |
		 *               NavUnnest
		 * and then turn it into
		 *               NavUnnest($c, $b ->null)
		 *                   |
		 *               NavNest($a/c->$c)
		 *                   |
		 *               NavNest($a/b->$b)
		 *                   |
		 *               NavUnnest
		 */

		//operator ==>stateId
		private Hashtable stateHash = new Hashtable();

		//operator ==>PU, the pu has the output queue
		private Hashtable outputHash = new Hashtable();

		//the output queue for the mega operator
		private XATQueue megaQueue = null;

		//the schema of the mega operator
		private Set schema = null;

		//the automata that contains the mega operator
		//one automaton may contain many mega operators

		//public int mappingStrategy = -1;
		//given a queue, find which of its columns are set to be subcolumns
		//if return null, means this queue is not a subtuple queue	
		protected Hashtable subTupleQHash;
		protected boolean subtuple_quick_response = false;
		protected boolean subtuple_shortcircuit = true;
		protected XATDag inDag;
		//give a navigate node, find which ancestor operator needs its group by info	
		private java.util.Hashtable toResolveNavHash = new Hashtable();
		//given a select, set the iColumnPosition and iQueuePosition of its selection predicate
		private ArrayList toResolveSelect = new ArrayList();
		private ArrayList toResolveMultiOp = new ArrayList();

		private List removedExtracts = new ArrayList();
		/**
		 * AutoConstuctor constructor comment.
		 */
		public PhysicalPlanGenForRecur() {
			super();
			subTupleQHash = new Hashtable();

		}
		/**
		 * set up an operator's input queue
		 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
		 * @param childOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 * @param parentOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 */
		public XATQueue associateByQueue(
			XATStreamOperator childOp,
			XATStreamOperator parentOp) {
			if (parentOp instanceof XATSingleQueueStreamOperator) {
				//there is only one input queue, then this one must be curOp's output queue
				XATQueue queue = childOp.getOutputQueue();
				parentOp.setInputQueue(queue);
				return queue;
			} else {
				DagNode parentNode = (DagNode) parentOp.getNode();
				DagNode childNode = (DagNode) childOp.getNode();

				for (int j = 0; j < parentNode.getChildrenSize(); j++) {
					try {
						if (parentNode.getChild(j) == childNode) {
							XATQueue queue = childOp.getOutputQueue();
							(
								(
									XATMultiQueueStreamOperator) parentOp)
										.setNthInputQueue(
								queue,
								j);
							return queue;
						}
					} catch (Exception e) {
						e.printStackTrace();
						System.exit(-1);
					}

				}
			}
			return null;
		}
		public Object dispatch() {
			return null;
		}
		public Object dispatch(Object obj) {
			return null;
		}
		public Object dispatch(Object obj1, Object obj2) {
			return null;
		}
		
		/**
		 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue  the queue between childOp and parentOp
		 * @param childOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 * @param parentOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 */
		public XATQueue findQueue(
			XATStreamOperator childOp,
			XATStreamOperator parentOp) {
			if (parentOp instanceof XATSingleQueueStreamOperator) {
				//there is only one input queue, then this one must be curOp's output queue
				XATQueue queue = childOp.getOutputQueue();
				return queue;
			} else {
				DagNode parentNode = (DagNode) parentOp.getNode();
				DagNode childNode = (DagNode) childOp.getNode();

				for (int j = 0; j < parentNode.getChildrenSize(); j++) {
					try {
						if (parentNode.getChild(j) == childNode) {
							XATQueue queue = childOp.getOutputQueue();
							return queue;
						}
					} catch (Exception e) {
						e.printStackTrace();
						System.exit(-1);
					}

				}
			}
			return null;
		}

		/**
		 * Top down traverse, create xatstreamoperator outof autologicoperator
		 * @return XATDag a physical plan
		 * @param inputDag a logical plan
		 */
		public XATDag generatePhyPlan(XATDag inputDag) {
			inDag = inputDag;

			//do a breadth first traverse from bottom up
			Vector traversal =
				DagTraversal.dagTopDownTraverse((DagNode) inputDag.getRoot());

			boolean root = true;

			for (Iterator it2 = traversal.iterator(); it2.hasNext();) {

				//visit operator
				DagNode curNode = (DagNode) it2.next();
				//get the logical operator
				XATOperator oldOp = curNode.getOperator();

				//visit 
				visit(curNode.getOperator());

				//get the physical operator
				XATStreamOperator curOp = (XATStreamOperator) curNode.getOperator();
				
				//set up default branch eval order
				/*if (curOp instanceof DemandDrivenInvoking){
					int curNodeChildSize = curNode.getChildrenSize();
					int[] branchEvalOrder = new int[curNodeChildSize];
					for (int i=0;i<curNodeChildSize; i++)
						branchEvalOrder.add(new Integer(i));
					
					((DemandDrivenInvoking)curOp).setBranchEvalOrder(branchEvalOrder);
				}*/
				
				//set common attributes
				curOp.setOutputColumnName(oldOp.getOutputColumnName());

				//if this operator is the root, do not set it to be datadrivinginvoking
				if (root)
					//curOp.setProperty("DATA_DRIVEN_INVOKING", "0");
					root = false;

				//do not set schema for StreamNavigate, they do not have output queues anyway

				if (!(curOp instanceof PureNavigateAutoStream) && !(curOp instanceof XMLScanStream)) {
					//set schema
					XATQueue q = (XATQueue) curOp.getOutputQueue();
					Vector names = FindOpVisitor.getSchemaNameList(curNode);

					XATQueueSchema schema = new XATQueueSchema(names);
					q.setSchema(schema);

				}

				if (curOp instanceof SelectStream)
					//need to resolve the column position and queue position for the predicate expression
					toResolveSelect.add(curOp);

				if (curOp instanceof XATMultiQueueStreamOperator)
					//need to resolve the number of synopsises
					toResolveMultiOp.add(curOp);

			} // end of for (Iterator it = traversal.iterator(); it.hasNext();)

			//set up node id schema
			Vector traversal2 = DagTraversal.dagBottomUpTraverse(inputDag);
			for (Iterator it = traversal2.iterator(); it.hasNext();) {
				DagNode curNode = (DagNode) it.next();
				XATStreamOperator curOp = (XATStreamOperator) curNode.getOperator();

				if (curOp instanceof NaturalJoinStream) {
					//set up joined on position
					for (int i = 0; i < curNode.getChildrenSize(); i++) {
						DagNode childNode = (DagNode) curNode.getChild(i);
						List inputSchemaNames =
							((XATStreamOperator) (childNode.getOperator()))
								.getOutputQueue()
								.getSchema()
								.getColNames();
						((NaturalJoinStream) curOp).setLeftTargetPos(
							inputSchemaNames.indexOf("$id"));
						((NaturalJoinStream) curOp).setRightTargetPos(
							inputSchemaNames.indexOf("$id"));
					}
				}

				//any node that has a natural join ancestor should keep the id column
				if (FindOpVisitor.hasNatureJoinAncestor(curNode)
					&& !(curOp instanceof PureNavigateAutoStream)
					&& !(curOp instanceof XMLScanStream)
					&& !FindOpVisitor.hasSJAncestor(curNode)) {
					if (curOp instanceof ExtractStream) {
						curOp.getOutputQueue().getSchema().addColumn("$id");
						curNode.getSchema().add("$id");
					} else {

						//revisit: hardcode
						List inputSchemaNames =
							((XATStreamOperator) (curNode
								.getChild(0)
								.getOperator()))
								.getOutputQueue()
								.getSchema()
								.getColNames();
						if (!inputSchemaNames.contains("$id")) {
							curOp.getOutputQueue().getSchema().addColumn("$id");
							curNode.getSchema().add("$id");
						} else {
							//need to be careful about the order
							int pos = inputSchemaNames.indexOf("$id");

							List outputSchemaNames =
								curOp.getOutputQueue().getSchema().getColNames();
							int count = 0;
							for (int i = 0; i < pos; i++) {
								String inputSchemaName =
									(String) inputSchemaNames.get(i);
								if (!outputSchemaNames.contains(inputSchemaNames))
									count++;

							}

							curOp.getOutputQueue().getSchema().getColNames().add(
								pos - count,
								"$id");
							curNode.getSchema().add("$id");
						}
					}
				}
			}

			/**************remove****************************/
			removeUnnessaryExtract(inputDag);

			/************************resolve the selectStreamOperators' predicate expressions*/
			for (Iterator i = toResolveSelect.iterator(); i.hasNext();) {
				SelectStream selectOp = (SelectStream) i.next();

				Vector terminalColumnExprs =
					selectOp.getExpression().getTerminalColumnExprs();

				for (int j = 0; j < terminalColumnExprs.size(); j++) {

					TerminalExpressionStrImp terminalExpr =
						(TerminalExpressionStrImp) terminalColumnExprs.get(j);

					String columnName =
						((ColumnName) terminalExpr.getValue()).getColumnName();
					String tableName =
						((ColumnName) terminalExpr.getValue()).getTableName();

					XATNode[] children = selectOp.getNode().getChildren();

					if (tableName == null) {

						// look through the tables until we find a matching column
						for (int k = 0;
							k < selectOp.getNode().getChildren().length;
							k++) {
							XATQueue inputQueue =
								(XATQueue) children[k]
									.getOperator()
									.getOutputDataSource();

							XATQueueSchema queueSchema = inputQueue.getSchema();
							int columnPosition =
								queueSchema.getColNames().indexOf(columnName);
							if (columnPosition != -1) {
								//column exists in this queue
								terminalExpr.setIQueuePosition(k);
								terminalExpr.setIColumnPosition(columnPosition);
							}
						}
					} //end of if (tableName == null)
					else
						//table name specified
						for (int k = 0; k < children.length; k++) {
							XATQueue inputQueue =
								(XATQueue) children[k]
									.getOperator()
									.getOutputDataSource();
							XATQueueSchema queueSchema = inputQueue.getSchema();
							if (queueSchema.getName().equals(tableName)) {
								//find the specified table

								int columnPosition =
									queueSchema.getColNames().indexOf(columnName);
								if (columnPosition != -1) {
									//column exists in this queue
									terminalExpr.setIQueuePosition(k);
									terminalExpr.setIColumnPosition(columnPosition);
								} else {
									System.out.println(
										"no specified columns in the specified tables");
									System.exit(-1);
								}
							}
						} //end of for k
				} //end of for j
			} //end of for (Iterator i = toResolveSelect.iterator(); i.hasNext();)

			/************************resolve the selectStreamOperators' predicate expressions*/
			for (Iterator i = toResolveMultiOp.iterator(); i.hasNext();) {
				XATMultiQueueStreamOperator op =
					(XATMultiQueueStreamOperator) i.next();
				if (op instanceof CartesianStream)
					((CartesianStream) op).initializeSynopsis(
						op.getInputQueueCount());

			}

			return inDag;
		}

		/**
			 * Top down traverse, create xatstreamoperator outof autologicoperator
			 * Creation date: (2002-12-20 15:57:08)
			 * @return edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
			 */
		public XATDag generatePhyPlanManual(XATDag inputDag) {
			inDag = inputDag;

			try {
				////////////////////////////////////////////////
				//bloody hack, get rid of the Expose and Aggregate
				//commented for using manual
				/*DagNode prevRoot = (DagNode) inDag.getRoot();
				prevRoot = (DagNode) prevRoot.getChild(0);
				DagNode newRoot = (DagNode) prevRoot.getChild(0);
				
				newRoot.deleteParent(prevRoot);
				inDag.setRoot(newRoot);*/

				//commented for using automatic
				DagNode newRoot = (DagNode) inDag.getRoot();

				//get rid of the AutoMegaOperator

				DagNode autoMegaNode = newRoot;
				while (autoMegaNode.getChildrenSize() > 0) {
					autoMegaNode = (DagNode) autoMegaNode.getChild(0);
					if (autoMegaNode.getOperator() instanceof AutoMegaOperator) {
						//if auto mega operator found
						DagNode parentNode = (DagNode) autoMegaNode.getParent();
						DagNode autoMegaBoundaryNode =
							((AutoMegaOperator) autoMegaNode.getOperator())
								.getBoundary();
						//replace the mega operator with the boundary operator
						parentNode.addChild(autoMegaBoundaryNode);
						parentNode.deleteChild(autoMegaNode);
						autoMegaBoundaryNode.addParent(parentNode);
						//break;
					}
				}

				//do a breadth first traverse from bottom up
				Vector traversal = DagTraversal.dagTopDownTraverse(newRoot);

				boolean root = true;

				for (Iterator it = traversal.iterator(); it.hasNext();) {

					//visit operator
					DagNode curNode = (DagNode) it.next();
					//get the logical operator
					XATOperator oldOp = curNode.getOperator();

					//visit 
					visit(curNode.getOperator());

					//get the physical operator
					XATStreamOperator curOp =
						(XATStreamOperator) curNode.getOperator();

					//set common attributes
					curOp.setOutputColumnName(oldOp.getOutputColumnName());

					//if this operator is the root, do not set it to be datadrivinginvoking
					if (root) {
						//curOp.setProperty("DATA_DRIVEN_INVOKING", "0");
						root = false;
					}

					//do not set schema for StreamNavigate, they do not have output queues anyway

					if (!(curOp instanceof PureNavigateAutoStream)) {
						//set schema
						XATQueue q = (XATQueue) curOp.getOutputQueue();
						Vector names = FindOpVisitor.getSchemaNameList(curNode);

						XATQueueSchema schema = new XATQueueSchema(names);
						q.setSchema(schema);

					}

					if (curOp instanceof SelectStream) {
						//need to resolve the column position and queue position for the predicate expression
						toResolveSelect.add(curOp);
					}

					if (curOp instanceof XATMultiQueueStreamOperator) {
						//need to resolve the number of synopsises
						toResolveMultiOp.add(curOp);
					}

				} // end of for (Iterator it = traversal.iterator(); it.hasNext();)

				/************************resolve the selectStreamOperators' predicate expressions*/
				for (Iterator i = toResolveSelect.iterator(); i.hasNext();) {
					SelectStream selectOp = (SelectStream) i.next();

					Vector terminalColumnExprs =
						selectOp.getExpression().getTerminalColumnExprs();

					for (int j = 0; j < terminalColumnExprs.size(); j++) {

						TerminalExpressionStrImp terminalExpr =
							(TerminalExpressionStrImp) terminalColumnExprs.get(j);

						String columnName =
							((ColumnName) terminalExpr.getValue()).getColumnName();
						String tableName =
							((ColumnName) terminalExpr.getValue()).getTableName();

						XATNode[] children = selectOp.getNode().getChildren();

						if (tableName == null) {

							// look through the tables until we find a matching column
							for (int k = 0;
								k < selectOp.getNode().getChildren().length;
								k++) {
								XATQueue inputQueue =
									(XATQueue) children[k]
										.getOperator()
										.getOutputDataSource();

								XATQueueSchema queueSchema = inputQueue.getSchema();
								int columnPosition =
									queueSchema.getColNames().indexOf(columnName);
								if (columnPosition != -1) {
									//column exists in this queue
									terminalExpr.setIQueuePosition(k);
									terminalExpr.setIColumnPosition(columnPosition);
								}
							}
						} //end of if (tableName == null)
						else
							//table name specified
							for (int k = 0; k < children.length; k++) {
								XATQueue inputQueue =
									(XATQueue) children[k]
										.getOperator()
										.getOutputDataSource();
								XATQueueSchema queueSchema = inputQueue.getSchema();
								if (queueSchema.getName().equals(tableName)) {
									//find the specified table

									int columnPosition =
										queueSchema.getColNames().indexOf(
											columnName);
									if (columnPosition != -1) {
										//column exists in this queue
										terminalExpr.setIQueuePosition(k);
										terminalExpr.setIColumnPosition(
											columnPosition);
									} else {
										System.out.println(
											"no specified columns in the specified tables");
										System.exit(-1);
									}
								}
							} //end of for k
					} //end of for j
				} //end of for (Iterator i = toResolveSelect.iterator(); i.hasNext();)

				/************************resolve the selectStreamOperators' predicate expressions*/
				for (Iterator i = toResolveMultiOp.iterator(); i.hasNext();) {
					XATMultiQueueStreamOperator op =
						(XATMultiQueueStreamOperator) i.next();
					if (op instanceof CartesianStream)
						((CartesianStream) op).initializeSynopsis(
							op.getInputQueueCount());

				}

			} catch (Exception e) {
				e.printStackTrace();
			}
			return inDag;
		}
		
		/**
		 * revisit: what if pattern is DOMPattern
		 * Creation date: (4/9/2003 11:47:26 AM)
		 * @param queue edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 */
		public void generateQueueSubtupProperty(XATStreamOperator curOp) {

			if (subtuple_quick_response) {
				genQSubtupForQuickRes(curOp);
			}

			if (subtuple_shortcircuit) {
				genQSubtupForShortcircuit(curOp);
			}

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (4/9/2003 2:52:15 PM)
		 * @param curOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 */
		public void genQSubtupForQuickRes(XATStreamOperator curOp) {

			if (curOp instanceof TaggerStream) {

				Pattern pattern = ((TaggerStream) curOp).getPattern();
				if (pattern instanceof ListPattern) {
					Vector patternV = ((ListPattern) pattern).getList();

					//count how many column variables are required in the pattern
					int columnCount = 0;
					String columnName = null;

					for (int i = 0; i < patternV.size(); i++) {
						Object item = patternV.elementAt(i);

						if (item instanceof ColumnName) {
							columnCount++;
							columnName = (String) item;
						}
					}

					if (columnCount == 1) {
						//require only one variable, set the input src providing this variable as subtuple inputs

						//FindOpVisitor visitor = new FindOpVisitor();                  
						XATStreamOperator childOp =
							FindOpVisitor.findColsGeneratePropagateChildLevelOps(
								curOp,
								columnName);

						XATQueue childQueue = associateByQueue(childOp, curOp);

						List l = new ArrayList();
						l.add(columnName);
						subTupleQHash.put(childQueue, l);
					}

				} //end of if (pattern instanceof ListPattern)
			} //end of if (curOp instanceof TaggerStream) 

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (4/9/2003 2:52:15 PM)
		 * @param curOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 */
		public void genQSubtupForShortcircuit(XATStreamOperator curOp) {
			if (!((curOp instanceof SelectStream)
				|| (curOp instanceof InTimeSJStream)))
				//curOp is not a filtering operator
				return;

			boolean shortCircuitable = false;

			XATNode curNode = curOp.getNode();

			Set outSchema = curNode.getSchema();

			//outSchema.size() < inSchema.size(), check the filtered column
			/*  if (curOp instanceof InTimeSJStream) {
			
			      for (int i = 0; i < curNode.getChildrenSize(); i++) {
			          try {
			              Set childSchema = curNode.getChild(i).getSchema();
			
			              for (Iterator j = childSchema.iterator(); j.hasNext(); ) {
			
			                  Object item = j.next();
			                  if (!outSchema.contains(item)) {
			                      FindOpVisitor visitor = new FindOpVisitor();
			                      if (visitor.isCollectionType((DagNode)curNode.getChild(i), (String) item)) {
			                          ((FilteringOp) curOp).setShortCircuit(true);
			                      }
			                  }
			
			              }
			          }catch (Exception e) {
			              e.printStackTrace();
			              System.exit(-1);
			          }
			      }
			   */

			if (curOp instanceof SelectStream) {
				Vector terminalCols =
					((SelectStreamImp) curOp)
						.getExpression()
						.getTerminalColumnExprs();

				for (int j = 0; j < terminalCols.size(); j++) {
					String colName =
						((ColumnName) ((TerminalExpressionStr) terminalCols.get(j))
							.getValue())
							.getColumnName();

					if (!FindOpVisitor
						.isCollectionType((DagNode) curOp.getNode(), colName))
						//if not a collection type, not shortcircuitable
						return;

					DagNode endNode =
						FindOpVisitor.findNodeExistentialConsuming(
							(DagNode) curOp.getNode(),
							colName);

					if (endNode != null) {

						XATStreamOperator childOp =
							FindOpVisitor.findColsGeneratePropagateChildLevelOps(
								curOp,
								colName);
						XATQueue childQueue = findQueue(childOp, curOp);

						List l = (List) subTupleQHash.get(childQueue);

						if (l == null)
							l = new ArrayList();

						l.add(colName);
						subTupleQHash.put(childQueue, l);
						//findQueuePos(childOp, curOp);
						if (curOp instanceof CollSelectStream)
							//curOp may only be a SelectStream
							 ((CollSelectStream) curOp).setShortCircuit(true);
					}

				} //end of for (int j = 0; j < terminalCols.size(); j++)

			} //end of if (curOp instanceof SelectStream)
		}
		
		
		/**
		 * first find whether "curOp" itself requies some input queue to be subtuple queue
		 * second given "curOpInputQ", find whether this input queue needs to be subtuple queue, 
		 * if yes, then set this input queue's owner (i.e., a
		 * child operator)'s output tuple granularity to be subtuple 
		 * Creation date: (4/9/2003 11:47:26 AM)
		 * @param queue edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator
		 */
		public void propagateQueueSubtupProperty(
			XATQueue curOpInputQ,
			XATStreamOperator curOp) {
			//correspondingly set its own input queues, especially the subtuple concern

			// see whether itself requires some input queue to be sutuple queue 
			generateQueueSubtupProperty(curOp);

			List subCols = (List) subTupleQHash.get(curOpInputQ);

			if (subCols != null) {
				//curOp's input queue is set to be a subtuple queue
				//set the corresponding child's property

				//FindOpVisitor visitor = new FindOpVisitor();

				for (int i = 0; i < subCols.size(); i++) {
					//find which is the generating src of this column on the immedidate child level
					String subCol = (String) subCols.get(i);

					XATStreamOperator subColRelatedOp =
						FindOpVisitor.findColsGeneratePropagateChildLevelOps(
							curOp,
							subCol);

					if (subColRelatedOp != null) {
						//curOp is not the generating src of the subcol, subColRelatedOp either propagates or generates the subcol

						//XATQueue curQueue = findQueue(subColRelatedOp, curOp);

						try {
							subColRelatedOp.setProperty(
								"OUTPUT_TUPLE_GRANULARITY",
								XATStreamOperator.SUB_TUPLE);
						} catch (Exception e) {
							e.printStackTrace();
							System.exit(-1);
						}

						// subTupleQHash.put(curOp.getInputQueue(), subCol);

					}

				} //end of for

			} //end of if (subCols != null)

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (4/9/2003 1:19:56 PM)
		 * @param newSubtuple_quick_response boolean
		 */
		public void setSubtuple_quick_response(boolean newSubtuple_quick_response) {
			subtuple_quick_response = newSubtuple_quick_response;
		}
		/**
		 * Insert the method's description here.
		 * Creation date: (4/9/2003 1:19:32 PM)
		 * @param newSubtuple_shortcircuit boolean
		 */
		public void setSubtuple_shortcircuit(boolean newSubtuple_shortcircuit) {
			subtuple_shortcircuit = newSubtuple_shortcircuit;
		}
		/**
		 * for "parentNode", set its output granularity
		 * Creation date: (4/10/2003 6:33:07 PM)
		 */
		public void setUpParentOutputSubtupProperty(DagNode parentNode) {

			if (parentNode != null) {

				XATStreamOperator parentOp =
					(XATStreamOperator) parentNode.getOperator();

				for (int j = 0; j < parentNode.getParentsSize(); j++) {

					propagateQueueSubtupProperty(
						parentOp.getOutputQueue(),
						(XATStreamOperator) parentNode.getParent(j).getOperator());
				}
			}

		}
		/**
		 * associate curNode's curOp's output queue with its parent's input queue
		 * Creation date: (4/9/2003 10:59:47 AM)
		 * @param curNode edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
		 */
		public void setUpQueues(DagNode curNode) {

			//step 1: associate curNode's curOp's output queue with its parent's input queue
			XATStreamOperator curOp = (XATStreamOperator) curNode.getOperator();

			for (Iterator it = curNode.getParents(); it.hasNext();) {

				DagNode parentNode = (DagNode) it.next();

				XATStreamOperator parentOp =
					(XATStreamOperator) parentNode.getOperator();

				//find which input queue should be the curOp's output queue
				XATQueue curQueue = associateByQueue(curOp, parentOp);

			}

		}

		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:31:07)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source
		 */
		//public void visit(Expose op) {
		//}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:31:07)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source
		 */
		public void visit(Select op) {

			Expression exp = op.getExpression();
			ExpressionStr expStr = null;

			//make op

			ExpressionStrImp expStrMaker = new ExpressionStrImp();
			expStr = expStrMaker.createExpressionStr(exp);

			DagNode node = (DagNode) op.getNode();
			SelectStream selOp = new SelectStreamImp(node, expStr);
			node.setOperator(selOp);

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

		}
		
		public void visit(Source op){
			
			DagNode node = (DagNode) op.getNode();
			XMLScanStream scanOp = new XMLScanStream(node);
			scanOp.setSourceName(op.getName());
			node.setOperator(scanOp);

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:31:07)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source
		 * 
		 */
		public void visit(NavCollection op) {
			DagNode node = (DagNode) op.getNode();

			//find whether the result is for a string value comparison, if yes, replace the destination to /step

			NavCollectionStream navOp =
				new NavCollectionStream(
					node,
					op.getEntryPoint(),
					op.getDestination());
			node.setOperator(navOp);

			//set operations
			navOp.setOutputColumnName(op.getOutputColumnName());

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:31:07)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source
		 */
		public void visit(NavUnnest op) {
			DagNode node = (DagNode) op.getNode();
			NavUnnestStream navOp =
				new NavUnnestStream(node, op.getEntryPoint(), op.getDestination());
			node.setOperator(navOp);

			//set operations
			//navOp.setBinding(op.getBinding());
			navOp.setOutputColumnName(op.getOutputColumnName());

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());
		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:31:07)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source
		 */
		public void visit(Tagger op) {
			DagNode node = (DagNode) op.getNode();
			TaggerStream tagOp = new TaggerStream(node);
			tagOp.setPattern(op.getPattern());
			node.setOperator(tagOp);

			//setUpQueues((DagNode) op.getNode());
			setUpQueues(node);

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

		}

		public void visit(NatureJoin nj) {
			DagNode node = (DagNode) nj.getNode();

			NaturalJoinStream njOp = new NaturalJoinStream(node);

			setUpQueues(node);

			setUpParentOutputSubtupProperty((DagNode) node.getParent());
		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:30:15)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollection
		 */
		public void visit(ExtractColl op) {

			DagNode node = (DagNode) op.getNode();
			ExtractByCollectionStreamImp exOp = null;

			//added for distinguishing whether an access type
			//if (FindOpVisitor.isNotAccess(node)) {
			//an operator that filters

			if (op instanceof OuterExtractColl)
				exOp =
					new OuterExtractByCollectionStream(
						node,
						op.getEntryPoint(),
						op.getDestination());
			else
				{
				 if (TestExecBaseLocal.queryIsRecur)
				 	exOp = new  ExtractByCollectionWithRecur(
						node,
						op.getEntryPoint(),
						op.getDestination());
				 else
				 	exOp =
					new ExtractByCollectionStreamImp(
						node,
						op.getEntryPoint(),
						op.getDestination());
				
				}

			int[] neededFormats = FindOpVisitor.findNeedFormats(op);

			//if both tree and dom needed, only use dom
			if (neededFormats[ExtractStream.COMPLETE_TREE] == 1
				&& neededFormats[ExtractStream.DOM] == 0)
				exOp.setStoringMethod(ExtractStream.COMPLETE_TREE);

			if (neededFormats[ExtractStream.TYPED_VALUE] == 1)
				exOp.setStoringMethod(ExtractStream.TYPED_VALUE);

			if (neededFormats[ExtractStream.DOM] == 1)
				exOp.setStoringMethod(ExtractStream.DOM);
				
			if (neededFormats[ExtractStream.NODE_ID] ==1)
			   exOp.setStoringMethod(ExtractStream.NODE_ID);  	

			if (neededFormats[ExtractStream.ATTRS] == 1)
				exOp.setStoringMethod(ExtractStream.ATTRS);

			((XATStreamOperator) exOp).setOutputColumnName(
				op.getOutputColumnName());

			node.setOperator((XATStreamOperator) exOp);

			//find the groupby node
			NavigationStep[] ep = op.getEntryPoint();

			//find the entry point is which Nav's destination

			DagNode groupByNode = (DagNode) op.getNode();

			while (groupByNode != null) {
				//a navcollection op can have only one child
				try {
					groupByNode = (DagNode) groupByNode.getChild(0);
				} catch (Exception e) {
					e.printStackTrace();
					System.exit(-1);
				}
				XATOperator groupByOp = groupByNode.getOperator();
				if (groupByOp instanceof StreamNavigate) {
					if (ep.length == 1)
						if (groupByOp
							.getOutputColumnName()
							.equals(ep[0].toString())) {
							groupByNode = (DagNode) groupByOp.getNode();
							break;
						}
				}
			}

			//resolve it later, the navigate op is not set up yet due to the top-down traversal
			ArrayList list = (ArrayList) toResolveNavHash.get(groupByNode);
			if (list == null) {
				list = new ArrayList();
				list.add(exOp);

				toResolveNavHash.put(groupByNode, list);
			} else {
				list.add(exOp);
			}

		//	removeUnnessaryExtract(exOp);

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

			exOp.setUpCellNum();

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:30:15)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollection
		 */
		public void visit(ExtractUnnest op) throws Exception {

			DagNode node = (DagNode) op.getNode();
			ExtractByUnnestStream exOp= null;
			 if (TestExecBaseLocal.queryIsRecur)
			 
			 	exOp =
					new ExtractByUnnestWithRecur(
						node,
						op.getEntryPoint(),
						op.getDestination());
			 else
			 	 exOp =
				new ExtractByUnnestStream(
					node,
					op.getEntryPoint(),
					op.getDestination());
			
			
			if (exOp.getDestination() == null) {
				//this implies materialize whole document,
				//we set the * to it instead
				NavigationStep[] steps = new NavigationStep[1];

				steps[0] = new NodeStepImp(State.Star_Transit);

				exOp.setDestination(steps);

			}

			node.setOperator(exOp);

			//set the corresponding storing format

			int[] neededFormats = FindOpVisitor.findNeedFormats(op);

			if (neededFormats[ExtractStream.COMPLETE_TREE] == 1
				&& neededFormats[ExtractStream.DOM] == 0) {
				exOp.setStoringMethod(ExtractStream.COMPLETE_TREE);
			}

			if (neededFormats[ExtractStream.TYPED_VALUE] == 1) {
				exOp.setStoringMethod(ExtractStream.TYPED_VALUE);
			}

			if (neededFormats[ExtractStream.DOM] == 1) {
				exOp.setStoringMethod(ExtractStream.DOM);
			}

			if (neededFormats[ExtractStream.ATTRS] == 1) {
				exOp.setStoringMethod(ExtractStream.ATTRS);
			}

			if (neededFormats[ExtractStream.NODE_ID] == 1) {
				exOp.setStoringMethod(ExtractStream.NODE_ID);
			}

			exOp.setOutputColumnName(op.getOutputColumnName());

		//	removeUnnessaryExtract(exOp);

			setUpQueues(node);

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

			exOp.setUpCellNum();

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:30:32)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnest
		 */
		public void visit(StreamNavigate op) throws Exception {
			DagNode node = (DagNode) op.getNode();
			PureNavigateAutoStream navOp = null;	
			if (TestExecBaseLocal.queryIsRecur)
				
				 	navOp= new PureNavigateAutoStreamWithRecur(
					node,
					op.getEntryPoint(),
					op.getDestination());  
			 
			else	
				navOp =
				  new PureNavigateAutoStream(
					node,
					op.getEntryPoint(),
					op.getDestination()); 
			
			node.setOperator(navOp);

			//resolve all operators that refer to it
			List list = (List) toResolveNavHash.get(op.getNode());
			if (list != null) {
				for (Iterator i = list.iterator(); i.hasNext();) {
					XATStreamOperator opInList = (XATStreamOperator) i.next();

					if (opInList instanceof InTimeSJStream) {
						((InTimeSJStream) opInList).setBranchNavOp(navOp);
					}

					if (opInList instanceof ExtractByCollectionStream) {
						(
							(
								ExtractByCollectionStream) opInList)
									.setCollectionByNavOp(
							navOp);
					}

					if (opInList instanceof OuterExtractByCollectionStream) {
						(
							(
								OuterExtractByCollectionStream) opInList)
									.setCollectionByNavOp(
							navOp);
					}

				}
			}

			navOp.setOutputColumnName(op.getOutputColumnName());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:30:45)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select
		 */
		public void visit(StreamSelect op) throws Exception {
			//make expression
			Expression exp = op.getExpression();
			ExpressionStr expStr = null;

			ExpressionStrImp expStrMaker = new ExpressionStrImp();
			expStr = expStrMaker.createExpressionStr(exp);

			//make op  

			DagNode node = (DagNode) op.getNode();
			//FlatSelect selOp = new FlatSelectImp(node,expStr);

			Vector v = expStr.getTerminalColumnExprs();

			//set up the iQueuePosition and iColumnPosition

			if (v.size() == 1) {
				String colName =
					((ColumnName) ((TerminalExpressionStr) v.get(0)).getValue())
						.getColumnName();

				boolean collType = FindOpVisitor.isCollectionType(node, colName);

				if (!collType
					|| (collType
						&& !subtuple_shortcircuit
						&& !subtuple_quick_response)) {
					//not collection type
					//or collection type but no shortcircuit or quick response needed to take advantage of column type 
					SelectStream selOp = new SelectStreamImp(node, expStr);
					node.setOperator(selOp);
				} else {
					CollSimpleSelStream selOp =
						new CollSimpleSelStream(node, expStr);
					node.setOperator(selOp);
				}
			} /*else if (v.size() > 1) {
				CollComplexSelStream selOp = new CollComplexSelStream(node, expStr);
				node.setOperator(selOp);

			}*/

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());
		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:31:07)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.Source
		 */
		public void visit(StreamSource op) {
			DagNode node = (DagNode) op.getNode();
			XMLScanStream scanOp = new XMLScanStream(node);
			scanOp.setSourceName(op.getName());
			node.setOperator(scanOp);

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());

		}
		/**
		 * Insert the method's description here.
		 * Creation date: (2002-12-20 16:30:15)
		 * @param op edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollection
		 */
		public void visit(StructuralJoin op) throws Exception {

			//make physical operator
			DagNode node = (DagNode) op.getNode();
			
			InTimeSJStream joinOp = null;	
			//decide whether use InTimeSJStreamImp or SingletonInTimeSJStream
			//if there is more that one child that is extractunnest 
			//then it must be intimesjstreamimp
			//otherwise can be singletonInTimeSJStream
			
			int cardiCount = 0;
			
			List interNodes = FindOpVisitor.findInterBetweenSJs(node);
			
			for (int i = 0; i<interNodes.size();i++){
				XATNode interNode = (XATNode)interNodes.get(i);
				if (interNode.getOperator() instanceof ExtractUnnest 
				|| interNode.getOperator() instanceof ExtractByUnnestStream
				|| interNode.getOperator() instanceof InTimeSJStream
				|| interNode.getOperator() instanceof StructuralJoin)
				cardiCount++;
			}
			
			if (cardiCount > 1 )
				{
				if (TestExecBaseLocal.queryIsRecur)
			 
				   joinOp = new InTimeSJStreamWithRecur(node);
			     else 
				   joinOp = new InTimeSJStreamImp(node);
				}
			  else
			 	
			  {
			  	if (TestExecBaseLocal.queryIsRecur)
			  		joinOp = new SingletonInTimeSJWithRecur(node);
			  	else
			  		joinOp = new SingletonInTimeSJStreamImp(node);
			  }
			  	
			  
			node.setOperator(joinOp);

			//resolve it later, the navigate op is not set up yet due to the top-down traversal
			ArrayList list = (ArrayList) toResolveNavHash.get(op.getShadowNode());
			if (list == null) {
				list = new ArrayList();
				list.add(joinOp);
				toResolveNavHash.put(op.getShadowNode(), list);
			} else {
				list.add(joinOp);
			}

			//this will be override later, but for the purpose of knowing which column this structural join is joined on
			//we need to set up the needed format of extract within the structural join
			PureNavigateAutoStream tempNavOp =
				new PureNavigateAutoStream(new XATNodeImp());
			tempNavOp.setBinding(
				((StreamNavigate) op.getShadowNode().getOperator()).getBinding());
			((InTimeSJStream) joinOp).setBranchNavOp(tempNavOp);

			setUpQueues((DagNode) op.getNode());

			setUpParentOutputSubtupProperty((DagNode) node.getParent());
		}

		public void linearizeNaturalJoin(XATDag xatdag) {

			Vector nodes = DagTraversal.dagBottomUpTraverse(xatdag);

			for (Iterator it = nodes.iterator(); it.hasNext();) {
				DagNode node = (DagNode) it.next();
				XATOperator op = node.getOperator();
				if (op instanceof NaturalJoinStream) {
					//node is now the natural join
					List desc = FindOpVisitor.getDescNodes(node);
					for (Iterator it2 = desc.iterator(); it2.hasNext();) {
						DagNode descNode = (DagNode) it2.next();
						if (descNode.getParentsSize() > 1) {
							//a desc node has multiple parent
							//must be a common ancestor
							DagNode firstParent = (DagNode) descNode.getParent(0);
							//intermediate does not include firstparent, so we include firstParent 
							List intermediate =
								FindOpVisitor.findAllInterOps(firstParent, node);
							intermediate.add(0, firstParent.getOperator());

							DagNode currentNjChild =
								(DagNode) ((XATOperator) intermediate
									.get(intermediate.size() - 1))
									.getNode();

							for (int i = 1; i < descNode.getParentsSize(); i++) {
								//put all nodes on the first branch 
								DagNode ithParent = (DagNode) descNode.getParent(i);

								ithParent.addChild(currentNjChild);
								currentNjChild.deleteParent(node);
								currentNjChild.addParent(ithParent);
								ithParent.deleteChild(descNode);
								descNode.deleteParent(ithParent);
								node.deleteChild(currentNjChild);

								intermediate =
									FindOpVisitor.findAllInterOps(ithParent, node);
								intermediate.add(0, ithParent.getOperator());
								currentNjChild =
									(DagNode) ((XATOperator) intermediate
										.get(intermediate.size() - 1))
										.getNode();
							} //end of for
							//remove naturejoin and add in multiNavUnnest
							currentNjChild.addParent(node.getParent());
							currentNjChild.deleteParent(node);
							node.getParent().addChild(currentNjChild);
							node.getParent().deleteChild(node);
							break;
						} //end of if (descNode.getParentsSize()>1)

					} //end of for (iterator it2)
				} //end of if
			}

		}

		private void removeUnnessaryExtract(XATDag inputDag) {
			Vector nodes = DagTraversal.dagTopDownTraverse(inputDag);
			
			for (Iterator it0 = nodes.iterator(); it0.hasNext();){
			DagNode node = (DagNode)it0.next();  
			
			if (!(node.getOperator() instanceof ExtractStream))
			continue;

	        
	        ExtractStream extractOp = (ExtractStream)node.getOperator();
	        if (extractOp.getTupleColNum() > 0){
	            continue;
	        }
	        
	        //extractOp.getTupleColNum()==0
	        //whether it has another navigation starting from the destination and underneath structural join
	     /*   boolean removable = false;
	        for (Iterator it = nodes.iterator(); it.hasNext();){
	        	DagNode otherNode = (DagNode)it.next();
	        	XATOperator otherOp = otherNode.getOperator();
	        	if (otherOp instanceof Navigate){
	        		String entry = ((Navigate)otherOp).getEntryPoint()[0].getStepValue();
	        		if (entry.equals(((XATStreamOperator)extractOp).getOutputColumnName())){
	        		removable = true;
	        		//can be removed
	        		break;
	        		}
	        	}
	        	
	        }//end of for
	        
	        if (!removable){
	        
	        continue;
	        }*/
	        

			//this op should be removed
			DagNode extractNode =
				(DagNode) ((XATStreamOperator) extractOp).getNode();
			DagNode parentNode =
				(DagNode) ((XATStreamOperator) extractOp).getNode().getParent();

			((DagNode) extractNode.getChild(0)).deleteParent(extractNode);

			extractNode.deleteChild(extractNode.getChild(0));
			extractNode.deleteAllParents();

			//parent op must be structural join
			boolean parentNodeRemoved = false;
			if (parentNode.getChildrenSize() == 2 && parentNode.getParentsSize()!=0) {
				//if the sj has only one child and sj is not the topmmost operator
				//remove this parent node
				parentNodeRemoved = true;
				
				        
	            //the pos of the node that is to be kept
				int pos = 0;
				if (parentNode.getChild(0) == extractNode)
					pos = 1;
				
//				if this parent has no further parent
				//reset the inputDag's root
				inputDag.setRoot(parentNode.getChild(pos));
				

				for (Iterator it2 = parentNode.getParents(); it2.hasNext();) {
					DagNode grandParent = (DagNode) it2.next();
					((DagNode) parentNode.getChild(pos)).addParent(grandParent);
					grandParent.addChild((DagNode) parentNode.getChild(pos));
					grandParent.deleteChild(parentNode);
					//parentNode.deleteParent(grandParent);

				}
				
				parentNode.deleteAllParents();

				((DagNode) parentNode.getChild(pos)).deleteParent(parentNode);
				parentNode.deleteChild((DagNode)parentNode.getChild(pos));
				parentNode.deleteChild(extractNode);

			} else
				//sj has multiple child
				parentNode.deleteChild(extractNode);

			for (Iterator it =
				((XATStreamOperator) parentNode.getOperator()).getInputQueues();
				it.hasNext();
				) {
				XATQueue parentInputQueue = (XATQueue) it.next();
				if (parentInputQueue.getQueueOwner().get(0) == extractOp) {

					for (Iterator it2 = it; it2.hasNext();) {
						XATQueue nextInputQueue = (XATQueue) it.next();
						//if (nextInputQueue.getQueueNumber()>parentInputQueue.getQueueNumber())
						if (nextInputQueue!=null)
						nextInputQueue.setQueueNumber(
							nextInputQueue.getQueueNumber() - 1);
					}

				}
			}

			for (Iterator it =
				((XATStreamOperator) parentNode.getOperator()).getInputQueues();
				it.hasNext();
				) {
				XATQueue inputQueue = (XATQueue) it.next();
				if (inputQueue.getQueueOwner().get(0) == extractOp)
					it.remove();
			}

			if (parentNodeRemoved) {
				//remove the input queue from parentNode to grandparent
				for (Iterator it = parentNode.getParents(); it.hasNext();) {
					DagNode grandParentNode = (DagNode) it.next();
					for (Iterator it2 =
						((XATStreamOperator) grandParentNode.getOperator())
							.getInputQueues();
						it2.hasNext();
						) {
						XATQueue parentInputQueue = (XATQueue) it2.next();
						if (parentInputQueue == null) {

							for (Iterator it3 = it2; it3.hasNext();) {
								XATQueue nextInputQueue = (XATQueue) it3.next();
								//if (nextInputQueue.getQueueNumber()>parentInputQueue.getQueueNumber())
								if (nextInputQueue.getQueueOwner().get(0)==extractOp)
								nextInputQueue.setQueueNumber(
									nextInputQueue.getQueueNumber() - 1);
							}

						}
					}

					for (Iterator it4 =
						((XATStreamOperator) grandParentNode.getOperator())
							.getInputQueues();
						it4.hasNext();
						) {
						XATQueue inputQueue = (XATQueue) it4.next();
						if (inputQueue.getQueueOwner().get(0) == extractOp)
							it4.remove();
					}

				}
			}
			}
		}

	}
