package edu.wpi.cs.dsrg.xmldb.xat.recursion;

/**
 * the object the key points to, which can either be a string or a dom Creation
 * date: (5/8/2003 8:39:05 PM)
 * 
 * @author: Hong Su
 */
import org.apache.xerces.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

import java.io.*;
import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;

public class XATKeyDataValue extends XATDataValueImp {
	/**
	 * XATKeyDataValue constructor comment.
	 * 
	 * @param obj
	 *            java.lang.Object
	 */
	public XATKeyDataValue(List obj) {
		collection = obj;
	}

	public XATKeyDataValue(Object obj) {
		value = obj;
	}

	/**
	 * convert the object to a dom representation
	 * 
	 * @param Object
	 */
	protected Object convertToDOM(Object o) {
		if (o instanceof Vector) {
			Vector v = (Vector) o;
			for (int i = 0; i < v.size(); i++) {
				v.setElementAt(convertToDOM(v.elementAt(i)), i);
			}
			return v;
		} else if (o instanceof XATDataValue) {

			return convertToDOM(((XATDataValue) o).convertToDOM());

		} else if (o instanceof String) {
			/* convert it... */
			InputSource is = new InputSource(new StringReader((String) o));
			DOMParser parser = new DOMParser();
			try {
				parser.parse(is);
			} catch (java.io.IOException ioe) {
				ioe.printStackTrace(System.err);
			} catch (org.xml.sax.SAXException sae) {
				sae.printStackTrace(System.err);
			}
			Document dDocument = parser.getDocument();
			return dDocument.getDocumentElement();
		} else if (o instanceof Node) {
			return o;
		} else if (o instanceof Finer_StreamStoreMgrKey) {
			if (((Finer_StreamStoreMgrKey) o).getKeyType() == Finer_StreamStoreMgrKey.DOM)
				return ((Finer_StreamStoreMgrKey) o).getDomNode();
		}
		return o;
	}

	public String toString() {
		String str = "";
		if (this.value instanceof Finer_StreamStoreMgrKey)
			str = ((Finer_StreamStoreMgrKey) value).toString();
		else if (value instanceof LightElement)
			str = ((LightElement)value).getNodeName();
		return str;

	}
}