/**
 * RainDrop code.
 * 
 * Copyright of the Software is and will remain with The Trustees of
 * WPI and/or its employees and shall at no point transfer to Licensee. 
 * Any copyright notices on the Software shall be included on all copies 
 * of the Derivatives, or any parts or portions thereof, in any form, manner 
 * or substance, which are produced by the Licensee including but not 
 * limited to incorporation of the Software into any other program, 
 * technical data, documentation, firmware, or other information of the 
 * like kind, type or quality
 * 
 * (c) 2006, Shoushen Yang(shoushen@cs.wpi.edu)
 */
package edu.wpi.cs.dsrg.xmldb.xat.rsox;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.AutomataEnabled;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractByCollectionStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.NavigateStreamImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.DescendantStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NodeStep;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.TraceState;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.testing.UtilForTesting;

import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
/**
 * @author shoushen
 *
 * This is to control the punctuation. 
 */
public class PuncController {
	
	static ExtendedAutomata ea;
	static QueryGraph qg;
	static DagNode dnl;

	/**
	 * 
	 */
	public PuncController() {
		super();
		// TODO Auto-generated constructor stub
	}

	static public void doWithPunc(String punc)
	{
		try
		{
			String[] ret = PuncParser.parsePunc(punc);
			
			XATDag plan = ea.getPlan();
			Vector dagNodes = DagTraversal.dagBottomUpTraverse(plan);
			
			for (int i = 0 ; i < dagNodes.size(); i++)
			{
				DagNode curNode = (DagNode)dagNodes.elementAt(i);
				XATOperator op = curNode.getOperator();
				if (!(op instanceof XMLScanStream))
				if (op instanceof ExtractByCollectionStream)
				{
					ExtractByCollectionStreamImp ebcs = (ExtractByCollectionStreamImp)op;
					if (ebcs.isNodeId())
					{
						String des = ((NavigateStreamImp)ebcs).getDestination()[0].toString();
						if ((des.equals(ret[4])))
						{	
							//we will NOT delete the node here. Instead we will mark it as "DELETED".
/*							
							//curNode.getParent().deleteChild(curNode);
							//plan.deleteNodeOnly(curNode);
							deleteState(curNode, plan, ret[4]);
							deleteNode(curNode, plan, ret[4]);	
							
							System.out.println(ea);
							//UtilForTesting.setDataDriven(plan);
							//UtilForTesting.setUpAuto(plan);							
							//plan.deleteNode(dnl);
							//plan.deleteNode(curNode);	
							//curNode.getParent().deleteChild(curNode);
							System.out.println("updating physical plan...");
							DagTraversal.printDag(plan);*/
							
							deleteState(curNode, plan, ret[4]);
							ebcs.deleted = true;
						}
					}
				}
			}

		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	static public void setExAutomata(ExtendedAutomata eap)
	{
		ea = eap;
	}
	static public void setQueryGraph(QueryGraph qgc)
	{
		qg = qgc;
	}	
	static public void deleteState(DagNode node, XATDag plan, String delStr)
	{
		DagNode[] children = (DagNode[])node.getChildren();
		
		XATStreamOperator opt = (XATStreamOperator)node.getOperator();

		if (opt instanceof AutomataEnabled)
		{
			//QueryGraphNode qgn = qg.getQgn((XATStreamOperator)opt);
			//List t = qgn.getTraceStates();
			
//			for (Iterator it = t.iterator(); it.hasNext();) 
			//{
/*				TraceState state = (TraceState) it.next();
				List autoStates = state.getAutoStates();*/
				ea.pprint();
				List autoStates = ea.getFrStateHash(opt);
				for (Iterator auto = autoStates.iterator(); auto.hasNext();) 
				{
					ExtendedState autoState = (ExtendedState) auto.next();
					//ea.removeState(autoState);
					//autoState.getParentState()
					//autoState.deleted = true;
					autoState.getParentState().deleteTransit("nickname");
				}
				System.out.println("after opt");
				ea.pprint();
			//}
		}		
/*		for (int i = 0 ; i < children.length; i++)
		{
			XATOperator op = children[i].getOperator();
			if (op instanceof NavigateStreamImp)
			{
				String str = ((NavigateStreamImp)op).getDestination()[0].toString();
				if ((str.equals(delStr)))
				{
					deleteState(children[i], plan, delStr);
				}
			}
		}*/
/*		List autoStates = ea.getStates();
		for (Iterator auto = autoStates.iterator(); auto.hasNext();) 
		{
			ExtendedState autoState = (ExtendedState) auto.next();
			
			for (Iterator it = autoState.getTransits().keySet().iterator(); it.hasNext();) 
			{
				String oldStateTransitName = (String) it.next();
				if (oldStateTransitName.equals("nickname"));
				
					//autoState.deleteTransit("nickname");
			}		
			
			//autoState.getParentState().deleteTransit("nickname");
		}*/

	}
	static public void deleteNode(DagNode node, XATDag plan, String delStr)
	{
		DagNode[] children = (DagNode[])node.getChildren();
		
		for (int i = 0 ; i < children.length; i++)
		{
			XATOperator op = children[i].getOperator();
			if (op instanceof NavigateStreamImp)
			{
				String str = ((NavigateStreamImp)op).getDestination()[0].toString();
				if ((str.equals(delStr)))
				{
					deleteNode(children[i], plan, delStr);
				}
				else
					children[i].deleteParent(node);
			}
			else return;
		}
		plan.deleteNodeOnly(node);

	}	
}
