/*
 * Created on May 30, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.testing;

import java.io.FileNotFoundException;

import junit.framework.TestCase;

public class JunitTestingSuite extends TestCase {

	public void main(String[] args) {
//		testOr1();
//		assertEquals(Test1(), 2);
	}

	/**
	 * Runs a trivial query without predicates
	 * over a trivial xml stream.  
	 * Has a join in the result.
	 * Expected to return 2 tuples.
	 * As of 05/24/06: Passes
	 *@author Drew Ditto
	 */
	public void test1(){
		int result = 0;
		try {			
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test1\\Test1Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 2);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Runs a trivial query without predicates 
	 * over a trivial XML stream.
	 * Has no join in the result
	 * Expected to return 2 tuples
	 * As of 05/24/06: Fails
	 *@author Drew Ditto
	 */
	public void test2() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test2\\Test2Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 2);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Runs a trivial query with predicates 
	 * over a trivial XML stream
	 * Has a join in the result
	 * Should return one tuple
	 * As of 05/24/06: Fails
	 *@author Drew Ditto
	 */
	public void test3() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test3\\Test3Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Runs a trivial query with predicates
	 * over a trivial XML stream
	 * Has no join in the result
	 * Should return one tuple
	 * As of 05/24/06: Fails
	 *@author Drew Ditto
	 */
	public void test4() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test4\\Test4Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Runs a query over an XML stream
	 * has no join in the result
	 * Should return tuples
	 * As of 05/24/06: fails
	 *@author Drew Ditto
	 */
/*	
 	Bad test data
 	public void test5() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test5\\Test5Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\openorder0-8.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertTrue(result > 0);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	} //*/
	
	/**
	 * Tests where based predicates
	 * Should return 1 tuple
	 * passes 05\25\06
	 *@authors Mingzhu
	 */
	public void test6() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test6\\Test6Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple1.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * This tests a triple join in the result tagger.
	 * Tagger needs to be displayed
	 * works 05/25/06
	 *@authors Drew Ditto & Ming Li
	 */
	public void test8() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test8\\Test8Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple1.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Tests Where syntax predicates and
	 * Xquery bracket syntax predicates.
	 * Should return 1 tuple
	 * Works as of 05/25/06
	 *@authors Drew Ditto & Ming Li
	 */
	public void test9() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test9\\Test9Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple2.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Runs a query with multiple predicates, both Where
	 * syntax and xquery bracket syntax, on both root and
	 * persons.  
	 * Should return 1 tuple
	 * Works as of: 05/25/06
	 *@Author Drew Ditto & Ming Li
	 */
	public void test10() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test10\\Test10Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple3.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Tests equality in bracket syntax predicates.
	 * Works
	 * Returns 1 tuple
	 *@authors Drew Ditto & Ming Li
	 */
	public void test11() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test11\\Test11Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple2.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Testing AND syntax in Where based predicates
	 * Should return 1 tuple
	 * Passes 05/25/06
	 *@authors Drew Ditto & Ming Li
	 */
	public void test12() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test12\\Test12Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple2.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Testing AND on two Mothers in the same person tag.
	 * Should return 1 tuple
	 * Fails 05/25/06
	 *@authors Drew Ditto & Ming Li
	 */
	public void test14() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test14\\Test14Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple4.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Runs a trivial query without predicates 
	 * over a trivial XML stream.
	 * Has no join in the result
	 * Expected to return 2 tuples
	 * As of 05/30/06: passes!
	 *@author Drew Ditto
	 */
	public void test15() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test15\\Test15Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 2);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Testing OR syntax in where based predicates
	 * should return 2 tuples
	 * FAILS 05/25/06
	 *@authors Drew Ditto & Ming Li
	 */
/*	public void testOr1() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test7\\Test7Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple1.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 2);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}  //*/
	
	/**
	 * Testing OR syntax
	 * Should return 1 tuple
	 * Fails 05/25/06
	 *@authors Drew Ditto & Ming Li
	 */
/*	public void testOr2() {
		try {
			int result = 0;
			String[] commandLine = new String[4];
			commandLine[0] = "c:\\drew\\newTestData\\Test13\\Test13Query.qlt";
			commandLine[1] = "C:\\drew\\newTestData\\person-simple2.token";
			commandLine[2] = "1.txt";
			commandLine[3] = "1";
			result = edu.wpi.cs.dsrg.xmldb.xat.testing.TestExecBaseLocal.main(commandLine);
			assertEquals(result, 1);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}//*/
	
}
