/*
 * Created on May 30, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.testing;

import java.util.HashSet;
import java.util.Set;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDagImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.ColumnNameNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.ColumnNameNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.RootNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.RootNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.TagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.TagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.TerminalExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnNameImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.SourceImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.TaggerImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NavigationStep;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NodeStepImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.VarStepImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.BinCOMPExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.DOMPatternImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.Pattern;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;

/**
 * @author suhong
 *
 * generate rainbow plans
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestCases {
	/*
		 * with wildcard
		 * 
		 * for $o in /open_auction_list/auction/bid, $b in $o/bidder
		 * where $o/ *\/phone = "508"
		 * return <result>$o, $b</result>
		 * tested: wildcard
		 * tested: occurrence number
		 */

	static public XATDag createPhysicalPlan3() {

		//source operator
		DagNode sourceNode = new DagNodeImp();
		XATOperator sourceOp =
			new SourceImp(sourceNode, "auction.xml", SourceImp.XML);
		sourceNode.setOperator(sourceOp);
		sourceOp.setOutputColumnName("$s");

		//navigate(source, open_auction_list/auction/bid->$o)/////////////////////////////////////////
		DagNode navNode1 = new DagNodeImp();

		NavigationStep[] navSteps0 = new NavigationStep[1];
		navSteps0[0] = new NodeStepImp("$s");
		NavigationStep[] navSteps1 = new NavigationStep[3];
		navSteps1[0] = new NodeStepImp("open_auction_list");
		navSteps1[1] = new NodeStepImp("auction");
		navSteps1[2] = new NodeStepImp("bid");

		XATOperator navOp1 = new NavUnnestImp(navNode1, navSteps0, navSteps1);
		navOp1.setOutputColumnName("$o");
		navNode1.setOperator(navOp1);

		navNode1.addChild(sourceNode);
		sourceNode.addParent(navNode1);

		//nav($o, /bidder->$b)
		DagNode navNode2 = new DagNodeImp();

		NavigationStep[] entry2 = new NavigationStep[1];
		entry2[0] = new VarStepImp("$o");
		NavigationStep[] navSteps2 = new NavigationStep[1];
		navSteps2[0] = new NodeStepImp("bidder");

		XATOperator navOp2 = new NavUnnestImp(navNode2, entry2, navSteps2);
		navOp2.setOutputColumnName("$b");
		navNode2.setOperator(navOp2);

		navNode2.addChild(navNode1);
		navNode1.addParent(navNode2);

		//navNest($b/*/name)//////////////////////////////////////////////////////////////////////
		DagNode navNode3 = new DagNodeImp();
		NavigationStep[] navSteps3 = new NavigationStep[1];
		NavigationStep[] navSteps4 = new NavigationStep[2];

		navSteps3[0] = new VarStepImp("$b");
		navSteps4[0] = new NodeStepImp(QueryGraphNode.WILDCARD);
		navSteps4[1] = new NodeStepImp("phone");

		XATOperator navOp3 =
			new NavCollectionImp(navNode3, navSteps3, navSteps4);
		navOp3.setOutputColumnName("$name");
		navNode3.setOperator(navOp3);

		navNode3.addChild(navNode2);
		navNode2.addParent(navNode3);

		//select $b = "abc"///////////////////////////////////////////////////////////////
		DagNode selectNode1 = new DagNodeImp();

		//create the expression for the predicate of the select of the operator
		ColumnName expressionColLeft = new ColumnNameImp("$name");
		TerminalExpressionImp eLeft =
			new TerminalExpressionImp(expressionColLeft);

		TerminalExpressionImp eRight = new TerminalExpressionImp("abc");
		BinCOMPExpression bin = new BinCOMPExpressionImp(eLeft, eRight);
		bin.setType(BinCOMPExpressionStr.EQ);

		Select selectOp1 = new SelectImp(selectNode1, bin);
		selectNode1.setOperator(selectOp1);

		selectNode1.addChild(navNode3);
		navNode3.addParent(selectNode1);

		//tagger
		DagNode taggerNode1 = new DagNodeImp();
		RootNode rootNodeForTag = new RootNodeImp();
		TagNode tag = new TagNodeImp("result");
		rootNodeForTag.addChild(tag);
		tag.setParent(rootNodeForTag);
		TagNode tag1 = new TagNodeImp("ouro");
		tag.addChild(tag1);
		tag1.setParent(tag);
		ColumnNameNode col1 = new ColumnNameNodeImp("$o");
		tag1.addChild(col1);
		col1.setParent(tag1);
		TagNode tag2 = new TagNodeImp("ourb");
		tag.addChild(tag2);
		ColumnNameNode col2 = new ColumnNameNodeImp("$b");
		tag2.addChild(col2);
		col2.setParent(tag2);
		Pattern pattern = new DOMPatternImp(rootNodeForTag);
		//Pattern pattern = new ListPatternImp(colNames);

		Tagger taggerOp = new TaggerImp(taggerNode1, pattern);
		taggerOp.setOutputColumnName("$final");
		taggerNode1.setOperator(taggerOp);

		taggerNode1.addChild(selectNode1);
		selectNode1.addParent(taggerNode1);

		//set up schema for each node
		Set schemaForSourceNode = new HashSet();
		schemaForSourceNode.add("$s");
		sourceNode.setSchema(schemaForSourceNode);

		Set schemaForNavNode1 = new HashSet();
		schemaForNavNode1.add("$o");
		navNode1.setSchema(schemaForNavNode1);

		Set schemaForNavNode2 = new HashSet();
		schemaForNavNode2.add("$o");
		schemaForNavNode2.add("$b");
		navNode2.setSchema(schemaForNavNode2);

		Set schemaForNavNode3 = new HashSet();
		schemaForNavNode3.add("$o");
		schemaForNavNode3.add("$b");
		schemaForNavNode3.add("$name");
		navNode3.setSchema(schemaForNavNode3);

		Set schemaForSelNode1 = new HashSet();
		schemaForSelNode1.add("$o");
		schemaForSelNode1.add("$b");
		selectNode1.setSchema(schemaForSelNode1);

		Set schemaForTaggerNode1 = new HashSet();
		schemaForTaggerNode1.add("$final");
		taggerNode1.setSchema(schemaForTaggerNode1);

		/*selectOp1.setInputQueue(
			((XATStreamOperator) extractOp2).getOutputQueue());
		//create the queueue schema
		Vector v = new Vector();
		v.add("name");
		XATQueueSchema queueSchema = new XATQueueSchema(v);
		selectOp1.getInputQueue().setSchema(queueSchema);*/

		//root is the upmost node, its is the parent of all nodes
		XATDag dag = new XATDagImp();
		dag.addRoot(taggerNode1);

		return dag;

	}

	/*
		 * for $o in /open_auction_list/auction/bid, $b in $o/bidder
		 * where $b/name = "abc"
		 * return <result>$o, $b</result>
		 * tested: propagation when bidder occurs within bid only once (works for both occurrence rule and exclusive rule)
		 * tested: exclusive rule when name is exclusive of name2
		 * 
		 */
	static public XATDag createPhysicalPlan4() {

		//source operator
		DagNode sourceNode = new DagNodeImp();
		XATOperator sourceOp =
			new SourceImp(sourceNode, "auction.xml", SourceImp.XML);
		sourceNode.setOperator(sourceOp);
		sourceOp.setOutputColumnName("$s");

		//navigate(source, open_auction_list/auction/bid->$o)/////////////////////////////////////////
		DagNode navNode1 = new DagNodeImp();

		NavigationStep[] navSteps0 = new NavigationStep[1];
		navSteps0[0] = new NodeStepImp("$s");
		NavigationStep[] navSteps1 = new NavigationStep[3];
		navSteps1[0] = new NodeStepImp("open_auction_list");
		navSteps1[1] = new NodeStepImp("auction");
		navSteps1[2] = new NodeStepImp("bid");

		XATOperator navOp1 = new NavUnnestImp(navNode1, navSteps0, navSteps1);
		navOp1.setOutputColumnName("$o");
		navNode1.setOperator(navOp1);

		navNode1.addChild(sourceNode);
		sourceNode.addParent(navNode1);

		//nav($o, /bidder->$b)
		DagNode navNode2 = new DagNodeImp();

		NavigationStep[] entry2 = new NavigationStep[1];
		entry2[0] = new VarStepImp("$o");
		NavigationStep[] navSteps2 = new NavigationStep[1];
		navSteps2[0] = new NodeStepImp("bidder");

		XATOperator navOp2 = new NavUnnestImp(navNode2, entry2, navSteps2);
		navOp2.setOutputColumnName("$b");
		navNode2.setOperator(navOp2);

		navNode2.addChild(navNode1);
		navNode1.addParent(navNode2);

		//navNest($b/*/name)//////////////////////////////////////////////////////////////////////
		DagNode navNode3 = new DagNodeImp();
		NavigationStep[] navSteps3 = new NavigationStep[1];
		NavigationStep[] navSteps4 = new NavigationStep[1];

		navSteps3[0] = new VarStepImp("$b");
		navSteps4[0] = new NodeStepImp("name");

		XATOperator navOp3 =
			new NavCollectionImp(navNode3, navSteps3, navSteps4);
		navOp3.setOutputColumnName("$name");
		navNode3.setOperator(navOp3);

		navNode3.addChild(navNode2);
		navNode2.addParent(navNode3);

		//select $b = "abc"///////////////////////////////////////////////////////////////
		DagNode selectNode1 = new DagNodeImp();

		//create the expression for the predicate of the select of the operator
		ColumnName expressionColLeft = new ColumnNameImp("$name");
		TerminalExpressionImp eLeft =
			new TerminalExpressionImp(expressionColLeft);

		TerminalExpressionImp eRight = new TerminalExpressionImp("abc");
		BinCOMPExpression bin = new BinCOMPExpressionImp(eLeft, eRight);
		bin.setType(BinCOMPExpressionStr.EQ);

		Select selectOp1 = new SelectImp(selectNode1, bin);
		selectNode1.setOperator(selectOp1);

		selectNode1.addChild(navNode3);
		navNode3.addParent(selectNode1);

		//tagger
		DagNode taggerNode1 = new DagNodeImp();
		RootNode rootNodeForTag = new RootNodeImp();
		TagNode tag = new TagNodeImp("result");
		rootNodeForTag.addChild(tag);
		tag.setParent(rootNodeForTag);
		TagNode tag1 = new TagNodeImp("ouro");
		tag.addChild(tag1);
		tag1.setParent(tag);
		ColumnNameNode col1 = new ColumnNameNodeImp("$o");
		tag1.addChild(col1);
		col1.setParent(tag1);
		TagNode tag2 = new TagNodeImp("ourb");
		tag.addChild(tag2);
		ColumnNameNode col2 = new ColumnNameNodeImp("$b");
		tag2.addChild(col2);
		col2.setParent(tag2);
		Pattern pattern = new DOMPatternImp(rootNodeForTag);
		//Pattern pattern = new ListPatternImp(colNames);

		Tagger taggerOp = new TaggerImp(taggerNode1, pattern);
		taggerOp.setOutputColumnName("$final");
		taggerNode1.setOperator(taggerOp);

		taggerNode1.addChild(selectNode1);
		selectNode1.addParent(taggerNode1);

		//set up schema for each node
		Set schemaForSourceNode = new HashSet();
		schemaForSourceNode.add("$s");
		sourceNode.setSchema(schemaForSourceNode);

		Set schemaForNavNode1 = new HashSet();
		schemaForNavNode1.add("$o");
		navNode1.setSchema(schemaForNavNode1);

		Set schemaForNavNode2 = new HashSet();
		schemaForNavNode2.add("$o");
		schemaForNavNode2.add("$b");
		navNode2.setSchema(schemaForNavNode2);

		Set schemaForNavNode3 = new HashSet();
		schemaForNavNode3.add("$o");
		schemaForNavNode3.add("$b");
		schemaForNavNode3.add("$name");
		navNode3.setSchema(schemaForNavNode3);

		Set schemaForSelNode1 = new HashSet();
		schemaForSelNode1.add("$o");
		schemaForSelNode1.add("$b");
		selectNode1.setSchema(schemaForSelNode1);

		Set schemaForTaggerNode1 = new HashSet();
		schemaForTaggerNode1.add("$final");
		taggerNode1.setSchema(schemaForTaggerNode1);

		/*selectOp1.setInputQueue(
			((XATStreamOperator) extractOp2).getOutputQueue());
		//create the queueue schema
		Vector v = new Vector();
		v.add("name");
		XATQueueSchema queueSchema = new XATQueueSchema(v);
		selectOp1.getInputQueue().setSchema(queueSchema);*/

		//root is the upmost node, its is the parent of all nodes
		XATDag dag = new XATDagImp();
		dag.addRoot(taggerNode1);

		return dag;

	}

	/*
	 * for $o in /open_auction_list/auction, $b in $o/seller, $c in $o/bid/bidder
	 * where $b/*\/phone = "508" and $c/sameAddr and $b/profile
	 * return <result>
	 *        $o, $b, $c
	 *        </result>
	 * tested: uncertainboundarypattern rule
	 */
	static public XATDag createPhysicalPlan5() {

		//source operator
		DagNode sourceNode = new DagNodeImp();
		XATOperator sourceOp =
			new SourceImp(sourceNode, "auction1.xml", SourceImp.XML);
		sourceNode.setOperator(sourceOp);
		sourceOp.setOutputColumnName("$s");

		//navigate(source, open_auction_list/auction/bid->$o)/////////////////////////////////////////
		DagNode navNode1 = new DagNodeImp();

		NavigationStep[] entry1 = new NavigationStep[1];
		entry1[0] = new NodeStepImp("$s");
		NavigationStep[] navSteps1 = new NavigationStep[2];
		navSteps1[0] = new NodeStepImp("open_auction_list");
		navSteps1[1] = new NodeStepImp("auction");

		XATOperator navOp1 = new NavUnnestImp(navNode1, entry1, navSteps1);
		navOp1.setOutputColumnName("$o");
		navNode1.setOperator(navOp1);

		navNode1.addChild(sourceNode);
		sourceNode.addParent(navNode1);

		//nav($o, /bidder->$b)
		DagNode navNode2 = new DagNodeImp();

		NavigationStep[] entry2 = new NavigationStep[1];
		entry2[0] = new VarStepImp("$o");
		NavigationStep[] navSteps2 = new NavigationStep[1];
		navSteps2[0] = new NodeStepImp("seller");

		XATOperator navOp2 = new NavUnnestImp(navNode2, entry2, navSteps2);
		navOp2.setOutputColumnName("$b");
		navNode2.setOperator(navOp2);

		navNode2.addChild(navNode1);
		navNode1.addParent(navNode2);

		//navNest($b/*/name)//////////////////////////////////////////////////////////////////////
		DagNode navNode3 = new DagNodeImp();
		NavigationStep[] entry3 = new NavigationStep[1];
		NavigationStep[] navSteps3 = new NavigationStep[2];

		entry3[0] = new VarStepImp("$b");
		navSteps3[0] = new NodeStepImp(QueryGraphNode.WILDCARD);
		navSteps3[1] = new NodeStepImp("phone");

		XATOperator navOp3 = new NavCollectionImp(navNode3, entry3, navSteps3);
		navOp3.setOutputColumnName("$phone");
		navNode3.setOperator(navOp3);

		navNode3.addChild(navNode2);
		navNode2.addParent(navNode3);

		//select $b = "abc"///////////////////////////////////////////////////////////////
		DagNode selectNode1 = new DagNodeImp();

		//create the expression for the predicate of the select of the operator
		ColumnName expressionColLeft1 = new ColumnNameImp("$phone");
		TerminalExpressionImp eLeft1 =
			new TerminalExpressionImp(expressionColLeft1);

		TerminalExpressionImp eRight1 = new TerminalExpressionImp("508");
		BinCOMPExpression bin1 = new BinCOMPExpressionImp(eLeft1, eRight1);
		bin1.setType(BinCOMPExpressionStr.EQ);

		Select selectOp1 = new SelectImp(selectNode1, bin1);
		selectNode1.setOperator(selectOp1);

		selectNode1.addChild(navNode3);
		navNode3.addParent(selectNode1);

		//navNest($b, /profile)
		DagNode navNode6 = new DagNodeImp();
		NavigationStep[] entry6 = new NavigationStep[1];
		NavigationStep[] navSteps6 = new NavigationStep[1];

		entry6[0] = new VarStepImp("$b");
		navSteps6[0] = new NodeStepImp("homepage");

		XATOperator navOp6 = new NavCollectionImp(navNode6, entry6, navSteps6);
		navOp6.setOutputColumnName("$homepage");
		navNode6.setOperator(navOp6);

		navNode6.addChild(selectNode1);
		selectNode1.addParent(navNode6);

		//		selection on $profile
		DagNode selectNode3 = new DagNodeImp();

		//create the expression for the predicate of the select of the operator
		ColumnName expressionColLeft3 = new ColumnNameImp("$homepage");
		TerminalExpressionImp eLeft3 =
			new TerminalExpressionImp(expressionColLeft3);

		TerminalExpressionImp eRight3 = new TerminalExpressionImp("");
		BinCOMPExpression bin3 = new BinCOMPExpressionImp(eLeft3, eRight3);
		bin3.setType(BinCOMPExpressionStr.NEQ);

		Select selectOp3 = new SelectImp(selectNode3, bin3);
		selectNode3.setOperator(selectOp3);

		selectNode3.addChild(navNode6);
		navNode6.addParent(selectNode3);

		//nav($o, /bid/bidder->$b)
		DagNode navNode4 = new DagNodeImp();

		NavigationStep[] entry4 = new NavigationStep[1];
		entry4[0] = new VarStepImp("$o");
		NavigationStep[] navSteps4 = new NavigationStep[2];
		navSteps4[0] = new NodeStepImp("bid");
		navSteps4[1] = new NodeStepImp("bidder");

		XATOperator navOp4 = new NavUnnestImp(navNode4, entry4, navSteps4);
		navOp4.setOutputColumnName("$c");
		navNode4.setOperator(navOp4);

		navNode4.addChild(selectNode3);
		selectNode3.addParent(navNode4);

		//nav($b/sameAddr)
		DagNode navNode5 = new DagNodeImp();

		NavigationStep[] entry5 = new NavigationStep[1];
		entry5[0] = new VarStepImp("$c");
		NavigationStep[] navSteps5 = new NavigationStep[1];
		navSteps5[0] = new NodeStepImp("sameAddr");

		XATOperator navOp5 = new NavCollectionImp(navNode5, entry5, navSteps5);
		navOp5.setOutputColumnName("$sameAddr");
		navNode5.setOperator(navOp5);

		navNode5.addChild(navNode4);
		navNode4.addParent(navNode5);

		//selection on $sameAddr
		DagNode selectNode2 = new DagNodeImp();

		//create the expression for the predicate of the select of the operator
		ColumnName expressionColLeft2 = new ColumnNameImp("$sameAddr");
		TerminalExpressionImp eLeft2 =
			new TerminalExpressionImp(expressionColLeft2);

		TerminalExpressionImp eRight2 = new TerminalExpressionImp("");
		BinCOMPExpression bin2 = new BinCOMPExpressionImp(eLeft2, eRight2);
		bin2.setType(BinCOMPExpressionStr.NEQ);

		Select selectOp2 = new SelectImp(selectNode2, bin2);
		selectNode2.setOperator(selectOp2);

		selectNode2.addChild(navNode5);
		navNode5.addParent(selectNode2);

		//tagger
		DagNode taggerNode1 = new DagNodeImp();
		RootNode rootNodeForTag = new RootNodeImp();
		TagNode tag = new TagNodeImp("result");
		rootNodeForTag.addChild(tag);
		tag.setParent(rootNodeForTag);
		TagNode tag1 = new TagNodeImp("ouro");
		tag.addChild(tag1);
		tag1.setParent(tag);
		ColumnNameNode col1 = new ColumnNameNodeImp("$o");
		tag1.addChild(col1);
		col1.setParent(tag1);
		TagNode tag2 = new TagNodeImp("ourb");
		tag.addChild(tag2);
		tag2.setParent(tag);
		ColumnNameNode col2 = new ColumnNameNodeImp("$b");
		tag2.addChild(col2);
		col2.setParent(tag2);
		TagNode tag3 = new TagNodeImp("ourc");
		tag.addChild(tag3);
		tag3.setParent(tag);
		ColumnNameNode col3 = new ColumnNameNodeImp("$c");
		tag3.addChild(col3);
		col3.setParent(tag3);
		Pattern pattern = new DOMPatternImp(rootNodeForTag);
		//Pattern pattern = new ListPatternImp(colNames);

		Tagger taggerOp = new TaggerImp(taggerNode1, pattern);
		taggerOp.setOutputColumnName("$final");
		taggerNode1.setOperator(taggerOp);

		taggerNode1.addChild(selectNode2);
		selectNode2.addParent(taggerNode1);

		//set up schema for each node
		Set schemaForSourceNode = new HashSet();
		schemaForSourceNode.add("$s");
		sourceNode.setSchema(schemaForSourceNode);

		Set schemaForNavNode1 = new HashSet();
		schemaForNavNode1.add("$o");
		navNode1.setSchema(schemaForNavNode1);

		Set schemaForNavNode2 = new HashSet();
		schemaForNavNode2.add("$o");
		schemaForNavNode2.add("$b");
		navNode2.setSchema(schemaForNavNode2);

		Set schemaForNavNode3 = new HashSet();
		schemaForNavNode3.add("$o");
		schemaForNavNode3.add("$b");
		schemaForNavNode3.add("$phone");
		navNode3.setSchema(schemaForNavNode3);

		Set schemaForNavNode4 = new HashSet();
		schemaForNavNode4.add("$o");
		schemaForNavNode4.add("$b");
		schemaForNavNode4.add("$c");
		navNode4.setSchema(schemaForNavNode4);

		Set schemaForNavNode5 = new HashSet();
		schemaForNavNode5.add("$o");
		schemaForNavNode5.add("$b");
		schemaForNavNode5.add("$c");
		schemaForNavNode5.add("$sameAddr");
		navNode5.setSchema(schemaForNavNode5);

		Set schemaForNavNode6 = new HashSet();
		schemaForNavNode6.add("$o");
		schemaForNavNode6.add("$b");
		schemaForNavNode6.add("$profile");
		navNode6.setSchema(schemaForNavNode6);

		Set schemaForSelNode1 = new HashSet();
		schemaForSelNode1.add("$o");
		schemaForSelNode1.add("$b");
		selectNode1.setSchema(schemaForSelNode1);

		Set schemaForSelNode2 = new HashSet();
		schemaForSelNode2.add("$o");
		schemaForSelNode2.add("$b");
		schemaForSelNode2.add("$c");
		selectNode2.setSchema(schemaForSelNode2);

		Set schemaForSelNode3 = new HashSet();
		schemaForSelNode3.add("$o");
		schemaForSelNode3.add("$b");
		schemaForSelNode3.add("$c");
		selectNode3.setSchema(schemaForSelNode3);

		Set schemaForTaggerNode1 = new HashSet();
		schemaForTaggerNode1.add("$final");
		taggerNode1.setSchema(schemaForTaggerNode1);

		/*selectOp1.setInputQueue(
			((XATStreamOperator) extractOp2).getOutputQueue());
		//create the queueue schema
		Vector v = new Vector();
		v.add("name");
		XATQueueSchema queueSchema = new XATQueueSchema(v);
		selectOp1.getInputQueue().setSchema(queueSchema);*/

		//root is the upmost node, its is the parent of all nodes
		XATDag dag = new XATDagImp();
		dag.addRoot(taggerNode1);

		return dag;

	}
	
	/*
		 * for $o in /open_auction_list/auction, $b in $o/seller, $c in $o/bid/bidder/sameAddr
		 * where $b/*\/phone = "508" and $b/sameAddr and $b/profile
		 * return <result>
		 *        $o, $b, $c
		 *        </result>
		 * tested: shipTo will not introduced for sameAddr
		 */
		static public XATDag createPhysicalPlan6() {

			//source operator
			DagNode sourceNode = new DagNodeImp();
			XATOperator sourceOp =
				new SourceImp(sourceNode, "auction1.xml", SourceImp.XML);
			sourceNode.setOperator(sourceOp);
			sourceOp.setOutputColumnName("$s");

			//navigate(source, open_auction_list/auction/bid->$o)/////////////////////////////////////////
			DagNode navNode1 = new DagNodeImp();

			NavigationStep[] entry1 = new NavigationStep[1];
			entry1[0] = new NodeStepImp("$s");
			NavigationStep[] navSteps1 = new NavigationStep[2];
			navSteps1[0] = new NodeStepImp("open_auction_list");
			navSteps1[1] = new NodeStepImp("auction");

			XATOperator navOp1 = new NavUnnestImp(navNode1, entry1, navSteps1);
			navOp1.setOutputColumnName("$o");
			navNode1.setOperator(navOp1);

			navNode1.addChild(sourceNode);
			sourceNode.addParent(navNode1);

			//nav($o, /bidder->$b)
			DagNode navNode2 = new DagNodeImp();

			NavigationStep[] entry2 = new NavigationStep[1];
			entry2[0] = new VarStepImp("$o");
			NavigationStep[] navSteps2 = new NavigationStep[1];
			navSteps2[0] = new NodeStepImp("seller");

			XATOperator navOp2 = new NavUnnestImp(navNode2, entry2, navSteps2);
			navOp2.setOutputColumnName("$b");
			navNode2.setOperator(navOp2);

			navNode2.addChild(navNode1);
			navNode1.addParent(navNode2);

			//navNest($b/*/name)//////////////////////////////////////////////////////////////////////
			DagNode navNode3 = new DagNodeImp();
			NavigationStep[] entry3 = new NavigationStep[1];
			NavigationStep[] navSteps3 = new NavigationStep[2];

			entry3[0] = new VarStepImp("$b");
			navSteps3[0] = new NodeStepImp(QueryGraphNode.WILDCARD);
			navSteps3[1] = new NodeStepImp("phone");

			XATOperator navOp3 = new NavCollectionImp(navNode3, entry3, navSteps3);
			navOp3.setOutputColumnName("$phone");
			navNode3.setOperator(navOp3);

			navNode3.addChild(navNode2);
			navNode2.addParent(navNode3);

			//select $b = "abc"///////////////////////////////////////////////////////////////
			DagNode selectNode1 = new DagNodeImp();

			//create the expression for the predicate of the select of the operator
			ColumnName expressionColLeft1 = new ColumnNameImp("$phone");
			TerminalExpressionImp eLeft1 =
				new TerminalExpressionImp(expressionColLeft1);

			TerminalExpressionImp eRight1 = new TerminalExpressionImp("508");
			BinCOMPExpression bin1 = new BinCOMPExpressionImp(eLeft1, eRight1);
			bin1.setType(BinCOMPExpressionStr.EQ);

			Select selectOp1 = new SelectImp(selectNode1, bin1);
			selectNode1.setOperator(selectOp1);

			selectNode1.addChild(navNode3);
			navNode3.addParent(selectNode1);

			//navNest($b, /profile)
			DagNode navNode6 = new DagNodeImp();
			NavigationStep[] entry6 = new NavigationStep[1];
			NavigationStep[] navSteps6 = new NavigationStep[1];

			entry6[0] = new VarStepImp("$b");
			navSteps6[0] = new NodeStepImp("homepage");

			XATOperator navOp6 = new NavCollectionImp(navNode6, entry6, navSteps6);
			navOp6.setOutputColumnName("$homepage");
			navNode6.setOperator(navOp6);

			navNode6.addChild(selectNode1);
			selectNode1.addParent(navNode6);

			//		selection on $profile
			DagNode selectNode3 = new DagNodeImp();

			//create the expression for the predicate of the select of the operator
			ColumnName expressionColLeft3 = new ColumnNameImp("$homepage");
			TerminalExpressionImp eLeft3 =
				new TerminalExpressionImp(expressionColLeft3);

			TerminalExpressionImp eRight3 = new TerminalExpressionImp("");
			BinCOMPExpression bin3 = new BinCOMPExpressionImp(eLeft3, eRight3);
			bin3.setType(BinCOMPExpressionStr.NEQ);

			Select selectOp3 = new SelectImp(selectNode3, bin3);
			selectNode3.setOperator(selectOp3);

			selectNode3.addChild(navNode6);
			navNode6.addParent(selectNode3);

			//nav($o, /bid/bidder->$b)
			DagNode navNode4 = new DagNodeImp();

			NavigationStep[] entry4 = new NavigationStep[1];
			entry4[0] = new VarStepImp("$o");
			NavigationStep[] navSteps4 = new NavigationStep[2];
			navSteps4[0] = new NodeStepImp("bid");
			navSteps4[1] = new NodeStepImp("bidder");

			XATOperator navOp4 = new NavUnnestImp(navNode4, entry4, navSteps4);
			navOp4.setOutputColumnName("$c");
			navNode4.setOperator(navOp4);

			navNode4.addChild(selectNode3);
			selectNode3.addParent(navNode4);

			//nav($b/sameAddr)
			DagNode navNode5 = new DagNodeImp();

			NavigationStep[] entry5 = new NavigationStep[1];
			entry5[0] = new VarStepImp("$b");
			NavigationStep[] navSteps5 = new NavigationStep[1];
			navSteps5[0] = new NodeStepImp("sameAddr");

			XATOperator navOp5 = new NavCollectionImp(navNode5, entry5, navSteps5);
			navOp5.setOutputColumnName("$sameAddr");
			navNode5.setOperator(navOp5);

			navNode5.addChild(navNode4);
			navNode4.addParent(navNode5);

			//selection on $sameAddr
			DagNode selectNode2 = new DagNodeImp();

			//create the expression for the predicate of the select of the operator
			ColumnName expressionColLeft2 = new ColumnNameImp("$sameAddr");
			TerminalExpressionImp eLeft2 =
				new TerminalExpressionImp(expressionColLeft2);

			TerminalExpressionImp eRight2 = new TerminalExpressionImp("");
			BinCOMPExpression bin2 = new BinCOMPExpressionImp(eLeft2, eRight2);
			bin2.setType(BinCOMPExpressionStr.NEQ);

			Select selectOp2 = new SelectImp(selectNode2, bin2);
			selectNode2.setOperator(selectOp2);

			selectNode2.addChild(navNode5);
			navNode5.addParent(selectNode2);

			//tagger
			DagNode taggerNode1 = new DagNodeImp();
			RootNode rootNodeForTag = new RootNodeImp();
			TagNode tag = new TagNodeImp("result");
			rootNodeForTag.addChild(tag);
			tag.setParent(rootNodeForTag);
			TagNode tag1 = new TagNodeImp("ouro");
			tag.addChild(tag1);
			tag1.setParent(tag);
			ColumnNameNode col1 = new ColumnNameNodeImp("$o");
			tag1.addChild(col1);
			col1.setParent(tag1);
			TagNode tag2 = new TagNodeImp("ourb");
			tag.addChild(tag2);
			tag2.setParent(tag);
			ColumnNameNode col2 = new ColumnNameNodeImp("$b");
			tag2.addChild(col2);
			col2.setParent(tag2);
			TagNode tag3 = new TagNodeImp("ourc");
			tag.addChild(tag3);
			tag3.setParent(tag);
			ColumnNameNode col3 = new ColumnNameNodeImp("$c");
			tag3.addChild(col3);
			col3.setParent(tag3);
			Pattern pattern = new DOMPatternImp(rootNodeForTag);
			//Pattern pattern = new ListPatternImp(colNames);

			Tagger taggerOp = new TaggerImp(taggerNode1, pattern);
			taggerOp.setOutputColumnName("$final");
			taggerNode1.setOperator(taggerOp);

			taggerNode1.addChild(selectNode2);
			selectNode2.addParent(taggerNode1);

			//set up schema for each node
			Set schemaForSourceNode = new HashSet();
			schemaForSourceNode.add("$s");
			sourceNode.setSchema(schemaForSourceNode);

			Set schemaForNavNode1 = new HashSet();
			schemaForNavNode1.add("$o");
			navNode1.setSchema(schemaForNavNode1);

			Set schemaForNavNode2 = new HashSet();
			schemaForNavNode2.add("$o");
			schemaForNavNode2.add("$b");
			navNode2.setSchema(schemaForNavNode2);

			Set schemaForNavNode3 = new HashSet();
			schemaForNavNode3.add("$o");
			schemaForNavNode3.add("$b");
			schemaForNavNode3.add("$phone");
			navNode3.setSchema(schemaForNavNode3);

			Set schemaForNavNode4 = new HashSet();
			schemaForNavNode4.add("$o");
			schemaForNavNode4.add("$b");
			schemaForNavNode4.add("$c");
			navNode4.setSchema(schemaForNavNode4);

			Set schemaForNavNode5 = new HashSet();
			schemaForNavNode5.add("$o");
			schemaForNavNode5.add("$b");
			schemaForNavNode5.add("$sameAddr");
			navNode5.setSchema(schemaForNavNode5);

			Set schemaForNavNode6 = new HashSet();
			schemaForNavNode6.add("$o");
			schemaForNavNode6.add("$b");
			schemaForNavNode6.add("$profile");
			navNode6.setSchema(schemaForNavNode6);

			Set schemaForSelNode1 = new HashSet();
			schemaForSelNode1.add("$o");
			schemaForSelNode1.add("$b");
			selectNode1.setSchema(schemaForSelNode1);

			Set schemaForSelNode2 = new HashSet();
			schemaForSelNode2.add("$o");
			schemaForSelNode2.add("$b");
			schemaForSelNode2.add("$c");
			selectNode2.setSchema(schemaForSelNode2);

			Set schemaForSelNode3 = new HashSet();
			schemaForSelNode3.add("$o");
			schemaForSelNode3.add("$b");
			schemaForSelNode3.add("$c");
			selectNode3.setSchema(schemaForSelNode3);

			Set schemaForTaggerNode1 = new HashSet();
			schemaForTaggerNode1.add("$final");
			taggerNode1.setSchema(schemaForTaggerNode1);

			/*selectOp1.setInputQueue(
				((XATStreamOperator) extractOp2).getOutputQueue());
			//create the queueue schema
			Vector v = new Vector();
			v.add("name");
			XATQueueSchema queueSchema = new XATQueueSchema(v);
			selectOp1.getInputQueue().setSchema(queueSchema);*/

			//root is the upmost node, its is the parent of all nodes
			XATDag dag = new XATDagImp();
			dag.addRoot(taggerNode1);

			return dag;
		}

}
