/*
 * Created on Sep 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.testing;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeperMgr;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.FindOpVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.BottomUpPipelineScheduler;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AutoDistiller;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestMapping extends TestRuleApplierOptLocal {
	public static void main(java.lang.String[] args)
			throws FileNotFoundException {

		int repeatingTimes = 5;

		String schemaFileName = null;
		String queryFileName = null;
		int xmlFileNum = 0;
		String[] xmlFileNames;
		String outputFileName = null;
		String planOutputFileName = null;
		int inAutoNavNum = 1;
		int inAutoSelNum = 0;

		boolean applyOccur = true;
		boolean applyExclusive = true;
		boolean applyUncertain = true;
		boolean noRedundant = false;
		boolean deleteOutlier = true;

		try {
			schemaFileName = args[0];
			queryFileName = args[1];
			xmlFileNum = Integer.parseInt(args[2]);
			xmlFileNames = new String[xmlFileNum];
			for (int i = 0; i < xmlFileNum; i++)
				xmlFileNames[i] = args[3 + i];
			outputFileName = args[3 + xmlFileNum];
			repeatingTimes = Integer.parseInt(args[4 + xmlFileNum]);
			if (Integer.parseInt(args[5 + xmlFileNum]) == 0)
				applyOccur = false;
			if (Integer.parseInt(args[6 + xmlFileNum]) == 0)
				applyExclusive = false;
			if (Integer.parseInt(args[7 + xmlFileNum]) == 0)
				applyUncertain = false;
			if (Integer.parseInt(args[8 + xmlFileNum]) == 0)
				noRedundant = false;
			if (Integer.parseInt(args[9 + xmlFileNum]) == 0)
				deleteOutlier = false;
			planOutputFileName = args[10 + xmlFileNum];

		} catch (Exception e) {
			System.out.println("usuage:");
			System.out
					.println("TestRuleApplierOpt -schemaFile -queryFile -tokenFileNum -sequence of tokenFile Name -outputFile -repeatingTime  -applyOccur -applyExclusive -applyUncertain -noredundant");
			return;
		}

		//generate rainbow plan
		XATDag rainbowDag = UtilForTesting.genRainbowPlan(queryFileName);

		int[] mappings = {
		//correct
				//AutoDistiller.MAPPING_ALLBINDING,

				//correct
				AutoDistiller.MAPPING_NAVONLY,
				//correct
				AutoDistiller.MAPPING_MAX,
		//AutoDistiller.MAPPING_NAVWITHSELONLY,
		//AutoDistiller.MAPPING_SELPARTIALIN,
		//correct (not for now)
		//AutoDistiller.MAPPING_SOURCE
		};

		System.setProperty("DATA_MODEL", "XATMemoryQueueImp");

		BufferedWriter out = null;
		BufferedWriter out2 = null;

		try {
			out = new BufferedWriter(new FileWriter(outputFileName));
			out2 = new BufferedWriter(new FileWriter(planOutputFileName));

			int selNum = FindOpVisitor.numOfSels(rainbowDag);

			int navNum = FindOpVisitor.numOfNavs(rainbowDag);

			for (int j = 0; j < mappings.length; j++) {

				if (mappings[j] == AutoDistiller.MAPPING_NAVONLY
						|| mappings[j] == AutoDistiller.MAPPING_NAVWITHSELONLY
						|| mappings[j] == AutoDistiller.MAPPING_SELPARTIALIN) {
					inAutoNavNum = navNum;
					//inAutoNavNum = 4;

					if (mappings[j] == AutoDistiller.MAPPING_NAVWITHSELONLY
							|| mappings[j] == AutoDistiller.MAPPING_SELPARTIALIN)
						inAutoSelNum = selNum;

				} else {
					//for the other mapping strategies, the two paras do not
					// matter
					inAutoNavNum = 1;
					inAutoSelNum = 0;
				}

				for (int k = 0; k < xmlFileNum; k++) {

					//test on each test data set
					String xmlFileName = xmlFileNames[k];
					//String xmlFileName = xmlFileNames[0];

					//			initialize the header
					//out.write("data set " + k + "\n");

					//out.write("timestamp:" + 10 * k);

					//out.write("\n");

					if (k == 0) {
						//the first one
						//need to have the column info
						out.write("plan ");
						out.write("execution time ");
						out.write("\n");
					}

					//for (int l = 1; l <= inAutoNavNum; l++)
					for (int l = 1; l <= inAutoNavNum; l++) {
						if (l != 1 && l != 4 && l!= inAutoNavNum)
							continue;
						//for (int l = 5; l <= 5; l++)
						for (int m = 0; m <= inAutoSelNum; m++) {

							//begin of generate raindrop plan

							System.out.println("l = " + l + " m=" + m);

							XATDag rainbowDagCopy = (XATDag) rainbowDag.clone();
							XATDag phyDag = UtilForTesting.genPhyXATDag(
									rainbowDagCopy, mappings[j], l, m);

							out2.write("l=" + l + " m=" + m);
							out2.write("\n");
							out2.write(phyDag.toString());

							//end of generate raindrop plan

							//							maintain the running time of each run
							List timeKeeperMgrs = new ArrayList();
							int outputNum = 0;

							for (int i = 0; i < repeatingTimes; i++) {

								XATDag phyDagCopy = (XATDag) phyDag.clone();

								BottomUpPipelineScheduler scheduler = new BottomUpPipelineScheduler();

								scheduler.setPlanDag(phyDagCopy);

								//set data driven must be before setupAuto
								//need the info of invoking to decide whether
								//a node is to be added into group by set
								//when an end tag is encountered

								UtilForTesting.setDataDriven(phyDagCopy);
								UtilForTesting.setUpAuto(phyDagCopy);

								//begin execution
								System.out.println(i + "th run...");

								//	for (int i = 0; i < repeatingTimes; i++) {

								//UtilForTesting.setDataDriven(phyDagCopy);
								//UtilForTesting.setUpAuto(phyDagCopy);

								//set up time keeper must be put after set up
								// auto
								//relies on token handler
								ClassExecTimeKeeperMgr keeperMgrForEachRun = UtilForTesting
										.setUpTimeKeepers(phyDagCopy);

								timeKeeperMgrs.add(keeperMgrForEachRun);

								outputNum = UtilForTesting.executeSocket(
										scheduler, phyDagCopy, 1);
								System.gc();
							}

							UtilForTesting.statisticsTimeForPlotting(j, l,
									m, out, timeKeeperMgrs, outputNum,
									deleteOutlier);

							out.write("\n");

							//} //end of SQO or not

						} //end of different nav and sel

					} //end of different test data
				}

			} //end of each strategy
			out.flush();
			out.close();
			out2.flush();
			out2.close();

		} catch (Exception e) {
			e.printStackTrace();
		}

		System.out.println("finished");

	}

}