/*
 * Created on Feb 21, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.testing;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.utils.DeepCopyMaker;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeperMgr;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.BottomUpPipelineScheduler;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.Automata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AutoDistiller;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.RuntimeOptUtil;
import edu.wpi.cs.dsrg.xmldb.xat.component.statistics.StatisticsCollector;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestOneTimeWithSta {

	public static void main(java.lang.String[] args) throws Exception {

		String queryFileName = null;
		String xmlFileName = null;
		String outputFileName = null;
		int repeatingTimes = 1;
		//when to collect statistsics, until the number of destination element
		//node of the bottommost tokenNav operator is reached
		int desiredDestCount = 0;
		double threshold = 0;

		if (args.length == 1) {
			queryFileName = args[0];
		} else if (args.length == 3) {
			queryFileName = args[0];
			outputFileName = args[1];
			repeatingTimes = Integer.parseInt(args[2]);

		} else if (args.length == 4) {
			queryFileName = args[0];
			outputFileName = args[1];
			desiredDestCount = Integer.parseInt(args[2]);
			repeatingTimes = Integer.parseInt(args[3]);
		} else if (args.length == 5){
			queryFileName = args[0];
			outputFileName = args[1];
			desiredDestCount = Integer.parseInt(args[2]);
			repeatingTimes = Integer.parseInt(args[3]);
			threshold = Double.parseDouble(args[4]);
			
		}else{
			System.out
					.println("usage: -queryFileName -outputFileName -desiredDestCount, -repeatingTimes");
			return;
		}

		//	generate rainbow plan
		XATDag rainbowDag = UtilForTesting.genRainbowPlan(queryFileName);
		XATDag phyDag = UtilForTesting.genPhyXATDag(rainbowDag,
				AutoDistiller.MAPPING_MAX, 0, 0);

		UtilForTesting.setDataDriven(phyDag);
		Automata auto = UtilForTesting.setUpAuto(phyDag, threshold);
		System.out.println("base one:");
		DagTraversal.printDag(phyDag);

		int outputNum = 0;

		BufferedWriter out = new BufferedWriter(new FileWriter(outputFileName));
		//		maintain the running time of each run
		List timeKeeperMgrs = new ArrayList();

		for (int i = 0; i < repeatingTimes; i++) {
			
			StatisticsCollector.resumeFirstTimeCollect();

			Automata autoCopy = (Automata) DeepCopyMaker.makeDeepCopy(auto);
			XATDag phyDagCopy = autoCopy.getPlan();

			autoCopy.reset();

			BottomUpPipelineScheduler scheduler = new BottomUpPipelineScheduler();

			scheduler.setPlanDag(phyDagCopy);

			//set data driven must be before setupAuto
			//need the info of invoking to decide whether
			//a node is to be added into group by set
			//when an end tag is encountered

			UtilForTesting.setDataDriven(phyDagCopy);

			RuntimeOptUtil.initialize(phyDagCopy);

			ClassExecTimeKeeperMgr keeperMgrForEachRun = UtilForTesting
					.setUpTimeKeepers(phyDagCopy);

			timeKeeperMgrs.add(keeperMgrForEachRun);

			outputNum = UtilForTesting.executeSocket(scheduler, phyDagCopy,
					desiredDestCount);

			System.out.println("finished " + i + "th try");
			System.gc();
		}

		UtilForTesting.statisticsTimeForPlotting(AutoDistiller.MAPPING_MAX, 1,
				0, out, timeKeeperMgrs, outputNum, true);

		out.flush();
		out.close();

		System.out.println("finished");
	}

}