/*
 * Created on Feb 24, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.wpi.cs.dsrg.xmldb.xat.testing;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeperMgr;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.schedulemode
	.BottomUpPipelineScheduler;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphInitiator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryNodeTypeInference;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraph;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.SchemaGraphInitiator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.rules.RuleApplier;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;

/**
 * @author suhong
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestRuleApplierOpt {

	public static void main(java.lang.String[] args)
		throws FileNotFoundException {

		int repeatingTimes = 5;

		String schemaFileName = null;
		String queryFileName = null;
		String xmlFileName = null;
		String outputFileName = null;
		boolean applyOccur = true;
		boolean applyExclusive = true;
		boolean applyUncertain = true;
		boolean noRedundant = true;
		
		boolean deleteOutlier = true;

		if (args.length == 5) {
			schemaFileName = args[0];
			queryFileName = args[1];
			xmlFileName = args[2];
			outputFileName = args[3];
			repeatingTimes = Integer.parseInt(args[4]);
		} else if (args.length == 9) {
			schemaFileName = args[0];
			queryFileName = args[1];
			xmlFileName = args[2];
			outputFileName = args[3];
			repeatingTimes = Integer.parseInt(args[4]);
			if (Integer.parseInt(args[5]) == 0)
				applyOccur = false;
			if (Integer.parseInt(args[6]) == 0)
				applyExclusive = false;
			if (Integer.parseInt(args[7]) == 0)
				applyUncertain = false;
			if (Integer.parseInt(args[8]) == 0)
				noRedundant = false;

		} else {
			System.out.println("usuage:");
			System.out.println(
				"TestRuleApplierOpt -schemaFile -queryFile -tokenFile -outputFile -repeatingTime -applyOccur -applyExclusive -applyUncertain -noredundant");
			return;
		}

		XATDag phyDag = UtilForTesting.genPhyXATDag(queryFileName);
		//XATDag phyDag = UtilForTesting.genPhyXATDagManual();
		UtilForTesting.setDataDriven(phyDag);
		UtilForTesting.setUpAuto(phyDag);
		
		QueryGraphInitiator qgi = new QueryGraphInitiator();
		SchemaGraphInitiator sgi = new SchemaGraphInitiator();
		

		//initiate
		qgi.setSchemaSourceName(schemaFileName);  
		QueryGraph[] qgs = qgi.construct(phyDag);
		SchemaGraph sg =SchemaGraphInitiator.constructSchemaGraph(qgi,schemaFileName);    

		List matchings = QueryNodeTypeInference.typeInference(qgs[0], sg);
		System.out.println("query graph after normalization: \n" + qgs[0]);

		RuleApplier applier =
			new RuleApplier(
				sg,
				qgs[0],
				applyOccur,
				applyExclusive,
				applyUncertain);
		applier.applyOnGraph(qgs[0], noRedundant);
		//System.out.println("final plan after SQO:");
		//System.out.println(qgs[0]);

		//UtilForTesting.setUpAuto(phyDag);
		System.out.println("optimized one:");
		DagTraversal.printDag(phyDag);
		
		//UtilForTesting.setUpCleanOps();   

		System.out.println("begin execution...");

		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new FileWriter(outputFileName));
		} catch (Exception e) {
			e.printStackTrace();
		}

		BottomUpPipelineScheduler scheduler =
			new BottomUpPipelineScheduler(phyDag);

		int outputNum = 0;
        
		List timeKeeperMgrs = new ArrayList();
		
		for (int i = 0; i < repeatingTimes; i++) {
			XATDag phyDagCopy = (XATDag)phyDag.clone();
			ClassExecTimeKeeperMgr keeperMgrForEachRun = UtilForTesting
			.setUpTimeKeepers(phyDagCopy);
			timeKeeperMgrs.add(keeperMgrForEachRun);
			outputNum =  UtilForTesting.executeSocket(
					scheduler, phyDagCopy, 1);;
			System.gc();
			
		}

		UtilForTesting.statisticsTimeForPlotting(0, 0, 0,
				 out, timeKeeperMgrs, outputNum,
				deleteOutlier);

		try {
			out.flush();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

		/*BottomUpPipelineScheduler scheduler =
			new BottomUpPipelineScheduler(phyDag);
		
		//set up input first,
		FileInputStream fis = new FileInputStream(xmlFileName);
		BufferedInputStream bis = new BufferedInputStream(fis, 1000000);
		
		//BufferedInputStream bis =
		//	new BufferedInputStream(socket.getInputStream());
		
		//ObjectInputStream ois = new ObjectInputStream(bis);
		// sourceOps[m].setInputTokenQueue(tokenQueue);
		//sourceOps[0].setP(ois);
		XMLScanStream sourceOp =
			(XMLScanStream) phyDag.getLeaves()[0].getOperator();
		
		sourceOp.setB(bis);
		//sourceOps[0].setIs(socket.getInputStream());
		// sourceOps[m].setQueueCapacity(1000000);
		
		// TokenBuffer tokenBuffer = new TokenBuffer(1000000);
		// sourceOps[0].setTokenBuffer(tokenBuffer);
		scheduler.scheduling();
		
		Vector v = DagTraversal.dagBottomUpTraverse(phyDag);
		XATStreamOperator op =
			(XATStreamOperator) (((DagNode) v.get(v.size() - 1)).getOperator());
		int outputNum = ((TaggerStream) op).getOutputCount();
		System.out.println(outputNum + " tuples");
		((TaggerStream) op).setOutputCount(0);
		//clear the output queue to save memory
		op.getOutputQueue().removeAllTuples();
		
		//recordTimes();
		
		System.out.println("finished");
		*/
		System.out.println("finished");
	}

}
