/*
 * Created on Feb 15, 2004 
 *
 * This class includes general utilities from query->rainbow plan->raindrop logical plan->raindrop physical plan->raindrop execution plan
 * 
 */
package edu.wpi.cs.dsrg.xmldb.xat.testing;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import xacute.quilt.QuiltParser;
import xacute.quilt.QuiltQuery;
import edu.wpi.cs.dsrg.utils.BindingTable;
import edu.wpi.cs.dsrg.utils.Debugger;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeper;
import edu.wpi.cs.dsrg.xmldb.xat.automata.utils.ClassExecTimeKeeperMgr;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.schedulemode.BottomUpPipelineScheduler;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.sqloperator.InTimeSJStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAutoStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.TaggerStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.TokenHandler;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.XMLScanStream;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollection;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.OuterNavCollectionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataSource;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.Automata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.ExtendedAutomata;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.common.XATStreamOpRunCore;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AutoCreaterFrPlan;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RaindropPhysicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RuleBaseRaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator.AutoMegaOperator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.storemanager.Finer_StreamStoreMgr;
import edu.wpi.cs.dsrg.xmldb.xat.component.automatainout.PlanManipulator;
import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.xml.CharSenders;
import edu.wpi.cs.dsrg.xmldb.xat.component.schemacleanup.SchemaCleanupVisitor;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.common.dag.ReWriteRules;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.common.dag.ReWriteTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.common.dag.XATCleanUp;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.ParserTraverse;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.QueryDecorrelation;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;
import edu.wpi.cs.dsrg.xmldb.xat.testfiles.TestSXE;

/**
 * @author suhong
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class UtilForTesting {

	static Finer_StreamStoreMgr storeMgr;

	/*
	 * @param keeperMgrs List a list of time keeper managers each of which
	 * corresponds to each run @param repeatingTimes int run this many times
	 * @param outputNum the number of output tuples
	 */

	/*
	 * static public void statisticsTime( List keeperMgrs, int outputNum) {
	 * //also print the execution time of the operators we care about List
	 * timeKeepers = ClassExecTimeKeeperMgr.getTimeKeepers(); int timeKeeperSize =
	 * timeKeepers.size();
	 * 
	 * //store the names of the classes to be evaluated String[] classNames =
	 * new String[timeKeeperSize]; //store the average execution time of each
	 * above class long[] executionTimes = new long[timeKeeperSize];
	 * 
	 * try {
	 * 
	 * for (int i = 0; i < timeKeeperSize; i++) { ClassExecTimeKeeper timeKeeper =
	 * (ClassExecTimeKeeper) timeKeepers.get(i);
	 * 
	 * if (timeKeeper.getMethodDesc() == null) {
	 */
	/*
	 * String fullClassName =
	 * timeKeeper.getEvaluatedClass().getClass().getName();
	 * 
	 * //find the partial class name int length = fullClassName.length(); for
	 * (int j = length - 1; j >= 0; j--) { if (fullClassName.charAt(j) == '.') {
	 * classNames[i] = fullClassName.substring(j + 1, length); if
	 * (classNames[i].equals("BottomUpPipelineScheduler")) classNames[i] =
	 * "Overall"; break; } }
	 */
	/*
	 * String className = timeKeeper.getEvaluatedClass().toString();
	 * classNames[i] = className; } else classNames[i] =
	 * timeKeeper.getMethodDesc();
	 * 
	 * out.write(classNames[i] + ",");
	 * 
	 * //out.write("storeMgr size" + ","); }
	 * 
	 * out.write("output num" + ",");
	 * 
	 * out.write("\n");
	 * 
	 * //out.write(", ,"); for (int j = 0; j < repeatingTimes; j++) { for (int i =
	 * 0; i < timeKeeperSize; i++) { ClassExecTimeKeeper timeKeeper =
	 * (ClassExecTimeKeeper) timeKeepers.get(i);
	 * 
	 * //store classname //or if the class has more than one time keeper, store
	 * the methodname
	 * 
	 * List times = timeKeeper.getAllFrozenTimes();
	 * 
	 * out.write(times.get(j) + ","); } //end of for int i
	 * 
	 * //out.write(storeMgrSize + ","); out.write(outputNum + ",");
	 * 
	 * out.write("\n"); } //end of for int j } catch (Exception e) {
	 * e.printStackTrace(); }
	 * 
	 * //clear up the timekeepers for this mapping mode
	 * ClassExecTimeKeeperMgr.clearUpMgr(); }
	 */

	/*
	 * store the average execution time in run (repeatingTimes) under data set
	 * fileId this makes statistics for one plan for one data set
	 */
	static public void statisticsTimeForPlotting(int mappingStrategy,
			int inAutoNavNum, int inAutoSelNum, BufferedWriter out,
			List timeKeeperMgrs, int outputNum, boolean deleteOutlier) {

		try {

			ClassExecTimeKeeperMgr firstMgr = (ClassExecTimeKeeperMgr) timeKeeperMgrs
					.get(0);

			//find out the position of the overall execution time

			for (int i = 0; i < firstMgr.getTimeKeepers().size(); i++) {
				ClassExecTimeKeeper keeper = (ClassExecTimeKeeper) firstMgr
						.getTimeKeepers().get(i);

				if (keeper.getEvaluatedClass().toString().indexOf(
						"TokenHandler") != -1
						|| (keeper.getMethodDesc() != null && (keeper
								.getMethodDesc().toString().equals("reasoning")
								|| keeper.getMethodDesc().toString().equals(
										"sta") || keeper.getMethodDesc()
								.toString().equals("migrate"))))
					out.write(keeper.getMethodDesc() + ",");
				else if (keeper.getMethodDesc() != null
						&& (keeper.getMethodDesc().toString().equals(
								"datadrivencontext")
								|| keeper.getMethodDesc().toString().equals(
										"demanddrivencontext") || keeper
								.getMethodDesc().toString().equals(
										"partitioncontext")))
					out.write(keeper.getMethodDesc() + ",");
				else
					out.write(keeper.getEvaluatedClass() + ",");

			}

			out.write("\n");

			//time of this many items is recorded during one run
			int itemNum = firstMgr.getTimeKeepers().size();

			//calculate the average execution time of each item

			long[] executionTimeSum = new long[itemNum];
			long[] max = new long[itemNum];

			for (Iterator it = timeKeeperMgrs.iterator(); it.hasNext();) {
				//iterate over result of each run
				ClassExecTimeKeeperMgr keeperMgr = (ClassExecTimeKeeperMgr) it
						.next();
				for (int i = 0; i < itemNum; i++) {
					//check ith computation's execution time
					ClassExecTimeKeeper timeKeeper = (ClassExecTimeKeeper) keeperMgr
					.getTimeKeepers().get(i);
					long currentTime = timeKeeper.getTime();
					executionTimeSum[i] = executionTimeSum[i] + currentTime;
					if (currentTime > max[i])
						max[i] = currentTime;

					if (currentTime > 0) {
						System.out.print(currentTime + " ");
						/*
						 * System.out.println("count="+((ClassExecTimeKeeper)
						 * keeperMgr .getTimeKeepers() .get(i)).count);
						 */
					}					
					
				}
			}

			//for each computation that has time recorded
			for (int i = 0; i < itemNum; i++) {
				if (!deleteOutlier)
					out
							.write(executionTimeSum[i] / timeKeeperMgrs.size()
									+ ",");
				else
					out.write((executionTimeSum[i] - max[i])
							/ (timeKeeperMgrs.size() - 1) + ",");
			}

			out.write(outputNum + ",");

			out.write("\n");

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	static long storeMgrSize = 0;

	public static ExtendedAutomata[] autos;

	static String readQuery(String file) {
		StringBuffer buf = null;
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(
					new FileInputStream(file)));
			buf = new StringBuffer();
			String s;
			while ((s = in.readLine()) != null)
				buf.append(s + "\n");
			in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return buf.toString();
	}

	/*
	 * use Ling's test XSE given a user query, create a XATTree out of it @param
	 * userQuery String the user's query @return XATTree the XAT tree generated
	 */
	static public XATTree makeXATNew(String userQuery) {
		//		step 1: generate the user tree
		XATTree userTree = null;
		userTree = TestSXE.treeGeneration(userQuery, userTree);

		//step 2: decorrelate the user tree, if prompted
		System.out.println("decor:");
		userTree = TestSXE.treeDecorrelation(userTree);

		//step 4: rewrite the tree
		System.out.println("rewrite");
		userTree = TestSXE.treeRewrite(userTree);

		//step 5: compute schema
		//System.out.println("schema");
		userTree = TestSXE.treeSchema(userTree);

		//userTree = TestSXE.treeCut(userTree);

		return userTree;

	}

	/*
	 * old version before new version of decor
	 * 
	 * @deprecated
	 */
	static public XATTree makeXAT(String xquery) {

		XATTree xattree = null;

		try {
			/////////////////////////////////////////////////////
			//parse xquery with quilt parser
			/////////////////////////////////////////////////////
			QuiltParser parser = new QuiltParser();
			QuiltQuery q = null;
			q = parser.parseQuery(xquery);

			/////////////////////////////////////////////////////
			//make initial xat
			/////////////////////////////////////////////////////
			/** set which operator factory to use */
			/** this is to generate persistent operators */
			System
					.setProperty(
							edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.OperatorFactory.factoryID,
							"edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.PersistentOperatorFactory");
			ParserTraverse ptU = new ParserTraverse();
			ptU.visit(q);
			xattree = ptU.getTree();

			/////////////////////////////////////////////////////
			//decor
			/////////////////////////////////////////////////////
			boolean debug = true;
			Debugger userDebug = null;
			BindingTable newUserTable = null;
			userDebug = new Debugger(xattree);

			//RewriteUtilities.cleanXATAfterGeneration(xattree, debug);
			XATCleanUp.doCleanUp(xattree);
			QueryDecorrelation qd1 = new QueryDecorrelation(xattree);
			xattree = qd1.getDecorTree();
			if (debug) {
				userDebug.setTree(xattree);
				//userDebug.printTree();
			}

			/////////////////////////////////////////////////////
			//rewrite
			/////////////////////////////////////////////////////

			Vector classList = new Vector();
			classList
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.MergeOperatorRules");
			ReWriteRules rules = new ReWriteRules(classList);
			Vector order = new Vector();
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.DistinctImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.TaggerImp");

			//set the variable table in the rules class to be the hashtable
			// from PT
			rules.setVariableTable(newUserTable);

			//create the traversal strategy
			ReWriteTraversal traverse = new ReWriteTraversal(xattree, rules,
					order);

			traverse.setDebug(debug);
			//traverse.doPushdown(ReWriteTraversal.DOWN);
			traverse.doPushdown();

			//first create a vector of the rule classes to look at
			classList = new Vector();
			String s1 = new String(
					"edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ComputationPushdownRules");
			classList.addElement(s1);

			//instantiate the rules class
			rules = new ReWriteRules(classList);

			//now make the order of Operator types to look at
			order = new Vector();
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp");
			order
					.addElement("edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp");
			//set the variable table in the rules class to be the hashtable
			// from PT
			rules.setVariableTable(newUserTable);

			//create the traversal strategy

			traverse = new ReWriteTraversal(xattree, rules, order);

			traverse.setDebug(debug);
			//traverse.doPushdown(ReWriteTraversal.DOWN);
			traverse.doPushdown();

			/////////////////////////////////////////////////////
			//schema cleanup
			/////////////////////////////////////////////////////
			SchemaCleanupVisitor sc = new SchemaCleanupVisitor();
			sc.visit(xattree);

			if (debug) {
				userDebug.printTree();
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return xattree;

	}

	/*
	 * @return XATDag an XAT dag which is the raindrop execution plan @param
	 * queryFile String the query file
	 */
	public static XATDag genPhyXATDag(String queryFile) {

		//1. get user query
		String xquery = null;
		xquery = readQuery(queryFile);

		//2. make XAT
		XATTree xattree = null;
		System
				.setProperty(
						edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.OperatorFactory.factoryID,
						"edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.PersistentOperatorFactory");
		xattree = makeXATNew(xquery);
		//xattree = makeXAT(xquery);

		//3. make raindrop logical plan
		System.out.println("-----------------------------------");
		System.out.println("Make raindrop logical plan...");
		RaindropLogicalPlanGenerator logGen = new RaindropLogicalPlanGenerator();
		XATDag logPlan = logGen.generatePlan(xattree);
		//Utility.printDag(logPlan);
		DagTraversal.printDag(logPlan);

		//4. make raindrop physical plan
		System.out.println("-----------------------------------");
		System.out.println("Make physical plan...");
		RaindropPhysicalPlanGenerator phyGen = new RaindropPhysicalPlanGenerator();
		XATDag phyPlan = phyGen.generatePhyPlan(logPlan);
		DagTraversal.printDag(phyPlan);

		return phyPlan;
	}

	/*
	 * @return XATDag an XAT dag which is the raindrop execution plan @param
	 * queryFile String the query file
	 */
	public static XATDag genRainbowPlan(String queryFile) {

		//1. get user query
		String xquery = null;
		xquery = readQuery(queryFile);

		//2. make XAT
		XATTree xattree = null;
		System
				.setProperty(
						edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.OperatorFactory.factoryID,
						"edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.PersistentOperatorFactory");
		xattree = makeXATNew(xquery);

		return (XATDag) xattree;
	}

	/**
	 * Generate a Physical Operating Plan from a Rainbow Core plan.
	 * @param rainbowPlan
	 * @param mappingStrategy
	 * @param inAutoNavNum
	 * @param inAutoSelNum
	 * @return
	 */
	public static XATDag genPhyXATDag(XATDag rainbowPlan, int mappingStrategy,
			int inAutoNavNum, int inAutoSelNum) {
		// Do outernav check
	//	outerNavRewrite(rainbowPlan);
		
		//3. make raindrop logical plan
		/* System.out.println("-----------------------------------"); */
		System.out.println("Make raindrop logical plan...");
		RuleBaseRaindropLogicalPlanGenerator.treeRewrite(rainbowPlan,
				mappingStrategy, inAutoNavNum, inAutoSelNum);
		DagTraversal.printDag(rainbowPlan);

		//4. make raindrop physical plan
		System.out.println("-----------------------------------");
		System.out.println("Make raindrop physical plan...");
		RaindropPhysicalPlanGenerator phyGen = new RaindropPhysicalPlanGenerator();
		XATDag phyPlan = phyGen.generatePhyPlan(rainbowPlan);
		DagTraversal.printDag(phyPlan);

		return phyPlan;
	}
	
	private static void outerNavRewrite(XATDag rainbowPlan){
		XATNode[] nodes = rainbowPlan.convertToArray();
		for(int i = 0; i < nodes.length; i++){
			if(nodes[i].getOperator() instanceof NavCollection &&
					!(nodes[i].getOperator() instanceof OuterNavCollectionImp)){
				System.out.println("Found a non-outer collection");
				// Is there a tagger below it?
				for(int j = i + 1; j < nodes.length; j++){
					if(nodes[j].getOperator() instanceof Tagger){												
						//There is a tagger below the nav, re-write the nav into an outer
						XATNode oldNode = nodes[i];
						NavCollectionImp oldOp = (NavCollectionImp)oldNode.getOperator();						
						XATNode node = new XATNodeImp();
						OuterNavCollectionImp newOuter = new OuterNavCollectionImp(oldNode);
						// Destination
						newOuter.setDestination(oldOp.getDestination());
						//entry
						newOuter.setEntryPoint(oldOp.getEntryPoint());
						//output column name
						newOuter.setOutputColumnName(oldOp.getOutputColumnName());
						//properties to-do						
						break;
					}
				}
			}
		}
	}

	/*
	 * this removes automega from logplan
	 */
	public static XATDag refineLogicalPlan(XATDag logPlan) {
		XATDag copy = (XATDag) logPlan.clone();
		Vector nodes = DagTraversal
				.dagTopDownTraverse((DagNode) copy.getRoot());
		for (Iterator it = nodes.iterator(); it.hasNext();) {
			DagNode node = (DagNode) it.next();
			if (node.getOperator() instanceof AutoMegaOperator) {
				DagNode boundary = ((AutoMegaOperator) node.getOperator())
						.getBoundary();
				boundary.setParent(node.getParent());
				node.getParent().addChild(boundary);
				node.getParent().deleteChild(node);

			}

		}
		return copy;

	}

	/*
	 * @param plan XATPlan a raindrop physical plan set up the default raindrop
	 * physical plan to be raindrop execution plan use data driven mode among
	 * operators as much as possible
	 */
	public static void setDataDriven(XATDag plan) {
		Vector v = DagTraversal.dagBottomUpTraverse(plan);
		for (Iterator it = v.iterator(); it.hasNext();) {
			DagNode node = (DagNode) it.next();
			XATStreamOperator op = (XATStreamOperator) node.getOperator();
			if (op instanceof InTimeSJStream ){//|| op instanceof ExtractStream) {				
				try {
					/*if (PlanManipulator.findNearestSJ(op)==null)
						//this operator will not be invoked by an ancestor structural join
						op.setProperty("DATA_DRIVEN_INVOKING", "1");
					else*/
						op.setProperty("DATA_DRIVEN_INVOKING", "0");
				} catch (Exception e) {
					throw new RuntimeException(e);
				}
			} else
				/*
				 * if ( !(op instanceof ExtractStream) && //the root has been
				 * set to 0 !(
				 * op.getProperty("DATA_DRIVEN_INVOKING").equals("0"))) {
				 */
				try {
					if (PlanManipulator.findNearestSJ(op)==null)
						//this operator will not be invoked by an ancestor structural join
						op.setProperty("DATA_DRIVEN_INVOKING", "1");
					else
						op.setProperty("DATA_DRIVEN_INVOKING", "0");
				} catch (Exception e) {
					throw new RuntimeException();
				}

		}
	}

	/*
	 * associate the automata with the data sources @param phyPlan XATDag a
	 * physical plan
	 */
	static public Automata setUpAuto(XATDag phyPlan) {
		AutoCreaterFrPlan creater = new AutoCreaterFrPlan();

		autos = new ExtendedAutomata[1];

		Vector v = DagTraversal.dagBottomUpTraverse(phyPlan);
		/** ****************** */

		XATNode[] sourceNodes = phyPlan.getLeaves();

		// set up the sourceop which is the entry of running
		storeMgr = new Finer_StreamStoreMgr();
		XMLScanStream[] sourceOps = new XMLScanStream[1];
		//generate an automata for each source
		for (int k = 0; k < sourceNodes.length; k++) {
			autos[k] = creater.generateAuto((DagNode) sourceNodes[k], storeMgr);
			autos[k].setPlan(phyPlan);
			//System.out.println(autos[k]);
			XMLScanStream sourceOp = (XMLScanStream) sourceNodes[k]
					.getOperator();

			sourceOp.setTokenHandler(new TokenHandler(autos[k]));

			try {
				sourceOp.setProperty("NUMBER_OF_TUPLES_TO_DEQUEUE", "500");
			} catch (Exception e) {
				System.out.println(e);
				System.exit(-1);
			}
			sourceOps[k] = sourceOp;
		}

		return autos[0];
	}

	/**
	 * Executes the physical plan in a simulated stream environment
	 * @param scheduler BottomUpPipelineScheduler the 
	 * default scheduler which does a bottom up pipelining 
	 * @param phydag XATDag the raindrop execution plan 
	 * @param xmlFileName string the data source which resides locally
	 * @param n int run n times
	 */	
	static public int execute(BottomUpPipelineScheduler scheduler,
			XATDag phyDag, String xmlFileName, int n)
			throws FileNotFoundException {

		//set up input first,set
		try {

			FileInputStream fis = new FileInputStream(xmlFileName);

			BufferedInputStream bis = new BufferedInputStream(fis);

			XMLScanStream sourceOp = (XMLScanStream) phyDag.getLeaves()[0]
					.getOperator();

			sourceOp.setB(bis);

			scheduler.scheduling();

			Vector v = DagTraversal.dagBottomUpTraverse(phyDag);
			XATStreamOperator op = (XATStreamOperator) (((DagNode) v.get(v
					.size() - 1)).getOperator());
			
			/** Drew's temporary fix for Class Exceptions **/ 
			int outputNum = 0;
			if(op instanceof TaggerStream){
				outputNum = ((TaggerStream) op).getTimeKeeper()
						.getOutputCount();
//				outputNum = ((TaggerStream) op).getNumOfResults();
				String[] results = ((TaggerStream) op).getResults();
				if(outputNum != results.length)
					System.out.println("Tagger Error!");
				outputNum = results.length;
				FileOutputStream fos = new FileOutputStream("outf.txt");
				BufferedOutputStream bos = new BufferedOutputStream(fos);
				for(int i = 0; i < results.length; i++){
					System.out.println(results[i]);				
					// Writes to c:\drew\outf.txt for the gui
					// very clumsy way to handle transfer of results
					// but it was already implemented this way.
					bos.write((results[i] + "\n").getBytes());					
				}
				bos.flush();
				bos.close();
				fos.close();
//				XATDataSource rs = ((TaggerStream) op).getOutputDataSource();
//				XATQueue rq = (XATQueue)rs;
//				
//				List tups = rq.getContents();
//				System.out.println(tups.size());
//				for(int i = 0;i < tups.size(); i++){
//					System.out.println(tups.get(i));
//				}
				//System.out.println(rs.toString());
			}else
				outputNum = -1;
			/** End Drew's fix **/
			
			System.out.println(outputNum + " tuples");
			//((XATStreamOpRunCore) op).resetOutputCount();

			//clear the output queue & storage to save memory
			op.getOutputQueue().removeAllTuples();
			storeMgr.clear();
			sourceOp.setB(null);

			//recordTimes();

			bis.close();
			fis.close();

			System.out.println("finished " + n + "th try");
			return outputNum;

		} catch (Exception e) {
			System.out.println(e);

		}

		//indicating wrong
		return -1;

	}

	/*
	 * @param scheduler BottomUpPipelineScheduler the default scheduler which
	 * does a bottom up pipelining @param phydag XATDag the raindrop execution
	 * plan @param xmlFileName string the data source which resides locally
	 * @param n int run n times
	 */
	static public int execute(BottomUpPipelineScheduler scheduler,
			XATDag phyDag, String xmlFileName, int n, int desiredBottomDestNum)
			throws FileNotFoundException {

		//set up input first,set
		try {

			FileInputStream fis = new FileInputStream(xmlFileName);

			BufferedInputStream bis = new BufferedInputStream(fis);

			XMLScanStream sourceOp = (XMLScanStream) phyDag.getLeaves()[0]
					.getOperator();

			sourceOp.setB(bis);

			scheduler.scheduling(desiredBottomDestNum);

			Vector v = DagTraversal.dagBottomUpTraverse(phyDag);
			XATStreamOperator op = (XATStreamOperator) (((DagNode) v.get(v
					.size() - 1)).getOperator());
			int outputNum = ((TaggerStream) op).getTimeKeeper()
					.getOutputCount();
			System.out.println(outputNum + " tuples");
			//((XATStreamOpRunCore) op).resetOutputCount();

			//clear the output queue & storage to save memory
			op.getOutputQueue().removeAllTuples();
			storeMgr.clear();
			sourceOp.setB(null);

			//recordTimes();

			bis.close();
			fis.close();

			System.out.println("finished " + n + "th try");
			return outputNum;

		} catch (Exception e) {
			System.out.println(e);

		}

		//indicating wrong
		return -1;

	}

	/*
	 * static public int executeSocket(BottomUpPipelineScheduler scheduler,
	 * XATDag phyDag, int desiredDestCount) { //100M
	 * //socket.setReceiveBufferSize(100000000);
	 * 
	 * try { //InetAddress addr = InetAddress.getByName("130.215.28.164");
	 * InetAddress addr = InetAddress.getByName("mmani-ra1.wpi.edu");
	 * 
	 * Socket socket = new Socket(addr, CharSenders.PORT);
	 * 
	 * BufferedInputStream bis = new BufferedInputStream(socket
	 * .getInputStream());
	 * 
	 * XMLScanStream sourceOp = (XMLScanStream) phyDag.getLeaves()[0]
	 * .getOperator();
	 * 
	 * sourceOp.setB(bis);
	 * 
	 * Vector v = DagTraversal.dagBottomUpTraverse(phyDag); XATStreamOperator op =
	 * (XATStreamOperator) (((DagNode) v.get(v .size() - 1)).getOperator());
	 * 
	 * scheduler.scheduling();
	 * 
	 * int outputNum = ((XATStreamOpRunCore)
	 * op).getTimeKeeper().getOutputCount(); System.out.println(outputNum + "
	 * tuples"); // ((XATStreamOpRunCore) op).resetOutputCount();
	 * 
	 * //clear the output queue & storage to save memory
	 * op.getOutputQueue().removeAllTuples(); storeMgr.clear();
	 * 
	 * sourceOp.setB(null);
	 * 
	 * return outputNum; } catch (Exception e) { e.printStackTrace(); return -1; } }
	 */

	static public int executeSocket(BottomUpPipelineScheduler scheduler,
			XATDag phyDag, int desiredDestNum) {
		//100M
		//socket.setReceiveBufferSize(100000000);

		try {
			//InetAddress addr = InetAddress.getByName("130.215.28.164");
			InetAddress addr = InetAddress.getByName("mmani-ra1.wpi.edu");

			Socket socket = new Socket(addr, CharSenders.PORT);

			BufferedInputStream bis = new BufferedInputStream(socket
					.getInputStream());

			XMLScanStream sourceOp = (XMLScanStream) phyDag.getLeaves()[0]
					.getOperator();

			sourceOp.setB(bis);

			Vector v = DagTraversal.dagBottomUpTraverse(phyDag);
			XATStreamOperator op = (XATStreamOperator) (((DagNode) v.get(v
					.size() - 1)).getOperator());

			scheduler.scheduling(desiredDestNum);

			int outputNum = ((XATStreamOpRunCore) op).getTimeKeeper()
					.getOutputCount();
			System.out.println(outputNum + " tuples");
			((XATStreamOpRunCore) op).getTimeKeeper().resetOutputCount();

			//clear the output queue & storage to save memory
			op.getOutputQueue().removeAllTuples();
			storeMgr.clear();

			sourceOp.setB(null);

			return outputNum;
		} catch (Exception e) {
			e.printStackTrace();
			return -1;
		}
	}

	/*
	 * store the average execution time in run (repeatingTimes) under data set
	 * fileId this makes statistics for one plan for one data set
	 */
	static public void statisticsTimeForPlottingDemoOnly(int fileId,
			int mappingStrategy, int inAutoNavNum, int inAutoSelNum,
			BufferedWriter out, List timeKeeperMgrs, int outputNum) {

		try {

			ClassExecTimeKeeperMgr firstMgr = (ClassExecTimeKeeperMgr) timeKeeperMgrs
					.get(0);

			//find out the position of the overall execution time
			int i = 0;
			for (i = 0; i < firstMgr.getTimeKeepers().size(); i++) {
				ClassExecTimeKeeper keeper = (ClassExecTimeKeeper) firstMgr
						.getTimeKeepers().get(i);

				//  if
				// (keeper.getEvaluatedClass().toString().indexOf("TokenHandler")!=-1)
				//out.write(keeper.getMethodDesc()+",");
				//else
				out.write(keeper.getEvaluatedClass().toString() + ",");

			}

			out.write("\n");

			//time of this many items is recorded during one run
			int itemNum = firstMgr.getTimeKeepers().size();

			//calculate the average execution time of each item

			long executionTimeSum = 0;
			for (Iterator it = timeKeeperMgrs.iterator(); it.hasNext();) {
				ClassExecTimeKeeperMgr keeperMgr = (ClassExecTimeKeeperMgr) it
						.next();
				executionTimeSum = executionTimeSum
						+ ((ClassExecTimeKeeper) keeperMgr.getTimeKeepers()
								.get(i)).getTime();
			}

			//Xaxis
			out.write(10 * fileId + " ");

			//yxis
			out.write(executionTimeSum / timeKeeperMgrs.size() + " ");

			out.write("\n");

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	/*
	 * @param phyDag XATDag @return ClassExecTimeKeeperMgr manage
	 */
	static public ClassExecTimeKeeperMgr setUpTimeKeepers(XATDag phyDag) {
		ClassExecTimeKeeperMgr mgr = new ClassExecTimeKeeperMgr();

		Vector v = DagTraversal.dagBottomUpTraverse(phyDag);

		boolean automataKeeperSet = false;

		for (Iterator it = v.iterator(); it.hasNext();) {
			XATStreamOperator op = (XATStreamOperator) ((DagNode) it.next())
					.getOperator();

			if (op instanceof XATStreamOpRunCore && !(op instanceof PureNavigateAutoStream))
				mgr.addIntoMgr(((XATStreamOpRunCore) op).getTimeKeeper(), true);

			if (op instanceof XMLScanStream) {
				ClassExecTimeKeeper overallTimeKeeper = ((XMLScanStream)op).getTimeKeeper();
				mgr.addIntoMgr(overallTimeKeeper, true);

				ClassExecTimeKeeper keeper1 = ((XMLScanStream) op)
						.getTokenHandler().getTimeKeeperSta();
				mgr.addIntoMgr(keeper1, true);
				ClassExecTimeKeeper keeper2 = ((XMLScanStream) op)
						.getTokenHandler().getTimeKeeperReasoning();
				mgr.addIntoMgr(keeper2, true);
				ClassExecTimeKeeper keeper3 = ((XMLScanStream) op)
						.getTokenHandler().getTimeKeeperMigrate();
				mgr.addIntoMgr(keeper3, true);			
				
				}
		}

		return mgr;
	}
}