/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.common;

/**
 * This class represents an
 * expanded-name in <i>XML</i>.
 */
public class ExpandedName {
    
    /**
     * The (expanded) prefix.
     *
     * This prefix might
     * be <b>null</b>.
     */
    private String prefix;

    /**
     * The local part of
     * the expanded-name.
     */
    private String localPart;

    /**
     * The unique constructor
     * in this class.
     */
    public ExpandedName()
    { 
	this.prefix = null;
	this.localPart = null;
    }

    public ExpandedName(String name)
    {
	this.prefix = null;
	this.localPart = name;
    }
    
    public void setPrefix(String prefix1) {
	this.prefix = prefix1;
    }

    public void setLocalPart(String localPart1) {
	this.localPart = localPart1;
    }
    
    public String toString() {
	return this.prefix + ":" + this.localPart;
    }

}







