/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package xacute.common;

import xacute.common.QuiltException;

public interface NodeList
{
    // list methods
    public int size();

    public boolean isEmpty();

    public Node get(int k);

    // comparison
    public boolean isEqualTo(NodeList l);

    public boolean isDifferentFrom(NodeList l);

    // list unary operations
    public NodeList freeDuplicateValues();

    // list binary operations
    // unordered
    public NodeList APPEND(Node n);

    public NodeList APPEND(NodeList nl);

    // ordered
    public NodeList UNION(NodeList l);

    // Exception is throwned when nodelists cannot be compared
    public NodeList INTER(NodeList l) throws QuiltException;

    public NodeList EXCEPT(NodeList l) throws QuiltException;

    public NodeList BEFORE(NodeList l) throws QuiltException;

    public NodeList AFTER(NodeList l) throws QuiltException;

    public NodeList applyPredicate(Predicate p) throws QuiltException;

    public String stringValue();

    public String stringValue_shallow();
}
