/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


/**
 *
 * This is an implementation of the xacute.common.Node interface that
 * relies on DOM.
 *
 **/

package xacute.impl.dom;

import xacute.common.Node;
import xacute.common.NodeList;

public class NodeImpl
    extends xacute.util.NodeDefaultImpl
{

    public NodeList createNodeList( org.w3c.dom.NodeList nl )
    {
	return new NodeListImpl( nl );
    }
    
    public NodeList createNodeList( org.w3c.dom.Node n )
    {
	return new NodeListImpl( n );
    }
    
    public NodeList createNodeList( Node n )
    {
	return new NodeListImpl( n );
    }
    
    public NodeList createNodeList()
    {
	return new NodeListImpl();
    }

    public Node createNode( org.w3c.dom.Node n )
    {
	return new NodeImpl(n);
    }
    
    public NodeImpl(org.w3c.dom.Node n)
    {
	super(n);
    }
    
}
