/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;


import xacute.common.Node;
import xacute.common.QuiltException;


public class AttributeExpression
    extends QuiltExpression
{

    /**
     * The name of the attribute.
     */
    private String name;

    /**
     * The expression whose evaluation
     * will give the value of the
     * attribute.
     */
    private QuiltExpression e;

    AttributeExpression(String name, QuiltExpression e)
    {
	this.name = name;
	this.e = e;
    }

    public String getName() { return this.name; }

    Value eval(EvalContext con)
	throws QuiltException
    {
	return this.e.eval(con);
    }

    public String pprint()
    {
	StringBuffer buf = new StringBuffer();
	if (name != null)
	    {
		buf.append(name);
		buf.append('=');
	    }
	buf.append(e.pprint());
	return buf.toString();
    }


  public QuiltExpression returnQuery() {
    return e;
    }

/**
 * Insert the method's description here.
 * Creation date: (8/9/02 5:03:31 PM)
 * @return xacute.quilt.QuiltExpression
 */
public QuiltExpression getE() {
	return this.e;
}
}


