/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.QuiltException;
import java.util.Vector;

/** This class represents any comparison operation. */
public class BinOpCOMP extends BinOpBool
{
    private int op;

    BinOpCOMP(int op, QuiltExpression left, QuiltExpression right)
    {
        this.e = left;
        this.operands = new QuiltExpression[1]; this.operands[0] = right;
        // that's a little dirty, I must confess.
        this.op = op;
    }

    private QuiltExpression getLeft() { return this.e; }

    private QuiltExpression getRight() { return this.operands[0]; }

    Value eval(EvalContext con) throws QuiltException
    {
        return new ValueBool(this.evalToBoolean(con));
    }

    public String pprint()
    {
        StringBuffer buf = new StringBuffer();
        buf.append(this.getLeft().pprint() + " " + Constants.COMPOPS[op] + " " + this.getRight().pprint());
        return buf.toString();
    }

    /**
     * Calls the comparison method on the <code>Value</code> objects evaluated from both sides of the comparison operation.
     * @param env the environment of evaluation
     */
    private boolean evalToBoolean(EvalContext con) throws QuiltException
    {
        Value _left = this.getLeft().eval(con);
        Value _right = this.getRight().eval(con);
        return _left.compare(this.op, _right, con);
    }

/**
 * Insert the method's description here.
 * Creation date: (3/22/2002 2:21:46 AM)
 * @return int
 */
public int getOp() {
	return op;
}
}
