/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.NodeList;
import xacute.common.QuiltException;

import java.util.Vector;
import org.xml.sax.helpers.AttributeListImpl;

/**
 * This class represents the 
 * <b>FILTER</b> binary operator.
 */
public class BinOpPruneFilter 
    extends Operator
{
    
    private QuiltExpression e;
    private QuiltExpression filter;
    
    BinOpPruneFilter(QuiltExpression e, QuiltExpression filter)
    {
	this.e = e;
	this.filter = filter;
    }

    public String pprint()
    {
	StringBuffer buf = new StringBuffer();
	buf.append(e.pprint());
	buf.append(" FILTER ");
	buf.append("(" + filter.pprint() + ")");
	return buf.toString();
    }
    
    Value eval(EvalContext con)
	throws QuiltException
    {
	NodeList result = con.getNodeFactory().makeEmptyNodeList();
	NodeList nl = this.e.eval(con).toNodeList(con);
	for(int i=0; i < nl.size(); i++)
	    result = result.APPEND( FilterHelper.filter( nl.get(i), new Predicate( this.filter, con), con ));
	return new ValueNodeList( result );
    }

}


