/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

/**
 * This class represents a pair
 * consisting of an element-name
 * and of an attribute-name, it is
 * used in <i>XPath</i> dereferencing 
 * steps to provide some hints.
 */
class DerefPair
    implements xacute.common.Hint
{
    
    /**
     * This field is the element-name.
     */
    private String elt;
    
    /**
     * This field is the attribute-name.
     */
    private String att;
    
    DerefPair(String elt, String att)
    {
	this.elt = elt;
	this.att = att;
    }
    
    public String getElt() { return this.elt; }
    
    public String getAtt() { return this.att; }

    public String toString() { return this.elt + ":" + att; }
}
