/* Generated by Together
 * Our own code.
 */

package xacute.quilt;

import xacute.common.Constants;
import xacute.common.NodeList;
import xacute.common.Node;
import xacute.common.QuiltException;
import java.util.Vector;
import java.util.TreeMap;

/** This class implements <i>Quilt</i>'s <b>FOR</b> / <b>LET</b> / <b>WHERE</b> / <b>UPDATE</b> expressions. */
public class FLWUExpression extends QuiltExpression
{
    private Binding[] bindings;
    private QuiltExpression where;
    private QuiltExpression[] updates;
    private String varname;

    FLWUExpression(Vector bindings, QuiltExpression where, String varname, Vector updates)
    {
        this.bindings = new Binding[bindings.size()];
        bindings.toArray(this.bindings);
        this.where = where;
        this.varname = varname;
        this.updates = new QuiltExpression[updates.size()];
        // this.updates = new Vector[updates.size()];
        updates.toArray(this.updates);
    }

    public String pprint()
    {
        StringBuffer buf = new StringBuffer();
        for (int i = 0; i < this.bindings.length; ++i)
            buf.append(this.bindings[i].pprint() + "\n");
        if (where != null)
            buf.append("WHERE " + this.where.pprint() + "\n");
        buf.append("UPDATE " + this.varname + " {\n");
        for (int i = 0; i < this.updates.length; i++)
            buf.append("    " + this.updates[i].pprint() + "\n");
        buf.append(" }\n");
        return buf.toString();
    }

    public Value eval(EvalContext con) throws QuiltException
    {
        if (con.getNode() != null)
            throw new RuntimeException("xacute.quilt.FLWRExpression.eval() with a non-null node");
        Vector result = new Vector();
        BindingTree.buildTreeAndPaths(this.bindings, con, this.where, null, result);
        return this.evalInOrder(result, con);
    }

    private Value evalInOrder(Vector tm, EvalContext con) throws QuiltException
    {
        // The call returns sorted results.
        // Depending on the nature of the sort, the result will be returned
        // forward or backward.
        BindingTreePath[] paths = new BindingTreePath[tm.size()];
        tm.toArray(paths);
        NodeList nl = con.getNodeFactory().makeEmptyNodeList();
        for (int k = 0; k < paths.length; k++)
        {
            con.getEnv().setBindings(this.bindings, paths[k]);
            for(int i = 0; i < this.updates.length; i++)
              nl = nl.APPEND(this.updates[i].eval(con).toNodeList(con));
        }
        if (paths.length > 0)
        {
            // System.err.println("in FLWR");
            // modified by Xin. for the purpose of SequenceExpression.
            // con.getEnv().rmBindings(this.bindings);
        }
        return new ValueNodeList(nl);
    }


    /**
     * Edited by Mukesh Mulchandani 15/01/2002
     * New Functions have been added.
     */

     public Binding[] getBindings()
     {
	     return bindings;
     }

	 public QuiltExpression getWhere() 
	 {
  	    return where;
     }

	 public QuiltExpression[] getUpdates()
	 {
		 return updates;
	 }

	 public String getVarname()
	 {
		 return varname;
	 }

}
