/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package xacute.quilt;

import java.util.Vector;
import xacute.common.Node;
import xacute.common.QuiltException;

public abstract class FunCall extends QuiltExpression
{
    protected QuiltExpression[] args;

    public abstract String getName();

    public QuiltExpression[] getArgs()
    {
        return args;
    }

    abstract Value eval(EvalContext con) throws QuiltException;

    /**
     * Sets the arguments of this <code>FunCall</code>.
     * @param v a <code>Vector</code> containing the arguments
     */
    void pushArgs(Vector v)
    {
        this.args = new QuiltExpression[v.size()];
        v.toArray(this.args);
    }

    public String pprint()
    {
        StringBuffer buf = new StringBuffer();
        buf.append("&" + this.getName() + "(");
        int s = this.args.length;
        for (int k = 0; k < s; ++k)
            buf.append(this.args[k].pprint() + ((k == s - 1) ? "" : ", "));
        buf.append(")");
        return buf.toString();
    }
}
