/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Node;
import xacute.common.NodeFactory;
import xacute.common.QuiltException;

/**
 * This class represents the <i>Quilt</i> <code>document</code>
 * construct giving the root node of an XML document.
 **/
public class FunDOCUMENT
    extends FunPrimitive
{

    FunDOCUMENT() {}

    Value eval(EvalContext con)
	throws QuiltException
    {
	String url = this.args[0].eval(con).toString(con);
	try
	    {
		NodeFactory nf = con.getNodeFactory();
		Node n = nf.getDocumentRoot( url );
		return new ValueNodeList( nf.makeNodeList(n) );
	    } catch (Exception e) {
		e.printStackTrace();
		throw new QuiltDocException("Document " + url + " not found");
	    }
    }
    public ValueString getDocString() {
      return (ValueString) this.args[0];
    }
}


