/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.NodeList;
import xacute.common.QuiltException;

/**
 * This class implements <i>WPI CS special</i>'s <code>GETTAG()</code> primitive.
 * Written by CS542 Class Project Team Aleksandar, Katica, Steffen 2001
 */
public class FunGETTAG extends FunPrimitive
{
    FunGETTAG() { }

    Value eval(EvalContext con) throws QuiltException
    {
        if (this.args.length != 1)
            throw new QuiltWrongArgNumberException(this.getName());
        else
        {
            NodeList nl = this.args[0].eval(con).toNodeList(con);
            try{
	            return new ValueString(nl.get(0).getQName());
            }catch(IndexOutOfBoundsException e){
	            return new ValueString("ERROR");
            }
        }
    }
}
