/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;


import xacute.common.Constants;
import xacute.common.NodeList;
import xacute.common.QuiltException;

/**
 * This class implements a function that joins (inverse of split).
 *
 */
public class FunJOIN
    extends FunPrimitive
{

    FunJOIN() {}

    Value eval(EvalContext con)
	throws QuiltException
    {
	if (this.args.length < 2)
	    throw new QuiltWrongArgNumberException(this.getName());

	StringBuffer buf = new StringBuffer();
	String sep = this.args[0].eval(con).toString(con);
	
	NodeList nl = con.getNodeFactory().makeEmptyNodeList();
	for(int i=1; i < args.length; i++)
	    nl = nl.APPEND( this.args[i].eval(con).toNodeList(con) );
	if (nl.size() > 0)
	    {
		buf.append( nl.get(0).stringValue() );
		for(int j=1; j < nl.size(); j++)
		    buf.append(sep).append( nl.get(j).stringValue() );
	    }
	return new ValueString( buf.toString() );
    }
}


