/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.NodeList;
import xacute.common.QuiltException;
import java.util.*;

/**
 * This class implements <i>WPI CS special</i>'s
 * <code>TOKEN(what, splitby, number)</code> primitive.
 *
 * Written by Steffen 2001
 */

public class FunTOKEN
    extends FunPrimitive
{

    FunTOKEN() { super(); }

    Value eval(EvalContext con)
	throws QuiltException
    {
		
	if (this.args.length != 3)
	    throw new QuiltWrongArgNumberException(this.getName());
	else
	    {
		NodeList nl1 = this.args[0].eval(con).toNodeList(con);
		String s1 = nl1.get(0).stringValue();
		NodeList nl2 = this.args[1].eval(con).toNodeList(con);
		String s2 = nl2.get(0).stringValue();
		NodeList nl3 = this.args[2].eval(con).toNodeList(con);
		String s3 = nl3.get(0).stringValue();
				
		String r1 = null;
		int counter = Integer.parseInt(s3.trim());
				
		StringTokenizer tokenizer = new StringTokenizer(s1, s2);
	
		while (counter>0)
		{
			if (tokenizer.hasMoreTokens())
			{
				r1 = tokenizer.nextToken();
			}else{
				r1 = "";
			}
			counter--;
		}
	
		return new ValueString(r1);
	    }
	
    }


}


