package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.QuiltException;

import java.util.*;

/**
 *
 */
public class IfThenElse
    extends QuiltExpression
{

    private QuiltExpression ifE;
    private QuiltExpression thenE;
    private QuiltExpression elseE;

    public IfThenElse(QuiltExpression ifE, 
		      QuiltExpression thenE, 
		      QuiltExpression elseE)
    {
	this.ifE = ifE;
	this.thenE = thenE;
	this.elseE = elseE;
    }
    Value eval(EvalContext con)
	throws QuiltException
    {
	if (this.ifE.isTrue(con))
	    return this.thenE.eval(con);
	else
	    return this.elseE.eval(con);
    }
    /**
    *@author Xin Zhang
    **/
    public QuiltExpression getElseE(){
	    return this.elseE;
    }
    /**
    *@author Xin Zhang
    **/
    public QuiltExpression getIfE(){
	    return this.ifE;
    }
    /**
    *@author Xin Zhang
    **/
    public QuiltExpression getThenE(){
	    return this.thenE;
    }
    public String pprint()
    {
	return ("IF " + this.ifE.pprint() 
		+ "\nTHEN " + this.thenE.pprint() 
		+ "\nELSE " + this.elseE.pprint() 
		+ "\n");
    }
}
