/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Node;

import java.util.Collection;
import java.util.Comparator;
import java.util.Iterator;
import java.util.TreeMap;
import java.util.Vector;


/**
 * This is a regular treemap that can handle duplicates.
 * Every key will lead to a Vector.
 * This class is used for sorting.
 **/


public class NodeListTreeMap
{
    private TreeMap tm;
    
    public NodeListTreeMap( Comparator c )
    {
	tm = new TreeMap(c);
    }

    public void put(String[] key, Node n)
    {
	if (!this.tm.containsKey(key))
	    {
		Vector v = new Vector();
		v.add(n);
		this.tm.put(key, v);
	    }
	else
	    {
		Vector v = (Vector) this.tm.get(key);
		v.add(n);
	    }
	return;
    }

    public Vector values()
    {
	Vector v = new Vector();
	Collection coll = this.tm.values();
	for( Iterator iter = coll.iterator(); iter.hasNext(); )
	    v.addAll( (Vector) iter.next() );
	return v;
    }

    private static String toString( String[] s )
    {
	StringBuffer buf = new StringBuffer();
	for(int i=0; i < s.length; i++)
	    buf.append(s[i] + "::" );
	return buf.toString();
    }
}
    



