/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.QuiltException;


public class NodeType
    extends NodeTest 
{
    
    private int type;
    
    public NodeType(int type) {	this.type = type; }
    
    public String pprint()
    {
	StringBuffer buf = new StringBuffer();
	if ((type >= 0) && (type < Constants.NODETYPES.length))
	    buf.append(Constants.NODETYPES[type] + "()");
	return buf.toString();
    }

    public boolean isTrue(Node n, int axis)
    {
	return (n.isOfType(this.type));
    }

    /**
     * Package method returning
     * the type constant of a 
     * <code>NodeType</code>.
     */
    public int getType() { return this.type; }

}



