/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Node;
import xacute.common.QuiltException;

/**
 *
 */
public class QName
    extends QuiltExpression
    implements TagNameable
{
    
    private String name;
    
    QName(String name)
    {
	this.name = name;
    }

    public String getTagName(EvalContext con)
	throws QuiltException
    {
	return this.name;
    }

    public String getTagName()
    {
	return this.name;
    }
    
    Value eval(EvalContext con)
	throws QuiltException
    {
	return new ValueString(this.name);
    }

    public String pprint() { return this.name; }
}
