/* Generated By:JavaCC: Do not edit this line. QuiltParser.java */
package xacute.quilt;


import xacute.common.Constants;

import java.io.*;
import java.util.Hashtable;
import java.util.Vector;

public final class QuiltParser implements QuiltParserConstants {

    private Hashtable funDefNames = new Hashtable();
    private Hashtable funImportNames = new Hashtable();

    public QuiltParser()
    {
        this(new ASCII_CharStream(new StringReader(""), 0, 0));
    }

    /**
     * Returns the <code>Query</code>
     * object representing a Quilt query.
     * @param s the <code>String</code>
     *          representation of the
     *          Quilt query
     */
    public QuiltQuery parseQuery(String s) throws Exception
    {
        this.funImportNames.clear();
        this.funDefNames.clear();
        this.ReInit(new ASCII_CharStream(new StringReader(s), 0, 0));
        return quilt_query();
    }

    /**
     * Auxiliary function removing
     * the first character at the beginning
     * of a string.
     */
    private static String chop(String s)
    {
        return s.substring(1);
    }

    private static String butLast(String s)
    {
        return s.substring(0, s.length()-1);
    }

    /**
     * Auxiliary function removing the quotes
     * around a string definition.
     */
    private static String unquote(String quoted)
    {
        try {
            String unquoted = quoted.substring(1, quoted.length() - 1);
            return unquoted;
        } catch (Exception e) {
            throw new RuntimeException("Syntax error in a string definition : " + quoted);
        }
    }

    /**
     * Auxiliary function that
     * handles tag creation
     * with QName or variables.
     **/
    private TagNameable getTagName(String tagName)
    {
        //	String s = chop(tagName);
        String s = tagName;
        if (s.startsWith("$"))
            return new Var(chop(s));
        else
            return new QName(s);
    }

    /**
     * Auxiliary function removing the
     * first and last character
     * around a <code>String</code>
     */
    private static String trim(String s)
    {
        return s.substring(1, s.length() - 1);
    }

/**
quilt_query ::= import_def_list? fun_def_list? quilt_expression <EOF>
*/
  final public QuiltQuery quilt_query() throws ParseException {
    Vector funDefs = new Vector();
    QuiltExpression queryBody;
    if (jj_2_1(999)) {
      import_def_list();
    } else {
      ;
    }
    if (jj_2_2(999)) {
      funDefs = fun_def_list();
    } else {
      ;
    }
    queryBody = quilt_expression();
    jj_consume_token(0);
      {if (true) return new QuiltQuery( funDefs, queryBody );}
    throw new Error("Missing return statement in function");
  }

/**
import_def_list ::= (<IMPORT> <NAME> <AS> (<CLASSNAME>|<NAME>) <SEMICOLON>)+
*/
  final public void import_def_list() throws ParseException {
    Token nameT, classT;
    label_1:
    while (true) {
      jj_consume_token(IMPORT);
      nameT = jj_consume_token(NAME);
      jj_consume_token(AS);
      if (jj_2_3(999)) {
        classT = jj_consume_token(CLASSNAME);
      } else if (jj_2_4(999)) {
        classT = jj_consume_token(NAME);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(SEMICOLON);
         funImportNames.put(nameT.image, classT.image);
      if (jj_2_5(999)) {
        ;
      } else {
        break label_1;
      }
    }
  }

/**
fun_def_list ::= ( <FUNCTION> <NAME> <LPAREN> fun_args? <RPAREN> <LBRACE> quilt_expression? <RBRACE> )+
*/
  final public Vector fun_def_list() throws ParseException {
    Token funName;
    Vector args = null;
    Vector funDefList = new Vector();
    QuiltExpression funBody = null;
    label_2:
    while (true) {
      jj_consume_token(FUNCTION);
      funName = jj_consume_token(NAME);
      jj_consume_token(LPAREN);
      if (jj_2_6(999)) {
        args = fun_args();
      } else {
        ;
      }
      jj_consume_token(RPAREN);
          // System.err.println("Putting >" + funName + "< in the HT");
          funDefNames.put( funName.image, Boolean.TRUE );
      jj_consume_token(LBRACE);
      if (jj_2_7(999)) {
        funBody = quilt_expression();
      } else {
        ;
      }
      jj_consume_token(RBRACE);
          funDefList.addElement( new FunDef( funName.image,
                                             args,
                                             funBody
                                             )
                               );
      if (jj_2_8(999)) {
        ;
      } else {
        break label_2;
      }
    }
          {if (true) return funDefList;}
    throw new Error("Missing return statement in function");
  }

/**
fun_args ::= <VARNAME> (<COMMA> <VARNAME>)*
*/
  final public Vector fun_args() throws ParseException {
    Token argName;
    Vector args = new Vector();
    argName = jj_consume_token(VARNAME);
      args.addElement(new Var(chop(argName.image)));
    label_3:
    while (true) {
      if (jj_2_9(999)) {
        ;
      } else {
        break label_3;
      }
      jj_consume_token(COMMA);
      argName = jj_consume_token(VARNAME);
       args.addElement(new Var(chop(argName.image)));
    }
          {if (true) return args;}
    throw new Error("Missing return statement in function");
  }

/** should I distinguish between fun variable and quilt variables ? **/

/**
quilt_expression ::= ( ( <LBRACE> sequence_expression <RBRACE>)|union_expression)
*/
  final public QuiltExpression quilt_expression() throws ParseException {
    QuiltExpression e;
    if (jj_2_10(999)) {
      jj_consume_token(LBRACE);
      e = sequence_expression();
      jj_consume_token(RBRACE);
    } else if (jj_2_11(999)) {
      e = union_expression();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
sequence_expression ::= quilt_expression (<COMMA> quilt_expression)*
*/
  final public QuiltExpression sequence_expression() throws ParseException {
    QuiltExpression e;
    Vector v = new Vector();
    e = quilt_expression();
       v.addElement(e);
    label_4:
    while (true) {
      if (jj_2_12(999)) {
        ;
      } else {
        break label_4;
      }
      jj_consume_token(COMMA);
      e = quilt_expression();
        v.addElement(e);
    }
      {if (true) return new SequenceExpression(v);}
    throw new Error("Missing return statement in function");
  }

/**
flwr_expression ::= ((<FOR> for_binding (<COMMA> for_binding)*)|(<LET> let_binding (<COMMA> let_binding)* ))* (<WHERE> where_clause)? <RETURN> quilt_expression sort_clause_list?
*/
  final public QuiltExpression flwr_expression() throws ParseException {
    QuiltExpression e;
    Vector sort = null;
    QuiltExpression where = null;
    Binding b;
    Vector bindings = new Vector();
    label_5:
    while (true) {
      if (jj_2_13(999)) {
        ;
      } else {
        break label_5;
      }
      if (jj_2_16(999)) {
        jj_consume_token(FOR);
        b = for_binding(true);
                                    bindings.addElement(b);
        label_6:
        while (true) {
          if (jj_2_14(999)) {
            ;
          } else {
            break label_6;
          }
          jj_consume_token(COMMA);
          b = for_binding(false);
                                          bindings.addElement(b);
        }
      } else if (jj_2_17(999)) {
        jj_consume_token(LET);
        b = let_binding(true);
                                    bindings.addElement(b);
        label_7:
        while (true) {
          if (jj_2_15(999)) {
            ;
          } else {
            break label_7;
          }
          jj_consume_token(COMMA);
          b = let_binding(false);
                                          bindings.addElement(b);
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    if (jj_2_18(999)) {
      jj_consume_token(WHERE);
      where = where_clause();
    } else {
      ;
    }
    jj_consume_token(RETURN);
    e = quilt_expression();
    if (jj_2_19(999)) {
      sort = sort_clause_list();
    } else {
      ;
    }
      {if (true) return new FLWRExpression(bindings, where, e, sort);}
    throw new Error("Missing return statement in function");
  }

/**
for_binding ::= <VARNAME> <IN> <DISTINCT>? quilt_expression
*/
  final public ForBinding for_binding(boolean isFirst) throws ParseException {
    Token t;
    boolean isDistinct = false;
    QuiltExpression e;
    t = jj_consume_token(VARNAME);
    jj_consume_token(IN);
    if (jj_2_20(999)) {
      jj_consume_token(DISTINCT);
                   isDistinct = true;
    } else {
      ;
    }
    e = quilt_expression();
      {if (true) return new ForBinding(isFirst, chop(t.image), isDistinct, e);}
    throw new Error("Missing return statement in function");
  }

/**
let_binding ::= <VARNAME> <DEF> <DISTINCT>? quilt_expression
*/
  final public LetBinding let_binding(boolean isFirst) throws ParseException {
    Token t;
    boolean isDistinct = false;
    QuiltExpression e;
    t = jj_consume_token(VARNAME);
    jj_consume_token(DEF);
    if (jj_2_21(999)) {
      jj_consume_token(DISTINCT);
                   isDistinct = true;
    } else {
      ;
    }
    e = quilt_expression();
      {if (true) return new LetBinding(isFirst, chop(t.image), isDistinct, e);}
    throw new Error("Missing return statement in function");
  }

/**
where_clause ::= quilt_expression
*/
  final public QuiltExpression where_clause() throws ParseException {
    QuiltExpression e;
    e = quilt_expression();
      {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
sort_clause_list ::= <SORTBY> <LPAREN> sort_clause (<COMMA> sort_clause)* <RPAREN>
*/
  final public Vector sort_clause_list() throws ParseException {
    Vector v = new Vector();
    SortClause s;
    jj_consume_token(SORTBY);
    jj_consume_token(LPAREN);
    s = sort_clause();
                      v.addElement(s);
    label_8:
    while (true) {
      if (jj_2_22(999)) {
        ;
      } else {
        break label_8;
      }
      jj_consume_token(COMMA);
      s = sort_clause();
       v.addElement(s);
    }
    jj_consume_token(RPAREN);
      {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
sort_clause ::= quilt_expression (<ASC> | <DESC>)?
*/
  final public SortClause sort_clause() throws ParseException {
    QuiltExpression e;
    boolean descOrder = false;
    e = quilt_expression();
    if (jj_2_25(999)) {
      if (jj_2_23(999)) {
        jj_consume_token(ASC);
      } else if (jj_2_24(999)) {
        jj_consume_token(DESC);
                            descOrder = true;
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } else {
      ;
    }
      {if (true) return new SortClause(e, descOrder);}
    throw new Error("Missing return statement in function");
  }

/**
element_contructor ::= <TAG1> (<NAME>|<VARNAME>|quilt_expression) attribute_list? (<TAG3>|<TAG2> element_content? <TAG4> (<NAME>|<VARNAME>) <TAG2>)
*/
  final public QuiltExpression element_constructor() throws ParseException {
    Token t=null;
    QuiltExpression e =null;
    Vector atts = new Vector();
    Vector content = new Vector();
    jj_consume_token(TAG1);
    if (jj_2_26(999)) {
      t = jj_consume_token(NAME);
    } else if (jj_2_27(999)) {
      t = jj_consume_token(VARNAME);
    } else if (jj_2_28(999)) {
      e = quilt_expression();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_29(999)) {
      atts = attribute_list();
    } else {
      ;
    }
    if (jj_2_33(999)) {
      jj_consume_token(TAG3);
    } else if (jj_2_34(999)) {
      jj_consume_token(TAG2);
      if (jj_2_30(999)) {
        content = element_content();
      } else {
        ;
      }
      jj_consume_token(TAG4);
      if (jj_2_31(999)) {
        jj_consume_token(NAME);
      } else if (jj_2_32(999)) {
        jj_consume_token(VARNAME);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(TAG2);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
        // System.err.println(t.image);
        if(e ==null)
                {if (true) return new ElementConstruct(getTagName(t.image),
                                          atts,
                                          content);}
        else
                {if (true) return new ElementConstruct(e,
                                          atts,
                                          content);}
    throw new Error("Missing return statement in function");
  }

/**
attribute_list ::= ( ( <NAME> <EQUAL> union_expression ) | union_expression )+
*/
  final public Vector attribute_list() throws ParseException {
    Token t;
    QuiltExpression e;
    Vector v = new Vector();
    label_9:
    while (true) {
      if (jj_2_35(999)) {
        /* I use atomic_value and not quilt_expression to force people to use a delimiter in case they want to write QuiltExpressions that could look ambiguous, interfering with the ">" for instance.
              */
             t = jj_consume_token(NAME);
        jj_consume_token(EQUAL);
        e = union_expression();
       v.addElement(new AttributeExpression(t.image, e));
      } else if (jj_2_36(999)) {
        /* added to support <A $tag/attribute() /> */
             e = union_expression();
       v.addElement(new AttributeExpression(null, e));
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      if (jj_2_37(999)) {
        ;
      } else {
        break label_9;
      }
    }
      {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
element_content ::= quilt_expression (<COMMA> quilt_expression)*
*/
  final public Vector element_content() throws ParseException {
    QuiltExpression e;
    Vector v = new Vector();
    e = quilt_expression();
       v.addElement(e);
    label_10:
    while (true) {
      if (jj_2_38(999)) {
        ;
      } else {
        break label_10;
      }
      jj_consume_token(COMMA);
      e = quilt_expression();
        v.addElement(e);
    }
      {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
union_expression ::= inter_expression ((<UNION>|<PIPE>) inter_expression)*
*/
  final public QuiltExpression union_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = inter_expression();
    label_11:
    while (true) {
      if (jj_2_39(999)) {
        ;
      } else {
        break label_11;
      }
       branch = true;
      if (jj_2_40(999)) {
        jj_consume_token(UNION);
      } else if (jj_2_41(999)) {
        jj_consume_token(PIPE);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      _e = inter_expression();
       v.addElement(_e);
    }
      {if (true) return branch ? new BinOpUnion(e,v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
inter_expression ::= prune_seq_expression (<INTERSECT> prune_seq_expression)*
*/
  final public QuiltExpression inter_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = prune_seq_expression();
    label_12:
    while (true) {
      if (jj_2_42(999)) {
        ;
      } else {
        break label_12;
      }
       branch = true;
      jj_consume_token(INTERSECT);
      _e = prune_seq_expression();
       v.addElement(_e);
    }
        if (branch)
          {if (true) return new BinOpIntersection(e, v);}
        else
          {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
prune_seq_expression ::= prune_filter_expression ((<BEFORE>|<AFTER>) prune_filter_expression)*
*/
  final public QuiltExpression prune_seq_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    boolean before = true;
    e = prune_filter_expression();
    label_13:
    while (true) {
      if (jj_2_43(999)) {
        ;
      } else {
        break label_13;
      }
      if (jj_2_44(999)) {
        jj_consume_token(BEFORE);
      } else if (jj_2_45(999)) {
        jj_consume_token(AFTER);
                            before = false;
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
       branch = true;
      _e = prune_filter_expression();
       v.addElement(_e);
    }
        if (branch)
        {
            if (before) {if (true) return new BinOpPruneBefore(e, v);}
            else {if (true) return new BinOpPruneAfter(e,v);}
        }
        {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
prune_filter_expression ::= simple_expression (<FILTER> simple_expression)?
*/
  final public QuiltExpression prune_filter_expression() throws ParseException {
    QuiltExpression e;
    QuiltExpression _e = null;
    boolean branch = false;
    e = simple_expression();
    if (jj_2_46(999)) {
      jj_consume_token(FILTER);
                branch = true;
      _e = simple_expression();
    } else {
      ;
    }
        if (branch)
          {if (true) return new BinOpPruneFilter(e, _e);}
        else
          {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
nav_expression ::= ( (<DOT> <DOT>) | <DOT> | ( variable filter?) | ( function_call filter?) | filter_expression ) steps?
*/
  final public QuiltExpression nav_expression() throws ParseException {
    QuiltExpression e;
    Vector v1 = new Vector();
    Vector v2 = new Vector();
    if (jj_2_49(999)) {
      jj_consume_token(DOT);
      jj_consume_token(DOT);
                  e = new ParentNode();
    } else if (jj_2_50(999)) {
      jj_consume_token(DOT);
            e = new CurrentNode();
    } else if (jj_2_51(999)) {
      // added by Arnaud: [ v=filter() { e = new FilterExpression(e,v); } ]
          e = variable();
      if (jj_2_47(999)) {
        v1 = filter();
                                 e = new FilterExpression(e,v1);
      } else {
        ;
      }
    } else if (jj_2_52(999)) {
      e = function_call();
      if (jj_2_48(999)) {
        v1 = filter();
                                      e = new FilterExpression(e,v1);
      } else {
        ;
      }
    } else if (jj_2_53(999)) {
      e = filter_expression();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_54(999)) {
      v2 = steps();
    } else {
      ;
    }
          /* edit by Xin Zhang */
          // test if the last element is the QuiltExpression.
          if(v2.size() > 0){
            Object obj = v2.elementAt(v2.size()-1);
            if(obj instanceof QuiltExpression){
              v2.removeElementAt(v2.size() -1);
              {if (true) return new Nav(e, v2, (QuiltExpression)obj);}
            }
          }
          /* end edit*/

          {if (true) return new Nav(e,v2);}
    throw new Error("Missing return statement in function");
  }

/**
variable ::= <VARNAME> filter?
*/
  final public QuiltExpression variable() throws ParseException {
    QuiltExpression e;
    Token t;
    Vector v = null;
    Var var;
    t = jj_consume_token(VARNAME);
    if (jj_2_55(999)) {
      v = filter();
    } else {
      ;
    }
        var = new Var(chop(t.image));
        if (v == null)
          {if (true) return var;}
        else
          {if (true) return new FilterExpression(var, v);}
    throw new Error("Missing return statement in function");
  }

/**
filter ::= (<LBRACKET> test_expression <RBRACKET>)+
*/
  final public Vector filter() throws ParseException {
    QuiltExpression e;
    Vector v = new Vector();
    label_14:
    while (true) {
      jj_consume_token(LBRACKET);
      e = test_expression();
      jj_consume_token(RBRACKET);
      v.addElement(e);
      if (jj_2_56(999)) {
        ;
      } else {
        break label_14;
      }
    }
          {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
steps ::= ( ( <SLASH2> location_step )| ( <SLASH> function_call filter? ) | ( <SLASH> location_step ) | deref_step )+
*/
  final public Vector steps() throws ParseException {
    Vector v = new Vector();
    Step s;
    NodeTest test;
    // following variables e, and v1 is added by Xin Zhang.
    QuiltExpression e;
    Vector v1 = new Vector();
    label_15:
    while (true) {
      if (jj_2_58(999)) {
        jj_consume_token(SLASH2);
        s = location_step();
       v.addElement( new LocationStep(Constants.DESCENDANT_SELF_AXIS,
                                      new NodeType(Constants.NODE_TYPE)));
       v.addElement(s);
      } else if (jj_2_59(999)) {
        jj_consume_token(SLASH);
        e = function_call();
        if (jj_2_57(999)) {
          v1 = filter();
                                               e = new FilterExpression(e,v1);
        } else {
          ;
        }
                                                                                     v.addElement(e); {if (true) return v;}
      } else if (jj_2_60(999)) {
        jj_consume_token(SLASH);
        s = location_step();
                                 v.addElement(s);
      } else if (jj_2_61(999)) {
        s = deref_step();
                      v.addElement(s);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      if (jj_2_62(999)) {
        ;
      } else {
        break label_15;
      }
    }
      {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
standalone_steps ::= ( ( <SLASH2> location_step ) | ( <SLASH> location_step ) | location_step |deref_step )+
*/
  final public Vector standalone_steps() throws ParseException {
    Vector v = new Vector();
    Step s;
    label_16:
    while (true) {
      if (jj_2_63(999)) {
        jj_consume_token(SLASH2);
        s = location_step();
       v.addElement( new LocationStep(Constants.DESCENDANT_SELF_AXIS,
                                      new NodeType(Constants.NODE_TYPE)));
       v.addElement(s);
      } else if (jj_2_64(999)) {
        jj_consume_token(SLASH);
        s = location_step();
                                 v.addElement(s);
      } else if (jj_2_65(999)) {
        s = location_step();
                          v.addElement(s);
      } else if (jj_2_66(999)) {
        s = deref_step();
                      v.addElement(s);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      if (jj_2_67(999)) {
        ;
      } else {
        break label_16;
      }
    }
      {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
deref_step ::= <ARROW> (<LBRACE> hints <RBRACE>)? (<LBRACKET> test_expression <RBRACKET>)*
*/
  final public Step deref_step() throws ParseException {
    Token t;
    DerefStep step = new DerefStep();
    Vector hints;
    Vector predicates = new Vector();
    QuiltExpression e;
    jj_consume_token(ARROW);
    if (jj_2_68(999)) {
      jj_consume_token(LBRACE);
      hints = hints();
                               step.setHints(hints);
      jj_consume_token(RBRACE);
    } else {
      ;
    }
    label_17:
    while (true) {
      if (jj_2_69(999)) {
        ;
      } else {
        break label_17;
      }
      jj_consume_token(LBRACKET);
      e = test_expression();
      jj_consume_token(RBRACKET);
       predicates.addElement(e);
    }
        step.setPredicates(predicates);
        {if (true) return step;}
    throw new Error("Missing return statement in function");
  }

/**
hints ::= qname <AT> qname (<COMMA> qname <AT> qname)*
*/
  final public Vector hints() throws ParseException {
    String eltName, idName;
    Vector v = new Vector();
    eltName = qname();
    jj_consume_token(AT);
    idName = qname();
      v.addElement( new DerefPair(eltName, idName) );
    label_18:
    while (true) {
      if (jj_2_70(999)) {
        ;
      } else {
        break label_18;
      }
      jj_consume_token(COMMA);
      eltName = qname();
      jj_consume_token(AT);
      idName = qname();
       v.addElement( new DerefPair(eltName, idName) );
    }
          {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
qname ::= NAME
*/
  final public String qname() throws ParseException {
    Token t;
    t = jj_consume_token(NAME);
               {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

/**
location_step ::= ( ( <DOT> <DOT> ) | ( axis? node_test ) ) (<LBRACKET> test_expression <RBRACKET>)*
*/
  final public Step location_step() throws ParseException {
    Step s;
    int a = Constants.CHILD_AXIS;
    Vector v = new Vector();
    NodeTest test;
    QuiltExpression e;
    if (jj_2_72(999)) {
      jj_consume_token(DOT);
      jj_consume_token(DOT);
                  a = Constants.PARENT_AXIS; test = null;
    } else if (jj_2_73(999)) {
      if (jj_2_71(999)) {
        a = axis();
      } else {
        ;
      }
      test = node_test();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_19:
    while (true) {
      if (jj_2_74(999)) {
        ;
      } else {
        break label_19;
      }
      jj_consume_token(LBRACKET);
      e = test_expression();
      jj_consume_token(RBRACKET);
       v.addElement(e);
    }
      {if (true) return new LocationStep(a, test, v);}
    throw new Error("Missing return statement in function");
  }

/**
test_expression ::= <NUMBER>|quilt_expression
*/
  final public QuiltExpression test_expression() throws ParseException {
    Token t;
    QuiltExpression e;
    if (jj_2_75(999)) {
      t = jj_consume_token(NUMBER);
        FunCall f = new FunPOSITION();
        f.pushArgs(new Vector());
        {if (true) return new BinOpCOMP(Constants.EQ,
                             f,
                             new ValueNum(t.image));}
    } else if (jj_2_76(999)) {
      e = quilt_expression();
                           {if (true) return e;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
axis ::= (<ANCESTOR>|<ANCESTOR_SELF>|<ATTRIBUTE>|<AT>|<CHILD>|<DESCENDANT>|<DESCENDANT_SELF>|<FOLLOWING>|<FOLLOWING_SIBLING>|<NAMESPACE>|<PARENT>|<PRECEDING>|<PRECEDING_SIBLING>|<SELF>)
*/
  final public int axis() throws ParseException {
    int a;
    if (jj_2_77(999)) {
      jj_consume_token(ANCESTOR);
                          a = Constants.ANCESTOR_AXIS;
    } else if (jj_2_78(999)) {
      jj_consume_token(ANCESTOR_SELF);
                          a = Constants.ANCESTOR_SELF_AXIS;
    } else if (jj_2_79(999)) {
      jj_consume_token(ATTRIBUTE);
                          a = Constants.ATTRIBUTE_AXIS;
    } else if (jj_2_80(999)) {
      jj_consume_token(AT);
                          a = Constants.ATTRIBUTE_AXIS;
    } else if (jj_2_81(999)) {
      jj_consume_token(CHILD);
                          a = Constants.CHILD_AXIS;
    } else if (jj_2_82(999)) {
      jj_consume_token(DESCENDANT);
                          a = Constants.DESCENDANT_AXIS;
    } else if (jj_2_83(999)) {
      jj_consume_token(DESCENDANT_SELF);
                          a = Constants.DESCENDANT_SELF_AXIS;
    } else if (jj_2_84(999)) {
      jj_consume_token(FOLLOWING);
                          a = Constants.FOLLOWING_AXIS;
    } else if (jj_2_85(999)) {
      jj_consume_token(FOLLOWING_SIBLING);
                          a = Constants.FOLLOWING_SIBLING_AXIS;
    } else if (jj_2_86(999)) {
      jj_consume_token(NAMESPACE);
                          a = Constants.NAMESPACE_AXIS;
    } else if (jj_2_87(999)) {
      jj_consume_token(PARENT);
                          a = Constants.PARENT_AXIS;
    } else if (jj_2_88(999)) {
      jj_consume_token(PRECEDING);
                          a = Constants.PRECEDING_AXIS;
    } else if (jj_2_89(999)) {
      jj_consume_token(PRECEDING_SIBLING);
                          a = Constants.PRECEDING_SIBLING_AXIS;
    } else if (jj_2_90(999)) {
      jj_consume_token(SELF);
                          a = Constants.SELF_AXIS;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

/**
node_test ::= (node_type|node_test|<STAR>)
*/
  final public NodeTest node_test() throws ParseException {
    NodeTest nodeTest;
    if (jj_2_91(999)) {
      nodeTest = node_type();
    } else if (jj_2_92(999)) {
      nodeTest = name_test();
    } else if (jj_2_93(999)) {
      jj_consume_token(STAR);
             nodeTest = new NameTest();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return nodeTest;}
    throw new Error("Missing return statement in function");
  }

/**
node_type ::= (<NODE>|<ELEMENT_NODE_TOK>|<TEXT_NODE_TOK>|<COMMENT_NODE_TOK>|<PROCESS_NODE>)<LPAREN><RPAREN>
*/
  final public NodeTest node_type() throws ParseException {
    int type;
    if (jj_2_94(999)) {
      jj_consume_token(NODE);
                        type = Constants.NODE_TYPE;
    } else if (jj_2_95(999)) {
      jj_consume_token(ELEMENT_NODE_TOK);
                            type = Constants.ELEMENT_NODE;
    } else if (jj_2_96(999)) {
      jj_consume_token(TEXT_NODE_TOK);
                            type = Constants.TEXT_NODE;
    } else if (jj_2_97(999)) {
      jj_consume_token(COMMENT_NODE_TOK);
                            type = Constants.COMMENT_NODE;
    } else if (jj_2_98(999)) {
      jj_consume_token(PROCESS_NODE);
                        type = Constants.PROCESSING_NODE;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LPAREN);
    jj_consume_token(RPAREN);
        {if (true) return new NodeType(type);}
    throw new Error("Missing return statement in function");
  }

/**
name_test ::= <NAME>
*/
  final public NodeTest name_test() throws ParseException {
    Token t;
    t = jj_consume_token(NAME);
      {if (true) return new NameTest(t.image);}
    throw new Error("Missing return statement in function");
  }

/**
simple_expression ::= or_expression
*/
  final public QuiltExpression simple_expression() throws ParseException {
    QuiltExpression e;
    e = or_expression();
      {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
or_expression ::= and_expression (<OR> and_expression)*
*/
  final public QuiltExpression or_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = and_expression();
    label_20:
    while (true) {
      if (jj_2_99(999)) {
        ;
      } else {
        break label_20;
      }
      branch = true;
      jj_consume_token(OR);
      _e = and_expression();
      v.addElement(_e);
    }
      {if (true) return branch ? new BinOpOR(e,v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
and_expression ::= comp_expression (<AND> comp_expression)*
*/
  final public QuiltExpression and_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = comp_expression();
    label_21:
    while (true) {
      if (jj_2_100(999)) {
        ;
      } else {
        break label_21;
      }
      branch = true;
      jj_consume_token(AND);
      _e = comp_expression();
      v.addElement(_e);
    }
      {if (true) return branch ? new BinOpAND(e,v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
comp_expression ::= plus_expression (operator plus_expression)?
*/
  final public QuiltExpression comp_expression() throws ParseException {
    QuiltExpression e;
    QuiltExpression _e = null;
    int op = -1;
    boolean branch = false;
    e = plus_expression();
    if (jj_2_101(999)) {
      branch = true;
      op = operator();
      _e = plus_expression();
    } else {
      ;
    }
      {if (true) return branch ? new BinOpCOMP(op,e,_e) : e;}
    throw new Error("Missing return statement in function");
  }

/**
new_comp_expression ::= <LPAREN> atomic_value operator atomic_value <RPAREN>
*/
  final public QuiltExpression new_comp_expression() throws ParseException {
    QuiltExpression e;
    QuiltExpression _e = null;
    int op = -1;
    boolean branch = false;
    jj_consume_token(LPAREN);
    e = atomic_value();
    op = operator();
    _e = atomic_value();
    jj_consume_token(RPAREN);
      {if (true) return new BinOpCOMP(op,e,_e);}
    throw new Error("Missing return statement in function");
  }

/**
operator ::= (<EQUAL>|<NEQUAL>|<GTHAN>|<GETHAN>|<LTHAN>|<LEQUAL>)
*/
  final public int operator() throws ParseException {
    int op;
    if (jj_2_102(999)) {
      jj_consume_token(EQUAL);
                 op = Constants.EQ;
    } else if (jj_2_103(999)) {
      jj_consume_token(NEQUAL);
                 op = Constants.NEQ;
    } else if (jj_2_104(999)) {
      jj_consume_token(GTHAN);
                 op = Constants.GT;
    } else if (jj_2_105(999)) {
      jj_consume_token(GEQUAL);
                 op = Constants.GEQ;
    } else if (jj_2_106(999)) {
      jj_consume_token(LTHAN);
                 op = Constants.LT;
    } else if (jj_2_107(999)) {
      jj_consume_token(LEQUAL);
                 op = Constants.LEQ;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

/**
plus_expression ::= minus_expression (<PLUS> minus_expression)*
*/
  final public QuiltExpression plus_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = minus_expression();
    label_22:
    while (true) {
      if (jj_2_108(999)) {
        ;
      } else {
        break label_22;
      }
      branch = true;
      jj_consume_token(PLUS);
      _e = minus_expression();
      v.addElement(_e);
    }
      {if (true) return branch ? new BinOpArith('+', e, v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
minus_expression ::= mult_expression (<MINUS> mult_expression)*
*/
  final public QuiltExpression minus_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = mult_expression();
    label_23:
    while (true) {
      if (jj_2_109(999)) {
        ;
      } else {
        break label_23;
      }
      branch = true;
      jj_consume_token(MINUS);
      _e = mult_expression();
      v.addElement(_e);
    }
      {if (true) return branch ? new BinOpArith('-', e, v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
mult_expression ::= div_expression (<STAR> div_expression)*
*/
  final public QuiltExpression mult_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = div_expression();
    label_24:
    while (true) {
      if (jj_2_110(999)) {
        ;
      } else {
        break label_24;
      }
      branch = true;
      jj_consume_token(STAR);
      _e = div_expression();
      v.addElement(_e);
    }
      {if (true) return branch ? new BinOpArith('*', e, v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
div_expression ::= mod_expression (<DIV> mod_expression)*
*/
  final public QuiltExpression div_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = mod_expression();
    label_25:
    while (true) {
      if (jj_2_111(999)) {
        ;
      } else {
        break label_25;
      }
      branch = true;
      jj_consume_token(DIV);
      _e = mod_expression();
      v.addElement(_e);
    }
      {if (true) return branch ? new BinOpArith('/', e, v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
mod_expression ::= unary_expression ( <MOD> unary_expression )*
*/
  final public QuiltExpression mod_expression() throws ParseException {
    QuiltExpression e, _e;
    Vector v = new Vector();
    boolean branch = false;
    e = unary_expression();
    label_26:
    while (true) {
      if (jj_2_112(2147483647)) {
        ;
      } else {
        break label_26;
      }
      branch = true;
      jj_consume_token(MOD);
      _e = unary_expression();
      v.addElement(_e);
    }
           {if (true) return branch ? new BinOpArith('%', e, v) : e;}
    throw new Error("Missing return statement in function");
  }

/**
unary_expression ::= ( ( <MINUS> atomic_value ) | ( <NOT> <LPAREN> simple_expression <RPAREN> ) | ( <NOT> simple_expression ) | atomic_value )
*/
  final public QuiltExpression unary_expression() throws ParseException {
    QuiltExpression e;
    Vector v = new Vector();
    boolean branch = false;
    if (jj_2_113(999)) {
      jj_consume_token(MINUS);
      e = atomic_value();
       {if (true) return new UnOpMinus(e);}
    } else if (jj_2_114(999)) {
      jj_consume_token(NOT);
      jj_consume_token(LPAREN);
      e = simple_expression();
      jj_consume_token(RPAREN);
        {if (true) return new UnOpNot(e);}
    } else if (jj_2_115(999)) {
      jj_consume_token(NOT);
      e = simple_expression();
        {if (true) return new UnOpNot(e);}
    } else if (jj_2_116(999)) {
      e = atomic_value();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
atomic_value ::= <TRUE>|<FALSE>|nav_expression|standalone_steps|<NUMBER>|<STRING>|<NAME>|<XML_START> <XML_END>|<element_constructor|quantify_expression|if_then_else_expression|flwr_expression
*/
  final public QuiltExpression atomic_value() throws ParseException {
    Token t;
    QuiltExpression e;
    Vector v = null;
    if (jj_2_119(999)) {
      jj_consume_token(TRUE);
             {if (true) return new ValueBool(true);}
    } else if (jj_2_120(999)) {
      jj_consume_token(FALSE);
              {if (true) return new ValueBool(false);}
    } else if (jj_2_121(999)) {
      e = nav_expression();
                          {if (true) return e;}
    } else if (jj_2_122(999)) {
      v = standalone_steps();
                            {if (true) return new Nav(new CurrentNode(), v);}
    } else if (jj_2_123(999)) {
      t = jj_consume_token(NUMBER);
                          {if (true) return new ValueNum(t.image);}
    } else if (jj_2_124(999)) {
      t = jj_consume_token(STRING);
                          {if (true) return new ValueString(unquote(t.image));}
    } else if (jj_2_125(999)) {
      t = jj_consume_token(NAME);
                          {if (true) return new QName(t.image);}
    } else if (jj_2_126(999)) {
      jj_consume_token(XML_START);
      t = jj_consume_token(XML_END);
                              {if (true) return new InLineXML(t.image);}
    } else if (jj_2_127(999)) {
      e = element_constructor();
                              {if (true) return e;}
    } else if (jj_2_128(999)) {
      e = quantify_expression();
                              {if (true) return e;}
    } else if (jj_2_129(999)) {
      e = if_then_else_expression();
                                  {if (true) return e;}
    } else if (jj_2_130(999)) {
      if (jj_2_117(999)) {
        e = flwu_expression();
      } else if (jj_2_118(999)) {
        e = flwr_expression();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
                                                  {if (true) return e;}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/**
filter_expression ::= <LPAREN> quilt_expression <RPAREN> filter?
*/
  final public QuiltExpression filter_expression() throws ParseException {
    QuiltExpression e;
    Vector v = null;
    jj_consume_token(LPAREN);
    e = quilt_expression();
    jj_consume_token(RPAREN);
    if (jj_2_131(999)) {
      v = filter();
    } else {
      ;
    }
        {if (true) return (v == null) ? e : new FilterExpression(e,v);}
    throw new Error("Missing return statement in function");
  }

/**
quantify_expression ::= ((<SOME_TOK>|<EVERY_TOK>) <VARNAME> <IN> quilt_expression <SATISFIES> simple_expression)
*/
  final public QuiltExpression quantify_expression() throws ParseException {
    int op;
    Token t;
    QuiltExpression e, cond;
    if (jj_2_132(999)) {
      jj_consume_token(SOME_TOK);
                  op = Constants.SOME;
    } else if (jj_2_133(999)) {
      jj_consume_token(EVERY_TOK);
                   op = Constants.EVERY;
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    t = jj_consume_token(VARNAME);
    jj_consume_token(IN);
    e = quilt_expression();
    jj_consume_token(SATISFIES);
    cond = simple_expression();
       {if (true) return new Quantifier(op, chop(t.image), e, cond);}
    throw new Error("Missing return statement in function");
  }

/**
if_then_else_expression ::= <IF> quilt_expression <THEN> quilt_expression <ELSE> quilt_expression
*/
  final public QuiltExpression if_then_else_expression() throws ParseException {
    QuiltExpression _if, _then, _else;
    jj_consume_token(IF);
    _if = quilt_expression();
    jj_consume_token(THEN);
    _then = quilt_expression();
    jj_consume_token(ELSE);
    _else = quilt_expression();
        {if (true) return new IfThenElse(_if, _then, _else);}
    throw new Error("Missing return statement in function");
  }

/**
function_call ::= ( <NAME> <LPAREN> ) args
*/
  final public QuiltExpression function_call() throws ParseException {
    FunCall f=null;
    Token t;
    Vector v;
    t = jj_consume_token(NAME);
    jj_consume_token(LPAREN);
         String funName =  t.image;
         if (funDefNames.containsKey(funName))
           f = new FunUserDefined( funName );
         else
         try
         {
             if (funImportNames.containsKey(funName))
             {
                 //		 System.out.println("Trying to instantiate " + funName + " as an imported function");
                 f = (FunCall) Class.forName( (String) funImportNames.get(funName) ).newInstance();
             }
             else
             {
                 // System.out.println("Trying to instantiate " + funName + " as a built-in function");
                 f = (FunCall) Class.forName("xacute.quilt.Fun" + funName.toUpperCase() ).newInstance();
             }
         }
         catch(Exception e)
         {
             e.printStackTrace(System.out);
             {if (true) throw new ParseException("Unable to instantiate " + funName);}
         }
    v = args();
    f.pushArgs(v); {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

/**
args ::= (quilt_expression (<COMMA> quilt_expression)*)? <RPAREN>
*/
  final public Vector args() throws ParseException {
    QuiltExpression e;
    Vector v = new Vector();;
    if (jj_2_135(999)) {
      e = quilt_expression();
      v.addElement(e);
      label_27:
      while (true) {
        if (jj_2_134(999)) {
          ;
        } else {
          break label_27;
        }
        jj_consume_token(COMMA);
        e = quilt_expression();
       v.addElement(e);
      }
    } else {
      ;
    }
    jj_consume_token(RPAREN);
          {if (true) return v;}
    throw new Error("Missing return statement in function");
  }

/**
flwu_expression ::= ((<FOR> for_binding (<COMMA> for_binding)*)|(<LET> let_binding (<COMMA> let_binding)* ))* (<WHERE> where_clause)? ( <UPDATE> <VARNAME> <LBRACE> update_operation <RBRACE> )
*/
  final public QuiltExpression flwu_expression() throws ParseException {
    QuiltExpression e;
    Vector updates = new Vector();
    QuiltExpression where = null;
    Binding b;
    Vector bindings = new Vector();
    Token t;
    label_28:
    while (true) {
      if (jj_2_136(999)) {
        ;
      } else {
        break label_28;
      }
      if (jj_2_139(999)) {
        jj_consume_token(FOR);
        b = for_binding(true);
                                   bindings.addElement(b);
        label_29:
        while (true) {
          if (jj_2_137(999)) {
            ;
          } else {
            break label_29;
          }
          jj_consume_token(COMMA);
          b = for_binding(false);
                                         bindings.addElement(b);
        }
      } else if (jj_2_140(999)) {
        jj_consume_token(LET);
        b = let_binding(true);
                                   bindings.addElement(b);
        label_30:
        while (true) {
          if (jj_2_138(999)) {
            ;
          } else {
            break label_30;
          }
          jj_consume_token(COMMA);
          b = let_binding(false);
                                         bindings.addElement(b);
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    if (jj_2_141(999)) {
      jj_consume_token(WHERE);
      where = where_clause();
    } else {
      ;
    }
    jj_consume_token(UPDATE);
    t = jj_consume_token(VARNAME);
    jj_consume_token(LBRACE);
    e = update_operator();
                                                       updates.addElement(e);
    label_31:
    while (true) {
      if (jj_2_142(999)) {
        ;
      } else {
        break label_31;
      }
      jj_consume_token(COMMA);
      e = update_operator();
                                                                                                              updates.addElement(e);
    }
    jj_consume_token(RBRACE);
     {if (true) return new FLWUExpression(bindings, where, t.image, updates);}
    throw new Error("Missing return statement in function");
  }

/**
update_operator ::= ( <DELETE> <VARNAME>) | ( <RENAME> <VARNAME> <TO> content ) | ( <INSERT> ( <VARNAME> ( <BEFORE> | <AFTER> <VARNAME> )? ) | update_function | ( content ( ( <BEFORE> | <AFTER> ) <VARNAME> )? ) ) | ( <REPLACE> <VARNAME> <WITH> ( update_function | content ) ) | flwu_expression
*/
  final public QuiltExpression update_operator() throws ParseException {
    QuiltExpression e=null;
    Token t;
    Token t1 = null;
    Content c = null;
    UpdateFunction u = null;
    boolean before = true;
    if (jj_2_154(999)) {
      jj_consume_token(DELETE);
      t = jj_consume_token(VARNAME);
                             e = new DeleteUpdate(t.image);
    } else if (jj_2_155(999)) {
      jj_consume_token(RENAME);
      t = jj_consume_token(VARNAME);
      jj_consume_token(TO);
      c = content();
                                              e = new RenameUpdate(t.image, c);
    } else if (jj_2_156(999)) {
      jj_consume_token(INSERT);
      if (jj_2_149(999)) {
        u = update_function();
                              e = new InsertUpdate(u);
      } else if (jj_2_150(999)) {
        t = jj_consume_token(VARNAME);
        if (jj_2_145(999)) {
          if (jj_2_143(999)) {
            jj_consume_token(BEFORE);
          } else if (jj_2_144(999)) {
            jj_consume_token(AFTER);
                                   before = false;
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
          t1 = jj_consume_token(VARNAME);
        } else {
          ;
        }
        if(t1==null)
           e = new InsertUpdate(t.image);
        else
           e = new InsertUpdate(t.image, before, t1.image);
      } else if (jj_2_151(999)) {
        c = content();
        if (jj_2_148(999)) {
          if (jj_2_146(999)) {
            jj_consume_token(BEFORE);
          } else if (jj_2_147(999)) {
            jj_consume_token(AFTER);
                                   before = false;
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
          t1 = jj_consume_token(VARNAME);
        } else {
          ;
        }
        if(t1==null)
          e = new InsertUpdate(c);
        else
          e = new InsertUpdate(c, before, t1.image);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } else if (jj_2_157(999)) {
      jj_consume_token(REPLACE);
      t = jj_consume_token(VARNAME);
      jj_consume_token(WITH);
      if (jj_2_152(999)) {
        u = update_function();
      } else if (jj_2_153(999)) {
        c = content();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
        if(c==null)
          e = new ReplaceUpdate(t.image, u);
       else
          e = new ReplaceUpdate(t.image, c);
    } else if (jj_2_158(999)) {
      e = flwu_expression();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
     {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
content ::= nav_expression | <STRING> | element_construct
*/
  final public Content content() throws ParseException {
    Token t = null;
    Content e = null;
    QuiltExpression n = null;
    QuiltExpression c = null;
    if (jj_2_159(999)) {
      n = nav_expression();
    } else if (jj_2_160(999)) {
      t = jj_consume_token(STRING);
    } else if (jj_2_161(999)) {
      c = element_constructor();
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
        if (n == null && c == null)
            e = new Content(t.image);
        else if(t == null && n == null)
            e = new Content(c);
        else
            e = new Content(n);
     {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
update_function ::= ( <NEW_ATTRIBUTE> | <NEW_REFERENCE> ) <LPAREN> <STRING> <COMMA> content <RPAREN>
*/
  final public UpdateFunction update_function() throws ParseException {
    UpdateFunction e = null;
    Token t;
    Token t1;
    Content c;
    if (jj_2_162(999)) {
      t1 = jj_consume_token(NEW_ATTRIBUTE);
    } else if (jj_2_163(999)) {
      t1 = jj_consume_token(NEW_REFERENCE);
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LPAREN);
    t = jj_consume_token(STRING);
    jj_consume_token(COMMA);
    c = content();
    jj_consume_token(RPAREN);
         e = new UpdateFunction(t1.image, t.image, c);
         {if (true) return e;}
    throw new Error("Missing return statement in function");
  }

/**
finito ::= <FINITO>
*/
  final public void finito() throws ParseException {
    jj_consume_token(FINITO);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_26();
    jj_save(25, xla);
    return retval;
  }

  final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_27();
    jj_save(26, xla);
    return retval;
  }

  final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_28();
    jj_save(27, xla);
    return retval;
  }

  final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_29();
    jj_save(28, xla);
    return retval;
  }

  final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_30();
    jj_save(29, xla);
    return retval;
  }

  final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_31();
    jj_save(30, xla);
    return retval;
  }

  final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_32();
    jj_save(31, xla);
    return retval;
  }

  final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_33();
    jj_save(32, xla);
    return retval;
  }

  final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_34();
    jj_save(33, xla);
    return retval;
  }

  final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_35();
    jj_save(34, xla);
    return retval;
  }

  final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_36();
    jj_save(35, xla);
    return retval;
  }

  final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_37();
    jj_save(36, xla);
    return retval;
  }

  final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_38();
    jj_save(37, xla);
    return retval;
  }

  final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_39();
    jj_save(38, xla);
    return retval;
  }

  final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_40();
    jj_save(39, xla);
    return retval;
  }

  final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_41();
    jj_save(40, xla);
    return retval;
  }

  final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_42();
    jj_save(41, xla);
    return retval;
  }

  final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_43();
    jj_save(42, xla);
    return retval;
  }

  final private boolean jj_2_44(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_44();
    jj_save(43, xla);
    return retval;
  }

  final private boolean jj_2_45(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_45();
    jj_save(44, xla);
    return retval;
  }

  final private boolean jj_2_46(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_46();
    jj_save(45, xla);
    return retval;
  }

  final private boolean jj_2_47(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_47();
    jj_save(46, xla);
    return retval;
  }

  final private boolean jj_2_48(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_48();
    jj_save(47, xla);
    return retval;
  }

  final private boolean jj_2_49(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_49();
    jj_save(48, xla);
    return retval;
  }

  final private boolean jj_2_50(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_50();
    jj_save(49, xla);
    return retval;
  }

  final private boolean jj_2_51(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_51();
    jj_save(50, xla);
    return retval;
  }

  final private boolean jj_2_52(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_52();
    jj_save(51, xla);
    return retval;
  }

  final private boolean jj_2_53(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_53();
    jj_save(52, xla);
    return retval;
  }

  final private boolean jj_2_54(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_54();
    jj_save(53, xla);
    return retval;
  }

  final private boolean jj_2_55(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_55();
    jj_save(54, xla);
    return retval;
  }

  final private boolean jj_2_56(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_56();
    jj_save(55, xla);
    return retval;
  }

  final private boolean jj_2_57(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_57();
    jj_save(56, xla);
    return retval;
  }

  final private boolean jj_2_58(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_58();
    jj_save(57, xla);
    return retval;
  }

  final private boolean jj_2_59(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_59();
    jj_save(58, xla);
    return retval;
  }

  final private boolean jj_2_60(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_60();
    jj_save(59, xla);
    return retval;
  }

  final private boolean jj_2_61(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_61();
    jj_save(60, xla);
    return retval;
  }

  final private boolean jj_2_62(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_62();
    jj_save(61, xla);
    return retval;
  }

  final private boolean jj_2_63(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_63();
    jj_save(62, xla);
    return retval;
  }

  final private boolean jj_2_64(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_64();
    jj_save(63, xla);
    return retval;
  }

  final private boolean jj_2_65(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_65();
    jj_save(64, xla);
    return retval;
  }

  final private boolean jj_2_66(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_66();
    jj_save(65, xla);
    return retval;
  }

  final private boolean jj_2_67(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_67();
    jj_save(66, xla);
    return retval;
  }

  final private boolean jj_2_68(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_68();
    jj_save(67, xla);
    return retval;
  }

  final private boolean jj_2_69(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_69();
    jj_save(68, xla);
    return retval;
  }

  final private boolean jj_2_70(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_70();
    jj_save(69, xla);
    return retval;
  }

  final private boolean jj_2_71(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_71();
    jj_save(70, xla);
    return retval;
  }

  final private boolean jj_2_72(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_72();
    jj_save(71, xla);
    return retval;
  }

  final private boolean jj_2_73(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_73();
    jj_save(72, xla);
    return retval;
  }

  final private boolean jj_2_74(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_74();
    jj_save(73, xla);
    return retval;
  }

  final private boolean jj_2_75(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_75();
    jj_save(74, xla);
    return retval;
  }

  final private boolean jj_2_76(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_76();
    jj_save(75, xla);
    return retval;
  }

  final private boolean jj_2_77(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_77();
    jj_save(76, xla);
    return retval;
  }

  final private boolean jj_2_78(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_78();
    jj_save(77, xla);
    return retval;
  }

  final private boolean jj_2_79(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_79();
    jj_save(78, xla);
    return retval;
  }

  final private boolean jj_2_80(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_80();
    jj_save(79, xla);
    return retval;
  }

  final private boolean jj_2_81(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_81();
    jj_save(80, xla);
    return retval;
  }

  final private boolean jj_2_82(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_82();
    jj_save(81, xla);
    return retval;
  }

  final private boolean jj_2_83(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_83();
    jj_save(82, xla);
    return retval;
  }

  final private boolean jj_2_84(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_84();
    jj_save(83, xla);
    return retval;
  }

  final private boolean jj_2_85(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_85();
    jj_save(84, xla);
    return retval;
  }

  final private boolean jj_2_86(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_86();
    jj_save(85, xla);
    return retval;
  }

  final private boolean jj_2_87(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_87();
    jj_save(86, xla);
    return retval;
  }

  final private boolean jj_2_88(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_88();
    jj_save(87, xla);
    return retval;
  }

  final private boolean jj_2_89(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_89();
    jj_save(88, xla);
    return retval;
  }

  final private boolean jj_2_90(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_90();
    jj_save(89, xla);
    return retval;
  }

  final private boolean jj_2_91(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_91();
    jj_save(90, xla);
    return retval;
  }

  final private boolean jj_2_92(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_92();
    jj_save(91, xla);
    return retval;
  }

  final private boolean jj_2_93(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_93();
    jj_save(92, xla);
    return retval;
  }

  final private boolean jj_2_94(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_94();
    jj_save(93, xla);
    return retval;
  }

  final private boolean jj_2_95(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_95();
    jj_save(94, xla);
    return retval;
  }

  final private boolean jj_2_96(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_96();
    jj_save(95, xla);
    return retval;
  }

  final private boolean jj_2_97(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_97();
    jj_save(96, xla);
    return retval;
  }

  final private boolean jj_2_98(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_98();
    jj_save(97, xla);
    return retval;
  }

  final private boolean jj_2_99(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_99();
    jj_save(98, xla);
    return retval;
  }

  final private boolean jj_2_100(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_100();
    jj_save(99, xla);
    return retval;
  }

  final private boolean jj_2_101(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_101();
    jj_save(100, xla);
    return retval;
  }

  final private boolean jj_2_102(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_102();
    jj_save(101, xla);
    return retval;
  }

  final private boolean jj_2_103(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_103();
    jj_save(102, xla);
    return retval;
  }

  final private boolean jj_2_104(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_104();
    jj_save(103, xla);
    return retval;
  }

  final private boolean jj_2_105(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_105();
    jj_save(104, xla);
    return retval;
  }

  final private boolean jj_2_106(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_106();
    jj_save(105, xla);
    return retval;
  }

  final private boolean jj_2_107(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_107();
    jj_save(106, xla);
    return retval;
  }

  final private boolean jj_2_108(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_108();
    jj_save(107, xla);
    return retval;
  }

  final private boolean jj_2_109(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_109();
    jj_save(108, xla);
    return retval;
  }

  final private boolean jj_2_110(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_110();
    jj_save(109, xla);
    return retval;
  }

  final private boolean jj_2_111(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_111();
    jj_save(110, xla);
    return retval;
  }

  final private boolean jj_2_112(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_112();
    jj_save(111, xla);
    return retval;
  }

  final private boolean jj_2_113(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_113();
    jj_save(112, xla);
    return retval;
  }

  final private boolean jj_2_114(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_114();
    jj_save(113, xla);
    return retval;
  }

  final private boolean jj_2_115(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_115();
    jj_save(114, xla);
    return retval;
  }

  final private boolean jj_2_116(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_116();
    jj_save(115, xla);
    return retval;
  }

  final private boolean jj_2_117(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_117();
    jj_save(116, xla);
    return retval;
  }

  final private boolean jj_2_118(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_118();
    jj_save(117, xla);
    return retval;
  }

  final private boolean jj_2_119(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_119();
    jj_save(118, xla);
    return retval;
  }

  final private boolean jj_2_120(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_120();
    jj_save(119, xla);
    return retval;
  }

  final private boolean jj_2_121(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_121();
    jj_save(120, xla);
    return retval;
  }

  final private boolean jj_2_122(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_122();
    jj_save(121, xla);
    return retval;
  }

  final private boolean jj_2_123(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_123();
    jj_save(122, xla);
    return retval;
  }

  final private boolean jj_2_124(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_124();
    jj_save(123, xla);
    return retval;
  }

  final private boolean jj_2_125(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_125();
    jj_save(124, xla);
    return retval;
  }

  final private boolean jj_2_126(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_126();
    jj_save(125, xla);
    return retval;
  }

  final private boolean jj_2_127(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_127();
    jj_save(126, xla);
    return retval;
  }

  final private boolean jj_2_128(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_128();
    jj_save(127, xla);
    return retval;
  }

  final private boolean jj_2_129(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_129();
    jj_save(128, xla);
    return retval;
  }

  final private boolean jj_2_130(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_130();
    jj_save(129, xla);
    return retval;
  }

  final private boolean jj_2_131(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_131();
    jj_save(130, xla);
    return retval;
  }

  final private boolean jj_2_132(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_132();
    jj_save(131, xla);
    return retval;
  }

  final private boolean jj_2_133(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_133();
    jj_save(132, xla);
    return retval;
  }

  final private boolean jj_2_134(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_134();
    jj_save(133, xla);
    return retval;
  }

  final private boolean jj_2_135(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_135();
    jj_save(134, xla);
    return retval;
  }

  final private boolean jj_2_136(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_136();
    jj_save(135, xla);
    return retval;
  }

  final private boolean jj_2_137(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_137();
    jj_save(136, xla);
    return retval;
  }

  final private boolean jj_2_138(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_138();
    jj_save(137, xla);
    return retval;
  }

  final private boolean jj_2_139(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_139();
    jj_save(138, xla);
    return retval;
  }

  final private boolean jj_2_140(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_140();
    jj_save(139, xla);
    return retval;
  }

  final private boolean jj_2_141(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_141();
    jj_save(140, xla);
    return retval;
  }

  final private boolean jj_2_142(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_142();
    jj_save(141, xla);
    return retval;
  }

  final private boolean jj_2_143(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_143();
    jj_save(142, xla);
    return retval;
  }

  final private boolean jj_2_144(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_144();
    jj_save(143, xla);
    return retval;
  }

  final private boolean jj_2_145(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_145();
    jj_save(144, xla);
    return retval;
  }

  final private boolean jj_2_146(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_146();
    jj_save(145, xla);
    return retval;
  }

  final private boolean jj_2_147(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_147();
    jj_save(146, xla);
    return retval;
  }

  final private boolean jj_2_148(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_148();
    jj_save(147, xla);
    return retval;
  }

  final private boolean jj_2_149(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_149();
    jj_save(148, xla);
    return retval;
  }

  final private boolean jj_2_150(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_150();
    jj_save(149, xla);
    return retval;
  }

  final private boolean jj_2_151(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_151();
    jj_save(150, xla);
    return retval;
  }

  final private boolean jj_2_152(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_152();
    jj_save(151, xla);
    return retval;
  }

  final private boolean jj_2_153(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_153();
    jj_save(152, xla);
    return retval;
  }

  final private boolean jj_2_154(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_154();
    jj_save(153, xla);
    return retval;
  }

  final private boolean jj_2_155(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_155();
    jj_save(154, xla);
    return retval;
  }

  final private boolean jj_2_156(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_156();
    jj_save(155, xla);
    return retval;
  }

  final private boolean jj_2_157(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_157();
    jj_save(156, xla);
    return retval;
  }

  final private boolean jj_2_158(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_158();
    jj_save(157, xla);
    return retval;
  }

  final private boolean jj_2_159(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_159();
    jj_save(158, xla);
    return retval;
  }

  final private boolean jj_2_160(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_160();
    jj_save(159, xla);
    return retval;
  }

  final private boolean jj_2_161(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_161();
    jj_save(160, xla);
    return retval;
  }

  final private boolean jj_2_162(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_162();
    jj_save(161, xla);
    return retval;
  }

  final private boolean jj_2_163(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_163();
    jj_save(162, xla);
    return retval;
  }

  final private boolean jj_3_131() {
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_131()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_24() {
    if (jj_scan_token(DESC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_74() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_71() {
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_23() {
    if (jj_scan_token(ASC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_25() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3_24()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_73() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_71()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_72() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_117() {
    if (jj_3R_72()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_72()) {
    jj_scanpos = xsp;
    if (jj_3_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_74()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_130() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_117()) {
    jj_scanpos = xsp;
    if (jj_3_118()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_25()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_129() {
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_128() {
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_127() {
    if (jj_3R_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_126() {
    if (jj_scan_token(XML_START)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(XML_END)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_125() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_22() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_124() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_123() {
    if (jj_scan_token(NUMBER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_122() {
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_scan_token(SORTBY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_42()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_22()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_121() {
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_120() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_119()) {
    jj_scanpos = xsp;
    if (jj_3_120()) {
    jj_scanpos = xsp;
    if (jj_3_121()) {
    jj_scanpos = xsp;
    if (jj_3_122()) {
    jj_scanpos = xsp;
    if (jj_3_123()) {
    jj_scanpos = xsp;
    if (jj_3_124()) {
    jj_scanpos = xsp;
    if (jj_3_125()) {
    jj_scanpos = xsp;
    if (jj_3_126()) {
    jj_scanpos = xsp;
    if (jj_3_127()) {
    jj_scanpos = xsp;
    if (jj_3_128()) {
    jj_scanpos = xsp;
    if (jj_3_129()) {
    jj_scanpos = xsp;
    if (jj_3_130()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_119() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_70() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(AT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(AT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_70()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_116() {
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_21() {
    if (jj_scan_token(DISTINCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DEF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_21()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_69() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_68() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_115() {
    if (jj_scan_token(NOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    if (jj_scan_token(ARROW)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_68()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_69()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_114() {
    if (jj_scan_token(NOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_113() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_71()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_113()) {
    jj_scanpos = xsp;
    if (jj_3_114()) {
    jj_scanpos = xsp;
    if (jj_3_115()) {
    jj_scanpos = xsp;
    if (jj_3_116()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_20() {
    if (jj_scan_token(DISTINCT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_20()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_112() {
    if (jj_scan_token(MOD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_66() {
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_65() {
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_57() {
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_64() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_scan_token(MOD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_19() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_scan_token(WHERE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_67() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_63()) {
    jj_scanpos = xsp;
    if (jj_3_64()) {
    jj_scanpos = xsp;
    if (jj_3_65()) {
    jj_scanpos = xsp;
    if (jj_3_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_63() {
    if (jj_scan_token(SLASH2)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_70() {
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_85()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_75() {
    Token xsp;
    if (jj_3_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_67()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_scan_token(LET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_15()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_16() {
    if (jj_scan_token(FOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_14()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_61() {
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_73() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_13()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    xsp = jj_scanpos;
    if (jj_3_18()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RETURN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_19()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_60() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_111() {
    if (jj_scan_token(DIV)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_163() {
    if (jj_scan_token(NEW_REFERENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_111()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_59() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_57()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_62() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_58()) {
    jj_scanpos = xsp;
    if (jj_3_59()) {
    jj_scanpos = xsp;
    if (jj_3_60()) {
    jj_scanpos = xsp;
    if (jj_3_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_58() {
    if (jj_scan_token(SLASH2)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    Token xsp;
    if (jj_3_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_62()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_110() {
    if (jj_scan_token(STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_110()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_12()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_162() {
    if (jj_scan_token(NEW_ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_162()) {
    jj_scanpos = xsp;
    if (jj_3_163()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_56() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    Token xsp;
    if (jj_3_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_56()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_35() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_109() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_68()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_3R_68()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_109()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_55() {
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_55()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_161() {
    if (jj_3R_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_9()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_160() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_108() {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_108()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_159() {
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_142() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_159()) {
    jj_scanpos = xsp;
    if (jj_3_160()) {
    jj_scanpos = xsp;
    if (jj_3_161()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_48() {
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_158() {
    if (jj_3R_72()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_107() {
    if (jj_scan_token(LEQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_47() {
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_106() {
    if (jj_scan_token(LTHAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_105() {
    if (jj_scan_token(GEQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_104() {
    if (jj_scan_token(GTHAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(CLASSNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_147() {
    if (jj_scan_token(AFTER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_103() {
    if (jj_scan_token(NEQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_102() {
    if (jj_scan_token(EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_153() {
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_102()) {
    jj_scanpos = xsp;
    if (jj_3_103()) {
    jj_scanpos = xsp;
    if (jj_3_104()) {
    jj_scanpos = xsp;
    if (jj_3_105()) {
    jj_scanpos = xsp;
    if (jj_3_106()) {
    jj_scanpos = xsp;
    if (jj_3_107()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_54() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_152() {
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(FUNCTION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_7()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_53() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    Token xsp;
    if (jj_3_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_8()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_144() {
    if (jj_scan_token(AFTER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_157() {
    if (jj_scan_token(REPLACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(WITH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_152()) {
    jj_scanpos = xsp;
    if (jj_3_153()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_52() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_48()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_146() {
    if (jj_scan_token(BEFORE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_148() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_146()) {
    jj_scanpos = xsp;
    if (jj_3_147()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_51() {
    if (jj_3R_50()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_47()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_50() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_49() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_49()) {
    jj_scanpos = xsp;
    if (jj_3_50()) {
    jj_scanpos = xsp;
    if (jj_3_51()) {
    jj_scanpos = xsp;
    if (jj_3_52()) {
    jj_scanpos = xsp;
    if (jj_3_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_54()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_151() {
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_148()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_143() {
    if (jj_scan_token(BEFORE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_145() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_143()) {
    jj_scanpos = xsp;
    if (jj_3_144()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_150() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_145()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(IMPORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(AS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3_4()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    Token xsp;
    if (jj_3_5()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_5()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_149() {
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_156() {
    if (jj_scan_token(INSERT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_149()) {
    jj_scanpos = xsp;
    if (jj_3_150()) {
    jj_scanpos = xsp;
    if (jj_3_151()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_101() {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_155() {
    if (jj_scan_token(RENAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() {
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_101()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_154() {
    if (jj_scan_token(DELETE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_46() {
    if (jj_scan_token(FILTER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_154()) {
    jj_scanpos = xsp;
    if (jj_3_155()) {
    jj_scanpos = xsp;
    if (jj_3_156()) {
    jj_scanpos = xsp;
    if (jj_3_157()) {
    jj_scanpos = xsp;
    if (jj_3_158()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_46()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_32()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_45() {
    if (jj_scan_token(AFTER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_100()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_100() {
    if (jj_scan_token(AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_138() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_141() {
    if (jj_scan_token(WHERE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_44() {
    if (jj_scan_token(BEFORE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_137() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_140() {
    if (jj_scan_token(LET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_39()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_138()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_43() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_44()) {
    jj_scanpos = xsp;
    if (jj_3_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_43()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_136() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_139()) {
    jj_scanpos = xsp;
    if (jj_3_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_139() {
    if (jj_scan_token(FOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_137()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_72() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_136()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    xsp = jj_scanpos;
    if (jj_3_141()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(UPDATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_142()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_99() {
    if (jj_scan_token(OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_63()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() {
    if (jj_3R_63()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_99()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_42() {
    if (jj_scan_token(INTERSECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_3R_82()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_42()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_134() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_135() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_134()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_135()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_41() {
    if (jj_scan_token(PIPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_40() {
    if (jj_scan_token(UNION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_39() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_40()) {
    jj_scanpos = xsp;
    if (jj_3_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_3R_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_39()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_98() {
    if (jj_scan_token(PROCESS_NODE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_97() {
    if (jj_scan_token(COMMENT_NODE_TOK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_96() {
    if (jj_scan_token(TEXT_NODE_TOK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_95() {
    if (jj_scan_token(ELEMENT_NODE_TOK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_94() {
    if (jj_scan_token(NODE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_94()) {
    jj_scanpos = xsp;
    if (jj_3_95()) {
    jj_scanpos = xsp;
    if (jj_3_96()) {
    jj_scanpos = xsp;
    if (jj_3_97()) {
    jj_scanpos = xsp;
    if (jj_3_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_38() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_38()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_93() {
    if (jj_scan_token(STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_92() {
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_91() {
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_91()) {
    jj_scanpos = xsp;
    if (jj_3_92()) {
    jj_scanpos = xsp;
    if (jj_3_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_83()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_36() {
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_35()) {
    jj_scanpos = xsp;
    if (jj_3_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_35() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    Token xsp;
    if (jj_3_37()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_37()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_90() {
    if (jj_scan_token(SELF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_89() {
    if (jj_scan_token(PRECEDING_SIBLING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_28() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_88() {
    if (jj_scan_token(PRECEDING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_87() {
    if (jj_scan_token(PARENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_86() {
    if (jj_scan_token(NAMESPACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_78() {
    if (jj_scan_token(IF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(THEN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_85() {
    if (jj_scan_token(FOLLOWING_SIBLING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_84() {
    if (jj_scan_token(FOLLOWING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_83() {
    if (jj_scan_token(DESCENDANT_SELF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_32() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_82() {
    if (jj_scan_token(DESCENDANT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_81() {
    if (jj_scan_token(CHILD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_80() {
    if (jj_scan_token(AT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_79() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_78() {
    if (jj_scan_token(ANCESTOR_SELF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_77() {
    if (jj_scan_token(ANCESTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_27() {
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_31() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_77()) {
    jj_scanpos = xsp;
    if (jj_3_78()) {
    jj_scanpos = xsp;
    if (jj_3_79()) {
    jj_scanpos = xsp;
    if (jj_3_80()) {
    jj_scanpos = xsp;
    if (jj_3_81()) {
    jj_scanpos = xsp;
    if (jj_3_82()) {
    jj_scanpos = xsp;
    if (jj_3_83()) {
    jj_scanpos = xsp;
    if (jj_3_84()) {
    jj_scanpos = xsp;
    if (jj_3_85()) {
    jj_scanpos = xsp;
    if (jj_3_86()) {
    jj_scanpos = xsp;
    if (jj_3_87()) {
    jj_scanpos = xsp;
    if (jj_3_88()) {
    jj_scanpos = xsp;
    if (jj_3_89()) {
    jj_scanpos = xsp;
    if (jj_3_90()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_30() {
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_26() {
    if (jj_scan_token(NAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_133() {
    if (jj_scan_token(EVERY_TOK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_34() {
    if (jj_scan_token(TAG2)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_30()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TAG4)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_31()) {
    jj_scanpos = xsp;
    if (jj_3_32()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TAG2)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_76() {
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_132() {
    if (jj_scan_token(SOME_TOK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_33() {
    if (jj_scan_token(TAG3)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_29() {
    if (jj_3R_43()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_77() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_132()) {
    jj_scanpos = xsp;
    if (jj_3_133()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(VARNAME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SATISFIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() {
    if (jj_scan_token(TAG1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_26()) {
    jj_scanpos = xsp;
    if (jj_3_27()) {
    jj_scanpos = xsp;
    if (jj_3_28()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_29()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_33()) {
    jj_scanpos = xsp;
    if (jj_3_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_118() {
    if (jj_3R_73()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_75()) {
    jj_scanpos = xsp;
    if (jj_3_76()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_75() {
    if (jj_scan_token(NUMBER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public QuiltParserTokenManager token_source;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[0];
  final private int[] jj_la1_0 = {};
  final private int[] jj_la1_1 = {};
  final private int[] jj_la1_2 = {};
  final private int[] jj_la1_3 = {};
  final private JJCalls[] jj_2_rtns = new JJCalls[163];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public QuiltParser(CharStream stream) {
    token_source = new QuiltParserTokenManager(stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(CharStream stream) {
    token_source.ReInit(stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public QuiltParser(QuiltParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(QuiltParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[115];
    for (int i = 0; i < 115; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 115; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 163; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
            case 43: jj_3_44(); break;
            case 44: jj_3_45(); break;
            case 45: jj_3_46(); break;
            case 46: jj_3_47(); break;
            case 47: jj_3_48(); break;
            case 48: jj_3_49(); break;
            case 49: jj_3_50(); break;
            case 50: jj_3_51(); break;
            case 51: jj_3_52(); break;
            case 52: jj_3_53(); break;
            case 53: jj_3_54(); break;
            case 54: jj_3_55(); break;
            case 55: jj_3_56(); break;
            case 56: jj_3_57(); break;
            case 57: jj_3_58(); break;
            case 58: jj_3_59(); break;
            case 59: jj_3_60(); break;
            case 60: jj_3_61(); break;
            case 61: jj_3_62(); break;
            case 62: jj_3_63(); break;
            case 63: jj_3_64(); break;
            case 64: jj_3_65(); break;
            case 65: jj_3_66(); break;
            case 66: jj_3_67(); break;
            case 67: jj_3_68(); break;
            case 68: jj_3_69(); break;
            case 69: jj_3_70(); break;
            case 70: jj_3_71(); break;
            case 71: jj_3_72(); break;
            case 72: jj_3_73(); break;
            case 73: jj_3_74(); break;
            case 74: jj_3_75(); break;
            case 75: jj_3_76(); break;
            case 76: jj_3_77(); break;
            case 77: jj_3_78(); break;
            case 78: jj_3_79(); break;
            case 79: jj_3_80(); break;
            case 80: jj_3_81(); break;
            case 81: jj_3_82(); break;
            case 82: jj_3_83(); break;
            case 83: jj_3_84(); break;
            case 84: jj_3_85(); break;
            case 85: jj_3_86(); break;
            case 86: jj_3_87(); break;
            case 87: jj_3_88(); break;
            case 88: jj_3_89(); break;
            case 89: jj_3_90(); break;
            case 90: jj_3_91(); break;
            case 91: jj_3_92(); break;
            case 92: jj_3_93(); break;
            case 93: jj_3_94(); break;
            case 94: jj_3_95(); break;
            case 95: jj_3_96(); break;
            case 96: jj_3_97(); break;
            case 97: jj_3_98(); break;
            case 98: jj_3_99(); break;
            case 99: jj_3_100(); break;
            case 100: jj_3_101(); break;
            case 101: jj_3_102(); break;
            case 102: jj_3_103(); break;
            case 103: jj_3_104(); break;
            case 104: jj_3_105(); break;
            case 105: jj_3_106(); break;
            case 106: jj_3_107(); break;
            case 107: jj_3_108(); break;
            case 108: jj_3_109(); break;
            case 109: jj_3_110(); break;
            case 110: jj_3_111(); break;
            case 111: jj_3_112(); break;
            case 112: jj_3_113(); break;
            case 113: jj_3_114(); break;
            case 114: jj_3_115(); break;
            case 115: jj_3_116(); break;
            case 116: jj_3_117(); break;
            case 117: jj_3_118(); break;
            case 118: jj_3_119(); break;
            case 119: jj_3_120(); break;
            case 120: jj_3_121(); break;
            case 121: jj_3_122(); break;
            case 122: jj_3_123(); break;
            case 123: jj_3_124(); break;
            case 124: jj_3_125(); break;
            case 125: jj_3_126(); break;
            case 126: jj_3_127(); break;
            case 127: jj_3_128(); break;
            case 128: jj_3_129(); break;
            case 129: jj_3_130(); break;
            case 130: jj_3_131(); break;
            case 131: jj_3_132(); break;
            case 132: jj_3_133(); break;
            case 133: jj_3_134(); break;
            case 134: jj_3_135(); break;
            case 135: jj_3_136(); break;
            case 136: jj_3_137(); break;
            case 137: jj_3_138(); break;
            case 138: jj_3_139(); break;
            case 139: jj_3_140(); break;
            case 140: jj_3_141(); break;
            case 141: jj_3_142(); break;
            case 142: jj_3_143(); break;
            case 143: jj_3_144(); break;
            case 144: jj_3_145(); break;
            case 145: jj_3_146(); break;
            case 146: jj_3_147(); break;
            case 147: jj_3_148(); break;
            case 148: jj_3_149(); break;
            case 149: jj_3_150(); break;
            case 150: jj_3_151(); break;
            case 151: jj_3_152(); break;
            case 152: jj_3_153(); break;
            case 153: jj_3_154(); break;
            case 154: jj_3_155(); break;
            case 155: jj_3_156(); break;
            case 156: jj_3_157(); break;
            case 157: jj_3_158(); break;
            case 158: jj_3_159(); break;
            case 159: jj_3_160(); break;
            case 160: jj_3_161(); break;
            case 161: jj_3_162(); break;
            case 162: jj_3_163(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
