package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.NodeFactory;
import xacute.common.NodeList;
import xacute.common.QuiltException;
import org.xml.sax.helpers.AttributeListImpl;
import java.util.Vector;

public class SequenceExpression extends QuiltExpression
{
    /** This array contains <code>QuiltExpression</code> objects to insert inside the constructed element. */
    private QuiltExpression[] content;

    SequenceExpression(Vector content)
    {
        this.content = new QuiltExpression[content.size()];
        content.toArray(this.content);
    }
    Value eval(EvalContext con) throws QuiltException
    {
        NodeFactory nf = con.getNodeFactory();
        NodeList new_nl = con.getNodeFactory().makeEmptyNodeList();
        for (int k = 0; k < this.content.length; k++)
        {
            Value v = this.content[k].eval(con);
            new_nl.APPEND(v.toNodeList(con));
        }
        return new ValueNodeList(new_nl);
    }
    public QuiltExpression[] getContent(){
	    return content;
    }
    public String pprint()
    {
        StringBuffer buf = new StringBuffer();
        if (this.content.length > 0)
        {
            for (int i = 0; i < this.content.length; ++i)
                buf.append(this.content[i].pprint() + "\n");
        }
        return buf.toString();
    }
}
