package xacute.quilt;

import xacute.common.QuiltException;

/**
 *
 * ONLY SUPPORT SINGLE CLAUSE SORT
 *
 */
public class SortClause
    implements PPrintable
{
    
    /**
     * This field is the expression
     * according which the results
     * must be sorted.
     */
    private QuiltExpression e;

    /**
     * This field indicates
     * if the results
     * must be sorted in
     * descending order.
     */
    private boolean descOrder;

    SortClause(QuiltExpression e, boolean descOrder)
    {
	this.e = e;
	this.descOrder = descOrder;
    }
    Value eval(EvalContext con)
	throws QuiltException
    {
	return this.e.eval(con);
    }
    public boolean getDescOrder(){
	    return this.descOrder;
    }
    public QuiltExpression getE() {
	    return e;
    }
    /**
     * Tests if the results
     * must be sorted in
     * descending order.
     */
    boolean isDescending()
    { 
	return this.descOrder; 
    }
    public String pprint()
    {
	return "SORTBY " 
	    + this.e.pprint() + 
	    (this.descOrder ? " DESCENDING" : "");
    }
}
