package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.NodeList;
import xacute.common.QuiltException;

public abstract class Step
{


    /**
     * This array
     * contains <code>QuiltExpression</code>
     * representing the predicates to apply
     * after the dereferencing step.
     */
    protected QuiltExpression[] predicates = new QuiltExpression[0];

    /**
     * Returns the evaluation of a <code>Step</code> as a
     * <code>NodeList</code>.
     * @param n   the context-node of evaluation
     * @param con the evaluation context
     */
    abstract NodeList evalStep(Node n, EvalContext con)
	throws QuiltException;
    public QuiltExpression[] getPredicates(){
	    return this.predicates;
    }
    public abstract String pprint();
}
