/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */



/**
 * DOMUtil.java
 *
 *
 * Created: Tue Jun 27 17:00:32 2000
 *
 * Some useful method to provide services not directly offered by DOM:
 * - ancestors
 * - descendants
 * - etc.
 * The other methods are simply rerouted to DOM.
 *
 * Just use the methods instead of DOM
 *
 *
 * @author Arnaud Sahuguet
 * @version
 */

package xacute.util;

import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;

import java.util.Hashtable;
import java.util.Vector;

import xacute.common.Hint;


class DOMNodeList
    implements NodeList
{
    private Vector list;
    
    public DOMNodeList()
    {
	this.list = new Vector();
    }
    
    public DOMNodeList append(NodeList nl)
    {
	for(int i=0; i<nl.getLength(); i++)
	    this.list.addElement(nl.item(i));
	return this;
    }
    
    public int getLength()
    {
	return this.list.size();
    }
    
    public void addElement(Node n)
    {
	this.list.addElement(n);
    }

    public Node item(int i)
    {
	return (Node) this.list.elementAt(i);
    }	
    
} // DOMNodeList
