/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package xacute.util;

import xacute.common.Node;
import xacute.common.QuiltException;
import xacute.common.Semantics;

public class NodeHelper
{
    /** Use sem to specify your semantics. */
    public static String print(Node n)
    {
        try
        {
            xacute.util.ToStringHandler tsh = new xacute.util.ToStringHandler();
            n.toSAX(tsh);
            return tsh.toString();
        }
        catch (Exception e) { }
        return "error in printing node";
    }

    public static float toFloat(Node n, Semantics sem) throws QuiltException
    {
        String s = n.stringValue();
        try
        {
            // return new Float(s).floatValue();
            return stringToFloat(s);
        }
        catch (Exception e)
        {
            throw new QuiltException(e.toString());
        }
    }

    public static boolean toBool(Node n, Semantics sem)
    {
        return true;
    }

    public static String toString(Node n, Semantics sem)
    {
        return n.stringValue();
    }

    public static String normalize(String s)
    {
        try
        {
            return new Float(stringToFloat(s)).toString();
        }
        catch (Exception e)
        {
            return s;
        }
    }

    private static float stringToFloat(String s) throws QuiltException
    {
        String tmp = s.replace('+', ' ').trim();
        try
        {
            try
            {
                return new Float(s).floatValue();
            }
            catch (NumberFormatException e)
            {
                int offset;
                offset = tmp.indexOf(" ");
                // System.out.println("Converting " + tmp.substring(0,offset) );
                int core = new Integer(tmp.substring(0, offset).trim()).intValue();
                tmp = tmp.substring(offset + 1);
                offset = tmp.indexOf("/");
                // System.out.println("Converting " + tmp.substring(0,offset) );
                int up = new Integer(tmp.substring(0, offset).trim()).intValue();
                tmp = tmp.substring(offset + 1);
                // System.out.println("Converting " + tmp );
                int down = new Integer(tmp.trim()).intValue();
                return core + (float)up / (float)down;
            }
        }
        catch (Exception e)
        {
            throw new QuiltException("in xacute.util.NodeHelper.stringToFloat()");
        }
    }
}
