/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package xacute.util;

import xacute.common.NodeList;
import xacute.common.QuiltException;
import xacute.common.QuiltException;
import xacute.common.Semantics;

public class NodeListHelper
{
    public static float average(NodeList nl, Semantics sem) throws QuiltException
    {
        if (nl.size() == 0)
            throw new QuiltException("xacute.util.NodeListHelper.average: average of empty nodelist not defined");
        float f = 0;
        for (int k = 0; k < nl.size(); k++)
            f += NodeHelper.toFloat(nl.get(k), sem);
        return f / nl.size();
    }

    public static float min(NodeList nl, Semantics sem) throws QuiltException
    {
        if (nl.size() == 0)
            throw new QuiltException("xacute.util.NodeListHelper.min: min of empty nodelist not defined");
        float f = NodeHelper.toFloat(nl.get(0), sem);
        for (int k = 1; k < nl.size(); k++)
            f = Math.min(f, NodeHelper.toFloat(nl.get(k), sem));
        return f;
    }

    public static float max(NodeList nl, Semantics sem) throws QuiltException
    {
        if (nl.size() == 0)
            throw new QuiltException("xacute.util.NodeListHelper.max: max of empty nodelist not defined");
        float f = NodeHelper.toFloat(nl.get(0), sem);
        for (int k = 1; k < nl.size(); k++)
            f = Math.max(f, NodeHelper.toFloat(nl.get(k), sem));
        return f;
    }

    public static float sum(NodeList nl, Semantics sem) throws QuiltException
    {
        float f = 0;
        for (int k = 0; k < nl.size(); k++)
            f += NodeHelper.toFloat(nl.get(k), sem);
        return f;
    }
}
