package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues;

import java.io.Serializable;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;

/**
 * This class implements teh KeyInteface.
 * Creation date: (2/2/2003 10:43:28 PM)
 * @author: Asima Silva
 */
public class KeyDouble extends XATDataValueImp implements KeyInterface, Serializable {
	protected double key;
/**
 * KeyDouble constructor comment.
 */
public KeyDouble() {
	super();
}
	/**
	 * Compares this object with the specified object for order.  Returns a
	 * negative integer, zero, or a positive integer as this object is less
	 * than, equal to, or greater than the specified object.<p>
	 *
	 * The implementor must ensure <tt>sgn(x.compareTo(y)) ==
	 * -sgn(y.compareTo(x))</tt> for all <tt>x</tt> and <tt>y</tt>.  (This
	 * implies that <tt>x.compareTo(y)</tt> must throw an exception iff
	 * <tt>y.compareTo(x)</tt> throws an exception.)<p>
	 *
	 * The implementor must also ensure that the relation is transitive:
	 * <tt>(x.compareTo(y)&gt;0 &amp;&amp; y.compareTo(z)&gt;0)</tt> implies
	 * <tt>x.compareTo(z)&gt;0</tt>.<p>
	 *
	 * Finally, the implementer must ensure that <tt>x.compareTo(y)==0</tt>
	 * implies that <tt>sgn(x.compareTo(z)) == sgn(y.compareTo(z))</tt>, for
	 * all <tt>z</tt>.<p>
	 *
	 * It is strongly recommended, but <i>not</i> strictly required that
	 * <tt>(x.compareTo(y)==0) == (x.equals(y))</tt>.  Generally speaking, any
	 * class that implements the <tt>Comparable</tt> interface and violates
	 * this condition should clearly indicate this fact.  The recommended
	 * language is "Note: this class has a natural ordering that is
	 * inconsistent with equals."
	 * 
	 * @param   o the Object to be compared.
	 * @return  a negative integer, zero, or a positive integer as this object
	 *		is less than, equal to, or greater than the specified object.
	 * 
	 * @throws ClassCastException if the specified object's type prevents it
	 *         from being compared to this Object.
	 */
public int compareTo(Object o) {
	Double thisInt = new Double(this.getKey());
	KeyDouble newKeyDble = (KeyDouble) o;
	Double newKeyDouble = new Double (newKeyDble.getKey());
	int ret = thisInt.compareTo(newKeyDouble);
	//int ret = thisInt.compareTo(o);
	return ret;
}
/**
 * Insert the method's description here.
 * Creation date: (2/2/2003 10:44:29 PM)
 * @return double
 */
public double getKey() {
	return key;
}
/**
 * Returns the type of this class: Comparable.
 * Creation date: (2/2/2003 10:43:28 PM)
 * @return java.lang.Comparable
 */
public Comparable getType() {
	return (Comparable) this;
}
/**
 * Returns the key.
 * Creation date: (2/2/2003 10:44:29 PM)
 * @param newKey double
 */
public void setKey(double newKey) {
	key = newKey;
}

/**
 * Returns the provided number as a KeyDouble.
 * Creation date: (2/11/2003 12:44:59 PM)
 * @param ndouble juggler.exploitationstructures.KeyInterface
 */
public KeyDouble(double ndouble) {
	this.setKey(ndouble);
	
	}

/**
 * Returns KeyDouble as a string.
 * Creation date: (2/11/2003 3:14:53 PM)
 * @return java.lang.String
 */
public String toString() {
	return ((new Double(this.getKey())).toString());
}

/**
 * Adds the key of the KeyInterface k, to this key.
 * Creation date: (2/12/2003 11:32:11 PM)
 * @param k juggler.exploitationstructures.KeyInterface
 */
public void addKey(KeyInterface k) {
	KeyDouble kDouble = (KeyDouble) k;
	setKey(kDouble.getKey()+ key);
	}

/**
 * Divides the key of the KeyInterface k, to this key.
 * Creation date: (2/12/2003 11:17:30 PM)
 * @param k juggler.exploitationstructures.KeyInterface
 */
public void divideKey(KeyInterface k) {
	KeyDouble kDoub = (KeyDouble)k;
	key= key/kDoub.getKey();
	}

/**
 * Returns true if k is equal to this.
 * Creation date: (2/18/2003 12:29:05 AM)
 * @return boolean
 * @param k org.omg.CORBA.Object
 */
public boolean equals(Object k) {

    KeyDouble kI = (KeyDouble) k;
    if (this.getKey() == kI.getKey())
        return true;
    else
        return false;
}

/**
 * Divides the key of the KeyInterface k, to this key.
 * Creation date: (2/12/2003 11:36:51 PM)
 * @param k juggler.exploitationstructures.KeyInterface
 */
public void subKey(KeyInterface k) {
	KeyDouble kDble = (KeyDouble) k;
	setKey(-kDble.getKey()+this.getKey());
	}

/**
 * Returns the value of the key as an Object.
 * Creation date: (5/13/2003 11:41:31 AM)
 * @return java.lang.Object
 */
public Object getValue(){
	return (new Double(key));
}

}
