package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.exploitationstructures;

import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;


/**
 * Interface for Exploitation Structures.
 * This aids in storing and retreiving the tuples for joins.
 * Creation date: (1/13/2003 11:40:53 AM)
 * @author: Asima Silva
 */
public interface IExpStructure {


/**
 * Inserts the tuples into the exploitation structure.
 * Creation date: (1/13/2003 11:41:15 AM)
 * @param tuples java.util.Iterator
 */
java.util.Iterator enterTuples(ArrayList tuples);

/**
 * Returns the column name of the exploitation structure.
 * Creation date: (1/13/2003 11:42:45 AM)
 * @return java.lang.String
 */
public java.lang.String getColumn();

/**
 * Returns the column index in the tuple.
 * Creation date: (1/29/2003 11:30:54 PM)
 * @return int
 */
public int getColumnInt();

/**
 * Returns the streamID of the exploitation structure.
 * Creation date: (1/13/2003 11:42:32 AM)
 * @return ArrayList
 */
public ArrayList getStreamIDs();

/**
 * Returns the stream names of this tuple.
 * Creation date: (1/12/2003 10:14:28 PM)
 * @return java.lang.String[]
 */
public ArrayList getStreamNames() ;

/**
 * Returns tuples that satisfy the operator and key provided.
 * Creation date: (4/14/2003 6:50:31 PM)
 * @return java.util.Iterator
 * @param tuple juggler.stream.Tuple
 * @param op juggler.predicatestructure.Operator
 */
public Iterator getTuplesWithValue(Comparable key, Operator op) ;

/**
 * Sets the column name of the exploitation structure.
 * Creation date: (1/13/2003 11:42:45 AM)
 * @param newColumn java.lang.String
 */
public void setColumn(java.lang.String newColumn);

/**
 * Sets the column's index in the tuple.
 * Creation date: (1/29/2003 11:30:54 PM)
 * @param newColumnInt int
 */
public void setColumnInt(int newColumnInt);

/**
 * Sets the streamID of the exploitation structure.
 * Creation date: (1/13/2003 11:42:32 AM)
 * @param newStreamID ArrayList
 */
public void setStreamIDs(ArrayList newStreamIDs);

/**
 * Sets the stream name of the exploitation structure.
 * Creation date: (1/13/2003 11:42:14 AM)
 * @param newStreamName ArrayList
 */
public void setStreamNames(ArrayList newStreamNames);

/**
 * Inserts the tuple into the exploitaiton structure.
 * Creation date: (1/13/2003 11:43:18 AM)
 * @param tuple juggler.stream.Tuple
 */
public boolean insertTuple(JugglerTupleList tuple);

/**
 * @param key
 * @param joinOp
 * @return
 */
Iterator getTuplesWithValue_XATTuple(Comparable key, Operator joinOp);
}
