package edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.exploitationstructures;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleListIterator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerWindowTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerWindowTupleListIterator;

/**
 * Join Exploitation Tree Structure is a class which stores 
 * the tuples by stream name, and column.
 * The tuples are stored in a tree structure (TreeMap), such that retrieval of tuples
 * with specific values is easily done.
 * Creation date: (1/27/2003 3:08:58 PM)
 * @author: Asima Silva
 */
public class JoinExpTreeStructure implements JoinExpStructure, Comparable, Serializable {
	protected ArrayList streamNames;
	protected ArrayList streamID = new ArrayList();
	protected java.lang.String column = "";

	/** TreeMap. */
	protected TreeMap internalStorage;

	/** Count. */
	protected long numTupleLists;

	protected int columnInt;
	/**
	 * JoinExpTreeStructure constructor comment.
	 */
	public JoinExpTreeStructure() {
		super();
		internalStorage = new TreeMap();
		numTupleLists = 0;
		column = "";
		streamID = new ArrayList();
		streamNames = new ArrayList();
	}
	/**
	 * Constructor specifiying the exp. structure's columnID, columnName, 
	 * stream IDs and stream names.
	 * Creation date: (1/29/2003 11:41:33 PM)
	 * @param newcolumnID int
	 * @param newcolumnName java.lang.String
	 * @param newstreamIDs ArrayList
	 * @param newStreamNames ArrayList
	 */
	public JoinExpTreeStructure(
		int newcolumnID,
		String newcolumnName,
		ArrayList newstreamIDs,
		ArrayList newStreamNames) {
		columnInt = newcolumnID;
		column = newcolumnName;
		streamID = newstreamIDs;
		streamNames = newStreamNames;
		internalStorage = new TreeMap();
		numTupleLists = 0;
	}
	/**
	 * Compares the provided joinExpStr to this. 
	 * Returns 0 if they are equal. 
	 * Creation date: (4/7/2003 7:49:38 PM)
	 * @return boolean
	 * @param joinExpStr Object
	 */
	public int compareTo(Object joinExpStr) {
		if (this.equals((JoinExpTreeStructure) joinExpStr))
			return 0;
		else
			return -1;
	}
	// return total number of tuples;
	public long count() {
		return numTupleLists;
	}
	/**
	 * Deletes the tuple from its exploitation structures.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public void deleteTuple(JugglerTupleList tuple) {
		//find the key in the tree map
		JugglerTupleList t1;
		if (!internalStorage.isEmpty()) {
			try {
				Vector v = new Vector();
				v = tuple.getFirstTuple().getValues();
				Comparable delKey = (Comparable) v.get(columnInt);
				t1 = (JugglerTupleList) internalStorage.get(delKey);
				t1.removeTuple(tuple.getFirstTuple());
				if (t1.isEmpty())
					internalStorage.remove(delKey);
			} catch (Exception e) {
				System.err.println();
			}

		}
	}
	/**
	 * Inserts the tuples into the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param tuples ArrayList
	 */
	public java.util.Iterator enterTuples(ArrayList tuplesArray) {
		Iterator tuples = tuplesArray.iterator();
		while (tuples.hasNext()) {
			JugglerTupleList t = (JugglerTupleList) tuples.next();
			this.insertTuple(t);
			//inserts the tuple into the tree map internal structure
		}

		return null;

	}

	/**
	 * Returns true or false after comparing the provided JoinExpTreeStructure
	 * to this.
	 * Creation date: (4/7/2003 7:09:45 PM)
	 * @return boolean
	 * @param param juggler.exploitationstructures.JoinExpTreeStructure
	 */
	public boolean equals(JoinExpTreeStructure param) {
		if (column.equals(param.getColumn())
			&& streamNames.equals(param.getStreamNames())
			&& streamID.equals(param.getStreamIDs()))
			return true;
		return false;
	}
	/**
	 * Returns the column name of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.lang.String
	 */
	public String getColumn() {
		return this.column;
	}
	/**
	 * Returns the column's index of the exploitation structure.
	 * Creation date: (1/29/2003 11:30:54 PM)
	 * @return int
	 */
	public int getColumnInt() {
		return columnInt;
	}
	/**
	 * Returns all the tuples that have the same value as the specified tuple.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerTupleList
	 */
	public java.util.Iterator getEqualTo(JugglerTupleList tuple) {
		JugglerTupleList t1 = null;
		JugglerWindowTupleListIterator tLI = null;

		Vector v = tuple.getTupleStream(this.streamNames).getValues();
		JugglerWindowTupleList collTupleList = new JugglerWindowTupleList();
		Comparable key = (Comparable) v.get(columnInt);

		if (internalStorage.containsKey(key)) {
			collTupleList = (JugglerWindowTupleList) internalStorage.get(key);
		}
		return (new JugglerWindowTupleListIterator(collTupleList));
	}
	/**
	 * Returns all the tuples that have the same value as the specified tuple.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.util.Iterator
	 * @param key Comparable
	 */
	public java.util.Iterator getEqualToValue(Comparable key) {
		JugglerTupleList t1 = null;
		JugglerWindowTupleListIterator tLI = null;

		JugglerWindowTupleList collTupleList = new JugglerWindowTupleList();

		if (internalStorage.containsKey(key)) {
			collTupleList = (JugglerWindowTupleList) internalStorage.get(key);
		}
		return (new JugglerWindowTupleListIterator(collTupleList));
	}
	/**
	 * Returns the streamID of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return ArrayList
	 */
	public ArrayList getStreamIDs() {
		return streamID;
	}
	/**
	 * Returns the stream name of the exploitation structure
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return ArrayList
	 */
	public ArrayList getStreamNames() {
		return streamNames;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/14/2003 6:50:31 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 * @param op juggler.predicatestructure.Operator
	 */
	public Iterator getTuples(JugglerTupleList tuple, Operator op) {
		if (op.getOpName() == ">")
			return getTuplesGreaterThan(tuple);
		if (op.getOpName() == ">=")
			return getTuplesGreaterThanOrEqualTo(tuple);
		if (op.getOpName() == "<")
			return getTuplesLessThan(tuple);
		if (op.getOpName() == "<=")
			return getTuplesLessThanOrEqual(tuple);
		if (op.getOpName() == "=")
			return getEqualTo(tuple);
		return null;
	}
	/**
	 * Returns tuples with values greater than the specified tuple.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerTupleList
	 */
	public java.util.Iterator getTuplesGreaterThan(JugglerTupleList tuple) {

		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//retrieve all the values with key values equal and greater to the specified key
			Vector v = tuple.getTupleStream(this.streamNames).getValues();
			Comparable vkey = (Comparable) v.get(columnInt);
			//strictly greater than vkey
			SortedMap sm = internalStorage.tailMap(vkey);
			Comparable inclusiveLowKey; //= (Comparable) sm.firstKey();
			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				inclusiveLowKey =
					(Comparable) tl.getTuple().getValues().get(columnInt);
				//don't include the key equal to the tuple's key
				if (inclusiveLowKey.compareTo(vkey) == 0)
					tl = (JugglerWindowTupleList) it.next();
				collTL.appendTupleList(tl);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns all the tuples greater than or equal to the provided tuple.
	 * Creation date: (1/28/2003 9:52:51 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerWindowTupleList
	 */
	public Iterator getTuplesGreaterThanOrEqualTo(JugglerTupleList tuple) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//retrieve all the values with key values equal and greater to the specified key
			Vector v = tuple.getTupleStream(this.streamNames).getValues();
			Comparable vkey = (Comparable) v.get(columnInt);
			//strictly greater than vkey
			SortedMap sm = internalStorage.tailMap(vkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {
				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				collTL.appendTupleList(tl);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns all the tuples greater than or equal to the provided vkey.
	 * Creation date: (1/28/2003 9:52:51 PM)
	 * @return java.util.Iterator
	 * @param key Comparable
	 */
	public Iterator getTuplesGreaterThanOrEqualToValue(Comparable vkey) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//strictly greater than vkey
			SortedMap sm = internalStorage.tailMap(vkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {
				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				collTL.appendTupleList(tl);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns tuples with values greater than the specified tuple.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.util.Iterator
	 * @param vkey Comparable
	 */
	public java.util.Iterator getTuplesGreaterThanValue(Comparable vkey) {

		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//strictly greater than vkey
			SortedMap sm = internalStorage.tailMap(vkey);
			Comparable inclusiveLowKey;
			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				inclusiveLowKey =
					(Comparable) tl.getTuple().getValues().get(columnInt);
				//don't include the key equal to the tuple's key
				int compared = inclusiveLowKey.compareTo(vkey);
				if (compared == 0)
					//tl = (JugglerWindowTupleList) it.next();
					continue;
				collTL.appendTupleList(tl);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns the tuples with values less than the specified tuple.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerTupleList
	 */
	public java.util.Iterator getTuplesLessThan(JugglerTupleList tuple) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//retrieve from beginning until the key specified
			Vector v = tuple.getTupleStream(this.streamNames).getValues();
			Comparable lkey = (Comparable) v.get(columnInt);
			SortedMap sm = internalStorage.headMap(lkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				collTL.appendTupleList(/*tl.getJList()*/
				tl);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns all tuples less than or equal to the provided tuple.
	 * Creation date: (1/28/2003 9:53:34 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerTupleList
	 */
	public Iterator getTuplesLessThanOrEqual(JugglerTupleList tuple) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//retrieve from beginning until the key specified
			Vector v = tuple.getTupleStream(this.streamNames).getValues();
			Comparable lkey = (Comparable) v.get(columnInt);
			SortedMap sm = internalStorage.headMap(lkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();
				if (tl != null)
					collTL.appendTupleList(
					/*tl.getJList()*/
					tl);
			}
			//append equal to tuple list for tuple's key
			Iterator eqTL = this.getEqualTo(tuple);
			JugglerTupleListIterator retTLI = (JugglerTupleListIterator) eqTL;
			JugglerTupleList retTL = retTLI.getTupleList();
			collTL.appendTupleList(retTL);
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns all the tuples less than or equal to the providek lkey.
	 * Creation date: (1/28/2003 9:53:34 PM)
	 * @return java.util.Iterator
	 * @param lkey Comparable
	 */
	public Iterator getTuplesLessThanOrEqualValue(Comparable lkey) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			SortedMap sm = internalStorage.headMap(lkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();
				if (tl != null)
					collTL.appendTupleList(
					/*tl.getJList()*/
					tl);
			}
			//append equal to tuple list for tuple's key
			Iterator eqTL = this.getEqualToValue(lkey);
			JugglerTupleListIterator retTLI = (JugglerTupleListIterator) eqTL;
			JugglerTupleList retTL = retTLI.getTupleList();
			collTL.appendTupleList(retTL);
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns the tuples with values less than the specified lkey.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.util.Iterator
	 * @param lkey Comparable
	 */
	public java.util.Iterator getTuplesLessThanValue(Comparable lkey) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			SortedMap sm = internalStorage.headMap(lkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				collTL.appendTupleList(/*tl.getJList()*/
				tl);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * Returns the tuples with the value and operator provided.
	 * Creation date: (4/14/2003 6:50:31 PM)
	 * @return java.util.Iterator
	 * @param key Comparale
	 * @param op juggler.predicatestructure.Operator
	 */
	public Iterator getTuplesWithValue(Comparable key, Operator op) {
		if (op.getOpName() == ">")
			return getTuplesGreaterThanValue(key);
		if (op.getOpName() == ">=")
			return getTuplesGreaterThanOrEqualToValue(key);
		if (op.getOpName() == "<")
			return getTuplesLessThanValue(key);
		if (op.getOpName() == "<=")
			return getTuplesLessThanOrEqualValue(key);
		if (op.getOpName() == "=")
			return getEqualToValue(key);
		return null;
	}

	/**
	 * Returns the tuples with the value and operator provided.
	 * Creation date: (4/14/2003 6:50:31 PM)
	 * @return java.util.Iterator
	 * @param key Comparale
	 * @param op juggler.predicatestructure.Operator
	 */
	public Iterator getTuplesWithValue_XATTuple(Comparable key, Operator op) {
		if (op.getOpName() == ">")
			return getTuplesGreaterThanValue_XATTuple(key);
		if (op.getOpName() == ">=")
			return getTuplesGreaterThanOrEqualToValue_XATTuple(key);
		if (op.getOpName() == "<")
			return getTuplesLessThanValue_XATTuple(key);
		if (op.getOpName() == "<=")
			return getTuplesLessThanOrEqualValue_XATTuple(key);
		if (op.getOpName() == "=")
			return getEqualToValue_XATTuple(key);
		return null;
	}
	/**
	* @param key
	* @return
	*/
	private Iterator getEqualToValue_XATTuple(Comparable key) {
		JugglerWindowTupleList t1 = null;
		JugglerWindowTupleListIterator tLI = null;

		JugglerWindowTupleList collTupleList = new JugglerWindowTupleList();

		if (internalStorage.containsKey(key)) {
			collTupleList = (JugglerWindowTupleList) internalStorage.get(key);
		}
		return (new JugglerWindowTupleListIterator(collTupleList));
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesLessThanOrEqualValue_XATTuple(Comparable lkey) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			SortedMap sm = internalStorage.headMap(lkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();
				if (tl != null)
					collTL.appendTupleList(
					/*tl.getJList()*/
					tl);
			}
			//append equal to tuple list for tuple's key
			Iterator eqTL = this.getEqualToValue_XATTuple(lkey);
			JugglerWindowTupleListIterator retTLI = (JugglerWindowTupleListIterator) eqTL;
			while (retTLI.hasNext()) {
				JugglerTupleList element = (JugglerTupleList) retTLI.next();
				collTL.appendTupleList_IfNotContained(element);
			}
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesLessThanValue_XATTuple(Comparable lkey) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			SortedMap sm = internalStorage.headMap(lkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				
				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				collTL.appendTupleList(/*tl.getJList()*/
				tl);
			}
			while(collTL.getPrevWinTL() != null)
									collTL  = collTL.getPrevWinTL();
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesGreaterThanOrEqualToValue_XATTuple(Comparable vkey) {
		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//strictly greater than vkey
			SortedMap sm = internalStorage.tailMap(vkey);

			for (Iterator it = sm.values().iterator(); it.hasNext();) {
				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				JugglerWindowTupleListIterator jIt = new JugglerWindowTupleListIterator(tl);
				while (jIt.hasNext()) {
					JugglerTupleList element = (JugglerTupleList) jIt.next();
					collTL.appendTupleList(element);
				}
			}
			while(collTL.getPrevWinTL() != null)
						collTL  = collTL.getPrevWinTL();
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesGreaterThanValue_XATTuple(Comparable vkey) {

		JugglerWindowTupleList collTL = new JugglerWindowTupleList();
		try {
			//strictly greater than vkey
			SortedMap sm = internalStorage.tailMap(vkey);
			Comparable inclusiveLowKey;
			for (Iterator it = sm.values().iterator(); it.hasNext();) {

				JugglerWindowTupleList tl = (JugglerWindowTupleList) it.next();

				XATDataValueImp tupleKey =
					(XATDataValueImp) tl.getTuple().getValues().get(columnInt);
				inclusiveLowKey = new KeyDouble(tupleKey.convertToDouble().doubleValue());
				//don't include the key equal to the tuple's key
				int compared = inclusiveLowKey.compareTo(vkey);
				if (compared == 0)
					//tl = (JugglerWindowTupleList) it.next();
					continue;
				collTL.appendTupleList(tl);
			}
			while(collTL.getPrevWinTL() != null)
			collTL  = collTL.getPrevWinTL();
			return (new JugglerWindowTupleListIterator(collTL));
		} catch (Exception e) {
			System.err.println();
			e.printStackTrace();
			return null;
		}
	}
	/** Insert.
		 * Are we making any use of the fact that tuples more-or-less arrive in timestamp order?
	 * Inserts the tuple into the exploitaiton structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param tuple juggler.stream.JugglerTupleList
	 */
	public boolean insertTuple(JugglerTupleList tuple) {

		try {
			Vector data = tuple.getFirstTuple().getValues();
			//gets the value to be inserted on.
			Comparable key = (Comparable) data.get(columnInt);

			//Integer key = new Integer (value);
			JugglerWindowTupleList tl =
				(JugglerWindowTupleList) internalStorage.get(key);
			if (tl == null) {
				internalStorage.put(
					key,
					new JugglerWindowTupleList(tuple, true));
			} else {
				JugglerWindowTupleList nl =
					tl.insertByTimeInWinTupleList(tuple);

				// if we are adding to the HEAD of the list, then we reset the pointer in the mapping.
				if (nl != tl) {
					internalStorage.put(key, nl);
				}
			}

			numTupleLists++;
			return true;
		} catch (Exception e) {
			System.err.println();
			return false;
		}
	}
	/**
	 * Retrieves all the tuples equal to the tuple's Values.
	 * Creation date: (1/28/2003 9:55:06 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerTuple
	 */
	public Iterator retrieve(JugglerTuple tuple) {
		try {
			SortedMap sm =
				internalStorage.subMap(
					(Comparable) tuple.getCell(columnInt),
					(Comparable) tuple.getCell(columnInt));
			return sm.values().iterator();
		} catch (Exception e) {
			System.err.println();
			return null;
		}
	}
	/**
	 * Sets the column name of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param newColumn java.lang.String
	 */
	public void setColumn(String newColumn) {
		column = newColumn;
	}
	/**
	 * Sets the column index of the exploitation structure.
	 * Creation date: (1/29/2003 11:30:54 PM)
	 * @param newColumnInt int
	 */
	public void setColumnInt(int newColumnInt) {
		columnInt = newColumnInt;
	}
	/**
	 * Sets the streamID of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param newStreamID int
	 */
	public void setStreamIDs(ArrayList newStreamIDs) {
		streamID = newStreamIDs;
	}
	/**
	 * Sets the stream names of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param newStreamName ArrayList
	 */
	public void setStreamNames(ArrayList newStreamName) {
		streamNames = newStreamName;
	}
	/**
	 * Displays the Exp Structures as a String.
	 * Creation date: (4/7/2003 7:38:44 PM)
	 * @return java.lang.String
	 */
	public String toString() {
		String treeInfo;
		treeInfo = "Column: " + column.toString() + "\n";
		treeInfo += "StreamNames: " + streamNames.toString() + "\n";
		//treeInfo += "StreamIDs: " + streamID.toString() + "\n";
		treeInfo += "TupleCount: " + getNumTupleLists() + "\n";
		//treeInfo += internalStorage.toString();
		return treeInfo;
	}
	/**
	 * @return
	 */
	public long getNumTupleLists() {
		numTupleLists = internalStorage.size();
		return numTupleLists;
	}

	/**
	 * @param l
	 */
	public void setNumTupleLists(long l) {
		numTupleLists = l;
	}

	/**
	 * @return
	 */
	public TreeMap getInternalStorage() {
		return internalStorage;
	}

	/**
	 * @param map
	 */
	public void setInternalStorage(TreeMap map) {
		internalStorage = map;
	}
	/**
	 * @return
	 */
	public boolean isEmpty() {
		if (internalStorage.isEmpty())
			return true;
		else
			return false;
	}
	/**
	 * @param tuple
	 */
	public boolean insertTuple_XATTuple(JugglerTupleList tuple) {

		
		try {
			Vector data = tuple.getFirstTuple().getValues();
			//gets the value to be inserted on.
			XATDataValue xatkey = (XATDataValue) data.get(columnInt);
			KeyDouble key = new KeyDouble(xatkey.convertToDouble().doubleValue());
			
			//Integer key = new Integer (value);
			JugglerWindowTupleList tl =
				(JugglerWindowTupleList) internalStorage.get(key);
			if (tl == null) {
				internalStorage.put(
					key,
					new JugglerWindowTupleList(tuple, true));
			} else {
				JugglerWindowTupleList nl =
					tl.insertByTimeInWinTupleList(tuple);

				// if we are adding to the HEAD of the list, then we reset the pointer in the mapping.
				if (nl != tl) {
					internalStorage.put(key, nl);
				}
			}

			numTupleLists++;
			return true;
		} catch (Exception e) {
			System.err.println();
			return false;
		}
	}
	/**
	 * @return
	 */
	public boolean isEmpty_XATTuple() {
		if (internalStorage.isEmpty())
			return true;
		else
			return false;
	}

}
