package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.exploitationstructures;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleListIterator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerWindowTupleList;

/**
 * Insert the type's description here.
 * Creation date: (1/28/2003 10:09:38 PM)
 * @author: Administrator
 */
public class WindowExpStructure implements Serializable {
	protected double timeIncrement;
	protected JugglerWindowTupleList listOfTuples;
	protected JugglerTupleList listOfTuples_XATTuple;
	protected double maxWin;
	protected long startTimeStamp;
	protected long endTimeStamp;
	protected int tupleCount;
	/**
	* WindowExpStructure constructor for multiple streamed tuple.
	*/
	public WindowExpStructure(double newTimeIncrement, double newmaxWin) {
		super();
		timeIncrement = newTimeIncrement;
		maxWin = newmaxWin;
		startTimeStamp = 0;
		endTimeStamp = 0;
		tupleCount = 0;
		listOfTuples = new JugglerWindowTupleList();
		listOfTuples_XATTuple = new JugglerTupleList();
	}
	/**
	 * Inserts the tuples into the exploitation structure.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param tuples java.util.Iterator
	 */
	public java.util.Iterator enterTuples(java.util.Iterator tuples) {
	 ArrayList insertInNextWinExpStr = new ArrayList();
	 
		while (tuples.hasNext()) {
			//inserts only if within the time increment
			if (endTimeStamp - startTimeStamp <= timeIncrement) {
				JugglerTupleList tList = (JugglerTupleList) tuples.next();
				JugglerTuple t = tList.getFirstTuple();
	            
				//check to see if the tuple being inserted, needs to be
				//in a new window exp structure
				if (t.getJugglerTimeStamp() - startTimeStamp > timeIncrement && listOfTuples.size()>0){
					insertInNextWinExpStr.add(tList);
					continue;
				}
	            
				//insert each tuple at a time, in a sorted order by timestamp
				//remove the tuple inserted from our iterator

				//If list of tuples is null, enter this as the first tuple.
				if (listOfTuples.size() == 0){
					listOfTuples = new JugglerWindowTupleList(tList, true);
					startTimeStamp = listOfTuples.getFirstTuple().getJugglerTimeStamp();
				}
				else 
					listOfTuples = this.listOfTuples.insertByTimeInWinTupleList(tList);
				tuples.remove();

				//update the last timestamp in the list
				//this method's traversal may not be needed if tuples are
				//assumed to be inserted and arrived sorted order
				endTimeStamp = listOfTuples.getLastTuple().getJugglerTimeStamp();

			}
			//return to create another window exp structure
			else {
				return insertInNextWinExpStr.iterator();
			}

		}
		return insertInNextWinExpStr.iterator();

	}
    
	/**
		 * Inserts the tuples into the exploitation structure.
		 * Creation date: (1/28/2003 10:09:38 PM)
		 * @param tuples java.util.Iterator
		 */
		public JugglerTupleList enterTuple(JugglerTupleList tList) {
			if(tList == null)
				return null;
			
			//inserts only if within the time increment
			long timeSpan = endTimeStamp - startTimeStamp;
				if (timeSpan <= timeIncrement) {
					//if the tuple has been joined in a previous operator
					//it will contain timestamps in one level above the tuplelist.
					long tupleMAX_TS = -1;
					if(tList.getTimeStamp() == null)
						tupleMAX_TS = tList.getFirstTuple().getJugglerTimeStamp();
					else
							tupleMAX_TS = tList.getJugglerTimeStamp();
	            
					//check to see if the tuple being inserted, needs to be
					//in a new window exp structure
					long potentialTimeSpan = tupleMAX_TS - startTimeStamp;
					if ((potentialTimeSpan > timeIncrement) && (listOfTuples.size()>0)){
						return tList;
	
					}
	            
					//insert each tuple at a time, in a sorted order by timestamp
					//remove the tuple inserted from our iterator

					//If list of tuples is null, enter this as the first tuple.
					if (listOfTuples.size() == 0){
						listOfTuples = new JugglerWindowTupleList(tList, true);
						startTimeStamp = listOfTuples.getFirstTuple().getJugglerTimeStamp();
						tList = null;
					}
					else {
						listOfTuples = this.listOfTuples.insertByTimeInWinTupleList(tList);
						tList = null;
					}

					//update the last timestamp in the list
					//this method's traversal may not be needed if tuples are
					//assumed to be inserted and arrived sorted order
					endTimeStamp = listOfTuples.getLastTuple().getJugglerTimeStamp();

				}
				//return to create another window exp structure
				else {
					return tList;
				}

			return tList;

		}    
    
    
    
/**
 * Insert the method's description here.
 * Creation date: (2/5/2003 8:18:22 PM)
 * @return int
 */
public int getCount() {
	return tupleCount;
}
	/**
	 * Returns the greatest timestamp of the tuple in the TupleList.
	 * Creation date: (1/29/2003 12:01:53 AM)
	 * @return long
	 */
	public long getEndTimeStamp() {
		return endTimeStamp;
	}
	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:43:02 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getEqualTo(JugglerTuple tuple) {
		long tTimeStamp = tuple.getJugglerTimeStamp();
		JugglerTupleList tTupleList = new JugglerTupleList();

		//if the start and end times of a windowExpStr are less then the tuple's timestamp
		// go to the next windowExpSTr
		if (this.getStartTimeStamp() < tTimeStamp
			&& this.getEndTimeStamp() < tTimeStamp) {
			return null;
		}
		//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
		//return all the tuples in this windowExpSTr
		if (this.getStartTimeStamp() <= tTimeStamp
			&& this.getEndTimeStamp() <= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesEqual(tuple));
			return (new JugglerTupleListIterator(tTupleList));
		}

		//if the start is less than but the end is not less than the tuple's timestamp
		//traverse the tuple list until a tuple greater than the timestamp is found
		if (this.getStartTimeStamp() <= tTimeStamp
			&& this.getEndTimeStamp() >= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesEqual(tuple));
			return (new JugglerTupleListIterator(tTupleList));

		}
		// if both the start and end are greater than the tuple's timestamp
		if (this.getStartTimeStamp() > tTimeStamp
			&& this.getEndTimeStamp() > tTimeStamp) {
			return null;
		}
		//if the start and end are both greater than or equal to than the tuple's timestamp
		//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
		if (this.getStartTimeStamp() >= tTimeStamp
			&& this.getEndTimeStamp() >= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesEqual(tuple));
			return (new JugglerTupleListIterator(tTupleList));
		}
			return null;

	}
	/**
	 * Returns the list of tuples.
	 * Creation date: (1/28/2003 11:58:25 PM)
	 * @return juggler.stream.TupleList
	 */
	public JugglerWindowTupleList getListOfTuples() {
		return listOfTuples;
	}
    
	/**
		 * Returns the list of tuples.
		 * Creation date: (1/28/2003 11:58:25 PM)
		 * @return juggler.stream.TupleList
		 */
		public int getTupleCount() {
			return listOfTuples.size();
		}
		
		
	/**
	 * Returns the maximum window size.
	 * Creation date: (1/28/2003 11:53:03 PM)
	 * @return long
	 */
	public double getMaxWin() {
		return maxWin;
	}
	/**
	 * Returns the least timestamp of the tuples in it's TupleList.
	 * Creation date: (1/29/2003 12:01:39 AM)
	 * @return long
	 */
	public long getStartTimeStamp() {
		return startTimeStamp;
	}
	/**
	 * Returns the time increment of each section.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return long
	 */
	public double getTimeIncrement() {
		return timeIncrement;
	}
	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be greater thanor equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:43:58 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesGreaterAndEq(JugglerTuple tuple) {
		long tTimeStamp = tuple.getJugglerTimeStamp();
		JugglerTupleList tTupleList = new JugglerTupleList();

		//if the start and end times of a windowExpStr are less then the tuple's timestamp
		// go to the next windowExpSTr
		if (this.getStartTimeStamp() < tTimeStamp
			&& this.getEndTimeStamp() < tTimeStamp) {
			return null;
		}
		//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
		//return all the tuples in this windowExpSTr
		if (this.getStartTimeStamp() <= tTimeStamp
			&& this.getEndTimeStamp() <= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesEqual(tuple));
			return (new JugglerTupleListIterator(tTupleList));
		}

		//if the start is less than but the end is not less than the tuple's timestamp
		//traverse the tuple list until a tuple greater than the timestamp is found
		if (this.getStartTimeStamp() <= tTimeStamp
			&& this.getEndTimeStamp() >= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesGreaterAndEq(tuple));
			return (new JugglerTupleListIterator(tTupleList));

		}
		// if both the start and end are greater than the tuple's timestamp
		if (this.getStartTimeStamp() > tTimeStamp
			&& this.getEndTimeStamp() > tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesGreaterAndEq(tuple));
			return (new JugglerTupleListIterator(tTupleList));
		}
		//if the start and end are both greater than or equal to than the tuple's timestamp
		//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
		if (this.getStartTimeStamp() >= tTimeStamp
			&& this.getEndTimeStamp() >= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesEqual(tuple));
			return (new JugglerTupleListIterator(tTupleList));
		}
		return null;
	}
	/**
	 * /**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be greater than the specified tuple's timestamp.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return java.util.Iterator
	 * Creation date: (1/28/2003 1:39:37 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public java.util.Iterator getTuplesGreaterThan(JugglerTuple tuple) {
		long tTimeStamp = tuple.getJugglerTimeStamp();
		JugglerTupleList tTupleList = new JugglerTupleList();

		//if the start and end times of a windowExpStr are less then the tuple's timestamp
		//return all the tuples in this windowExpSTr
		if (this.getStartTimeStamp() <= tTimeStamp
			&& this.getEndTimeStamp() <= tTimeStamp) {
			return null;
		}

		//if the start is less than but the end is not less than the tuple's timestamp
		//traverse the tuple list until a tuple greater than the timestamp is found
		if (this.getStartTimeStamp() <= tTimeStamp
			&& this.getEndTimeStamp() >= tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples().getTuplesGreater(tuple));
			return (new JugglerTupleListIterator(tTupleList));
		}

		//if the start and end are both not less than the tuple's timestamp
		//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
		if (this.getStartTimeStamp() > tTimeStamp
			&& this.getEndTimeStamp() > tTimeStamp) {
			tTupleList.appendTupleList(this.getListOfTuples());
			return (new JugglerTupleListIterator(tTupleList));
		}
			return null;

	}
/**
 * Returns tuples from the specified tuple's timestamp.
 * The tuples will be less than or equal to the specified tuple's timestamp.
 * Creation date: (1/28/2003 1:44:40 PM)
 * @return java.util.Iterator
 * @param tuple juggler.stream.Tuple
 */
public Iterator getTuplesLessAndEql(JugglerTuple tuple) {
	long tTimeStamp = tuple.getJugglerTimeStamp();
	JugglerTupleList tTupleList = new JugglerTupleList();

	//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
	//return all the tuples in this windowExpSTr
	if (this.getStartTimeStamp() <= tTimeStamp
		&& this.getEndTimeStamp() <= tTimeStamp) {
		tTupleList.appendTupleList(this.getListOfTuples());
		return (new JugglerTupleListIterator(tTupleList));
	}

	//if the start is less than but the end is not less than the tuple's timestamp
	//traverse the tuple list until a tuple greater than the timestamp is found
	if (this.getStartTimeStamp() <= tTimeStamp
		&& this.getEndTimeStamp() >= tTimeStamp) {
		tTupleList.appendTupleList(this.getListOfTuples().getTuplesLessAndEq(tuple));
		return (new JugglerTupleListIterator(tTupleList));

	}
	// if both the start and end are greater than the tuple's timestamp
	if (this.getStartTimeStamp() > tTimeStamp
		&& this.getEndTimeStamp() > tTimeStamp) {
		return null;
	}
	//if the start and end are both greater than or equal to than the tuple's timestamp
	//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
	if (this.getStartTimeStamp() >= tTimeStamp
		&& this.getEndTimeStamp() >= tTimeStamp) {
		tTupleList.appendTupleList(this.getListOfTuples().getTuplesEqual(tuple));
		return null;
	}
	return null;

}
/**
* Returns tuples from the specified tuple's timestamp.
 * The tuples will be less than the specified tuple's timestamp.
 * Creation date: (1/28/2003 1:42:05 PM)
 * @return java.util.Iterator
 * @param tuple juggler.stream.Tuple
 */
public Iterator getTuplesLessThan(JugglerTuple tuple) {
	long tTimeStamp = tuple.getJugglerTimeStamp();
	JugglerTupleList tTupleList = new JugglerTupleList();

	//if the start and end times of a windowExpStr are less then the tuple's timestamp
	//return all the tuples in this windowExpSTr
	if (this.getStartTimeStamp() < tTimeStamp
		&& this.getEndTimeStamp() < tTimeStamp) {
		tTupleList.appendTupleList(this.getListOfTuples());
		return (new JugglerTupleListIterator(tTupleList));
	}

	//if the start is less than but the end is not less than the tuple's timestamp
	//traverse the tuple list until a tuple greater than the timestamp is found
	if (this.getStartTimeStamp() <= tTimeStamp
		&& this.getEndTimeStamp() >= tTimeStamp) {
		tTupleList.appendTupleList(this.getListOfTuples().getTuplesLess(tuple));
		return (new JugglerTupleListIterator(tTupleList));
	}

	//if the start and end are both not less than the tuple's timestamp
	//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
	if (this.getStartTimeStamp() >= tTimeStamp
		&& this.getEndTimeStamp() >= tTimeStamp) {
		return null;
	}
	return null;

}
/**
 * Insert the method's description here.
 * Creation date: (2/5/2003 8:18:22 PM)
 * @param newCount int
 */
public void setCount(int newCount) {
	tupleCount = newCount;
}
	/**
	 * Sets the largest timestamp of tuples in the WindowExpStructure's TupleList.
	 * Creation date: (1/29/2003 12:01:53 AM)
	 * @param newEndTimeStamp long
	 */
	public void setEndTimeStamp(long newEndTimeStamp) {
		endTimeStamp = newEndTimeStamp;
	}
	/**
	 * Sets the TupleList contained in the WindowExpStructure.
	 * Creation date: (1/28/2003 11:58:25 PM)
	 * @param newListOfTuples juggler.stream.TupleList
	 */
	public void setListOfTuples(JugglerWindowTupleList newListOfTuples) {
		listOfTuples = newListOfTuples;
		tupleCount += newListOfTuples.getCount();
	}
	/**
	 * Sets the max window of this windowExpStructure.
	 * Creation date: (1/28/2003 11:53:03 PM)
	 * @param newMaxWin long
	 */
	public void setMaxWin(long newMaxWin) {
		maxWin = newMaxWin;
	}
	/**
	 * Sets the least timestamp of the tuples in the windowExpStructure's tupleList.
	 * Creation date: (1/29/2003 12:01:39 AM)
	 * @param newStartTimeStamp long
	 */
	public void setStartTimeStamp(long newStartTimeStamp) {
		startTimeStamp = newStartTimeStamp;
	}
	/**
	 * Sets the time increment of this section manager.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param newTimeIncrement long
	 */
	public void setTimeIncrement(long newTimeIncrement) {
		timeIncrement = newTimeIncrement;
	}
	/**
	 * Updates the sections and tuples in each section.
	 * Deletes the expired tuples.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 */
	public void updateSection() {
	   //do over
	}
    
	public String toString() {
		int tupleCount = getTupleCount();
		String retString = "The number of tuples: "+ tupleCount +"\n";
		if (tupleCount > 0)
			retString += "TupleLists are: " +	listOfTuples.toString();
		return retString;
	}
	/**
	 * @param tuple
	 * @return
	 */
	public JugglerTupleList enterTuple_XATTuple(JugglerTupleList tuple) throws XATTimeStampException {
		if(tuple == null)
				return null;
			
			//inserts only if within the time increment
			long timeSpan = endTimeStamp - startTimeStamp;
				if (timeSpan <= timeIncrement) {
					//if the tuple has been joined in a previous operator
					//it will contain timestamps in one level above the tuplelist.
					long tupleMAX_TS = -1;
		
							try {
								tupleMAX_TS = tuple.getFirstTuple().getTimeStamp().getMaxTimeStamp();
							} catch (XATTimeStampException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
	            
					//check to see if the tuple being inserted, needs to be
					//in a new window exp structure
					long potentialTimeSpan = tupleMAX_TS - startTimeStamp;
					if ((potentialTimeSpan > timeIncrement) && (listOfTuples.size()>0)){
						return tuple;
	
					}
	            
					//insert each tuple at a time, in a sorted order by timestamp
					//remove the tuple inserted from our iterator

					//If list of tuples is null, enter this as the first tuple.
					if (listOfTuples.size() == 0){
						listOfTuples = new JugglerWindowTupleList(tuple, true);
						startTimeStamp = listOfTuples.getFirstTuple().getTimeStamp().getMaxTimeStamp();
						tuple = null;
					}
					else {
						listOfTuples_XATTuple = this.listOfTuples.insertByTimeInWinTupleList(tuple);
						tuple = null;
					}

					//update the last timestamp in the list
					//this method's traversal may not be needed if tuples are
					//assumed to be inserted and arrived sorted order
					endTimeStamp = listOfTuples.getLastTuple().getTimeStamp().getMaxTimeStamp();

				}
				//return to create another window exp structure
				else {
					return tuple;
				}

			return tuple;
	}

	/**
	 * @return
	 */
	public JugglerTupleList getListOfTuples_XATTuple() {
		return listOfTuples_XATTuple;
	}

	/**
	 * @param list
	 */
	public void setListOfTuples_XATTuple(JugglerTupleList list) {
		listOfTuples_XATTuple = list;
	}

}
