package edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.exploitationstructures;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleListIterator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerWindowTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerWindowTupleListIterator;

/**
 * Insert the type's description here.
 * Creation date: (1/28/2003 10:09:38 PM)
 * @author: Administrator
 */
public class WindowExpStructureList implements SectionManager, Comparable, Serializable {
	protected double timeIncrement;
	protected ArrayList streamNames;
	protected ArrayList streamIDs;
	protected int numBuckets;
	protected WindowExpStructureList prevWinExpStrList;
	protected WindowExpStructureList nextWinExpStrList;
	protected WindowExpStructure thisWinExpStr;
	protected double maxWin;
	protected long startTimeStamp;
	protected long endTimeStamp;
	protected int bucketID;
	protected int numBucketsLimit;
	protected static int totalTupleCount;
	public java.lang.String column;
	protected int columnInt;
	protected ArrayList removeBucketList;
	/**
	* WindowExpStructure constructor for multiple streamed tuple.
	*/
	public WindowExpStructureList(
		double newTimeIncrement,
		ArrayList newStreamNames,
		ArrayList newStreamIDs,
		double newmaxWin) {
		super();
		timeIncrement = newTimeIncrement;
		streamNames = newStreamNames;
		streamIDs = newStreamIDs;
		numBuckets = (int) (maxWin / newTimeIncrement + 1);
		maxWin = newmaxWin;
		startTimeStamp = 0;
		endTimeStamp = 0;
		numBucketsLimit = (int) Math.ceil(maxWin / timeIncrement);
		prevWinExpStrList = null;
		nextWinExpStrList = null;
		thisWinExpStr = new WindowExpStructure(newTimeIncrement, newmaxWin);
		column = "ts";
		columnInt = 0;
		removeBucketList = new ArrayList();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/7/2003 8:00:37 PM)
	 * @return int
	 * @param winExpStr java.lang.Object
	 */
	public int compareTo(Object winExpStr) {
		if (this.equals((WindowExpStructureList) winExpStr))
			return 0;
		else
			return -1;
	}
	/**
	 * Recursively decrements the current exp structure and all the ones that follow it
	 * Creation date: (1/28/2003 2:59:01 PM)
	 */
	public void decrementBucketID() {
		WindowExpStructureList tempList = this;

		while (tempList != null) {
			tempList.bucketID--;
			tempList = tempList.getNextWinExpStrList();
		}
		return;

	}

	/**
	 * Inserts the tuples into the exploitation structure.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param tuples java.util.Iterator
	 */
	public java.util.Iterator enterTuples(ArrayList tuplesArray) {
		Iterator tuples = tuplesArray.iterator();
		//if this is the first bucket,
		//initialize the bucket numbers and ids
		if (this.getPrevWinExpStrList() == null && this.bucketID == 0) {
			this.setBucketID(1);
		}

		boolean createNewWinExpStr = false;

		while (tuples.hasNext()) {
			//inserts only if within the time increment
			if (endTimeStamp - startTimeStamp <= timeIncrement) {
				//insert tuples 
				tuples = thisWinExpStr.enterTuples(tuples);

				//if the funcion returns any tuples left over,
				//it needs to be inserted in teh new WinExpStr
				if (tuples.hasNext()) {
					createNewWinExpStr = true;
				}

				//update the last timestamp in the list
				//this method's traversal may not be needed if tuples are 
				//assumed to be inserted and arrived sorted order
				endTimeStamp =
					thisWinExpStr
						.getListOfTuples()
						.getLastTuple()
						.getJugglerTimeStamp();
				startTimeStamp =
					thisWinExpStr
						.getListOfTuples()
						.getTuple()
						.getJugglerTimeStamp();
			} else {
				//then there is a need for another WindowExpStructure
				createNewWinExpStr = true;

			} //end else

			if (createNewWinExpStr) {
				//if there is already a next winExpStr, then 
				//try to insert the tuples into this
				if (nextWinExpStrList != null) {

					//create the array list of the left over tuples
					ArrayList leftOverTuples = new ArrayList();
					while (tuples.hasNext()) {
						JugglerTupleList element =
							(JugglerTupleList) tuples.next();
						leftOverTuples.add(element);
					}
					tuples = nextWinExpStrList.enterTuples(leftOverTuples);

				} //if there is no nextWinExpStr, create a new one

				//			then there is a need for another WindowExpStructure
				//if this is a exp structure for a single stream
				nextWinExpStrList =
					new WindowExpStructureList(
						timeIncrement,
						streamNames,
						streamIDs,
						maxWin);

				this.setNextWinExpStrList(nextWinExpStrList);
				nextWinExpStrList.setBucketID(bucketID + 1);
				nextWinExpStrList.setPrevWinExpStrList(this);
				//set the new bucketID

				tuples = nextWinExpStrList.enterTuples(tuplesArray);
				//enter the remainder of the tuples

				//			optimization???
				while (numBucketsLimit < getBucketSize()) {
					//remove the first bucket;
					this.removeBucket(1);
				}
			} //end of if to creat new Exp structure
			createNewWinExpStr = false;

		} //end while

		return tuples;

	}

	/**
		 * Inserts the tuples into the exploitation structure.
		 * Creation date: (1/28/2003 10:09:38 PM)
		 * @param tuples java.util.Iterator
		 */
	public JugglerTupleList enterTuple(JugglerTupleList tuple) {
		//if this is the first bucket,
		//initialize the bucket numbers and ids
		if (this.getPrevWinExpStrList() == null && this.bucketID == 0) {
			this.setBucketID(1);
		}

		boolean createNewWinExpStr = false;

		//inserts only if within the time increment
		long timeSpan = endTimeStamp - startTimeStamp;
		if ((timeSpan <= timeIncrement)) {
			//insert tuples 
			tuple = thisWinExpStr.enterTuple(tuple);

			//if the funcion returns any tuples left over,
			//it needs to be inserted in teh new WinExpStr
			if (tuple != null) {
				createNewWinExpStr = true;
			} else {
				//update the last timestamp in the list
				//this method's traversal may not be needed if tuples are 
				//assumed to be inserted and arrived sorted order
				endTimeStamp =
					thisWinExpStr
						.getListOfTuples()
						.getLastTuple()
						.getJugglerTimeStamp();
				startTimeStamp =
					thisWinExpStr
						.getListOfTuples()
						.getTuple()
						.getJugglerTimeStamp();
			}
		} else {
			//then there is a need for another WindowExpStructure
			createNewWinExpStr = true;

		} //end else

		if (createNewWinExpStr) {
			//if there is already a next winExpStr, then 
			//try to insert the tuples into this
			if (nextWinExpStrList != null) {
				tuple = nextWinExpStrList.enterTuple(tuple);

			} //if there is no nextWinExpStr, create a new one
			else {
				//			then there is a need for another WindowExpStructure
				//if this is a exp structure for a single stream
				nextWinExpStrList =
					new WindowExpStructureList(
						timeIncrement,
						streamNames,
						streamIDs,
						maxWin);

				this.setNextWinExpStrList(nextWinExpStrList);
				nextWinExpStrList.setBucketID(bucketID + 1);
				nextWinExpStrList.setPrevWinExpStrList(this);
				//set the new bucketID

				tuple = nextWinExpStrList.enterTuple(tuple);
				//enter the remainder of the tuples
			}

		} //end of if to creat new Exp structure
		createNewWinExpStr = false;

		if (bucketID == 1) {
			int currBucketSize = getBucketSize();
			int bucketLimit = numBucketsLimit;
			//			optimization???
			if (currBucketSize > bucketLimit) {
				//	remove the first bucket;
				//			this.removeBucket(1);
				int listSize = getRemoveBucketList().size();
				int newIDRemove = 0;
				if (listSize > 0)
					newIDRemove =
						((Integer) getRemoveBucketList().get(listSize - 1))
							.intValue();
				getRemoveBucketList().add(new Integer(newIDRemove + 1));
			}
		}

		return tuple;

	}

	/**
	 * Insert the method's description here.
	 * Creation date: (4/7/2003 8:05:56 PM)
	 * @return boolean
	 * @param winExpStrL juggler.exploitationstructures.WindowExpStructureList
	 */
	public boolean equals(WindowExpStructureList winExpStrL) {
		if (/*this.getStreamIDs().equals(winExpStrL.getStreamIDs())
																																																&& */
			this.getStreamNames().equals(winExpStrL.getStreamNames()))
			return true;
		else
			return false;

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:41:35 PM)
	 * @return int
	 */
	public int getBucketID() {
		return bucketID;
	}
	/**
	 * Returns the current number of WindowExpStructure/buckets in the list.
	 * Creation date: (1/28/2003 1:23:44 PM)
	 * @return int
	 */
	public int getBucketSize() {
		WindowExpStructureList temp = this;
		WindowExpStructureList curr = this;

		//if this is the last one i the list
		if (temp.getNextWinExpStrList() == null)
			return this.getBucketID();
		else {
			while (temp != null) {
				curr = temp;
				temp = temp.getNextWinExpStrList();
			}
			return curr.getBucketID();
		}
	}

	/**
		 * Returns the current number of WindowExpStructure/buckets in the list.
		 * Creation date: (1/28/2003 1:23:44 PM)
		 * @return int
		 */
	public int getTotalTupleCount() {
		WindowExpStructureList tempPrev = this;
		totalTupleCount = 0;

		if (tempPrev == null) {
			return 0;
		}

		while (tempPrev.getPrevWinExpStrList() != null) {
			tempPrev = tempPrev.getPrevWinExpStrList();
		}

		//if this is the last one i the list
		if (tempPrev.getNextWinExpStrList() == null)
			totalTupleCount += tempPrev.thisWinExpStr.getTupleCount();
		else {
			totalTupleCount = tempPrev.thisWinExpStr.getTupleCount();
			while (tempPrev.getNextWinExpStrList() != null) {
				totalTupleCount
					+= tempPrev
						.getNextWinExpStrList()
						.thisWinExpStr
						.getTupleCount();
				tempPrev = tempPrev.getNextWinExpStrList();
			}
		}
		return totalTupleCount;
	}
	/**
	 * Returns the column name of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @return java.lang.String
	 */
	public String getColumn() {
		return this.column;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/13/2003 12:05:19 PM)
	 * @return int
	 */
	public int getColumnInt() {
		return columnInt;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:17:36 PM)
	 * @return long
	 */
	public long getEndTimeStamp() {
		endTimeStamp =
			thisWinExpStr
				.getListOfTuples()
				.getFirstTuple()
				.getJugglerTimeStamp();
		return endTimeStamp;
	}
	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:43:02 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getEqualToValue(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerWindowTupleList tTupleList = new JugglerWindowTupleList();

		WindowExpStructureList temp = this.getFirstWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {

				JugglerWindowTupleListIterator tempTL_it =
					new JugglerWindowTupleListIterator(temp.getListOfTuples());
				while (tempTL_it.hasNext()) {
					JugglerTupleList tempTL =
						(JugglerTupleList) tempTL_it.next();
					if (tempTL.getJugglerTimeStamp() == tTimeStamp)
						tTupleList.appendTupleList(tempTL);
				}
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				JugglerWindowTupleListIterator tempTL_it =
					new JugglerWindowTupleListIterator(temp.getListOfTuples());
				while (tempTL_it.hasNext()) {
					JugglerTupleList tempTL =
						(JugglerTupleList) tempTL_it.next();
					if (tempTL.getJugglerTimeStamp() == tTimeStamp)
						tTupleList.appendTupleList(tempTL);
				}
				temp = temp.getNextWinExpStrList();

			}

			if (temp == null)
				break;

			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				return (new JugglerWindowTupleListIterator(tTupleList));
				//we can stop now
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				JugglerWindowTupleListIterator tempTL_it =
					new JugglerWindowTupleListIterator(temp.getListOfTuples());
				while (tempTL_it.hasNext()) {
					JugglerTupleList tempTL =
						(JugglerTupleList) tempTL_it.next();
					if (tempTL.getJugglerTimeStamp() == tTimeStamp)
						tTupleList.appendTupleList(tempTL);
				}
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;
		}
		return (new JugglerWindowTupleListIterator(tTupleList));
	}
	/**
	 * Returns the first WindowExpStructure in the list.
	 * Creation date: (1/28/2003 1:55:24 PM)
	 * @return juggler.exploitationstructures.WindowExpStructure
	 */
	public WindowExpStructureList getFirstWinExpStructureList() {
		WindowExpStructureList temp = this;
		while (temp.getPrevWinExpStrList() != null) {
			temp = temp.getPrevWinExpStrList();
		}
		return temp;
	}
	/**
	 * Returns the last WindowExpStructure in the list.
	 * Creation date: (1/28/2003 1:57:01 PM)
	 * @return juggler.exploitationstructures.WindowExpStructure
	 */
	public WindowExpStructureList getLastWinExpStructureList() {
		WindowExpStructureList temp = this;
		while (temp.getNextWinExpStrList() != null) {
			temp = temp.getNextWinExpStrList();
		}
		return temp;
	}
	/**
	 * Returns the maximum window size.
	 * Creation date: (1/28/2003 11:53:03 PM)
	 * @return long
	 */
	public double getMaxWin() {
		return maxWin;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:14:10 PM)
	 * @return juggler.exploitationstructures.WindowExpStructureList
	 */
	public WindowExpStructureList getNextWinExpStrList() {
		return nextWinExpStrList;
	}
	/**
	 * Return the number of buckets currently in the list.
	 * Creation date: (1/28/2003 10:38:28 PM)
	 * @return int
	 */
	public int getNumBuckets() {
		WindowExpStructureList temp = this;
		while (temp != null) {
			temp = temp.getNextWinExpStrList();
		}

		return temp.bucketID;
	}
	/**
	 * Returns the max number of WindowExpStructures/buckets.
	 * Creation date: (1/28/2003 1:16:30 PM)
	 * @return int
	 */
	public int getNumBucketsLimit() {
		return numBucketsLimit;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:14:10 PM)
	 * @return juggler.exploitationstructures.WindowExpStructureList
	 */
	public WindowExpStructureList getPrevWinExpStrList() {
		return prevWinExpStrList;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:17:10 PM)
	 * @return long
	 */
	public long getStartTimeStamp() {
		startTimeStamp =
			thisWinExpStr
				.getListOfTuples()
				.getFirstTuple()
				.getJugglerTimeStamp();
		return startTimeStamp;
	}
	/**
	 * Returns all the streamIDs of the tuple.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return int[]
	 */
	public ArrayList getStreamIDs() {
		return streamIDs;
	}
	/**
	 * Returns the stream names of this tuple.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return java.lang.String[]
	 */
	public ArrayList getStreamNames() {
		return streamNames;
	}
	/**
	 * Returns the time increment of each section.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return long
	 */
	public double getTimeIncrement() {
		return timeIncrement;
	}
	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be greater thanor equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:43:58 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesGreaterThanOrEqualToValue(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerWindowTupleList tTupleList = new JugglerWindowTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				return (new JugglerWindowTupleListIterator(tTupleList));
				//we can stop now
			}
			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp.getEqualToValue(key))
						.getTupleList());
			}

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}
			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

		}
		return (new JugglerWindowTupleListIterator(tTupleList));
	}
	/**
	 * /**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be greater than the specified tuple's timestamp.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return java.util.Iterator
	 * Creation date: (1/28/2003 1:39:37 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public java.util.Iterator getTuplesGreaterThanValue(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerWindowTupleList tTupleList = new JugglerWindowTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are greater then the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				return (new JugglerWindowTupleListIterator(tTupleList));
			}

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp
						.getTuplesGreaterThanValue(key))
						.getTupleList());
				return (new JugglerWindowTupleListIterator(tTupleList));
			}

			//if the start and end are both not less than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getPrevWinExpStrList();
			}

			if (temp == null)
				break;

		}
		return (new JugglerWindowTupleListIterator(tTupleList));
	}
	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be less than or equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:44:40 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesLessThanOrEqualValue(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerWindowTupleList tTupleList = new JugglerWindowTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp
						.getTuplesLessThanValue(key))
						.getTupleList());
				temp = temp.getNextWinExpStrList();
				return (new JugglerWindowTupleListIterator(tTupleList));

			}
			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				return (new JugglerWindowTupleListIterator(tTupleList));
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				return (new JugglerWindowTupleListIterator(tTupleList));
			}

		}
		return (new JugglerWindowTupleListIterator(tTupleList));
	}
	/**
	* Returns tuples from the specified tuple's timestamp.
	 * The tuples will be less than the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:42:05 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesLessThanValue(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerWindowTupleList tTupleList = new JugglerWindowTupleList();

		WindowExpStructureList temp = this.getFirstWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp
						.getTuplesLessThanValue(key))
						.getTupleList());
				return (new JugglerWindowTupleListIterator(tTupleList));
			}

			//if the start and end are both not less than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				return (new JugglerWindowTupleListIterator(tTupleList));
			}

		}
		return (new JugglerWindowTupleListIterator(tTupleList));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/14/2003 6:50:31 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 * @param op juggler.predicatestructure.Operator
	 */
	public Iterator getTuplesWithValue(Comparable key, Operator op) {
		if (op.getOpName() == ">")
			return getTuplesGreaterThanValue(key);
		if (op.getOpName() == ">=")
			return getTuplesGreaterThanOrEqualToValue(key);
		if (op.getOpName() == "<")
			return getTuplesLessThanValue(key);
		if (op.getOpName() == "<=")
			return getTuplesLessThanOrEqualValue(key);
		if (op.getOpName() == "=")
			return getEqualToValue(key);
		return null;
	}

	/**
		 * Removes the bucket/WindowExpStructure with the specified ID.
		 * Creation date: (1/28/2003 10:33:11 AM)
		 * @param bucketID int
		 */
	public WindowExpStructureList getWindowExpStrList_With_BucketID(int bucketID) {
		WindowExpStructureList temp = this;
		WindowExpStructureList tempNext;
		WindowExpStructureList tempPrev;

		while (temp.getBucketID() != bucketID) {
			//if we need to traverse forward for the needed bucketID
			if (temp.getBucketID() < bucketID) {
				temp = temp.getNextWinExpStrList();

			}
			//if we need to traverse backward for the needed bucketID
			if (temp.getBucketID() > bucketID) {
				temp = temp.getPrevWinExpStrList();
			}
		} //end while
		return temp;
	}

	/**
		 * Removes the bucket/WindowExpStructure with the specified ID.
		 * Creation date: (1/28/2003 10:33:11 AM)
		 * @param bucketID int
		 */
	public void removeBucket_XATTuple(int nbucketID) {
		WindowExpStructureList temp = this;
		int currID = temp.getBucketID();
		WindowExpStructureList tempNext;
		WindowExpStructureList tempPrev;

		temp = this.getWindowExpStrList_With_BucketID(nbucketID);

		//if the bucketID to be removed is the current bucketID
		if (temp.getBucketID() == nbucketID) {
			cleanBucket_XATTuple(temp);
			tempNext = temp.getNextWinExpStrList();
			tempPrev = temp.getPrevWinExpStrList();
			//if the bucket being removed has a prev and next
			//replace the prev's next as the next.
			if (tempPrev != null) {
				if (tempNext != null) {
					tempNext.decrementBucketID();
					tempNext.setPrevWinExpStrList(tempPrev);
					temp = tempNext;

					//set this as the tempNext
				}
			} else {
				//if the bucket being removed doesn't have a prev
				//but has a next, 
				//replace the next's prev as null.
				if (tempNext != null) {
					tempNext.decrementBucketID();
					tempNext = tempNext.nextWinExpStrList;
					tempNext.setPrevWinExpStrList(null);
					temp = tempNext;
				}
			}

			// make sure you don't return an null one,
			//return an empty one instead
			if (temp == null) {
				temp =
					new WindowExpStructureList(
						this.timeIncrement,
						this.streamNames,
						this.streamIDs,
						this.maxWin);
			}
		} //if bucketID = desired bucketID

		//set this as the temp
		thisWinExpStr = temp.thisWinExpStr;
		this.nextWinExpStrList =
			temp.getFirstWinExpStructureList().nextWinExpStrList;
		this.prevWinExpStrList =
			temp.getFirstWinExpStructureList().prevWinExpStrList;
		return;
	}

	/**
		 * Removes the bucket/WindowExpStructure with the specified ID.
		 * Creation date: (1/28/2003 10:33:11 AM)
		 * @param bucketID int
		 */
	public void removeBucket(int nbucketID) {
		WindowExpStructureList temp = this;
		int currID = temp.getBucketID();
		WindowExpStructureList tempNext;
		WindowExpStructureList tempPrev;
	
		temp = this.getWindowExpStrList_With_BucketID(nbucketID);
	
		//if the bucketID to be removed is the current bucketID
		if (temp.getBucketID() == nbucketID) {
			cleanBucket(temp);
			tempNext = temp.getNextWinExpStrList();
			tempPrev = temp.getPrevWinExpStrList();
			//if the bucket being removed has a prev and next
			//replace the prev's next as the next.
			if (tempPrev != null) {
				if (tempNext != null) {
					tempNext.setPrevWinExpStrList(tempPrev);
					tempNext.decrementBucketID();
					temp = tempNext;
	
					//set this as the tempNext
				}
			} else {
				//if the bucket being removed doesn't have a prev
				//but has a next, 
				//replace the next's prev as null.
				if (tempNext != null) {
					tempNext.decrementBucketID();
					tempNext.setPrevWinExpStrList(null);
					temp = tempNext;
				}
			}
	
			// make sure you don't return an null one,
			//return an empty one instead
			if (temp == null) {
				temp =
					new WindowExpStructureList(
						this.timeIncrement,
						this.streamNames,
						this.streamIDs,
						this.maxWin);
			}
		} //if bucketID = desired bucketID
	
		//set this as the temp
		thisWinExpStr = temp.getFirstWinExpStructureList().thisWinExpStr;
		this.nextWinExpStrList =
			temp.getFirstWinExpStructureList().nextWinExpStrList;
		this.prevWinExpStrList =
			temp.getFirstWinExpStructureList().prevWinExpStrList;
	}

	/**
		 * Removes the bucket/WindowExpStructure with the specified ID.
		 * Creation date: (1/28/2003 10:33:11 AM)
		 * @param bucketID int
		 */
	public void cleanBucket_XATTuple(WindowExpStructureList winList) {
		JugglerWindowTupleList listOfTupleInExpStr = winList.getListOfTuples();
		JugglerWindowTupleList currWinTupleList =
			listOfTupleInExpStr.getFirstWinTupleList();
		while (currWinTupleList != null) {
			//currTupleList.jList = null;
			boolean isNotNull = currWinTupleList.setTupleReference_XATTuple(null);
			if (!isNotNull)
				currWinTupleList = currWinTupleList.getNextWinTL();
			else {

				return;
			}
		}
	}

	/**
		 * Removes the bucket/WindowExpStructure with the specified ID.
		 * Creation date: (1/28/2003 10:33:11 AM)
		 * @param bucketID int
		 */
	public void cleanBucket(WindowExpStructureList winList) {
		JugglerWindowTupleList listOfTupleInExpStr = winList.getListOfTuples();
		JugglerWindowTupleList currWinTupleList =
			listOfTupleInExpStr.getFirstWinTupleList();
		while (currWinTupleList != null) {
			//currTupleList.jList = null;
			boolean isNotNull = currWinTupleList.setTupleReference(null);
			if (!isNotNull)
				currWinTupleList = currWinTupleList.getNextWinTL();
			else {
	
				return;
			}
		}
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:41:35 PM)
	 * @param newBucketID int
	 */
	public void setBucketID(int newBucketID) {
		bucketID = newBucketID;
	}
	/**
	 * Sets the column name of the exploitation structure.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param newColumn java.lang.String
	 */
	public void setColumn(String newColumn) {
		column = newColumn;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/13/2003 12:05:19 PM)
	 * @param newColumnInt int
	 */
	public void setColumnInt(int newColumnInt) {
		columnInt = newColumnInt;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (4/14/2003 6:50:31 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 * @param op juggler.predicatestructure.Operator
	 */
	public Iterator getTuplesWithValue_XATTuple(Comparable key, Operator op) {
		if (op.getOpName() == ">")
			return getTuplesGreaterThanValue_XATTuple(key);
		if (op.getOpName() == ">=")
			return getTuplesGreaterThanOrEqualToValue_XATTuple(key);
		if (op.getOpName() == "<")
			return getTuplesLessThanValue_XATTuple(key);
		if (op.getOpName() == "<=")
			return getTuplesLessThanOrEqualValue_XATTuple(key);
		if (op.getOpName() == "=")
			return getEqualToValue_XATTuple(key);
		return null;
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getEqualToValue_XATTuple(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerTupleList tTupleList = new JugglerTupleList();

		WindowExpStructureList temp = this.getFirstWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {

				JugglerTupleListIterator tempTL_it =
					new JugglerTupleListIterator(temp.getListOfTuples());
				while (tempTL_it.hasNext()) {
					JugglerTupleList tempTL =
						(JugglerTupleList) tempTL_it.next();
					if (tempTL.getJugglerTimeStamp() == tTimeStamp)
						tTupleList.appendTupleList(tempTL);
				}
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				JugglerTupleListIterator tempTL_it =
					new JugglerTupleListIterator(temp.getListOfTuples());
				while (tempTL_it.hasNext()) {
					JugglerTupleList tempTL =
						(JugglerTupleList) tempTL_it.next();
					if (tempTL.getJugglerTimeStamp() == tTimeStamp)
						tTupleList.appendTupleList(tempTL);
				}
				temp = temp.getNextWinExpStrList();

			}

			if (temp == null)
				break;

			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
				//we can stop now
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				JugglerWindowTupleListIterator tempTL_it =
					new JugglerWindowTupleListIterator(temp.getListOfTuples());
				while (tempTL_it.hasNext()) {
					JugglerTupleList tempTL =
						(JugglerTupleList) tempTL_it.next();
					if (tempTL.getJugglerTimeStamp() == tTimeStamp)
						tTupleList.appendTupleList(tempTL);
				}
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;
		}
		return (new JugglerTupleListIterator(tTupleList));
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesLessThanOrEqualValue_XATTuple(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerTupleList tTupleList = new JugglerTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp
						.getTuplesLessThanValue(key))
						.getTupleList());
				temp = temp.getNextWinExpStrList();
				return (new JugglerTupleListIterator(tTupleList));

			}
			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
			}

		}
		return (new JugglerTupleListIterator(tTupleList));
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesLessThanValue_XATTuple(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerTupleList tTupleList = new JugglerTupleList();

		WindowExpStructureList temp = this.getFirstWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			if (temp == null)
				break;

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp
						.getTuplesLessThanValue(key))
						.getTupleList());
				return (new JugglerTupleListIterator(tTupleList));
			}

			//if the start and end are both not less than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
			}

		}
		return (new JugglerTupleListIterator(tTupleList));
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesGreaterThanOrEqualToValue_XATTuple(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerTupleList tTupleList = new JugglerTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
				//we can stop now
			}
			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp.getEqualToValue(key))
						.getTupleList());
			}

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}
			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

		}
		return (new JugglerTupleListIterator(tTupleList));
	}
	/**
	 * @param key
	 * @return
	 */
	private Iterator getTuplesGreaterThanValue_XATTuple(Comparable key) {
		long tTimeStamp = ((Double) ((KeyDouble) key).getValue()).longValue();
		JugglerTupleList tTupleList = new JugglerTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are greater then the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
			}

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					((JugglerTupleListIterator) temp
						.getTuplesGreaterThanValue(key))
						.getTupleList());
				return (new JugglerTupleListIterator(tTupleList));
			}

			//if the start and end are both not less than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getPrevWinExpStrList();
			}

			if (temp == null)
				break;

		}
		return (new JugglerTupleListIterator(tTupleList));
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:17:36 PM)
	 * @param newEndTimeStamp long
	 */
	public void setEndTimeStamp(long newEndTimeStamp) {
		endTimeStamp = newEndTimeStamp;
	}
	/**
	 * Sets the max window of this windowExpStructure.
	 * Creation date: (1/28/2003 11:53:03 PM)
	 * @param newMaxWin long
	 */
	public void setMaxWin(long newMaxWin) {
		maxWin = newMaxWin;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:14:10 PM)
	 * @param newNextWinExpStrList juggler.exploitationstructures.WindowExpStructureList
	 */
	public void setNextWinExpStrList(WindowExpStructureList newNextWinExpStrList) {
		totalTupleCount -= nextWinExpStrList.thisWinExpStr.getTupleCount();
		if (newNextWinExpStrList != null) {
			totalTupleCount
				+= newNextWinExpStrList.thisWinExpStr.getTupleCount();
		}
		nextWinExpStrList = newNextWinExpStrList;
	}
	/**
	 * Sets the number of buckets in this WindowExpStructure.
	 * Creation date: (1/28/2003 10:38:28 PM)
	 * @param newNumBuckets int
	 */
	public void setNumBuckets(int newNumBuckets) {
		numBuckets = newNumBuckets;
	}
	/**
	 * Sets the most number of buckets maintained with the specified maxWindow and timeIncrement
	 * of the WindowExpStructure.
	 * Creation date: (1/28/2003 1:16:30 PM)
	 * @param newNumBucketsLimit int
	 */
	public void setNumBucketsLimit(int newNumBucketsLimit) {
		numBucketsLimit = newNumBucketsLimit;
	}
	/**
	 * Returns the number of sections/WindowExpStructure maintained for this stream.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param winpolicy juggler.policy.WinPolicy
	 */
	public void setNumSections(
		edu
			.wpi
			.cs
			.dsrg
			.xmldb
			.xat
			.component
			.operator
			.Juggler
			.policy
			.WinPolicy winpolicy) {
		//compare this to actual window policy
		if (winpolicy.getPolicy().equals(winpolicy.getMaxWindowString())) {
			numBucketsLimit = (int) Math.ceil(maxWin / timeIncrement);
		}
		if (winpolicy.getPolicy().equals(winpolicy.getMinWinString())) {
			//not supported
		}
		if (winpolicy.getPolicy().equals(winpolicy.getGreedyMin())) {
			//not supported
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:14:10 PM)
	 * @param newPrevWinExpStrList juggler.exploitationstructures.WindowExpStructureList
	 */
	public void setPrevWinExpStrList(WindowExpStructureList newPrevWinExpStrList) {
		if (this.prevWinExpStrList != null) {
			totalTupleCount -= prevWinExpStrList.thisWinExpStr.getTupleCount();
		}
		if (newPrevWinExpStrList != null) {
			totalTupleCount
				+= newPrevWinExpStrList.thisWinExpStr.getTupleCount();
			this.prevWinExpStrList = newPrevWinExpStrList;
					this.prevWinExpStrList.bucketID = newPrevWinExpStrList.bucketID;
					this.prevWinExpStrList.column = newPrevWinExpStrList.column;
					this.prevWinExpStrList.columnInt = newPrevWinExpStrList.columnInt;
					this.prevWinExpStrList.endTimeStamp = newPrevWinExpStrList.endTimeStamp;
					this.prevWinExpStrList.maxWin = newPrevWinExpStrList.maxWin;
					this.prevWinExpStrList.numBuckets = newPrevWinExpStrList.numBuckets;
					this.prevWinExpStrList.numBucketsLimit = newPrevWinExpStrList.numBucketsLimit;
					this.prevWinExpStrList.nextWinExpStrList = newPrevWinExpStrList.nextWinExpStrList;
		}
	
		prevWinExpStrList = newPrevWinExpStrList;
		return;

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/29/2003 9:17:10 PM)
	 * @param newStartTimeStamp long
	 */
	public void setStartTimeStamp(long newStartTimeStamp) {
		startTimeStamp = newStartTimeStamp;
	}
	/**
	 * Sets the stream IDs of this section manager.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param newStreamIDs int[]
	 */
	public void setStreamIDs(ArrayList newStreamIDs) {
		streamIDs = newStreamIDs;
	}
	/**
	 * Sets the stream names of this section manager.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param newStreamNames java.lang.String[]
	 */
	public void setStreamNames(ArrayList newStreamNames) {
		streamNames = newStreamNames;
	}
	/**
	 * Sets the time increment of this section manager.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @param newTimeIncrement long
	 */
	public void setTimeIncrement(double newTimeIncrement) {
		timeIncrement = newTimeIncrement;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/5/2003 8:19:59 PM)
	 * @param newTupleCount int
	 */
	public void setTotalTupleCount(int newTupleCount) {
		totalTupleCount = newTupleCount;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/7/2003 7:40:44 PM)
	 * @return java.lang.String
	 */
	public String toString() {
		String winInfoString = "";
		WindowExpStructureList temp = getFirstWinExpStructureList();
		//counting as traversed saves time calling the ExpStructure's methods
		int bucketsize = 0;
		int totalTupleCount = 0;

		while (temp != null) {
			if (temp.getStreamNames() != null)
				winInfoString += "StreamNames: " + temp.getStreamNames() + "\n";
			if (temp.getStreamIDs() != null)
				winInfoString += "StreamIDs: " + temp.getStreamIDs() + "\n";
			winInfoString += "Bucket ID: " + temp.getBucketID() + "\n";
			if (temp.thisWinExpStr != null) {
				totalTupleCount += temp.thisWinExpStr.getTupleCount();
				winInfoString += "Tuples size: "
					+ temp.thisWinExpStr.getTupleCount()
					+ "\n";
			}
			temp = temp.nextWinExpStrList;
			bucketsize++;
		}
		winInfoString += "Bucket Size: " + bucketsize + "\n";
		winInfoString += "Total Tuple Count: " + totalTupleCount + "\n";
		return winInfoString;
	}
	/**
	 * Updates the sections and tuples in each section.
	 * Deletes the expired tuples.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 */
	public void updateSection() {
		WindowExpStructureList first = this.getFirstWinExpStructureList();
		WindowExpStructureList last = this.getLastWinExpStructureList();
		WindowExpStructureList newFirst;

		if (last.getBucketID() > numBucketsLimit + 1) {
			//check if the maxWin is satisfied
			if (first.getStartTimeStamp() - last.getEndTimeStamp() <= maxWin)
				//double check that there may be a case where we exceeded the number of buckets
				//but have not exceeded the maxWin.. but this should never occur since
				//the bucket limit is calcuated with the maxWin
				return;
			else {
				newFirst = first.getNextWinExpStrList();
				newFirst.setPrevWinExpStrList(null);
				newFirst.decrementBucketID();
				first = null;
			}
		} else
			//no update is needed,
			return;

	}

	/**
	 * Deletes the tuple from its exploitation structures.
	 * Creation date: (1/27/2003 3:08:58 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public void deleteTuple(JugglerTupleList tuple) {
	}

	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:43:02 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getEqualTo(JugglerTupleList tuple) {
		long tTimeStamp = tuple.getFirstTuple().getJugglerTimeStamp();

		KeyDouble key = new KeyDouble(tTimeStamp);

		return getEqualToValue(key);

	}

	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be greater thanor equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:43:58 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesGreaterAndEq(JugglerTupleList tuple) {
		long tTimeStamp = tuple.getFirstTuple().getJugglerTimeStamp();

		KeyDouble key = new KeyDouble(tTimeStamp);

		return getTuplesGreaterThanOrEqualToValue(key);

	}

	/**
	 * /**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be greater than the specified tuple's timestamp.
	 * Creation date: (1/28/2003 10:09:38 PM)
	 * @return java.util.Iterator
	 * Creation date: (1/28/2003 1:39:37 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public java.util.Iterator getTuplesGreaterThan(JugglerTupleList tuple) {
		long tTimeStamp = tuple.getFirstTuple().getJugglerTimeStamp();

		KeyDouble key = new KeyDouble(tTimeStamp);

		return getTuplesGreaterThanValue(key);
	}

	/**
	 * Returns tuples from the specified tuple's timestamp.
	 * The tuples will be less than or equal to the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:44:40 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesLessAndEql(JugglerTupleList tuple) {
		long tTimeStamp = tuple.getFirstTuple().getJugglerTimeStamp();
		JugglerTupleList tTupleList = new JugglerTupleList();

		WindowExpStructureList temp = this.getLastWinExpStructureList();
		while (temp != null) {
			//if the start and end times of a windowExpStr are less then the tuple's timestamp
			// go to the next windowExpSTr
			if (temp.getStartTimeStamp() < tTimeStamp
				&& temp.getEndTimeStamp() < tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}
			//if the start and end times of a windowExpStr are less then or equal to the tuple's timestamp
			//return all the tuples in this windowExpSTr
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() <= tTimeStamp) {
				tTupleList.appendTupleList(temp.getListOfTuples());
				temp = temp.getNextWinExpStrList();
			}

			//if the start is less than but the end is not less than the tuple's timestamp
			//traverse the tuple list until a tuple greater than the timestamp is found
			if (temp.getStartTimeStamp() <= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				tTupleList.appendTupleList(
					temp.getListOfTuples().getTuplesLessAndEq(
						tuple.getFirstTuple()));
				temp = temp.getNextWinExpStrList();
				return (new JugglerTupleListIterator(tTupleList));

			}
			// if both the start and end are greater than the tuple's timestamp
			if (temp.getStartTimeStamp() > tTimeStamp
				&& temp.getEndTimeStamp() > tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
			}
			//if the start and end are both greater than or equal to than the tuple's timestamp
			//stop trying to find any more tuples.. no more will be contained in the later winExpStructures
			if (temp.getStartTimeStamp() >= tTimeStamp
				&& temp.getEndTimeStamp() >= tTimeStamp) {
				return (new JugglerTupleListIterator(tTupleList));
			}

		}
		return (new JugglerTupleListIterator(tTupleList));
	}

	/**
	* Returns tuples from the specified tuple's timestamp.
	 * The tuples will be less than the specified tuple's timestamp.
	 * Creation date: (1/28/2003 1:42:05 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.Tuple
	 */
	public Iterator getTuplesLessThan(JugglerTupleList tuple) {
		long tTimeStamp = tuple.getFirstTuple().getJugglerTimeStamp();
		KeyDouble key = new KeyDouble(tTimeStamp);

		return getTuplesLessThanValue(key);

	}

	/**
	 * Insert the method's description here.
	 * Creation date: (2/20/2003 12:54:29 AM)
	 * @param tuple juggler.stream.Tuple
	 */
	public boolean insertTuple(JugglerTupleList tuple) {
		return true;
	}

	/**
	 * Returns the list of tuples.
	 * Creation date: (1/28/2003 11:58:25 PM)
	 * @return juggler.stream.TupleList
	 */
	public JugglerWindowTupleList getListOfTuples() {
		return thisWinExpStr.getListOfTuples();
	}
	/**
	 * @return
	 */
	public ArrayList getRemoveBucketList() {
		return removeBucketList;
	}

	/**
	 * @param list
	 */
	public void setRemoveBucketList(ArrayList list) {
		removeBucketList = list;
	}

	/**
	 * @return
	 */
	public WindowExpStructure getThisWinExpStr() {
		return thisWinExpStr;
	}

	/**
	 * @param structure
	 */
	public void setThisWinExpStr(WindowExpStructure structure) {
		thisWinExpStr = structure;
	}
	/**
	 * @return
	 */
	public boolean isEmpty() {

		if (this.thisWinExpStr == null)
			return true;

		WindowExpStructureList tempWinExpStrList =
			this.getFirstWinExpStructureList();
		int numBucketsTemp = this.numBuckets;
		for (int i = 0; i < numBucketsTemp; i++) {
			if (tempWinExpStrList.thisWinExpStr.listOfTuples == null
				|| tempWinExpStrList.thisWinExpStr.listOfTuples.isEmpty())
				return true;
			else
				return false;
		}
		return false;
	}
	/**
	 * @param element
	 */
	public JugglerTupleList enterTuple_XATTuple(JugglerTupleList tuple) {
		//if this is the first bucket,
		//initialize the bucket numbers and ids
		if (this.getPrevWinExpStrList() == null && this.bucketID == 0) {
			this.setBucketID(1);
		}

		boolean createNewWinExpStr = false;

		//inserts only if within the time increment
		long timeSpan = endTimeStamp - startTimeStamp;
		if ((timeSpan <= timeIncrement)) {
			//insert tuples 
			try {
				tuple = thisWinExpStr.enterTuple_XATTuple(tuple);
			} catch (XATTimeStampException e) {
				e.printStackTrace();
			}

			//if the funcion returns any tuples left over,
			//it needs to be inserted in teh new WinExpStr
			if (tuple != null) {
				createNewWinExpStr = true;
			} else {
				//update the last timestamp in the list
				//this method's traversal may not be needed if tuples are 
				//assumed to be inserted and arrived sorted order
					endTimeStamp =
						thisWinExpStr.getListOfTuples().getLastTuple().getJugglerTimeStamp();
	
					startTimeStamp =
						thisWinExpStr.getListOfTuples().getFirstTuple().getJugglerTimeStamp();
			}
		} else {
			//then there is a need for another WindowExpStructure
			createNewWinExpStr = true;

		} //end else

		if (createNewWinExpStr) {
			//if there is already a next winExpStr, then 
			//try to insert the tuples into this
			if (nextWinExpStrList != null) {
				tuple = nextWinExpStrList.enterTuple_XATTuple(tuple);

			} //if there is no nextWinExpStr, create a new one
			else {
				//			then there is a need for another WindowExpStructure
				//if this is a exp structure for a single stream
				nextWinExpStrList =
					new WindowExpStructureList(
						timeIncrement,
						streamNames,
						streamIDs,
						maxWin);

				this.setNextWinExpStrList(nextWinExpStrList);
				nextWinExpStrList.setBucketID(bucketID + 1);
				nextWinExpStrList.setPrevWinExpStrList(this);
				//set the new bucketID

				tuple = nextWinExpStrList.enterTuple_XATTuple(tuple);
				//enter the remainder of the tuples
			}

		} //end of if to creat new Exp structure
		createNewWinExpStr = false;

		if (bucketID == 1) {
			int currBucketSize = getBucketSize();
			int bucketLimit = numBucketsLimit;
			//			optimization???
			if (currBucketSize > bucketLimit) {
				//	remove the first bucket;
				//			this.removeBucket(1);
				int listSize = getRemoveBucketList().size();
				int newIDRemove = 0;
				if (listSize > 0)
					newIDRemove =
						((Integer) getRemoveBucketList().get(listSize - 1))
							.intValue();
				getRemoveBucketList().add(new Integer(newIDRemove + 1));
			}
		}

		return tuple;
	}
	/**
	 * @return
	 */
	public boolean isEmpty_XATTuple() {
		if (this.thisWinExpStr == null)
			return true;

		WindowExpStructureList tempWinExpStrList =
			this.getFirstWinExpStructureList();
		int numBucketsTemp = this.numBuckets;
		for (int i = 0; i < numBucketsTemp; i++) {
			if (tempWinExpStrList.thisWinExpStr.listOfTuples == null
				|| tempWinExpStrList
					.thisWinExpStr
					.listOfTuples
					.isEmpty())
				return true;
			else
				return false;
		}
		return false;
	}

}
