package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatemanagers;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Iterator;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparableTupleValues
	.KeyDouble;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.Operator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerTuple;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerTupleList;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerWindowTupleList;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerWindowTupleListIterator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.exploitationstructures
	.IExpStructure;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicateBitRepresentation
	.ExtPredicateBitSet;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatelists
	.BitPosition;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatelists
	.JWPredOrderList;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatelists
	.OrderList;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatelists
	.OrderListS;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatestructure
	.IPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.Query;
/**
 * Insert the type's description here.
 * Creation date: (1/12/2003 8:36:29 PM)
 * @author: Administrator
 */
public abstract class JWPredManager
	extends PredicateManager
	implements Serializable {
	protected ArrayList joinTreeStructures;
	protected OrderListS jwPredicateLists;
	/**
	 * JWPredManager constructor comment.
	 */
	public JWPredManager() {
		super();
		joinTreeStructures = new ArrayList();
		jwPredicateLists = new OrderListS();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/30/2003 9:32:06 PM)
	 * @param it java.util.Iterator
	 */
	public Iterator applyAllRelevantPredicates(
		JugglerTupleList firstTuple,
		Iterator it) {
		ArrayList appliedJoinedTuples = new ArrayList();

		//for each joined tuples
		while (it.hasNext()) {
			//second half of the joined tuple
			JugglerTupleList secondTuple = (JugglerTupleList) it.next();
			//second half of the joined tuple

			if (firstTuple == null || secondTuple == null)
				continue;

			//for each join/window predicate list
			for (int i = 0; i < jwPredicateLists.size(); i++) {
				JWPredOrderList jwList =
					(JWPredOrderList) jwPredicateLists.getOrderLists().get(i);

				//if list is not relevant, continue........
				boolean isRelevantList = false;
				// check to see if the list is relevevant boolean isRelevantList = false;
				for (int q = 0; q < jwList.size(); q++) {
					if (((BitSet) secondTuple
						.getFirstTuple()
						.getPredicates()
						.getIsEvaluated_Relevant(this.getTypeName())
						.getPredicateBitSets()[jwList
						.getListIndex()])
						.get(q))
						isRelevantList = true;
					break;

				}
				if (!isRelevantList) {
					BitSet clearedBS = new BitSet(jwList.size());
					secondTuple
						.getFirstTuple()
						.getPredicates()
						.getIsEvaluated_Relevant(this.getTypeName())
						.getPredicateBitSets()[jwList
						.getListIndex()] =
						clearedBS;
					continue;
				}

				JugglerTupleList tupleForFirstStream = new JugglerTupleList();
				JugglerTupleList tupleForSecondStream = new JugglerTupleList();

				//set which the tuple is on which side of the list
				if (firstTuple
					.getStreamNames()
					.containsAll(jwList.getStreamName1())
					&& secondTuple.getStreamNames().containsAll(
						jwList.getStreamName2())) { //go on
					tupleForFirstStream = firstTuple;
					tupleForSecondStream = secondTuple;
				} else {
					if (secondTuple
						.getStreamNames()
						.containsAll(jwList.getStreamName1())
						&& firstTuple.getStreamNames().containsAll(
							jwList.getStreamName2())) { //go on
						tupleForFirstStream = secondTuple;
						tupleForSecondStream = firstTuple;
					} //if none match, then jwList is irrelevant
					else {
						secondTuple
							.getFirstTuple()
							.getPredicates()
							.getIsEvaluated_Relevant(this.getTypeName())
							.getPredicateBitSets()[jwList
							.getListIndex()] =
							new BitSet(jwList.size());
						continue;
					}
				}
				//find most covering predicate
				ArrayList listMostCoveringIndexes =
					jwList.findMosCoveringPredicates(
						tupleForFirstStream,
						tupleForSecondStream);
				//if the predicates were satisfied, join the tuple
				if (listMostCoveringIndexes.size() != 0) {
					//for each bit position returned from the most covering predicates
					for (int q = 0; q < listMostCoveringIndexes.size(); q++) {
						int listMostCoveringIndex =
							((Integer) listMostCoveringIndexes.get(q))
								.intValue();
						secondTuple
							.getFirstTuple()
							.getPredicates()
							.getAppropriatePredicateTypeExt(this.getTypeName())
							.setMostCoveringBits(
								new BitPosition(
									jwList.getListIndex(),
									listMostCoveringIndex),
								jwList.size());
					} //finishes settig all the bits
				}

			} //for all predicate lists

			//combine the predicate bitsets
			(
				(ExtPredicateBitSet) secondTuple
					.getFirstTuple()
					.getPredicates())
					.combineBitSets(
				(ExtPredicateBitSet) firstTuple
					.getFirstTuple()
					.getPredicates());
			//join the tuple and return

			//firstTuple.appendTupleList(secondTuple);

			//firstTuple.updatePredicateBitSetsInTupleList();
			appliedJoinedTuples.add(secondTuple);
		} //for each joined tuple
		return appliedJoinedTuples.iterator();
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (4/30/2003 9:32:06 PM)
	 * @param it java.util.Iterator
	 */
	public Iterator applyAllRelevantPredicates_XATTuple(
		JugglerTupleList firstTuple,
		Iterator it) {
		ArrayList appliedJoinedTuples = new ArrayList();

		if (it == null)
			return null;

		//for each joined tuples
		while (it.hasNext()) {
			//second half of the joined tuple
			JugglerTupleList secondTuple = (JugglerTupleList) it.next();
			//second half of the joined tuple

			if (firstTuple == null || secondTuple == null)
				continue;

			//for each join/window predicate list
			for (int i = 0; i < jwPredicateLists.size(); i++) {
				JWPredOrderList jwList =
					(JWPredOrderList) jwPredicateLists.getOrderLists().get(i);

				//if list is not relevant, continue........
				boolean isRelevantList = false;
				// check to see if the list is relevevant boolean isRelevantList = false;
				for (int q = 0; q < jwList.size(); q++) {
					if (((BitSet) secondTuple
						.getFirstTuple()
						.getPredicates()
						.getIsEvaluated_Relevant(this.getTypeName())
						.getPredicateBitSets()[jwList
						.getListIndex()])
						.get(q))
						isRelevantList = true;
					break;

				}
				if (!isRelevantList) {
					BitSet clearedBS = new BitSet(jwList.size());
					secondTuple
						.getFirstTuple()
						.getPredicates()
						.getIsEvaluated_Relevant(this.getTypeName())
						.getPredicateBitSets()[jwList
						.getListIndex()] =
						clearedBS;
					continue;
				}

				JugglerTupleList tupleForFirstStream = new JugglerTupleList();
				JugglerTupleList tupleForSecondStream = new JugglerTupleList();

				//set which the tuple is on which side of the list
				if (firstTuple
					.getStreamNames()
					.containsAll(jwList.getStreamName1())
					&& secondTuple.getStreamNames().containsAll(
						jwList.getStreamName2())) { //go on
					tupleForFirstStream = firstTuple;
					tupleForSecondStream = new JugglerTupleList(secondTuple);
				} else {
					if (secondTuple
						.getStreamNames()
						.containsAll(jwList.getStreamName1())
						&& firstTuple.getStreamNames().containsAll(
							jwList.getStreamName2())) { //go on
						tupleForFirstStream = new JugglerTupleList(secondTuple);
						tupleForSecondStream = firstTuple;
					} //if none match, then jwList is irrelevant
					else {
						secondTuple
							.getFirstTuple()
							.getPredicates()
							.getIsEvaluated_Relevant(this.getTypeName())
							.getPredicateBitSets()[jwList
							.getListIndex()] =
							new BitSet(jwList.size());
						continue;
					}
				}
				//find most covering predicate
				ArrayList listMostCoveringIndexes;
				try {
					listMostCoveringIndexes =
						jwList.findMosCoveringPredicates_XATTuple(
							tupleForFirstStream,
							tupleForSecondStream);

					//if the predicates were satisfied, join the tuple
					if (listMostCoveringIndexes.size() != 0) {
						//for each bit position returned from the most covering predicates
						for (int q = 0;
							q < listMostCoveringIndexes.size();
							q++) {
							int listMostCoveringIndex =
								((Integer) listMostCoveringIndexes.get(q))
									.intValue();
							secondTuple
								.getFirstTuple()
								.getPredicates()
								.getAppropriatePredicateTypeExt(
									this.getTypeName())
								.setMostCoveringBits(
									new BitPosition(
										jwList.getListIndex(),
										listMostCoveringIndex),
									jwList.size());
						} //finishes settig all the bits
					}
				} catch (XATTimeStampException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			} //for all predicate lists

			//combine the predicate bitsets
			(
				(ExtPredicateBitSet) secondTuple
					.getFirstTuple()
					.getPredicates())
					.combineBitSets(
				(ExtPredicateBitSet) firstTuple
					.getFirstTuple()
					.getPredicates());
			//join the tuple and return

			//firstTuple.appendTupleList(secondTuple);

			//firstTuple.updatePredicateBitSetsInTupleList();
			appliedJoinedTuples.add(secondTuple);
		} //for each joined tuple
		return appliedJoinedTuples.iterator();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/9/2003 11:38:22 PM)
	 * @param t juggler.stream.Tuple
	 * @return Iterator
	 */
	public Iterator applyPredicates_XATTuple(
		JugglerTupleList unjoinedtuples,
		Iterator setOfJoinedTuples) {
		Iterator it = null;

		//if the tuples have already been joined by either the join predicates or windowpredicates
		if (setOfJoinedTuples != null) {
			///??????? do we traqvese the set of Joined tupples????
			it =
				applyAllRelevantPredicates_XATTuple(
					unjoinedtuples,
					setOfJoinedTuples);
		} else {
			//this assumes that join/window predicates have not been joined, that this the first "join" of tuples
			//if window predicates have been already processed, only need to check the list for covering relations
			it = this.retrieveRelevantTuplesToJoin_XATTuple(unjoinedtuples);
			it = applyAllRelevantPredicates_XATTuple(unjoinedtuples, it);

		}

		return it;
	}

	/**
	 * @param unjoinedtuples
	 * @return
	 */
	private Iterator retrieveRelevantTuplesToJoin_XATTuple(JugglerTupleList tuples) {
		ArrayList oldToBeJoinedStreamNames = null;
		ArrayList tupleStreamNameToJoin = null;
		ArrayList intermediateTuples = new ArrayList();
		JugglerTupleList intermediateJoinedTuples = new JugglerTupleList();
		JugglerTuple firstTuple = tuples.getFirstTuple();
		JugglerTuple firstTupleClone =
			(JugglerTuple) firstTuple.getJugglerClone();
		int joinColumnOld = -1;
		int joinColumnNew = -1;
		Operator joinOp = null;
		JugglerWindowTupleList tempIntrTL = new JugglerWindowTupleList();

		//for each joinPredList
		for (int i = 0;
			i < this.getPredicateOrderLists().getOrderLists().size();
			i++) {
			JWPredOrderList jwList =
				(JWPredOrderList) this
					.getPredicateOrderLists()
					.getOrderLists()
					.get(
					i);

			//check to see if the list is relevevant
			boolean isRelevantList = false;
			for (int q = 0; q < jwList.size(); q++) {
				if (((BitSet) tuples
					.getFirstTuple()
					.getPredicates()
					.getIsEvaluated_Relevant(this.getTypeName())
					.getPredicateBitSets()[jwList
					.getListIndex()])
					.get(q)) {
					isRelevantList = true;
					break;
				}

			}
			if (!isRelevantList)
				continue;

			//set which the tuple is on which side of the list
			if (tuples.getStreamNames().containsAll(jwList.getStreamName1())) {
				oldToBeJoinedStreamNames = (ArrayList) jwList.getStreamName2();
				tupleStreamNameToJoin = (ArrayList) jwList.getStreamName1();
				joinColumnOld = jwList.getColumnInt2();
				joinColumnNew = jwList.getColumnInt1();
				joinOp = jwList.getOp().getOppositeOperator();
			} else if (
				tuples.getStreamNames().containsAll(jwList.getStreamName2())) {
				oldToBeJoinedStreamNames = (ArrayList) jwList.getStreamName1();
				tupleStreamNameToJoin = (ArrayList) jwList.getStreamName2();
				joinColumnOld = jwList.getColumnInt1();
				joinColumnNew = jwList.getColumnInt2();
				joinOp = jwList.getOp();

			}

			if (oldToBeJoinedStreamNames == null)
				continue;
			//if the predicate matches teh first predicate part
			//go to all the relvant exp structures for the second predicate part
			// retrieve the appropriate tuples
			//join them, and find the most covering predicate for each
			//get teh list information

			for (int jwExpStrIndex = 0;
				jwExpStrIndex < this.getExpStructures().size();
				jwExpStrIndex++) {
				IExpStructure jwExpStr =
					(IExpStructure) this.getExpStructures().get(jwExpStrIndex);

				//make sure the join exp tree structure applies to this join
				if (!jwExpStr
					.getStreamNames()
					.equals(oldToBeJoinedStreamNames))
					continue;

				if (jwExpStr.getColumnInt() != joinColumnOld)
					continue;

				JugglerTuple tuple =
					tuples.getTupleStream_XATTuple(tupleStreamNameToJoin);

				if (tuple != null) {
					//get tuple's value to retrieve the potential join tuples of the other predicate part
					//if its a window structure... then use timestamp of the tuple!!!!
					XATDataValueImp key = new XATDataValueImp();
					if (jwExpStr.getColumn() == "ts")
						key =
							new KeyDouble(
								new Long(tuples.getJugglerTimeStamp())
									.doubleValue());
					else {
						Vector tupleValeus = tuple.getValues();
						key = (XATDataValueImp) tupleValeus.get(joinColumnNew);
						key =
							new KeyDouble(key.convertToDouble().doubleValue());
					}
					Iterator tempIt =
						jwExpStr.getTuplesWithValue_XATTuple(key, joinOp);
					//only add the tuples to this list, if the tuple has not already been added
					while (tempIt.hasNext()) {
						JugglerTupleList tempTL =
							(JugglerTupleList) tempIt.next();
						if (tempTL == null)
							return null;
						tempTL.getFirstTuple().getPredicates().combineBitSets(
							firstTuple.getPredicates());
						tempIntrTL.appendTupleList_IfNotContained(tempTL);
					}
				} //if tuple to be joined is not null
			} //for each exploitation structure
		} //for each predicate list

		JugglerWindowTupleListIterator tuplesToBeJoined =
			new JugglerWindowTupleListIterator(tempIntrTL);

		return tuplesToBeJoined;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/9/2003 11:38:22 PM)
	 * @param t juggler.stream.Tuple
	 * @return Iterator
	 */
	public Iterator applyPredicates(
		JugglerTupleList unjoinedtuples,
		Iterator setOfJoinedTuples) {
		Iterator it = null;

		//if the tuples have already been joined by either the join predicates or windowpredicates
		if (setOfJoinedTuples != null) {
			///??????? do we traqvese the set of Joined tupples????
			it = applyAllRelevantPredicates(unjoinedtuples, setOfJoinedTuples);
		} else {
			//this assumes that join/window predicates have not been joined, that this the first "join" of tuples
			//if window predicates have been already processed, only need to check the list for covering relations
			it = this.retrieveRelevantTuplesToJoin(unjoinedtuples);
			it = applyAllRelevantPredicates(unjoinedtuples, it);

		}

		return it;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/26/2003 10:43:32 PM)
	 * @param tuples ArrayList
	 */
	public void enterTuples(ArrayList tuples) {
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/13/2003 10:31:30 AM)
	 * @return java.util.ArrayList
	 */
	public ArrayList getExpStructures() {
		return null;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/22/2003 7:26:36 PM)
	 * @return java.util.ArrayList
	 * @param jwList juggler.predicatelists.JWPredOrderList
	 */
	public void getJoiningStreamNameAndColumnInt(
		JWPredOrderList jwList,
		JugglerTupleList tuples,
		ArrayList oldToBeJoinedStreamNames,
		int joinColumn) {
		if (jwList.getStreamName1().equals(tuples.getStreamNames())) {
			oldToBeJoinedStreamNames = (ArrayList) jwList.getStreamName2();
			joinColumn = jwList.getColumnInt1();
		} else if (jwList.getStreamName2().equals(tuples.getStreamNames())) {
			oldToBeJoinedStreamNames = (ArrayList) jwList.getStreamName1();
			joinColumn = jwList.getColumnInt2();
		}
		return;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/28/2003 10:17:00 PM)
	 * @return ArrayList
	 */
	public ArrayList getJoinTreeStructures() {
		return joinTreeStructures;
	}
	/**
	 * Returns the predicate specified by the bitposition.
	 * Creation date: (1/12/2003 5:12:46 PM)
	 * @return juggler.predicatestructure.Predicate
	 * @param predBitPosition juggler.predicatestructure.BitPosition
	 */
	public IPredicate getPredicate(BitPosition predBitPosition) {
		OrderList jwList =
			(OrderList) this.jwPredicateLists.getOrderLists().get(
				predBitPosition.getPredListIndex());
		return jwList.getPredicate(predBitPosition.getPredIndex());
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (3/5/2003 10:43:43 PM)
	 * @return juggler.predicatelists.OrderListS
	 */
	public OrderListS getPredicateOrderLists() {
		return jwPredicateLists;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/26/2003 10:50:36 PM)
	 * @param tuples java.util.Iterator
	 */
	public void processTuples(Iterator tuples) {
	}
	/**
	 * Registers the query predicates in the list.
	 * Creation date: (1/12/2003 5:10:36 PM)
	 * @param queries juggler.query.Query[]
	 */
	public void registerQueries(Query[] queries) {

	}
	/**
	 * Joins tuple using predicates in the predicate list.
	 * Tuples to join will be retrieved from join exploitation structure.
	 * Creation date: (1/12/2003 8:37:08 PM)
	 * @return java.util.Iterator
	 * @param tuple juggler.stream.JugglerTuple
	 */
	public java.util.Iterator retrieveRelevantTuplesToJoin(
		JugglerTupleList tuples) {
		ArrayList oldToBeJoinedStreamNames = null;
		ArrayList tupleStreamNameToJoin = null;
		ArrayList intermediateTuples = new ArrayList();
		JugglerTupleList intermediateJoinedTuples = new JugglerTupleList();
		JugglerTuple firstTuple = tuples.getFirstTuple();
		JugglerTuple firstTupleClone =
			(JugglerTuple) firstTuple.getJugglerClone();
		int joinColumnOld = -1;
		int joinColumnNew = -1;
		Operator joinOp = null;
		JugglerWindowTupleList tempIntrWTL = new JugglerWindowTupleList();

		//for each joinPredList
		for (int i = 0;
			i < this.getPredicateOrderLists().getOrderLists().size();
			i++) {
			JWPredOrderList jwList =
				(JWPredOrderList) this
					.getPredicateOrderLists()
					.getOrderLists()
					.get(
					i);

			//check to see if the list is relevevant
			boolean isRelevantList = false;
			for (int q = 0; q < jwList.size(); q++) {
				if (((BitSet) tuples
					.getFirstTuple()
					.getPredicates()
					.getIsEvaluated_Relevant(this.getTypeName())
					.getPredicateBitSets()[jwList
					.getListIndex()])
					.get(q)) {
					isRelevantList = true;
					break;
				}

			}
			if (!isRelevantList)
				continue;

			//set which the tuple is on which side of the list
			if (tuples.getStreamNames().containsAll(jwList.getStreamName1())) {
				oldToBeJoinedStreamNames = (ArrayList) jwList.getStreamName2();
				tupleStreamNameToJoin = (ArrayList) jwList.getStreamName1();
				joinColumnOld = jwList.getColumnInt2();
				joinColumnNew = jwList.getColumnInt1();
				joinOp = jwList.getOp().getOppositeOperator();
			} else if (
				tuples.getStreamNames().containsAll(jwList.getStreamName2())) {
				oldToBeJoinedStreamNames = (ArrayList) jwList.getStreamName1();
				tupleStreamNameToJoin = (ArrayList) jwList.getStreamName2();
				joinColumnOld = jwList.getColumnInt1();
				joinColumnNew = jwList.getColumnInt2();
				joinOp = jwList.getOp();

			}

			if (oldToBeJoinedStreamNames == null)
				continue;
			//if the predicate matches teh first predicate part
			//go to all the relvant exp structures for the second predicate part
			// retrieve the appropriate tuples
			//join them, and find the most covering predicate for each
			//get teh list information

			for (int jwExpStrIndex = 0;
				jwExpStrIndex < this.getExpStructures().size();
				jwExpStrIndex++) {
				IExpStructure jwExpStr =
					(IExpStructure) this.getExpStructures().get(jwExpStrIndex);

				//make sure the join exp tree structure applies to this join
				if (!jwExpStr
					.getStreamNames()
					.equals(oldToBeJoinedStreamNames))
					continue;

				if (jwExpStr.getColumnInt() != joinColumnOld)
					continue;

				JugglerTuple tuple =
					tuples.getTupleStream(tupleStreamNameToJoin);

				if (tuple != null) {
					//get tuple's value to retrieve the potential join tuples of the other predicate part
					//if its a window structure... then use timestamp of the tuple!!!!
					Comparable key;
					if (jwExpStr.getColumn() == "ts")
						key =
							new KeyDouble(
								(new Long(tuples.getJugglerTimeStamp()))
									.doubleValue());
					else {
						Vector tupleValeus = tuple.getValues();
						key = (Comparable) tupleValeus.get(joinColumnNew);
					}
					Iterator tempIt = jwExpStr.getTuplesWithValue(key, joinOp);
					//only add the tuples to this list, if the tuple has not already been added
					while (tempIt.hasNext()) {
						JugglerTupleList tempTL =
							(JugglerTupleList) tempIt.next();
						if (tempTL != null) {
							tempTL
								.getFirstTuple()
								.getPredicates()
								.combineBitSets(
								firstTuple.getPredicates());
							tempIntrWTL.appendTupleList_IfNotContained(tempTL);
						}
					}
				} //if tuple to be joined is not null
			} //for each exploitation structure
		} //for each predicate list

		JugglerWindowTupleListIterator tuplesToBeJoined =
			new JugglerWindowTupleListIterator(tempIntrWTL);

		return tuplesToBeJoined;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (3/5/2003 10:43:43 PM)
	 * @param newPredicateLists juggler.predicatelists.OrderListS
	 */
	public void setPredicateLists(OrderListS newPredicateLists) {
		jwPredicateLists = newPredicateLists;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (3/5/2003 10:43:43 PM)
	 * @param newPredicateLists juggler.predicatelists.OrderListS
	 */
	public boolean isExpStrucutresEmpty() {
		return false;
	}
}
