package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatemanagers;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyDouble;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerWindowTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.exploitationstructures.JoinExpStructure;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.exploitationstructures.JoinExpTreeStructure;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.Query;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.QueryQED;

/**
 * Insert the type's description here.
 * Creation date: (1/12/2003 8:30:56 PM)
 * @author: Administrator
 */
public class JoinPredicateManager extends JWPredManager implements Serializable{
/**
 * JoinPredicateManager constructor comment.
 */
public JoinPredicateManager() {
	super();
	joinTreeStructures = new ArrayList();
	//joinLists = new juggler.predicatelists.OrderListS();
	this.setTypeName("join");
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 7:17:34 PM)
 * @param predicateType java.lang.String
 */
public JoinPredicateManager(String predicateType) {
	super();
	this.setTypeName(predicateType);
	joinTreeStructures = new ArrayList();
	//joinLists = new juggler.predicatelists.OrderListS();
	}
/**
 * Add the join exploitation structure to the predicate join manager.
 * Creation date: (1/12/2003 8:34:31 PM)
 * @param jexpStructure juggler.exploitationstructures.JoinExpStructure
 */
public void addJoinExpStructure(JoinExpStructure jexpStructure) {
	joinTreeStructures.add(jexpStructure); 
	}
/**
 * Insert the method's description here.
 * Creation date: (4/7/2003 8:18:49 PM)
 * @return boolean
 * @param param juggler.exploitationstructures.JoinExpTreeStructure
 */
public boolean containsJoinExpTreeStr(JoinExpTreeStructure param) {
	Iterator joinIt = this.getJoinTreeStructures().iterator();
	while (joinIt.hasNext()) {
		JoinExpTreeStructure joinExpTStr = (JoinExpTreeStructure) joinIt.next();
		if (joinExpTStr.equals(param))
			return true;
	}
	return false;
}

/**
 * Insert the method's description here.
 * Creation date: (4/7/2003 8:18:49 PM)
 * @return boolean
 * @param param juggler.exploitationstructures.JoinExpTreeStructure
 */
public JoinExpTreeStructure getJoinExpTreeStr(JoinExpTreeStructure param) {
	Iterator joinIt = this.getJoinTreeStructures().iterator();
	while (joinIt.hasNext()) {
		JoinExpTreeStructure joinExpTStr = (JoinExpTreeStructure) joinIt.next();
		if (joinExpTStr.equals(param))
			return joinExpTStr;
	}
	return null;
}

/**
 * Deletes join exploitation structure.
 * Creation date: (1/12/2003 8:34:58 PM)
 */
public void deleteJoinExpStructure(JoinExpStructure jTree) {

	joinTreeStructures.remove(jTree);
	}
/**
 * Enter tuples in the join explotiation structure.
 * Assume that the streamIDs are always set for the Join Exp structure. 
 * Creation date: (1/12/2003 8:35:25 PM)
 * @param tuplesArray ArrayList
 */
public void enterTuples(ArrayList tuplesArray) {
	Iterator tuples = ((ArrayList)tuplesArray.clone()).iterator();
	Iterator it = this.getJoinTreeStructures().iterator();
	while (tuples.hasNext()) {
		JugglerTupleList t = (JugglerTupleList) tuples.next();
		while (it.hasNext()) {
			tuples =((ArrayList) tuplesArray.clone()).iterator();
			JoinExpTreeStructure jTree =
			(JoinExpTreeStructure) it.next();
			if ( t.getStreamNames().containsAll(jTree.getStreamNames())) {
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				jTree.enterTuples(tuplesArray);
			}
				
		}
	}
}

/**
 * Enter tuples in the join explotiation structure.
 * Assume that the streamIDs are always set for the Join Exp structure. 
 * Creation date: (1/12/2003 8:35:25 PM)
 * @param tuplesArray ArrayList
 */
public void enterTuplesOptmized(ArrayList tuplesArray) {
	Iterator tuples = tuplesArray.iterator();
	Iterator it = this.getJoinTreeStructures().iterator();
	while (tuples.hasNext()) {
		JugglerTupleList t = (JugglerTupleList) tuples.next();
		while (it.hasNext()) {
			JoinExpTreeStructure jTree =
			(JoinExpTreeStructure) it.next();
			if (t.getStreamNames().containsAll(jTree.getStreamNames())) {
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				jTree.enterTuples(tuplesArray);
			}
				
		}
	}
}

/**
 * Enter tuples in the join explotiation structure.
 * Assume that the streamIDs are always set for the Join Exp structure. 
 * Creation date: (1/12/2003 8:35:25 PM)
 * @param tuplesArray ArrayList
 */
public void enterTuple(JugglerTupleList tuple) {
	Iterator it = this.getJoinTreeStructures().iterator();
		while (it.hasNext()) {
			JoinExpTreeStructure jTree =
			(JoinExpTreeStructure) it.next();
			if (tuple.getStreamNames().containsAll(jTree.getStreamNames())) {
				//jTree.insertTuple(t);
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				jTree.insertTuple(tuple);
			}
				
		}
}


/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 10:18:38 PM)
 * @return ArrayList
 */
public ArrayList getJoinTreeStructures() {
	return joinTreeStructures;
}
/**
 * Registers the query predicates in the list.
 * Parameter of arrayList of queries.
 * Creation date: (1/12/2003 5:10:36 PM)
 * @param queries juggler.query.Query[]
 * @param qde juggler.query.QueryDependentEncoding
 */
public void registerQueries(
	ArrayList queries) {


	//for each query
	for (int i = 0; i < queries.size(); i++) {
		Query query = (Query) queries.get(i);
		ArrayList bitPositions = new ArrayList();
		QueryQED qedQuery = new QueryQED();
		//an ArrayList of Predicate
		ArrayList joinPredicates = query.getJoinPredicates();
		//for each join predicate in the query
		if (joinPredicates != null) {
			for (int j = 0; j < joinPredicates.size(); j++) {
				Predicate joinPred = (Predicate) joinPredicates.get(j);
				//inserts the predicate into the relevant join lists and returns its bitPositions
				jwPredicateLists.insertIntoPredList(joinPred);
			}
		}
	}

}
/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 10:18:38 PM)
 * @param newJoinTreeStructures ArrayList
 */
public void setJoinTreeStructures(ArrayList newJoinTreeStructures) {
	joinTreeStructures = newJoinTreeStructures;
}
/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 9:18:06 PM)
 * @return java.lang.String
 */
public String toString() {

	String predLists = "";

		predLists += jwPredicateLists.toString();

	
	return predLists;
}

/**
 * Add tuple to the join exploitation structure.
 * Creation date: (1/12/2003 8:32:07 PM)
 * @param tuple juggler.stream.Tuple
 */
public void addTuple(JugglerTuple tuple) {
	Iterator it = this.getJoinTreeStructures().iterator();
	while (it.hasNext()) {
		JoinExpTreeStructure jTree =
			(JoinExpTreeStructure) it.next();
		if (jTree.getStreamIDs().containsAll(tuple.getStreamIDs()))
			jTree.insertTuple(new JugglerTupleList(tuple));
	}

}

/**
 * Deletes tuple in the exploitation structure.
 * Creation date: (1/12/2003 8:32:31 PM)
 * @param tuple juggler.stream.Tuple
 */
public void deleteTuple(JugglerTuple tuple) {
	 Iterator it = this.getJoinTreeStructures().iterator();
	while (it.hasNext()) {
		JoinExpStructure jTree =
			(JoinExpTreeStructure) it.next();
		if (jTree.getStreamIDs().containsAll(tuple.getStreamIDs()))
			jTree.deleteTuple(new JugglerTupleList(tuple));
	}
	
	}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 10:31:30 AM)
 * @return java.util.ArrayList
 */
public ArrayList getExpStructures() {
	return this.joinTreeStructures;
}


/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 10:31:30 AM)
 * @return java.util.ArrayList
 */
public void removeTupleList(JugglerTupleList tupleList) {
	Iterator joinIt = this.getJoinTreeStructures().iterator();
		while (joinIt.hasNext()) {
			JoinExpTreeStructure joinExpTStr = (JoinExpTreeStructure) joinIt.next();
			ArrayList joinExpTStr_StreamNames = joinExpTStr.getStreamNames();
			ArrayList tuple_StreamNames = tupleList.getStreamNames();
			Iterator streamNames = tuple_StreamNames.iterator();
				if (joinExpTStr_StreamNames.containsAll(tuple_StreamNames)) {
					int columnInt = joinExpTStr.getColumnInt();
					Vector data  = tupleList.getFirstTuple().getValues();//gets the value to be retrieved on.
					Comparable key = new KeyDouble(((XATDataValueImp) data.get(columnInt)).convertToDouble().doubleValue());
					JugglerWindowTupleList winList = (JugglerWindowTupleList)joinExpTStr.getInternalStorage().get(key);
					joinExpTStr.getInternalStorage().remove(key);
					winList = winList.removeTupleList(tupleList);
					if(winList != null)
						joinExpTStr.getInternalStorage().put(key, winList);
			}
		}
}

/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 10:43:43 PM)
 * @param newPredicateLists juggler.predicatelists.OrderListS
 */
public boolean isExpStrucutresEmpty() {
	Iterator joinIt = this.joinTreeStructures.iterator();
	while(joinIt.hasNext()){
		JoinExpTreeStructure joinExpTStr = (JoinExpTreeStructure) joinIt.next();
		if(!joinExpTStr.isEmpty())
			return false;
	}
	return true;
}
/**
 * @param element
 */
public void enterTuple_XATTuple(JugglerTupleList tuple) {
	Iterator it = this.getJoinTreeStructures().iterator();
		while (it.hasNext()) {
			JoinExpTreeStructure jTree =
			(JoinExpTreeStructure) it.next();
			if (tuple.getStreamNames().containsAll(jTree.getStreamNames())) {
				//jTree.insertTuple(t);
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				jTree.insertTuple_XATTuple(tuple);
			}
				
		}
	
}
/**
 * 
 */
public boolean isExpStrucutresEmpty_XATTuple() {
	Iterator joinIt = this.joinTreeStructures.iterator();
	while(joinIt.hasNext()){
		JoinExpTreeStructure joinExpTStr = (JoinExpTreeStructure) joinIt.next();
		if(!joinExpTStr.isEmpty_XATTuple())
			return false;
	}
	return true;
}

}
