package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatemanagers;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.AttrPredOrderList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.AttrPredOrderListS;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.OrderList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.IPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.Query;


/**
 * Construction.
 * Creation date: (1/12/2003 4:47:50 PM)
 * @author: Administrator
 */
public class PredicateManager implements IPredicateManager, Serializable{
	protected AttrPredOrderListS predicateList;
	protected double selectivity;
	protected double currSelectivity;
	protected java.lang.String predicateTypeName;
/**
 * PredicateManager constructor comment.
 */
public PredicateManager() {
	super();
	predicateList = new AttrPredOrderListS();
	this.setTypeName("attribute");
	selectivity = 0;
	
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 7:15:25 PM)
 * @param predicateType java.lang.String
 */
public PredicateManager(String predicateType) {
	super();
	this.setTypeName(predicateType);
	predicateList = new AttrPredOrderListS();
	selectivity = 0;
	}
/**
 * Adds the predicate order list to the manager.
 * Creation date: (1/12/2003 5:04:15 PM)
 * @param predicatelist juggler.predicatelists.OrderList
 */
public void addPredOrderList(OrderList predicatelist) {}
/**
 * Calculates the selectivity for the predicate type.
 * Creation date: (1/12/2003 9:17:32 PM)
 * @param tuplesSatisfied int
 * @param tuplesUnSatisfied int
 */
public void calculateSelectivity(int tuples_Input, int tuplesUnSatisfied_Output) {
	if(tuples_Input == 0)
		currSelectivity = 0;
	else{
		double input = (new Double(tuples_Input)).doubleValue();
		double output = (new Double(tuplesUnSatisfied_Output)).doubleValue();
		currSelectivity = output/input;
	}
}
/**
 * Deletes a predicate order list in the predicate manager.
 * Creation date: (1/12/2003 5:04:53 PM)
 * @param predicatelist juggler.predicatelists.OrderList
 */
public void deletePredOrderList(OrderList predicatelist) {}
/**
 * Enters the tuples into the exploitation structures.
 * Creation date: (2/26/2003 10:31:51 PM)
 * @param tuples ArrayList
 */
public void enterTuples(ArrayList tuples) {
    
	return;
	
	}
/**
 * Returns the bitposition of the predicate.
 * Creation date: (1/12/2003 5:11:14 PM)
 * @return juggler.predicatestructure.BitPosition
 * @param predicate juggler.predicatestructure.Predicate
 */
public BitPosition getBitPosition(Predicate predicate) {

	return (this.getPredicateList().getBitPosition(predicate));
}
/**
 * Returns bitsizes of the predicate lists.
 * Creation date: (1/12/2003 5:11:49 PM)
 * @return juggler.predicatestructure.BitPosition[]
 */
public BitPosition[] getBitSetSizes() {

	Iterator it = this.getPredicateList().getOrderLists().iterator();

	BitPosition[] bpArray = new BitPosition[this.getPredicateList().getOrderLists().size()];

	int i = 0;
	
	while (it.hasNext()) {
		OrderList ol = (OrderList) it.next();
		int listIndex = ol.getListIndex();
		int listSize = ol.getList().size();
		BitPosition bpSizes = new BitPosition(listIndex, listSize);
		bpArray[i] = bpSizes;
		i++;
	}
	return null;
}
/**
 * Returns the predicate specified by the bitposition.
 * Creation date: (1/12/2003 5:12:46 PM)
 * @return juggler.predicatestructure.Predicate
 * @param predBitPosition juggler.predicatestructure.BitPosition
 */
public IPredicate getPredicate(BitPosition predBitPosition) {
	OrderList attrList = (OrderList) this.predicateList.getOrderLists().get(predBitPosition.getPredListIndex());
	return	attrList.getPredicate(predBitPosition.getPredIndex());
}
/**
 * Returns the predicate list.
 * Creation date: (1/12/2003 4:49:02 PM)
 * @return juggler.predicatelists.OrderListS
 */
public edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.AttrPredOrderListS getPredicateList() {
	return predicateList;
}
/**
 * Returns the Predicate Manager that corresponds to the predicate type name.
 * Creation date: (2/26/2003 7:25:32 PM)
 * @return juggler.predicatemanagers.PredicateManager
 * @param predicateType java.lang.String
 */
public PredicateManager getPredicateManager(String predicateType) {
	if (predicateType == predicateTypeName)
		return this;
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (1/12/2003 9:13:38 PM)
 * @return long
 */
public double getSelectivity() {
	return selectivity;
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 7:13:25 PM)
 * @return java.lang.String
 */
public java.lang.String getTypeName() {
	return predicateTypeName;
}
/**
 * Registers the query predicates in the list.
 * Parameter of arraylist of queries.
 * Creation date: (1/12/2003 5:10:36 PM)
 * @param queries juggler.query.Query[]
 */
public void registerQueries(
    ArrayList queries) {

    //for each query
    for (int i = 0; i < queries.size(); i++) {
        Query query = (Query) queries.get(i);
        
        //arrayList of AttrPredicate
       ArrayList attrPredcates = query.getAttrPredicates();
        //for each attr predicate in the query
        if (attrPredcates != null) {
            for (int j = 0; j < attrPredcates.size(); j++) {
                AttrPredicate attrPred = (AttrPredicate) attrPredcates.get(j);
                //inserts the predicate into the relevant attr lists and returns its bitPositions
                //bitPositions = predicateList.insertIntoPredList(attrPred);
                predicateList.insertIntoPredList(attrPred);
            }
        }
    }

}
/**
 * Sets the predicate list.
 * Creation date: (1/12/2003 4:49:02 PM)
 * @param newPredicateList juggler.predicatelists.OrderListS
 */
public void setPredicateList(AttrPredOrderListS newPredicateList) {
	predicateList = newPredicateList;
}
/**
 * Insert the method's description here.
 * Creation date: (1/12/2003 9:13:38 PM)
 * @param newSelectivity long
 */
public void setSelectivity(long newSelectivity) {
	selectivity = newSelectivity;
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 7:13:25 PM)
 * @param newTypeName java.lang.String
 */
public void setTypeName(java.lang.String newTypeName) {
	predicateTypeName = newTypeName;
}
/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 9:18:06 PM)
 * @return java.lang.String
 */
public String toString() {

	String predLists = "";

		predLists += this.getPredicateList().toString();
	return predLists;
}

/**
 * Applies the predicate to the tuple to see if it satisfies it.
 * Creation date: (1/12/2003 4:50:38 PM)
 * @param tuple juggler.stream.Tuple
 * @param predicate juggler.predicatestructure.Predicate
 */
public void applyPredicate(JugglerTupleList tuples, Predicate predicate) {}

/**
 * Applies all the relevant predicates to the tuple.
 * Iterator is usually null for apply predicates for attributes.
 * Creation date: (1/12/2003 4:50:01 PM)
 * @param tuple juggler.stream.Tuple
 * @return Iterator
 */
public Iterator applyPredicates(JugglerTupleList tuples, Iterator setOfTuples) {

	//if the tuples have not been joined either by the join or window predicates yet
	if (setOfTuples == null) {
		tuples = this.getPredicateList().findMostCovering(tuples);

		ArrayList filteredTuples = new ArrayList();
		filteredTuples.add(tuples);
		return (filteredTuples.iterator());
	
    } else {
        //this assumes that join/window predicates have  been joined, that this the second or thrid "join" of tuples
        Iterator it = this.applyAllRelevantPredicates(tuples, setOfTuples);
         return it;
        
    }

}

/**
 * Insert the method's description here.
 * Creation date: (4/30/2003 9:32:06 PM)
 * @param it java.util.Iterator
 */
public Iterator applyAllRelevantPredicates(JugglerTupleList firstTuple, Iterator it) {
    ArrayList appliedJoinedTuples = new ArrayList();

    //for each joined tuples
    while (it.hasNext()) {
        //second half of the joined tuple
        JugglerTupleList secondTuple =
            (JugglerTupleList) it.next();

        //for each attribute predicate list
        for (int i = 0; i < predicateList.size(); i++) {
            AttrPredOrderList attrList =
                (AttrPredOrderList) predicateList.getOrderLists().get(i);

            //if list is not relevant, continue........
            boolean isRelevantList = false;
            // check to see if the list is relevevant boolean isRelevantList = false;
            for (int q = 0; q < attrList.size(); q++) {
                if (((BitSet) secondTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant("attribute")
                    .getPredicateBitSets()[attrList.getListIndex()])
                    .get(q)) {
                    isRelevantList = true;
                    break;
                }
            }
            if (!isRelevantList) {
                BitSet clearedBS = new BitSet(attrList.size());
                secondTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant("attribute")
                    .getPredicateBitSets()[attrList.getListIndex()] = clearedBS;
                continue;
            }

            JugglerTuple applyPredToThisTuple = new JugglerTuple();

            //set which the tuple is on which side of the list
            if (firstTuple.getStreamNames().containsAll(attrList.getStreamName1())) {
                //go on
                applyPredToThisTuple = firstTuple.getTupleStream(attrList.getStreamName1());
            } else
                if (secondTuple.getStreamNames().containsAll(attrList.getStreamName1())) {
                    //go on
                    applyPredToThisTuple = secondTuple.getTupleStream(attrList.getStreamName1());
                } //if none match, then jwList is irrelevant

            else {
                secondTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant("attribute")
                    .getPredicateBitSets()[attrList.getListIndex()]= new BitSet(attrList.size());
                //secondTuple.updatePredicateBitSetsInTupleList();
                continue;
            }

            //find most covering predicate
            int mostCoveringIndexes =
                attrList.findMostCovering(applyPredToThisTuple);
            //if the predicates were satisfied, join the tuple
            if (mostCoveringIndexes >= 0) {
				secondTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getAppropriatePredicateTypeExt("attribute")
                    .setMostCoveringBits(
                        new BitPosition(
                            attrList.getListIndex(),
                            mostCoveringIndexes),
                        attrList.size());
            }

        } //for all predicate lists

        //combine the predicate bitsets
        secondTuple.getFirstTuple().getPredicates().combineBitSets(
            firstTuple.getFirstTuple().getPredicates());
        //join the tuple and return
        //firstTuple.appendTupleList(secondTuple);

        //firstTuple.updatePredicateBitSetsInTupleList();
        appliedJoinedTuples.add(/*tupleList*/ secondTuple);
    } //for each joined tuple
    return appliedJoinedTuples.iterator();
}

/**
 * Insert the method's description here.
 * Creation date: (4/30/2003 9:32:06 PM)
 * @param it java.util.Iterator
 */
public Iterator applyAllRelevantPredicatesForInitialization(Iterator it) {
    ArrayList appliedAttrPredicates = new ArrayList();

    //for each joined tuples
    while (it.hasNext()) {
        JugglerTupleList firstTuple = (JugglerTupleList) it.next();

        //for each attribute predicate list
        for (int i = 0; i < predicateList.size(); i++) {
            AttrPredOrderList attrList =
                (AttrPredOrderList) predicateList.getOrderLists().get(i); 

            //if list is not relevant, continue........
            boolean isRelevantList = false;
            // check to see if the list is relevevant boolean isRelevantList = false;
            for (int q = 0; q < attrList.size(); q++) {
                if (((BitSet) firstTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant("attribute")
                    .getPredicateBitSets()[attrList.getListIndex()])
                    .get(q)) {
                    isRelevantList = true;
                    break;
                }
            }
            if (!isRelevantList) {
                BitSet clearedBS = new BitSet(attrList.size());
                firstTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant("attribute")
                    .getPredicateBitSets()[attrList.getListIndex()] = clearedBS;
                continue;
            }

            //set which the tuple is on which side of the list
            if (!firstTuple.getStreamNames().containsAll(attrList.getStreamName1())) 
            {
                firstTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getIsEvaluated_Relevant("attribute")
                    .getPredicateBitSets()[attrList.getListIndex()] =new BitSet(attrList.size());
                    firstTuple.updatePredicateBitSetsInTupleList(); 
                continue;
            }

            
            //find most covering predicate
            int mostCoveringIndexes =
                attrList.findMostCovering(firstTuple.getTuple());
            //if the predicates were satisfied, join the tuple
            if (mostCoveringIndexes >= 0) {
                firstTuple
                    .getFirstTuple()
                    .getPredicates()
                    .getAppropriatePredicateTypeExt("attribute")
                    .setMostCoveringBits(
                        new edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition(
                            attrList.getListIndex(),
                            mostCoveringIndexes),
                        attrList.size());
            }

        } //for all predicate lists
        firstTuple.updatePredicateBitSetsInTupleList();
        appliedAttrPredicates.add(firstTuple);
    } //for each joined tuple
    return appliedAttrPredicates.iterator();
}
	/**
	 * @return
	 */
	public double getCurrSelectivity() {
		return currSelectivity;
	}

	/**
	 * @param l
	 */
	public void setCurrSelectivity(double l) {
		currSelectivity = l;
	}
	/**
	 * @param tuples
	 * @return
	 */
	public JugglerTuple[] applyAllRelevantPredicatesForInitialization_XATTuple(JugglerTuple[] tuples) {
		JugglerTuple[] appliedAttrPredicates = new JugglerTuple[tuples.length];

	//for each joined tuples
	for(int j=0; j< tuples.length; j++) {
		JugglerTuple firstTuple = tuples[j];

		//for each attribute predicate list
		for (int i = 0; i < predicateList.size(); i++) {
			AttrPredOrderList attrList =
				(AttrPredOrderList) predicateList.getOrderLists().get(i); 

			//if list is not relevant, continue........
			boolean isRelevantList = false;
			// check to see if the list is relevevant boolean isRelevantList = false;
			for (int q = 0; q < attrList.size(); q++) {
				if (((BitSet) firstTuple
					.getPredicates()
					.getIsEvaluated_Relevant("attribute")
					.getPredicateBitSets()[attrList.getListIndex()])
					.get(q)) {
					isRelevantList = true;
					break;
				}
			}
			if (!isRelevantList) {
				BitSet clearedBS = new BitSet(attrList.size());
				firstTuple
					.getPredicates()
					.getIsEvaluated_Relevant("attribute")
					.getPredicateBitSets()[attrList.getListIndex()] = clearedBS;
				continue;
			}

			//set which the tuple is on which side of the list
			if (!firstTuple.getStreamNames().containsAll(attrList.getStreamName1())) 
			{
				firstTuple
					.getPredicates()
					.getIsEvaluated_Relevant("attribute")
					.getPredicateBitSets()[attrList.getListIndex()]= new BitSet(attrList.size());
					//firstTuple.updatePredicateBitSetsInTupleList_XATTuple(); 
				continue;
			}

            
			//find most covering predicate
			int mostCoveringIndexes =
				attrList.findMostCovering_XATTuple(firstTuple);
			//if the predicates were satisfied, join the tuple
			if (mostCoveringIndexes >= 0) {
				firstTuple
					.getPredicates()
					.getAppropriatePredicateTypeExt("attribute")
					.setMostCoveringBits(
						new edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition(
							attrList.getListIndex(),
							mostCoveringIndexes),
						attrList.size());
			}

		} //for all predicate lists
		//firstTuple.updatePredicateBitSetsInTupleList_XATTuple();
		appliedAttrPredicates[j]=firstTuple;
	} //for each joined tuple
	return appliedAttrPredicates;
	}
	/**
	 * @param firstParttuple
	 * @param iterator
	 * @return
	 */
	public Iterator applyPredicates_XATTuple(JugglerTupleList tuples, Iterator setOfTuples) {
		
		//if the tuples have not been joined either by the join or window predicates yet
		if (setOfTuples == null) {
			tuples = this.getPredicateList().findMostCovering_XATTuple(tuples);

			ArrayList filteredTuples = new ArrayList();
			filteredTuples.add(tuples);
			return (filteredTuples.iterator());
	
		} else {
			//this assumes that join/window predicates have  been joined, that this the second or thrid "join" of tuples
			Iterator it = this.applyAllRelevantPredicates_XATTuple(tuples, setOfTuples);
			 return it;
        
		}
	}
	/**
	 * @param tuples
	 * @param setOfTuples
	 * @return
	 */
	protected Iterator applyAllRelevantPredicates_XATTuple(JugglerTupleList firstTuple, Iterator it) {
		ArrayList appliedJoinedTuples = new ArrayList();

	//for each joined tuples
	while (it.hasNext()) {
		//second half of the joined tuple
		JugglerTupleList secondTuple =
			(JugglerTupleList) it.next();

		//for each attribute predicate list
		for (int i = 0; i < predicateList.size(); i++) {
			AttrPredOrderList attrList =
				(AttrPredOrderList) predicateList.getOrderLists().get(i);

			//if list is not relevant, continue........
			boolean isRelevantList = false;
			// check to see if the list is relevevant boolean isRelevantList = false;
			for (int q = 0; q < attrList.size(); q++) {
				if (((BitSet) secondTuple
					.getFirstTuple()
					.getPredicates()
					.getIsEvaluated_Relevant("attribute")
					.getPredicateBitSets()[attrList.getListIndex()])
					.get(q)) {
					isRelevantList = true;
					break;
				}
			}
			if (!isRelevantList) {
				BitSet clearedBS = new BitSet(attrList.size());
				secondTuple
				.getFirstTuple()
					.getPredicates()
					.getIsEvaluated_Relevant("attribute")
					.getPredicateBitSets()[attrList.getListIndex()] = clearedBS;
				continue;
			}

			JugglerTuple applyPredToThisTuple = new JugglerTuple();

			//set which the tuple is on which side of the list
			if (firstTuple.getStreamNames().containsAll(attrList.getStreamName1())) {
				//go on
				applyPredToThisTuple = firstTuple.getTupleStream_XATTuple(attrList.getStreamName1());
			} else
				if (secondTuple.getStreamNames().containsAll(attrList.getStreamName1())) {
					//go on
					applyPredToThisTuple = secondTuple.getTupleStream(attrList.getStreamName1());;
				} //if none match, then jwList is irrelevant

			else {
				secondTuple
					.getFirstTuple()
					.getPredicates()
					.getIsEvaluated_Relevant("attribute")
					.getPredicateBitSets()[attrList.getListIndex()] = new BitSet(attrList.size());
				//secondTuple.updatePredicateBitSetsInTupleList();
				continue;
			}

			//find most covering predicate
			int mostCoveringIndexes =
				attrList.findMostCovering_XATTuple(applyPredToThisTuple);
			//if the predicates were satisfied, join the tuple
			if (mostCoveringIndexes >= 0) {
				secondTuple
				.getFirstTuple()
					.getPredicates()
					.getAppropriatePredicateTypeExt("attribute")
					.setMostCoveringBits(
						new BitPosition(
							attrList.getListIndex(),
							mostCoveringIndexes),
						attrList.size());
			}

		} //for all predicate lists

		//combine the predicate bitsets
		secondTuple.getFirstTuple().getPredicates().combineBitSets(
			firstTuple.getFirstTuple().getPredicates());
		//join the tuple and return
		//firstTuple.appendTupleList(secondTuple);

		//firstTuple.updatePredicateBitSetsInTupleList();
		appliedJoinedTuples.add(/*tupleList*/ secondTuple);
	} //for each joined tuple
	return appliedJoinedTuples.iterator();
	}

}
