package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatemanagers;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.exploitationstructures.WindowExpStructureList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.Query;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.QueryQED;

/**
 * Constructor.
 * Creation date: (1/12/2003 8:38:59 PM)
 * @author: Administrator
 */
public class WindowPredicateManager extends JWPredManager implements Serializable{
	protected ArrayList windowExpManagers;
	protected static ArrayList windowRemoveBuckets = new ArrayList();
/**
 * WindowPredicateManager constructor comment.
 */
public WindowPredicateManager() {
	super();
	windowExpManagers = new ArrayList();
	windowRemoveBuckets = new ArrayList();
	//windowPredLists = new juggler.predicatelists.OrderListS();
	this.setTypeName("window");
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 7:16:53 PM)
 * @param predicateType java.lang.String
 */
public WindowPredicateManager(String predicateType) {
	super();
	this.setTypeName(predicateType);
	windowExpManagers = new ArrayList();
	}
/**
 * Insert the method's description here.
 * Creation date: (4/7/2003 8:11:31 PM)
 * @return boolean
 * @param param juggler.exploitationstructures.WindowExpStructureList
 */
public boolean containsWinMan(WindowExpStructureList param) {
	Iterator winIt = this.getWindowManagers().iterator();
	while (winIt.hasNext()) {
		WindowExpStructureList winExpStrL = (WindowExpStructureList) winIt.next();
		if (winExpStrL.equals(param))
			return true;	
	}
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 10:16:05 PM)
 * @return ArrayList
 */
public ArrayList getWindowManagers() {
	return windowExpManagers;
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 11:08:10 PM)
 * @param tuples java.util.Iterator
 */
public void processTuples(Iterator tuples) {}
/**
 * Registers the query predicates in the list.
 * Parameter takes an arraylist of queries.
 * Creation date: (1/12/2003 5:10:36 PM)
 * @param queries ArrayList
 * @param qde juggler.query.QueryDependentEncoding
 */
public void registerQueries(ArrayList queries) {

	//for each query
	for (int i = 0; i < queries.size(); i++) {
		Query query = (Query) queries.get(i);
		 ArrayList bitPositions = new ArrayList();
		QueryQED qedQuery = new QueryQED();
		//arrayList of Predicate
		ArrayList winPredcates = query.getWindowPredicates();
		//for each attr predicate in the query
		if (winPredcates != null) {
			for (int j = 0; j < winPredcates.size(); j++) {
				Predicate winPred = (Predicate) winPredcates.get(j);
				//inserts the predicate into the relevant win lists and returns its bitPositions
				jwPredicateLists.insertIntoPredList(winPred);
			}
		}
	}
     
                
      
}
/**
 * Insert the method's description here.
 * Creation date: (1/28/2003 10:16:05 PM)
 * @param newWindowManagers ArrayList
 */
public void setWindowManagers(ArrayList newWindowManagers) {
	windowExpManagers = newWindowManagers;
}
/**
 * Insert the method's description here.
 * Creation date: (3/5/2003 9:18:06 PM)
 * @return java.lang.String
 */
/*public String toString() {

	String predLists = "";

		predLists += jwPredicateLists.toString();
	return predLists;
}*/
/**
 * Updates the sections for this stream.
 * Creation date: (1/12/2003 8:39:45 PM)
 */
public void updateSections() {
	Iterator it = this.getWindowManagers().iterator();

	while (it.hasNext()) {
		WindowExpStructureList winList = (WindowExpStructureList) it.next();
		winList.updateSection();
		
	}
	
	}
/**
 * Insert the method's description here.
 * Creation date: (1/12/2003 8:56:46 PM)
 * @param streamIDs ArrayList
 */
public void updateSections(ArrayList streamIDs) {
	Iterator it = this.getWindowManagers().iterator();

	while (it.hasNext()) {
		WindowExpStructureList winList = (WindowExpStructureList) it.next();
		 if (streamIDs.containsAll(winList.getStreamIDs()))
			winList.updateSection();
		
	}
	
	
	}

/**
 * Enter tuples in the exploitation structure (section).
 * Creation date: (1/12/2003 8:40:54 PM)
 * @param tuplesArray ArrayList
 */
public void enterTuples(ArrayList tuplesArray) {
	Iterator it = this.getWindowManagers().iterator();
	while (it.hasNext()) {
		WindowExpStructureList wExp =
			(WindowExpStructureList) it.next();
		Iterator tuples = tuplesArray.iterator();
		if (tuples.hasNext()) {
			JugglerTupleList t = (JugglerTupleList) tuples.next();
			//assumes streamIDs can be set to null and streamNames are always set!!!!
			if (t.getStreamNames().containsAll(wExp.getStreamNames())) {
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				wExp.enterTuples(tuplesArray);
			}

		}
	}

}

/**
 * Enter tuples in the exploitation structure (section).
 * Creation date: (1/12/2003 8:40:54 PM)
 * @param tuplesArray ArrayList
 */
public void enterTuple(JugglerTupleList tuple) {
	Iterator it = this.getWindowManagers().iterator();
	int i=0;
	boolean foundWinExpStr = false;
	double maxWin = 0.0;
	while (it.hasNext()) {
		WindowExpStructureList wExp =
			(WindowExpStructureList) it.next();
			//assumes streamIDs can be set to null and streamNames are always set!!!!
			if (tuple.getStreamNames().containsAll(wExp.getStreamNames())) {
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				wExp.enterTuple(tuple);
				foundWinExpStr = true;

				if(wExp.getRemoveBucketList().size() >0)
					getWindowRemoveBuckets().add(new Integer(i+1));
				i++;
			}
	}
	
	//create an exp structure for those tuples not included in any predicates
	if(!foundWinExpStr){
		WindowExpStructureList newWinExpStr = new WindowExpStructureList(0.0, tuple.getStreamNames(), null, maxWin);
		//set the predicates for this set to null, so that the predicates during joining are not overwritten.
		tuple.getFirstTuple().setPredicates(null);
		tuple.updatePredicateBitSetsInTupleList();
		newWinExpStr.enterTuple(tuple);
		this.addExpStructures(newWinExpStr);
		
	}

}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 10:31:30 AM)
 * @return java.util.ArrayList
 */
public ArrayList getExpStructures() {
	return this.windowExpManagers;
}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 10:31:30 AM)
 * @return java.util.ArrayList
 */
public void addExpStructures(WindowExpStructureList winExp) {
	this.windowExpManagers.add(winExp);
}

/**
 * Insert the method's description here.
 * Creation date: (5/13/2003 10:31:30 AM)
 * @return java.util.ArrayList
 */
public String toString() {
	String retString = "The exploitation Structures are \n";
	for(int i = 0; i < windowExpManagers.size(); i++) {
		WindowExpStructureList aExpList = (WindowExpStructureList) windowExpManagers.get(i);
		retString +=  aExpList.toString()+"\n";
	}
	return retString;
}
	/**
	 * @return
	 */
	public static ArrayList getWindowRemoveBuckets() {
		return windowRemoveBuckets;
	}

	/**
	 * @param list
	 */
	public static void setWindowRemoveBuckets(ArrayList list) {
		windowRemoveBuckets = list;
	}

	/**
	 * @param list
	 */
	public void setTimeIncrement(long time) {
		Iterator it = 	windowExpManagers.iterator();
	int i=0;
	while (it.hasNext()) {
		WindowExpStructureList wExp =
			(WindowExpStructureList) it.next();
			wExp.setTimeIncrement(time);
				i++;
			}
	}
	
	/**
	 * Insert the method's description here.
	 * Creation date: (3/5/2003 10:43:43 PM)
	 * @param newPredicateLists juggler.predicatelists.OrderListS
	 */
	public boolean isExpStrucutresEmpty() {
		Iterator winIt = this.joinTreeStructures.iterator();
		while(winIt.hasNext()){
			WindowExpStructureList winExpTStrList = (WindowExpStructureList) winIt.next();
			if(!winExpTStrList.isEmpty())
				return false;
		}
		
		return true;
	}
	/**
	 * @param element
	 */
	public void enterTuple_XATTuple(JugglerTupleList element) {
		Iterator it = this.getWindowManagers().iterator();
	int i=0;
	boolean foundWinExpStr = false;
	double maxWin = 0.0;
	while (it.hasNext()) {
		WindowExpStructureList wExp =
			(WindowExpStructureList) it.next();
			//assumes streamIDs can be set to null and streamNames are always set!!!!
			if (element.getStreamNames().containsAll(wExp.getStreamNames())) {
				//do we need the insert tuple all by itself? does it get removed with next() call?????
				wExp.enterTuple_XATTuple(element);
				foundWinExpStr = true;

				if(wExp.getRemoveBucketList().size() >0)
					getWindowRemoveBuckets().add(new Integer(i+1));
				i++;
			}
	}
	
	//create an exp structure for those tuples not included in any predicates
	if(!foundWinExpStr){
		WindowExpStructureList newWinExpStr = new WindowExpStructureList(0.0, element.getStreamNames(), null, maxWin);
		//set the predicates for this set to null, so that the predicates during joining are not overwritten.
		element.getFirstTuple().setPredicates(null);
		//tuple.updatePredicateBitSetsInTupleList();
		newWinExpStr.enterTuple_XATTuple(element);
		this.addExpStructures(newWinExpStr);
		
	}

		
	}
	/**
	 * 
	 */
	public boolean isExpStrucutresEmpty_XATTuple() {
		Iterator winIt = this.joinTreeStructures.iterator();
		while(winIt.hasNext()){
			WindowExpStructureList winExpTStrList = (WindowExpStructureList) winIt.next();
			if(!winExpTStrList.isEmpty_XATTuple())
				return false;
		}
		
		return true;
	}

}
